  ; Parameter : RECORD_ID1 = RecordID des Termins, falls er schon im DocuManager existiert  (kann leer sein)
  ;             RECORD_ID2 = RecordID des Datensatzes, fr den der Termin ist               (kann leer sein)
  ;             PAR_STR3   = TableName                                                      (kann leer sein)
  ;             PAR_STR4   = XRefName                                                       (kann leer sein)
  ;             PAR_STR5   = Start Date                                                     (kann leer sein)

  ; http://csh.nci.de/yq/yqSandbox/CawaBase-GCalendar/?sslTest  (unser sslTest, ob der Server ssl-fhig ist)

  PROCEDURE InitVars
    VAR_BOOL   SaveLastUsedCalendar, FALSE
               ; If this is true, the last used calendar will be saved to the station-ini-file
               ; otherwise the users calendar (see MitStamm.csh - mask) will be saved.
               ; The saved calendar will be one, that is the default, if this script is opened.


    VAR_MASK   CalendarMask,'CalendarGoogleDlg'

    VAR_STR    LastUsedCalendar

    VAR_STR    DateTimeStr
    VAR_STR    CRLF
    VAR_LIST   ANote
    VAR_LIST   Event
    VAR_LIST   Calenders
    VAR_BOOL   Res

    VAR_QUERY  TableFld
    VAR_QUERY  Record
    VAR_STR    FName
    VAR_STR    TmpStr1
    VAR_STR    TmpStr2
    VAR_STR    NaviRes

    VAR_STR    CalenderUSR
    VAR_STR    CalenderPWD

    VAR_DATE   TmpDate
    VAR_TIME   TmpTime

    VAR_DATE   StartDate
    VAR_TIME   StartTime
    VAR_DATE   StopDate
    VAR_TIME   StopTime

    VAR_FLOAT  TimeStamp

    VAR_NUM    SPos
    VAR_NUM    LnAct
    VAR_NUM    LnCnt

    CALC [CRLF]                                 AS CHAR(#13#10)

    CALC [CalendarMask!MASK_HOOK_BUTTON]        AS 'ButtonHook'
    CALC [CalendarMask!MASK_HOOK_EXIT]          AS 'ExitHook'
    CALC [CalendarMask!MASK_HOOK_SHOW]          AS 'ShowHook'
    CALC [CalendarMask!MASK_HOOK_PRE_SAVE]      AS 'PreSaveHook'
    CALC [CalendarMask!MASK_HOOK_POST_EDIT]     AS 'PostEditHook'
    CALC [CalendarMask!MASK_HOOK_POST_NAVIGATE] AS 'PostNavigate'


    LIST_CLR   [ANote]
    LIST_CLR   [Calenders]
    CALC [TmpStr1] AS CON('A - ',[IP_FIRMEN_NAME])
    LIST_APPEND [Calenders],[TmpStr1]

    QUERY [Record]
      SELECT Name1, Name2, KalenderDatei, KalenderDateiPWD
        FROM personal
       WHERE RecordID = [ACT_MIT_ID|R0,0]
    END_QUERY
    EXECUTE [Record],[Res]
    IF [Res]
      GET_DATA [Record],[Res]
      IF [Res]
        IF [Record!KalenderDatei]<>''
          IF [Record!KalenderDateiPWD]<>''
            CALC [TmpStr1] AS CON('P - ',[Record!Name2])
            LIST_APPEND [Calenders],[TmpStr1]
          END_IF
        END_IF
      END_IF
    END_IF

    QUERY [Record]
      SELECT Name1, Name2, KalenderDatei
        FROM personal
       WHERE RecordID         <> [ACT_MIT_ID|R0,0]
         AND KalenderDatei    <> ""
         AND KalenderDateiPWD <> ""
         AND Aktiv            = 1
    END_QUERY
    EXECUTE [Record],[Res]
    IF [Res]
      GET_DATA [Record],[Res]
      WHILE [Res]
        IF [Record!KalenderDatei]<>''
          CALC [TmpStr1] AS CON('P - ',[Record!Name2])
          LIST_APPEND [Calenders],[TmpStr1]
        END_IF
        GET_DATA [Record],[Res]
      END_WHILE
    END_IF

    INI_READ	[Res], [LastUsedCalendar], [SCRIPT_STRING], [STATION_INI_FILE], 'LAST_USED_CALENDAR', 'IDEAL'
  END_PROC



  PROCEDURE ExitHook
    INI_WRITE [Res], [LastUsedCalendar], [SCRIPT_STRING], [STATION_INI_FILE], 'LAST_USED_CALENDAR', 'IDEAL'
    CALC [CalendarMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE NormalizeStr ~VS NS.Str
    IF [NS.Str]<>''
      CALC [NS.Str] AS REPLACE([NS.Str],'','Ae')
      CALC [NS.Str] AS REPLACE([NS.Str],'','Ue')
      CALC [NS.Str] AS REPLACE([NS.Str],'','Oe')
      CALC [NS.Str] AS REPLACE([NS.Str],'','ss')
      CALC [NS.Str] AS REPLACE([NS.Str],'','ae')
      CALC [NS.Str] AS REPLACE([NS.Str],'','ue')
      CALC [NS.Str] AS REPLACE([NS.Str],'','oe')
    END_IF
  END_PROC



  PROCEDURE SaveDate
    LIST_STR_GET [CalendarMask!9990120],[LastUsedCalendar],[LIST_ITEM_ACTUAL]
    IF [LastUsedCalendar]=''
      MESSAGE 'Achtung Fehler','Bitte geben Sie einen Kalender an.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [CalenderUSR] AS ''
    CALC [CalenderPWD] AS ''

    CALC [TmpStr1] AS COPY([LastUsedCalendar],1,1)
    IF [TmpStr1]='A'
      CALC [CalenderUSR] AS [IP_FIRMEN_KALENDER]
      CALC [CalenderPWD] AS [IP_FIRMEN_KALENDER_PWD]
    ELSE
      CALC [TmpStr1] AS COPY([LastUsedCalendar],5,255)

      QUERY [Record]
        SELECT KalenderDatei, KalenderDateiPWD
          FROM personal
         WHERE Name2            = "[TmpStr1]"
           AND KalenderDatei    <> ""
           AND KalenderDateiPWD <> ""
      END_QUERY
      EXECUTE [Record],[Res]
      IF [Res]
        GET_DATA [Record],[Res]
        IF [Res]
          CALC [CalenderUSR] AS [Record!KalenderDatei]
          CALC [CalenderPWD] AS [Record!KalenderDateiPWD]
        END_IF
      END_IF
    END_IF

    IF [CalenderUSR]=''
      MESSAGE 'Achtung Fehler','Die Kalenderinformationen konnten nicht geladen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    IF [CalenderPWD]=''
      MESSAGE 'Achtung Fehler','Das Kalenderpasswort konnte nicht geladen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [StartDate] AS [CalendarMask!StartDate]
    CALC [StopDate]  AS [CalendarMask!StartDate]
    IF [CalendarMask!Fullday]
      CALC [StartTime] AS '08:00:00'
      CALC [StopTime]  AS '17:00:00'
    ELSE
      CALC [StartTime] AS [CalendarMask!StartTime]
      CALC [StopTime]  AS [CalendarMask!StopTime]
    END_IF

    LIST_CLR [Event]
    CALC [TmpStr1] AS CON('http://www.cshgermany.com/Tools/OVS-GoogleCalendar/index.php?email=',[CalenderUSR],'&password=',[CalenderPWD],'&tzoffset=02')
    CALC [TmpStr1] AS CON([TmpStr1],'&startdate=',[StartDate|R0,yyyy-mm-dd],'&enddate=',[StopDate|R0,yyyy-mm-dd],'&starttime=',[StartTime|R0,hh:mm],'&endtime=',[StopTime|R0,hh:mm])

    CALC [TmpStr2] AS [CalendarMask!Subject]
    CALL NormalizeStr [TmpStr2]
    CALC [TmpStr1] AS CON([TmpStr1],'&title=',[TmpStr2])

    LIST_CLR [ANote]
    MEMO_GET [CalendarMask],[ANote],'Infotext'
    LIST_ITEM_GET [ANote],[LnAct],[LnCnt]
    IF [LnCnt]=0
      CALC [TmpStr1] AS CON([TmpStr1],'&text=')
    ELSE
      LIST_STR_GET [ANote],[TmpStr2],1
      CALL NormalizeStr [TmpStr2]
      CALC [TmpStr1] AS CON([TmpStr1],'&text=',[TmpStr2],'<br>')
    END_IF
    LIST_APPEND [Event], [TmpStr1]

    CALC [LnAct] AS 2
    WHILE [LnAct]<=[LnCnt]
      LIST_STR_GET [ANote],[TmpStr1],[LnAct]
      CALL NormalizeStr [TmpStr2]
      CALC [TmpStr1] AS CON([TmpStr1],'<br>')
      LIST_APPEND [Event],[TmpStr1]
      INC [LnAct]
    END_WHILE

    NAVIGATE [CalendarMask], 'GoogleService', [Event], [NaviRes]
  END_PROC



  PROCEDURE ShowHook
    LIST_CLR [CalendarMask!9990120]
    LIST_ITEM_GET [Calenders],[LnAct],[LnCnt]
    IF [LnCnt]>0
      CALC [SPos]  AS 0
      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [Calenders],[TmpStr1],[LnAct]
        IF [SPos]=0
          CALC [SPos] AS POS([LastUsedCalendar],[TmpStr1])
          IF [SPos]>0
            CALC [SPos] AS [LnAct]
          END_IF
        END_IF

        LIST_APPEND [CalendarMask!9990120],[TmpStr1]
        INC [LnAct]
      END_WHILE

      IF [SPos]=0
        CALC [SPos] AS 1
      END_IF
      LIST_ITEM_SET [CalendarMask!9990120], [SPos]
    END_IF


    IF [PAR_STR5]<>''
      CALC [TmpDate] AS [PAR_STR5]
      CALC [CalendarMask!StartDate] AS [TmpDate]
    END_IF

    CALC [TmpTime] AS [CalendarMask!StopTime]
    CALC [TmpTime] AS [TmpTime] + 1200
    CALC [CalendarMask!StopTime] AS [TmpTime]
    MASK_UPDATE [CalendarMask]

    IF [RECORD_ID2]>[EPSILON]
      CALC [TmpStr1] AS [PAR_STR3]
      IF [PAR_STR4]<>''
        CALC [TmpStr1] AS [PAR_STR4]
      END_IF

      IF [TmpStr1]=''
        EXIT_PROC
      END_IF

      IF [PAR_STR4]<>''
        QUERY [TableFld]
          SELECT * FROM TableFld WHERE XRefName = "[PAR_STR4]" AND FieldName1 <> "RECORDID"
        END_QUERY
        EXECUTE [TableFld],[Res]
        IF [Res]
          GET_DATA [TableFld],[Res]
          IF [Res]
            FORE_JUMP
          END_IF
        END_IF
      END_IF

      IF [PAR_STR3]<>''
        QUERY [TableFld]
          SELECT * FROM TableFld WHERE TableName = "[PAR_STR3]" AND FieldName1 <> "RECORDID"
        END_QUERY
        EXECUTE [TableFld],[Res]
        IF [Res]
          GET_DATA [TableFld],[Res]
          IF [Res]
            FORE_JUMP
          END_IF
        END_IF
      END_IF

      MESSAGE 'Achtung relationale Informationen fehlen','Zu dieser Tabelle sind keine ausreichenden Informationen in den "Tabellenfeldern" hinterlegt.'
      EXIT_PROC


      FORE_MARK
      LIST_CLR [ANote]
      NOTE_READ [ANote],[Res],'tablefld',1,[TableFld!RecordID]

      LIST_ITEM_GET [ANote],[LnAct],[LnCnt]
      IF [LnCnt]>0
        QUERY [Record]
        END_QUERY
        LIST_2_QUERY [ANote],[Record]

        CALC [TmpStr1] AS COPY([TableFld!TableName],1,1)
        CALC [TmpStr1] AS UPCASE([TmpStr1])
        CALC [TmpStr1] AS CON([TmpStr1],'.RecordID = ',[RECORD_ID2|R0,0])
        QUERY_ADD_WHERE [Record],255,[TmpStr1]

        EXECUTE [Record],[Res]
        IF [Res]=FALSE
          QUERY [Record]
          END_QUERY
          LIST_2_QUERY [ANote],[Record]

          CALC [TmpStr1] AS CON('RecordID = ',[RECORD_ID2|R0,0])
          QUERY_ADD_WHERE [Record],255,[TmpStr1]

          EXECUTE [Record],[Res]
        END_IF
      ELSE
        QUERY [Record]
          SELECT * FROM [TableFld!TableName] WHERE RecordID = [RECORD_ID2|R0,0]
        END_QUERY

        EXECUTE [Record],[Res]
      END_IF

      IF [Res]
        GET_DATA [Record],[Res]
        IF [Res]
          LOCAL_STR LocStr
          LIST_CLR [ANote]

          CALC [TmpStr1] AS CON([TableFld!TableName],':')
          IF [TmpStr1]<>''
            LIST_APPEND [ANote],[TmpStr1]
          END_IF

          CALC [TmpStr1] AS [Record![TableFld!FieldName1]]
          IF [TmpStr1]<>''
            LIST_APPEND [ANote],[TmpStr1]
            IF [LocStr]<>''
              CALC [LocStr] AS CON([LocStr],', ')
            END_IF
            CALC [LocStr] AS CON([LocStr],[TmpStr1])
          END_IF

          IF [TableFld!FieldName2]<>''
            IF [TableFld!FieldName2]<>'RECORDID'
              CALC [TmpStr1] AS [Record![TableFld!FieldName2]]
              IF [TmpStr1]<>''
                LIST_APPEND [ANote],[TmpStr1]
                IF [LocStr]<>''
                  CALC [LocStr] AS CON([LocStr],', ')
                END_IF
                CALC [LocStr] AS CON([LocStr],[TmpStr1])
              END_IF
            END_IF
          END_IF

          IF [TableFld!FieldName3]<>''
            IF [TableFld!FieldName3]<>'RECORDID'
              CALC [TmpStr1] AS [Record![TableFld!FieldName3]]
              IF [TmpStr1]<>''
                LIST_APPEND [ANote],[TmpStr1]
                IF [LocStr]<>''
                  CALC [LocStr] AS CON([LocStr],', ')
                END_IF
                CALC [LocStr] AS CON([LocStr],[TmpStr1])
              END_IF
            END_IF
          END_IF

          IF [TableFld!FieldName4]<>''
            IF [TableFld!FieldName4]<>'RECORDID'
              CALC [TmpStr1] AS [Record![TableFld!FieldName4]]
              IF [TmpStr1]<>''
                LIST_APPEND [ANote],[TmpStr1]
                IF [LocStr]<>''
                  CALC [LocStr] AS CON([LocStr],', ')
                END_IF
                CALC [LocStr] AS CON([LocStr],[TmpStr1])
              END_IF
            END_IF
          END_IF

          MEMO_SET [CalendarMask],[ANote],'Infotext'

          CALC [CalendarMask!Subject] AS [LocStr]
          MASK_UPDATE [CalendarMask]
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE PreSaveHook
    IF [CalendarMask!Subject]=''
      MESSAGE 'Achtung Abbruch','Bitte geben Sie mindestens einen Betreff ein.',[MESSAGE_WARNING]
      CALC [CalendarMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    CALL SaveDate

    CALC [CalendarMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE PostEditHook
    IF [CalendarMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [CalendarMask!MASK_ACT_FIELD_NAME]='StartTime'
      CALC [TmpTime]               AS [CalendarMask!StartTime]
      IF [TmpTime]<=[CalendarMask!StopTime]
        CALC [TmpTime]               AS [TmpTime]+600
        CALC [CalendarMask!StopTime] AS [TmpTime]
        MASK_UPDATE [CalendarMask]
      END_IF

    ELSE_IF [CalendarMask!MASK_ACT_FIELD_NAME]='StopTime'
      CALC [TmpTime] AS [CalendarMask!StartTime]
      IF [TmpTime]<=[CalendarMask!StartTime]
        CALC [TmpTime]                AS [TmpTime]-600
        CALC [CalendarMask!StartTime] AS [TmpTime]
        MASK_UPDATE [CalendarMask]
      END_IF

    ELSE_IF [CalendarMask!MASK_ACT_FIELD_NAME]='fullday'
      IF [CalendarMask!fullday]
        FIELD_FLAG_ON_OFF [CalendarMask],'StartTime', '[FIELD_FLAG_PROTECTED]', ''
        FIELD_FLAG_ON_OFF [CalendarMask],'StopTime',  '[FIELD_FLAG_PROTECTED]', ''
      ELSE
        FIELD_FLAG_ON_OFF [CalendarMask],'StartTime', '','[FIELD_FLAG_PROTECTED]'
        FIELD_FLAG_ON_OFF [CalendarMask],'StopTime',  '','[FIELD_FLAG_PROTECTED]'
      END_IF

    ELSE_IF [CalendarMask!MASK_ACT_FIELD_ID]=9990120
      LIST_STR_GET [CalendarMask!9990120],[TmpStr1],[LIST_ITEM_ACTUAL]
      IF [TmpStr1]<>''
        CALC [DateTimeStr]      AS PART([TmpStr1],1,'-')
        CALC [DateTimeStr]      AS TRIM([DateTimeStr])
        CALC [TmpStr1]           AS COPY([TmpStr1],5,255)
        CALC [LastUsedCalendar] AS TRIM([TmpStr1])
      END_IF
    END_IF
  END_PROC


  PROCEDURE PostNavigate
    IF [CalendarMask!MASK_ACT_FIELD_NAME]='GoogleService'
      NAVIGATE [CalendarMask], 'GoogleService', [NAVIGATE_SAVE], [NaviRes]
      MASK_COMMAND [CalendarMask],[MASK_COMMAND_EXIT]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  MASK_PROCESS [CalendarMask]
SCRIPT_END
