  ; Parameter : RECORD_ID1 = RecordID des Termins, falls er schon im DocuManager existiert  (kann leer sein)
  ;             RECORD_ID2 = RecordID des Datensatzes, fr den der Termin ist               (kann leer sein)
  ;             PAR_STR3   = TableName                                                      (kann leer sein)
  ;             PAR_STR4   = XRefName                                                       (kann leer sein)
  ;             PAR_STR5   = Start Date                                                     (kann leer sein)


; WebDAV  file:///L:/Arbeit/Kalender/DD-Kalender.ics
;
; privat-folder is in adressen.KalenderDatei



  PROCEDURE InitVars
    VAR_BOOL   SaveLastUsedCalendar, FALSE
               ; If this is true, the last used calendar will be saved to the station-ini-file
               ; otherwise the users calendar (see MitStamm.csh - mask) will be saved.
               ; The saved calendar will be one, that is the default, if this script is opened.


    VAR_MASK   CalendarMask,'CalendarSunbirdDlg'

    VAR_STR    CalendarFilePath
    VAR_STR    CalendarFileName
    VAR_LIST   CalendarFile
    VAR_STR    CalendarFilePathPrivat
    VAR_STR    CalendarPrivat

    VAR_STR    LastUsedCalendar

    IF [IP_FIRMEN_KALENDER]<>''
      CALC [CalendarFileName] AS REPLACE([IP_FIRMEN_KALENDER],'/','\')
    END_IF

    VAR_STR    DateTimeStr
    VAR_STR    CRLF
    VAR_LIST   ANote
    VAR_LIST   Event
    VAR_LIST   Calenders
    VAR_BOOL   Res

    VAR_QUERY  TableFld
    VAR_QUERY  Record
    VAR_STR    FName
    VAR_STR    TmpStr

    VAR_DATE   TmpDate
    VAR_TIME   TmpTime

    VAR_DATE   ADate
    VAR_TIME   ATime

    VAR_FLOAT  TimeStamp

    VAR_NUM    SPos
    VAR_NUM    LnAct
    VAR_NUM    LnCnt

    CALC [CRLF]                             AS CHAR(#13#10)
    CALC [CalendarMask!MASK_HOOK_BUTTON]    AS 'ButtonHook'
    CALC [CalendarMask!MASK_HOOK_EXIT]      AS 'ExitHook'
    CALC [CalendarMask!MASK_HOOK_SHOW]      AS 'ShowHook'
    CALC [CalendarMask!MASK_HOOK_PRE_SAVE]  AS 'PreSaveHook'
    CALC [CalendarMask!MASK_HOOK_POST_EDIT] AS 'PostEditHook'


    ; Lies die Position des privaten Kalender-Verzeichnisses aus den Adressen
    QUERY [Record]
      SELECT KalenderDatei FROM adressen WHERE RecordID = [ACT_MIT_ID|R0,0]
    END_QUERY
    EXECUTE [Record],[Res]
    IF [Res]
      GET_DATA [Record],[Res]
      IF [Res]
        IF [Record!KalenderDatei]<>''
          CALC [TmpStr] AS REPLACE([Record!KalenderDatei],'/','\')
        ELSE
          CALC [TmpStr] AS ''
        END_IF
        FILE_NAME [CalendarPrivat],[TmpStr]
        IF [CalendarPrivat]<>''
          CALC [CalendarPrivat] AS REPLACE([CalendarPrivat],'.ics','')
        END_IF
        FILE_PATH [CalendarFilePathPrivat],[TmpStr]
        IF [CalendarFilePathPrivat]<>''
          CALC [CalendarFilePathPrivat] AS REPLACE([CalendarFilePathPrivat],'/','\')
          FILE_SLASH [CalendarFilePathPrivat], TRUE
        END_IF
      END_IF
    END_IF

    FILE_PATH  [CalendarFilePath],[CalendarFileName]
    FILE_SLASH [CalendarFilePath], TRUE
    LIST_CLR   [ANote]
    LIST_CLR   [Calenders]
    FILE_LIST  [ANote], '*.ics', [CalendarFilePath], FALSE, FALSE, FALSE, TRUE
    LIST_ITEM_GET [ANote],[LnAct],[LnCnt]
    IF [LnCnt]>0
      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [ANote],[TmpStr],[LnAct]
        FILE_EXT [DateTimeStr], [TmpStr]
        CALC [TmpStr] AS REPLACE([TmpStr],[DateTimeStr],'')
        CALC [TmpStr] AS CON('A - ',[TmpStr])
        LIST_APPEND [Calenders],[TmpStr]
        INC [LnAct]
      END_WHILE
    END_IF

    IF [CalendarFilePathPrivat]<>''
      LIST_CLR   [ANote]
      FILE_LIST  [ANote], '*.ics', [CalendarFilePathPrivat], FALSE, FALSE, FALSE, TRUE
      LIST_ITEM_GET [ANote],[LnAct],[LnCnt]
      IF [LnCnt]>0
        CALC [LnAct] AS 1
        WHILE [LnAct]<=[LnCnt]
          LIST_STR_GET [ANote],[TmpStr],[LnAct]
          FILE_EXT [DateTimeStr], [TmpStr]
          CALC [TmpStr] AS REPLACE([TmpStr],[DateTimeStr],'')
          CALC [TmpStr] AS CON('P - ',[TmpStr])
          LIST_APPEND [Calenders],[TmpStr]
          INC [LnAct]
        END_WHILE
      END_IF
    END_IF

    CALC [TmpStr] AS CON([PRINTSET_PATH],[STATION_SHORT],'.INI')
    INI_READ	[Res], [LastUsedCalendar], [SCRIPT_STRING], [TmpStr], 'LAST_USED_CALENDAR', 'IDEAL'

    IF [LastUsedCalendar]=''
      FILE_NAME [LastUsedCalendar],[CalendarFileName]
      FILE_EXT  [TmpStr], [LastUsedCalendar]
      CALC [LastUsedCalendar] AS REPLACE([LastUsedCalendar],[TmpStr],'')
    END_IF
  END_PROC


  PROCEDURE ExitHook
    IF [SaveLastUsedCalendar]=FALSE
      IF [CalendarPrivat]<>''
        CALC [LastUsedCalendar] AS [CalendarPrivat]
      END_IF
    END_IF

    CALC [TmpStr] AS CON([PRINTSET_PATH],[STATION_SHORT],'.INI')
    INI_WRITE [Res], [LastUsedCalendar], [SCRIPT_STRING], [TmpStr], 'LAST_USED_CALENDAR', 'IDEAL'
    CALC [CalendarMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC


  PROCEDURE NormalizeStr ~VS NS.Str
    IF [NS.Str]<>''
      CALC [NS.Str] AS REPLACE([NS.Str],'','Ae')
      CALC [NS.Str] AS REPLACE([NS.Str],'','Ue')
      CALC [NS.Str] AS REPLACE([NS.Str],'','Oe')
      CALC [NS.Str] AS REPLACE([NS.Str],'','ss')
      CALC [NS.Str] AS REPLACE([NS.Str],'','ae')
      CALC [NS.Str] AS REPLACE([NS.Str],'','ue')
      CALC [NS.Str] AS REPLACE([NS.Str],'','oe')
    END_IF
  END_PROC


  PROCEDURE DateTime2SunbirdDateTime VD DT2SDT.ADate, VT DT2SDT.ATime, VS DT2SDT.VarName, VS DT2SDT.EndStr
    CALC [[DT2SDT.VarName]] AS ''

    LOCAL_NUM DT2SDT.Day
    LOCAL_NUM DT2SDT.Month
    LOCAL_NUM DT2SDT.Year

    LOCAL_NUM DT2SDT.Hour
    LOCAL_NUM DT2SDT.Min
    LOCAL_NUM DT2SDT.Sec

    LOCAL_STR DT2SDT.Str1
    LOCAL_STR DT2SDT.Str2

    DATE_2_DMY [DT2SDT.ADate], [DT2SDT.Day],  [DT2SDT.Month], [DT2SDT.Year]
    TIME_2_HMS [DT2SDT.ATime], [DT2SDT.Hour], [DT2SDT.Min],   [DT2SDT.Sec]

    IF [DT2SDT.Year]<40
      CALC [DT2SDT.Year] AS [DT2SDT.Year] + 2000
    ELSE_IF [DT2SDT.Year]<100
      CALC [DT2SDT.Year] AS [DT2SDT.Year] + 1900
    END_IF
    CALC [DT2SDT.Str1] AS [DT2SDT.Year]

    CALC [DT2SDT.Str2] AS [DT2SDT.Month]
    CALC [DT2SDT.Str2] AS EXT([DT2SDT.Str2],2,48,2,1)
    CALC [DT2SDT.Str1] AS CON([DT2SDT.Str1],[DT2SDT.Str2])

    CALC [DT2SDT.Str2] AS [DT2SDT.Day]
    CALC [DT2SDT.Str2] AS EXT([DT2SDT.Str2],2,48,2,1)
    CALC [DT2SDT.Str1] AS CON([DT2SDT.Str1],[DT2SDT.Str2],'T')

    CALC [DT2SDT.Str2] AS [DT2SDT.Hour]
    CALC [DT2SDT.Str2] AS EXT([DT2SDT.Str2],2,48,2,1)
    CALC [DT2SDT.Str1] AS CON([DT2SDT.Str1],[DT2SDT.Str2])

    CALC [DT2SDT.Str2] AS [DT2SDT.Min]
    CALC [DT2SDT.Str2] AS EXT([DT2SDT.Str2],2,48,2,1)
    CALC [DT2SDT.Str1] AS CON([DT2SDT.Str1],[DT2SDT.Str2])

    CALC [DT2SDT.Str2] AS [DT2SDT.Sec]
    CALC [DT2SDT.Str2] AS EXT([DT2SDT.Str2],2,48,2,1)
    CALC [DT2SDT.Str1] AS CON([DT2SDT.Str1],[DT2SDT.Str2],[DT2SDT.EndStr])

    CALC [[DT2SDT.VarName]] AS [DT2SDT.Str1]
  END_PROC


  PROCEDURE SaveDate
    CALC [ADate] AS [DATE]
    CALC [ATime] AS [TIME]

    LIST_CLR [Event]

    LIST_APPEND [Event],'BEGIN:VCALENDAR'

    CALC [DateTimeStr] AS CON('VERSION',[CRLF],' :2.0')
    LIST_APPEND [Event],[DateTimeStr]

    CALC [DateTimeStr] AS CON('PRODID',[CRLF],' :-//Mozilla.org/NONSGML Mozilla Calendar V1.0//EN')
    LIST_APPEND [Event],[DateTimeStr]

    ;BEGIN:VEVENT
    LIST_APPEND [Event],'BEGIN:VEVENT'

    ;UID:uuid1143538987898
    DATE_TIME_2_REC_ID [ADate],[ATime],[TimeStamp]
    CALC [DateTimeStr] AS CON('UID',[CRLF],' :uuid',[TimeStamp|R0,0])
    LIST_APPEND [Event],[DateTimeStr]

    ;SUMMARY:dd ist toll
    CALC [DateTimeStr] AS [CalendarMask!Subject]
    CALL NormalizeStr [DateTimeStr]
    CALC [DateTimeStr] AS CON('SUMMARY',[CRLF],' :',[DateTimeStr])
    LIST_APPEND [Event],[DateTimeStr]

    ;DESCRIPTION:Diest ist ein lngerer Text den ich auch noch speichern
    ;mchte\nAber der soll schn lang\nsein\n
    MEMO_GET [CalendarMask],[ANote],'Infotext'
    LIST_ITEM_GET [ANote],[LnAct],[LnCnt]
    CALC [LnAct] AS 1
    WHILE [LnAct]<=[LnCnt]
      LIST_STR_GET [ANote],[DateTimeStr],[LnAct]
      CALL NormalizeStr [DateTimeStr]
      IF [LnAct]=1
        CALC [DateTimeStr] AS CON('DESCRIPTION',[CRLF],' :',[DateTimeStr])
      ELSE
        CALC [DateTimeStr] AS CON(' ',[DateTimeStr],'\n')
      END_IF
      LIST_APPEND [Event],[DateTimeStr]
      INC [LnAct]
    END_WHILE

    ;STATUS:
    CALC [DateTimeStr] AS CON('STATUS',[CRLF],' :TENTATIVE')
    LIST_APPEND [Event],[DateTimeStr]

    ;CLASS:PUBLIC
    CALC [DateTimeStr] AS CON('CLASS',[CRLF],' :PUBLIC')
    LIST_APPEND [Event],[DateTimeStr]

;   ;PRIORITY:0
;   CALC [DateTimeStr] AS CON('PRIORITY',[CRLF],' :0')
;   LIST_APPEND [Event],[DateTimeStr]

    ;DTSTART:20060306T114500
    ;DTSTART;VALUE=DATE:20060306   ganztgig
    CALL DateTime2SunbirdDateTime [CalendarMask!StartDate], [CalendarMask!StartTime], 'DateTimeStr', ''
    IF [CalendarMask!fullday]
      CALC [DateTimeStr] AS COPY([DateTimeStr],1,8)
      CALC [DateTimeStr] AS CON('DTSTART',[CRLF],' ;VALUE=DATE',[CRLF],' :',[DateTimeStr])
    ELSE
      CALC [DateTimeStr] AS CON('DTSTART',[CRLF],' :',[DateTimeStr])
    END_IF
    LIST_APPEND [Event],[DateTimeStr]

    ;DTEND:20060306T124500
    ;DTEND;VALUE=DATE:20060307     ganztgig
    CALL DateTime2SunbirdDateTime [CalendarMask!StartDate], [CalendarMask!StopTime], 'DateTimeStr', ''
    IF [CalendarMask!fullday]
      CALC [DateTimeStr] AS COPY([DateTimeStr],1,8)
      CALC [DateTimeStr] AS CON('DTEND',[CRLF],' ;VALUE=DATE',[CRLF],' :',[DateTimeStr])
    ELSE
      CALC [DateTimeStr] AS CON('DTEND',[CRLF],' :',[DateTimeStr])
    END_IF
    LIST_APPEND [Event],[DateTimeStr]

    ;DTSTAMP:20060328T094300Z
    CALL DateTime2SunbirdDateTime [ADate], [ATime], 'DateTimeStr', 'Z'
    CALC [DateTimeStr] AS CON('DTSTAMP',[CRLF],' :',[DateTimeStr])
    LIST_APPEND [Event],[DateTimeStr]

;   ;CREATED:20060328T094300Z
;   CALL DateTime2SunbirdDateTime [ADate], [ATime], 'DateTimeStr', 'Z'
;   CALC [DateTimeStr] AS CON('CREATED',[CRLF],' :',[DateTimeStr])
;   LIST_APPEND [Event],[DateTimeStr]

    ;LAST-MODIFIED:20060328T094524Z
    CALL DateTime2SunbirdDateTime [ADate], [ATime], 'DateTimeStr', 'Z'
    CALC [DateTimeStr] AS CON('LAST-MODIFIED',[CRLF],' :',[DateTimeStr])
    LIST_APPEND [Event],[DateTimeStr]

    ;END:VEVENT
    LIST_APPEND [Event],'END:VEVENT'

    ;END:VCALENDAR
    LIST_APPEND [Event],'END:VCALENDAR'


    CALC [CalendarFileName] AS ''
    LIST_STR_GET [CalendarMask!9990120],[TmpStr],[LIST_ITEM_ACTUAL]
    IF [TmpStr]<>''
      CALC [DateTimeStr] AS PART([TmpStr],1,'-')
      CALC [DateTimeStr] AS TRIM([DateTimeStr])
      CALC [TmpStr]      AS COPY([TmpStr],5,255)
      CALC [TmpStr]      AS TRIM([TmpStr])
      CALC [TmpStr]      AS CON([TmpStr],'.ics')
      IF [DateTimeStr]='A'
        CALC [TmpStr] AS CON([CalendarFilePath],      [TmpStr])
      ELSE
        CALC [TmpStr] AS CON([CalendarFilePathPrivat],[TmpStr])
      END_IF

      EXIST_FILE [TmpStr],[Res]
      IF [Res]
        CALC [CalendarFileName] AS [TmpStr]
      END_IF
    END_IF

    IF [CalendarFileName]=''
      MESSAGE 'Achtung Fehler','Die Kalenderdatei konnte nicht gefunden werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    LIST_FILE_READ [CalendarFile],[Res],[CalendarFilename]
    IF [Res]=FALSE
      CALC [TmpStr] AS CON('Die Kalenderdatei konnte nicht gelesen werden!|',[CalendarFilename])
      MESSAGE 'Achtung Fehler',[TmpStr],[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [Event],[LnAct],[LnCnt]
    CALC [LnAct] AS 1
    WHILE [LnAct]<=[LnCnt]
      LIST_STR_GET [Event],[DateTimeStr],[LnAct]
      LIST_APPEND  [CalendarFile],[DateTimeStr]
      INC [LnAct]
    END_WHILE

    LIST_FILE_WRITE [CalendarFile],[Res],[CalendarFilename]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Kalenderdatei konnte nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    MESSAGE 'Information','Der Termin wurde gespeichert'
    MASK_CLEAR [CalendarMask]
    MASK_COMMAND [CalendarMask],[MASK_COMMAND_EXIT]
  END_PROC


  PROCEDURE ShowHook
    LIST_CLR [CalendarMask!9990120]
    LIST_ITEM_GET [Calenders],[LnAct],[LnCnt]
    IF [LnCnt]>0
      CALC [SPos]  AS 0
      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [Calenders],[TmpStr],[LnAct]
        IF [SPos]=0
          CALC [SPos] AS POS([LastUsedCalendar],[TmpStr])
          IF [SPos]>0
            CALC [SPos] AS [LnAct]
          END_IF
        END_IF

        LIST_APPEND [CalendarMask!9990120],[TmpStr]
        INC [LnAct]
      END_WHILE

      IF [SPos]=0
        CALC [SPos] AS 1
      END_IF
      LIST_ITEM_SET [CalendarMask!9990120], [SPos]
    END_IF


    IF [PAR_STR5]<>''
      CALC [TmpDate] AS [PAR_STR5]
      CALC [CalendarMask!StartDate] AS [TmpDate]
    END_IF

    CALC [ATime] AS [CalendarMask!StopTime]
    CALC [ATime] AS [ATime] + 1200
    CALC [CalendarMask!StopTime] AS [ATime]
    MASK_UPDATE [CalendarMask]

    IF [RECORD_ID2]>[EPSILON]
      CALC [TmpStr] AS [PAR_STR3]
      IF [PAR_STR4]<>''
        CALC [TmpStr] AS [PAR_STR4]
      END_IF

      IF [TmpStr]=''
        EXIT_PROC
      END_IF

      IF [PAR_STR4]<>''
        QUERY [TableFld]
          SELECT * FROM TableFld WHERE XRefName = "[PAR_STR4]" AND FieldName1 <> "RECORDID"
        END_QUERY
        EXECUTE [TableFld],[Res]
        IF [Res]
          GET_DATA [TableFld],[Res]
          IF [Res]
            FORE_JUMP
          END_IF
        END_IF
      END_IF

      IF [PAR_STR3]<>''
        QUERY [TableFld]
          SELECT * FROM TableFld WHERE TableName = "[PAR_STR3]" AND FieldName1 <> "RECORDID"
        END_QUERY
        EXECUTE [TableFld],[Res]
        IF [Res]
          GET_DATA [TableFld],[Res]
          IF [Res]
            FORE_JUMP
          END_IF
        END_IF
      END_IF

      MESSAGE 'Achtung relationale Informationen fehlen','Zu dieser Tabelle sind keine ausreichenden Informationen in den "Tabellenfeldern" hinterlegt.'
      EXIT_PROC


      FORE_MARK
      LIST_CLR [ANote]
      NOTE_READ [ANote],[Res],'tablefld',1,[TableFld!RecordID]

      LIST_ITEM_GET [ANote],[LnAct],[LnCnt]
      IF [LnCnt]>0
        QUERY [Record]
        END_QUERY
        LIST_2_QUERY [ANote],[Record]

        CALC [TmpStr] AS COPY([TableFld!TableName],1,1)
        CALC [TmpStr] AS UPCASE([TmpStr])
        CALC [TmpStr] AS CON([TmpStr],'.RecordID = ',[RECORD_ID2|R0,0])
        QUERY_ADD_WHERE [Record],255,[TmpStr]

        EXECUTE [Record],[Res]
        IF [Res]=FALSE
          QUERY [Record]
          END_QUERY
          LIST_2_QUERY [ANote],[Record]

          CALC [TmpStr] AS CON('RecordID = ',[RECORD_ID2|R0,0])
          QUERY_ADD_WHERE [Record],255,[TmpStr]

          EXECUTE [Record],[Res]
        END_IF
      ELSE
        QUERY [Record]
          SELECT * FROM [TableFld!TableName] WHERE RecordID = [RECORD_ID2|R0,0]
        END_QUERY

        EXECUTE [Record],[Res]
      END_IF

      IF [Res]
        GET_DATA [Record],[Res]
        IF [Res]
          LOCAL_STR LocStr
          LIST_CLR [ANote]

          CALC [TmpStr] AS CON([TableFld!TableName],':')
          IF [TmpStr]<>''
            LIST_APPEND [ANote],[TmpStr]
          END_IF

          CALC [TmpStr] AS [Record![TableFld!FieldName1]]
          IF [TmpStr]<>''
            LIST_APPEND [ANote],[TmpStr]
            IF [LocStr]<>''
              CALC [LocStr] AS CON([LocStr],', ')
            END_IF
            CALC [LocStr] AS CON([LocStr],[TmpStr])
          END_IF

          IF [TableFld!FieldName2]<>''
            IF [TableFld!FieldName2]<>'RECORDID'
              CALC [TmpStr] AS [Record![TableFld!FieldName2]]
              IF [TmpStr]<>''
                LIST_APPEND [ANote],[TmpStr]
                IF [LocStr]<>''
                  CALC [LocStr] AS CON([LocStr],', ')
                END_IF
                CALC [LocStr] AS CON([LocStr],[TmpStr])
              END_IF
            END_IF
          END_IF

          IF [TableFld!FieldName3]<>''
            IF [TableFld!FieldName3]<>'RECORDID'
              CALC [TmpStr] AS [Record![TableFld!FieldName3]]
              IF [TmpStr]<>''
                LIST_APPEND [ANote],[TmpStr]
                IF [LocStr]<>''
                  CALC [LocStr] AS CON([LocStr],', ')
                END_IF
                CALC [LocStr] AS CON([LocStr],[TmpStr])
              END_IF
            END_IF
          END_IF

          IF [TableFld!FieldName4]<>''
            IF [TableFld!FieldName4]<>'RECORDID'
              CALC [TmpStr] AS [Record![TableFld!FieldName4]]
              IF [TmpStr]<>''
                LIST_APPEND [ANote],[TmpStr]
                IF [LocStr]<>''
                  CALC [LocStr] AS CON([LocStr],', ')
                END_IF
                CALC [LocStr] AS CON([LocStr],[TmpStr])
              END_IF
            END_IF
          END_IF

          MEMO_SET [CalendarMask],[ANote],'Infotext'

          CALC [CalendarMask!Subject] AS [LocStr]
          MASK_UPDATE [CalendarMask]
        END_IF
      END_IF
    END_IF
  END_PROC


  PROCEDURE PreSaveHook
    IF [CalendarMask!Subject]=''
      MESSAGE 'Achtung Abbruch','Bitte geben Sie mindestens einen Betreff ein.',[MESSAGE_WARNING]
      CALC [CalendarMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    CALL SaveDate

    CALC [CalendarMask!MASK_ACTION] AS 1
  END_PROC


  PROCEDURE PostEditHook
    IF [CalendarMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [CalendarMask!MASK_ACT_FIELD_NAME]='StartTime'
      CALC [TmpTime]               AS [CalendarMask!StartTime]
      IF [TmpTime]<=[CalendarMask!StopTime]
        CALC [TmpTime]               AS [TmpTime]+600
        CALC [CalendarMask!StopTime] AS [TmpTime]
        MASK_UPDATE [CalendarMask]
      END_IF

    ELSE_IF [CalendarMask!MASK_ACT_FIELD_NAME]='StopTime'
      CALC [TmpTime] AS [CalendarMask!StartTime]
      IF [TmpTime]<=[CalendarMask!StartTime]
        CALC [TmpTime]                AS [TmpTime]-600
        CALC [CalendarMask!StartTime] AS [TmpTime]
        MASK_UPDATE [CalendarMask]
      END_IF

    ELSE_IF [CalendarMask!MASK_ACT_FIELD_NAME]='fullday'
      IF [CalendarMask!fullday]
        FIELD_FLAG_ON_OFF [CalendarMask],'StartTime', '[FIELD_FLAG_PROTECTED]', ''
        FIELD_FLAG_ON_OFF [CalendarMask],'StopTime',  '[FIELD_FLAG_PROTECTED]', ''
      ELSE
        FIELD_FLAG_ON_OFF [CalendarMask],'StartTime', '','[FIELD_FLAG_PROTECTED]'
        FIELD_FLAG_ON_OFF [CalendarMask],'StopTime',  '','[FIELD_FLAG_PROTECTED]'
      END_IF

    ELSE_IF [CalendarMask!MASK_ACT_FIELD_ID]=9990120
      LIST_STR_GET [CalendarMask!9990120],[TmpStr],[LIST_ITEM_ACTUAL]
      IF [TmpStr]<>''
        CALC [DateTimeStr]      AS PART([TmpStr],1,'-')
        CALC [DateTimeStr]      AS TRIM([DateTimeStr])
        CALC [TmpStr]           AS COPY([TmpStr],5,255)
        CALC [LastUsedCalendar] AS TRIM([TmpStr])
      END_IF
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  MASK_PROCESS [CalendarMask]
SCRIPT_END
