    ; exportiert  PROCEDURE DocMgrCheckHeader       VS DMCH.TableName, VF DMCH.RecID, ~VN DMCH.RFlag,    ~VF DMCH.HeaderID
    ;             PROCEDURE DocMgrFastInfo          VS DMFI.TableName, VF DMFI.RecID,  VF DMFI.HeaderID,  VS DMFI.ItemNote, ~VF DMFI.ItemID,   VS DMFI.Document, VS DMFI.ListName
    ;             PROCEDURE DocMgrFastInfoWithDatum VS DMFI.TableName, VF DMFI.RecID,  VF DMFI.HeaderID,  VS DMFI.ItemNote, ~VF DMFI.ItemID,   VF DMFI.NextProcID, VD DMFI.NextProcDate, VT DMFI.NextProcTime, VS DMFI.Document, VS DMFI.ListName
    ;             PROCEDURE DocMgrFastRsm           VS DMFR.TableName, VF DMFR.RecID,  VF DMFR.HeaderID,  VS DMFR.ItemNote,  VD DMFR.ItemDate, VT DMFR.ItemTime, VF DMFR.UserID, ~VF DMFR.ItemID, VS DMFR.Document, VS DMFI.ListName


    PROCEDURE DocMgrCheckHeader VS DMCH.TableName, VF DMCH.RecID, ~VN DMCH.RFlag, ~VF DMCH.HeaderID
      LOCAL_QUERY DMCH.Q
      LOCAL_BOOL  DMCH.Res
      LOCAL_NUM   DMCH.ANum

      CALC [DMCH.HeaderID] AS 0.0
      CALC [DMCH.RFlag]    AS 0

      ; 1. Hole die RecFlag des Datensatzes zu dem ein DocMgrHeader anegelet werden soll
      QUERY [DMCH.Q]
        SELECT RecFlag
          FROM [DMCH.TableName]
         WHERE RecordID  = [DMCH.RecID|R0,0]
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln des Status eines Datensatz konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      GET_DATA [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Status eines Datensatzes konnte nicht ermittelt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      CALC [DMCH.RFlag] AS [DMCH.Q!RecFlag]


      ; 2. Ist ein Header vorhanden
      QUERY [DMCH.Q]
        SELECT RecordID, FileName
          FROM DocMgrH
         WHERE RelRecID  = [DMCH.RecID|R0,0]
           AND TableName = "[DMCH.TableName]"
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Dokumenten-Manager-Ordner-Abfrage konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      GET_DATA [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]
        ; 2a. Setze die RecFlag des Datensatzes, falls notwendig
        CALC [DMCH.ANum] AS [DMCH.RFlag]
        FLAG_SET [DMCH.ANum],8192,TRUE
        IF [DMCH.ANum]<>[DMCH.RFlag]
          CALC [DMCH.RFlag] AS [DMCH.ANum]
          QUERY [DMCH.Q]
            UPDATE [DMCH.TableName]
               SET RecFlag  = [DMCH.RFlag]
             WHERE RecordID = [DMCH.RecID|R0,0]
          END_QUERY
          EXECUTE [DMCH.Q],[DMCH.Res]
          IF [DMCH.Res]=FALSE
            MESSAGE 'Achtung Abbruch','Der Status des Datensatzes konnte nicht gendert werden',[MESSAGE_ERROR]
            CALC [DMCH.HeaderID] AS 0.0
            CALC [DMCH.RFlag]    AS 0
            EXIT_PROC
          END_IF
        END_IF

        ; Header vorhanden --> fertig und raus hier
        CALC [DMCH.HeaderID] AS [DMCH.Q!RecordID]
        EXIT_PROC
      END_IF

      ; Ab hier : Kein Header da, mache einen

      ; 3. Mache einen Header
      NEW_RECORD [DMCH.Res], 'DOCMGRH', [DMCH.HeaderID], TRUE, FALSE, FALSE
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Ordner konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      QUERY [DMCH.Q]
        UPDATE DocMgrH
           SET FileName  = "Informationen / Termine / Dokumente / Bemerkungen",
               RelRecID  = [DMCH.RecID|R0,0],
               FileDate  = [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               TableName = "[DMCH.TableName]"
         WHERE RecordID  = [DMCH.HeaderID|R0,0]
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMCH.HeaderID] AS 0.0
        CALC [DMCH.RFlag]    AS 0
        EXIT_PROC
      END_IF


      ; 4. Setze die RecFlag des Datensatzes
      FLAG_SET [DMCH.RFlag],8192,TRUE
      QUERY [DMCH.Q]
        UPDATE [DMCH.TableName]
           SET RecFlag  = [DMCH.RFlag]
         WHERE RecordID = [DMCH.RecID|R0,0]
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Status des Datensatzes konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMCH.HeaderID] AS 0.0
        CALC [DMCH.RFlag]    AS 0
        EXIT_PROC
      END_IF
    END_PROC


    PROCEDURE DocMgrFastInfo VS DMFI.TableName, VF DMFI.RecID, VF DMFI.HeaderID, VS DMFI.ItemNote, ~VF DMFI.ItemID, VS DMFI.Document, VS DMFI.ListName
      LOCAL_QUERY DMFI.Q
      LOCAL_BOOL  DMFI.Res
      LOCAL_TIME  DMFI.ATime
      LOCAL_FLOAT DMFI.AFloat1
      LOCAL_FLOAT DMFI.AFloat2
      LOCAL_NUM   DMFI.ListCnt
      LOCAL_NUM   DMFI.ListAct

      CALC [DMFI.ItemID] AS 0.0

      NEW_RECORD [DMFI.Res], 'DOCMGRI', [DMFI.ItemID], TRUE, FALSE, FALSE
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMFI.ATime] AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFI.AFloat1]
      CALC [DMFI.AFloat2] AS [DMFI.AFloat1] + 30805

      QUERY [DMFI.Q]
        UPDATE DocMgrI
           SET HeaderID              =  [DMFI.HeaderID|R0,0],
               ItemNote              =  "[DMFI.ItemNote]",

               FilePath              =  "[DMFI.Document]",

               CreatorID             =  [ACT_MIT_ID|R0,0],
               CreateDate            =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMFI.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =  0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "Schnellinfo",
               CreateDTID            =  [DMFI.AFloat1],
               CreateRunDTID         =  [DMFI.AFloat2],
               CreateDuranceID       =  30805

         WHERE RecordID              = [DMFI.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFI.Q],[DMFI.Res]
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFI.ItemID] AS 0.0
        EXIT_PROC
      END_IF

      CALC [DMFI.ListCnt] AS 1
      LIST_ITEM_GET [[DMFI.ListName]],[DMFI.ListAct],[DMFI.ListCnt]
      IF [DMFI.ListCnt]=0
        LIST_CLR    [[DMFI.ListName]]
        LIST_APPEND [[DMFI.ListName]],[DMFI.ItemNote]
      END_IF
      NOTE_WRITE  [[DMFI.ListName]],[DMFI.Res],'DocMgrI',1,[DMFI.ItemID]
    END_PROC


    PROCEDURE DocMgrFastInfoWithDatum VS DMFI.TableName, VF DMFI.RecID, VF DMFI.HeaderID, VS DMFI.ItemNote, ~VF DMFI.ItemID, VF DMFI.NextProcID, VD DMFI.NextProcDate, VT DMFI.NextProcTime, VS DMFI.Document, VS DMFI.ListName
      LOCAL_QUERY DMFI.Q
      LOCAL_BOOL  DMFI.Res
      LOCAL_TIME  DMFI.ATime
      LOCAL_FLOAT DMFI.AFloat1
      LOCAL_FLOAT DMFI.AFloat2
      LOCAL_NUM   DMFI.ListCnt
      LOCAL_NUM   DMFI.ListAct

      CALC [DMFI.ItemID] AS 0.0

      NEW_RECORD [DMFI.Res], 'DOCMGRI', [DMFI.ItemID], TRUE, FALSE, FALSE
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMFI.ATime] AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFI.AFloat1]
      CALC [DMFI.AFloat2] AS [DMFI.AFloat1] + 30805

      QUERY [DMFI.Q]
        UPDATE DocMgrI
           SET HeaderID              =  [DMFI.HeaderID|R0,0],
               ItemNote              =  "[DMFI.ItemNote]",

               FilePath              =  "[DMFI.Document]",

               CreatorID             =  [ACT_MIT_ID|R0,0],
               CreateDate            =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMFI.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =  0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "Schnellinfo",
               CreateDTID            =  [DMFI.AFloat1],
               CreateRunDTID         =  [DMFI.AFloat2],
               CreateDuranceID       =  30805

         WHERE RecordID              = [DMFI.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFI.Q],[DMFI.Res]
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFI.ItemID] AS 0.0
        EXIT_PROC
      END_IF

      CALC [DMFI.ListCnt] AS 1
      LIST_ITEM_GET [[DMFI.ListName]],[DMFI.ListAct],[DMFI.ListCnt]
      IF [DMFI.ListCnt]=0
        LIST_CLR    [[DMFI.ListName]]
        LIST_APPEND [[DMFI.ListName]],[DMFI.ItemNote]
      END_IF
      NOTE_WRITE  [[DMFI.ListName]],[DMFI.Res],'DocMgrI',1,[DMFI.ItemID]
    END_PROC



    PROCEDURE DocMgrFastRsm VS DMFR.TableName, VF DMFR.RecID, VF DMFR.HeaderID, VS DMFR.ItemNote, VD DMFR.ItemDate, VT DMFR.ItemTime, VF DMFR.UserID, ~VF DMFR.ItemID, VS DMFR.Document, VS DMFR.ListName
      LOCAL_QUERY DMFR.Q
      LOCAL_BOOL  DMFR.Res
      LOCAL_TIME  DMFR.ATimeCreate
      LOCAL_TIME  DMFR.ATimeRsm
      LOCAL_FLOAT DMFR.AFloatCreate1
      LOCAL_FLOAT DMFR.AFloatCreate2
      LOCAL_FLOAT DMFR.AFloatRsm1
      LOCAL_FLOAT DMFR.AFloatRsm2
      LOCAL_NUM   DMFR.ListCnt
      LOCAL_NUM   DMFR.ListAct

      CALC [DMFR.ItemID] AS 0.0

      NEW_RECORD [DMFR.Res], 'DOCMGRI', [DMFR.ItemID], TRUE, FALSE, FALSE
      IF [DMFR.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMFR.ATimeCreate]   AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFR.AFloatCreate1]
      CALC [DMFR.AFloatCreate2] AS [DMFR.AFloatCreate1] + 30805

      CALC [DMFR.ATimeRsm]      AS [DMFR.ItemTime]+5
      DATE_TIME_2_REC_ID [DMFR.ItemDate], [DMFR.ItemTime], [DMFR.AFloatRsm1]
      CALC [DMFR.AFloatRsm2]    AS [DMFR.AFloatRsm1]    + 30805

      QUERY [DMFR.Q]
        UPDATE DocMgrI
           SET HeaderID              =  [DMFR.HeaderID|R0,0],
               ItemNote              =  "[DMFR.ItemNote]",

               FilePath              =  "[DMFR.Document]",

               CreatorID             =  [ACT_MIT_ID|R0,0],
               CreateDate            =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMFR.ATimeCreate|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =  0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "schnelle Wiedervorlage",
               CreateDTID            =  [DMFR.AFloatCreate1],
               CreateRunDTID         =  [DMFR.AFloatCreate2],
               CreateDuranceID       =  30805,

               NextProcessorID       =  [DMFR.UserID|R0,0],
               NextProcessDate       =  [SQL_DATE_QUOTES_4_MODIFY][DMFR.ItemDate|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               NextProcessTime       =  [SQL_TIME_QUOTES_4_MODIFY][DMFR.ItemTime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               NextProcessRunDate    =  [SQL_DATE_QUOTES_4_MODIFY][DMFR.ItemDate|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               NextProcessRunTime    =  [SQL_TIME_QUOTES_4_MODIFY][DMFR.ATimeRsm|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               NextProcessDurance    =  0.08,
               NextProcessDuranceStr =  "0.00:05",
               NextProcessType       =  "schnelle Wiedervorlage",
               NextProcessDTID       =  [DMFR.AFloatRsm1],
               NextProcessRunDTID    =  [DMFR.AFloatRsm2],
               NextProcessDuranceID  =  30805

         WHERE RecordID              = [DMFR.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFR.Q],[DMFR.Res]
      IF [DMFR.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFR.ItemID] AS 0.0
        EXIT_PROC
      END_IF

      CALC [DMFR.ListCnt] AS 1
      LIST_ITEM_GET [[DMFR.ListName]],[DMFR.ListAct],[DMFR.ListCnt]
      IF [DMFR.ListCnt]=0
        LIST_CLR    [[DMFR.ListName]]
        LIST_APPEND [[DMFR.ListName]],[DMFR.ItemNote]
      END_IF
      NOTE_WRITE  [[DMFR.ListName]],[DMFR.Res],'DocMgrI',1,[DMFR.ItemID]
    END_PROC
