
  PROCEDURE InitVars
    VAR_BOOL    Res
    VAR_FLOAT   TmpID
    VAR_BROWSER SB
    VAR_QUERY   UQ
    VAR_STR     StartingWithStr

    VAR_STR     ActTableName
    VAR_STR     MainClause
    VAR_STR     MainClauseAlias
    VAR_STR     FieldName1
    VAR_STR     FieldName2
    VAR_STR     FieldName3
    VAR_STR     FieldName4
    VAR_STR     FieldName5
    VAR_STR     FieldName6
    VAR_STR     VDelField

    VAR_QUERY   GridQ
    VAR_NUM     GridOption
    CALC [GridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_ICON_USER]

    VAR_BOOL    BufVirtualDelete
    VAR_BOOL    BufSuids

    VAR_FLOAT   StartID
    VAR_FLOAT   StopID

    VAR_MASK    WorkMask,'ChangeLogDialog'

    CALC [WorkMask!MASK_HOOK_EXIT]       AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_SHOW]       AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_BUTTON]     AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_POST_CLEAR] AS 'PostClearHook'
    CALC [WorkMask!MASK_HOOK_PRE_SEARCH] AS 'PreSearchHook'
    CALC [WorkMask!MASK_HOOK_POST_EDIT]  AS 'PostEditHook'
    CALC [WorkMask!MASK_HOOK_GRID_OK]    AS 'GridOkHook'
    CALC [WorkMask!MASK_HOOK_GRID_USER]  AS 'GridUserHook'

    CALC [BufVirtualDelete]              AS [VIRTUAL_DELETE]
    CALC [BufSuids]                      AS [SUPER_UNIQUE_RECORDID]

    CALC [SUPER_UNIQUE_RECORDID]         AS FALSE

    IDENTIFIER_EXIST 'GlobChangeLogTable',[Res]
    IF [Res]=FALSE
      GLOBAL_BOOL GlobChangeLogTableMade,  FALSE
      GLOBAL_STR  GlobChangeLogTable

      ACT_REC_ID [TmpID]
      CALC [GlobChangeLogTable] AS CON('cl',[TmpID|R0,0])
    END_IF
  END_PROC



  PROCEDURE ChangeLogTableDrop
    IF [GlobChangeLogTableMade]
      QUERY [UQ]
        DROP TABLE [GlobChangeLogTable]
      END_QUERY

      EXECUTE [UQ],[Res]
      IF [Res]=FALSE
        MESSAGE 'Abbruch','Die ChangeLog-Temporrtabelle konnte nicht gelscht werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [GlobChangeLogTableMade] AS FALSE
    ELSE
      CALC [Res] AS TRUE
    END_IF
  END_PROC



  PROCEDURE ChangeLogTableCreate
    CALL ChangeLogTableDrop
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR CreateAddStr1
    IF [SQL_VENDOR]='MYSQL'
      CALC [CreateAddStr1] AS 'ENGINE=MEMORY'
    END_IF

    QUERY [UQ]
      CREATE TABLE [GlobChangeLogTable]
        (TableName  [SQL_DEFINE_STRING]   (61) [SQL_DEFINE_STRING_END],
         FieldName1 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName2 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName3 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName4 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName5 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName6 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         RelRecID   [SQL_DEFINE_RECORDID]      [SQL_DEFINE_RECORDID_END],
         ScriptName [SQL_DEFINE_STRING]   (41) [SQL_DEFINE_STRING_END],
         Aktiv      [SQL_DEFINE_LONGINT]       [SQL_DEFINE_LONGINT_END],
         VDelID     [SQL_DEFINE_RECORDID]      [SQL_DEFINE_RECORDID_END] ) [CreateAddStr1]
    END_QUERY

    EXECUTE [UQ],[Res]
    IF [Res]=FALSE
      MESSAGE 'Abbruch','Die ChangeLog-Temporrtabelle konnte nicht erzeugt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [GlobChangeLogTableMade] AS TRUE
  END_PROC



  PROCEDURE ChangeLogTableInsert
    IF [WorkMask!UserID]<=[EPSILON]
      EXIT_PROC
    END_IF

    IF [ActTableName]=''
      EXIT_PROC
    END_IF

    CALC [VIRTUAL_DELETE] AS [BufVirtualDelete]

    LOCAL_QUERY LocQ
    LOCAL_QUERY LocC
    LOCAL_QUERY LocU
    LOCAL_BOOL  LocRes
    LOCAL_LIST  LocList
    LOCAL_NUM   LocAllCnt
    LOCAL_NUM   LocLnAct
    LOCAL_NUM   LocLnCnt
    LOCAL_NUM   LocPos
    LOCAL_STR   LocScriptName
    LOCAL_STR   LocAlias
    LOCAL_STR   LocStr1
    LOCAL_STR   LocStr2
    LOCAL_STR   LocStr3
    LOCAL_STR   LocStr4
    LOCAL_STR   LocStr5
    LOCAL_STR   LocStr6
    LOCAL_BOOL  LocFound

    ; Wurde in TableFld-Angaben ein Query hinterlegt?
    CALC [FieldName1]    AS 'RecordID'
    CALC [FieldName2]    AS 'RecordID'
    CALC [FieldName3]    AS 'RecordID'
    CALC [FieldName4]    AS 'RecordID'
    CALC [FieldName5]    AS 'RecordID'
    CALC [FieldName6]    AS 'RecordID'
    CALC [VDelField]     AS 'VirtualDelID'
    CALC [LocScriptName] AS ''

    QUERY [LocC]
      SELECT *
        FROM [ActTableName]
    END_QUERY

    QUERY [LocQ]
      SELECT *
        FROM tablefld
       WHERE RecordID  > 0
         AND TableName = "[ActTableName]"
    END_QUERY
    EXECUTE [LocQ], [LocRes]
    IF [LocRes]
      GET_DATA [LocQ], [LocRes]
      IF [LocRes]
        CALC [LocAlias] AS ''
        CALC [LocPos]   AS POS('.',[LocQ!FieldName1])
        IF [LocPos]>0
          CALC [LocAlias] AS COPY([LocQ!FieldName1],1,2)
        END_IF
        CALC [LocAlias] AS UPCASE([LocAlias])

        IF [LocQ!FieldName1]<>''
          CALC [FieldName1]  AS [LocQ!FieldName1]
        ELSE
          CALC [FieldName1]  AS CON([LocAlias],[FieldName1])
        END_IF
        IF [LocQ!FieldName2]<>''
          CALC [FieldName2]  AS [LocQ!FieldName2]
        ELSE
          CALC [FieldName2]  AS CON([LocAlias],[FieldName2])
        END_IF
        IF [LocQ!FieldName3]<>''
          CALC [FieldName3]  AS [LocQ!FieldName3]
        ELSE
          CALC [FieldName3]  AS CON([LocAlias],[FieldName3])
        END_IF
        IF [LocQ!FieldName4]<>''
          CALC [FieldName4]  AS [LocQ!FieldName4]
        ELSE
          CALC [FieldName4]  AS CON([LocAlias],[FieldName4])
        END_IF
        IF [LocQ!FieldName5]<>''
          CALC [FieldName5]  AS [LocQ!FieldName5]
        ELSE
          CALC [FieldName5]  AS CON([LocAlias],[FieldName5])
        END_IF
        IF [LocQ!FieldName6]<>''
          CALC [FieldName6]  AS [LocQ!FieldName6]
        ELSE
          CALC [FieldName6]  AS CON([LocAlias],[FieldName6])
        END_IF

        CALC [VDelField]     AS CON([LocAlias],[VDelField])

        CALC [LocScriptName] AS [LocQ!ExecScript]

        LIST_CLR  [LocList]
        NOTE_READ [LocList],[LocRes],'tablefld',1,[LocQ!RecordID]
        LIST_ITEM_GET [LocList],[LocLnAct],[LocLnCnt]
        IF [LocLnCnt]>0
          ; Ja, es wurde Query hinterlegt - wir nehmen es!
          QUERY [LocC]
          END_QUERY
          LIST_2_QUERY [LocList],[LocC]
        ELSE
          ; Nein, es wurde kein Query hinterlegt - wir bauen uns eines!
          QUERY [LocC]
               SELECT [FieldName1], [FieldName2], [FieldName3], [FieldName4], [FieldName5], [FieldName6], [VDelField], RecordID, RecFlag
                 FROM [ActTableName]
             ORDER BY [FieldName1], [FieldName2], [FieldName3], [FieldName4], [FieldName5], [FieldName6]
          END_QUERY
        END_IF
      END_IF
    END_IF

    CALC [MainClause]      AS CON('(IDUser = ',[WorkMask!UserIdx],' OR UpdateID = ',[WorkMask!UserIdx],')')
    CALC [MainClauseAlias] AS CON('(',[LocAlias],'IDUser = ',[WorkMask!UserIdx],' OR ',[LocAlias],'UpdateID = ',[WorkMask!UserIdx],')')
    IF [WorkMask!StartDate]>[DEFAULT_DATE]
      DATE_TIME_2_REC_ID [WorkMask!StartDate],[WorkMask!StartTime],[StartID]
      CALC [MainClause]      AS CON([MainClause],' AND (RecordID >= ',[StartID|R0,0],' OR UpdateTime >= ',[StartID|R0,0],')')
      CALC [MainClauseAlias] AS CON([MainClauseAlias],' AND (',[LocAlias],'RecordID >= ',[StartID|R0,0],' OR ',[LocAlias],'UpdateTime >= ',[StartID|R0,0],')')
    END_IF
    IF [WorkMask!EndDate]>[DEFAULT_DATE]
      DATE_TIME_2_REC_ID [WorkMask!EndDate],[WorkMask!EndTime],[StopID]
      CALC [MainClause]      AS CON([MainClause],' AND (RecordID <= ',[StopID|R0,0],' OR UpdateTime <= ',[StopID|R0,0],')')
      CALC [MainClauseAlias] AS CON([MainClauseAlias],' AND (',[LocAlias],'RecordID <= ',[StopID|R0,0],' OR ',[LocAlias],'UpdateTime <= ',[StopID|R0,0],')')
    END_IF

    QUERY_ADD_WHERE [LocC],255,[MainClauseAlias]

    ; Das Query ausfhren und prfen, ob darin auch eine RecordID entahlten ist. - Sonst wird nicht weiter gemacht
    EXECUTE [LocC],[LocRes]
    IF [LocC!QUERY_DESCR_REC_ID]<>''
      QUERY_COUNT [LocC],[LocLnCnt]

      ; Wurden berhaupt Daten gefunden?
      IF [LocLnCnt]>0
        ; Jetzt kann es also losgehn. Die Daten sollen in die Temporrtabelle.

        ; Als erstes wird die berschrift generiert. Diese wird mit Aktiv = 1 gespeichert, dann kann man sie spter gut hervorheben.
        ; Nun die Feldnamen ohne Alias als berschrift.
        CALC [LocStr1] AS [FieldName1]
        CALC [LocStr2] AS [FieldName2]
        CALC [LocStr3] AS [FieldName3]
        CALC [LocStr4] AS [FieldName4]
        CALC [LocStr5] AS [FieldName5]
        CALC [LocStr6] AS [FieldName6]
        IF [LocAlias]<>''
          CALC [LocStr1] AS PART([FieldName1],2,'.')
          CALC [LocStr2] AS PART([FieldName2],2,'.')
          CALC [LocStr3] AS PART([FieldName3],2,'.')
          CALC [LocStr4] AS PART([FieldName4],2,'.')
          CALC [LocStr5] AS PART([FieldName5],2,'.')
          CALC [LocStr6] AS PART([FieldName6],2,'.')
        END_IF

        ; berschrift speichern
        QUERY [LocU]
          INSERT
            INTO [GlobChangeLogTable]
          VALUES ("[ActTableName]","[LocStr1]","[LocStr2]","[LocStr3]","[LocStr4]","[LocStr5]","[LocStr6]",0,"[LocScriptName]",1,0)
        END_QUERY
        EXECUTE [LocU],[LocRes]


        ; Nun das INSERT-Query basteln: alles bis zum FROM wegnehmen. Dann das INSERT-INTO davor bauen.
        IF [BufVirtualDelete]=FALSE
          CALC [VDelField] AS REPLACE([VDelField],'VirtualDelID','EventFlag')
        END_IF

        QUERY [LocU]
          INSERT
            INTO [GlobChangeLogTable]
                 (FieldName1, FieldName2, FieldName3, FieldName4, FieldName5, FieldName6, RelRecID, VDelID)
          SELECT [FieldName1], [FieldName2], [FieldName3], [FieldName4], [FieldName5], [FieldName6], [LocC!QUERY_DESCR_REC_ID], [VDelField]
        END_QUERY

        ; Alles ab dem FROM an das Query dran bauen
        LIST_CLR [LocList]
        QUERY_2_LIST [LocC],[LocList]
        LIST_ITEM_GET [LocList],[LocLnAct],[LocLnCnt]
        CALC [LocLnAct] AS 1
        CALC [LocFound] AS FALSE
        WHILE [LocLnAct]<=[LocLnCnt]
          LIST_STR_GET [LocList],[LocStr1],[LocLnAct]
          IF [LocFound]
            QUERY_ADD_STRING [LocU],[LocStr1]
          ELSE
            CALC [LocPos] AS POS(' FROM ',[LocStr1])
            IF [LocPos]=0
              CALC [LocPos] AS POS(' FROM',[LocStr1])
              IF [LocPos]=0
                CALC [LocPos] AS POS('FROM ',[LocStr1])
                IF [LocPos]<>1
                  CALC [LocPos] AS 0
                END_IF
              END_IF
            END_IF
            IF [LocPos]>0
              CALC [LocFound] AS TRUE
              CALC [LocStr1]  AS COPY([LocStr1],[LocPos],255)
              QUERY_ADD_STRING [LocU],[LocStr1]
            END_IF
          END_IF

          INC [LocLnAct]
        END_WHILE

        ; Einfgen....
        EXECUTE [LocU],[LocRes]

        ; Zum Schlu in die neuen Eintrge noch die fehlenden Informationen geben. FERTIG!
        QUERY [LocU]
          UPDATE [GlobChangeLogTable]
             SET Aktiv      =  0,
                 TableName  = "[ActTableName]",
                 ScriptName = "[LocScriptName]"
           WHERE TableName  = ""
        END_QUERY

        FLAG_SET [LocU!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
        FLAG_SET [LocU!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE

        EXECUTE [LocU],[LocRes]

        CALC [VIRTUAL_DELETE] AS FALSE
        QUERY [LocU]
          SELECT COUNT(TableName)
            FROM [GlobChangeLogTable]
           WHERE TableName = "[ActTableName]"
        END_QUERY
        EXECUTE [LocU],[LocRes]
        IF [LocRes]
          GET_DATA [LocU],[LocRes]
          IF [LocRes]
            CALC [LocLnCnt] AS [LocU!COUNT(TableName)]
            IF [LocLnCnt]>0
              DEC [LocLnCnt]
            END_IF

            IF [LocLnCnt]>0
              CALC [LocAllCnt] AS [LocAllCnt]+[LocLnCnt]
              CALC [LocStr1]   AS CON([ActTableName],'   ',[LocLnCnt])

              QUERY [LocU]
                UPDATE [GlobChangeLogTable]
                   SET TableName = "[LocStr1]"
                 WHERE TableName = "[ActTableName]"
                   AND Aktiv      = 1
              END_QUERY
              EXECUTE [LocU],[LocRes]
            END_IF
          END_IF
        END_IF

        CALC [VIRTUAL_DELETE] AS [BufVirtualDelete]
      END_IF
    END_IF
  END_PROC



  PROCEDURE InitGrid
    CALC [VIRTUAL_DELETE] AS FALSE

    LOCAL_STR LocClause
    LOCAL_STR LocStr1
    IF [WorkMask!Tabellen]
      CALC [LocClause] AS 'WHERE Aktiv = 1'
    END_IF

    QUERY [GridQ]
      SELECT [  W10 N"Tabelle"             ]TableName,
             [  W25 N"Bezeichner 1"        ]FieldName1,
             [  W25 N"Bezeichner 2"        ]FieldName2,
             [  W25 N"Bezeichner 3"        ]FieldName3,
             [  W25 N"Bezeichner 4"        ]FieldName4,
             [  W25 N"Bezeichner 5"        ]FieldName5,
             [  W25 N"Bezeichner 6"        ]FieldName6,
             [H                            ]RelRecID,
             [H                            ]ScriptName,
             [H                       K>"0"]Aktiv,
             [H                     C1A>"0"]VDelID
        FROM [GlobChangeLogTable]
             [LocClause]
             [StartingWithStr]
    END_QUERY

    EXECUTE [GridQ],[Res]
    IF [Res]
      GRID_SET [WorkMask], 'Ergebnisse', [GridQ], [Res], [GridOption]
    END_IF
  END_PROC



  PROCEDURE GridOkHook
    CALC [StartingWithStr] AS ''
    IF [WorkMask!MASK_ACT_GRID_NAME]='Ergebnisse'
      IF [WorkMask!Tabellen]
        CALC [WorkMask!Tabellen] AS FALSE
        MASK_UPDATE [WorkMask]
        CALC [StartingWithStr] AS CON('STARTING WITH TableName = "',[GridQ!TableName],'"')
        CALL InitGrid
      ELSE
        IF [GridQ!ScriptName]<>''
          CALC [VIRTUAL_DELETE] AS [BufVirtualDelete]
          SCRIPT [GridQ!ScriptName], [GridQ!RelRecID]
          CALC [VIRTUAL_DELETE] AS FALSE
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE GridUserHook
    IF [WorkMask!MASK_ACT_GRID_NAME]='Ergebnisse'
      IF [WorkMask!Tabellen]=FALSE
        QUERY [SB]
            SELECT [  W10 N"Datum"                                  ]ChangeDate,
                   [  W10 N"Zeit"                                   ]ChangeTime,
                   [  W10 N"Benutzer"                               ]UserName,
                   [  W15 N"Feld"                                   ]FieldName,
                   [  W35 N"alter Wert"                             ]ValueOld,
                   [  W35 N"neuer Wert"                             ]ValueNew,
                   [H                   C1A="[WorkMask!UserID|R0,0]"]UserID,
                   [H                                               ]RecordID,
                   [H                                               ]RecFlag

              FROM changes

             WHERE TableName = "[GridQ!TableName]"
               AND RelRecID  =  [GridQ!RelRecID|R0,0]

          ORDER BY TableName, RelRecID, ChangeDate DESC, ChangeTime DESC
        END_QUERY

        CALC [SB!QUERY_ID] AS 'ChangeLog002'
        VIEW [SB],[Res],'Feldnderungen'
        CALC [SB!QUERY_ID] AS ''
      END_IF
    END_IF
  END_PROC



  PROCEDURE PostEditHook
    IF [WorkMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='Tabellen'
      CALL InitGrid
    END_IF
  END_PROC



  PROCEDURE ExitHook
    CALL ChangeLogTableDrop
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
    CALC [VIRTUAL_DELETE] AS [BufVirtualDelete]
  END_PROC



  PROCEDURE PostClearHook
    CALC [WorkMask!MASK_HEAD_LINE] AS 'ChangeLog'
    CALL ChangeLogTableDrop
    CALL ChangeLogTableCreate
    CALL InitGrid
  END_PROC



  PROCEDURE PreSearchHook
    LOCAL_NUM  LocTablesLnAct
    LOCAL_NUM  LocTablesLnCnt

    LIST_STR_GET [WorkMask!Tables],[ActTableName]
    IF [ActTableName]=''
      LIST_ITEM_GET [WorkMask!Tables],[LocTablesLnAct],[LocTablesLnCnt]
      CALC [LocTablesLnAct] AS 1
      WHILE [LocTablesLnAct]<=[LocTablesLnCnt]
        LIST_STR_GET [WorkMask!Tables],[ActTableName],[LocTablesLnAct]
        CALL ChangeLogTableInsert
        INC [LocTablesLnAct]
      END_WHILE
    ELSE
      CALL ChangeLogTableInsert
    END_IF

    CALL InitGrid
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE GetUser
    QUERY [SB]
             SELECT [  N"Name 1"      W15]Name1,
                    [  N"name 2"      W15]Name2,
                    [  N"Personalnr." W08]Personalnummer,
                    [H                   ]RecordID,
                    [H                   ]UserID
               FROM adressen
              WHERE Mitarbeiter = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
                AND MAktiv      > 0
           ORDER BY Name1, Name2, Personalnummer
      STARTING WITH RecordID    = [WorkMask!UserID|R0,0]
    END_QUERY

    CALC [SB!QUERY_ID] AS 'ChangeLog001'
    VIEW [SB],[Res],'Mitarbeiter'
    CALC [SB!QUERY_ID] AS ''

    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [WorkMask!UserID]     AS [SB!RecordID]
    CALC [WorkMask!UserIdx]    AS [SB!UserID]
    CALC [WorkMask!Dummy.User] AS [SB!Name1]
    MASK_UPDATE [WorkMask], TRUE
  END_PROC



  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_User'
      CALL GetUser
    END_IF
  END_PROC



  PROCEDURE TableClr VS LocTable, VB LocLike
    LOCAL_NUM LocNum

    BACK_MARK

    IF [LocLike]
      LIST_STR_FIND [WorkMask!Tables],[LocTable], [LocNum]
    ELSE
      LIST_STR_FIND [WorkMask!Tables],[LocTable], [LocNum], '>>'
    END_IF

    IF [LocNum]>0
      LIST_DELETE [WorkMask!Tables],[LocNum]
      MASK_UPDATE [WorkMask]
      IF [LocLike]
        BACK_JUMP
      END_IF
    END_IF
  END_PROC



  PROCEDURE ShowHook
    CALL TableClr 'applog',    FALSE
    CALL TableClr 'changes',   FALSE
    CALL TableClr 'dbinfos',   FALSE
    CALL TableClr 'lockrecs',  FALSE
    CALL TableClr 'reltable',  FALSE
    CALL TableClr 'sqlstream', FALSE
    CALL TableClr 'suids',     FALSE

    CALL TableClr 'cl7*',      TRUE
    CALL TableClr 'ms7*',      TRUE

    LIST_APPEND [WorkMask!Tables], ''
    LIST_SORT [WorkMask!Tables]
    LIST_ITEM_SET [WorkMask!Tables],1
    CALC [WorkMask!Tables] AS ''
    MASK_UPDATE [WorkMask], TRUE

    CALL ChangeLogTableCreate
    CALL InitGrid
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END