  ; Vorraussetzung: Im CARA-Ordner muss sich ein Unterordner mit dem Namen "PortableBrowser" befinden.
  ;                 In diesem Ordner muss sich entweder die entpackte IronPortable-Installation im Verzeichnis "IronPortable" befinden
  ;                 UND/ODER es befindet sich dort die GoogleChromePortable-Installer-EXE, die etwa diesen Namen hat:
  ;                 "GoogleChromePortable_10.0.648.204_online.paf.exe" (wobei die Versionsnummer im Mittelteil durchaus abweichen darf).
  ;
  ; INTERN   = interner Browser von Cara, das ist ein IE, da Cara ja nur die DLLs von Windows nutzt
  ; STANDARD = der auf dem jeweiligen System installierte Standard-Internet-Browser
  ; CHROME   = es soll der protable Chrome-Browser verwendet werden und ggf. instaliiert werden (erfordert Benutzer-Zugriff)
  ; IRON     = es soll der protable Iron-Browser verwendet werden und ggf. instaliiert werden



  PROCEDURE CallBrowserInitConsts
    CONST_NUM  CALL_BROWSER_TYPE_INTERN,   0
    CONST_NUM  CALL_BROWSER_TYPE_STANDARD, 1
    CONST_NUM  CALL_BROWSER_TYPE_CHROME,   2
    CONST_NUM  CALL_BROWSER_TYPE_IRON,     3

    VAR_NUM    CallBrowserPreferredType, [CALL_BROWSER_TYPE_STANDARD]
  END_PROC



  PROCEDURE CallBrowserInitBase VN CallBrowserInitType
    ; Welcher portable Browser soll installiert und verwendet werden?
    VAR_NUM    CallBrowserType, [CallBrowserInitType]

    ; Temporrordner fr den portable Browser (hier wird STATION_SHORT weiter unten noch angefgt)
    VAR_STR    CallBrowserPath, [TEMP_FILES_PATH]

    ; Dateiname inkl. Dateipfad zum portable Browser
    VAR_STR    CallBrowserFile

    ; Suchmaske fr das Installtionsprogramm des portable Browser
    VAR_STR    CallBrowserInst

    ; Pfad zur Exe des portable Browser innerhalb des Temporrordners
    VAR_STR    CallBrowserExec

    LOCAL_BOOL LocRes
    LOCAL_STR  LocStr

    IDENTIFIER_EXIST 'CallBrowserPara', [LocRes]
    IF [LocRes]=FALSE
      ; Parameterliste fr den Aufruf vom portable Browser. Hier muss die URL rein.
      GLOBAL_LIST CallBrowserPara

      LIST_CLR [CallBrowserPara]
    END_IF

    IF [CallBrowserType]=[CALL_BROWSER_TYPE_INTERN]
      VAR_STR  CallBrowserMaskHeadline, 'Internetbrowser'
      VAR_MASK CallBrowserMask,         'CallBrowserDlg'

      CALC [CallBrowserMask!MASK_HOOK_EXIT]     AS 'CallBrowserHookExit'
      CALC [CallBrowserMask!MASK_HOOK_IS_READY] AS 'CallBrowserHookIsReady'

      EXIT_PROC
    ELSE_IF [CallBrowserType]=[CALL_BROWSER_TYPE_STANDARD]

      EXIT_PROC
    ELSE_IF [CallBrowserType]=[CALL_BROWSER_TYPE_CHROME]
      CALC [CallBrowserInst] AS 'GoogleChromePortable_*_online.paf.exe'
      CALC [CallBrowserExec] AS 'GoogleChromePortable\GoogleChromePortable.exe'
    ELSE_IF [CallBrowserType]=[CALL_BROWSER_TYPE_IRON]
      CALC [CallBrowserInst] AS 'IronPortable'
      CALC [CallBrowserExec] AS 'IronPortable\IronPortable.exe'
    END_IF

    ; Pro Station ein Temporrordner im Printset-Pfad (aber nicht pro Station und User)
    CALC [CallBrowserPath] AS CON([CallBrowserPath],[STATION_SHORT],'\')
  END_PROC



  PROCEDURE CallBrowserInit VN CallBrowserInitType
    LOCAL_BOOL LocRes
    LOCAL_STR  LocStr

    CALL CallBrowserInitBase [CallBrowserInitType]

    ; Gibt es den Temporrordner schon?
    EXIST_DIR [CallBrowserPath],[LocRes]
    IF [LocRes]=FALSE
      ; Nein: dann erzeuge ihn
      FORCE_DIR [LocRes],[CallBrowserPath]
      IF [LocRes]=FALSE
        MESSAGE 'Achtung Fehler','Der portable Browser-Pfad konnte nicht angelegt werden',[MESSAGE_ERROR]
        CALC [CallBrowserPath] AS ''
        EXIT_PROC
      END_IF
    END_IF

    ; Wurde der portable Browser schon im Temporrordner installiert?
    CALC [CallBrowserFile] AS CON([CallBrowserPath],[CallBrowserExec])
    EXIST_FILE [CallBrowserFile],[LocRes]
    IF [LocRes]=FALSE
      IF [CallBrowserType]=[CALL_BROWSER_TYPE_CHROME]
        ; Nein: Dann rufe im CARA-Verzeichnis die aktuelle GoogleChromePortable-Installationsdatei auf
        ;       und zeige dem User an wie das Verzeichnis heit, in das er installlieren muss.
        LOCAL_LIST LocList
        LOCAL_NUM  LocCnt
        LOCAL_NUM  LocMax

        ; Wie leutet der Dateiname des aktuellen portable Browser-Installers?
        CALC [LocStr] AS CON([CARA_PATH],'PortableBrowser\')
        LIST_CLR  [LocList]
        FILE_LIST [LocList], [CallBrowserInst], [LocStr], FALSE, FALSE, FALSE, TRUE

        LIST_ITEM_GET [LocList],[LocCnt],[LocMax]
        IF [LocMax]>0
          CALC [LocCnt] AS 1
          LIST_STR_GET [LocList],[LocStr],[LocCnt]
          IF [LocStr]<>''
            LIST_CLR [LocList]
            CALC [LocStr] AS CON([CARA_PATH],'PortableBrowser\',[LocStr])
            ; Temporrordnername in einem WAIT anzeigen
            WAIT_INFO 'Bitte intsallieren Sie in Verzeichnis',[CallBrowserPath]
            ; Installer aufrufen
            EXTERN [LocStr],[EXTERN_SHOWNA], [LocList], TRUE, [CallBrowserPath], [LocRes], [LocMax]
            END_WAIT
          ELSE
            MESSAGE 'Achtung Fehler','Die portable Browser-Quelle ist nicht verfgbar (2)',[MESSAGE_ERROR]
            CALC [CallBrowserPath] AS ''
            CALC [CallBrowserFile] AS ''
          END_IF
        ELSE
          MESSAGE 'Achtung Fehler','Die portable Browser-Quelle ist nicht verfgbar (1)',[MESSAGE_ERROR]
          CALC [CallBrowserPath] AS ''
          CALC [CallBrowserFile] AS ''
        END_IF

      ELSE_IF [CallBrowserType]=[CALL_BROWSER_TYPE_IRON]
        ; Nein: Dann kopiere aus dem CARA-Verzeichnis das IronPortable Verzeichnis in den Temporrordner.
        CALC [LocStr] AS CON([CARA_PATH],'PortableBrowser\',[CallBrowserInst])
        EXIST_DIR [CallBrowserPath],[LocRes]
        IF [LocRes]
          WAIT_INFO 'Bitte warten...','Der portable Browser wird in den Temporrordner kopiert'
          COPY_DIR [LocRes], [LocStr], [CallBrowserPath]
          END_WAIT
          IF [LocRes]=FALSE
            MESSAGE 'Achtung Fehler','Die portable Browser-Quelle konhte nicht kopiert werden',[MESSAGE_ERROR]
            CALC [CallBrowserPath] AS ''
            CALC [CallBrowserFile] AS ''
          END_IF
        ELSE
          MESSAGE 'Achtung Fehler','Die portable Browser-Quelle ist nicht verfgbar (3)',[MESSAGE_ERROR]
          CALC [CallBrowserPath] AS ''
          CALC [CallBrowserFile] AS ''
        END_IF
      END_IF
    END_IF

    ; Wurde der portable Browser denn nun wirklich im Temporrordner installiert?
    CALC [CallBrowserFile] AS CON([CallBrowserPath],[CallBrowserExec])
    EXIST_FILE [CallBrowserFile],[LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Achtung Fehler','Der portable Browser wurde nicht korrekt bzw. nicht am vorgesehenen Ort installiert',[MESSAGE_ERROR]
      CALC [CallBrowserPath] AS ''
      CALC [CallBrowserFile] AS ''
    END_IF
  END_PROC



  PROCEDURE CallBrowserStart VB LocWait4App
    LOCAL_BOOL LocRes
    LOCAL_NUM  LocNum
    LOCAL_LIST LocList

    IF [CallBrowserType]=[CALL_BROWSER_TYPE_INTERN]
      MASK_PROCESS [CallBrowserMask]
      EXIT_PROC
    ELSE_IF [CallBrowserType]=[CALL_BROWSER_TYPE_STANDARD]
      SHELL_EXECUTE 'open', [CallBrowserPara], '', '', [EXTERN_SHOWNA]
      EXIT_PROC
    END_IF

    IF [CallBrowserPath]<>''
      IF [CallBrowserFile]<>''
        ; Die URL, die der Aufrufer in die Liste [CallBrowserPara] eingefgt hat
        ; muss nun in dieser Form an GoogleChromePortable weitergegeben
        ; werden: GoogleChromePortable.exe --app "URL"
        LIST_CLR    [LocList]
        LIST_APPEND [LocList],' --allow-file-access-from-files --app="'
;       LIST_APPEND [LocList],' --allow-file-access-from-files "'
        LIST_2_LIST [CallBrowserPara], [LocList], FALSE, 1
        LIST_APPEND [LocList],'"'
        LIST_CLR    [CallBrowserPara]
        LIST_APPEND [CallBrowserPara],' '
        LIST_2_LIST_STR [LocList], [CallBrowserPara], '', 1

        EXTERN [CallBrowserFile],[EXTERN_SHOWNA], [CallBrowserPara], [LocWait4App], [CallBrowserPath], [LocRes],[LocNum]
        EXIT_PROC
      END_IF
    END_IF

    MESSAGE 'Achtung Fehler','Der portable Browser ist nicht verfgbar',[MESSAGE_ERROR]
  END_PROC



  PROCEDURE CallBrowserHookIsReady
    CALC [CallBrowserMask!MASK_HOOK_IS_READY] AS ''
    CALC [CallBrowserMask!MASK_IS_BROWSER]    AS TRUE
    CALC [CallBrowserMask!MASK_HEAD_LINE]     AS [CallBrowserMaskHeadline]

    NAVIGATE [CallBrowserMask], 'OnlineInfo', [CallBrowserPara]
  END_PROC



  PROCEDURE CallBrowserHookExit
    CALC [CallBrowserMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC

