  ; Parameter PAR_STR1   = StartDatum
  ;           PAR_STR2   = StopDatum
  ;           PAR_STR3   = Header (wie z.B. "alle Termine bis heute [22.11.2007]")
  ;           RECORD_ID4 > 0 ==>> Erster Aufruf, Zurcksetzten der Markierungen fr "Zur Kenntnis genommen"


  ;Document-Managament-System +
  INCLUDE DmsRoutines.inc
  ;Document-Managament-System -


  PROCEDURE InitVars
    ;Document-Managament-System +
    CALL DmsXmlInit
    ;Document-Managament-System -

    VAR_QUERY    Q
    VAR_BOOL     Res
    VAR_DATE     StartDate
    VAR_DATE     StopDate
    VAR_STR      TimeClause
    VAR_BOOL     VirtDelBuf, [VIRTUAL_DELETE]
    VAR_BOOL     SuidsBuf,   [SUPER_UNIQUE_RECORDID]

;   VAR_DATABASE SilvERP,silverp_novatherm,silverpUser,silverpPassword,,3306,192.168.1.6
    VAR_DATABASE SilvERP,silverp_novatherm,silverpUser,silverpPassword,,3306,127.0.0.1

    CALC [StartDate] AS [PAR_STR1]
    CALC [StopDate]  AS [PAR_STR2]

    CALC [TimeClause] AS ''
    IF [RECORD_ID4]<=[EPSILON]
      IF [StopDate]=[DATE]
        CALC [TimeClause] AS CON(' AND d.tsStart <= ',[SQL_TIME_QUOTES_4_SELECT],[TIME|R0,[SQL_TIME_PICTURE_4_SELECT]],[SQL_TIME_QUOTES_4_SELECT],' ')
      END_IF
    END_IF

    CALC [VIRTUAL_DELETE]        AS FALSE
    CALC [SUPER_UNIQUE_RECORDID] AS FALSE
  END_PROC



  PROCEDURE Main
    IDENTIFIER_EXIST 'SilvERP',[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Verbindung zur DMS-Datenbank konnte nicht hergestellt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY_SET_DATABASE [Q], [SilvERP]

    QUERY [Q]
      SELECT count(d.idRecord)

        FROM silverp_novatherm.dmsorganizeritem          d,
             silverp_novatherm.dmsconnectororganizeritem c,
             silverp_novatherm.archivedocument           a,
             silverp_novatherm.organizer                 o,
             silverp_novatherm.archiveentry              e,
             dmsdata_novatherm.archivedata               s

       WHERE o.idUser             = [ACT_MIT_ID|R0,0]
         AND o.organizerType      = "standard"
         AND c.idOrganizer        = o.idRecord
         AND a.sourceIdentifier   = c.idItem
         AND a.idInvisble         = 0
         AND d.idArchiveDocument  = a.idRecord
         AND e.idArchiveDocument  = a.idRecord
         AND e.idRecord           = s.idArchiveEntry
         AND s.blobFilename       = "Terminbeschreibung.html"
         AND d.itemType           = "event"
         AND d.bvDone             = 0
         AND d.dtStart           >= [SQL_DATE_QUOTES_4_SELECT][StartDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND d.dtStart           <= [SQL_DATE_QUOTES_4_SELECT][StopDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
             [TimeClause]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]
      GET_DATA [Q],[Res]
      IF [Res]
        CALC [DOCU_MGR_DATE_LIST_COUNT] AS [Q!COUNT(d.idRecord)]
      END_IF
    END_IF


    QUERY [Q]
      SELECT count(d.idRecord)

        FROM silverp_novatherm.dmsorganizeritem          d,
             silverp_novatherm.dmsconnectororganizeritem c,
             silverp_novatherm.archivedocument           a,
             silverp_novatherm.organizer                 o,
             silverp_novatherm.workflow                  w,
             silverp_novatherm.archiveentry              e,
             dmsdata_novatherm.archivedata               s

       WHERE o.idUser             =    [ACT_MIT_ID|R0,0]
         AND o.organizerType      =    "standard"
         AND c.idOrganizer        =    o.idRecord
         AND a.sourceIdentifier   =    c.idItem
         AND a.sourceIdentifier   =    w.sourceIdentifier
         AND a.idInvisble         =    0
         AND d.idArchiveDocument  =    a.idRecord
         AND d.itemType           =    "task"
         AND d.bvDone             =    0
         AND a.idRecord           =    e.idArchiveDocument
         AND e.idRecord           =    s.idArchiveEntry
         AND s.blobFilename       =    "Allgemein_Notizen.html"
         AND w.stateData          LIKE "[SQL_WILD_CARD_MULTI]IDUser\";s:13:\"[ACT_MIT_ID|R0,0]\";s:5:\"state\";s:10:\"inProgress[SQL_WILD_CARD_MULTI]"
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]
      GET_DATA [Q],[Res]
      IF [Res]
        CALC [DOCU_MGR_DATE_LIST_COUNT] AS [DOCU_MGR_DATE_LIST_COUNT] + [Q!COUNT(d.idRecord)]
      END_IF
    END_IF

    CALC [DOCU_MGR_DATE_LIST_UNCHECKED] AS [DOCU_MGR_DATE_LIST_COUNT]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main

  CALC [VIRTUAL_DELETE]        AS [VirtDelBuf]
  CALC [SUPER_UNIQUE_RECORDID] AS [SuidsBuf]
SCRIPT_END