  ; Parameter PAR_STR1   = StartDatum
  ;           PAR_STR2   = StopDatum
  ;           PAR_STR3   = Header (wie z.B. "alle Termine bis heute [22.11.2007]")


  ;Document-Managament-System +
  INCLUDE DmsRoutines.inc
  ;Document-Managament-System -


  PROCEDURE InitVars
    ;Document-Managament-System +
    CALL DmsXmlInit
    ;Document-Managament-System -

    VAR_BROWSER  B
    VAR_BOOL     Res
    VAR_NUM      RelRecFlag
    VAR_DATE     StartDate
    VAR_DATE     StopDate
    VAR_FLOAT    RecID
    VAR_STR      TimeClause
    VAR_BOOL     VirtDelBuf, [VIRTUAL_DELETE]
    VAR_BOOL     SuidsBuf,   [SUPER_UNIQUE_RECORDID]

;   VAR_DATABASE SilvERP,silverp_novatherm,silverpUser,silverpPassword,,3306,192.168.1.6
    VAR_DATABASE SilvERP,silverp_novatherm,silverpUser,silverpPassword,,3306,127.0.0.1

    CALC [StartDate] AS [PAR_STR1]
    IF [StartDate]<='01.01.1980'
      CALC [StartDate] AS '01.01.1990'
    END_IF
    CALC [StopDate]  AS [PAR_STR2]

    CALC [TimeClause] AS ''
    IF [RECORD_ID5]>[EPSILON]
      IF [StopDate]=[DATE]
        CALC [TimeClause] AS CON(' AND d.tsStart <= ',[SQL_TIME_QUOTES_4_SELECT],[TIME|R0,[SQL_TIME_PICTURE_4_SELECT]],[SQL_TIME_QUOTES_4_SELECT],' ')
      END_IF
    END_IF

    CALC [VIRTUAL_DELETE]        AS FALSE
    CALC [SUPER_UNIQUE_RECORDID] AS FALSE
  END_PROC



  PROCEDURE Main
    IDENTIFIER_EXIST 'SilvERP',[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Verbindung zur DMS-Datenbank konnte nicht hergestellt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY_SET_DATABASE [B], [SilvERP]

    BACK_MARK

    QUERY [B]
        SELECT [  W08 N"Datum"            ]d.dtStart AS StartDate,
               [  W08 N"um"               ]d.tsStart AS StartTime,

               [  W08 N"bis zum"          ]d.dtEnd,
               [  W08 N"um "              ]d.tsEnd,

               [  W15 N"Titel"            ]d.summary,
               [  W25 N"Beschreibung"     ]d.description,

               [  W08 N"Anlage"           ]d.dtCreate,
               [  W08 N"um  "             ]d.tsCreate,

               [  W12 N"Ort"              ]d.location,
               [  W08 N"ganzer Tag"       ]d.bvWholeDay,

               [  W50 N"Info"         R"4"]s.blobData,

               [H C3A="task"              ]d.itemType,

               [H                         ]a.sourceIdentifier,
               [H                         ]e.idRecord

          FROM silverp_novatherm.dmsorganizeritem          d,
               silverp_novatherm.dmsconnectororganizeritem c,
               silverp_novatherm.archivedocument           a,
               silverp_novatherm.organizer                 o,
               silverp_novatherm.archiveentry              e,
               dmsdata_novatherm.archivedata               s

         WHERE o.idUser             = [ACT_MIT_ID|R0,0]
           AND o.organizerType      = "standard"
           AND c.idOrganizer        = o.idRecord
           AND a.sourceIdentifier   = c.idItem
           AND a.idInvisble         = 0
           AND d.idArchiveDocument  = a.idRecord
           AND e.idArchiveDocument  = a.idRecord
           AND e.idRecord           = s.idArchiveEntry
           AND s.blobFilename       = "Terminbeschreibung.html"
           AND d.itemType           = "event"
           AND d.bvDone             = 0
           AND d.dtStart           >= [SQL_DATE_QUOTES_4_SELECT][StartDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
           AND d.dtStart           <= [SQL_DATE_QUOTES_4_SELECT][StopDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
               [TimeClause]

      UNION

        SELECT d.dtStart AS StartDate,
               d.tsStart AS StartTime,

               "",
               "",

               d.summary,
               "",

               d.dtCreate,
               d.tsCreate,

               "",
               "",

               s.blobData,

               d.itemType,

               a.sourceIdentifier,
               e.idRecord

;       SELECT [  W08 N"Datum"            ]d.dtStart,
;              [  W08 N"um"               ]d.tsStart,
;
;              [  W15 N"Titel"            ]d.summary,
;
;              [  W08 N"Anlage"           ]d.dtCreate,
;              [  W08 N"um  "             ]d.tsCreate,
;
;              [  W50 N"Info"         R"4"]s.blobData

          FROM silverp_novatherm.dmsorganizeritem          d,
               silverp_novatherm.dmsconnectororganizeritem c,
               silverp_novatherm.archivedocument           a,
               silverp_novatherm.organizer                 o,
               silverp_novatherm.workflow                  w,
               silverp_novatherm.archiveentry              e,
               dmsdata_novatherm.archivedata               s

         WHERE o.idUser             =    [ACT_MIT_ID|R0,0]
           AND o.organizerType      =    "standard"
           AND c.idOrganizer        =    o.idRecord
           AND a.sourceIdentifier   =    c.idItem
           AND a.sourceIdentifier   =    w.sourceIdentifier
           AND a.idInvisble         =    0
           AND d.idArchiveDocument  =    a.idRecord
           AND d.itemType           =    "task"
           AND d.bvDone             =    0
           AND a.idRecord           =    e.idArchiveDocument
           AND e.idRecord           =    s.idArchiveEntry
           AND s.blobFilename       =    "Allgemein_Notizen.html"
           AND w.stateData          LIKE "[SQL_WILD_CARD_MULTI]IDUser\";s:13:\"[ACT_MIT_ID|R0,0]\";s:5:\"state\";s:10:\"inProgress[SQL_WILD_CARD_MULTI]"

      ORDER BY StartDate DESC, StartTime DESC
    END_QUERY

    EXECUTE [B], [Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Termine und Aufgaben-Abfrage konnte nicht bersetzt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [B!QUERY_ID] AS 'DocMgrShow001'
    VIEW [B], [Res], 'Termine- und Aufgabenliste (farbig = Aufgaben)', '', FALSE, TRUE
    IF [Res]
      IF [B!d.itemType]='task'
        SCRIPT 'DmsTasks.csh'
      ELSE
        SCRIPT 'DmsDates.csh'
      END_IF
      BACK_JUMP
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main

  CALC [VIRTUAL_DELETE]        AS [VirtDelBuf]
  CALC [SUPER_UNIQUE_RECORDID] AS [SuidsBuf]
SCRIPT_END