
  INCLUDE Routines.inc
  INCLUDE DmsRoutines.inc



  PROCEDURE InitVars
    VAR_MASK DmsFreeMask,'DmsFree'

    CALC [DmsFreeMask!MASK_HOOK_PRE_SAVE]    AS 'PreSaveHook'
    CALC [DmsFreeMask!MASK_HOOK_POST_DELETE] AS 'PostDeleteHook'
    CALC [DmsFreeMask!MASK_HOOK_POST_CLEAR]  AS 'PostClearHook'
    CALC [DmsFreeMask!MASK_HOOK_EXIT]        AS 'ExitHook'
    CALC [DmsFreeMask!MASK_HOOK_DROP]        AS 'DropHook'
  END_PROC



  PROCEDURE ExitHook
    CALC [DmsFreeMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE PreSaveHook
    CALC [DmsFreeMask!CreateTime] AS [TIME]
    MASK_UPDATE [DmsFreeMask],TRUE
  END_PROC



  PROCEDURE PostDeleteHook
    MASK_CLEAR [DmsFreeMask]
  END_PROC



  PROCEDURE PostClearHook
    CALC [DmsFreeMask!CreateTime] AS [TIME]
    MASK_UPDATE [DmsFreeMask],TRUE
  END_PROC



  PROCEDURE DropHook
    LOCAL_NUM   LocYNRes
    LOCAL_BOOL  LocRes
    LOCAL_STR   LocStr1
    LOCAL_STR   LocStr2
    LOCAL_STR   LocFNameFull
    LOCAL_STR   LocFNamePure
    LOCAL_STR   LocFNamePath
    LOCAL_NUM   LocLnAct
    LOCAL_NUM   LocLnMax
    LOCAL_NUM   LocCount
    LOCAL_STR   LocMaskName,  'DmsFreeMask'

    LOCAL_STR   LocPronomRel, 'dem'
    LOCAL_STR   LocPronomDef, 'einen'
    LOCAL_STR   LocBelegName, 'Datensatz'

    IF [[LocMaskName]!MASK_RECORD_ID]<=[EPSILON]
      CALC [LocStr1] AS CON('Bitte whlen Sie zunchst ',[LocPronomDef],' ',[LocBelegName],' aus.')
      MESSAGE 'Achtung Abbruch',[LocStr1],[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [[LocMaskName]!MASK_DROP_LIST],[LocLnAct],[LocLnMax]
    IF [LocLnMax]=0
      CALC [[LocMaskName]!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    IF [LocLnMax]>1
      CALC [LocStr1] AS CON('Mchten Sie nun ',[LocPronomRel],' ',[LocBelegName],' insgesamt ',[LocLnMax],' Dateien zuordnen?')
    ELSE
      CALC [LocStr1] AS CON('Mchten Sie nun ',[LocPronomRel],' ',[LocBelegName],' diese Datei zuordnen?')
    END_IF
    CALC [LocYNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!',[LocStr1],[LocYNRes]
    IF [LocYNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    CALC [LocLnAct] AS 1
    WHILE [LocLnAct]<=[LocLnMax]
      LIST_STR_GET [[LocMaskName]!MASK_DROP_LIST],[LocFNameFull],[LocLnAct]
      EXIST_FILE [LocFNameFull],[LocRes]
      IF [LocRes]
        FILE_NAME  [LocFNamePure], [LocFNameFull]
        FILE_PATH  [LocFNamePath], [LocFNameFull]
        FILE_SLASH [LocFNamePath], TRUE

        CALL DmsXmlStartProcess
        CALL DmsXmlStartFile

        ; Die Datei in das DMS-Verzeichnis kopieren
        CALC [LocStr1] AS CON([DmsXmlPath],[LocFNamePure])
        FILE_COPY [LocRes], [LocFNameFull],[LocStr1]
        IF [LocRes]=FALSE
          CALC [LocStr1] AS CON('Die Datei "',[LocFNamePure],'" konnte nicht ins Archivierungsverzeichnis kopiert werden!'
          MESSAGE 'Achtung Abbruch',[LocStr1],[MESSAGE_ERROR]
          CALL DmsXmlAbortProcess
          EXIT_PROC
        END_IF
        ; Kein MD5 machen, gedroppte Dateien sollen IMMER an das DMS gesendet werden - egal ob sie schon dort sind oder nicht
        ; MD5 [DmsMD5], [MD5_FILE], [LocFNameFull]

        ; Archivieren der Quelldatei in das Quellverzeichnis\ARCHIV\ (wenn es das nicht gibt, dann wird es angelegt)
        CALC [LocStr1] AS CON([LocFNamePath],'archiv\')
        EXIST_DIR [LocStr1],[LocRes]
        IF [LocRes]=FALSE
          FORCE_DIR [LocRes],[LocStr1]
        END_IF
        IF [LocRes]
          CALC [LocStr1] AS CON([LocStr1],[LocFNamePure])
          FILE_COPY [LocRes], [LocFNameFull],[LocStr1]
          IF [LocRes]
            FILE_DELETE [LocRes], [LocFNameFull]
          END_IF
        END_IF

        LIST_APPEND [DmsXml], '<documentAttribute>'
        LIST_APPEND [DmsXml], '<attribute name="type" value="dmsfree" />'
        LIST_APPEND [DmsXml], '<attribute name="dmsidx" value="15" />'
        LIST_APPEND [DmsXml], '<attribute name="dmslevel" value="0" />'
        LIST_APPEND [DmsXml], '<attribute name="sourceSystem" value="ideal" />'

        CALC [DmsXmlStr] AS CON('FREE ',[[LocMaskName]!FieldLbl01],' = ',[[LocMaskName]!FieldVal01])
        CALL DmsXmlStrAdd '<attribute name="description" value="', [DmsXmlStr], '" />'

        ; ACHTUNG WICHTIG: Die [DmsUniqueID] muss unbedingt gesetzt werden, damit man den MD5-Vergeich der
        ;                  Datei machen kann und ggf. vermeidet, dass ein und dasselbe Dokument mehrfach
        ;                  im DMS abgelegt wird, obwohl es sich nicht verndert hat.
        CALC [DmsUniqueID] AS CON('dmsfree#',[[LocMaskName]!MASK_RECORD_ID|R0,0])
        CALL DmsXmlStrAdd '<attribute name="sourceIdentifier" value="', [DmsUniqueID], '" />'
        LIST_APPEND [DmsXml], '</documentAttribute>'


        LIST_APPEND [DmsXml], '<searchAttribute>'

        CALC [LocCount] AS 1
        WHILE [LocCount]<=5
          CALC [LocStr1]   AS [LocCount]
          CALC [LocStr1]   AS EXT([LocStr1],2,48,2,1)
          CALC [DmsXmlStr] AS [[LocMaskName]!FieldLbl[LocStr1]]
          IF [DmsXmlStr]<>''
            CALC [LocStr2] AS CON('<attribute name="FieldLabel',[LocStr1],'"      type="string" value="')
            CALL DmsXmlStrAdd [LocStr2], [DmsXmlStr], '" />'
          END_IF
          CALC [DmsXmlStr] AS [[LocMaskName]!FieldVal[LocStr1]]
          IF [DmsXmlStr]<>''
            CALC [LocStr2] AS CON('<attribute name="FieldValue',[LocStr1],'"      type="string" value="')
            CALL DmsXmlStrAdd [LocStr2], [DmsXmlStr], '" />'
          END_IF
          INC [LocCount]
        END_WHILE

        CALC [DmsXmlStr] AS [[LocMaskName]!CreateDate|R0,yyyy-mm-dd]
        CALL DmsXmlStrAdd '<attribute name="datum"             type="date"   value="', [DmsXmlStr], '" />'

        CALC [DmsXmlStr] AS [[LocMaskName]!CreateTime]
        CALL DmsXmlStrAdd '<attribute name="uhrzeit"           type="time"   value="', [DmsXmlStr], '" />'

        CALL LoadRelationFields  [ACT_MIT_ID], 'ADRESSEN',   'Name1|Name2', [DmsXmlStr], ''
        IF [DmsXmlStr]=''
          CALC [DmsXmlStr] AS [SHORT_NAME]
        END_IF
        CALC [DmsXmlStr] AS REPLACE([DmsXmlStr],'|',' ')
        CALC [DmsXmlStr] AS    TRIM([DmsXmlStr])
        CALL DmsXmlStrAdd '<attribute name="commitname" forceupdate="true"      type="string" value="', [DmsXmlStr], '" />'

        LIST_APPEND [DmsXml], '</searchAttribute>'


        LIST_APPEND [DmsXml], '<systemAttribute>'
        CALC [DmsXmlStr] AS CON([[LocMaskName]!MASK_RECORD_ID|R0,0])
        CALL DmsXmlStrAdd '<attribute name="backjump" value="dmsfree#', [DmsXmlStr], '" />'

        LIST_APPEND [DmsXml], '<attribute name="io" value="Datei" />'
        LIST_APPEND [DmsXml], '</systemAttribute>'

        LIST_APPEND [DmsXml], '</dms>'
        CALL DmsXmlSaveFile
        CALL DmsXmlStopProcess
      END_IF

      INC [LocLnAct]
    END_WHILE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  MASK_PROCESS [DmsFreeMask]
SCRIPT_END