

  INCLUDE Printout.inc


  PROCEDURE DmsXmlInit
    LOCAL_BOOL LocRes

    IDENTIFIER_EXIST 'DmsDropFile',[LocRes]
    IF [LocRes]=FALSE
      ; Die folgenden vier Variablen werden mittels der CFG-Datei gefllt. Scripte: ReadIdealParameter.inc, FParamet.csh und die Maske 1010.msk
      GLOBAL_BOOL DmsXmlActive,   FALSE
      GLOBAL_BOOL DmsRetryMode,   FALSE
      GLOBAL_STR  DmsServer,      ''
      GLOBAL_STR  DmsURL,         ''
      GLOBAL_STR  DmsPWD,         ''

      GLOBAL_STR  DmsMD5,         ''
      GLOBAL_STR  DmsUniqueID,    ''
      GLOBAL_STR  DmsXmlPath,     ''
      GLOBAL_LIST DmsXmlProtokoll

      GLOBAL_STR  DmsDropID,      ''
      GLOBAL_NUM  DmsDropGrp,     0
      GLOBAL_BOOL DmsDropRes,     FALSE
      GLOBAL_STR  DmsDropArt,     ''
      GLOBAL_STR  DmsDropFile,    ''

      LIST_CLR [DmsXmlProtokoll]
    END_IF

    IDENTIFIER_EXIST 'DmsXml',[LocRes]
    IF [LocRes]=FALSE
      VAR_LIST  DmsXml
      VAR_BOOL  DmsXmlRes
      VAR_STR   DmsXmlStr
      VAR_STR   DmsXmlQuote
      VAR_LIST  DmsXmlGroup
      VAR_NUM   DmsXmlGroupCnt
      VAR_STR   DmsXmlGroupDocID

      CALC [DmsXmlQuote] AS CHAR(#39)
    END_IF
  END_PROC



  PROCEDURE DmsXmlStartProcess
    ; Erstellt ein temporres Austauschverzeichnis fr EINEN DMS-Eintrag.
    ; HINWEIS: Dies wird nach der bertragung spter wieder entfernt.

    CALL DmsXmlInit

    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    LIST_CLR [DmsXmlProtokoll]

    IF [DmsRetryMode]=FALSE
      LOCAL_BOOL  LocRes
      LOCAL_FLOAT LocID

      ACT_REC_ID [LocID]
      CALC [DmsXmlPath] AS ''
      REC_ID_2_FILENAME [LocID], [DmsXmlPath]
      CALC [DmsXmlPath] AS CON([PRINTSET_PATH],'dms\',[DmsXmlPath],'_',[LocID|R0,0],'_',[STATION_SHORT])
      IF [USER_SID_SHORT]<>''
        CALC [DmsXmlPath] AS CON([DmsXmlPath],'_',[USER_SID_SHORT])
      END_IF

      CALC [DmsXmlPath] AS CON([DmsXmlPath],'\')
      FORCE_DIR [LocRes],[DmsXmlPath]
      IF [LocRes]=FALSE
        CALC [DmsXmlPath] AS CON('Der DMS-Dateipfad konnte nicht angelegt werden: ',[DmsXmlPath])
        LIST_APPEND [DmsXmlProtokoll], [DmsXmlPath]
        CALC [DmsXmlPath] AS ''
        EXIT_PROC
      END_IF
    END_IF

    CALC [DmsMD5]      AS ''
    CALC [DmsUniqueID] AS ''
  END_PROC



  PROCEDURE DmsXmlStartFile
    ; Die XML-Liste wird geleert und mit dem Startstring befllt.

    CALL DmsXmlInit

    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    LIST_CLR [DmsXml]
    LIST_APPEND [DmsXml], '<?xml version="1.0" encoding="UTF-8"?>'
    LIST_APPEND [DmsXml], '<dms>'

    CALC [DmsMD5]      AS ''
    CALC [DmsUniqueID] AS ''
  END_PROC



  PROCEDURE DmsXmlStrAdd VS DXSA.StartStr, VS DXSA.ValStr, VS DXSA.StopStr
    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'&',          '&amp;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'"',          '&quot;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'<',          '&lt;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'>',          '&gt;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],[DmsXmlQuote],'&apos;')
    CALC [DXSA.ValStr] AS  A2UTF8([DXSA.ValStr])

    CALC [DmsXmlStr]   AS CON([DXSA.StartStr],[DXSA.ValStr],[DXSA.StopStr])
    LIST_APPEND [DmsXml], [DmsXmlStr]
  END_PROC



  PROCEDURE DmsXmlSaveFile
    CALL DmsXmlInit

    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    IF [DmsXmlPath]=''
      EXIT_PROC
    END_IF

    LOCAL_NUM  LocLnAct, 1
    LOCAL_NUM  LocLnMax
    LOCAL_BOOL LocRes

    LIST_ITEM_GET [DmsXml],[LocLnAct],[LocLnMax]
    IF [LocLnMax]=0
      EXIT_PROC
    END_IF

    CALC [DmsXmlStr] AS CON([DmsXmlPath],'attribute.xml')

    LIST_FILE_WRITE [DmsXml],[LocRes],[DmsXmlStr]
  END_PROC



  PROCEDURE DmsXmlPrintPdf VS PrintVarName, VS PdfName
    CALL DmsXmlInit

    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    IF [DmsXmlPath]=''
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Der Druck wird ans DMS gesendet...'

    LOCAL_STR  LocStr
    LOCAL_LIST LocList
    LOCAL_NUM  LocLnAct
    LOCAL_NUM  LocLnMax

    IF [PdfName]=''
      CALC [PdfName] AS 'printout'
    END_IF

    CALC [DmsMD5] AS ''

    IF [VPE_VERSION]='2'
      CALC [LocStr] AS CON([PdfName],'.pdf')
      CALL PrintOut.eDocPrintProWaiter [PrintVarName], [DmsXmlPath], [LocStr], [DmsXmlRes]

      ; Unter VPE 2.x gab es nur das Dateiformat ".vpe" zum Speichern.
      ; Zum Glck wird da kein Zeitstempel oder etwas anderes Vernderliches
      ; mit reingedruckt - deswegen kann man die Datei zum MD5-Vergleich verwenden.
      CALC [LocStr] AS CON([DmsXmlPath],[PdfName],'.vpe')
      PRINT_SAVE [[PrintVarName]], [LocStr], [DmsXmlRes]

      EXIST_FILE [LocStr],[DmsXmlRes]
      IF [DmsXmlRes]
        MD5 [DmsMD5], [MD5_FILE], [LocStr]
        FILE_DELETE [DmsXmlRes], [LocStr]
      END_IF
    ELSE
      CALC [LocStr] AS CON([DmsXmlPath],[PdfName],'.pdf')
      PRINT_SAVE [[PrintVarName]], [LocStr], [DmsXmlRes]
      IF [DmsXmlRes]
        ; In der XML-Datei in der zweiten Zeile befinden sich als Bemerkung die Vernderlichen
        ; Werte, die VPE6 einbaut. Hier ist u.a. der Zeitstelmpel zu finden.
        ;
        ; Vorgehensweise:
        ; 1. Den Druck als MD5 speichern
        CALC [LocStr] AS CON([DmsXmlPath],[PdfName],'.xml')
        PRINT_SAVE [[PrintVarName]], [LocStr], [DmsXmlRes]
        IF [DmsXmlRes]
          ; 2. Die XML-Datei in eine Liste lesen
          LIST_CLR [LocList]
          LIST_FILE_READ [LocList],[DmsXmlRes],[LocStr]
          IF [DmsXmlRes]
            ; 2.a. Enthlt die XML-Datei mindestens zwei Zeilen?
            CALC [LocLnAct] AS 1
            LIST_ITEM_GET [LocList],[LocLnAct],[LocLnMax]
            CALC [LocLnAct] AS 1
            IF [LocLnMax]>=2
            ; 3. Die zweite Zeile aus der Liste lschen
              LIST_DELETE [LocList],2
              ; 4. Die Liste wieder als XML-Datei speichern
              LIST_FILE_WRITE [LocList],[DmsXmlRes],[LocStr]
              IF [DmsXmlRes]
                ; 5. Den MD5 ermitteln
                MD5 [DmsMD5], [MD5_FILE], [LocStr]
                ; 6. Die XML-Datei lschen
                FILE_DELETE [DmsXmlRes], [LocStr]
              END_IF
            END_IF
          END_IF
        END_IF
      END_IF

      IF [DmsXmlRes]=FALSE
        MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht gespeichert werden (VPE6)',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF

    END_WAIT
  END_PROC



  PROCEDURE DmsXmlProtokollAdd VS DXPA.S1, VS DXPA.S2, VS DXPA.S3
    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    IF [DXPA.S2]<>''
      CALC [DXPA.S1] AS CON([DXPA.S1],' ',[DXPA.S2])
    END_IF
    IF [DXPA.S3]<>''
      CALC [DXPA.S1] AS CON([DXPA.S1],' ',[DXPA.S3])
    END_IF
    CALC [DXPA.S1] AS TRIM([DXPA.S1])
    IF [DXPA.S1]<>''
      LIST_APPEND [DmsXmlProtokoll],[DXPA.S1]
    END_IF
  END_PROC



  PROCEDURE DmsXmlAbortProcess
    IF [DmsXmlActive]=FALSE
      EXIT_PROC
    END_IF

    IF [DmsXmlPath]<>''
      DELETE_DIR [DmsXmlRes], [DmsXmlPath]
      IF [DmsXmlRes]=FALSE
        CALC [DmsMD5] AS CON('Das DMS-Verzeichnis konnte nicht gelscht werden "',[DmsXmlPath],'"')
        LIST_APPEND [DmsXmlProtokoll], [DmsMD5]
        CALC [DmsXmlPath] AS CON([DmsXmlPath],'Protokoll.txt')
        LIST_FILE_WRITE [DmsXmlProtokoll],[DmsXmlRes],[DmsXmlPath]
      END_IF
      CALC [DmsXmlPath] AS ''
    END_IF

    CALC [DmsMD5]      AS ''
    CALC [DmsUniqueID] AS ''

    LIST_CLR [DmsXml]
    LIST_CLR [DmsXmlProtokoll]
  END_PROC



  PROCEDURE DmsXmlStopProcess
    LOCAL_BOOL  LocPushIt,  TRUE
    LOCAL_FLOAT LocID,      0
    LOCAL_QUERY LocQ
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocSICheck, 0
    LOCAL_NUM   LocLnAct
    LOCAL_NUM   LocLnMax

    IF [DmsXmlActive]
      IF [APPLICATION_NAME]>>'*test*'
        ; Hier nicht TRUE setzten, wenn das Test-System benutzt wird (auer whren der Testphase)
        CALC [LocPushIt] AS FALSE
      END_IF

      IF [DmsMD5]<>''
        IF [DmsUniqueID]<>''
          QUERY [LocQ]
            SELECT HashCode, RecordID
              FROM dmsmd5
             WHERE SourceIdentifier = "[DmsUniqueID]"
          END_QUERY
          EXECUTE [LocQ],[LocRes]
          IF [LocRes]
            GET_DATA [LocQ],[LocRes]
            IF [LocRes]
              CALC [LocID] AS [LocQ!RecordID]

              IF [LocQ!HashCode]=[DmsMD5]
                IF [DmsRetryMode]=FALSE
                  CALC [LocPushIt] AS FALSE
                END_IF
              END_IF
            END_IF
          END_IF
        END_IF
      END_IF

      IF [LocPushIt]
        ;   Fehlermeldungen = 1
        ;                     |
        ;                     |
        ;                     v
        SCRIPT 'DmsPush.csh', 0

        IF [DmsMD5]<>''
          IF [DmsUniqueID]<>''
            IF [LocID]<=[EPSILON]
              CALC [LocSICheck] AS 0

              BACK_MARK

              NEW_RECORD [LocRes],'dmsmd5',[LocID], TRUE, FALSE, FALSE
              IF [LocRes]=FALSE
                ; Es kann gelegentlich passieren, dass ein Source-Identifier leer ist.
                ; Da darauf ein unique Key liegt, wrde dann kein neuer Datensatz mehr
                ; angelegt werden knnen. Hier wird genau ein Mal "aufgerumt".
                IF [LocSICheck]=0
                  INC [LocSICheck]
                  QUERY [LocQ]
                    DELETE
                      FROM dmsmd5
                     WHERE RecordID         >  1000
                       AND SourceIdentifier = ""
                  END_QUERY
                  EXECUTE [LocQ],[LocRes]

                  BACK_JUMP
                END_IF
              END_IF

            ELSE
              CALC [LocRes] AS TRUE
            END_IF
            IF [LocRes]
              QUERY [LocQ]
                UPDATE dmsmd5
                   SET HashCode         = "[DmsMD5]",
                       SourceIdentifier = "[DmsUniqueID]"
                 WHERE RecordID         =  [LocID|R0,0]
              END_QUERY
              EXECUTE [LocQ],[LocRes]
            END_IF
          END_IF
        END_IF

        LIST_ITEM_GET [DmsXmlProtokoll],[LocLnAct],[LocLnMax]
        IF [LocLnMax]>0
          CALC [DmsXmlPath] AS CON([DmsXmlPath],'Protokoll.txt')
          LIST_FILE_WRITE [DmsXmlProtokoll],[LocRes],[DmsXmlPath]
        END_IF
      ELSE
        CALL DmsXmlAbortProcess
        EXIT_PROC
      END_IF
    END_IF

    ; Steht etwas im Protokoll? Gebe Fehler-Meldungen aus.

    CALC [DmsMD5]      AS ''
    CALC [DmsXmlPath]  AS ''
    CALC [DmsUniqueID] AS ''

    LIST_CLR [DmsXml]
    LIST_CLR [DmsXmlProtokoll]
  END_PROC



