
  INCLUDE Routines.inc
  INCLUDE DocMgrUtils.inc
  INCLUDE DmsRoutines.inc
  INCLUDE DmsGroupsIdeal.inc



  PROCEDURE InitVars
    CALL DocMgrUtilInitVars
    CALL DmsXmlInit

    VAR_BOOL  Res
    VAR_BOOL  HeaderDone

    VAR_QUERY Q1
    VAR_QUERY Q2
    VAR_QUERY Sub1
    VAR_QUERY Sub2
    VAR_QUERY Sub3

    VAR_NUM   Max1
    VAR_NUM   Cnt1

    VAR_NUM   Max2
    VAR_NUM   Cnt2

    VAR_NUM   LnMax
    VAR_NUM   LnAct

    VAR_NUM   YNRes

    VAR_STR   Inf
    VAR_STR   Str1

    VAR_BOOL  VirtDelBuf, [VIRTUAL_DELETE]

    VAR_LIST  DocDetail
    VAR_LIST  DateInfo
    VAR_LIST  Note
    VAR_STR   DocDesc
    VAR_STR   DocTable
    VAR_STR   DocType
    VAR_NUM   DocIdx
    VAR_STR   DocThema
  END_PROC



  PROCEDURE CancelRequest
    END_WAIT
    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die bergabe der Dokumentmanagerdaten an das DMS abbrechen?',[YNRes]
    IF [YNRes]<>[ID_YES]
      CALC [WAIT_BREAK] AS FALSE
    END_IF
  END_PROC


  PROCEDURE LocalDmsXmlStrAdd VS DXSA.StartStr, VS DXSA.ValStr, VS DXSA.StopStr
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'&',          '&amp;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'"',          '&quot;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'<',          '&lt;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],'>',          '&gt;')
    CALC [DXSA.ValStr] AS REPLACE([DXSA.ValStr],[DmsXmlQuote],'&apos;')
    CALC [DXSA.ValStr] AS  A2UTF8([DXSA.ValStr])

    CALC [DmsXmlStr]   AS CON([DXSA.StartStr],[DXSA.ValStr],[DXSA.StopStr])
    LIST_APPEND [DocDetail], [DmsXmlStr]
  END_PROC



  PROCEDURE DoGutschrift
    QUERY [Sub2]
      SELECT R.Rechnungsnummer, R.Datum, R.BelegNetto, R.BelegVerpackung, R.MwstJa,
             R.BelegFracht, R.BelegWarenwert, R.BelegMwSt, R.BelegBrutto, R.AuftragID,
             R.MwstWaren, R.KundenID, R.RecordID, R.ZahlBedID, R.GSID,
             K.Suchbegriff, K.Kundennummer, K.Debitornummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse,
             K.Laenderspezifikation, K.Kopien_KRG, K.Zusatz3, K.KLieferBedID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor,
             M.FreeInt1, M.RecordID, R.VertreterID, R.RechKundeID

        FROM rechnung R, adressen K, adressen M, waehrung W

       WHERE R.RecordID    = [Q1!RelRecID|R0,0]
         AND R.KundenID    = K.RecordID
         AND R.VertreterID = M.RecordID
         AND R.WaehrungID  = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    QUERY [Sub3]
      SELECT R.Rechnungsnummer, R.Datum,
             A.Auftragsnummer, A.Auftragsdatum, A.ProjekteID
        FROM rechnung R, auftrag A
       WHERE R.RecordID  = [Sub3!R.GSID|R0,0]
         AND R.AuftragID = A.RecordID
    END_QUERY
    EXECUTE [Sub3],[Res]
    IF [Res]
      GET_DATA [Sub3],[Res]
      IF [Res]
        CALL LoadRelationFields [Sub3!A.ProjekteID], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
        CALC [LocProjBez] AS PART([Str1], 2, '|')
        CALC [LocProjNr]  AS PART([Str1], 1, '|')
      END_IF
    END_IF

    CALC [DocDesc] AS CON('GS ',[Sub2!R.Rechnungsnummer],' vom ',[Sub2!R.Datum],'   Knd ',[Sub2!K.Kundennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="gutschriftsnummer"             type="string"  value="', [Sub2!R.Rechnungsnummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub2!K.Suchbegriff],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"                  type="string"  value="', [Sub2!K.Kundennummer],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub2!K.Name1],           '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub2!K.Name2],           '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub2!K.PLZ],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub2!K.Ort],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"                 type="string"  value="', [LocProjNr],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"                   type="string"  value="', [LocProjBez],             '" />'
    CALC [DmsXmlStr] AS [Sub2!R.Datum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],              '" />'
  END_PROC



  PROCEDURE DoRechnung
    QUERY [Sub2]
      SELECT R.Rechnungsnummer, R.Datum, R.BelegNetto, R.BelegVerpackung,
             R.BelegFracht, R.BelegWarenwert, R.BelegMwst, R.BelegBrutto, R.AuftragID,
             R.MwstWaren, R.KundenID, R.RecordID, R.ZahlBedID,
             A.Auftragsnummer, A.Sachbearbeiter, A.Auftragsdatum, A.Versandart,
             A.VerKundeID, A.MwstJA, A.Referenz, A.Bestellnummer, A.ProjekteID,
             A.Bestelldatum, A.ArtikelID, A.RechKundeID,
             K.Suchbegriff, K.Kundennummer, K.Debitornummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse,
             K.Laenderspezifikation, K.Kopien_KRG, K.Zusatz3, K.KLieferBedID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor,
             M.Name1, M.Name2, M.Personalnummer, M.FreeInt1, A.VertreterID
        FROM RECHNUNG R, AUFTRAG A, ADRESSEN K, ADRESSEN M, Waehrung W
       where R.RecordID    = [Q1!RelRecID|R0,0]
         and R.AuftragID   = A.RecordID
         and R.KundenID    = K.RecordID
         AND A.VertreterID = M.RecordID
         AND A.WaehrungID  = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [DocDesc] AS CON('RG ',[Sub2!R.Rechnungsnummer],' vom ',[Sub2!R.Datum],'   Knd ',[Sub2!K.Kundennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    CALL LoadRelationFields [Sub2!A.ProjekteID], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
    CALC [LocProjBez] AS PART([Str1], 2, '|')
    CALC [LocProjNr]  AS PART([Str1], 1, '|')

    CALL LocalDmsXmlStrAdd '<attribute name="rechnungsnummer"               type="string"  value="', [Sub2!R.Rechnungsnummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub2!K.Suchbegriff],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"                  type="string"  value="', [Sub2!K.Kundennummer],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub2!K.Name1],           '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub2!K.Name2],           '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub2!K.PLZ],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub2!K.Ort],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"                 type="string"  value="', [LocProjNr],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"                   type="string"  value="', [LocProjBez],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="auftragsnummer"                type="string"  value="', [Sub2!A.Auftragsnummer],  '" />'
    CALC [DmsXmlStr] AS [Sub2!R.Datum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],              '" />'
  END_PROC



  PROCEDURE DoBestellung
    QUERY [Sub2]
      SELECT B.Bestellnummer, B.Bestelldatum, B.RecordID, B.PartnerID,
             B.LieferantenID, B.Referenz, B.Sachbearbeiter,
             K.Lieferantennummer, B.FreeNum3,
             K.Suchbegriff, K.Kndnummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.Strasse, K.LLieferBedID,
             K.Laenderspezifikation, K.Kopien_LBS, K.Zusatz3, B.ZahlbedID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor
        FROM bestkopf B, adressen K, waehrung W
       WHERE B.RecordID      = [Q1!RelRecID|R0,0]
         AND B.LieferantenID = K.RecordID
         AND B.WaehrungID    = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    CALL LoadRelationFields [Sub2!B.FreeNum3], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
    CALC [LocProjBez] AS PART([Str1], 2, '|')
    CALC [LocProjNr]  AS PART([Str1], 1, '|')

    CALC [DocDesc] AS CON('BST ',[Sub2!B.Bestellnummer],' vom ',[Sub2!B.BestellDatum],'   Lief ',[Sub2!K.Lieferantennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub2!K.Suchbegriff],       '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="lieferantennummer"             type="string"  value="', [Sub2!K.Lieferantennummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub2!K.Name1],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub2!K.Name2],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub2!K.PLZ],               '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub2!K.Ort],               '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="bestellnummer"                 type="string"  value="', [Sub2!B.Bestellnummer],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"                 type="string"  value="', [LocProjNr],                '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"                   type="string"  value="', [LocProjBez],               '" />'
    CALC [DmsXmlStr] AS [Sub2!B.BestellDatum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],                '" />'
  END_PROC



  PROCEDURE DoAnfrage
    QUERY [Sub2]
      SELECT B.Bestellnummer, B.Bestelldatum, B.RecordID, B.PartnerID,
             B.LieferantenID, B.Referenz, B.Sachbearbeiter,
             K.Suchbegriff, K.Lieferantennummer, B.FreeNum3,
             K.Kndnummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.Strasse, K.LLieferBedID,
             K.Laenderspezifikation, K.Kopien_LBS, K.Zusatz3, B.ZahlbedID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor
        FROM bestkopf B, adressen K, waehrung W
       WHERE B.RecordID      = [Q1!RelRecID|R0,0]
         AND B.LieferantenID = K.RecordID
         AND B.WaehrungID    = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    CALL LoadRelationFields [Sub2!B.FreeNum3], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
    CALC [LocProjBez] AS PART([Str1], 2, '|')
    CALC [LocProjNr]  AS PART([Str1], 1, '|')

    CALC [DocDesc] AS CON('ANF ',[Sub2!B.Bestellnummer],' vom ',[Sub2!B.BestellDatum],'   Lief ',[Sub2!K.Lieferantennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub2!K.Suchbegriff],       '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="lieferantennummer"             type="string"  value="', [Sub2!K.Lieferantennummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub2!K.Name1],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub2!K.Name2],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub2!K.PLZ],               '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub2!K.Ort],               '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="bestellnummer"                 type="string"  value="', [Sub2!B.Bestellnummer],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"                 type="string"  value="', [LocProjNr],                '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"                   type="string"  value="', [LocProjBez],               '" />'
    CALC [DmsXmlStr] AS [Sub2!B.BestellDatum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],                '" />'
  END_PROC



  PROCEDURE DoAuftrag
    QUERY [Sub2]
      SELECT A.Auftragsnummer, A.Auftragsdatum, A.BelegNetto, A.WaehrungID,
             A.BelegMwst, A.BelegBrutto, A.RecordID,
             A.KundenID, A.ZahlBedID, A.Free1Str, A.LieferKW1,
             A.Sachbearbeiter, A.Versandart,
             A.VerKundeID, A.MwStJA, A.Referenz, A.Bestellnummer,
             A.Bestelldatum, A.RechKundeID, A.FreeNum1, A.ProjekteID,
             K.Suchbegriff, K.Kundennummer, K.Debitornummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse,
             K.Laenderspezifikation, K.Kopien_KAB, K.Zusatz3, A.LieferBedID,
             M.Name1, M.Name2, M.Personalnummer, M.FreeInt1, A.VertreterID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor
        FROM AUFTRAG A, ADRESSEN K, ADRESSEN M, Waehrung W
       WHERE A.RecordID    = [Q1!RelRecID|R0,0]
         AND A.KundenID    = K.RecordID
         AND A.VertreterID = M.RecordID
         AND A.WaehrungID  = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    CALL LoadRelationFields [Sub2!A.ProjekteID], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
    CALC [LocProjBez] AS PART([Str1], 2, '|')
    CALC [LocProjNr]  AS PART([Str1], 1, '|')

    CALC [DocDesc] AS CON('AB ',[Sub2!A.Auftragsnummer],' vom ',[Sub2!A.Auftragsdatum],'   Knd ',[Sub2!K.Kundennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub2!K.Suchbegriff],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"                  type="string"  value="', [Sub2!K.Kundennummer],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub2!K.Name1],           '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub2!K.Name2],           '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub2!K.PLZ],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub2!K.Ort],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="auftragsnummer"                type="string"  value="', [Sub2!A.Auftragsnummer],  '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"                 type="string"  value="', [LocProjNr],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"                   type="string"  value="', [LocProjBez],             '" />'
    CALC [DmsXmlStr] AS [Sub2!A.Auftragsdatum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],              '" />'
  END_PROC



  PROCEDURE DoAngebot
    QUERY [Sub2]
      select A.Angebotsnummer, A.Angebotsdatum, A.BelegNetto,  A.Fertbyte,
             A.BelegMwSt, A.BelegBrutto, A.RecordID, A.Free1Str, A.ProjekteID,
             A.KundenID, A.ZahlBedID, A.Free2Str, A.Free3Str,
             A.Sachbearbeiter, A.Versandart, A.Lieferdatum1,
             A.VerKundeID, A.MwstJA, A.Referenz, A.Bestellnummer,
             A.Bestelldatum, A.RechKundeID, A.PartnerID, A.FreeNum1,
             K.Suchbegriff, K.Kundennummer, K.Name1, K.Name2, K.Zusatz1, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse,
             K.Laenderspezifikation, K.Kopien_KAB, K.Zusatz3, A.LieferBedID,
             M.Name1, M.Name2, M.Personalnummer, M.FreeInt1, A.VertreterID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor
        from AUFTRAG A, ADRESSEN K, Adressen M, Waehrung W
       where A.RecordID    = [Q1!RelRecID|R0,0]
         and A.KundenID    = K.RecordID
         AND A.VertreterID = M.RecordID
         AND A.WaehrungID  = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    CALL LoadRelationFields [Sub2!A.ProjekteID], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
    CALC [LocProjBez] AS PART([Str1], 2, '|')
    CALC [LocProjNr]  AS PART([Str1], 1, '|')

    CALC [DocDesc] AS CON('ANG ',[Sub2!A.Angebotsnummer],' vom ',[Sub2!A.Angebotsdatum],'   Knd ',[Sub2!K.Kundennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub2!K.Suchbegriff],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"                  type="string"  value="', [Sub2!K.Kundennummer],   '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub2!K.Name1],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub2!K.Name2],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub2!K.PLZ],            '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub2!K.Ort],            '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="angebotsnummer"                type="string"  value="', [Sub2!A.Angebotsnummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"                 type="string"  value="', [LocProjNr],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"                   type="string"  value="', [LocProjBez],            '" />'
    CALC [DmsXmlStr] AS [Sub2!A.Angebotsdatum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],             '" />'
  END_PROC



  PROCEDURE DoKunden
    CALC [DocDesc] AS CON('ADR Kunden ',[Sub1!Kundennummer],', ',[Sub1!Name1],', ',[Sub1!Name2],', ',[Sub1!Strasse],', ',[Sub1!PLZ],', ',[Sub1!Ort])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub1!Suchbegriff],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"                  type="string"  value="', [Sub1!Kundennummer],   '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub1!Name1],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub1!Name2],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub1!PLZ],            '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub1!Ort],            '" />'

    CALC [DmsXmlStr] AS [Q2!CreateDate|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],           '" />'
  END_PROC



  PROCEDURE DoLieferanten
    CALC [DocDesc] AS CON('ADR Lieferanten ',[Sub1!Lieferantennummer],', ',[Sub1!Name1],', ',[Sub1!Name2],', ',[Sub1!Strasse],', ',[Sub1!PLZ],', ',[Sub1!Ort])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub1!Suchbegriff],       '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="lieferantennummer"             type="string"  value="', [Sub1!Lieferantennummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub1!Name1],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub1!Name2],             '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub1!PLZ],               '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub1!Ort],               '" />'

    CALC [DmsXmlStr] AS [Q2!CreateDate|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],              '" />'
  END_PROC



  PROCEDURE DoMitarbeiter
    CALC [DocDesc] AS CON('ADR Mitarbeiter ',[Sub1!Personalnummer],', ',[Sub1!Name1],', ',[Sub1!Name2],', ',[Sub1!Strasse],', ',[Sub1!PLZ],', ',[Sub1!Ort])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub1!Suchbegriff],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="Personalnummer"                type="string"  value="', [Sub1!Personalnummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub1!Name1],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub1!Name2],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub1!PLZ],            '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub1!Ort],            '" />'

    CALC [DmsXmlStr] AS [Q2!CreateDate|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],           '" />'
  END_PROC



  PROCEDURE DoInteressent
    CALC [DocDesc] AS CON('ADR Interessent ',[Sub1!Name1],', ',[Sub1!Name2],', ',[Sub1!Strasse],', ',[Sub1!PLZ],', ',[Sub1!Ort])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub1!Suchbegriff],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub1!Name1],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub1!Name2],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub1!PLZ],            '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub1!Ort],            '" />'

    CALC [DmsXmlStr] AS [Q2!CreateDate|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],           '" />'
  END_PROC



  PROCEDURE DoAdressen
    CALC [DocDesc] AS CON('ADR Allgemein ',[Sub1!Name1],', ',[Sub1!Name2],', ',[Sub1!Strasse],', ',[Sub1!PLZ],', ',[Sub1!Ort])

    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"                   type="string"  value="', [Sub1!Suchbegriff],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                         type="string"  value="', [Sub1!Name1],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                         type="string"  value="', [Sub1!Name2],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                           type="string"  value="', [Sub1!PLZ],            '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                           type="string"  value="', [Sub1!Ort],            '" />'

    CALC [DmsXmlStr] AS [Q2!CreateDate|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                         type="date"    value="', [DmsXmlStr],           '" />'
  END_PROC



  PROCEDURE DoArtikel
    QUERY [Sub2]
      SELECT A.Artikelnummer, A.Kurzbezeichnung,
             A.Bezeichnung1, A.Bezeichnung2,
             W.Gruppe, W.Bezeichnung
        FROM artikel A, warengrp W
       WHERE A.RecordID  = [Q1!RelRecID|R0,0]
         AND A.Aktiv     = 1
         AND A.WarenGrID = W.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [DocDesc] AS CON('ART ',[Sub2!A.Artikelnummer],', ',[Sub2!A.Kurzbezeichnung],', ',[Sub2!A.Bezeichnung1],', ',[Sub2!A.Bezeichnung2],', ',[Sub2!W.Gruppe],', ',[Sub2!W.Bezeichnung])

    CALL LocalDmsXmlStrAdd '<attribute name="artikelnummer"          type="string"  value="', [Sub2!A.Artikelnummer],   '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kurzbezeichnung"        type="string"  value="', [Sub2!A.Kurzbezeichnung], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="bezeichnung1"           type="string"  value="', [Sub2!A.Bezeichnung1],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="bezeichnung2"           type="string"  value="', [Sub2!A.Bezeichnung2],    '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="wgruppe"                type="string"  value="', [Sub2!W.Gruppe],          '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="wbezeichnung"           type="string"  value="', [Sub2!w.Bezeichnung],     '" />'

    CALC [DmsXmlStr] AS [Q2!CreateDate|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                  type="date"    value="', [DmsXmlStr],               '" />'
  END_PROC



  PROCEDURE DoLieferschein
    QUERY [Sub2]
      SELECT L.Lieferscheinnummer, L.Lieferdatum, L.AuftragID,
             A.KundenID, L.RecordID, A.ZahlBedID, A.eilt, A.ProjekteID,
             A.Auftragsnummer, A.Sachbearbeiter, A.Auftragsdatum, A.Versandart,
             A.VerKundeID, A.MwstJA, A.Referenz, A.Bestellnummer,
             A.Bestelldatum, A.ArtikelID, A.RechKundeID,
             K.Suchbegriff, K.Kundennummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort,
             K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse,
             K.Laenderspezifikation, K.Kopien_KLS, K.Zusatz3, K.KLieferBedID

        FROM liefersc L, auftrag A, adressen K

       WHERE L.RecordID  = [Q1!RelRecID|R0,0]
         AND L.AuftragID = A.RecordID
         AND A.KundenID  = K.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR LocProjNr
    LOCAL_STR LocProjBez
    CALL LoadRelationFields [Sub2!A.ProjekteID], 'projekte', 'ProjektNr|Bezeichnung1', [Str1], ''
    CALC [LocProjBez] AS PART([Str1], 2, '|')
    CALC [LocProjNr]  AS PART([Str1], 1, '|')

    CALC [DocDesc] AS CON('LS ',[Sub2!L.Lieferscheinnummer],' vom ',[Sub2!L.Lieferdatum],'   Knd ',[Sub2!K.Kundennummer],', ',[Sub2!K.Name1],', ',[Sub2!K.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="lieferscheinnummer"     type="string"  value="', [Sub2!L.Lieferscheinnummer], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"            type="string"  value="', [Sub2!K.Suchbegriff],        '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"           type="string"  value="', [Sub2!K.Kundennummer],       '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                  type="string"  value="', [Sub2!K.Name1],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                  type="string"  value="', [Sub2!K.Name2],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                    type="string"  value="', [Sub2!K.PLZ],                '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                    type="string"  value="', [Sub2!K.Ort],                '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="auftragsnummer"         type="string"  value="', [Sub2!A.Auftragsnummer],     '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"          type="string"  value="', [LocProjNr],                 '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="projektname"            type="string"  value="', [LocProjBez],                '" />'
    CALC [DmsXmlStr] AS [Sub2!L.Lieferdatum|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                  type="date"    value="', [DmsXmlStr],                 '" />'
  END_PROC



  PROCEDURE DoProjekte
    QUERY [Sub2]
      SELECT P.ProjektNr, P.Bezeichnung1, P.Beginn,
             A.Suchbegriff, A.Kundennummer, A.Name1, A.Name2, A.Plz, A.Ort
        FROM projekte P, adressen A
       WHERE P.RecordID = [Q1!RelRecID|R0,0]
         AND P.KundenID = A.RecordID
    END_QUERY

    EXECUTE [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Sub2],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [DocDesc] AS CON('PROJ ',[Sub2!P.ProjektNr],' vom ',[Sub2!P.Beginn],'  ',[Sub2!P.Bezeichnung1],'   Knd ',[Sub2!A.Kundennummer],', ',[Sub2!A.Name1],', ',[Sub2!A.Name2])

    CALL LocalDmsXmlStrAdd '<attribute name="projektnummer"          type="string"  value="', [Sub2!P.ProjektNr], '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="bezeichnung"            type="string"  value="', [Sub2!P.Bezeichnung1],       '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="suchbegriff"            type="string"  value="', [Sub2!A.Suchbegriff],        '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="kundennummer"           type="string"  value="', [Sub2!A.Kundennummer],       '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name1"                  type="string"  value="', [Sub2!A.Name1],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="name2"                  type="string"  value="', [Sub2!A.Name2],              '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="plz"                    type="string"  value="', [Sub2!A.PLZ],                '" />'
    CALL LocalDmsXmlStrAdd '<attribute name="ort"                    type="string"  value="', [Sub2!A.Ort],                '" />'
    CALC [DmsXmlStr] AS [Sub2!P.Beginn|R0,yyyy-mm-dd]
    CALL LocalDmsXmlStrAdd '<attribute name="datum"                  type="date"    value="', [DmsXmlStr],                 '" />'
  END_PROC



  PROCEDURE Main
    WAIT_INFO 'Bitte warten...','Die Dokumentenordner werden ausgewertet...'

    CALC [VIRTUAL_DELETE] AS FALSE
    QUERY [Q1]
        SELECT *
          FROM docmgrh
         WHERE RecordID     > 1000
           AND VirtualDelID = 0
      ORDER BY RecordID DESC
;        LIMIT 0, 100
    END_QUERY

    EXECUTE [Q1],[Res]
    CALC [VIRTUAL_DELETE] AS [VirtDelBuf]
    IF [Res]=FALSE
      END_WAIT
      MESSAGE 'Achtung Fehler','Die Abfrage zum Laden aller Dokummentenordner konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es sind keine Dokummentenordner vorhanden',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q1],[Max1]
    CALC [Cnt1] AS 0

    END_WAIT

    CALC [YNRes] AS [ID_NO]
    CALC [Inf]   AS CON('Mchten Sie nun alle ',[Max1],' Dokummentenordner in das DMS-System bernehmen?')
    GET_YES_NO 'Achtung! Sind Sie sicher?!',[Inf],[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    CALC [WAIT_BREAK] AS FALSE

    WHILE [Res]
      IF [WAIT_BREAK]
        CALL CancelRequest
      END_IF
      IF [WAIT_BREAK]
        EXIT_PROC
      END_IF

      INC  [Cnt1]
      CALC [Inf] AS CON('O ',[Cnt1],' / ',[Max1])
      WAIT_INFO 'Bitte warten...', [Inf], TRUE

      CALC [HeaderDone] AS FALSE

      QUERY [Q2]
        SELECT * FROM docmgri WHERE HeaderID = [Q1!RecordID|R0,0]
      END_QUERY
      EXECUTE [Q2],[Res]
      IF [Res]
        GET_DATA [Q2],[Res]
        IF [Res]
          QUERY_COUNT [Q2],[Max2]
          CALC [Cnt2] AS 0

          WHILE [Res]
            IF [WAIT_BREAK]
              CALL CancelRequest
            END_IF
            IF [WAIT_BREAK]
              EXIT_PROC
            END_IF

            INC  [Cnt2]
            CALC [Inf] AS CON('O ',[Cnt1],' / ',[Max1],'   -   E ',[Cnt2],' / ',[Max2])
            WAIT_INFO 'Bitte warten...', [Inf], TRUE

            CALC [DocType] AS 'skip'
            CALC [DocTable] AS LOWCASE([Q1!TableName])
            ; Hier mssen die mehrdeutigen Tabellen abgeklopft werden: um was genau handelt es sich?
            QUERY [Sub1]
              SELECT * FROM [DocTable] WHERE RecordID = [Q1!RelRecID|R0,0]
            END_QUERY
            EXECUTE [Sub1],[Res]
            IF [Res]
              GET_DATA [Sub1],[Res]
              IF [Res]
                LIST_CLR [DocDetail]
                CALC [DocDesc] AS ''
                CALC [DocType] AS 'docmanageritem'
                CALC [DocIdx]  AS 16

                IF [DocTable]='adressen'
                  IF [Sub1!KAktiv]>0
                    CALC [DocType] AS 'kunden'
                    CALC [DocIdx]  AS 12
                    CALL DoKunden
                  ELSE_IF [Sub1!LAktiv]>0
                    CALC [DocType] AS 'lieferanten'
                    CALC [DocIdx]  AS 13
                    CALL DoLieferanten
                  ELSE_IF [Sub1!MAktiv]>0
                    CALC [DocType] AS 'mitarbeiter'
                    CALC [DocIdx]  AS 11
                    CALL DoMitarbeiter
                  ELSE_IF [Sub1!Interessent]
                    CALC [DocType] AS 'interessent'
                    CALC [DocIdx]  AS 14
                    CALL DoInteressent
                  ELSE
                    CALC [DocType] AS 'adressenallgemein'
                    CALC [DocIdx]  AS 15
                    CALL DoAdressen
                  END_IF

                ELSE_IF [DocTable]='artikel'
                    CALC [DocType] AS 'artikel'
                    CALC [DocIdx]  AS 10
                    CALL DoArtikel

                ELSE_IF [DocTable]='auftrag'
                  IF [Sub1!FertByte]=-4
                    CALC [DocType] AS 'arbeitsnachweis'
                    CALC [DocIdx]  AS 1
                    CALL DoAuftrag
                  ELSE_IF [Sub1!FertByte]=-3
                    CALC [DocType] AS 'reparatur'
                    CALC [DocIdx]  AS 1
                    CALL DoAuftrag
                  ELSE_IF [Sub1!FertByte]=-2
                    CALC [DocType] AS 'internerbeleg'
                    CALC [DocIdx]  AS 1
                    CALL DoAuftrag
                  ELSE_IF [Sub1!FertByte]=-1
                    CALC [DocType] AS 'angebot'
                    CALC [DocIdx]  AS 2
                    CALL DoAngebot
                    CALL DmsXmlGroup 'auftrag', 'angebot', [Q1!RelRecID], FALSE
                  ELSE_IF [Sub1!FertByte]=1
                    CALC [DocType] AS 'fertigungsauftrag'
                    CALC [DocIdx]  AS 1
                    CALL DoAuftrag
                  ELSE
                    CALC [DocType] AS 'aufrag'
                    CALC [DocIdx]  AS 1
                    CALL DoAuftrag
                    CALL DmsXmlGroup 'auftrag', 'auftrag', [Q1!RelRecID], FALSE
                  END_IF

                ELSE_IF [DocTable]='bestkopf'
                  IF [Sub1!FreeInt1]=1
                    ; Rahmenbestellung
                    CALC [DocType] AS 'bestellung'
                    CALC [DocIdx]  AS 7
                    CALL DoBestellung
                    CALL DmsXmlGroup 'bestkopf', 'bestellung', [Q1!RelRecID], FALSE
                  ELSE_IF [Sub1!FreeInt1]=2
                    CALC [DocType] AS 'anfrage'
                    CALC [DocIdx]  AS 6
                    CALL DoAnfrage
                    CALL DmsXmlGroup 'bestkopf', 'anfrage', [Q1!RelRecID], FALSE
                  ELSE
                    CALC [DocType] AS 'bestellung'
                    CALC [DocIdx]  AS 7
                    CALL DoBestellung
                    CALL DmsXmlGroup 'bestkopf', 'bestellung', [Q1!RelRecID], FALSE
                  END_IF

                ELSE_IF [DocTable]='liefersc'
                  CALC [DocType] AS 'lieferschein'
                  CALC [DocIdx]  AS 3
                  CALL DoLieferschein
                  CALL DmsXmlGroup 'liefersc', 'lieferschein', [Q1!RelRecID], FALSE

                ELSE_IF [DocTable]='projekte'
                  CALC [DocType] AS 'projekte'
                  CALC [DocIdx]  AS 9
                  CALL DoProjekte

                ELSE_IF [DocTable]='rechnung'
                  IF [Sub1!Kennung]='G'
                    CALC [DocType] AS 'gutschrift'
                    CALC [DocIdx]  AS 5
                    CALL DoGutschrift
                    CALL DmsXmlGroup 'rechnung', 'gutschrift', [Q1!RelRecID], FALSE
                  ELSE
                    CALC [DocType] AS 'rechnung'
                    CALC [DocIdx]  AS 4
                    CALL DoRechnung
                    CALL DmsXmlGroup 'rechnung', 'rechnung', [Q1!RelRecID], FALSE
                  END_IF
                END_IF

                IF [DocType]<>'skip'
                  IF [DocDesc]<>''
                    CALC [HeaderDone] AS TRUE
                    IF [HeaderDone]=FALSE

                      CALL DmsXmlStartProcess
                      CALL DmsXmlStartFile

                      LIST_APPEND [DmsXml], '<documentAttribute>'
                      LIST_APPEND [DmsXml], '<attribute name="skipduplicate"                               value="true" />'

                      CALC [DmsXmlStr] AS CON('<attribute name="type"                                        value="docmanagergroup" />')
                      LIST_APPEND [DmsXml], [DmsXmlStr]

                      CALC [DmsXmlStr] AS CON('<attribute name="dmsidx"                                      value="',[DocIdx],'" />')
                      LIST_APPEND [DmsXml], [DmsXmlStr]

                      LIST_APPEND [DmsXml], '<attribute name="dmslevel"                                    value="0" />'
                      LIST_APPEND [DmsXml], '<attribute name="sourceSystem"                                value="awagio" />'

                      CALL DmsXmlStrAdd '<attribute name="description"                                 value="', [DocDesc], '" />'

;                     CALC [DmsUniqueID] AS CON('docmgrh#',[Q1!RecordID|R0,0],'#folder')
                      CALC [DmsUniqueID] AS CON('docmgrh#',[Q1!RecordID|R0,0])

                      CALL DmsXmlStrAdd     '<attribute name="sourceIdentifier"                            value="', [DmsUniqueID], '" />'
                      LIST_APPEND [DmsXml], '</documentAttribute>'
                      LIST_APPEND [DmsXml], '<searchAttribute>'

                      CALL DmsXmlStrAdd '<attribute name="description"                                 value="', [DocDesc], '" />'

                      CALL LoadRelationFields  [Q2!CreatorID], 'ADRESSEN',   'Name1|Name2', [DmsXmlStr], ''
                      IF [DmsXmlStr]=''
                        CALC [DmsXmlStr] AS [SHORT_NAME]
                      END_IF
                      CALC [DmsXmlStr] AS REPLACE([DmsXmlStr],'|',' ')
                      CALC [DmsXmlStr] AS    TRIM([DmsXmlStr])
                      CALL DmsXmlStrAdd '<attribute name="commitname" forceupdate="true" type="string" value="', [DmsXmlStr], '" />'

                      LIST_APPEND [DmsXml], '</searchAttribute>'

                      LIST_APPEND [DmsXml], '<systemAttribute>'
                      LIST_APPEND [DmsXml], '<attribute name="io"                                          value="DocMgrH" />'

                      CALC [DmsXmlStr] AS CON( '<attribute name="idGroup"                                     value="docmgrh#',[Q1!RecordID|R0,0],'" targettable="docmanagergroup" />')
                      LIST_APPEND [DmsXml], [DmsXmlStr]

                      CALC [DmsXmlStr] AS CON( '<attribute name="backjump"                                    value="docmgrh#',[Q1!RecordID|R0,0],'" />')
                      LIST_APPEND [DmsXml], [DmsXmlStr]

                      LIST_APPEND [DmsXml], '</systemAttribute>'
                      LIST_APPEND [DmsXml], '</dms>'

                      CALL DmsXmlSaveFile
                      CALL DmsXmlStopProcess

                      CALC [HeaderDone] AS TRUE
                    END_IF


                    CALL DmsXmlStartProcess
                    CALL DmsXmlStartFile

                    LIST_APPEND [DmsXml], '<documentAttribute>'
                    LIST_APPEND [DmsXml], '<attribute name="skipduplicate"                                value="true" />'
                    LIST_APPEND [DmsXml], '<attribute name="type"                                         value="docmanageritem" />'

                    CALC [DmsXmlStr] AS CON('<attribute name="dmsidx"                                       value="',[DocIdx],'" />')
                    LIST_APPEND [DmsXml], [DmsXmlStr]

                    LIST_APPEND [DmsXml], '<attribute name="dmslevel"                                     value="0" />'
                    LIST_APPEND [DmsXml], '<attribute name="sourceSystem"                                 value="awagio" />'

                    CALL DmsXmlStrAdd '<attribute name="description"                                  value="', [Q2!ItemNote], '" />'

                    ; ACHTUNG WICHTIG: Die [DmsUniqueID] muss unbedingt gesetzt werden, damit man den MD5-Vergeich der
                    ;                  Datei machen kann und ggf. vermeidet, dass ein und dasselbe Dokument mehrfach
                    ;                  im DMS abgelegt wird, obwohl es sich nicht verndert hat.
                    CALC [DmsUniqueID] AS CON('docmgri#',[Q2!RecordID|R0,0])
                    CALL DmsXmlStrAdd '<attribute name="sourceIdentifier"                             value="', [DmsUniqueID], '" />'
                    LIST_APPEND [DmsXml], '</documentAttribute>'
                    LIST_APPEND [DmsXml], '<searchAttribute>'
                    CALL DmsXmlStrAdd '<attribute name="description"                   type="string"  value="', [Q2!ItemNote], '" />'

                    CALC [DocThema] AS ''
                    IF [Q2!CategoryID]>[EPSILON]
                      CALC [Str1] AS [Q2!CategoryID|R0,0]
                      QUERY [Sub2]
                        SELECT Ziffer, Bezeichnung
                          FROM docmgrca
                         WHERE RecordID = [Q2!CategoryID|R0,0]
                      END_QUERY
                      EXECUTE [Sub2],[Res]
                      IF [Res]
                        GET_DATA [Sub2],[Res]
                        IF [Res]
                          CALC [DocThema] AS CON([Sub2!Ziffer], '.', [Sub2!Bezeichnung])
                          CALL DmsXmlStrAdd '<attribute name="thema"                      type="string"  value="', [DocThema], '" />'
                        END_IF
                      END_IF
                    END_IF
                    CALL DmsXmlStrAdd '<attribute name="gespraechsfaden"               type="string"  value="', [Q2!ThreadName], '" />'

                    CALL DocMgrFixPath [Q2!FilePath], FALSE, [Str1]
                    IF [Str1]<>''
                      EXIST_FILE [Str1],[Res]
                      IF [Res]
                        FILE_NAME [DmsXmlStr],[Str1]
                        CALC [DmsXmlStr] AS CON([DmsXmlPath],[DmsXmlStr])
                        FILE_COPY [Res], [Str1], [DmsXmlStr]
                        IF [Res]
                          FILE_NAME [DmsXmlStr],[Str1]
                          CALL DmsXmlStrAdd '<attribute name="file2archive"                  type="string"  value="', [DmsXmlStr], '" />'
                        END_IF
                      ELSE
                        ;******************************
                        ;******************************
                        ; Kleine Datei als Dummy bauen
                        LIST_CLR [DateInfo]
                        CALC [Str1] AS CON('Dokument konnte nicht gefunden werden: ',[Str1])
                        CALC [Str1] AS A2UTF8([Str1])
                        LIST_APPEND [DateInfo], [Str1]
                        CALC [Str1] AS CON([DmsXmlPath],'dummy.txt')
                        LIST_FILE_WRITE [DateInfo],[Res],[Str1]
                        ;******************************
                        ;******************************
                      END_IF
                    ELSE
                      ;******************************
                      ;******************************
                      ; Kleine Datei als Dummy bauen
                      LIST_CLR [DateInfo]
                      CALC [Str1] AS [Q2!ItemNote]
                      CALC [Str1] AS A2UTF8([Str1])
                      LIST_APPEND [DateInfo], [Str1]
                      CALC [Str1] AS CON([DmsXmlPath],'note.txt')
                      LIST_FILE_WRITE [DateInfo],[Res],[Str1]
                      ;******************************
                      ;******************************
                    END_IF

                    LIST_2_LIST [DocDetail], [DmsXml], FALSE, 1

                    CALL LoadRelationFields  [Q2!CreatorID], 'ADRESSEN',   'Name1|Name2', [DmsXmlStr], ''
                    IF [DmsXmlStr]=''
                      CALC [DmsXmlStr] AS [SHORT_NAME]
                    END_IF
                    CALC [DmsXmlStr] AS REPLACE([DmsXmlStr],'|',' ')
                    CALC [DmsXmlStr] AS    TRIM([DmsXmlStr])
                    CALL DmsXmlStrAdd '<attribute name="commitname" forceupdate="true" type="string"  value="', [DmsXmlStr], '" />'
                    LIST_APPEND [DmsXml], '</searchAttribute>'


                    LIST_APPEND [DmsXml], '<systemAttribute>'

                    IF [Q2!CreatorID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'Str1', 'Q2!CreatorID',       [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="sourceinfo"                    type="string"  value="', [Str1], '"   typetable="true" />'
                        CALC [Str1] AS [Q2!CreatorID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="sourceid"                      type="float"   value="', [Str1], '"   typetable="true" />'
                        CALC [Str1] AS [Q2!CreateDate|R0,yyyy-mm-dd]
                        CALL DmsXmlStrAdd '<attribute name="sourcestartdate"               type="date"    value="', [Str1], '"   typetable="true" />'
                        CALC [Str1] AS [Q2!CreateTime]
                        CALL DmsXmlStrAdd '<attribute name="sourcestarttime"               type="time"    value="', [Str1], '"   typetable="true" />'

;                       CALC [Str1] AS [Q2!CreateRunDate|R0,yyyy-mm-dd]
;                       CALL DmsXmlStrAdd '<attribute name="sourceenddate"                 type="date"    value="', [Str1], '"   typetable="true" />'
;
;                       CALC [Str1] AS [Q2!CreateRunTime]
;                       CALL DmsXmlStrAdd '<attribute name="sourceendtime"                 type="time"    value="', [Str1], '"   typetable="true" />'

                        CALL DmsXmlStrAdd '<attribute name="sourcetype"                    type="string"  value="', [Q2!CreateType], '"   typetable="true" />'
                      END_IF
                    END_IF

                    IF [Q2!NextProcessDate]>[DEFAULT_DATE]
                      ;******************************
                      ;******************************
                      ; Kleine Datei zum Termin bauen
                      LIST_CLR [DateInfo]
                      CALC [Str1] AS CON('Termin: ',[Q2!ItemNote])
                      CALC [Str1] AS A2UTF8([Str1])
                      LIST_APPEND [DateInfo], [Str1]
                      LIST_APPEND [DateInfo], ''
                      CALC [Str1] AS ''
                      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'Str1', 'Q2!CreatorID',       [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      CALC [Str1] AS CON('vom  ',[Q2!CreateDate],' um ',[Q2!CreateTime],'h, von ',[Str1])
                      CALC [Str1] AS A2UTF8([Str1])
                      LIST_APPEND [DateInfo], [Str1]
                      LIST_APPEND [DateInfo], ''
                      CALC [Str1] AS ''
                      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'Str1', 'Q2!NextProcessorID', [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      CALC [Str1] AS CON('am   ',[Q2!NextProcessDate],' um ',[Q2!NextProcessTime],'h, fr ',[Str1])
                      CALC [Str1] AS A2UTF8([Str1])
                      LIST_APPEND [DateInfo], [Str1]
                      LIST_APPEND [DateInfo], ''
                      CALC [Str1] AS ''
                      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'Str1', 'Q2!FinisherID', [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      CALC [Str1] AS CON('erl. ',[Q2!FinishDate],' um ',[Q2!FinishTime],'h, fr ',[Str1])
                      CALC [Str1] AS A2UTF8([Str1])
                      LIST_APPEND [DateInfo], [Str1]
                      LIST_APPEND [DateInfo], ''
                      LIST_CLR  [Note]
                      NOTE_READ [Note],[Res],'docmgri',1,[Q2!RecordID]
                      LIST_ITEM_GET [Note],[LnAct],[LnMax]
                      IF [LnMax]>0
                        LIST_APPEND [DateInfo], 'Information:'
                        CALC [LnAct] AS 1
                        WHILE [LnAct]<=[LnMax]
                          LIST_STR_GET [Note],[Str1],[LnAct]
                          CALC [Str1] AS A2UTF8([Str1])
                          LIST_APPEND [DateInfo], [Str1]
                          INC [LnAct]
                        END_WHILE
                      END_IF
                      CALC [Str1] AS CON([DmsXmlPath],'termin.txt')
                      LIST_FILE_WRITE [DateInfo],[Res],[Str1]
                      ;******************************
                      ;******************************

                      LIST_APPEND [DmsXml], '<attribute name="bvIsTermin"                    type="boolean" value="1"    typetable="true" />'

                      IF [Q2!FinishDate]>[DEFAULT_DATE]
                        LIST_APPEND [DmsXml], '<attribute name="done"                          type="boolean" value="1"   typetable="true" />'
                      ELSE
                        LIST_APPEND [DmsXml], '<attribute name="done"                          type="boolean" value="0"   typetable="true" />'
                      END_IF

                      IF [Q2!NextProcessorID]>[EPSILON]
                        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'Str1', 'Q2!NextProcessorID', [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                        IF [Str1]<>''
                          CALL DmsXmlStrAdd '<attribute name="targetinfo"                    type="string"  value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!NextProcessorID|R0,0]
                          CALL DmsXmlStrAdd '<attribute name="targetid"                      type="float"   value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!NextProcessDate|R0,yyyy-mm-dd]
                          CALL DmsXmlStrAdd '<attribute name="dtstart"                       type="date"    value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!NextProcessTime]
                          CALL DmsXmlStrAdd '<attribute name="tsstart"                       type="time"    value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!NextProcessRunDate|R0,yyyy-mm-dd]
                          CALL DmsXmlStrAdd '<attribute name="dtend"                         type="date"    value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!NextProcessRunTime]
                          CALL DmsXmlStrAdd '<attribute name="tsend"                         type="time"    value="', [Str1], '"   typetable="true" />'

                          CALL DmsXmlStrAdd '<attribute name="targettype"                    type="string"  value="', [Q2!NextProcessType], '"   typetable="true" />'
                        END_IF
                      END_IF

                      IF [Q2!FinisherID]>[EPSILON]
                        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'Str1', 'Q2!FinisherID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                        IF [Str1]<>''
                          CALL DmsXmlStrAdd '<attribute name="doneinfo"                      type="string"  value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!FinisherID|R0,0]
                          CALL DmsXmlStrAdd '<attribute name="doneid"                        type="float"   value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!FinishDate|R0,yyyy-mm-dd]
                          CALL DmsXmlStrAdd '<attribute name="donestartdate"                 type="date"    value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!FinishTime]
                          CALL DmsXmlStrAdd '<attribute name="donestarttime"                 type="time"    value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!FinishRunDate|R0,yyyy-mm-dd]
                          CALL DmsXmlStrAdd '<attribute name="doneenddate"                   type="date"    value="', [Str1], '"   typetable="true" />'

                          CALC [Str1] AS [Q2!FinishRunTime]
                          CALL DmsXmlStrAdd '<attribute name="doneendtime"                   type="time"    value="', [Str1], '"   typetable="true" />'

                          CALL DmsXmlStrAdd '<attribute name="donetype"                      type="string"  value="', [Q2!FinishType], '"   typetable="true" />'
                        END_IF
                      END_IF
                    END_IF

                    IF [Q2!XRef01ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef01Name], '', 'Str1', 'Q2!XRef01ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref1info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef01ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref1id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref1name"                     type="string"  value="', [Q2!XRef01Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef02ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef02Name], '', 'Str1', 'Q2!XRef02ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref2info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef02ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref2id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref2name"                     type="string"  value="', [Q2!XRef02Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef03ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef03Name], '', 'Str1', 'Q2!XRef03ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref3info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef03ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref3id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref3name"                     type="string"  value="', [Q2!XRef03Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef04ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef04Name], '', 'Str1', 'Q2!XRef04ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref4info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef04ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref4id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref4name"                     type="string"  value="', [Q2!XRef04Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef05ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef05Name], '', 'Str1', 'Q2!XRef05ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref5info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef05ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref5id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref5name"                     type="string"  value="', [Q2!XRef05Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef06ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef06Name], '', 'Str1', 'Q2!XRef06ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref6info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef06ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref6id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref6name"                     type="string"  value="', [Q2!XRef06Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef07ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef07Name], '', 'Str1', 'Q2!XRef07ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref7info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef07ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref7id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref7name"                     type="string"  value="', [Q2!XRef07Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef08ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef08Name], '', 'Str1', 'Q2!XRef08ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref8info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef08ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref8id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref8name"                     type="string"  value="', [Q2!XRef08Name], '" />'
                      END_IF
                    END_IF
                    IF [Q2!XRef09ID]>[EPSILON]
                      CALL DocMgrUtilLoadRelationByTableFld [Q2!XRef09Name], '', 'Str1', 'Q2!XRef09ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
                      IF [Str1]<>''
                        CALL DmsXmlStrAdd '<attribute name="xref9info"                     type="string"  value="', [Str1], '" />'
                        CALC [Str1] AS [Q2!XRef09ID|R0,0]
                        CALL DmsXmlStrAdd '<attribute name="xref9id"                       type="float"   value="', [Str1], '"   typetable="true" />'
                        CALL DmsXmlStrAdd '<attribute name="xref9name"                     type="string"  value="', [Q2!XRef09Name], '" />'
                      END_IF
                    END_IF

                    CALC [DmsXmlStr] AS CON( '<attribute name="backjump"                                     value="docmgri#',[Q2!RecordID|R0,0],'" />')
                    LIST_APPEND [DmsXml], [DmsXmlStr]

                    LIST_APPEND [DmsXml], '<attribute name="io"                                           value="DocMgrI" />'

                    IF [Q2!NextProcessDate]>[DEFAULT_DATE]
                      CALC [Str1] AS [Q2!CreatorID|R0,0]
                      CALL DmsXmlStrAdd '<attribute name="sourceid"                      type="float"   value="', [Str1], '"   typetable="true" />'

                      CALC [Str1] AS [Q2!NextProcessorID|R0,0]
                      CALL DmsXmlStrAdd '<attribute name="targetid"                      type="float"   value="', [Str1], '"   typetable="true" />'

                      CALC [Str1] AS [Q2!FinisherID|R0,0]
                      CALL DmsXmlStrAdd '<attribute name="doneid"                        type="float"   value="', [Str1], '"   typetable="true" />'
                    END_IF

                    LIST_APPEND [DmsXml], '</systemAttribute>'

                    LIST_APPEND [DmsXml], '<groupconnect>'

                    IF [DocThema]=''
                      CALC [DocThema] AS [Q1!FileName]
                    END_IF
;                   CALC [DmsXmlStr] AS CON( '<attribute name="con0" value="',[DocThema],'" groupid="docmgrh#',[Q1!RecordID|R0,0],'#folder"            targetid="',[DmsUniqueID],'" description="')
;                   CALC [DmsXmlStr] AS CON( '<attribute name="con0" value="',[DocThema],'" groupid="docmgrh#',[Q1!RecordID|R0,0],'"                   targetid="',[DmsUniqueID],'" description="')
                    CALC [DmsXmlStr] AS CON( '<attribute name="con0" value="',[DocThema],'" groupid="',[Q1!TableName],'#',[Q1!RelRecID|R0,0],'#folder" targetid="',[DmsUniqueID],'" description="')
                    CALL DmsXmlStrAdd [DmsXmlStr], [Q2!ItemNote], '" doctype="docmgr"/>'

                    LIST_ITEM_GET [DmsXmlGroup],[LnAct],[LnMax]
                    IF [LnMax]>0
                      LIST_2_LIST [DmsXmlGroup], [DmsXml], FALSE, 1
                    END_IF
                    LIST_APPEND [DmsXml], '</groupconnect>'

                    LIST_APPEND [DmsXml], '</dms>'

                    CALL DmsXmlSaveFile
                    CALL DmsXmlStopProcess
                  END_IF
                END_IF
              END_IF
            END_IF

            GET_DATA [Q2],[Res]
          END_WHILE
        END_IF
      END_IF

      GET_DATA [Q1],[Res]
    END_WHILE

    END_WAIT
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
