  ; dd 18.08.2006
  ;
  ;
  ; Die "Kill"-Routinen lschen Relationen eines Datensatzes. Sie "kmmern" sich nicht um die RecFlag.
  ; Es wird davon ausgegangen, dass danach der Datensatz selbst gelscht wird. Man "braucht" eigentlich
  ; nur die Routine "KillRelations".
  ;
  ; PROC KillNotes      VS KN.TableName, VF KN.RelRecID             >  Lsche die Notizen                       des Datensatzes [KN.RelRecID] aus der Tabelle [KN.TableName]
  ; PROC KillDocs       VS KD.TableName, VF KD.RelRecID             >  Lsche die Dokumenten-Ordner             des Datensatzes [KD.RelRecID] aus der Tabelle [KD.TableName]
  ; PROC KillRelations  VS KR.TableName, VF KR.RelRecID             >  Lsche die Notizen und Dokumenten-Ordner des Datensatzes [KR.RelRecID] aus der Tabelle [KR.TableName]
  ;
  ;
  ;
  ; PROC SetRecFlag     VS SR.TableName, VF SR.RelRecID             >  Setzt bzw. repariert die RecFlag         des Datensatzes [SR.RelRecID] aus der Tabelle [SR.TableName]
  ;
  ;
  ;
  ; Die "Erase"-Routinen lschen Relationen eines Datensatzes. Sie "kmmern" sich auch um die RecFlag.
  ; Es wird davon ausgegangen, dass danach der Datensatz noch bentigt wird. Es werden immer alle
  ; betroffenen Relationen gelscht.
  ;
  ; PROC EraseNotes     VS EN.TableName, VF EN.RelRecID             >  Lsche die Notizen                       des Datensatzes [EN.RelRecID] aus der Tabelle [EN.TableName] und setzte die RecFlag
  ; PROC EraseDocs      VS ED.TableName, VF ED.RelRecID             >  Lsche die Dokumenten-Ordner             des Datensatzes [ED.RelRecID] aus der Tabelle [ED.TableName] und setzte die RecFlag
  ; PROC EraseRelations VS ER.TableName, VF ER.RelRecID             >  Lsche die Notizen und Dokumenten-Ordner des Datensatzes [ER.RelRecID] aus der Tabelle [ER.TableName] und setzte die RecFlag
  ;
  ;
  ;
  ; Die "Del"-Routinen lschen spezielle Relationen eines Datensatzes. Sie "kmmern" sich auch um
  ; die RecFlag. Es wird davon ausgegangen, dass danach der Datensatz noch bentigt wird. Es werden
  ; nur die genau bezeichneten Relationen gelscht.
  ;
  ; PROC DelNote        VS DN.TableName, VF DN.RelRecID, VN DN.Idx  >  Lsche die Notiz             mit dem Index [DN.Idx] des Datensatzes [DN.RelRecID] aus der Tabelle [DN.TableName] und setzte die RecFlag
  ; PROC DelDoc         VS DD.TableName, VF DD.RelRecID, VF DD.Id   >  Lsche den Dokumenten-Ordner mit der ID    [DD.ID]  des Datensatzes [DD.RelRecID] aus der Tabelle [DD.TableName] und setzte die RecFlag




  PROCEDURE KillNotes VS KN.TableName, VF KN.RelRecID
    ; Lsche die Notizen des Datensatzes [KN.RelRecID] aus der Tabelle [KN.TableName]

    LOCAL_QUERY KN.DelQ
    LOCAL_BOOL  KN.Res

    QUERY [KN.DelQ]
      DELETE
        FROM notes
       WHERE TableName = "[KN.TableName]"
         AND RelRecID  =  [KN.RelRecID|R0,0]
         AND RecordID  >  0
    END_QUERY

    EXECUTE [KN.DelQ],[KN.Res]
  END_PROC



  PROCEDURE KillDocs VS KD.TableName, VF KD.RelRecID
    ; Lsche die Dokumenten-Ordner des Datensatzes [KD.RelRecID] aus der Tabelle [KD.TableName]

    LOCAL_QUERY KD.SelQH
    LOCAL_QUERY KD.SelQI
    LOCAL_BOOL  KD.Res

    ; Alle Dokumenten-Ordner holen, die dem Datensatz zugeordnet sind
    QUERY [KD.SelQH]
      SELECT RecordID
        FROM docmgrh
       WHERE TableName = "[KD.TableName]"
         AND RelRecID  =  [KD.RelRecID|R0,0]
         AND RecordID  >  1000
    END_QUERY

    EXECUTE [KD.SelQH],[KD.Res]
    IF [KD.Res]=FALSE
      ; Wenn das hier schief geht, gibt es offenbar keine Dokumenten-Ordner-Tabellen,
      ; also ist es sinnlos einen Fehler anzuzeigen = raus hier
      EXIT_PROC
    END_IF

    GET_DATA [KD.SelQH],[KD.Res]
    IF [KD.Res]=FALSE
      ; Keine Ordner da, also gibt es nichts zu tun = raus hier
      EXIT_PROC
    END_IF

    WHILE [KD.Res]
      ; Jede einzelne Position des Ordners holen und dessen Notizen lschen
      QUERY [KD.SelQI]
        SELECT RecordID
          FROM docmgri
         WHERE HeaderID = [KD.SelQH!RecordID|R0,0]
           AND RecordID > 1000
      END_QUERY

      EXECUTE [KD.SelQI],[KD.Res]
      IF [KD.Res]
        GET_DATA [KD.SelQI],[KD.Res]
        WHILE [KD.Res]
          CALL KillNotes 'docmgri', [KD.SelQI!RecordID]
          GET_DATA [KD.SelQI],[KD.Res]
        END_WHILE

        ; Alle Position des Ordners lschen
        QUERY [KD.SelQI]
          DELETE
            FROM docmgri
           WHERE HeaderID = [KD.SelQH!RecordID|R0,0]
             AND RecordID > 1000
        END_QUERY

        EXECUTE [KD.SelQI],[KD.Res]
      END_IF

      ; Jetzt noch die Notiz des Ordners selbst lschen
      CALL KillNotes 'docmgrh', [KD.SelQH!RecordID]

      GET_DATA [KD.SelQH],[KD.Res]
    END_WHILE

    ; Zuletzt die nun leeren Ordner selbst lschen
    QUERY [KD.SelQH]
      DELETE
        FROM docmgrh
       WHERE TableName = "[KD.TableName]"
         AND RelRecID  =  [KD.RelRecID|R0,0]
         AND RecordID  >  1000
    END_QUERY

    EXECUTE [KD.SelQH],[KD.Res]
  END_PROC



  PROCEDURE KillRelations VS KR.TableName, VF KR.RelRecID
    ; Lsche die Notizen und Dokumenten-Ordner des Datensatzes [KR.RelRecID] aus der Tabelle [KR.TableName]
    CALL KillDocs  [KR.TableName], [KR.RelRecID]
    CALL KillNotes [KR.TableName], [KR.RelRecID]
  END_PROC



  PROCEDURE SetRecFlag VS SR.TableName, VF SR.RelRecID
    ; Setzt bzw. repariert die RecFlag des Datensatzes [SR.RelRecID] aus der Tabelle [SR.TableName]

    LOCAL_QUERY SR.Q1
    LOCAL_BOOL  SR.Res
    LOCAL_NUM   SR.RFlag

    ; Zunchst gehen wir mal davon aus, dass keine Relation existiert
    CALC [SR.RFlag] AS 0


    ; Welche Notiztypen existieren zu dem Datensatz ?
    QUERY [SR.Q1]
      SELECT DISTINCT NoteID
        FROM notes
       WHERE TableName = "[SR.TableName]"
         AND RecordID  =  [SR.RelRecID|R0,0]
         AND RecordID  >  1000
    END_QUERY
    EXECUTE [SR.Q1],[SR.Res]
    IF [SR.Res]
      GET_DATA [SR.Q1],[SR.Res]
      WHILE [Res]
        ; Flagge passend zur Notiz verndern (wenn ntig).
        IF [SR.Q1!DISTINCTNoteID]=1
          FLAG_SET [SR.RFlag],[NOTES_FLAG_PRINT_FRONT], TRUE
        ELSE_IF [SR.Q1!DISTINCTNoteID]=2
          FLAG_SET [SR.RFlag],[NOTES_FLAG_PRINT_BACK],  TRUE
        ELSE_IF [SR.Q1!DISTINCTNoteID]=3
          FLAG_SET [SR.RFlag],[NOTES_FLAG_INTERN],      TRUE
        ELSE_IF [SR.Q1!DISTINCTNoteID]=4
          FLAG_SET [SR.RFlag],[NOTES_FLAG_DEMAND],      TRUE
        ELSE_IF [SR.Q1!DISTINCTNoteID]>4
          FLAG_SET [SR.RFlag],[NOTES_FLAG_FREE_TEXT],   TRUE
        END_IF

        GET_DATA [SR.Q1],[SR.Res]
      END_WHILE
    END_IF

    ; Gibt es Dokumenten-Ordner zu dem Datensatz?
    QUERY [SR.Q1]
      SELECT COUNT(RecordID)
        FROM docmgrh
       WHERE TableName = "[SR.TableName]"
         AND RecordID  =  [SR.RelRecID|R0,0]
         AND RecordID  >  1000
    END_QUERY
    EXECUTE [SR.Q1],[SR.Res]
    IF [SR.Res]
      GET_DATA [SR.Q1],[SR.Res]
      IF [SR.Res]
        IF [SR.Q1!COUNT(RecordID)]>0
          FLAG_SET [SR.RFlag], 8192, TRUE
        END_IF
      END_IF
    END_IF

    ; RecFlag setzten.
    QUERY [SR.Q1]
      UPDATE [SR.TableName]
         SET RecFlag   = [SR.RFlag]
       WHERE RecordID  = [SR.RelRecID|R0,0]
         AND RecordID  > 1000
    END_QUERY

    EXECUTE [SR.Q1],[SR.Res]
  END_PROC



  PROCEDURE EraseNotes VS EN.TableName, VF EN.RelRecID
    ; Lsche die Notizen des Datensatzes [EN.RelRecID] aus der Tabelle [EN.TableName] und setzte die RecFlag
    CALL KillNotes  [EN.TableName], [EN.RelRecID]
    CALL SetRecFlag [EN.TableName], [EN.RelRecID]
  END_PROC



  PROCEDURE EraseDocs VS ED.TableName, VF ED.RelRecID
    ; Lsche die Dokumenten-Ordner des Datensatzes [ED.RelRecID] aus der Tabelle [ED.TableName] und setzte die RecFlag
    CALL KillDocs   [ED.TableName], [ED.RelRecID]
    CALL SetRecFlag [ED.TableName], [ED.RelRecID]
  END_PROC



  PROCEDURE EraseRelations VS ER.TableName, VF ER.RelRecID
    ; Lsche die Notizen und Dokumenten-Ordner des Datensatzes [ER.RelRecID] aus der Tabelle [ER.TableName] und setzte die RecFlag
    CALL KillNotes  [ER.TableName], [ER.RelRecID]
    CALL KillDocs   [ER.TableName], [ER.RelRecID]
    CALL SetRecFlag [ER.TableName], [ER.RelRecID]
  END_PROC



  PROCEDURE DelNote VS DN.TableName, VF DN.RelRecID, VN DN.Idx
    ; Lsche die Notiz mit dem Index [DN.Idx] des Datensatzes [DN.RelRecID] aus der Tabelle [DN.TableName] und setzte die RecFlag

    LOCAL_QUERY DN.DelQ
    LOCAL_BOOL  DN.Res

    QUERY [DN.DelQ]
      DELETE
        FROM notes
       WHERE TableName = "[DN.TableName]"
         AND RelRecID  =  [DN.RelRecID|R0,0]
         AND NoteID    =  [DN.Idx]
         AND RecordID  >  0
    END_QUERY

    EXECUTE [DN.DelQ],[DN.Res]

    CALL SetRecFlag [DN.TableName], [DN.RelRecID]
  END_PROC



  PROCEDURE DelDoc VS DD.TableName, VF DD.RelRecID, VF DD.Id
    ; Lsche den Dokumenten-Ordner mit der ID    [DD.ID]  des Datensatzes [DD.RelRecID] aus der Tabelle [DD.TableName] und setzte die RecFlag

    LOCAL_QUERY DD.SelQH
    LOCAL_QUERY DD.SelQI
    LOCAL_BOOL  DD.Res

    ; Alle Dokumenten-Ordner holen, die dem Datensatz zugeordnet sind
    QUERY [DD.SelQH]
      SELECT RecordID
        FROM docmgrh
       WHERE TableName = "[DD.TableName]"
         AND RelRecID  =  [DD.RelRecID|R0,0]
         AND RecordID  =  [DD.ID|R0,0]
         AND RecordID  >  1000
    END_QUERY

    EXECUTE [DD.SelQH],[DD.Res]
    IF [DD.Res]=FALSE
      ; Wenn das hier schief geht, gibt es offenbar keine Dokumenten-Ordner-Tabellen,
      ; also ist es sinnlos einen Fehler anzuzeigen = nur noch die RecFlag setzten, also Sprung nach vorne
      FORE_JUMP
    END_IF

    GET_DATA [DD.SelQH],[DD.Res]
    IF [DD.Res]=FALSE
      ; Keine Ordner da, also gibt es nichts zu tun = nur noch die RecFlag setzten, also Sprung nach vorne
      FORE_JUMP
    END_IF

    WHILE [DD.Res]
      ; Jede einzelne Position des Ordners holen und dessen Notizen lschen
      QUERY [DD.SelQI]
        SELECT RecordID
          FROM docmgri
         WHERE HeaderID = [DD.SelQH!RecordID|R0,0]
           AND RecordID > 1000
      END_QUERY

      EXECUTE [DD.SelQI],[DD.Res]
      IF [DD.Res]
        GET_DATA [DD.SelQI],[DD.Res]
        WHILE [DD.Res]
          CALL KillNotes 'docmgri', [DD.SelQI!RecordID]
          GET_DATA [DD.SelQI],[DD.Res]
        END_WHILE

        ; Alle Position des Ordners lschen
        QUERY [DD.SelQI]
          DELETE
            FROM docmgri
           WHERE HeaderID = [DD.SelQH!RecordID|R0,0]
             AND RecordID > 1000
        END_QUERY

        EXECUTE [DD.SelQI],[DD.Res]
      END_IF

      ; Jetzt noch die Notiz des Ordners selbst lschen
      CALL KillNotes 'docmgrh', [DD.SelQH!RecordID]

      GET_DATA [DD.SelQH],[DD.Res]
    END_WHILE

    ; Zuletzt den nun leeren Ordner selbst lschen
    QUERY [DD.SelQH]
      DELETE
        FROM docmgrh
       WHERE TableName = "[DD.TableName]"
         AND RelRecID  =  [DD.RelRecID|R0,0]
         AND RecordID  =  [DD.ID|R0,0]
         AND RecordID  >  1000
    END_QUERY

    EXECUTE [DD.SelQH],[DD.Res]

    FORE_MARK
    CALL SetRecFlag [DD.TableName], [DD.RelRecID]
  END_PROC

