  ; dd 05.09.2007 Bietet einen Dialog, mit dem das auf Betriebssystem-Ebene Umbenennen
  ;               eines Ordner auf die Dokumenten-Ordner-Zuordnungen abbildet.



  PROCEDURE InitVars
    VAR_MASK  WorkMask, 'DocMgrChangeFolderDlg'
    VAR_NUM   YNRes
    VAR_STR   FolderOld
    VAR_STR   FolderNew
    VAR_BOOL  Res
    VAR_QUERY SelQ
    VAR_QUERY UpdQ
    VAR_NUM   Max
    VAR_NUM   Cnt
    VAR_NUM   SPos
    VAR_STR   Str1

    CALC [WorkMask!MASK_HOOK_EXIT]     AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE] AS 'PreSaveHook'
  END_PROC



  PROCEDURE CheckAndSetPath VS SourcePath
    CALC [Str1] AS UPCASE([SourcePath])

    CALC [SPos] AS POS([FolderOld],[Str1])
    IF [SPos]<>1
      EXIT_PROC
    END_IF

    CALC [Str1] AS REPLACE([Str1],[FolderOld],[FolderNew])
    CALC [Str1] AS LOWCASE([Str1])
    IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
      CALC [Str1] AS DBL_BACK_SLASH([Str1])
    ELSE
      CALC [Str1] AS SGL_BACK_SLASH([Str1])
    END_IF
  END_PROC



  PROCEDURE ChangeDocMgrI
    QUERY [SelQ]
      SELECT FilePath, RecordID
        FROM docmgri
       WHERE FilePath <> ""
    END_QUERY

    EXECUTE [SelQ],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Dokumenten-Eintrge konnten abgefragt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SelQ],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [SelQ], [Max]
    CALC [Cnt] AS 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Str1] AS CON('berprfung des Eintrages ',[Cnt],' von ',[Max])
      WAIT_INFO 'Bitte warten...', [Str1], FALSE, 70, 2

      CALL CheckAndSetPath [SelQ!FilePath]

      IF [SPos]=1
        QUERY [UpdQ]
          UPDATE docmgri
             SET FilePath = "[Str1]"
           WHERE RecordID =  [SelQ!RecordID|R0,0]
        END_QUERY

        EXECUTE [UpdQ],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Fehler','Ein Dokumenten-Eintrag konnte nicht gendert werden.',[MESSAGE_ERROR]
        END_IF
      END_IF

      GET_DATA [SelQ],[Res]
    END_WHILE

    END_WAIT
  END_PROC



  PROCEDURE ChangeDocMgrH
    QUERY [SelQ]
      SELECT FolderName, RecordID
        FROM docmgrh
       WHERE FolderName <> ""
    END_QUERY

    EXECUTE [SelQ],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Dokumenten-Ordner konnten abgefragt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SelQ],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [SelQ], [Max]
    CALC [Cnt] AS 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Str1] AS CON('berprfung des Ordners ',[Cnt],' von ',[Max])
      WAIT_INFO 'Bitte warten...', [Str1], FALSE, 70, 2

      CALL CheckAndSetPath [SelQ!FolderName]

      IF [SPos]=1
        QUERY [UpdQ]
          UPDATE docmgrh
             SET FolderName = "[Str1]"
           WHERE RecordID   =  [SelQ!RecordID|R0,0]
        END_QUERY

        EXECUTE [UpdQ],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Fehler','Ein Dokumenten-Ordner konnte nicht gendert werden.',[MESSAGE_ERROR]
        END_IF
      END_IF

      GET_DATA [SelQ],[Res]
    END_WHILE

    END_WAIT
  END_PROC



  PROCEDURE PreSaveHook
    CALC [FolderOld] AS LOWCASE([WorkMask!FolderOld])
    FILE_SLASH [FolderOld], TRUE
    CALC [FolderNew] AS LOWCASE([WorkMask!FolderNew])
    FILE_SLASH [FolderNew], TRUE

    CALC [SPos] AS POS('document_path\',[FolderOld])
    IF [SPos]<>1
      MESSAGE 'Achtung Abbruch','Der "alte" Pfad muss auf jeden Fall mit dem Wort "document_path\" beginnen.',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    CALC [SPos] AS POS('document_path\',[FolderNew])
    IF [SPos]<>1
      MESSAGE 'Achtung Abbruch','Der "neue" Pfad muss auf jeden Fall mit dem Wort "document_path\" beginnen.',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Sollen die Datei-Zuordnungen, die auf den "alten Ordner" verweisen, so gendert werden, dass sie nun im "neuen Ordner" zu finden sind?',[YNRes]
    IF [YNRes]<>[ID_YES]
      FORE_JUMP
    END_IF

    CALL ChangeDocMgrI
    CALL ChangeDocMgrH

    FORE_MARK

    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
