  ; Parameter PAR_STR1   = StartDatum
  ;           PAR_STR2   = StopDatum
  ;           PAR_STR3   = Header (wie z.B. "alle Termine bis heute [22.11.2007]")
  ;           RECORD_ID4 > 0 ==>> Erster Aufruf, Zurcksetzten der Markierungen fr "Zur Kenntnis genommen"

  PROCEDURE InitVars
    VAR_QUERY Q
    VAR_BOOL  Res
    VAR_DATE  StartDate
    VAR_DATE  StopDate
    VAR_STR   TimeClause

    CALC [StartDate] AS [PAR_STR1]
    CALC [StopDate]  AS [PAR_STR2]

    CALC [TimeClause] AS ''
    IF [RECORD_ID4]<=[EPSILON]
      IF [StopDate]=[DATE]
        CALC [TimeClause] AS CON(' AND NextProcessTime <= ',[SQL_TIME_QUOTES_4_SELECT],[TIME|R0,[SQL_TIME_PICTURE_4_SELECT]],[SQL_TIME_QUOTES_4_SELECT],' ')
      END_IF
    END_IF
  END_PROC


  PROCEDURE Main
    ; Neustart der Anwendung?!
    IF [RECORD_ID4]>[EPSILON]
      ; Checken, ob das neue Feld "TakeNotice" schon vorhanden ist, wenn nicht anlegen
      QUERY [Q]
        SELECT TakeNotice
          FROM docmgri
         WHERE RecordID <= 1000
      END_QUERY
      EXECUTE [Q],[Res]
      IF [Res]=FALSE
        QUERY [Q]
          ALTER TABLE docmgri ADD TakeNotice [SQL_DEFINE_BOOLEAN] [SQL_DEFINE_BOOLEAN_END]
        END_QUERY
        EXECUTE [Q],[Res]
        IF [Res]
          QUERY [Q]
            UPDATE docmgri SET TakeNotice = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]
          END_QUERY
          EXECUTE [Q],[Res]
        END_IF
      END_IF

      IF [ACT_MIT_ID]>[EPSILON]
        QUERY [Q]
          UPDATE docmgri
             SET TakeNotice      = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]
           WHERE NextProcessorID = [ACT_MIT_ID|R0,0]
             AND (FinisherID     < 1 OR (Termin   = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]  AND
                                         Erledigt = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]    ))
        END_QUERY

        EXECUTE [Q],[Res]
      END_IF
    END_IF

    QUERY [Q]
      SELECT COUNT(RecordID)
        FROM docmgri
       WHERE NextProcessorID  = [ACT_MIT_ID|R0,0]
         AND NextProcessDate >= [SQL_DATE_QUOTES_4_SELECT][StartDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND NextProcessDate <= [SQL_DATE_QUOTES_4_SELECT][StopDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND (FinisherID      < 1 OR (Termin   = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]  AND
                                      Erledigt = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]    ))
             [TimeClause]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]
      GET_DATA [Q],[Res]
      IF [Res]
        CALC [DOCU_MGR_DATE_LIST_COUNT] AS [Q!COUNT(RecordID)]
      END_IF
    END_IF

    QUERY [Q]
      SELECT COUNT(RecordID)
        FROM docmgri
       WHERE NextProcessorID  = [ACT_MIT_ID|R0,0]
         AND NextProcessDate >= [SQL_DATE_QUOTES_4_SELECT][StartDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND NextProcessDate <= [SQL_DATE_QUOTES_4_SELECT][StopDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND (FinisherID      < 1 OR (Termin   = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]  AND
                                      Erledigt = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]    ))
         AND TakeNotice       = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]
             [TimeClause]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]
      GET_DATA [Q],[Res]
      IF [Res]
        CALC [DOCU_MGR_DATE_LIST_UNCHECKED] AS [Q!COUNT(RecordID)]
      END_IF
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END