; Standard-Document-Manager-Main-Script
;
; Replacement for the former Document-Manager, instant part of the CARA-Script-Interpreter-Engine
;
; 28.08.2007 Dieter Dasberg
;
;
; Parameters : PAR_STR1    TableName
;              PAR_STR2    XRefName     / kann leer sein
;              RECORD_ID3  RecFlag
;              RECORD_ID4  RelRecID
;              RECORD_ID5  RightsFlag   / kann 0 sein
;              PAR_STR6    Header       / kann leer sein
;              RECORD_ID7  ItemID       >0 /  0 / -1
;              RECORD_ID8  WorkMode     0 = Dokumanager
;                                       1 = Ticket-Dashboard



  INCLUDE DocMgrUtils.inc
  INCLUDE Choicer.inc

  PROCEDURE DocMgrMainInitVars
    CALL DocMgrUtilInitVars

    VAR_BOOL    DMPreViewIsOn
    VAR_BOOL    DMDocumentDirect
    VAR_BOOL    DMRes
    VAR_MASK    DMMask,       'DocMgrMainDlg'
    VAR_BOOL    DMMNewItem

    VAR_STR     DMTableName
    VAR_STR     DMXRefName
    VAR_STR     DMCategoryName
    VAR_NUM     DMRelRecFlag
    VAR_FLOAT   DMRelRecID
    VAR_NUM     DMRightsFlag
    VAR_STR     DMHeader
    VAR_FLOAT   DMItemID
    VAR_FLOAT   DMActItemID

    VAR_FLOAT   DMHeaderID
    VAR_NUM     DMHeaderFlag

    VAR_NUM     DMRelMax, 9
    VAR_NUM     DMRelCnt
    CALC [DMRelCnt] AS 1
    WHILE [DMRelCnt]<=[DMRelMax]
      VAR_STR   DMRelName[DMRelCnt]
      VAR_STR   DMRelLabel[DMRelCnt]
      VAR_STR   DMRelTable[DMRelCnt]
      VAR_STR   DMRelHint[DMRelCnt]
      VAR_STR   DMRelClause[DMRelCnt]
      INC [DMRelCnt]
    END_WHILE

    VAR_NUM     DMSendConfirm
    VAR_NUM     DMYNRes
    VAR_NUM     DMMax
    VAR_NUM     DMQueryIdx
    VAR_NUM     DMLnCnt
    VAR_NUM     DMLnMax
    VAR_LIST    DMNote

    VAR_STR     DMFilter4Folder
    VAR_STR     DMFilter4Thread
    VAR_STR     DMFilter4Category
    VAR_STR     DMHeaderOri
    VAR_STR     DMStr1
    VAR_STR     DMStr2
    VAR_STR     DMStr3
    VAR_STR     DMNum1

    VAR_BOOL    DMTicket
    VAR_BOOL    DMTermin
    VAR_BOOL    DMErledigt

    VAR_FLOAT   DMFloat1

    VAR_BROWSER DMViewer
    VAR_QUERY   DMGridQ

    VAR_QUERY   DMWorkQ

    VAR_NUM     DMWorkMode

    VAR_NUM     DMGridOption

    ; INI-Datei fr Relationen auslesen
    CALC [DMRelCnt] AS 1
    WHILE [DMRelCnt]<=[DMRelMax]
      CALC [DMStr2] AS CON('XRef0',[DMRelCnt])
      CALC [DMStr1] AS ''

      EXIST_FILE [APPLICATION_INI_FILE],[DMRes]
      IF [DMRes]
        INI_READ [DMRes],[DMStr1],[SCRIPT_STRING],[APPLICATION_INI_FILE],[DMStr2],'DocumentManager'
        IF [DMRes]=FALSE
          CALC [DMStr1] AS ''
        END_IF
      END_IF

      IF [DMStr1]=''
        CALC [DMLnCnt] AS [DMRelCnt]
        WHILE [DMLnCnt]<=[DMRelMax]
          CALC [DMStr1] AS CON('LB_REL_',[DMLnCnt])
          FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

          CALC [DMStr1] AS CON('InfRel',[DMLnCnt])
          FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

          CALC [DMStr1] AS CON('BB_REL_CHOOSE_',[DMLnCnt])
          FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

          CALC [DMStr1] AS CON('BB_REL_JUMP_',[DMLnCnt])
          FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

          INC  [DMLnCnt]
        END_WHILE

        CALC [DMRelMax] AS [DMRelCnt]-1
      ELSE
        CALC [DMRelName[DMRelCnt]]   AS PART([DMStr1],1,',')
        CALC [DMRelLabel[DMRelCnt]]  AS PART([DMStr1],2,',')
        CALC [DMRelTable[DMRelCnt]]  AS PART([DMStr1],3,',')
        CALC [DMRelHint[DMRelCnt]]   AS PART([DMStr1],4,',')
        CALC [DMRelClause[DMRelCnt]] AS PART([DMStr1],5,',')

        CALC [DMStr1] AS CON('LB_REL_',[DMRelCnt])
        SET_LABEL [DMMask],[DMStr1],[DMRelLabel[DMRelCnt]]
      END_IF

      INC [DMRelCnt]
    END_WHILE

    CALC [DMGridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_ICON_INSERT]

    CALC [DMTableName]  AS [PAR_STR1]
    CALC [DMXRefName]   AS [PAR_STR2]
    CALC [DMRelRecFlag] AS [RECORD_ID3]
    CALC [DMRelRecID]   AS [RECORD_ID4]
    CALC [DMRightsFlag] AS [RECORD_ID5]
    CALC [DMHeader]     AS [PAR_STR6]
    CALC [DMItemID]     AS [RECORD_ID7]
    CALC [DMWorkMode]   AS [RECORD_ID8]

    CALC [DMQueryIdx] AS 2
    IF [DMItemID]>[EPSILON]
      CALC [DMQueryIdx] AS 1

      IF [DMTableName]=''
        IF [DMXRefName]=''
          IF [DMRelRecFlag]=0
            IF [DMRelRecID]<=[EPSILON]
              ; es wurde DOCUMENT_DIRECT aufgerufen
              ; d.h. das die Datei sofort angezeigt werden soll und dann raus hier

              CALC [DMDocumentDirect] AS TRUE

              QUERY [DMWorkQ]
                SELECT FilePath, TemplateName
                  FROM docmgri
                 WHERE RecordID = [DMItemID|R0,0]
              END_QUERY
              EXECUTE [DMWorkQ], [DMRes]
              IF [DMRes]
                GET_DATA [DMWorkQ], [DMRes]
                IF [DMRes]
                  IF [DMWorkQ!FilePath]<>''
                    CALL DocMgrFixPath [DMWorkQ!FilePath], [DM_REMOVE_PATH_DUMMY], [DMStr1]
                    EXIST_FILE [DMStr1], [DMRes]
                    IF [DMRes]=FALSE
                      IF [DMWorkQ!TemplateName]<>''
                        CALL DocMgrFixPath [DMWorkQ!TemplateName], [DM_REMOVE_PATH_DUMMY], [DMStr2]
                        EXIST_FILE [DMStr2], [DMRes]
                        IF [DMRes]
                          FILE_COPY [DMRes], [DMStr2], [DMStr1]
                          IF [DMRes]
                            EXIST_FILE [DMStr1], [DMRes]
                          END_IF
                        END_IF
                      END_IF
                    END_IF

                    IF [DMRes]
                      SHELL_EXECUTE '', [DMStr1], '', '', [EXTERN_SHOWNORMAL]
                    END_IF
                  END_IF
                END_IF
              END_IF

              EXIT_PROC
            END_IF
          END_IF
        END_IF
      END_IF
    END_IF

    IF [DMItemID]>[EPSILON]
      IF [DMRelRecID]<=[EPSILON]
        QUERY [DMWorkQ]
          SELECT H.TableName, H.XRefName, H.RelRecID, H.RecordID
            FROM docmgri I, docmgrh H
           WHERE I.RecordID = [DMItemID|R0,0]
             AND I.HeaderID = H.RecordID
        END_QUERY
        EXECUTE [DMWorkQ], [DMRes]
        IF [DMRes]
          GET_DATA [DMWorkQ], [DMRes]
          IF [DMRes]
            CALC [DMTableName]  AS [DMWorkQ!H.TableName]
            CALC [DMXRefName]   AS [DMWorkQ!H.XRefName]
            CALC [DMRelRecID]   AS [DMWorkQ!H.RecordID]
          END_IF
        END_IF
      END_IF
    END_IF

    CALC [DMHeaderOri] AS [DMMask!MASK_HEAD_LINE]

    IF [DMWorkMode]=[DM_WORK_MODE_DOC_MANAGER]
      IF [DMRelRecID]<=[EPSILON]
        EXIT_PROC
      END_IF

      IF [DMHeader]=''
        CALL DocMgrUtilLoadRelationByTableFld [DMXRefName], [DMTableName], 'DMHeader', 'DMRelRecID', [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      END_IF

      CALC [DMMask!MASK_HEAD_LINE] AS CON([DMHeaderOri],'  =>  ',[DMHeader])
    ELSE_IF [DMWorkMode]=[DM_WORK_MODE_DASHBOARD_TICKET]
      CALC [DMMask!MASK_HEAD_LINE] AS [DMHeader]
      CALC [DMTicket]              AS TRUE
    END_IF

    CALC [DMMask!MASK_HOOK_EXIT]       AS 'DocMgrMainExitHook'
    CALC [DMMask!MASK_HOOK_SHOW]       AS 'DocMgrMainShowHook'
    CALC [DMMask!MASK_HOOK_BUTTON]     AS 'DocMgrMainButtonHook'
    CALC [DMMask!MASK_HOOK_GRID_OK]    AS 'DocMgrMainGridOkHook'
    CALC [DMMask!MASK_HOOK_PRE_SAVE]   AS 'DocMgrMainPreSaveHook'
    CALC [DMMask!MASK_HOOK_POST_SAVE]  AS 'DocMgrMainPostSaveHook'
    CALC [DMMask!MASK_HOOK_POST_CLEAR] AS 'DocMgrMainPostClearHook'
    CALC [DMMask!MASK_HOOK_DELETE]     AS 'DocMgrMainDeleteHook'
    CALC [DMMask!MASK_HOOK_DROP]       AS 'DocMgrMainDropHook'
    CALC [DMMask!MASK_HOOK_POST_EDIT]  AS 'DocMgrMainPostEditHook'
    CALC [DMMask!MASK_HOOK_INFO]       AS 'DocMgrMainInfoHook'
    CALC [DMMask!MASK_HOOK_IS_READY]   AS 'DocMgrMainIsReadyHook'

    CALC [DMMask!TableName]  AS [DMTableName]
    CALC [DMMask!XRefName]   AS [DMXRefName]
    CALC [DMMask!RelRecID]   AS [DMRelRecID]
    CALC [DMMask!FolderInfo] AS [DMHeader]

    MASK_UPDATE [DMMask], TRUE
  END_PROC


  PROCEDURE MaskSettingsRead
    LOCAL_BOOL LocValue

    ; Wird zum ersten Mal versucht die Settings zu lesen?
    CALC [DMStr1] AS ''
    INI_READ [DMRes], [DMStr1], [SCRIPT_STRING], [STATION_INI_FILE], 'DragDropVereinen',    'DocumentManager'
    IF [DMStr1]=''
      EXIT_PROC
    END_IF

    INI_READ [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'DragDropVereinen',    'DocumentManager'
    CALC [DMMask!CB_UNION] AS [LocValue]

    INI_READ [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'DragDropVerschieben', 'DocumentManager'
    CALC [DMMask!CB_MOVE]  AS [LocValue]

    INI_READ [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'DragDropVerzeichnis', 'DocumentManager'
    CALC [DMMask!CB_DIR]   AS [LocValue]

    INI_READ [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'Gruppenauswahl',      'DocumentManager'
    CALC [DMMask!CB_GROUP] AS [LocValue]

    INI_READ [DMRes], [DMPreViewIsOn], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'Vorschau',            'DocumentManager'
    CALC [DMMask!CB_PREVIEW] AS [DMPreViewIsOn]

    MASK_UPDATE [DMMask], TRUE
  END_PROC


  PROCEDURE MaskSettingsWrite
    LOCAL_BOOL LocValue

    CALC [LocValue] AS [DMMask!CB_UNION]
    INI_WRITE [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'DragDropVereinen',    'DocumentManager'

    CALC [LocValue] AS [DMMask!CB_MOVE]
    INI_WRITE [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'DragDropVerschieben', 'DocumentManager'

    CALC [LocValue] AS [DMMask!CB_DIR]
    INI_WRITE [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'DragDropVerzeichnis', 'DocumentManager'

    CALC [LocValue] AS [DMMask!CB_GROUP]
    INI_WRITE [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'Gruppenauswahl',      'DocumentManager'

    CALC [LocValue] AS [DMMask!CB_PREVIEW]
    INI_WRITE [DMRes], [LocValue], [SCRIPT_BOOLEAN], [STATION_INI_FILE], 'Vorschau',            'DocumentManager'
  END_PROC


  PROCEDURE DocMgrShowPreview
    LOCAL_LIST  LocHTML
    LOCAL_STR   LocStr1
    LOCAL_STR   LocStr2
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocSPos
    LOCAL_QUERY LocQ
    LOCAL_BOOL  LocFound

    CALL DocMgrFixPath [DMMask!I.FilePath], [DM_REMOVE_PATH_DUMMY], [DMStr1]

    CALC [LocStr1] AS [DMStr1]
    EXIST_FILE [LocStr1],[LocRes]
    IF [LocRes]
      CALC [LocFound] AS TRUE

      FILE_EXT [LocStr2], [LocStr1]
      IF [LocStr2]=''
        CALC [LocSPos] AS 0
      ELSE
        CALC [LocSPos] AS POS([LocStr2],'.bmp .jpg .gif .png .jpeg')
      END_IF
      IF [LocSPos]=0
        FORE_JUMP
      ELSE
        CALC [LocStr2]  AS CON('<html><body bgcolor=#',[WINDOWS_COL_BTN_FACE],' ><div align="center">')
        LIST_APPEND [LocHTML],[LocStr2]

        CALC [LocStr2] AS [LocStr1]
; Nicht ntig: Leerzeichen ersetzten
;           CALC [LocStr2] AS REPLACE([LocStr1],' ','%20')

        CALC [LocStr1] AS CON('<img src="',[LocStr2],'" border=0 alt="',[LocStr1],'" ></a><br><br>')
        LIST_APPEND [LocHTML],[LocStr1]

        IF [LocFound]
          LIST_APPEND [LocHTML],'</div></body></html>'
        END_IF
      END_IF
    END_IF


    IF [LocFound]=FALSE
      CALC [LocStr1] AS CON('<html><body bgcolor=#',[WINDOWS_COL_BTN_FACE],' ></body></html>')
      LIST_APPEND [LocHTML],[LocStr1]
    END_IF

    CALC [LocStr1] AS CON([PRINTSET_PATH],'empty_',[STATION_SHORT],'.htm')
    LIST_FILE_WRITE [LocHTML],[LocRes],[LocStr1]

    FORE_MARK

    NAVIGATE [DMMask], 'DM_PREVIEW_NAVI', [LocStr1]
  END_PROC



  PROCEDURE DocMgrMainRecChange
    DATA_2_MASK [DMMask],[DMGridQ], FALSE
    CALC [DMActItemID] AS [DMGridQ!I.RecordID]

    IF [DMWorkMode]=[DM_WORK_MODE_DASHBOARD_TICKET]
      CALC [DMTableName] AS [DMGridQ!D.TableName]
      CALC [DMXRefName]  AS [DMGridQ!D.XRefName]
      CALC [DMRelRecID]  AS [DMGridQ!D.RelRecID]
      CALC [DMHeaderID]  AS [DMGridQ!D.RecordID]
      CALC [DMHeader]    AS [DMGridQ!D.FolderInfo]

      CALL DocMgrUtilLoadRelationByTableFld [DMXRefName], [DMTableName], 'DMHeader', 'DMRelRecID', [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF

    IF [DMMask!I.NextProcessDate]>'01.01.1980'
      IF [DMMask!I.FinishDate]<='01.01.1980'
        SET_COLOR [DMMask], 'I.NextProcessDate', 'yellow'
        SET_COLOR [DMMask], 'I.NextProcessTime', 'yellow'
      ELSE
        SET_COLOR [DMMask], 'I.NextProcessDate', 'window'
        SET_COLOR [DMMask], 'I.NextProcessTime', 'window'
      END_IF
    ELSE
      SET_COLOR [DMMask], 'I.NextProcessDate', 'window'
      SET_COLOR [DMMask], 'I.NextProcessTime', 'window'
    END_IF

    CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMMask!NextProcessor',   'DMMask!I.NextProcessorID', [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMMask!Creator',         'DMMask!I.CreatorID',       [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMMask!Finisher',        'DMMask!I.FinisherID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]

    IF [DMMask!I.XRef01ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef01Name], '', 'DMMask!InfRel1', 'DMMask!I.XRef01ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef02ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef02Name], '', 'DMMask!InfRel2', 'DMMask!I.XRef02ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef03ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef03Name], '', 'DMMask!InfRel3', 'DMMask!I.XRef03ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef04ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef04Name], '', 'DMMask!InfRel4', 'DMMask!I.XRef04ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef05ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef05Name], '', 'DMMask!InfRel5', 'DMMask!I.XRef05ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef06ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef06Name], '', 'DMMask!InfRel6', 'DMMask!I.XRef06ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef07ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef07Name], '', 'DMMask!InfRel7', 'DMMask!I.XRef07ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef08ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef08Name], '', 'DMMask!InfRel8', 'DMMask!I.XRef08ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF
    IF [DMMask!I.XRef09ID]>[EPSILON]
      CALL DocMgrUtilLoadRelationByTableFld [DMMask!I.XRef09Name], '', 'DMMask!InfRel9', 'DMMask!I.XRef09ID',      [DM_MASK_UPDATE_NO],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
    END_IF

    CALC [DMMask!CategoryName] AS [DMGridQ![DM_SQL_CATEGORY_STR]]

    IF [DMGridQ!I.SendConfirm]=2
      CALC [DMMask!SendConfirmDo]  AS TRUE
      CALC [DMMask!SendConfirmDid] AS TRUE
    ELSE_IF [DMGridQ!I.SendConfirm]=1
      CALC [DMMask!SendConfirmDo]  AS TRUE
      CALC [DMMask!SendConfirmDid] AS FALSE
    ELSE
      CALC [DMMask!SendConfirmDo]  AS FALSE
      CALC [DMMask!SendConfirmDid] AS FALSE
    END_IF

    NOTE_READ [DMNote], [DMRes],  'docmgri',    1, [DMActItemID]
    MEMO_SET  [DMMask], [DMNote], 'I.ItemInfos'

    MASK_UPDATE [DMMask], TRUE

    IF [DMGridQ!I.SendConfirm]=2
      FIELD_FLAG_ON_OFF [DMMask],'SendConfirmDo','[FIELD_FLAG_PROTECTED]',''
    ELSE
      FIELD_FLAG_ON_OFF [DMMask],'SendConfirmDo','','[FIELD_FLAG_PROTECTED]'
    END_IF

    IF [DMPreViewIsOn]
      CALL DocMgrShowPreview
    END_IF
  END_PROC



  PROCEDURE DocMgrMainSetGrid
    CALC [DMGridQ!QUERY_HOOK_REC_CHANGE]  AS ''

    IF [DMWorkMode]=[DM_WORK_MODE_DOC_MANAGER]
      QUERY [DMGridQ]
          SELECT [W48 N"Info"                                  ]I.ItemNote,
                 [W06 N"Ticket"        I1A="[SQL_BOOLEAN_TRUE]"]I.FirstOfThread,

                 [W12 N"angelegt am"                           ]I.CreateDate,
                 [W05 N"um"                                    ]I.CreateTime,
                 [W15 N"Art"                                   ]I.CreateType,

                 [W12 N"Termin"                                ]I.NextProcessDate,
                 [W05 N"von"                                   ]I.NextProcessTime,
                 [W05 N"bis"                                   ]I.NextProcessRunTime,
                 [W15 N"Typ"                                   ]I.NextProcessType,

                 [W12 N"erledigt"                              ]I.FinishDate,
                 [W05 N"von "                                  ]I.FinishTime,
                 [W05 N"bis "                                  ]I.FinishRunTime,
                 [W15 N"wie"                                   ]I.FinishType,

                 [W20 N"Kategorie"                             ][DM_SQL_CATEGORY],
                 [W20 N"Thema"                                 ]I.ThreadName,

                 [W60 N"Datei"                      KA<>"" L"3"]I.FilePath,

                 [H                                            ]I.NextProcessRunDate,
                 [H                                            ]I.FinishRunDate,
                 [H                                            ]I.SendConfirm,
                 [H                                            ]I.RightActionLevel,
                 [H                                            ]I.CategoryID,
                 [H                                            ]I.CreatorID,
                 [H                                            ]I.NextProcessorID,
                 [H                                            ]I.FinisherID,
                 [H                                            ]I.Termin,
                 [H                                            ]I.erledigt,
                 [H                                            ]I.TemplateName,
                 [H                                            ]I.XRef01ID,
                 [H                                            ]I.XRef02ID,
                 [H                                            ]I.XRef03ID,
                 [H                                            ]I.XRef04ID,
                 [H                                            ]I.XRef05ID,
                 [H                                            ]I.XRef06ID,
                 [H                                            ]I.XRef07ID,
                 [H                                            ]I.XRef08ID,
                 [H                                            ]I.XRef09ID,
                 [H                                            ]I.XRef10ID,
                 [H                                            ]I.XRef01Name,
                 [H                                            ]I.XRef02Name,
                 [H                                            ]I.XRef03Name,
                 [H                                            ]I.XRef04Name,
                 [H                                            ]I.XRef05Name,
                 [H                                            ]I.XRef06Name,
                 [H                                            ]I.XRef07Name,
                 [H                                            ]I.XRef08Name,
                 [H                                            ]I.XRef09Name,
                 [H                                            ]I.XRef10Name,
                 [H                                            ]I.XRef01TableName,
                 [H                                            ]I.XRef02TableName,
                 [H                                            ]I.XRef03TableName,
                 [H                                            ]I.XRef04TableName,
                 [H                                            ]I.XRef05TableName,
                 [H                                            ]I.XRef06TableName,
                 [H                                            ]I.XRef07TableName,
                 [H                                            ]I.XRef08TableName,
                 [H                                            ]I.XRef09TableName,
                 [H                                            ]I.XRef10TableName,
                 [H                                            ]I.RecordID,
                 [H                                            ]I.RecFlag

            FROM docmgri I, docmgrca C

           WHERE I.HeaderID   = [DMMask!MASK_RECORD_ID|R0,0]
             AND I.HeaderID   > 1000
             AND I.CategoryID = C.RecordID

                 [DMFilter4Folder]
                 [DMFilter4Thread]
                 [DMFilter4Category]
      END_QUERY
    ELSE_IF [DMWorkMode]=[DM_WORK_MODE_DASHBOARD_TICKET]
      LOCAL_STR LocClause

      IF [DMMask!ShowTicketsOpen]=FALSE
        CALC [LocClause] AS CON([LocClause],' AND I.erledigt = ',[SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION])
      END_IF
      IF [DMMask!ShowTicketsClosed]=FALSE
        CALC [LocClause] AS CON([LocClause]' AND I.erledigt = ',[SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION])
      END_IF

      QUERY [DMGridQ]
          SELECT [W20 N"Kunde Name 1"                          ]K.Name1,
                 [W48 N"Info"                                  ]I.ItemNote,
                 [W06 N"Ticket"        I1A="[SQL_BOOLEAN_TRUE]"]I.FirstOfThread,

                 [W15 N"von"                                   ]M.Name1,
                 [W12 N"angelegt am"                           ]I.CreateDate,
                 [W08 N"um"                                    ]I.CreateTime,
                 [W15 N"Art"                                   ]I.CreateType,

                 [W12 N"Termin"                                ]I.NextProcessDate,
                 [W05 N"von"                                   ]I.NextProcessTime,
                 [W05 N"bis"                                   ]I.NextProcessRunTime,
                 [W15 N"Typ"                                   ]I.NextProcessType,

                 [W20 N"Ordner-Name"                           ]D.FileName,
                 [W20 N"vom"                                   ]D.FileDate,
                 [W20 N"Verzeichnis"                           ]D.FolderName,

                 [W12 N"erledigt"                              ]I.FinishDate,
                 [W05 N"von "                                  ]I.FinishTime,
                 [W05 N"bis "                                  ]I.FinishRunTime,
                 [W15 N"wie"                                   ]I.FinishType,

                 [W20 N"Kategorie"                             ][DM_SQL_CATEGORY],
                 [W20 N"Thema"                                 ]I.ThreadName,

                 [W60 N"Datei"                      KA<>"" L"3"]I.FilePath,

                 [H                                            ]D.RelRecID,
                 [H                                            ]D.RecordID,
                 [H                                            ]D.TableName,
                 [H                                            ]D.XRefName,
                 [H                                            ]D.FolderInfo,

                 [H                                            ]I.NextProcessRunDate,
                 [H                                            ]I.FinishRunDate,
                 [H                                            ]I.SendConfirm,
                 [H                                            ]I.RightActionLevel,
                 [H                                            ]I.CategoryID,
                 [H                                            ]I.CreatorID,
                 [H                                            ]I.NextProcessorID,
                 [H                                            ]I.FinisherID,
                 [H                                            ]I.Termin,
                 [H                                            ]I.erledigt,
                 [H                                            ]I.TemplateName,
                 [H                                            ]I.XRef01ID,
                 [H                                            ]I.XRef02ID,
                 [H                                            ]I.XRef03ID,
                 [H                                            ]I.XRef04ID,
                 [H                                            ]I.XRef05ID,
                 [H                                            ]I.XRef06ID,
                 [H                                            ]I.XRef07ID,
                 [H                                            ]I.XRef08ID,
                 [H                                            ]I.XRef09ID,
                 [H                                            ]I.XRef10ID,
                 [H                                            ]I.XRef01Name,
                 [H                                            ]I.XRef02Name,
                 [H                                            ]I.XRef03Name,
                 [H                                            ]I.XRef04Name,
                 [H                                            ]I.XRef05Name,
                 [H                                            ]I.XRef06Name,
                 [H                                            ]I.XRef07Name,
                 [H                                            ]I.XRef08Name,
                 [H                                            ]I.XRef09Name,
                 [H                                            ]I.XRef10Name,
                 [H                                            ]I.XRef01TableName,
                 [H                                            ]I.XRef02TableName,
                 [H                                            ]I.XRef03TableName,
                 [H                                            ]I.XRef04TableName,
                 [H                                            ]I.XRef05TableName,
                 [H                                            ]I.XRef06TableName,
                 [H                                            ]I.XRef07TableName,
                 [H                                            ]I.XRef08TableName,
                 [H                                            ]I.XRef09TableName,
                 [H                                            ]I.XRef10TableName,
                 [H                                            ]I.RecordID,
                 [H                                            ]I.RecFlag

            FROM docmgrh D, docmgri I, docmgrca C, adressen M, adressen K

           WHERE D.RecordID   = I.HeaderID
             AND I.HeaderID   > 1000
             AND D.RelRecID   = K.RecordID
             AND I.CategoryID = C.RecordID
             AND I.CreatorID  = M.RecordID

                 [LocClause]

                 [DMFilter4Folder]
                 [DMFilter4Thread]
                 [DMFilter4Category]
      END_QUERY
    END_IF


    IF [DMPreViewIsOn]
      QUERY_ADD_STRING [DMGridQ],'ORDER BY I.ItemNote DESC'
    ELSE
      QUERY_ADD_STRING [DMGridQ],'ORDER BY I.RecordID DESC, I.CreateDate DESC, I.CreateTime DESC'
    END_IF

    EXECUTE [DMGridQ],[DMRes]
    IF [DMRes]
      QUERY_COUNT [DMGridQ],[DMMax]
      GRID_SET [DMMask], 'FileList', [DMGridQ], [DMRes], [DMGridOption]
    ELSE
      CALC [DMMax] AS 0
    END_IF

    IF [DMMax]>0
      GET_DATA [DMGridQ], [DMRes], [CURR_REC]

      IF [DMWorkMode]=[DM_WORK_MODE_DOC_MANAGER]
        CALL DocMgrMainRecChange
        CALC [DMGridQ!QUERY_HOOK_REC_CHANGE]  AS 'DocMgrMainRecChange'
      END_IF

      FIELD_FLAG_ON_OFF [DMMask],'FileList','[FIELD_FLAG_ACTUAL]'
    END_IF
  END_PROC



  PROCEDURE DocMgrMainPostEditHook
    IF [DMMask!MASK_ACT_FIELD_NAME]='CB_UNION'
      FIELD_FLAG_ON_OFF [DMMask], 'CB_UNION', '[FIELD_FLAG_MODIFIED]'
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='CB_MOVE'
      FIELD_FLAG_ON_OFF [DMMask], 'CB_MOVE',  '[FIELD_FLAG_MODIFIED]'
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='CB_DIR'
      FIELD_FLAG_ON_OFF [DMMask], 'CB_DIR',   '[FIELD_FLAG_MODIFIED]'

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='ShowTicketsOpen'
      CALL DocMgrMainSetGrid
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='ShowTicketsClosed'
      CALL DocMgrMainSetGrid
    END_IF
  END_PROC



  PROCEDURE DocMgrMainGridOkHook
    IF [DMTicket]
      CALC [DMGridQ!QUERY_HOOK_REC_CHANGE]  AS 'DocMgrMainRecChange'

      IF [DMFilter4Thread]=''
        CALC [DMFilter4Category] AS CON('AND I.CategoryID = ', [DM_TICKET_CATEGORY|R0,0])
        CALC [DMFilter4Thread]   AS CON('AND I.ThreadName = "',[DMGridQ!I.ThreadName],'"')
        CALL DocMgrMainSetGrid
        CALC [DMGridQ!QUERY_HOOK_REC_CHANGE]  AS 'DocMgrMainRecChange'
        EXIT_PROC
      END_IF
    END_IF

    IF [DMMask!MASK_ACT_GRID_NAME]='FileList'
      IF [DMMask!I.FilePath]<>''
        CALL DocMgrFixPath [DMMask!I.FilePath], [DM_REMOVE_PATH_DUMMY], [DMStr1]
        EXIST_FILE [DMStr1], [DMRes]
        IF [DMRes]
          SHELL_EXECUTE '', [DMStr1], '', '', [EXTERN_SHOWNORMAL]
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE DocMgrMainDelNotes VS DMMDN.TableName, VF DMMDN.RelRecID, VN DMMDN.NoteIdx
    LOCAL_STR DMMDN.CLause
    IF [DMMDN.NoteIdx]>0
      CALC [DMMDN.CLause] AS CON('AND NoteId = ',[DMMDN.NoteIdx])
    END_IF
    QUERY [DMWorkQ]
      DELETE
        FROM notes
       WHERE TableName = "[DMMDN.TableName]"
         AND RelRecID  =  [DMMDN.RelRecID|R0,0]
             [DMMDN.CLause]
    END_QUERY
    EXECUTE [DMWorkQ], [DMRes]
  END_PROC



  PROCEDURE CheckChangesLocal VS NewVal, VS OldVal, VB IsID, VS AddInfo
    LOCAL_STR   LocStrNew
    LOCAL_STR   LocStrOld
    LOCAL_STR   LocField
    LOCAL_QUERY LocQ
    LOCAL_BOOL  LocRes
    LOCAL_FLOAT LocID

    IF [IsID]
      CALC [LocStrNew] AS [[NewVal]|R0,0]
      CALC [LocStrOld] AS [[OldVal]|R0,0]
    ELSE
      CALC [LocStrNew] AS [[NewVal]]
      CALC [LocStrOld] AS [[OldVal]]
    END_IF

    IF [LocStrNew]=[LocStrOld]
      EXIT_PROC
    END_IF

    IF [AddInfo]<>''
      CALC [LocStrNew] AS CON([LocStrNew],'  ',[AddInfo])
    END_IF

    CALC [LocField] AS PART([OldVal],2,'.')

    NEW_RECORD [LocRes],'changes',[LocID], TRUE, FALSE, FALSE
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    QUERY [LocQ]
      UPDATE changes
         SET TableName  = "docmgri",
             RelRecID   =  [DMActItemID|R0,0],
             ChangeDate =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             ChangeTime =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             UserName   = "[SHORT_NAME]",
             FieldName  = "[LocField]",
             ValueOld   = "[LocStrOld]",
             ValueNew   = "[LocStrNew]",
             StationID  =  [STATION_ID|R0,0],
             UserID     =  [ACT_MIT_ID|R0,0]
       WHERE RecordID   =  [LocID|R0,0]
    END_QUERY

    EXECUTE [LocQ], [LocRes]
    IF [LocRes]=FALSE
      QUERY [LocQ]
        DELETE
          FROM changes
         WHERE RecordID = [LocID|R0,0]
      END_QUERY
      EXECUTE [LocQ], [LocRes]
    END_IF
  END_PROC



  PROCEDURE DocMgrMainSaveItem
    IF [DMMask!I.ItemNote]=''
      MESSAGE 'Achtung die Detailangaben werden nicht gespeichert','Bitte geben Sie zunchst eine Bemerkung an',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    IF [DMTicket]
      IF [DMMask!I.ThreadName]=''
        MESSAGE 'Achtung die Detailangaben werden nicht gespeichert','Sie befinden sich im "Ticketmodus".|Bitte geben Sie zunchst ein Thema an',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      CALC [DMFloat1] AS ABS([DMMask!I.CategoryID]-[DM_TICKET_CATEGORY])
      IF [DMFloat1]>[EPSILON]
        MESSAGE 'Achtung die Detailangaben werden nicht gespeichert','Sie befinden sich im "Ticketmodus".|Bitte geben Sie die Kategorie "Tickets" an',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF
    END_IF


    CALC [DMMNewItem] AS FALSE

    CALC [DMSendConfirm] AS 0
    IF [DMMask!SendConfirmDid]
      CALC [DMSendConfirm] AS 2
    ELSE_IF [DMMask!SendConfirmDo]
      CALC [DMSendConfirm] AS 1
    ELSE
      CALC [DMSendConfirm] AS 0
    END_IF

    IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
      CALC [DMStr1] AS DBL_BACK_SLASH([DMMask!I.FilePath])
    ELSE
      CALC [DMStr1] AS SGL_BACK_SLASH([DMMask!I.FilePath])
    END_IF

    CALC [DMTermin] AS FALSE
    IF [DMMask!I.NextProcessorID]>[EPSILON]
      IF [DMMask!I.NextProcessDate]>[DEFAULT_DATE]
        CALC [DMTermin] AS TRUE
      END_IF
    END_IF

    CALC [DMErledigt] AS FALSE
    IF [DMMask!I.FinisherID]>[EPSILON]
      IF [DMMask!I.FinishDate]>[DEFAULT_DATE]
        CALC [DMErledigt] AS TRUE
      END_IF
    END_IF

    IF [DMActItemID]<=[EPSILON]
      NEW_RECORD [DMRes],'docmgri',[DMActItemID], TRUE, FALSE, FALSE
      IF [DMRes]=FALSE
        MESSAGE 'Achtung Fehler','Es konnte kein neuer Datensatz in der Tabelle "docmgri" erzeugt werden.',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      CALC [DMMNewItem] AS TRUE
    ELSE
      CALL CheckChangesLocal 'DMMask!I.CreateDate',         'DMGridQ!I.CreateDate',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.CreateTime',         'DMGridQ!I.CreateTime',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.CreateType',         'DMGridQ!I.CreateType',         FALSE, ''

      IF [DMMask!I.CreatorID]>[EPSILON]
        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMStr2', 'DMMask!I.CreatorID',  [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      ELSE
        CALC [DMStr2] AS 'keine Angabe'
      END_IF
      IF [DMGridQ!I.CreatorID]>[EPSILON]
        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMStr3', 'DMGridQ!I.CreatorID', [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      ELSE
        CALC [DMStr3] AS 'keine Angabe'
      END_IF
      CALC [DMStr2] AS CON(' = ',[DMStr2],' -> ',[DMStr3])
      CALL CheckChangesLocal 'DMMask!I.CreatorID',          'DMGridQ!I.CreatorID',          TRUE,  [DMStr2]

      CALL CheckChangesLocal 'DMMask!I.NextProcessDate',    'DMGridQ!I.NextProcessDate',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.NextProcessTime',    'DMGridQ!I.NextProcessTime',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.NextProcessRunTime', 'DMGridQ!I.NextProcessRunTime', FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.NextProcessType',    'DMGridQ!I.NextProcessType',    FALSE, ''

      IF [DMMask!I.CreatorID]>[EPSILON]
        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMStr2', 'DMMask!I.NextProcessorID',  [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      ELSE
        CALC [DMStr2] AS 'keine Angabe'
      END_IF
      IF [DMGridQ!I.CreatorID]>[EPSILON]
        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMStr3', 'DMGridQ!I.NextProcessorID', [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      ELSE
        CALC [DMStr3] AS 'keine Angabe'
      END_IF
      CALC [DMStr2] AS CON(' = ',[DMStr2],' -> ',[DMStr3])
      CALL CheckChangesLocal 'DMMask!I.NextProcessorID',    'DMGridQ!I.NextProcessorID',    TRUE,  [DMStr2]

      CALL CheckChangesLocal 'DMMask!I.FinishDate',         'DMGridQ!I.FinishDate',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.FinishTime',         'DMGridQ!I.FinishTime',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.FinishRunTime',      'DMGridQ!I.FinishRunTime',      FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.FinishType',         'DMGridQ!I.FinishType',         FALSE, ''

      IF [DMMask!I.CreatorID]>[EPSILON]
        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMStr2', 'DMMask!I.FinisherID',  [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      ELSE
        CALC [DMStr2] AS 'keine Angabe'
      END_IF
      IF [DMGridQ!I.CreatorID]>[EPSILON]
        CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMStr3', 'DMGridQ!I.FinisherID', [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]
      ELSE
        CALC [DMStr3] AS 'keine Angabe'
      END_IF
      CALC [DMStr2] AS CON(' = ',[DMStr2],' -> ',[DMStr3])
      CALL CheckChangesLocal 'DMMask!I.FinisherID',         'DMGridQ!I.FinisherID',         TRUE,  ''

      CALL CheckChangesLocal 'DMMask!I.ItemNote',           'DMGridQ!I.ItemNote',           FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.ThreadName',         'DMGridQ!I.ThreadName',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.FilePath',           'DMGridQ!I.FilePath',           FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.CategoryID',         'DMGridQ!I.CategoryID',         TRUE,  ''
      CALL CheckChangesLocal 'DMSendConfirm',               'DMGridQ!I.SendConfirm',        FALSE, ''
      CALL CheckChangesLocal 'DMTermin',                    'DMGridQ!I.Termin',             FALSE, ''
      CALL CheckChangesLocal 'DMErledigt',                  'DMGridQ!I.Erledigt',           FALSE, ''

      CALL CheckChangesLocal 'DMMask!I.XRef01ID',           'DMGridQ!I.XRef01ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef02ID',           'DMGridQ!I.XRef02ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef03ID',           'DMGridQ!I.XRef03ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef04ID',           'DMGridQ!I.XRef04ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef05ID',           'DMGridQ!I.XRef05ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef06ID',           'DMGridQ!I.XRef06ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef07ID',           'DMGridQ!I.XRef07ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef08ID',           'DMGridQ!I.XRef08ID',           TRUE,  ''
      CALL CheckChangesLocal 'DMMask!I.XRef09ID',           'DMGridQ!I.XRef09ID',           TRUE,  ''

      CALL CheckChangesLocal 'DMMask!I.XRef01Name',         'DMGridQ!I.XRef01Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef02Name',         'DMGridQ!I.XRef02Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef03Name',         'DMGridQ!I.XRef03Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef04Name',         'DMGridQ!I.XRef04Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef05Name',         'DMGridQ!I.XRef05Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef06Name',         'DMGridQ!I.XRef06Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef07Name',         'DMGridQ!I.XRef07Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef08Name',         'DMGridQ!I.XRef08Name',         FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef09Name',         'DMGridQ!I.XRef09Name',         FALSE, ''

      CALL CheckChangesLocal 'DMMask!I.XRef01TableName',    'DMGridQ!I.XRef01TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef02TableName',    'DMGridQ!I.XRef02TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef03TableName',    'DMGridQ!I.XRef03TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef04TableName',    'DMGridQ!I.XRef04TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef05TableName',    'DMGridQ!I.XRef05TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef06TableName',    'DMGridQ!I.XRef06TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef07TableName',    'DMGridQ!I.XRef07TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef08TableName',    'DMGridQ!I.XRef08TableName',    FALSE, ''
      CALL CheckChangesLocal 'DMMask!I.XRef09TableName',    'DMGridQ!I.XRef09TableName',    FALSE, ''
    END_IF


    IF [DMMask!I.ThreadName]<>''
      IF [DMMask!I.FirstOfThread]
        QUERY [DMWorkQ]
          UPDATE docmgri
             SET FirstOfThread  =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]
           WHERE HeaderID       =  [DMMask!MASK_RECORD_ID|R0,0]
             AND ThreadName     = "[DMMask!I.ThreadName]"
             AND RecordID      <>  [DMActItemID|R0,0]
        END_QUERY

        EXECUTE [DMWorkQ], [DMRes]
        IF [DMRes]=FALSE
          MESSAGE 'Achtung Fehler','Der "Themenstart" konnte nicht sichergestellt werden.',[MESSAGE_ERROR]
        END_IF
      ELSE
        QUERY [DMWorkQ]
          SELECT RecordID
            FROM docmgri
           WHERE HeaderID       =  [DMMask!MASK_RECORD_ID|R0,0]
             AND ThreadName     = "[DMMask!I.ThreadName]"
             AND RecordID      <>  [DMActItemID|R0,0]
             AND FirstOfThread  =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
        END_QUERY

        EXECUTE [DMWorkQ], [DMRes]
        IF [DMRes]
          GET_DATA [DMWorkQ], [DMRes]
          IF [DMRes]=FALSE
            CALC [DMMask!I.FirstOfThread] AS TRUE
            MASK_UPDATE [DMMask]
          END_IF
        ELSE
          MESSAGE 'Achtung Fehler','Die Abfrage zum Ermitteln des "Themenstarts" konnte nicht ausgefhrt werden.',[MESSAGE_ERROR]
        END_IF
      END_IF
    END_IF


    QUERY [DMWorkQ]
      UPDATE docmgri

         SET CreateDate         =  [SQL_DATE_QUOTES_4_MODIFY][DMMask!I.CreateDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             CreateTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMMask!I.CreateTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             CreateRunDate      =  [SQL_DATE_QUOTES_4_MODIFY][DMMask!I.CreateDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             CreateRunTime      =  [SQL_TIME_QUOTES_4_MODIFY][DMMask!I.CreateTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             CreateType         = "[DMMask!I.CreateType]",

             NextProcessDate    =  [SQL_DATE_QUOTES_4_MODIFY][DMMask!I.NextProcessDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             NextProcessTime    =  [SQL_TIME_QUOTES_4_MODIFY][DMMask!I.NextProcessTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             NextProcessRunDate =  [SQL_DATE_QUOTES_4_MODIFY][DMMask!I.NextProcessDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             NextProcessRunTime =  [SQL_TIME_QUOTES_4_MODIFY][DMMask!I.NextProcessRunTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             NextProcessType    = "[DMMask!I.NextProcessType]",

             FinishDate         =  [SQL_DATE_QUOTES_4_MODIFY][DMMask!I.FinishDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             FinishTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMMask!I.FinishTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             FinishRunDate      =  [SQL_DATE_QUOTES_4_MODIFY][DMMask!I.FinishDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             FinishRunTime      =  [SQL_TIME_QUOTES_4_MODIFY][DMMask!I.FinishRunTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             FinishType         = "[DMMask!I.FinishType]",

             ItemNote           = "[DMMask!I.ItemNote]",

             ThreadName         = "[DMMask!I.ThreadName]",
             FirstOfThread      =  [SQL_BOOLEAN_QUOTATION][DMMask!I.FirstOfThread][SQL_BOOLEAN_QUOTATION],
             FilePath           = "[DMStr1]",

             SendConfirm        =  [DMSendConfirm],

             CategoryID         =  [DMMask!I.CategoryID|R0,0],
             CreatorID          =  [DMMask!I.CreatorID|R0,0],
             NextProcessorID    =  [DMMask!I.NextProcessorID|R0,0],
             FinisherID         =  [DMMask!I.FinisherID|R0,0],

             Termin             =  [SQL_BOOLEAN_QUOTATION][DMTermin][SQL_BOOLEAN_QUOTATION],
             erledigt           =  [SQL_BOOLEAN_QUOTATION][DMErledigt][SQL_BOOLEAN_QUOTATION],

             HeaderID           =  [DMMask!MASK_RECORD_ID|R0,0],

             XRef01ID           =  [DMMask!I.XRef01ID|R0,0],
             XRef02ID           =  [DMMask!I.XRef02ID|R0,0],
             XRef03ID           =  [DMMask!I.XRef03ID|R0,0],
             XRef04ID           =  [DMMask!I.XRef04ID|R0,0],
             XRef05ID           =  [DMMask!I.XRef05ID|R0,0],
             XRef06ID           =  [DMMask!I.XRef06ID|R0,0],
             XRef07ID           =  [DMMask!I.XRef07ID|R0,0],
             XRef08ID           =  [DMMask!I.XRef08ID|R0,0],
             XRef09ID           =  [DMMask!I.XRef09ID|R0,0],

             XRef01Name         = "[DMMask!I.XRef01Name]",
             XRef02Name         = "[DMMask!I.XRef02Name]",
             XRef03Name         = "[DMMask!I.XRef03Name]",
             XRef04Name         = "[DMMask!I.XRef04Name]",
             XRef05Name         = "[DMMask!I.XRef05Name]",
             XRef06Name         = "[DMMask!I.XRef06Name]",
             XRef07Name         = "[DMMask!I.XRef07Name]",
             XRef08Name         = "[DMMask!I.XRef08Name]",
             XRef09Name         = "[DMMask!I.XRef09Name]",

             XRef01TableName    = "[DMMask!I.XRef01TableName]",
             XRef02TableName    = "[DMMask!I.XRef02TableName]",
             XRef03TableName    = "[DMMask!I.XRef03TableName]",
             XRef04TableName    = "[DMMask!I.XRef04TableName]",
             XRef05TableName    = "[DMMask!I.XRef05TableName]",
             XRef06TableName    = "[DMMask!I.XRef06TableName]",
             XRef07TableName    = "[DMMask!I.XRef07TableName]",
             XRef08TableName    = "[DMMask!I.XRef08TableName]",
             XRef09TableName    = "[DMMask!I.XRef09TableName]"

       WHERE RecordID           =  [DMActItemID|R0,0]
    END_QUERY

    EXECUTE [DMWorkQ], [DMRes]
    IF [DMRes]=FALSE
      MESSAGE 'Achtung Fehler','Der Ordner-Eintrag konnte nicht gespeichert werden.',[MESSAGE_ERROR]
      IF [DMMNewItem]
        QUERY [DMWorkQ]
          DELETE FROM DocMgrI WHERE RecordID = [DMActItemID|R0,0]
        END_QUERY
        EXECUTE [DMWorkQ],[DMRes]
        CALC [DMActItemID] AS 0.0
      END_IF
      EXIT_PROC
    END_IF

    MEMO_GET   [DMMask], [DMNote], 'I.ItemInfos'
    LIST_ITEM_GET [DMNote],[DMLnCnt],[DMLnMax]
    CALC [DMMax] AS 0
    IF [DMLnMax]>0
      CALC [DMLnCnt] AS 1
      WHILE [DMLnCnt]<=[DMLnMax]
        LIST_STR_GET [DMNote],[DMStr1],[DMLnCnt]
        CALC [DMStr1] AS TRIM([DMStr1])
        IF [DMStr1]<>''
          INC [DMMax]
        END_IF
        INC [DMLnCnt]
      END_WHILE
    END_IF

    IF [DMMax]=0
      CALL DocMgrMainDelNotes 'docmgri', [DMActItemID], 1
    ELSE
      NOTE_WRITE [DMNote], [DMRes],  'docmgri', 1, [DMActItemID]
    END_IF
  END_PROC



  PROCEDURE DocMgrMainForceDir VS DMMFD.Dir
    EXIST_DIR [DMMFD.Dir],[DMRes]
    IF [DMRes]=FALSE
      FORCE_DIR [DMRes],[DMMFD.Dir]
      IF [DMRes]=FALSE
        CALC [DMMFD.Dir] AS CON('Folgendes Verzeichnis kann nicht angelegt werden|',[DMMFD.Dir])
        MESSAGE 'Achtung Fehler!',[DMMFD.Dir],[MESSAGE_ERROR]
      END_IF
    END_IF
  END_PROC



  PROCEDURE DocMgrMainPreSaveHook
    CALC [DMStr1] AS TRIM([DMMask!FolderName])
    CALC [DMMax]  AS  LEN([DMStr1])
    IF [DMMax]<5
      MESSAGE 'Achtung Abbruch','Bitte geben Sie einen aussagekrftigen Ordner-Namen ein',[MESSAGE_WARNING]
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    CALL DocMgrFixPath [DMStr1], [DM_REMOVE_PATH_DUMMY], [DMStr1]
    CALL DocMgrMainForceDir [DMStr1]
    IF [DMRes]=FALSE
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    CALC [DMDir] AS [DMMask!FolderName]

    IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
      CALC [DMStr1] AS DBL_BACK_SLASH([DMMask!FolderName])
    ELSE
      CALC [DMStr1] AS SGL_BACK_SLASH([DMMask!FolderName])
    END_IF

    CALC [DMMask!FolderName] AS [DMStr1]

    MASK_UPDATE [DMMask]
  END_PROC



  PROCEDURE DocMgrUpload
    IF [DMMask!I.FilePath]<>''
      CALC [DMFloat1] AS ABS([DMMask!I.CategoryID]-[DM_WEBPIC_CATEGORY])
      IF [DMFloat1]<=[EPSILON]
        CALC [DMNum1] AS 0
        CALC [DMStr1] AS COPY([DMMask!I.ItemNote],1,2)
        CALC [DMNum1] AS  VAL([DMStr1])
        IF [DM_SSH_UPLOAD]
          SCRIPT 'SSHUpload.csh', [DMMask!I.FilePath], 0, [DMRelRecID], [DMNum1]
        ELSE_IF [DM_FTP_UPLOAD]
          SCRIPT 'FTPUpload.csh', [DMMask!I.FilePath], 0, [DMRelRecID], [DMNum1]
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE DocMgrMainPostSaveHook
    IF [DMMask!MASK_RECORD_ID]<=[EPSILON]
      EXIT_PROC
    END_IF

    CALC [DMHeaderID]   AS [DMMask!MASK_RECORD_ID]
    CALC [DMHeaderFlag] AS [DMMask!MASK_RECORD_FLAG]

    CALL DocMgrMainSaveItem

    CALC [DMStr1] AS SGL_BACK_SLASH([DMMask!FolderName])
    CALC [DMMask!FolderName] AS [DMStr1]

    MASK_UPDATE [DMMask], TRUE

    FIELD_FLAG_ON_OFF [DMMask], 'FolderName', '[FIELD_FLAG_PROTECTED]'
    FIELD_FLAG_ON_OFF [DMMask], 'BB_FOLDER',  '[FIELD_FLAG_PROTECTED]'
    FIELD_FLAG_ON_OFF [DMMask], 'FileName',   '[FIELD_FLAG_PROTECTED]'

    IF [DMActItemID]>[EPSILON]
      IF [DMMNewItem]
        CALC [DMFilter4Folder]   AS ''

        IF [DMTicket]=FALSE
          CALC [DMFilter4Thread]   AS ''
          CALC [DMFilter4Category] AS ''
        END_IF

        CALL DocMgrMainSetGrid
      ELSE
        CALC [DMStr1] AS CON('STARTING WITH I.RecordID = ',[DMActItemID|R0,0])
        QUERY_REFRESH [DMGridQ], FALSE, [DMStr1]
      END_IF
      NOTE_READ [DMNote], [DMRes],  'docmgri',    1, [DMActItemID]
      MEMO_SET  [DMMask], [DMNote], 'I.ItemInfos'

      MASK_UPDATE [DMMask], TRUE

      CALL DocMgrUpload
    END_IF
  END_PROC



  PROCEDURE SetTicketModeOn
    IF [DMTicket]
      IF [DM_TICKET_CATEGORY]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte legen Sie die Ticketkategorie an.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      IF [DMCategoryName]=''
        QUERY [DMWorkQ]
          SELECT Ziffer, Bezeichnung
            FROM docmgrca
           WHERE RecordID = [DM_TICKET_CATEGORY|R0,0]
        END_QUERY

        EXECUTE [DMWorkQ], [DMRes]
        IF [DMRes]=FALSE
          MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden der Ticketkategorie konnte nicht ausgefhrt werden.',[MESSAGE_WARNING]
          EXIT_PROC
        END_IF

        GET_DATA [DMWorkQ], [DMRes]
        IF [DMRes]=FALSE
          MESSAGE 'Achtung Abbruch','Die Ticketkategorie konnte nicht gefunden werden.',[MESSAGE_WARNING]
          EXIT_PROC
        END_IF

        CALC [DMCategoryName] AS CON([DMWorkQ!Ziffer],'.',[DMWorkQ!Bezeichnung])
      END_IF

      CALC [DMMask!I.CategoryID] AS [DM_TICKET_CATEGORY]
      CALC [DMMask!CategoryName] AS [DMCategoryName]
      CALC [DMMask!CB_Ticket]    AS TRUE

      CALC [DMFilter4Category] AS CON('AND I.CategoryID = ',[DM_TICKET_CATEGORY|R0,0],' AND I.FirstOfThread = ',[SQL_BOOLEAN_QUOTATION],[SQL_BOOLEAN_TRUE],[SQL_BOOLEAN_QUOTATION])
    END_IF
  END_PROC



  PROCEDURE DocMgrMainSetWorkModeDetails
    IF [DMWorkMode]=[DM_WORK_MODE_DOC_MANAGER]
      FIELD_FLAG_ON_OFF [DMMask],'GB_DragDrop',       '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'BB_GROUP',          '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'BB_PREVIEW',        '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'BB_TICKET',         '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'CB_GROUP',          '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'CB_PREVIEW',        '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'CB_TICKET',         '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'LB_TICKET_OPEN',    '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'ShowTicketsOpen',   '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'LB_TICKET_CLOSED',  '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'ShowTicketsClosed', '[FIELD_FLAG_HIDDEN]',''
    ELSE_IF [DMWorkMode]=[DM_WORK_MODE_DASHBOARD_TICKET]
      FIELD_FLAG_ON_OFF [DMMask],'GB_DragDrop',       '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'BB_GROUP',          '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'BB_PREVIEW',        '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'BB_TICKET',         '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'CB_GROUP',          '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'CB_PREVIEW',        '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'CB_TICKET',         '[FIELD_FLAG_HIDDEN]',''
      FIELD_FLAG_ON_OFF [DMMask],'LB_TICKET_OPEN',    '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'ShowTicketsOpen',   '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'LB_TICKET_CLOSED',  '','[FIELD_FLAG_HIDDEN]'
      FIELD_FLAG_ON_OFF [DMMask],'ShowTicketsClosed', '','[FIELD_FLAG_HIDDEN]'
    END_IF
  END_PROC



  PROCEDURE DocMgrMainPostClearHook
    CALL DocMgrMainSetWorkModeDetails

    CALC [DMMask!MASK_RECORD_ID]   AS [DMHeaderID]
    CALC [DMMask!MASK_RECORD_FLAG] AS [DMHeaderFlag]

    IF [DMTicket]
      IF [DMFilter4Thread]=''
        CALC [DMMask!I.ThreadName] AS ''
      END_IF
    ELSE
      CALC [DMMask!I.ThreadName] AS ''
      CALC [DMMask!CategoryName] AS ''
      CALC [DMMask!I.CategoryID] AS 0.0
    END_IF

    CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter', '', 'DMMask!Creator', 'DMMask!I.CreatorID', [DM_MASK_UPDATE_YES], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]

    CALC [DMActItemID] AS 0.0

    FIELD_FLAG_ON_OFF [DMMask],'I.ItemNote','[FIELD_FLAG_ACTUAL]',''

    CALC [DMRes] AS FALSE
    IF [DMFilter4Folder]<>''
      CALC [DMFilter4Folder]   AS ''
      CALC [DMRes]             AS TRUE
    END_IF

    CALC [DMLnCnt] AS [DMRelMax]+1
    WHILE [DMLnCnt]<=9
      CALC [DMStr1] AS CON('LB_REL_',[DMLnCnt])
      FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

      CALC [DMStr1] AS CON('InfRel',[DMLnCnt])
      FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

      CALC [DMStr1] AS CON('BB_REL_CHOOSE_',[DMLnCnt])
      FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

      CALC [DMStr1] AS CON('BB_REL_JUMP_',[DMLnCnt])
      FIELD_FLAG_ON_OFF [DMMask],[DMStr1],'[FIELD_FLAG_HIDDEN]'

      INC  [DMLnCnt]
    END_WHILE

    IF [DMTicket]
      IF [DMWorkMode]=[DM_WORK_MODE_DASHBOARD_TICKET]
        CALC [DMMask!MASK_RECORD_ID]   AS 0.0
        CALC [DMMask!MASK_RECORD_FLAG] AS 0
        CALC [DMMask!I.ThreadName]     AS ''
        CALC [DMHeaderID]              AS 0.0
        CALC [DMHeaderFlag]            AS 0
        CALC [DMActItemID]             AS 0.0
        CALC [DMFilter4Thread]         AS ''
        MASK_UPDATE [DMMask]

        CALL SetTicketModeOn

        CALC [DMRes] AS TRUE
      END_IF
    ELSE
      IF [DMFilter4Thread]<>''
        CALC [DMFilter4Thread]   AS ''
        CALC [DMRes]             AS TRUE
      END_IF
      IF [DMFilter4Category]<>''
        CALC [DMFilter4Category] AS ''
        CALC [DMRes]             AS TRUE
      END_IF
    END_IF

    IF [DMRes]
      CALL DocMgrMainSetGrid
    END_IF
  END_PROC



  PROCEDURE DocMgrMainDeleteHook
    IF [DMMask!MASK_RECORD_ID]<=[EPSILON]
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    CALC [DMYNRes] AS [ID_NO]
    QUERY_COUNT [DMGridQ],[DMMax]

    IF [DMActItemID]<=[EPSILON]
      IF [DMMax]>0
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie bitte zunchste einen Ordner-Eintrag aus',[MESSAGE_WARNING]
        CALC [DMMask!MASK_ACTION] AS 1
        EXIT_PROC
      ELSE
        GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie diesen leeren Ordner wirklich lschen?',[DMYNRes]
      END_IF
    ELSE
      GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie den aktuellen Eintrag wirklich lschen?',[DMYNRes]
    END_IF

    IF [DMYNRes]<>[ID_YES]
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    IF [DMMax]=0
      CALL DocMgrMainDelNotes 'docmgrh', [DMMask!MASK_RECORD_ID], 0

      QUERY [DMWorkQ]
        DELETE
          FROM docmgrh
         WHERE RecordID = [DMMask!MASK_RECORD_ID|R0,0]
      END_QUERY
      EXECUTE [DMWorkQ], [DMRes]

      CALC [DMMask!MASK_ACTION] AS 1

      IF [DMRes]
        MASK_COMMAND [DMMask],[MASK_COMMAND_EXIT]
        CALC [DMMask!MASK_ACTION] AS 1
      ELSE
        MESSAGE 'Achtung Fehler','Der Ordner konnte nicht gelscht werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    ELSE
      CALL DocMgrMainDelNotes 'docmgri', [DMActItemID], 0

      QUERY [DMWorkQ]
        DELETE
          FROM docmgri
         WHERE RecordID = [DMActItemID|R0,0]
      END_QUERY
      EXECUTE [DMWorkQ], [DMRes]

      CALC [DMMask!MASK_ACTION] AS 1

      IF [DMRes]=FALSE
        MESSAGE 'Achtung Fehler','Der Ordner konnte nicht gelscht werden',[MESSAGE_ERROR]
      END_IF

      QUERY_REFRESH [DMGridQ], FALSE, ''
    END_IF

    CALC [DMMask!MASK_ACTION] AS 1
  END_PROC


  PROCEDURE DocMgrMainChooseGroup VB DMMCG.StartUp
    IF [DMRelRecID]<=[EPSILON]
      EXIT_PROC
    END_IF

    SCRIPT 'DocMgrMainChooser.csh', [DMRelRecID], [DMTableName]

    IF [DOCU_MGR_SCRIPT_RESULT_STR]<>''
      CALC [DMStr1]   AS PART([DOCU_MGR_SCRIPT_RESULT_STR],1,'|')
      CALC [DMStr2]   AS PART([DOCU_MGR_SCRIPT_RESULT_STR],2,'|')
      CALC [DMFloat1] AS  VAL([DMStr2])
      IF [DMFloat1]<=[EPSILON]
        EXIT_PROC
      END_IF
      MASK_COMMAND [DMMask],[MASK_COMMAND_CLEAR]
      CALC [DMMask!MASK_RECORD_ID] AS [DMFloat1]
      MASK_UPDATE  [DMMask]
      MASK_COMMAND [DMMask],[MASK_COMMAND_SEARCH]

      CALC [DMHeaderID]        AS [DMMask!MASK_RECORD_ID]
      CALC [DMHeaderFlag]      AS [DMMask!MASK_RECORD_FLAG]

      CALC [DMFilter4Folder]   AS ''
      CALC [DMFilter4Thread]   AS ''
      CALC [DMFilter4Category] AS ''

      IF [DMStr1]='H'
        ; do nothing - but the grid will be reset below
      ELSE_IF [DMStr1]='C'
        CALC [DMStr2] AS PART([DOCU_MGR_SCRIPT_RESULT_STR],3,'|')
        CALC [DMFilter4Category] AS CON('AND I.CategoryID = ',[DMStr2])
      ELSE_IF [DMStr1]='F'
        CALC [DMStr2] AS PART([DOCU_MGR_SCRIPT_RESULT_STR],3,'|')

        IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
          ; What the hack?! After trying arround I found that out. Please don't ask, just take it as it is!
          CALC [DMStr2] AS REPLACE([DMStr2],'\','\\\\')
;         CALC [DMStr2] AS DBL_BACK_SLASH([DMStr2])
        ELSE
          CALC [DMStr2] AS SGL_BACK_SLASH([DMStr2])
        END_IF

        CALC [DMFilter4Folder] AS CON('AND I.FilePath LIKE "',[DMStr2],[SQL_WILD_CARD_MULTI],'"')
      ELSE_IF [DMStr1]='T'
        CALC [DMStr2] AS PART([DOCU_MGR_SCRIPT_RESULT_STR],3,'|')
        CALC [DMFilter4Thread] AS CON('AND I.ThreadName = "',[DMStr2],'"')
      ELSE
        EXIT_PROC
      END_IF

      IF [DMMCG.StartUp]=FALSE
        CALL DocMgrMainSetGrid
      END_IF
    END_IF
  END_PROC



  PROCEDURE DocMgrMainSendMail VF LocReceiverID
    ; Achtung: Das hier kann man generisch auch korrekt ber die TableFld-Tabelle laufen lassen. Siehe "DocMgrUtilLoadRelationByTableFld"
    ;          Ich mache das hier "auf die Scnelle" passend fr die CSH

    LOCAL_STR LocReceiverMail
    LOCAL_STR LocReceiverName

    LOCAL_STR LocSenderMail
    LOCAL_STR LocSenderName

    LOCAL_STR LocStr

    QUERY [DMWorkQ]
      SELECT Email1, Name1
        FROM adressen
       WHERE RecordID = [ACT_MIT_ID|R0,0]
    END_QUERY
    EXECUTE [DMWorkQ],[DMRes]
    IF [DMRes]
      GET_DATA [DMWorkQ],[DMRes]
      IF [DMRes]
        IF [DMWorkQ!Email1]<>''
          CALC [LocSenderMail] AS [DMWorkQ!Email1]
          CALC [LocSenderName] AS [DMWorkQ!Name1]
        END_IF
      END_IF
    END_IF

    QUERY [DMWorkQ]
      SELECT Email1, Name1
        FROM adressen
       WHERE RecordID = [LocReceiverID|R0,0]
    END_QUERY
    EXECUTE [DMWorkQ],[DMRes]
    IF [DMRes]
      GET_DATA [DMWorkQ],[DMRes]
      IF [DMRes]
        IF [DMWorkQ!Email1]<>''
          CALC [LocReceiverMail] AS [DMWorkQ!Email1]
          CALC [LocReceiverName] AS [DMWorkQ!Name1]
        END_IF
      END_IF
    END_IF

    LIST_CLR [GlobSelectionList]

    CALC [LocStr] AS CON('Ticketinformation zu ',[DMHeader])
    LIST_APPEND [GlobSelectionList], [LocStr]

    LIST_APPEND [GlobSelectionList], ''

    IF [DMMask!I.ThreadName]<>''
      CALC [LocStr] AS CON('Thema "',[DMMask!I.ThreadName],'"')
      LIST_APPEND [GlobSelectionList], [LocStr]
      LIST_APPEND [GlobSelectionList], ''
    END_IF

    IF [DMMask!CategoryName]<>''
      CALC [LocStr] AS CON('Kategorie "',[DMMask!CategoryName],'"')
      LIST_APPEND [GlobSelectionList], [LocStr]
      LIST_APPEND [GlobSelectionList], ''
    END_IF

    IF [DMMask!Creator]<>''
      CALC [LocStr] AS CON('Angelegt von "',[DMMask!Creator],'" um ',[DMMask!I.CreateTime],' am ',[DMMask!I.CreateDate])
      LIST_APPEND [GlobSelectionList], [LocStr]
    END_IF

    IF [DMMask!NextProcessor]<>''
      CALC [LocStr] AS CON('Wiedervorlage bei "',[DMMask!NextProcessor],'" um ',[DMMask!I.NextProcessTime],' am ',[DMMask!I.NextProcessDate])
      LIST_APPEND [GlobSelectionList], [LocStr]
    END_IF

    IF [DMMask!Finisher]<>''
      CALC [LocStr] AS CON('Erledigt von "',[DMMask!Finisher],'" um ',[DMMask!I.FinishTime],' am ',[DMMask!I.FinishDate])
      LIST_APPEND [GlobSelectionList], [LocStr]
    END_IF

    LIST_APPEND [GlobSelectionList], ''

    IF [DMMask!I.ItemNote]<>''
      CALC [LocStr] AS CON('Info "',[DMMask!I.ItemNote],'"')
      LIST_APPEND [GlobSelectionList], [LocStr]
    END_IF

    IF [DMMask!I.FilePath]<>''
      CALC [LocStr] AS CON('Anhang "',[DMMask!I.FilePath],'"')
      LIST_APPEND [GlobSelectionList], [LocStr]
    END_IF

    LIST_APPEND [GlobSelectionList], ''
    LIST_APPEND [GlobSelectionList], ''


    SEND_MAIL [DMRes], [GlobSelectionList], 'Ticketinformation', [LocSenderName], [LocSenderMail], [LocReceiverName], [LocReceiverMail], '', '', TRUE, TRUE

    ; AdressenID                                      [RECORD_ID1]  MUSS
    ; Betreff                                         [PAR_STR2]    MUSS
    ; Dateiname Anhang                                [PAR_STR3]    KANN LEER SEIN !!
    ; Variablenname einer GLOBALEN Variable Emailtext [PAR_STR4]    MUSS
    ; From-Adresse zwecks Antwort                     [PAR_STR5]    kann
;   SCRIPT 'DirectCaraSmtp.csh', [LocReceiverID], 'Ticketinformation', '', 'GlobSelectionList', [LocSenderMail]
  END_PROC



  PROCEDURE DocMgrMainButtonHook
    IF [DMMask!MASK_ACT_FIELD_NAME]='BB_CATEGORY'
      CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS [DMMask!I.CategoryID|R0,0]

      SCRIPT 'DocMgrCA.CSH'
      IF [DOCU_MGR_SCRIPT_RESULT_STR]<>''
        CALC [DMStr1] AS PART([DOCU_MGR_SCRIPT_RESULT_STR],1,'|')
        CALC [DMMask!I.CategoryID] AS VAL([DMStr1])
        CALC [DMStr1] AS PART([DOCU_MGR_SCRIPT_RESULT_STR],2,'|')
        CALC [DMStr1] AS REPLACE([DMStr1],', ','.')
        CALC [DMMask!CategoryName] AS [DMStr1]
      ELSE
        IF [DMMask!I.CategoryID]>[EPSILON]
          CALC [DMYNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die bestehende Zuordnung nun aufheben?',[DMYNRes]
          IF [DMYNRes]<>[ID_YES]
            EXIT_PROC
          END_IF
        END_IF

        CALC [DMMask!I.CategoryID] AS 0.0
        CALC [DMMask!CategoryName] AS ''
      END_IF

      MASK_UPDATE  [DMMask]


    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_FINISHER'
      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter',  '', 'DMMask!Finisher',      'DMMask!I.FinisherID',      [DM_MASK_UPDATE_YES],  [DM_VIEW_LIST_YES], [DM_CHECK_POSSIBLE_ERRORS_NO]
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_NEXTPROCESSOR'
      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter',  '', 'DMMask!NextProcessor', 'DMMask!I.NextProcessorID', [DM_MASK_UPDATE_YES],  [DM_VIEW_LIST_YES], [DM_CHECK_POSSIBLE_ERRORS_NO]
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_CREATOR'
      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter',  '', 'DMMask!Creator',       'DMMask!I.CreatorID',       [DM_MASK_UPDATE_YES],  [DM_VIEW_LIST_YES], [DM_CHECK_POSSIBLE_ERRORS_NO]

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_FINISHER_MAIL'
      IF [DMMask!I.FinisherID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst eine Person aus, die den Termin erledigt hat.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF
      CALL DocMgrMainSendMail [DMMask!I.FinisherID]
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_NEXTPROCESSOR_MAIL'
      IF [DMMask!I.NextProcessorID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst eine Person aus, fr die der Termin ist.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF
      CALL DocMgrMainSendMail [DMMask!I.NextProcessorID]
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_CREATOR_MAIL'
      IF [DMMask!I.CreatorID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst eine Person aus, die den Datensatz angelegt hat.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF
      CALL DocMgrMainSendMail [DMMask!I.CreatorID]

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_CREATE_TYPE'
      CALL ChoicerGet TRUE, 'DMMask', 'I.CreateType',      '', 999901, 'Auswahl', 'Auswahl', 20, 'Anlage-Arten',      'Anlage-Arten',      [DMRes]
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_NEXTPROCESS_TYPE'
      CALL ChoicerGet TRUE, 'DMMask', 'I.NextProcessType', '', 999902, 'Auswahl', 'Auswahl', 20, 'Termin-Arten',      'Termin-Arten',      [DMRes]
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_FINISH_TYPE'
      CALL ChoicerGet TRUE, 'DMMask', 'I.FinishType',      '', 999903, 'Auswahl', 'Auswahl', 20, 'Erledigungs-Arten', 'Erledigungs-Arten', [DMRes]


    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_FILE'
      IF [DMMask!I.FilePath]<>''
        CALL DocMgrFixPath [DMMask!I.FilePath], [DM_REMOVE_PATH_DUMMY], [DMStr1]
        FILE_PATH  [DMStr1], [DMStr1]
        FILE_SLASH [DMStr1], TRUE
      ELSE
        CALC [DMStr1] AS [DOCUMENT_PATH]
      END_IF

      CALC [DMStr2] AS '*.*'
      CHOOSE_FILE [DMStr2],[CHOOSE_FILE_4_OPEN],'Bitte geben Sie den Dateinamen an.','Dateien (*.*)|*.*',[DMRes],[DMStr1]
      IF [DMRes]
        CALL DocMgrFixPath [DMStr2], [DM_INSERT_PATH_DUMMY], [DMStr2]
        CALC [DMMask!I.FilePath] AS [DMStr2]
        MASK_UPDATE [DMMask]
      ELSE
        IF [DMMask!I.FilePath]<>''
          CALC [DMYNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die bestehende Datei-Zuordnung aufheben?',[DMYNRes]
          IF [DMYNRes]=[ID_YES]
            CALC [DMMask!I.FilePath] AS ''
            MASK_UPDATE [DMMask]
          END_IF
        END_IF

        EXIT_PROC
      END_IF

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_THREAD'
      IF [DMMask!MASK_RECORD_ID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst einen Dokumenten-Ordner aus.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      CALC [DMStr1] AS ''
      IF [DMMask!I.ThreadName]<>''
        CALC [DMStr1] AS CON('STARTING WITH DISTINCTI.ThreadName = "',[DMMask!I.ThreadName],'"')
      END_IF

      QUERY [DMViewer]
          SELECT [W40 N"Thema"]DISTINCT I.ThreadName

            FROM DocMgrI I

           WHERE I.HeaderID    = [DMMask!MASK_RECORD_ID|R0,0]
             AND I.HeaderID    > 1000
             AND I.ThreadName <> ""

        ORDER BY I.ThreadName

                 [DMStr1]
      END_QUERY

      EXECUTE [DMViewer], [DMRes]
      IF [DMRes]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden der Themen dieses Ordners, konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      QUERY_COUNT [DMViewer],[DMMax]
      IF [DMMax]=0
        MESSAGE 'In diesem Ordner sind keine Themen vorhanden.','Sie knnen einfach ein Thema vergeben.'
        EXIT_PROC
      END_IF

      CALC [DMViewer!QUERY_ID] AS 'DocMgrMainThemen001'
      VIEW [DMViewer],[DMRes],'Themen dieses Ordners','',FALSE,TRUE
      CALC [DMViewer!QUERY_ID] AS ''
      IF [DMRes]
        CALC [DMMask!I.ThreadName] AS [DMViewer!DISTINCTI.ThreadName]
        MASK_UPDATE [DMMask]
      ELSE_IF [DMMask!I.ThreadName]<>''
        CALC [DMYNRes] AS [ID_NO]
        GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die bestehende Themen-Zuordnung aufheben?',[DMYNRes]
        IF [DMYNRes]=[ID_YES]
          CALC [DMMask!I.ThreadName] AS ''
          MASK_UPDATE [DMMask]
        END_IF
      END_IF


    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_THREAD_FILTER'
      IF [DMFilter4Thread]<>''
        CALC [DMFilter4Thread] AS ''
      ELSE
        CALC [DMFilter4Thread] AS CON('AND I.ThreadName = "',[DMMask!I.ThreadName],'"')
      END_IF

      CALL DocMgrMainSetGrid

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_CATEGORY_FILTER'
      IF [DMFilter4Category]<>''
        CALC [DMFilter4Category] AS ''
      ELSE
        CALC [DMFilter4Category] AS CON('AND I.CategoryID = ',[DMMask!I.CategoryID])
      END_IF

      CALL DocMgrMainSetGrid

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_TICKET'
      IF [DMTicket]
        CALC [DMTicket] AS FALSE
      ELSE
        CALC [DMTicket] AS TRUE
      END_IF

      IF [DMTicket]
        CALL SetTicketModeOn
      ELSE
        CALC [DMMask!CB_Ticket]  AS FALSE
        CALC [DMFilter4Category] AS ''
      END_IF

      MASK_UPDATE [DMMask]

      CALC [DMFilter4Thread] AS ''

      CALL DocMgrMainSetGrid

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_FINISH_NOW'
      IF [DMMask!I.NextProcessDate]<='01.01.1980'
        MESSAGE 'Achtung Abbruch','Dieser Eintrag hat keinen Wiedervorlage-Termin.|Er kann nicht "erledigt" werden.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      IF [DMMask!I.FinishDate]>'01.01.1980'
        MESSAGE 'Achtung Abbruch','Dieser Eintrag wurde bereits als "erledigt" gekennzeichnet.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      CALC [DMMask!I.FinishDate] AS [DATE]
      CALC [DMMask!I.FinishTime] AS [TIME]
      CALC [DMMask!I.FinisherID] AS [ACT_MIT_ID]
      MASK_UPDATE [DMMask]

      CALL DocMgrUtilLoadRelationByTableFld 'Mitarbeiter',  '', 'DMMask!Creator',       'DMMask!I.CreatorID',       [DM_MASK_UPDATE_YES],  [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_GROUP'
      IF [DMRelRecID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Der Dokumenten-Ordner hat keinen konkreten Bezug.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      CALL DocMgrMainChooseGroup FALSE
      IF [DMPreViewIsOn]
        FIELD_FLAG_ON_OFF [DMMask],'PL_PREVIEW','','[FIELD_FLAG_HIDDEN]'
        CALL DocMgrShowPreview
      END_IF
    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_PREVIEW'
      IF [DMPreViewIsOn]
        CALC [DMPreViewIsOn] AS FALSE
      ELSE
        CALC [DMPreViewIsOn] AS TRUE
      END_IF

      IF [DMPreViewIsOn]
        FIELD_FLAG_ON_OFF [DMMask],'PL_PREVIEW','','[FIELD_FLAG_HIDDEN]'
        CALL DocMgrShowPreview
      ELSE
        FIELD_FLAG_ON_OFF [DMMask],'PL_PREVIEW','[FIELD_FLAG_HIDDEN]',''
      END_IF

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_NAME'
      CALC [DMMask!FileName] AS 'Allgemein'
      MASK_UPDATE [DMMask]
      FIELD_FLAG_ON_OFF [DMMask],'FileName','[FIELD_FLAG_ACTUAL]','[FIELD_FLAG_PROTECTED]'

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]>>'BB_REL_CHOOSE_*'
      CALC [DMStr1]  AS PART([DMMask!MASK_ACT_FIELD_NAME],2,'BB_REL_CHOOSE_')
      CALC [DMLnCnt] AS VAL([DMStr1])

      IF [DMRelName[DMLnCnt]]=''
        EXIT_PROC
      END_IF

      QUERY [DMWorkQ]
        SELECT RecordID,   TableName,
               FieldName1, FieldName2,
               FieldName3, FieldName4,
               FieldName5, FieldName6
          FROM tablefld
         WHERE XRefName = "[DMRelName[DMLnCnt]]"
      END_QUERY
      EXECUTE [DMWorkQ],[DMRes]
      IF [DMRes]=FALSE
        EXIT_PROC
      END_IF
      GET_DATA [DMWorkQ],[DMRes]
      IF [DMRes]=FALSE
        EXIT_PROC
      END_IF

      LIST_CLR  [DMNote]
      NOTE_READ [DMNote],[DMRes],'tablefld',1,[DMWorkQ!RecordID]

      CALC [DMStr2] AS   COPY([DMWorkQ!TableName],1,1)
      CALC [DMStr2] AS UPCASE([DMStr2])

      QUERY [DMViewer]
      END_QUERY
      LIST_2_QUERY [DMNote], [DMViewer]

      IF [DMMask!I.XRef0[DMLnCnt]ID]>[EPSILON]
        CALC [DMStr3] AS CON('STARTING WITH ',[DMStr2],'.RecordID = ',[DMMask!I.XRef0[DMLnCnt]ID|R0,0])
        QUERY_ADD_STRING [DMViewer],[DMStr3]
      END_IF

      CALC [DMViewer!QUERY_ID] AS CON('DocMgrRel',[DMLnCnt])
      VIEW [DMViewer],[DMRes],[DMRelHint[DMLnCnt]]
      CALC [DMViewer!QUERY_ID] AS ''
      IF [DMRes]
        CALC [DMMask!I.XRef0[DMLnCnt]ID]        AS [DMViewer![DMViewer!QUERY_DESCR_REC_ID]]
        CALC [DMMask!I.XRef0[DMLnCnt]Name]      AS [DMRelName[DMLnCnt]]
        CALC [DMMask!I.XRef0[DMLnCnt]TableName] AS [DMRelTable[DMLnCnt]]

        IF [DMWorkQ!FieldName1]<>''
          CALC [DMMask!InfRel[DMLnCnt]] AS [DMViewer![DMWorkQ!FieldName1]]
        END_IF
        IF [DMWorkQ!FieldName2]<>''
          IF [DMMask!InfRel[DMLnCnt]]<>''
            CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],', ')
          END_IF
          CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],[DMViewer![DMWorkQ!FieldName2]])
        END_IF
        IF [DMWorkQ!FieldName3]<>''
          IF [DMMask!InfRel[DMLnCnt]]<>''
            CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],', ')
          END_IF
          CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],[DMViewer![DMWorkQ!FieldName3]])
        END_IF
        IF [DMWorkQ!FieldName4]<>''
          IF [DMMask!InfRel[DMLnCnt]]<>''
            CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],', ')
          END_IF
          CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],[DMViewer![DMWorkQ!FieldName4]])
        END_IF
        IF [DMWorkQ!FieldName5]<>''
          IF [DMMask!InfRel[DMLnCnt]]<>''
            CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],', ')
          END_IF
          CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],[DMViewer![DMWorkQ!FieldName5]])
        END_IF
        IF [DMWorkQ!FieldName6]<>''
          IF [DMMask!InfRel[DMLnCnt]]<>''
            CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],', ')
          END_IF
          CALC [DMMask!InfRel[DMLnCnt]] AS CON([DMMask!InfRel[DMLnCnt]],[DMViewer![DMWorkQ!FieldName6]])
        END_IF
        MASK_UPDATE [DMMask]
      ELSE
        IF [DMMask!I.XRef0[DMLnCnt]ID]>[EPSILON]
          CALC [DMYNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die bestehende Relation wieder zurcksetzten?',[DMYNRes]
          IF [DMYNRes]=[ID_YES]
            CALC [DMMask!I.XRef0[DMLnCnt]ID]        AS 0.0
            CALC [DMMask!InfRel[DMLnCnt]]           AS ''
            CALC [DMMask!I.XRef0[DMLnCnt]Name]      AS ''
            CALC [DMMask!I.XRef0[DMLnCnt]TableName] AS ''
            MASK_UPDATE [DMMask]
          END_IF
        END_IF
      END_IF

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]='BB_FILE_UPLOAD'
      CALL DocMgrUpload

    ELSE_IF [DMMask!MASK_ACT_FIELD_NAME]>>'BB_REL_JUMP_*'
      CALC [DMStr1]  AS PART([DMMask!MASK_ACT_FIELD_NAME],2,'BB_REL_JUMP_')
      CALC [DMLnCnt] AS VAL([DMStr1])

      IF [DMRelName[DMLnCnt]]=''
        EXIT_PROC
      END_IF

      IF [DMMask!I.XRef0[DMLnCnt]ID]<=[EPSILON]
        EXIT_PROC
      END_IF

      QUERY [DMWorkQ]
        SELECT ExecScript
          FROM tablefld
         WHERE XRefName = "[DMRelName[DMLnCnt]]"
      END_QUERY
      EXECUTE [DMWorkQ],[DMRes]
      IF [DMRes]=FALSE
        EXIT_PROC
      END_IF
      GET_DATA [DMWorkQ],[DMRes]
      IF [DMRes]=FALSE
        EXIT_PROC
      END_IF
      IF [DMWorkQ!ExecScript]=''
        EXIT_PROC
      END_IF

      SCRIPT [DMWorkQ!ExecScript], [DMMask!I.XRef0[DMLnCnt]ID]
    END_IF
  END_PROC



  PROCEDURE DocMgrMainCreateItem4File VS DMMCI4F.FName
    LOCAL_STR  DMMCI4F.FSave
    LOCAL_TIME DMMCI4F.ATime

    NEW_RECORD [DMRes],'docmgri',[DMActItemID], TRUE, FALSE, FALSE
    IF [DMRes]=FALSE
      MESSAGE 'Achtung Fehler','Es konnte kein neuer Datensatz in der Tabelle "docmgri" erzeugt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
      CALC [DMMCI4F.FSave] AS DBL_BACK_SLASH([DMMCI4F.FName])
    ELSE
      CALC [DMMCI4F.FSave] AS SGL_BACK_SLASH([DMMCI4F.FName])
    END_IF

    FILE_NAME [DMMCI4F.FName],[DMMCI4F.FName]

    QUERY [DMWorkQ]
      UPDATE docmgri

         SET CreateDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             CreateTime         =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             CreateRunDate      =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             CreateRunTime      =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],

             NextProcessDate    =  [DEFAULT_DATE_4_MODIFY],
             NextProcessTime    =  [SQL_TIME_QUOTES_4_MODIFY][DMMCI4F.ATime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             NextProcessRunDate =  [DEFAULT_DATE_4_MODIFY],
             NextProcessRunTime =  [SQL_TIME_QUOTES_4_MODIFY][DMMCI4F.ATime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],

             FinishDate         =  [DEFAULT_DATE_4_MODIFY],
             FinishTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMMCI4F.ATime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
             FinishRunDate      =  [DEFAULT_DATE_4_MODIFY],
             FinishRunTime      =  [SQL_TIME_QUOTES_4_MODIFY][DMMCI4F.ATime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],

             ItemNote           = "[DMMCI4F.FName]",
             ThreadName         = "[DMMask!I.ThreadName]",
             FilePath           = "[DMMCI4F.FSave]",

             CategoryID         =  [DMMask!I.CategoryID|R0,0],
             CreatorID          =  [ACT_MIT_ID|R0,0],

             HeaderID           =  [DMMask!MASK_RECORD_ID|R0,0]

       WHERE RecordID           =  [DMActItemID|R0,0]
    END_QUERY

    EXECUTE [DMWorkQ], [DMRes]
    IF [DMRes]=FALSE
      MESSAGE 'Achtung Fehler','Der Ordner-Eintrag konnte nicht gespeichert werden.',[MESSAGE_ERROR]
      QUERY [DMWorkQ]
        DELETE FROM DocMgrI WHERE RecordID = [DMActItemID|R0,0]
      END_QUERY
      EXECUTE [DMWorkQ],[DMRes]
      CALC [DMActItemID] AS 0.0
      EXIT_PROC
    END_IF

  END_PROC



  PROCEDURE DocMgrMainDropHook
    IF [DMMask!MASK_RECORD_ID]<=[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst einen Dokumenten-Ordner aus.',[MESSAGE_WARNING]
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [DMMask!MASK_DROP_LIST],[DMLnCnt],[DMLnMax]
    IF [DMLnMax]=0
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Die Dateien werden verarbeitet...'

    CALL DocMgrFixPath [DMDir], [DM_REMOVE_PATH_DUMMY], [DMStr1]
    CALL DocMgrMainForceDir [DMStr1]
    IF [DMRes]=FALSE
      CALC [DMMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    CALC [DMLnCnt] AS 1
    WHILE [DMLnCnt]<=[DMLnMax]
      LIST_STR_GET [DMMask!MASK_DROP_LIST],[DMStr1],[DMLnCnt]
      EXIST_FILE [DMStr1],[DMRes]
      IF [DMRes]
        FILE_NAME [DMStr2],[DMStr1]
        CALC [DMStr2] AS CON([DMDir],[DMStr2])

        QUERY [DMWorkQ]
          SELECT RecordID
            FROM DocMgrI
           WHERE FilePath  = "[DMStr2]"
             AND HeaderID  =  [DMMask!MASK_RECORD_ID|R0,0]
        END_QUERY
        EXECUTE [DMWorkQ],[DMRes]
        IF [DMRes]
          GET_DATA [DMWorkQ],[DMRes]
          IF [DMRes]
            FILE_NAME [DMStr1], [DMStr2])
            CALC [DMStr1] AS CON('Folgende Datei wurde diesem Ordner bereits zugeordnet|',[DMStr1])
            MESSAGE 'Achtung Fehler!',[DMStr1],[MESSAGE_WARNING]
          ELSE
            CALL DocMgrMainCreateItem4File [DMStr2]
            IF [DMRes]
              CALL DocMgrFixPath [DMStr2], [DM_REMOVE_PATH_DUMMY], [DMStr2]
              FILE_COPY [DMRes], [DMStr1], [DMStr2]
              IF [DMRes]
                IF [DMMask!CB_MOVE]
                  FILE_DELETE [DMRes], [DMStr1]
                  IF [DMRes]=FALSE
                    CALC [DMStr1] AS CON('Folgende Datei konnte nicht gelscht werden|',[DMStr1])
                    MESSAGE 'Achtung Fehler!',[DMStr1],[MESSAGE_WARNING]
                  END_IF
                END_IF
              ELSE
                FILE_NAME [DMStr1], [DMStr2]
                CALC [DMStr1] AS CON('Folgende Datei konnt enicht kopiert werden|',[DMStr1])
                MESSAGE 'Achtung Fehler!',[DMStr1],[MESSAGE_WARNING]

                QUERY [DMWorkQ]
                  DELETE FROM DocMgrI WHERE RecordID = [DMActItemID|R0,0]
                END_QUERY
                EXECUTE [DMWorkQ],[DMRes]
              END_IF
            END_IF
          END_IF
        END_IF
      ELSE
        CALC [DMStr1] AS CON('Folgende Datei kann nicht gefunden werden|',[DMStr1])
        MESSAGE 'Achtung Fehler!',[DMStr1]
      END_IF
      INC [DMLnCnt]
    END_WHILE

    END_WAIT

    CALL DocMgrMainSetGrid
  END_PROC



  PROCEDURE DocMgrMainInfoHook
    IF [DMMask!MASK_LAST_CHOICE]=911013
      IF [DMHeaderID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst einen Ordner aus',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      CALC [DMMax] AS 0

      QUERY_LOAD [DMViewer],[DMRes],'DocMgrMain002'
      IF [DMRes]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Datenbankabfrage konnte nicht geladen werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMStr1] AS CON('RecordID <> ',[DMHeaderID|R0,0])
      QUERY_ADD_WHERE [DMViewer],255,[DMStr1]

      EXECUTE [DMWorkQ],[DMRes]
      IF [DMRes]
        QUERY_COUNT [DMWorkQ],[DMMax]
      END_IF
      IF [DMMax]<=0
        MESSAGE 'Achtung Abbruch','Es knnen keine weiteren Ordner zu diesem Datensatz gefunden werden',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      VIEW [DMViewer],[DMRes],'Bitte whlen Sie den Ordner aus, der Importiert werden soll','',FALSE,TRUE
      IF [DMRes]
        CALC [DMYNRes] AS [ID_NO]
        CALC [DMStr1]  AS CON('Soll der Ordner "',[DMViewer!FileName],'" in den Ordner "',[DMMask!FileName],'" importiert werden?|Der Ordner "',[DMViewer!FileName],'" wird anschlieend gelscht!')
        GET_YES_NO 'Achtung! Sind Sie sicher?!',[DMStr1],[DMYNRes]
        IF [DMYNRes]<>[ID_YES]
          EXIT_PROC
        END_IF

        SCRIPT 'DocMgrMergeFolder.csh', [DMViewer!RecordID], [DMHeaderID]
        IF [GLOB_RES_STR3]='0'
          CALL DocMgrMainSetGrid
          MESSAGE 'Erfolg!','Der Ordner wurde importiert'
        ELSE
          CALC [DMStr1] AS CON('Der Ordner konnte nicht importiert werden (',[GLOB_RES_STR3],').')
          MESSAGE 'Fehler!','Der Ordner konnte nicht importiert werden',[MESSAGE_ERROR]
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE DocMgrMainExitHook
    CALL MaskSettingsWrite

    IF [DMWorkMode]=[DM_WORK_MODE_DOC_MANAGER]
      QUERY [DMWorkQ]
        SELECT COUNT(RecordID)
          FROM DocMgrH
         WHERE RecordID  >  1000
           AND RelRecID  >  1000
           AND RelRecID  =  [DMRelRecID|R0,0]
           AND TableName = "[DMTableName]"
      END_QUERY
      EXECUTE [DMWorkQ],[DMRes]
      IF [DMRes]
        GET_DATA [DMWorkQ],[DMRes]
        IF [DMRes]
          CALC [DMMax] AS [DMWorkQ!COUNT(RecordID)]

          IF [DMMax]>0
            FLAG_SET [DMRelRecFlag], [DM_DOC_MGR_FLAG], TRUE
          ELSE
            FLAG_SET [DMRelRecFlag], [DM_DOC_MGR_FLAG], FALSE
          END_IF

          QUERY [DMWorkQ]
            UPDATE [DMTableName]
               SET RecFlag  = [DMRelRecFlag]
             WHERE RecordID = [DMRelRecID|R0,0]
          END_QUERY
          EXECUTE [DMWorkQ],[DMRes]
        END_IF
      END_IF

      CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS [DMRelRecFlag]
    END_IF

    CALC [DMMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC


  PROCEDURE CheckAndSetDir
    LOCAL_STR  LocStr1
    LOCAL_NUM  LocNum1
    LOCAL_BOOL LocIsAdresse

    CALC [DMDir] AS [DOCUMENT_PATH]

    IF [DMMask!CB_DIR]
      IF [DMDocumentSubFolder]<>''
        CALC [DMDir] AS CON([DMDir],[DMDocumentSubFolder])
      END_IF

      CALC [LocIsAdresse] AS FALSE
      CALC [LocStr1] AS LOWCASE([DMTableName])
      CALC [LocNum1] AS POS('adres',[LocStr1])
      IF [LocNum1]=0
        CALC [LocNum1] AS POS('addres',[LocStr1])
        IF [LocNum1]=0
          CALC [LocStr1] AS LOWCASE([DMTableName])
          CALC [LocNum1] AS POS('adres',[LocStr1])
          IF [LocNum1]=0
            CALC [LocNum1] AS POS('addres',[LocStr1])
          END_IF
        END_IF
      END_IF
      IF [LocNum1]>0
        CALC [LocIsAdresse] AS TRUE
      END_IF

      CALC [DMStr1] AS [DMHeader]

      IF [DMXRefName]<>''
        CALC [DMStr1] AS LOWCASE([DMXRefName])
        CALC [DMDir]  AS CON([DMDir],[DMStr1])
        FILE_SLASH [DMDir], TRUE
      ELSE_IF [DMTableName]<>''
        CALC [DMStr1] AS LOWCASE([DMTableName])
        CALC [DMDir]  AS CON([DMDir],[DMStr1])
        FILE_SLASH [DMDir], TRUE
      END_IF

      CALC [DMStr1] AS [DMHeader]
      IF [LocIsAdresse]
        CALC [DMStr1] AS FILTER([DMStr1],'.,:;-0123456789+#?=)(/&%$"!^*`@')
      ELSE
        CALC [DMStr1] AS FILTER([DMStr1],'.,:;-+#?=)(/&%$"!^*`@')
      END_IF

      CALC [DMStr1]  AS REPLACE([DMStr1],'  ',' ')
      CALC [DMStr1]  AS REPLACE([DMStr1],'  ',' ')
      CALC [DMStr1]  AS REPLACE([DMStr1],'  ',' ')
      CALC [DMStr1]  AS REPLACE([DMStr1],'  ',' ')
      CALC [DMStr1]  AS REPLACE([DMStr1],' ','_')
      CALC [DMStr1]  AS LOWCASE([DMStr1])
      CALC [DMStr1]  AS REPLACE([DMStr1],'','ae')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','oe')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','ue')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','ss')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','a')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','a')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','a')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','e')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','e')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','e')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','u')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','u')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','u')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','o')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','o')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','o')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','i')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','i')
      CALC [DMStr1]  AS REPLACE([DMStr1],'','i')

      IF [DMStr1]<>''
        CALC [DMDir] AS CON([DMDir],[DMStr1])
        CALC [LocNum1] AS LEN([DMDir])
        IF [LocNum1]>0
          CALC [LocStr1] AS COPY([DMDir],[LocNum1],1)
        ELSE
          CALC [LocStr1] AS ''
        END_IF
        IF [LocStr1]<>'\'
          FILE_SLASH [DMDir], TRUE
        END_IF

        CALC [DMDir] AS REPLACE([DMDir],'\_\','\')

        CALC [DMDir] AS REPLACE([DMDir],'\_','\')
        CALC [DMDir] AS REPLACE([DMDir],'\_','\')
        CALC [DMDir] AS REPLACE([DMDir],'\_','\')

        CALC [DMDir] AS REPLACE([DMDir],'_\','\')
        CALC [DMDir] AS REPLACE([DMDir],'_\','\')
        CALC [DMDir] AS REPLACE([DMDir],'_\','\')
      END_IF
    END_IF

    CALL DocMgrFixPath [DMDir], [DM_INSERT_PATH_DUMMY], [DMDir]

    CALC [LocStr1] AS LOWCASE([DMMask!FolderName])
    CALC [LocStr1] AS REPLACE([LocStr1],'document_path\','')
    IF [LocStr1]=''
      IF [DMDocumentSubFolder]<>''
        CALC [LocStr1] AS LOWCASE([DMDir])
        CALC [LocNum1] AS POS([DMDocumentSubFolder],[LocStr1])
        IF [LocNum1]=0
          CALC [LocNum1] AS POS('document_path\',[DMDir])
          IF [LocNum1]>0
            CALC [LocStr1] AS COPY([DMDir],15,255)
            CALC [DMDir]   AS  CON('document_path\',[DMDocumentSubFolder],[Str1])
          END_IF
        END_IF
      END_IF

      CALC [DMMask!FolderName] AS [DMDir]

      MASK_UPDATE [DMMask], TRUE
      FIELD_FLAG_ON_OFF [DMMask], 'FolderName', '[FIELD_FLAG_ACTUAL]', '[FIELD_FLAG_PROTECTED]'
      FIELD_FLAG_ON_OFF [DMMask], 'BB_FOLDER',  '',                    '[FIELD_FLAG_PROTECTED]'
    ELSE
      CALC [DMDir] AS [DMMask!FolderName]
    END_IF
  END_PROC



  PROCEDURE DocMgrMainShowHook
    CALC [DMMask!MASK_QUERY_ID] AS CON('DocMgrMain00',[DMQueryIdx])
    MASK_UPDATE  [DMMask]

    CALL MaskSettingsRead

    IF [DMPreViewIsOn]
      FIELD_FLAG_ON_OFF [DMMask],'PL_PREVIEW','','[FIELD_FLAG_HIDDEN]'
    ELSE
      FIELD_FLAG_ON_OFF [DMMask],'PL_PREVIEW','[FIELD_FLAG_HIDDEN]',''
    END_IF

    CALL DocMgrMainSetWorkModeDetails

    CALL SetTicketModeOn

    IF [DMHeaderID]<=[EPSILON]
      CALC [DMMax] AS 0
      QUERY_LOAD [DMWorkQ],[DMRes],[DMMask!MASK_QUERY_ID]
      EXECUTE [DMWorkQ],[DMRes]
      IF [DMRes]
        QUERY_COUNT [DMWorkQ],[DMMax]
      END_IF
      IF [DMMax]>0
        MASK_COMMAND [DMMask],[MASK_COMMAND_SEARCH]

        CALC [DMHeaderID]   AS [DMMask!MASK_RECORD_ID]
        CALC [DMHeaderFlag] AS [DMMask!MASK_RECORD_FLAG]
      END_IF
    END_IF

    CALL CheckAndSetDir

    CALL DocMgrMainSetGrid

    IF [RECORD_ID7]>[EPSILON]
      CALC [DMStr1] AS CON('STARTING WITH I.RecordID = ',[RECORD_ID7|R0,0])
      QUERY_REFRESH [DMGridQ], FALSE, [DMStr1]
    END_IF
  END_PROC


  PROCEDURE DocMgrMainIsReadyHook
    CALC [DMMask!MASK_HOOK_IS_READY] AS ''
    IF [DMMask!CB_GROUP]
      CALL DocMgrMainChooseGroup FALSE
      IF [DMPreViewIsOn]
        FIELD_FLAG_ON_OFF [DMMask],'PL_PREVIEW','','[FIELD_FLAG_HIDDEN]'
        CALL DocMgrShowPreview
      END_IF
    END_IF
  END_PROC


  PROCEDURE DocMgrMainExecuter
    IF [DMWorkMode]=[DM_WORK_MODE_DOC_MANAGER]
      IF [DMRelRecID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Es liegt keine Datensatz-ID vor',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF
    END_IF

    MASK_PROCESS [DMMask]
  END_PROC



SCRIPT_BEGIN
  CALL DocMgrMainInitVars
  IF [DMDocumentDirect]=FALSE
    CALL DocMgrMainExecuter
  END_IF
SCRIPT_END
