; Standard-Document-Manager-Main-Chooser-Script
;
; Shows cathegories, themes, folder or physical folder to choose a group of content shown in the main grid
;
; 26.09.2007 Dieter Dasberg
;
;
; Parameters : RECORD_ID1 = RelRecID
;              PAR_STR2   = TableName

  INCLUDE DocMgrUtils.inc
  INCLUDE Choicer.inc

  PROCEDURE DocMgrMainChooserInitVars
    CALL DocMgrUtilInitVars

    VAR_BOOL    DMCRes
    VAR_MASK    DMCMask, 'DocMgrMainChooserDlg'

    VAR_QUERY   DMCGridQObenRechts
    VAR_QUERY   DMCGridQObenLinks
    VAR_QUERY   DMCGridQUntenRechts
    VAR_QUERY   DMCGridQUntenLinks

    VAR_NUM     DMCGridOption
    VAR_STR     DMCStr1

    CALC [DMCGridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]


    CALC [DMCMask!MASK_HOOK_SHOW]    AS 'DocMgrMainChooserShowHook'
    CALC [DMCMask!MASK_HOOK_EXIT]    AS 'DocMgrMainChooserExitHook'
    CALC [DMCMask!MASK_HOOK_GRID_OK] AS 'DocMgrMainChooserGridOkHook'

    CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS ''
  END_PROC


  PROCEDURE GULRecChangeHook
    QUERY [DMCGridQObenLinks]
        SELECT [W40 N"Kategorien"][DM_SQL_CATEGORY] AS DMCategory,
               [H                ]I.CategoryID

          FROM DocMgrI I, DocMgrCA C

         WHERE I.HeaderID   = [DMCGridQUntenLinks!RecordID|R0,0]
           AND I.HeaderID   > 1000
           AND I.CategoryID = C.RecordID

      GROUP BY I.CategoryID

      ORDER BY DMCategory
    END_QUERY

    EXECUTE [DMCGridQObenLinks],[DMCRes]
    IF [DMCRes]
      GRID_SET [DMCMask], 'GridObenLinks', [DMCGridQObenLinks], [DMCRes], [DMCGridOption]
    END_IF


    QUERY [DMCGridQObenRechts]
        SELECT [W80 N"Themen"]DISTINCT I.ThreadName AS DMThreads,
               [H            ]I.HeaderID

          FROM DocMgrI I

         WHERE I.HeaderID = [DMCGridQUntenLinks!RecordID|R0,0]
           AND I.HeaderID > 1000

      ORDER BY DMThreads
    END_QUERY

    EXECUTE [DMCGridQObenRechts],[DMCRes]
    IF [DMCRes]
      GRID_SET [DMCMask], 'GridObenRechts', [DMCGridQObenRechts], [DMCRes], [DMCGridOption]
    END_IF


    QUERY [DMCGridQUntenRechts]
        SELECT [W80 N"Physicalische Ordner"]DISTINCT I.FilePath AS DMFiles,
               [H                          ]I.HeaderID

          FROM DocMgrI I

         WHERE I.HeaderID = [DMCGridQUntenLinks!RecordID|R0,0]
           AND I.HeaderID > 1000

      ORDER BY DMFiles
    END_QUERY

    EXECUTE [DMCGridQUntenRechts],[DMCRes]
    IF [DMCRes]
      GRID_SET [DMCMask], 'GridUntenRechts', [DMCGridQUntenRechts], [DMCRes], [DMCGridOption]
    END_IF
  END_PROC



  PROCEDURE DocMgrMainChooserSetFolderGrid
    CALC [DMCGridQUntenLinks!QUERY_HOOK_REC_CHANGE] AS ''

    QUERY [DMCGridQUntenLinks]
        SELECT [W80 N"Ordner"]FileName, RecordID

          FROM DocMgrH

         WHERE RecordID  >  1000
           AND RelRecID  =  [RECORD_ID1|R0,0]
           AND TableName = "[PAR_STR2]"

      ORDER BY FileName
    END_QUERY

    EXECUTE [DMCGridQUntenLinks],[DMCRes]
    IF [DMCRes]
      GRID_SET [DMCMask], 'GridUntenLinks', [DMCGridQUntenLinks], [DMCRes], [DMCGridOption]
      GET_DATA [DMCGridQUntenLinks],[DMCRes]
      CALL GULRecChangeHook
      CALC [DMCGridQUntenLinks!QUERY_HOOK_REC_CHANGE] AS 'GULRecChangeHook'
    END_IF
  END_PROC



  PROCEDURE DocMgrMainChooserGridOkHook
    CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS [DMCGridQUntenLinks!RecordID|R0,0]

    IF [DMCMask!MASK_ACT_GRID_NAME]='GridUntenLinks'
      CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS CON('H|',[DOCU_MGR_SCRIPT_RESULT_STR],'|0')
    ELSE_IF [DMCMask!MASK_ACT_GRID_NAME]='GridObenLinks'
      CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS CON('C|',[DOCU_MGR_SCRIPT_RESULT_STR],'|',[DMCGridQObenLinks!I.CategoryID|R0,0])
    ELSE_IF [DMCMask!MASK_ACT_GRID_NAME]='GridUntenRechts'
      FILE_PATH  [DMCStr1], [DMCGridQUntenRechts!DISTINCTI.FilePathASDMFiles]
      FILE_SLASH [DMCStr1], TRUE
      CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS CON('F|',[DOCU_MGR_SCRIPT_RESULT_STR],'|',[DMCStr1])
    ELSE_IF [DMCMask!MASK_ACT_GRID_NAME]='GridObenRechts'
      CALC [DOCU_MGR_SCRIPT_RESULT_STR] AS CON('T|',[DOCU_MGR_SCRIPT_RESULT_STR],'|',[DMCGridQObenRechts!DISTINCTI.ThreadNameASDMThreads])
    END_IF

    MASK_COMMAND [DMCMask],[MASK_COMMAND_EXIT]
  END_PROC


  PROCEDURE DocMgrMainChooserExitHook
    CALC [DMCMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC


  PROCEDURE DocMgrMainChooserShowHook
    ; 1 = Kategorien
    FLAG_STATE [DM_WORK_MODE_DOC_CHOOSER],1,[DMCRes]
    IF [DMCRes]
      FIELD_FLAG_ON_OFF [DMCMask],'GridObenLinks','','[FIELD_FLAG_HIDDEN]'
    ELSE
      FIELD_FLAG_ON_OFF [DMCMask],'GridObenLinks','[FIELD_FLAG_HIDDEN]',''
    END_IF

    ; 2 = Ordner
    FLAG_STATE [DM_WORK_MODE_DOC_CHOOSER],2,[DMCRes]
    IF [DMCRes]
      FIELD_FLAG_ON_OFF [DMCMask],'GridUntenLinks','','[FIELD_FLAG_HIDDEN]'
    ELSE
      FIELD_FLAG_ON_OFF [DMCMask],'GridUntenLinks','[FIELD_FLAG_HIDDEN]',''
    END_IF

    ; 4 = Themen
    FLAG_STATE [DM_WORK_MODE_DOC_CHOOSER],4,[DMCRes]
    IF [DMCRes]
      FIELD_FLAG_ON_OFF [DMCMask],'GridObenRechts','','[FIELD_FLAG_HIDDEN]'
    ELSE
      FIELD_FLAG_ON_OFF [DMCMask],'GridObenRechts','[FIELD_FLAG_HIDDEN]',''
    END_IF

    ; 8 = Physicalische Ordner
    FLAG_STATE [DM_WORK_MODE_DOC_CHOOSER],8,[DMCRes]
    IF [DMCRes]
      FIELD_FLAG_ON_OFF [DMCMask],'GridUntenRechts','','[FIELD_FLAG_HIDDEN]'
    ELSE
      FIELD_FLAG_ON_OFF [DMCMask],'GridUntenRechts','[FIELD_FLAG_HIDDEN]',''
    END_IF

    CALL DocMgrMainChooserSetFolderGrid
  END_PROC


  PROCEDURE DocMgrMainChooserExecuter
    MASK_PROCESS [DMCMask]
  END_PROC



SCRIPT_BEGIN
  CALL DocMgrMainChooserInitVars
  CALL DocMgrMainChooserExecuter
SCRIPT_END
