  ; dd 31.10.2007
  ;
  ; Vereint den Inhalt zweier Ordner zu einem. Der Quell-Ordner,
  ; der anschlieend leer ist, wird dann gelscht.
  ;
  ; Das Script gibt keine Warte oder Warnmeldung aus.
  ; Wenn alles geklappt hat, wird GLOB_RES_STR3 = '0' sein, anderenfalls
  ; enthlt es als Wert der Abbruchpunkt dieses Scriptes.
  ;
  ; Parameter: RECORD_ID1 : RecordID des Quellordners
  ;            RECORD_ID2 : RecordID des Zielordners


  INCLUDE DocMgrUtils.inc


  PROCEDURE InitVars
    CONST_NUM DM_DOC_MGR_FLAG, 8192

    VAR_BOOL  Res

    VAR_QUERY Q1
    VAR_QUERY Q2

    VAR_STR   Str1

    VAR_NUM   ARecFlag

    VAR_FLOAT Float1

    VAR_FLOAT SourceID
    VAR_FLOAT SourceRelRecID
    VAR_STR   SourceTableName

    VAR_FLOAT DestID
    VAR_FLOAT DestRelRecID
    VAR_STR   DestTableName

    CALC [SourceID]        AS [RECORD_ID1]
    CALC [DestID]          AS [RECORD_ID2]
  END_PROC



  PROCEDURE CheckConditions
    CALC [Res] AS FALSE

    IF [SourceID]<=[EPSILON]
      ; Keine Quelle angegeben
      CALC [GLOB_RES_STR3] AS '1'
      EXIT_PROC
    END_IF

    IF [DestID]<=[EPSILON]
      ; Kein Ziel angegeben
      CALC [GLOB_RES_STR3] AS '2'
      EXIT_PROC
    END_IF

    QUERY [Q1]
      SELECT RelRecID, TableName, RecordID, RecFlag
        FROM docmgrh
       WHERE RecordID = [SourceID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Quell-Ordner-Abfrage fehlgeschlagen
      CALC [GLOB_RES_STR3] AS '3'
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      ; Quell-Ordner nicht vorhanden
      CALC [GLOB_RES_STR3] AS '4'
      EXIT_PROC
    END_IF
    CALC [SourceRelRecID]  AS [Q1!RelRecID]
    CALC [SourceTableName] AS [Q1!TableName]


    QUERY [Q1]
      SELECT RelRecID, TableName, RecordID, RecFlag
        FROM docmgrh
       WHERE RecordID = [DestID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Ziel-Ordner-Abfrage fehlgeschlagen
      CALC [GLOB_RES_STR3] AS '5'
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      ; Ziel-Ordner nicht vorhanden
      CALC [GLOB_RES_STR3] AS '6'
      EXIT_PROC
    END_IF
    CALC [DestRelRecID]  AS [Q1!RelRecID]
    CALC [DestTableName] AS [Q1!TableName]
  END_PROC



  PROCEDURE CopyItems
    QUERY [Q1]
      UPDATE docmgri
         SET HeaderID = [DestID|R0,0]
       WHERE HeaderID = [SourceID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [GLOB_RES_STR3] AS '10'
      ; Defekte Tabelle oder
      ; DocMgrI ist nicht vorhanden
      EXIT_PROC
    END_IF

    QUERY [Q1]
      DELETE
        FROM notes
       WHERE RelRecID  = [SourceID|R0,0]
         AND TableName = "docmgrh"
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [GLOB_RES_STR3] AS '11'
      ; Defekte Tabelle oder
      ; DocMgrH ist nicht vorhanden
      EXIT_PROC
    END_IF


    QUERY [Q1]
      DELETE
        FROM docmgrh
       WHERE RecordID = [SourceID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [GLOB_RES_STR3] AS '12'
      ; Defekte Tabelle oder
      ; DocMgrH ist nicht vorhanden
      EXIT_PROC
    END_IF


    QUERY [Q1]
      SELECT RecFlag
        FROM [SourceTableName]
       WHERE RecordID = [SourceRelRecID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]
      GET_DATA [Q1],[Res]
      IF [Res]
        CALC [ARecFlag] AS [Q1!RecFlag]

        QUERY [Q1]
          SELECT COUNT(RecordID)
            FROM docmgrh
           WHERE RecordID  >  1000
             AND RelRecID  >  1000
             AND RelRecID  =  [SourceRelRecID|R0,0]
             AND TableName = "[SourceTableName]"
        END_QUERY
        EXECUTE [Q1],[Res]
        IF [Res]
          GET_DATA [Q1],[Res]
          IF [Res]
            IF [Q1!COUNT(RecordID)]>0
              FLAG_SET [ARecFlag], [DM_DOC_MGR_FLAG], TRUE
            ELSE
              FLAG_SET [ARecFlag], [DM_DOC_MGR_FLAG], FALSE
            END_IF

            QUERY [Q1]
              UPDATE [SourceTableName]
                 SET RecFlag  = [ARecFlag]
               WHERE RecordID = [SourceRelRecID|R0,0]
            END_QUERY
            EXECUTE [Q1],[Res]
          END_IF
        END_IF
      END_IF
    END_IF

    CALC [Float1] AS ABS([SourceRelRecID]-[DestRelRecID])
    IF [Float1]>[EPSILON]
      QUERY [Q1]
        SELECT RecFlag
          FROM [DestTableName]
         WHERE RecordID = [DestRelRecID|R0,0]
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]
        GET_DATA [Q1],[Res]
        IF [Res]
          CALC [ARecFlag] AS [Q1!RecFlag]

          QUERY [Q1]
            SELECT COUNT(RecordID)
              FROM docmgrh
             WHERE RecordID  >  1000
               AND RelRecID  >  1000
               AND RelRecID  =  [DestRelRecID|R0,0]
               AND TableName = "[DestTableName]"
          END_QUERY
          EXECUTE [Q1],[Res]
          IF [Res]
            GET_DATA [Q1],[Res]
            IF [Res]
              IF [Q1!COUNT(RecordID)]>0
                FLAG_SET [ARecFlag], [DM_DOC_MGR_FLAG], TRUE
              ELSE
                FLAG_SET [ARecFlag], [DM_DOC_MGR_FLAG], FALSE
              END_IF

              QUERY [Q1]
                UPDATE [DestTableName]
                   SET RecFlag  = [ARecFlag]
                 WHERE RecordID = [DestRelRecID|R0,0]
              END_QUERY
              EXECUTE [Q1],[Res]
            END_IF
          END_IF
        END_IF
      END_IF
    END_IF

    CALC [Res] AS TRUE
  END_PROC



  PROCEDURE Main
    CALC [GLOB_RES_STR3] AS '0'

    CALL CheckConditions
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALL CopyItems
    IF [Res]=FALSE
      EXIT_PROC
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
