  ; dd 05.09.2007
  ;
  ; Verscheiebt den Inhalt des ersten auffindbaren Ordners einer Quell-RelRecID
  ; in den ersten auffinbaren Ordner der Ziel-RelRecID.
  ; Wenn bei der ZielRelRecID kein Ordner auffindbar ist, wird dieser angelegt.
  ;
  ; Das Script gibt keine Warte oder Warnmeldung aus.
  ; Wenn alles geklappt hat, wird GLOB_RES_STR3 = '0' sein, anderenfalls
  ; enthlt es als Wert der Abbruchpunkt dieses Scriptes.
  ;
  ; Parameter: RECORD_ID1 : RelRecID der Quelle
  ;            RECORD_ID2 : RelRecID des Zieles
  ;            PAR_STR3   : Tabelle der Quelle
  ;            PAR_STR4   : Tabelle des Zieles
  ;            RECORD_ID5 : 0 = Daten verschieben und den Quell-Ordner lschen.
  ;                         1 = Daten verschieben und im  Quell-Ordner einen Verweis zum Ziel-Ordner hinterlassen
  ;            PAR_STR6   : Verweistext wenn RECORD_ID5 = 1, kann leer sein, dann wird hier ein Text erzeugt
  ;            PAR_STR7   : XRefName der Quelle
  ;            PAR_STR8   : XRefName des Zieles


  INCLUDE DocMgrUtils.inc


  PROCEDURE InitVars
    CONST_NUM DM_DOC_MGR_FLAG, 8192

    VAR_BOOL  Res

    VAR_QUERY Q1
    VAR_QUERY Q2

    VAR_STR   Str1

    VAR_FLOAT SourceID
    VAR_STR   SourceXRef
    VAR_STR   SourceTable
    VAR_STR   SourceFolder
    VAR_FLOAT SourceItemID
    VAR_NUM   SourceRecFlag
    VAR_NUM   SourceHeaders
    VAR_FLOAT SourceHeaderID

    VAR_FLOAT DestID
    VAR_STR   DestXRef
    VAR_STR   DestTable
    VAR_FLOAT DestItemID
    VAR_NUM   DestRecFlag
    VAR_FLOAT DestHeaderID

    VAR_STR   TextSource2Dest

    CALC [SourceID]        AS [RECORD_ID1]
    CALC [DestID]          AS [RECORD_ID2]
    CALC [SourceTable]     AS [PAR_STR3]
    CALC [DestTable]       AS [PAR_STR4]

    CALC [TextSource2Dest] AS [PAR_STR6]
    CALC [SourceXRef]      AS [PAR_STR7]
    CALC [DestXRef]        AS [PAR_STR8]
  END_PROC



  PROCEDURE CheckConditions
    CALC [Res] AS FALSE

    IF [SourceID]<=[EPSILON]
      ; Keine Quelle angegeben
      CALC [GLOB_RES_STR3] AS '1'
      EXIT_PROC
    END_IF

    IF [DestID]<=[EPSILON]
      ; Kein Ziel angegeben
      CALC [GLOB_RES_STR3] AS '2'
      EXIT_PROC
    END_IF

    IF [SourceTable]=''
      ; Kein Tabelle fr die Quelle angegeben
      CALC [GLOB_RES_STR3] AS '3'
      EXIT_PROC
    END_IF

    IF [DestTable]=''
      ; Kein Tabelle fr das Ziel angegeben
      ; wird auf die Tabelle der Quelle gesetzt
      CALC [DestTable] AS [SourceTable]
      IF [DestXRef]=''
        CALC [DestXRef] AS [SourceXRef]
      END_IF
    END_IF

    QUERY [Q1]
      SELECT RecordID, RecFlag
        FROM [SourceTable]
       WHERE RecordID = [SourceID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Falsche Angabe fr die Quell-Tabelle oder
      ; defekte Tabelle oder
      ; die Tabelle entspricht nicht dem CARA-Aufbau
      CALC [GLOB_RES_STR3] AS '4'
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      ; Datensatz ist in der Quell-Tabelle
      ; nicht vorhanden
      CALC [GLOB_RES_STR3] AS '5'
      EXIT_PROC
    END_IF
    CALC [SourceRecFlag] AS [Q1!RecFlag]


    QUERY [Q1]
      SELECT RecordID, RecFlag
        FROM [DestTable]
       WHERE RecordID = [DestID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Falsche Angabe fr die Ziel-Tabelle oder
      ; defekte Tabelle oder
      ; die Tabelle entspricht nicht dem CARA-Aufbau
      CALC [GLOB_RES_STR3] AS '6'
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      ; Datensatz ist in der Ziel-Tabelle
      ; nicht vorhanden
      CALC [GLOB_RES_STR3] AS '7'
      EXIT_PROC
    END_IF
    CALC [DestRecFlag] AS [Q1!RecFlag]


    QUERY [Q1]
        SELECT RecordID, XRefName, FolderName
          FROM docmgrh
         WHERE RelRecID  =  [SourceID|R0,0]
           AND TableName = "[SourceTable]"
      ORDER BY RecordID
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Dokumanager Tabelle nicht
      ; installiert oder defekt
      CALC [GLOB_RES_STR3] AS '8'
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      ; Die Quelle hat keinen DocMgr-Ordner
      CALC [GLOB_RES_STR3] AS '9'
      EXIT_PROC
    END_IF
    CALC [SourceFolder]   AS [Q1!FolderName]
    CALC [SourceHeaderID] AS [Q1!RecordID]
    IF [Q1!XRefName]<>''
      IF [SourceXRef]=''
        CALC [SourceXRef] AS [Q1!XRefName]
      END_IF
    END_IF
    QUERY_COUNT [Q1],[SourceHeaders]

    QUERY [Q1]
        SELECT RecordID, XRefName
          FROM docmgrh
         WHERE RelRecID  =  [DestID|R0,0]
           AND TableName = "[DestTable]"
      ORDER BY RecordID
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Dokumanager Tabelle nicht
      ; installiert oder defekt
      CALC [GLOB_RES_STR3] AS '10'
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]
      CALC [DestHeaderID] AS [Q1!RecordID]
      IF [Q1!XRefName]<>''
        IF [DestXRef]=''
          CALC [DestXRef] AS [Q1!XRefName]
        END_IF
      END_IF
      IF [DestXRef]=''
        IF [DestTable]=[SourceTable]
          CALC [DestXRef] AS [SourceXRef]
        END_IF
      END_IF
    ELSE
      IF [DestXRef]=''
        IF [DestTable]=[SourceTable]
          CALC [DestXRef] AS [SourceXRef]
        END_IF
      END_IF

      ; Die Ziel hat keinen DocMgr-Ordner
      ; es muss ein Ordner angelegt werden

      CALC [DestHeaderID] AS [SourceHeaderID]
      NEW_RECORD [Res],'docmgrh',[DestHeaderID], TRUE, FALSE, TRUE
      IF [Res]=FALSE
        ; Es konnte kein neuer Eintrag erzeugt werden
        CALC [GLOB_RES_STR3] AS '11'
        EXIT_PROC
      END_IF

      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [SourceFolder] AS DBL_BACK_SLASH([SourceFolder])
      ELSE
        CALC [SourceFolder] AS SGL_BACK_SLASH([SourceFolder])
      END_IF

      QUERY [Q1]
        UPDATE docmgrh
           SET TableName  = "[DestTable]",
               XRefName   = "[DestXRef]",
               FolderName = "[SourceFolder]",
               RelRecID   =  [DestID|R0,0]
         WHERE RecordID   =  [DestHeaderID|R0,0]
      END_QUERY

      EXECUTE [Q1],[Res]
      IF [Res]
        FLAG_SET [DestRecFlag],[DM_DOC_MGR_FLAG],TRUE
        QUERY [Q1]
          UPDATE [DestTable]
             SET RecFlag  = [DestRecFlag]
           WHERE RecordID = [DestID|R0,0]
        END_QUERY
        IF [Res]=FALSE
          ; Die RecFlag des Ziel-Datensatzes
          ; konnte nicht gesetzt werden
          CALC [GLOB_RES_STR3] AS '13'
          EXIT_PROC
        END_IF
      ELSE
        ; Initialisierung schlug fehl

        ; !aufrumen!
        QUERY [Q1]
          DELETE FROM docmgrh WHERE RecordID  = [DestHeaderID|R0,0]
        END_QUERY
        EXECUTE [Q1],[Res]
        ; Ergebnis muss FALSE bleiben
        CALC [Res]=FALSE
        CALC [GLOB_RES_STR3] AS '12'
        EXIT_PROC
      END_IF
    END_IF
  END_PROC



  PROCEDURE CopyItems
    QUERY [Q1]
      SELECT RecordID, FilePath
        FROM docmgri
       WHERE HeaderID = [SourceHeaderID|R0,0]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [GLOB_RES_STR3] AS '20'
      ; Defekte Tabelle oder
      ; DocMgrI ist nicht vorhanden
      EXIT_PROC
    END_IF
    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      ; Leine Eintrge im Ordner
      FORE_JUMP
    END_IF

    WHILE [Res]
      CALC [DestItemID] AS [Q1!RecordID]

      NEW_RECORD [Res],'docmgri',[DestItemID], TRUE, FALSE, TRUE
      IF [Res]=FALSE
        ; Es konnte kein neuer Eintrag erzeugt werden
        CALC [GLOB_RES_STR3] AS '21'
        EXIT_PROC
      END_IF

      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [Str1] AS DBL_BACK_SLASH([Q1!FilePath])
      ELSE
        CALC [Str1] AS SGL_BACK_SLASH([Q1!FilePath])
      END_IF

      QUERY [Q2]
        UPDATE docmgri
           SET HeaderID =  [DestHeaderID|R0,0],
               FilePath = "[Str1]"
         WHERE RecordID =  [DestItemID|R0,0]
      END_QUERY
      EXECUTE [Q2],[Res]
      IF [Res]=FALSE
        ; Initialisierung schlug fehl

        ; !aufrumen!
        QUERY [Q2]
          DELETE FROM docmgri WHERE RecordID  = [DestItemID|R0,0]
        END_QUERY
        EXECUTE [Q2],[Res]
        ; Ergebnis muss FALSE bleiben
        CALC [Res]=FALSE

        CALC [GLOB_RES_STR3] AS '22'
        EXIT_PROC
      END_IF

      QUERY [Q2]
        UPDATE notes
           SET RelRecID  =  [DestItemID|R0,0],
               TableName = "docmgri"
         WHERE RelRecID  =  [Q1!RecordID|R0,0]
           AND TableName = "docmgri"
      END_QUERY
      EXECUTE [Q2],[Res]
      IF [Res]=FALSE
        ; Notizen konnten nicht verlegt werden
        CALC [GLOB_RES_STR3] AS '23'
        EXIT_PROC
      END_IF

      ; Quelle lschen
      QUERY [Q2]
        DELETE FROM docmgri WHERE RecordID  = [Q1!RecordID|R0,0]
      END_QUERY
      EXECUTE [Q2],[Res]
      IF [Res]=FALSE
        ; Quelle konnte nicht gelscht werden?
        CALC [GLOB_RES_STR3] AS '24'
        EXIT_PROC
      END_IF

      GET_DATA [Q1],[Res]
    END_WHILE

    FORE_MARK

    CALC [Res] AS TRUE
  END_PROC



  PROCEDURE Main
    CALC [GLOB_RES_STR3] AS '0'

    CALL CheckConditions
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALL CopyItems
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY [Q1]
      UPDATE notes
         SET RelRecID  =  [DestHeaderID|R0,0],
             TableName = "[DestTable]"
       WHERE RelRecID  =  [SourceHeaderID|R0,0]
         AND TableName = "[SourceTable]"
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Notizen des Headers konnten nicht verlegt werden
      CALC [GLOB_RES_STR3] AS '30'
      EXIT_PROC
    END_IF


    IF [RECORD_ID5]<=[EPSILON]
      ; Quell-Ordner lschen
      QUERY [Q1]
        DELETE FROM docmgrh WHERE RecordID = [SourceHeaderID|R0,0]
      END_QUERY
      EXECUTE [Q2],[Res]
      IF [Res]=FALSE
        ; Der Quell-Ordner konnte nicht gelscht werden
        CALC [GLOB_RES_STR3] AS '31'
        EXIT_PROC
      END_IF

      IF [SourceHeaders]<=1
        FLAG_SET [SourceRecFlag],[DM_DOC_MGR_FLAG],TRUE
        QUERY [Q1]
          UPDATE [SourceTable]
             SET RecFlag  = [SourceRecFlag]
           WHERE RecordID = [SourceID|R0,0]
        END_QUERY
        IF [Res]=FALSE
          ; Die RecFlag des Quell-Datensatzes
          ; konnte nicht gesetzt werden
          CALC [GLOB_RES_STR3] AS '32'
          EXIT_PROC
        END_IF
      END_IF
    ELSE
      ; Im Quell-Ordner einen Verweis erzeugen
      IF [TextSource2Dest]=''
        CALL DocMgrUtilLoadRelationByTableFld '', [DestTable], 'TextSource2Dest', 'SourceID', [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_YES]
      END_IF

      IF [TextSource2Dest]=''
        ; Kein Verweistext vorhanden
        CALC [GLOB_RES_STR3] AS '33'
        EXIT_PROC
      END_IF

      CALC [TextSource2Dest] AS CON('Ordner verlegt ',[TextSource2Dest])

      NEW_RECORD [Res],'docmgri',[SourceItemID], TRUE, FALSE, FALSE
      IF [Res]=FALSE
        ; Es konnte kein neuer Eintrag erzeugt werden
        CALC [GLOB_RES_STR3] AS '34'
        EXIT_PROC
      END_IF

      QUERY [Q1]
        UPDATE docmgri
           SET HeaderID =  [SourceHeaderID|R0,0],
               ItemNote = "[TextSource2Dest]"
         WHERE RecordID =  [SourceItemID|R0,0]
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]=FALSE
        ; Initialisierung schlug fehl

        ; !aufrumen!
        QUERY [Q1]
          DELETE FROM docmgri WHERE RecordID = [SourceItemID|R0,0]
        END_QUERY
        EXECUTE [Q1],[Res]

        CALC [GLOB_RES_STR3] AS '35'
        EXIT_PROC
      END_IF
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
