    ; exportiert  PROCEDURE DocMgrCheckHeader       VS DMCH.TableName, VF DMCH.RecID, ~VN DMCH.RFlag,    ~VF DMCH.HeaderID
    ;             PROCEDURE DocMgrFastInfo          VS DMFI.TableName, VF DMFI.RecID,  VF DMFI.HeaderID,  VS DMFI.ItemNote, ~VF DMFI.ItemID,       VS DMFI.Document,      VS DMFI.ListName
    ;             PROCEDURE DocMgrFastInfoWithDatum VS DMFI.TableName, VF DMFI.RecID,  VF DMFI.HeaderID,  VS DMFI.ItemNote, ~VF DMFI.ItemID,       VF DMFI.NextProcID,    VD DMFI.NextProcDate,  VT DMFI.NextProcTime, VS DMFI.Document, VS DMFI.ListName
    ;             PROCEDURE DocMgrFastRsm           VS DMFR.TableName, VF DMFR.RecID,  VF DMFR.HeaderID,  VS DMFR.ItemNote,  VD DMFR.ItemDate,     VT DMFR.ItemTime,      VF DMFR.UserID,       ~VF DMFR.ItemID,       VS DMFR.Document, VS DMFI.ListName
    ;             PROCEDURE DocMgrFastRelAdrDoc     VS DMFD.TableName, VF DMFD.RecID,  VF DMFD.HeaderID,  VF DMFD.RelAdrID,  VS DMFD.DocNamePart1, VS DMFD.DocNamePart2, ~VF DMFD.ItemID


    PROCEDURE DocMgrCheckHeader VS DMCH.TableName, VF DMCH.RecID, ~VN DMCH.RFlag, ~VF DMCH.HeaderID
      LOCAL_QUERY DMCH.Q
      LOCAL_BOOL  DMCH.Res
      LOCAL_NUM   DMCH.ANum

      CALC [DMCH.HeaderID] AS 0.0
      CALC [DMCH.RFlag]    AS 0

      ; 1. Hole die RecFlag des Datensatzes zu dem ein DocMgrHeader anegelet werden soll
      QUERY [DMCH.Q]
        SELECT RecFlag
          FROM [DMCH.TableName]
         WHERE RecordID  = [DMCH.RecID|R0,0]
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln des Status eines Datensatz konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      GET_DATA [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Status eines Datensatzes konnte nicht ermittelt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      CALC [DMCH.RFlag] AS [DMCH.Q!RecFlag]


      ; 2. Ist ein Header vorhanden
      QUERY [DMCH.Q]
          SELECT RecordID, FileName
            FROM DocMgrH
           WHERE RelRecID  =  [DMCH.RecID|R0,0]
             AND TableName = "[DMCH.TableName]"
        ORDER BY RecordID DESC
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Dokumenten-Manager-Ordner-Abfrage konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      GET_DATA [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]
        ; Header vorhanden --> fertig und raus hier
        CALC [DMCH.HeaderID] AS [DMCH.Q!RecordID]

        ; 2a. Setze die RecFlag des Datensatzes, falls notwendig
        CALC [DMCH.ANum] AS [DMCH.RFlag]
        FLAG_SET [DMCH.ANum],8192,TRUE
        IF [DMCH.ANum]<>[DMCH.RFlag]
          CALC [DMCH.RFlag] AS [DMCH.ANum]
          QUERY [DMCH.Q]
            UPDATE [DMCH.TableName]
               SET RecFlag  = [DMCH.RFlag]
             WHERE RecordID = [DMCH.RecID|R0,0]
          END_QUERY
          EXECUTE [DMCH.Q],[DMCH.Res]
          IF [DMCH.Res]=FALSE
            MESSAGE 'Achtung Abbruch','Der Status des Datensatzes konnte nicht gendert werden',[MESSAGE_ERROR]
            CALC [DMCH.HeaderID] AS 0.0
            CALC [DMCH.RFlag]    AS 0
            EXIT_PROC
          END_IF
        END_IF

        EXIT_PROC
      END_IF

      ; Ab hier : Kein Header da, mache einen

      ; 3. Mache einen Header
      NEW_RECORD [DMCH.Res], 'DOCMGRH', [DMCH.HeaderID], TRUE, FALSE, FALSE
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Ordner konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      QUERY [DMCH.Q]
        UPDATE DocMgrH
           SET FileName  = "Allgemein",
               RelRecID  = [DMCH.RecID|R0,0],
               FileDate  = [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               TableName = "[DMCH.TableName]"
         WHERE RecordID  = [DMCH.HeaderID|R0,0]
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMCH.HeaderID] AS 0.0
        CALC [DMCH.RFlag]    AS 0
        EXIT_PROC
      END_IF


      ; 4. Setze die RecFlag des Datensatzes
      FLAG_SET [DMCH.RFlag],8192,TRUE
      QUERY [DMCH.Q]
        UPDATE [DMCH.TableName]
           SET RecFlag  = [DMCH.RFlag]
         WHERE RecordID = [DMCH.RecID|R0,0]
      END_QUERY
      EXECUTE [DMCH.Q],[DMCH.Res]
      IF [DMCH.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Status des Datensatzes konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMCH.HeaderID] AS 0.0
        CALC [DMCH.RFlag]    AS 0
        EXIT_PROC
      END_IF
    END_PROC


    PROCEDURE DocMgrFastInfo VS DMFI.TableName, VF DMFI.RecID, VF DMFI.HeaderID, VS DMFI.ItemNote, ~VF DMFI.ItemID, VS DMFI.Document, VS DMFI.ListName
      LOCAL_QUERY DMFI.Q
      LOCAL_BOOL  DMFI.Res
      LOCAL_TIME  DMFI.ATime
      LOCAL_FLOAT DMFI.AFloat1
      LOCAL_FLOAT DMFI.AFloat2
      LOCAL_NUM   DMFI.ListCnt
      LOCAL_NUM   DMFI.ListAct
      LOCAL_NUM   DMFI.SPos

      CALC [DMFI.ItemID] AS 0.0

      NEW_RECORD [DMFI.Res], 'DOCMGRI', [DMFI.ItemID], TRUE, FALSE, FALSE
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMFI.Document] AS LOWCASE([DMFI.Document])
      CALC [DMFI.SPos]     AS POS([DOCUMENT_PATH],[DMFI.Document])
      IF [DMFI.SPos]=1
        CALC [DMFI.Document] AS REPLACE([DMFI.Document],[DOCUMENT_PATH],'document_path\')
      END_IF
      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [DMFI.Document] AS DBL_BACK_SLASH([DMFI.Document])
      ELSE
        CALC [DMFI.Document] AS SGL_BACK_SLASH([DMFI.Document])
      END_IF

      CALC [DMFI.ATime] AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFI.AFloat1]
      CALC [DMFI.AFloat2] AS [DMFI.AFloat1] + 30805

      QUERY [DMFI.Q]
        UPDATE DocMgrI
           SET HeaderID              =   [DMFI.HeaderID|R0,0],
               ItemNote              =  "[DMFI.ItemNote]",

               FilePath              =  "[DMFI.Document]",

               CreatorID             =   [ACT_MIT_ID|R0,0],
               CreateDate            =   [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =   [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =   [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =   [SQL_TIME_QUOTES_4_MODIFY][DMFI.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =   0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "Schnellinfo",
               CreateDTID            =   [DMFI.AFloat1],
               CreateRunDTID         =   [DMFI.AFloat2],
               CreateDuranceID       =   30805,

               NextProcessorID       =   [ACT_MIT_ID|R0,0],
               NextProcessDate       =   [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               NextProcessTime       =   [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               NextProcessRunDate    =   [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               NextProcessRunTime    =   [SQL_TIME_QUOTES_4_MODIFY][DMFI.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               NextProcessDurance    =   0.08,
               NextProcessDuranceStr =  "0.00:05",
               NextProcessType       =  "Schnellinfo",
               NextProcessDTID       =   [DMFI.AFloat1],
               NextProcessRunDTID    =   [DMFI.AFloat2],
               NextProcessDuranceID  =   30805,

               FinisherID            =   [ACT_MIT_ID|R0,0],
               FinishDate            =   [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               FinishTime            =   [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               FinishRunDate         =   [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               FinishRunTime         =   [SQL_TIME_QUOTES_4_MODIFY][DMFI.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               FinishDurance         =   0.08,
               FinishDuranceStr      =  "0.00:05",
               FinishType            =  "Schnellinfo",
               FinishDTID            =   [DMFI.AFloat1],
               FinishRunDTID         =   [DMFI.AFloat2],
               FinishDuranceID       =   30805,

               Termin                =   [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION],
               erledigt              =   [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]

         WHERE RecordID              =   [DMFI.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFI.Q],[DMFI.Res]
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFI.ItemID] AS 0.0
        EXIT_PROC
      END_IF

      IF [DMFI.ListName]<>''
        CALC [DMFI.ListCnt] AS 1
        LIST_ITEM_GET [[DMFI.ListName]],[DMFI.ListAct],[DMFI.ListCnt]
        IF [DMFI.ListCnt]=0
          LIST_CLR    [[DMFI.ListName]]
          LIST_APPEND [[DMFI.ListName]],[DMFI.ItemNote]
        END_IF
        NOTE_WRITE  [[DMFI.ListName]],[DMFI.Res],'DocMgrI',1,[DMFI.ItemID]
      END_IF
    END_PROC


    PROCEDURE DocMgrFastInfoWithDatum VS DMFI.TableName, VF DMFI.RecID, VF DMFI.HeaderID, VS DMFI.ItemNote, ~VF DMFI.ItemID, VF DMFI.NextProcID, VD DMFI.NextProcDate, VT DMFI.NextProcTime, VS DMFI.Document, VS DMFI.ListName
      LOCAL_QUERY DMFI.Q
      LOCAL_BOOL  DMFI.Res
      LOCAL_TIME  DMFI.ATime
      LOCAL_FLOAT DMFI.AFloat1
      LOCAL_FLOAT DMFI.AFloat2
      LOCAL_NUM   DMFI.ListCnt
      LOCAL_NUM   DMFI.ListAct
      LOCAL_NUM   DMFI.SPos

      CALC [DMFI.ItemID] AS 0.0

      NEW_RECORD [DMFI.Res], 'DOCMGRI', [DMFI.ItemID], TRUE, FALSE, FALSE
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMFI.Document] AS LOWCASE([DMFI.Document])
      CALC [DMFI.SPos]     AS POS([DOCUMENT_PATH],[DMFI.Document])
      IF [DMFI.SPos]=1
        CALC [DMFI.Document] AS REPLACE([DMFI.Document],[DOCUMENT_PATH],'document_path\')
      END_IF
      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [DMFI.Document] AS DBL_BACK_SLASH([DMFI.Document])
      ELSE
        CALC [DMFI.Document] AS SGL_BACK_SLASH([DMFI.Document])
      END_IF

      CALC [DMFI.ATime] AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFI.AFloat1]
      CALC [DMFI.AFloat2] AS [DMFI.AFloat1] + 30805

      QUERY [DMFI.Q]
        UPDATE DocMgrI
           SET HeaderID              =  [DMFI.HeaderID|R0,0],
               ItemNote              =  "[DMFI.ItemNote]",

               FilePath              =  "[DMFI.Document]",

               CreatorID             =  [ACT_MIT_ID|R0,0],
               CreateDate            =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMFI.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =  0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "Schnellinfo",
               CreateDTID            =  [DMFI.AFloat1],
               CreateRunDTID         =  [DMFI.AFloat2],
               CreateDuranceID       =  30805

         WHERE RecordID              = [DMFI.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFI.Q],[DMFI.Res]
      IF [DMFI.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFI.ItemID] AS 0.0
        EXIT_PROC
      END_IF

      IF [DMFI.ListName]<>''
        CALC [DMFI.ListCnt] AS 1
        LIST_ITEM_GET [[DMFI.ListName]],[DMFI.ListAct],[DMFI.ListCnt]
        IF [DMFI.ListCnt]=0
          LIST_CLR    [[DMFI.ListName]]
          LIST_APPEND [[DMFI.ListName]],[DMFI.ItemNote]
        END_IF
        NOTE_WRITE  [[DMFI.ListName]],[DMFI.Res],'DocMgrI',1,[DMFI.ItemID]
      END_IF
    END_PROC



    PROCEDURE DocMgrFastRsm VS DMFR.TableName, VF DMFR.RecID, VF DMFR.HeaderID, VS DMFR.ItemNote, VD DMFR.ItemDate, VT DMFR.ItemTime, VF DMFR.UserID, ~VF DMFR.ItemID, VS DMFR.Document, VS DMFR.ListName
      LOCAL_QUERY DMFR.Q
      LOCAL_BOOL  DMFR.Res
      LOCAL_TIME  DMFR.ATimeCreate
      LOCAL_TIME  DMFR.ATimeRsm
      LOCAL_FLOAT DMFR.AFloatCreate1
      LOCAL_FLOAT DMFR.AFloatCreate2
      LOCAL_FLOAT DMFR.AFloatRsm1
      LOCAL_FLOAT DMFR.AFloatRsm2
      LOCAL_NUM   DMFR.ListCnt
      LOCAL_NUM   DMFR.ListAct
      LOCAL_NUM   DMFR.SPos

      CALC [DMFR.ItemID] AS 0.0

      NEW_RECORD [DMFR.Res], 'DOCMGRI', [DMFR.ItemID], TRUE, FALSE, FALSE
      IF [DMFR.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [DMFR.ATimeCreate]   AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFR.AFloatCreate1]
      CALC [DMFR.AFloatCreate2] AS [DMFR.AFloatCreate1] + 30805

      CALC [DMFR.ATimeRsm]      AS [DMFR.ItemTime]+5
      DATE_TIME_2_REC_ID [DMFR.ItemDate], [DMFR.ItemTime], [DMFR.AFloatRsm1]
      CALC [DMFR.AFloatRsm2]    AS [DMFR.AFloatRsm1]    + 30805

      CALC [DMFR.Document] AS LOWCASE([DMFR.Document])
      CALC [DMFR.SPos]     AS POS([DOCUMENT_PATH],[DMFR.Document])
      IF [DMFR.SPos]=1
        CALC [DMFR.Document] AS REPLACE([DMFR.Document],[DOCUMENT_PATH],'document_path\')
      END_IF
      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [DMFR.Document] AS DBL_BACK_SLASH([DMFR.Document])
      ELSE
        CALC [DMFR.Document] AS SGL_BACK_SLASH([DMFR.Document])
      END_IF


      QUERY [DMFR.Q]
        UPDATE DocMgrI
           SET HeaderID              =  [DMFR.HeaderID|R0,0],
               ItemNote              =  "[DMFR.ItemNote]",

               FilePath              =  "[DMFR.Document]",

               CreatorID             =  [ACT_MIT_ID|R0,0],
               CreateDate            =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMFR.ATimeCreate|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =  0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "schnelle Wiedervorlage",
               CreateDTID            =  [DMFR.AFloatCreate1],
               CreateRunDTID         =  [DMFR.AFloatCreate2],
               CreateDuranceID       =  30805,

               NextProcessorID       =  [DMFR.UserID|R0,0],
               NextProcessDate       =  [SQL_DATE_QUOTES_4_MODIFY][DMFR.ItemDate|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               NextProcessTime       =  [SQL_TIME_QUOTES_4_MODIFY][DMFR.ItemTime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               NextProcessRunDate    =  [SQL_DATE_QUOTES_4_MODIFY][DMFR.ItemDate|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               NextProcessRunTime    =  [SQL_TIME_QUOTES_4_MODIFY][DMFR.ATimeRsm|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               NextProcessDurance    =  0.08,
               NextProcessDuranceStr =  "0.00:05",
               NextProcessType       =  "schnelle Wiedervorlage",
               NextProcessDTID       =  [DMFR.AFloatRsm1],
               NextProcessRunDTID    =  [DMFR.AFloatRsm2],
               NextProcessDuranceID  =  30805,

               Termin                =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]

         WHERE RecordID              = [DMFR.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFR.Q],[DMFR.Res]
      IF [DMFR.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFR.ItemID] AS 0.0
        EXIT_PROC
      END_IF

      IF [DMFR.ListName]<>''
        CALC [DMFR.ListCnt] AS 1
        LIST_ITEM_GET [[DMFR.ListName]],[DMFR.ListAct],[DMFR.ListCnt]
        IF [DMFR.ListCnt]=0
          LIST_CLR    [[DMFR.ListName]]
          LIST_APPEND [[DMFR.ListName]],[DMFR.ItemNote]
        END_IF
        NOTE_WRITE  [[DMFR.ListName]],[DMFR.Res],'DocMgrI',1,[DMFR.ItemID]
      END_IF
    END_PROC



    PROCEDURE DocMgrFastRelAdrDoc VS DMFD.TableName, VF DMFD.RecID, VF DMFD.HeaderID, VF DMFD.RelAdrID, VS DMFD.DocNamePart1, VS DMFD.DocNamePart2, ~VF DMFD.ItemID
      LOCAL_QUERY DMFD.Q
      LOCAL_BOOL  DMFD.Res
      LOCAL_TIME  DMFD.ATime
      LOCAL_FLOAT DMFD.AFloat1
      LOCAL_FLOAT DMFD.AFloat2
      LOCAL_NUM   DMFD.ListCnt
      LOCAL_NUM   DMFD.ListAct
      LOCAL_STR   DMFD.DocName
      LOCAL_STR   DMFD.Tmplate
      LOCAL_STR   DMFD.SubDir
      LOCAL_NUM   DMFD.Y
      LOCAL_NUM   DMFD.M
      LOCAL_NUM   DMFD.D
      LOCAL_NUM   DMFD.SPos

      CALC [DMFD.ItemID] AS 0.0

      NEW_RECORD [DMFD.Res], 'DOCMGRI', [DMFD.ItemID], TRUE, FALSE, FALSE
      IF [DMFD.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Ein Dokumenten-Manager-Eintrag konnte nicht angelegt werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF


      INI_READ [DMFD.Res], [DMFD.SubDir],  [SCRIPT_STRING], [CONFIG_FILE], 'DOCUMENTS_SUBDIR', 'Allgemein'
      CALC [DMFD.SubDir]  AS CON([DOCUMENT_PATH],[DMFD.SubDir])
      FILE_SLASH [DMFD.SubDir], TRUE

      ;1. Es gibt nur eine Vorlage
      ; INI_READ [DMFD.Res], [DMFD.Tmplate], [SCRIPT_STRING], [DMFD.DocName], 'TEMPLATE_REL_ADR', 'Allgemein'
      ; CALC [DMFD.Tmplate] AS CON([DOCUMENT_PATH],[DMFD.Tmplate])

      ;2. Auswahl
      CALC [DMFD.Tmplate] AS CON([DOCUMENT_PATH],'Standard*.doc')
      CHOOSE_FILE [DMFD.Tmplate],[CHOOSE_FILE_4_OPEN],'Bitte whlen Sie eine Vorlage aus','doc-Dateien (*.doc)|*.doc|Alle Dateien (*.*)|*.*',[DMFD.Res]

      CALC [DMFD.Tmplate] AS LOWCASE([DMFD.Tmplate])
      CALC [DMFD.SPos]    AS POS([DOCUMENT_PATH],[DMFD.Tmplate])
      IF [DMFD.SPos]=1
        CALC [DMFD.Tmplate] AS REPLACE([DMFD.Tmplate],[DOCUMENT_PATH],'document_path\')
      END_IF
      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [DMFD.Tmplate] AS DBL_BACK_SLASH([DMFD.Tmplate])
      ELSE
        CALC [DMFD.Tmplate] AS SGL_BACK_SLASH([DMFD.Tmplate])
      END_IF


      CALC [DMFD.DocName] AS [DMFD.SubDir]
      IF [DMFD.DocNamePart1]<>''
        CALC [DMFD.DocName] AS CON([DMFD.DocName],[DMFD.DocNamePart1],'_')
      END_IF
      IF [DMFD.DocNamePart2]<>''
        CALC [DMFD.DocName] AS CON([DMFD.DocName],[DMFD.DocNamePart2],'_')
      END_IF
      DATE_2_DMY [DATE],[DMFD.D],[DMFD.M],[DMFD.Y]
      CALC [DMFD.DocName] AS CON([DMFD.DocName],[DMFD.Y],'_',[DMFD.M],'_',[DMFD.D],'.DOC')

      CALC [DMFD.DocName] AS LOWCASE([DMFD.DocName])
      CALC [DMFD.SPos]    AS POS([DOCUMENT_PATH],[DMFD.DocName])
      IF [DMFD.SPos]=1
        CALC [DMFD.DocName] AS REPLACE([DMFD.DocName],[DOCUMENT_PATH],'document_path\')
      END_IF
      IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
        CALC [DMFD.DocName] AS DBL_BACK_SLASH([DMFD.DocName])
      ELSE
        CALC [DMFD.DocName] AS SGL_BACK_SLASH([DMFD.DocName])
      END_IF


      CALC [DMFD.ATime] AS [TIME]+5
      DATE_TIME_2_REC_ID [DATE], [TIME], [DMFD.AFloat1]
      CALC [DMFD.AFloat2] AS [DMFD.AFloat1] + 30805

      QUERY [DMFD.Q]
        UPDATE DocMgrI
           SET HeaderID              =  [DMFD.HeaderID|R0,0],
               ItemNote              =  "[SHORT_NAME]",

               FilePath              =  "[DMFD.DocName]",
               TemplateName          =  "[DMFD.Tmplate]",

               CreatorID             =  [ACT_MIT_ID|R0,0],
               CreateDate            =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateTime            =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateRunDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R10,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
               CreateRunTime         =  [SQL_TIME_QUOTES_4_MODIFY][DMFD.ATime|R10,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
               CreateDurance         =  0.08,
               CreateDuranceStr      =  "0.00:05",
               CreateType            =  "Zusatz-Adressen-Dokument",
               CreateDTID            =  [DMFD.AFloat1],
               CreateRunDTID         =  [DMFD.AFloat2],
               CreateDuranceID       =  30805,

               XRef01ID              = [DMFD.RelAdrID|R0,0],
               XRef01Name            = "ADRESSE1",
               XRef01TableName       = "ADRESSEN"

         WHERE RecordID              = [DMFD.ItemID|R0,0]
      END_QUERY
      EXECUTE [DMFD.Q],[DMFD.Res]
      IF [DMFD.Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die neuen Dokumenten-Manager-Ordner-Daten konnte nicht gendert werden',[MESSAGE_ERROR]
        CALC [DMFD.ItemID] AS 0.0
        EXIT_PROC
      END_IF
    END_PROC


  PROCEDURE DocMgrDateSave VS DocMgrDS.InfoStr, VS DocMgrDS.TableName, VF DocMgrDS.RecID, VN DocMgrDS.Days2Futur, VS DocMgrDS.MaskName
    IF [DocMgrDS.TableName]=''
      MESSAGE 'Achtung Abbruch','Es wurde kein Tabellen-Name fr das Anlegen eines Termins genannt',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    IF [DocMgrDS.InfoStr]=''
      MESSAGE 'Achtung Abbruch','Es wurde keine Notiz fr das Anlegen eines Termins genannt',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    IF [DocMgrDS.RecID]<[EPSILON]
      MESSAGE 'Achtung Abbruch','Es wurde keine Datensatz-ID fr das Anlegen eines Termins genannt',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    IF [DocMgrDS.Days2Futur]<0
      MESSAGE 'Achtung Abbruch','Es wurde versucht einen Termin in der Vergangenheit anzulegen',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    LOCAL_BOOL DocMgrDS.Result
    LOCAL_DATE DocMgrDS.ADate

    IDENTIFIER_EXIST 'DocMgrDS.ARecFlag',[DocMgrDS.Result]
    IF [DocMgrDS.Result]=FALSE
      VAR_NUM   DocMgrDS.ARecFlag
      VAR_FLOAT DocMgrDS.AHeaderID
    END_IF

    CALC [DocMgrDS.ADate] AS [DATE] + [DocMgrDS.Days2Futur]
    CALL DocMgrCheckHeader [DocMgrDS.TableName], [DocMgrDS.RecID], [DocMgrDS.ARecFlag], [DocMgrDS.AHeaderID]
    IF [DocMgrDS.AHeaderID]>[EPSILON]
      CALL DocMgrFastRsm [DocMgrDS.TableName], [DocMgrDS.RecID], [DocMgrDS.AHeaderID], [DocMgrDS.InfoStr], [DocMgrDS.ADate], '08:00', [DEFAULT_WIEDERV_MITID], [DocMgrDS.AHeaderID]
    END_IF

    IF [DocMgrDS.MaskName]<>''
      IF [DocMgrDS.ARecFlag]<>[[DocMgrDS.MaskName]!MASK_RECORD_FLAG]
        CALC [[DocMgrDS.MaskName]!MASK_RECORD_FLAG] AS [DocMgrDS.ARecFlag]
        MASK_UPDATE
      END_IF
    END_IF
  END_PROC




  PROCEDURE DocMgrDateDelete VB DocMgrDD.Ask, VS DocMgrDD.InfoStr, VS DocMgrDD.TableName, VF DocMgrDD.RecID, VN DocMgrDD.Days2Futur, VS DocMgrDD.MaskName
    LOCAL_BOOL  DocMgrDD.Res
    LOCAL_QUERY DocMgrDD.Q
    LOCAL_QUERY DocMgrDD.SubQ
    LOCAL_NUM   DocMgrDD.YNRes
    LOCAL_NUM   DocMgrDD.Max
    LOCAL_NUM   DocMgrDD.RFlag

    QUERY [DocMgrDD.Q]
      SELECT H.RecordID, I.RecordID, I.ItemNote
        FROM DocMgrH H, DocMgrI I
       WHERE H.RelRecID  =  [DocMgrDD.RecID|R0,0]
         AND H.TableName = "[DocMgrDD.TableName]"
         AND H.RecordID  =  I.HeaderID
         AND I.ItemNote  = "[DocMgrDD.InfoStr]"
    END_QUERY

    EXECUTE [DocMgrDD.Q],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Datenbank-Abfrage zum Laden eines Termins konnte nicht bersetzt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [DocMgrDD.Q],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      IF [DocMgrDD.Ask]
        CALC [DocMgrDD.YNRes] AS [ID_YES]
        GET_YES_NO 'Achtung!','Es ist derzeit kein Termin gespeichert!|Mchten Sie jetzt einen neuen Termin speichern ?',[DocMgrDD.YNRes]
        IF [DocMgrDD.YNRes]<>[ID_YES]
          EXIT_PROC
        ELSE
          CALL DocMgrDateSave [DocMgrDD.InfoStr], [DocMgrDD.TableName], [DocMgrDD.RecID], [DocMgrDD.Days2Futur], [DocMgrDD.MaskName]
          EXIT_PROC
        END_IF
      ELSE
        EXIT_PROC
      END_IF
    END_IF

    IF [DocMgrDD.Q!I.RecordID]<[EPSILON]
      EXIT_PROC
    END_IF

    IF [DocMgrDD.Ask]
      CALC [DocMgrDD.YNRes] AS [ID_NO]
      GET_YES_NO 'Abbruch','Mchten Sie den Termin lschen ?',[DocMgrDD.YNRes]
      IF [DocMgrDD.YNRes]<>[ID_YES]
        EXIT_PROC
      END_IF
    END_IF


    QUERY [DocMgrDD.SubQ]
      DELETE
        FROM notes
       WHERE RelRecID  = [DocMgrDD.Q!I.RecordID|R0,0]
         AND TableName = "DocMgrI"
    END_QUERY

    EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Notizen des Termins konnten nicht gelscht werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY [DocMgrDD.SubQ]
      DELETE
        FROM docmgri
       WHERE RecordID = [DocMgrDD.Q!I.RecordID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Der Termin konnte nicht gelscht werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF


    QUERY [DocMgrDD.SubQ]
      SELECT COUNT(RecordID)
        FROM docmgri
       WHERE HeaderID = [DocMgrDD.Q!H.RecordID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Abfrage zum Ermitteln der Anzahl der verbliebenen Dokumenten-Ordner-Eintrge konnte nicht gelscht werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Anzahl der verbliebenen Dokumenten-Ordner-Eintrge konnte nicht ermittelt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    IF [DocMgrDD.SubQ!COUNT(RecordID)]>0
      EXIT_PROC
    END_IF


    QUERY [DocMgrDD.SubQ]
      DELETE
        FROM notes
       WHERE RelRecID  = [DocMgrDD.Q!H.RecordID|R0,0]
         AND TableName = "DocMgrH"
    END_QUERY

    EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Notizen des Dokumenten-Ordners konnten nicht gelscht werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY [DocMgrDD.SubQ]
      DELETE
        FROM docmgrh
       WHERE RecordID = [DocMgrDD.Q!H.RecordID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Der Dokumenten-Ordner konnte nicht gelscht werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF



    QUERY [DocMgrDD.SubQ]
      SELECT COUNT(RecordID)
        FROM docmgrh
       WHERE RelRecID  =  [DocMgrDD.RecID|R0,0]
         AND TableName = "[DocMgrDD.TableName]"
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Abfrage zum Ermitteln der Anzahl der verbliebenen Dokumenten-Ordner konnte nicht gelscht werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Abbruch','Die Anzahl der verbliebenen Dokumenten-Ordner konnte nicht ermittelt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    IF [DocMgrDD.SubQ!COUNT(RecordID)]>0
      EXIT_PROC
    END_IF


    QUERY [DocMgrDD.SubQ]
      SELECT RecFlag
        FROM [DocMgrDD.TableName]
       WHERE RecordID  = [DocMgrDD.RecID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln des Status eines Datensatz konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Achtung Abbruch','Der Status eines Datensatzes konnte nicht ermittelt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [DocMgrDD.RFlag] AS [DocMgrDD.SubQ!RecFlag]
    FLAG_SET [DocMgrDD.RFlag],8192,FALSE


    QUERY [DocMgrDD.SubQ]
      UPDATE [DocMgrDD.TableName]
         SET RecFlag  = [DocMgrDD.RFlag]
       WHERE RecordID = [DocMgrDD.RecID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      MESSAGE 'Achtung Abbruch','Der Status eines Datensatz konnte nicht gesetzt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    IF [DocMgrDD.MaskName]<>''
      IF [DocMgrDD.RFlag]<>[[DocMgrDD.MaskName]!MASK_RECORD_FLAG]
        CALC [[DocMgrDD.MaskName]!MASK_RECORD_FLAG] AS [DocMgrDD.RFlag]
        MASK_UPDATE [[DocMgrDD.MaskName]]
      END_IF
    END_IF
  END_PROC



  PROCEDURE DocMgrDelete VS DocMgrDD.TableName, VF DocMgrDD.RecID, VS DocMgrDD.MaskName
    LOCAL_BOOL  DocMgrDD.Res
    LOCAL_QUERY DocMgrDD.Q
    LOCAL_QUERY DocMgrDD.SubQ
    LOCAL_NUM   DocMgrDD.RFlag
    LOCAL_FLOAT DocMgrDD.LastHeaderID
    LOCAL_FLOAT DocMgrDD.Float1

    QUERY [DocMgrDD.Q]
        SELECT H.RecordID, I.RecordID
          FROM DocMgrH H, DocMgrI I
         WHERE H.RelRecID  =  [DocMgrDD.RecID|R0,0]
           AND H.TableName = "[DocMgrDD.TableName]"
           AND H.RecordID  = I.HeaderID
      ORDER BY H.RecordID, I.RecordID
    END_QUERY

    EXECUTE [DocMgrDD.Q],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [DocMgrDD.Q],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [DocMgrDD.LastHeaderID] AS 0

    WHILE [DocMgrDD.Res]
      CALC [DocMgrDD.Float1] AS ABS([DocMgrDD.LastHeaderID]-[DocMgrDD.Q!H.RecordID])
      IF [DocMgrDD.Float1]>[EPSILON]
        QUERY [DocMgrDD.SubQ]
          DELETE
            FROM notes
           WHERE RelRecID  = [DocMgrDD.Q!H.RecordID|R0,0]
             AND TableName = "DocMgrH"
        END_QUERY
        EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]

        QUERY [DocMgrDD.SubQ]
          DELETE
            FROM DocMgrH
           WHERE RecordID  = [DocMgrDD.Q!H.RecordID|R0,0]
        END_QUERY
        EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]
      END_IF

      CALC [DocMgrDD.LastHeaderID] AS [DocMgrDD.Q!H.RecordID]

      QUERY [DocMgrDD.SubQ]
        DELETE
          FROM notes
         WHERE RelRecID  = [DocMgrDD.Q!I.RecordID|R0,0]
           AND TableName = "DocMgrI"
      END_QUERY
      EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]

      QUERY [DocMgrDD.SubQ]
        DELETE
          FROM DocMgrI
         WHERE RecordID  = [DocMgrDD.Q!I.RecordID|R0,0]
      END_QUERY
      EXECUTE [DocMgrDD.SubQ], [DocMgrDD.Res]

      GET_DATA [DocMgrDD.Q],[DocMgrDD.Res]
    END_WHILE

    QUERY [DocMgrDD.SubQ]
      SELECT RecFlag
        FROM [DocMgrDD.TableName]
       WHERE RecordID  = [DocMgrDD.RecID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [DocMgrDD.RFlag] AS [DocMgrDD.SubQ!RecFlag]
    FLAG_SET [DocMgrDD.RFlag],8192,FALSE

    QUERY [DocMgrDD.SubQ]
      UPDATE [DocMgrDD.TableName]
         SET RecFlag  = [DocMgrDD.RFlag]
       WHERE RecordID = [DocMgrDD.RecID|R0,0]
    END_QUERY

    EXECUTE [DocMgrDD.SubQ],[DocMgrDD.Res]
    IF [DocMgrDD.Res]=FALSE
      EXIT_PROC
    END_IF

    IF [DocMgrDD.MaskName]<>''
      IF [DocMgrDD.RFlag]<>[[DocMgrDD.MaskName]!MASK_RECORD_FLAG]
        CALC [[DocMgrDD.MaskName]!MASK_RECORD_FLAG] AS [DocMgrDD.RFlag]
        MASK_UPDATE [[DocMgrDD.MaskName]]
      END_IF
    END_IF
  END_PROC
