  ; dd 05.09.2007  Dieses Script durchluft alle Ordner.
  ;                Kontrolliert ob schon der Name des virtuellen Ordners vergeben wurde.
  ;
  ;                Wenn noch kein Ordner-Name vergeben wurde und dem Ordner bereits
  ;                Eintrge zugeordnet wurden, wird der Name des virtuellen Ordners
  ;                aus dem ersten Eintrag extrahiert, der die Bedingung erfllt,
  ;                dass der im FinePath hinetrlegte Dateiname mit "DOCUMENT_PATH\"
  ;                beginnt.



  PROCEDURE InitVars
    VAR_MASK  WorkMask, 'DocMgrChangeFolderDlg'
    VAR_NUM   YNRes
    VAR_BOOL  Res
    VAR_QUERY SelQ
    VAR_QUERY UpdQ
    VAR_NUM   Max
    VAR_NUM   Cnt
    VAR_NUM   SPos
    VAR_STR   Str1
    VAR_BOOL  SaveIt

    CALC [WorkMask!MASK_HOOK_EXIT]     AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE] AS 'PreSaveHook'
  END_PROC



  PROCEDURE CheckAndSetPath VS SourcePath
    CALC [SaveIt] AS FALSE

    CALC [Str1] AS LOWCASE([SourcePath])
    CALC [Str1] AS   TRIM([Str1])
    IF [Str1]<>''
      CALC [Str1] AS REPLACE([Str1],'document_path\','')
      CALC [Str1] AS    TRIM([Str1])
      IF [Str1]<>''
        EXIT_PROC
      END_IF
    END_IF

    QUERY [UpdQ]
      SELECT FilePath
        FROM docmgri
       WHERE HeaderID  = [SelQ!RecordID|R0,0]
         AND FilePath <> ""
    END_QUERY

    EXECUTE [UpdQ],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [UpdQ],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    WHILE [Res]
      CALC [Str1] AS LOWCASE([UpdQ!FilePath])
      CALC [SPos] AS POS('document_path\',[Str1])
      IF [SPos]=1
        CALC [Res] AS FALSE
      ELSE
        GET_DATA [UpdQ],[Res]
      END_IF
    END_WHILE

    IF [SPos]<>1
      EXIT_PROC
    END_IF

    FILE_PATH  [Str1],[Str1]
    FILE_SLASH [Str1], TRUE
    CALC [Str1] AS LOWCASE([Str1])
    IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
      CALC [Str1] AS DBL_BACK_SLASH([Str1])
    ELSE
      CALC [Str1] AS SGL_BACK_SLASH([Str1])
    END_IF

    CALC [SaveIt] AS TRUE
  END_PROC



  PROCEDURE CheckFolders
    QUERY [SelQ]
      SELECT FolderName, RecordID
        FROM docmgrh
       WHERE RecordID > 1000
    END_QUERY

    EXECUTE [SelQ],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Dokumenten-Ordner konnten abgefragt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SelQ],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [SelQ], [Max]
    CALC [Cnt] AS 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Str1] AS CON('berprfung des Ordners ',[Cnt],' von ',[Max])
      WAIT_INFO 'Bitte warten...', [Str1], FALSE, 70, 2

      CALL CheckAndSetPath [SelQ!FolderName]

      IF [SaveIt]
        QUERY [UpdQ]
          UPDATE docmgrh
             SET FolderName = "[Str1]"
           WHERE RecordID   =  [SelQ!RecordID|R0,0]
        END_QUERY

        EXECUTE [UpdQ],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Fehler','Ein Dokumenten-Ordner konnte nicht gendert werden.',[MESSAGE_ERROR]
        END_IF
      END_IF

      GET_DATA [SelQ],[Res]
    END_WHILE

    END_WAIT
  END_PROC



  PROCEDURE Main
    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Soll bei allen virtuellen Ordnern, denen bereits Dateien zugeordnet sind und bei denen der Ordner-Name noch leer ist, diese Ordner Namen aus den zugeordneten Dateien ermittelt werden?',[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF


    CALL CheckFolders
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
