  ; Parameter PAR_STR1   = StartDatum
  ;           PAR_STR2   = StopDatum
  ;           PAR_STR3   = Header (wie z.B. "alle Termine bis heute [22.11.2007]")

  PROCEDURE InitVars
    VAR_BROWSER B
    VAR_QUERY   Q
    VAR_BOOL    Res
    VAR_NUM     Marked
    VAR_NUM     RelRecFlag
    VAR_DATE    StartDate
    VAR_DATE    StopDate
    VAR_FLOAT   RecID
    VAR_STR     TimeClause

    CALC [StartDate] AS [PAR_STR1]
    IF [StartDate]<='01.01.1980'
      CALC [StartDate] AS '01.01.1990'
    END_IF
    CALC [StopDate]  AS [PAR_STR2]

    CALC [TimeClause] AS ''
    IF [RECORD_ID5]>[EPSILON]
      IF [StopDate]=[DATE]
        CALC [TimeClause] AS CON(' AND I.NextProcessTime <= ',[SQL_TIME_QUOTES_4_SELECT],[TIME|R0,[SQL_TIME_PICTURE_4_SELECT]],[SQL_TIME_QUOTES_4_SELECT],' ')
      END_IF
    END_IF
  END_PROC


  PROCEDURE Main
    BACK_MARK

    QUERY [B]
        SELECT [  W14 N"Wiedervorlage"      ]I.NextProcessDate,
               [  W06 N"um"   M"hh:mm"      ]I.NextProcessTime,
               [  W60 N"Datensatz"          ]D.FolderInfo,
               [  W60 N"Info"               ]I.ItemNote,
               [  W20 N"Ordner"             ]D.FileName,
               [  W10 N"vom"                ]D.FileDate,
               [H                           ]D.TableName,
               [H                           ]D.RelRecID,
               [H                           ]D.XRefName,
               [H                           ]D.FolderName,
               [H                           ]I.RecordID,
               [H C2A="[SQL_BOOLEAN_TRUE]"  ]I.TakeNotice,
               [H                           ]I.Termin,
               [H                           ]I.erledigt,
               [H                           ]D.RecordID,
               [H                           ]D.RecFlag

          FROM DocMgrH D, DocMgrI I

         WHERE D.RecordID         = I.HeaderID
           AND D.RecordID         > 1000
           AND I.NextProcessorID  = [ACT_MIT_ID|R0,0]
           AND I.NextProcessDate >= [SQL_DATE_QUOTES_4_SELECT][StartDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
           AND I.NextProcessDate <= [SQL_DATE_QUOTES_4_SELECT][StopDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
           AND (I.FinisherID      < 1 OR (I.Termin = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]    AND
                                          I.Erledigt = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]    ))
                [TimeClause]

      ORDER BY I.NextProcessDate DESC, I.NextProcessTime DESC
    END_QUERY

    EXECUTE [B], [Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Terminmanager-Abfrage konnte nicht bersetzt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY_COUNT [B],[Marked]
    IF [Marked]=0
      EXIT_PROC
    END_IF

    CALC [B!QUERY_ID] AS 'DocMgrShow001'
    FLAG_SET [B!VIEW_FLAG], [BROWSER_FLAG_SELECT_ALLOWED], TRUE

    VIEW [B], [Res], 'Terminliste', '', FALSE, TRUE

    IF [Res]
      QUERY_LIST_COUNT [B],[Marked]
      IF [Marked]>0
        QUERY_LIST_FIRST [B],[RecID]
        WHILE [RecID]>[EPSILON]
          QUERY [Q]
            UPDATE docmgri
               SET TakeNotice = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
             WHERE RecordID   = [RecID|R0,0]
          END_QUERY
          EXECUTE [Q],[Res]
          IF [Res]=FALSE
            MESSAGE 'Achtung Fehler','Die Zurkenntnisnahme eines Termins konnte nicht gespeichert werden',[MESSAGE_ERROR]
          END_IF

          QUERY_LIST_NEXT [B],[RecID]
        END_WHILE
      ELSE
        CALC [RelRecFlag] AS 0

        QUERY [Q]
          SELECT RecFlag
            FROM [B!D.TableName]
           WHERE RecordID = [B!D.RelRecID|R0,0]
        END_QUERY

        EXECUTE [Q],[Res]
        IF [Res]
          GET_DATA [Q],[Res]
          IF [Res]
            CALC [RelRecFlag] AS [Q!RecFlag]
          ELSE
            MESSAGE 'Achtung!','Die zugehrige Datensatz ist nicht mher vorhanden!',[MESSAGE_ERROR]
          END_IF
        ELSE
          MESSAGE 'Achtung!','Die zugehrige Tabelle kann nicht gelesen werden!',[MESSAGE_ERROR]
        END_IF

        ; Parameters : PAR_STR1    TableName
        ;              PAR_STR2    XRefName     / kann leer sein
        ;              RECORD_ID3  RecFlag
        ;              RECORD_ID4  RelRecID
        ;              RECORD_ID5  RightsFlag   / kann 0 sein
        ;              PAR_STR6    Header       / kann leer sein
        ;              RECORD_ID7  ItemID       >0 /  0 / -1
        SCRIPT [DOCU_MGR_MAIN_SCRIPT], [B!D.TableName], [B!D.XRefName], [RelRecFlag], [B!D.RelRecID], 0, [B!D.FolderInfo], [B!I.RecordID]

        BACK_JUMP
      END_IF
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END