  INCLUDE DocMgrRoutines.inc

  PROCEDURE DocMgrUtilInitVars
    LOCAL_BOOL  LocRes
    IDENTIFIER_EXIST 'DM_MASK_UPDATE_YES',[LocRes]
    IF [LocRes]
      EXIT_PROC
    END_IF

    IDENTIFIER_EXIST 'GlobSelectionList',[LocRes]
    IF [LocRes]=FALSE
      GLOBAL_LIST GlobSelectionList
      LIST_CLR [GlobSelectionList]
    END_IF
                ; 1 = Kategorien
                ; 2 = Ordner
                ; 4 = Themen
                ; 8 = Physicalische Ordner
    CONST_NUM   DM_WORK_MODE_DOC_CHOOSER,      15

    CONST_NUM   DM_WORK_MODE_DOC_MANAGER,      0
    CONST_NUM   DM_WORK_MODE_DASHBOARD_TICKET, 1

    CONST_BOOL  DM_INSERT_PATH_DUMMY,          TRUE
    CONST_BOOL  DM_REMOVE_PATH_DUMMY,          FALSE

    CONST_FLOAT DM_TICKET_CATEGORY,            7858742536656
    CONST_FLOAT DM_WEBPIC_CATEGORY,            7848942608707

    CONST_NUM   DM_DOC_MGR_FLAG,               8192

    CONST_BOOL  DM_MASK_UPDATE_YES,            TRUE
    CONST_BOOL  DM_MASK_UPDATE_NO,             FALSE

    CONST_BOOL  DM_VIEW_LIST_YES,              TRUE
    CONST_BOOL  DM_VIEW_LIST_NO,               FALSE

    CONST_BOOL  DM_CHECK_POSSIBLE_ERRORS_YES,  TRUE
    CONST_BOOL  DM_CHECK_POSSIBLE_ERRORS_NO,   FALSE

    CONST_BOOL  DM_SSH_UPLOAD,                 FALSE
    CONST_BOOL  DM_FTP_UPLOAD,                 TRUE

    VAR_STR     DM_SQL_CATEGORY
    VAR_STR     DM_SQL_CATEGORY_STR

    VAR_STR     DMDir

    ; z.B. BMZ = "IdealDocumentManager" (Alle Dokumnete liegen in DOCUMENT_PATH und dann noch in diesem Unterordner)
    VAR_STR     DMDocumentSubFolder,           ''

    ; z.B. OVS = "Ablage" (Alle Dokumnete, die per Drag&Drop auf eine Adressmaske gezogen werden, liegen in DOCUMENT_PATH und dann noch in diesem Unterordner)
    VAR_STR     DMDocumentTrayFolder,          ''


    VAR_STR     DM_SINGLE_QUOTE
    CALC [DM_SINGLE_QUOTE] AS CHAR(#39)

    ; opcode compilierte INI-Datei?
    EXIST_FILE [APPLICATION_INI_FILE],[LocRes]
    IF [LocRes]
      INI_READ [LocRes],[DMDocumentSubFolder],[SCRIPT_STRING],[APPLICATION_INI_FILE],'DocumentSubPath','config'
      IF [LocRes]
        IF [DMDocumentSubFolder]<>''
          CALC [DMDocumentSubFolder] AS LOWCASE([DMDocumentSubFolder])
          FILE_SLASH [DMDocumentSubFolder], TRUE
        END_IF
      ELSE
        CALC [DMDocumentSubFolder] AS ''
      END_IF

      INI_READ [LocRes],[DMDocumentTrayFolder],[SCRIPT_STRING],[APPLICATION_INI_FILE],'DocumentTrayPath','config'
      IF [LocRes]
        IF [DMDocumentTrayFolder]<>''
          CALC [DMDocumentTrayFolder] AS LOWCASE([DMDocumentTrayFolder])
          FILE_SLASH [DMDocumentTrayFolder], TRUE
        END_IF
      ELSE
        CALC [DMDocumentTrayFolder] AS ''
      END_IF
    END_IF

    IDENTIFIER_EXIST 'SQL_COLON_REPLACE',[LocRes]
    IF [LocRes]=FALSE
      GLOBAL_STR SQL_COLON_REPLACE
      CALC [SQL_COLON_REPLACE] AS ''
    END_IF

    CALC [DM_SQL_CATEGORY_STR] AS ''
    CALC [DM_SQL_CATEGORY]     AS CON('C.Ziffer ',[SQL_CONCATE],' ',[DM_SINGLE_QUOTE],'.',[DM_SINGLE_QUOTE],' ',[SQL_CONCATE],' C.Bezeichnung')
    IF [SQL_VENDOR]='MSSQL'
      CALC [DM_SQL_CATEGORY]     AS CON('RTRIM(CAST(C.Ziffer AS CHAR(50))) + ',[DM_SINGLE_QUOTE],'.',[DM_SINGLE_QUOTE],' + RTRIM(CAST(C.Bezeichnung AS CHAR(100)))')
      CALC [DM_SQL_CATEGORY_STR] AS [DM_SQL_CATEGORY]
    ELSE_IF [SQL_VENDOR]='MYSQL'
      CALC [DM_SQL_CATEGORY]     AS CON([SQL_CONCATE],'C.Ziffer',[SQL_COLON_REPLACE],[DM_SINGLE_QUOTE],'.',[DM_SINGLE_QUOTE],[SQL_COLON_REPLACE],'C.Bezeichnung)')
      CALC [DM_SQL_CATEGORY_STR] AS CON([SQL_CONCATE],'C.Ziffer,',[DM_SINGLE_QUOTE],'.',[DM_SINGLE_QUOTE],',C.Bezeichnung)')
    ELSE_IF [SQL_VENDOR]='SQLITE'
      CALC [DM_SQL_CATEGORY]     AS CON('C.Ziffer || C.Bezeichnung')
      CALC [DM_SQL_CATEGORY_STR] AS [DM_SQL_CATEGORY]
    END_IF
    IF [DM_SQL_CATEGORY_STR]=''
      CALC [DM_SQL_CATEGORY_STR] AS FILTER([DM_SQL_CATEGORY],' ')
    ELSE
      CALC [DM_SQL_CATEGORY_STR] AS FILTER([DM_SQL_CATEGORY_STR],' ')
    END_IF
    CALC [DM_SQL_CATEGORY_STR] AS COPY([DM_SQL_CATEGORY_STR],1,64)


    VAR_BOOL    LRBTD.Res
    VAR_NUM     LRBTD.TmpNum
    VAR_NUM     LRBTD.LnCnt
    VAR_NUM     LRBTD.LnMax
    VAR_NUM     LRBTD.VarType
    VAR_STR     LRBTD.MaskName
    VAR_STR     LRBTD.MaskField
    VAR_QUERY   LRBTD.Q1
    VAR_BROWSER LRBTD.Q2
    VAR_STR     LRBTD.TmpStr
    VAR_STR     LRBTD.Operator, ' = '
    VAR_LIST    LRBTD.FQuery
  END_PROC



  PROCEDURE DocMgrFixPath VS DMFP.PathStr, VB DMFP.InsertDummyPath, ~VS DMFP.ResultStr
    LOCAL_STR DMFP.FindStr
    LOCAL_NUM DMFP.SPos
    LOCAL_NUM DMFP.SLen

    CALC [DMFP.ResultStr] AS [DMFP.PathStr]

    CALC [DMFP.PathStr]   AS    TRIM([DMFP.PathStr])
    CALC [DMFP.PathStr]   AS LOWCASE([DMFP.PathStr])
    IF [DMFP.InsertDummyPath]
      CALC [DMFP.FindStr] AS LOWCASE([DOCUMENT_PATH])
    ELSE
      CALC [DMFP.FindStr] AS 'document_path\'
    END_IF

    CALC [DMFP.SPos] AS POS([DMFP.FindStr],[DMFP.PathStr])
    IF [DMFP.SPos]<>1
      EXIT_PROC
    END_IF

    CALC [DMFP.SLen]    AS LEN([DMFP.FindStr])
    CALC [DMFP.SPos]    AS [DMFP.SLen]+1
    CALC [DMFP.PathStr] AS COPY([DMFP.ResultStr],[DMFP.SPos],255)

    IF [DMFP.InsertDummyPath]
      CALC [DMFP.PathStr] AS CON('document_path\',[DMFP.PathStr])
    ELSE
      CALC [DMFP.PathStr] AS CON([DOCUMENT_PATH], [DMFP.PathStr])
    END_IF

    CALC [DMFP.ResultStr] AS [DMFP.PathStr]
  END_PROC



  PROCEDURE DocMgrUtilLoadRelationByTableFld VS LRBTD.XRefName, VS LRBTD.TableName, VS LRBTD.VarName, VS LRBTD.IDVarName, VB LRBTD.MaskUpdate, VB LRBTD.ViewList, VB LRBTD.ChecksOn
    CALL DocMgrUtilInitVars

    ; Diese Routine ld aus der Tabelle "TableDef" die Einstellungen zu der
    ; X-Referenz "LRBTD.XRefName" oder (wenn "LRBTD.XRefName" leer sein sollte)
    ; zu der Tabelle "LRBTD.TableName".
    ;
    ; Anschlieend wird entweder das in den Einstellungen hinterlegte Query zum Laden
    ; des Datensatzes mit der RecordID "[[LRBTD.IDVarBane]]" verwendet - oder es wird
    ; einfach folgendes durchgefhrt :
    ; SELECT * FROM "TableName-in-den-Einstellungen" WHERE RecordID = [[LRBTD.IDVarName]]
    ;
    ; In der Variable mit dem Namen "LRBTD.VarName" wird dann das Ergebnis plaziert.
    ; Dabei werden genau die Felder zur Anzeige gebracht, die in den Einstellungen
    ; der TableDef hinterlegt wurden. "LRBTD.VarName" mu eine Varibale vom vom Type
    ; VAR_STR benennen.
    ;
    ; Wenn "LRBTD.MaskUpdate" TRUE ist und "LRBTD.VarName" den FeldNamen einer Maske
    ; bezeichnet, wird nach dem Fllen der Variable ein MASK_UPDATE ausgefhrt.
    ;
    ; Wenn "LRBTD.ViewList" TRUE ist, wird dem Benutzer die Mglichkeit zur Auswahl
    ; eines Datensatzes geboten - anderenfalls wird einfach nur der Datensatz mit der
    ; RecordID "[[LRBTD.IDVarName]]" geladen. Falls ein Datensatz gewhlt wurde, wird die
    ; RecordID in [[LRBTD.IDVarName]] zurckgegeben.
    ;
    ; Wenn man sich sicher ist, da beim Laden der Einstellungen aus der Tabelle
    ; TableDef sinnvolle Ergebnisse zustande kommen und man in den Aufrufen keine
    ; Fehler gemacht hat, kann man eine Reihe von Tests unterdrcken indem man
    ; "LRBTD.ChecksOn" FALSE bergibt. Dadurch wird der Ladevorgang beschleunigt.
    ;
    WAIT_CURSOR TRUE

    IF [LRBTD.ChecksOn]
      IF [LRBTD.XRefName]=''
        IF [LRBTD.TableName]=''
          WAIT_CURSOR FALSE
          EXIT_PROC
        END_IF
      END_IF

      IF [LRBTD.VarName]=''
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      IDENTIFIER_EXIST [LRBTD.VarName],[LRBTD.Res],[LRBTD.TmpNum],[LRBTD.VarType]
      IF [LRBTD.Res]=FALSE
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      IF [LRBTD.VarType]<>[SCRIPT_STRING]
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF
    END_IF

    CALC [[LRBTD.VarName]] AS ''

    CALC [LRBTD.MaskName]    AS ''
    CALC [LRBTD.MaskField]   AS ''
    CALC [LRBTD.TmpNum]      AS POS('!',[LRBTD.VarName])
    IF [LRBTD.TmpNum]>0
      DEC  [LRBTD.TmpNum]
      CALC [LRBTD.MaskName]  AS COPY([LRBTD.VarName],1,[LRBTD.TmpNum])
      CALC [LRBTD.TmpNum]    AS [LRBTD.TmpNum] + 2
      CALC [LRBTD.MaskField] AS COPY([LRBTD.VarName],[LRBTD.TmpNum],255)
    END_IF

    IF [LRBTD.ViewList]=FALSE
      IF [[LRBTD.IDVarName]]<=[EPSILON]
        IF [LRBTD.MaskUpdate]
          IF [LRBTD.MaskName]<>''
            MASK_UPDATE [[LRBTD.MaskName]]
          END_IF
        END_IF

        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF
    ELSE
;     CALC [LRBTD.Operator] AS ' >= '
      CALC [LRBTD.Operator] AS ' = '
    END_IF

    IF [LRBTD.XRefName]<>''
      CALC [LRBTD.TmpStr] AS CON('WHERE XRefName  = "',[LRBTD.XRefName],'" ')
      QUERY [LRBTD.Q1]
        SELECT *
          FROM TableFld
        [LRBTD.TmpStr]
      END_QUERY

      EXECUTE [LRBTD.Q1], [LRBTD.Res]
      IF [LRBTD.Res]=FALSE
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LRBTD.Q1], [LRBTD.Res]
    ELSE
      CALC [LRBTD.Res] AS FALSE
    END_IF

    IF [LRBTD.Res]=FALSE
      CALC [LRBTD.TmpStr] AS CON('WHERE TableName = "',[LRBTD.TableName],'" ')
      QUERY [LRBTD.Q1]
        SELECT *
          FROM TableFld
        [LRBTD.TmpStr]
      END_QUERY

      EXECUTE [LRBTD.Q1], [LRBTD.Res]
      IF [LRBTD.Res]=FALSE
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LRBTD.Q1], [LRBTD.Res]
      IF [LRBTD.Res]=FALSE
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF
    END_IF


    IF [LRBTD.Q1!FieldQuery]<>''
      IF [LRBTD.ChecksOn]
        QUERY [LRBTD.Q2]
          [LRBTD.Q1!FieldQuery]
        END_QUERY

        EXECUTE [LRBTD.Q2], [LRBTD.Res]
        IF [LRBTD.Res]=FALSE
          WAIT_CURSOR FALSE
          EXIT_PROC
        END_IF

        CALC [LRBTD.TmpStr] AS CON([LRBTD.Q2!QUERY_DESCR_REC_ID],[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
      ELSE
        CALC [LRBTD.TmpStr] AS COPY([LRBTD.Q1!TableName],1,1)
        CALC [LRBTD.TmpStr] AS CON([LRBTD.TmpStr],'.RecordID',[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
      END_IF

      QUERY [LRBTD.Q2]
        [LRBTD.Q1!FieldQuery]
      END_QUERY
    ELSE
      CALC [LRBTD.LnMax] AS 0
      NOTE_READ [LRBTD.FQuery],[LRBTD.Res],'tablefld',1,[LRBTD.Q1!RecordID]
      IF [LRBTD.Res]
        LIST_ITEM_GET [LRBTD.FQuery],[LRBTD.LnCnt],[LRBTD.LnMax]
      END_IF

      IF [LRBTD.LnMax]>0
        QUERY [LRBTD.Q2]
        END_QUERY
        LIST_2_QUERY [LRBTD.FQuery], [LRBTD.Q2]

        IF [LRBTD.ChecksOn]
          EXECUTE [LRBTD.Q2], [LRBTD.Res]
          IF [LRBTD.Res]=FALSE
            WAIT_CURSOR FALSE
            EXIT_PROC
          END_IF

          CALC [LRBTD.TmpStr] AS CON('RecordID',[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
          IF [LRBTD.Q2!QUERY_DESCR_REC_ID]<>''
            CALC [LRBTD.TmpStr] AS CON([LRBTD.Q2!QUERY_DESCR_REC_ID],[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
          END_IF

          QUERY [LRBTD.Q2]
          END_QUERY
          LIST_2_QUERY [LRBTD.FQuery], [LRBTD.Q2]
        ELSE
          LIST_STR_GET [LRBTD.FQuery],[LRBTD.TmpStr],1
          CALC [LRBTD.TmpNum] AS POS('.',[LRBTD.TmpStr])
          IF [LRBTD.TmpNum]>0
            CALC [LRBTD.TmpStr] AS PART([LRBTD.TmpStr],1,'.')
            CALC [LRBTD.TmpStr] AS TRIM([LRBTD.TmpStr])
            CALC [LRBTD.TmpStr] AS PART([LRBTD.TmpStr],2,' ')
            CALC [LRBTD.TmpStr] AS  CON([LRBTD.TmpStr],'.RecordID',[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
          ELSE
            CALC [LRBTD.TmpStr] AS CON('RecordID',[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
          END_IF
        END_IF
      ELSE
        QUERY [LRBTD.Q2]
          SELECT *
            FROM [LRBTD.Q1!TableName]
        END_QUERY

        CALC [LRBTD.TmpStr] AS CON('RecordID',[LRBTD.Operator],[[LRBTD.IDVarName]|R0,0])
      END_IF
    END_IF

    IF [LRBTD.ViewList]
      IF [[LRBTD.IDVarName]]>[EPSILON]
        CALC [LRBTD.TmpStr] AS CON('STARTING WITH ',[LRBTD.TmpStr])
        QUERY_ADD_STRING [LRBTD.Q2],[LRBTD.TmpStr]
      END_IF
    ELSE
      QUERY_ADD_WHERE [LRBTD.Q2],255,[LRBTD.TmpStr]
    END_IF

    IF [LRBTD.ViewList]
      IF [LRBTD.XRefName]<>''
        CALC [LRBTD.Q2!QUERY_ID] AS CON('DocMgrUtils001_' + [LRBTD.XRefName])
      ELSE
        CALC [LRBTD.Q2!QUERY_ID] AS CON('DocMgrUtils001_' + [LRBTD.TableName])
      END_IF

      VIEW [LRBTD.Q2], [LRBTD.Res], [LRBTD.Q1!Name]
      CALC [LRBTD.Q2!QUERY_ID] AS ''

      IF [LRBTD.Res]=FALSE
        IF [[LRBTD.IDVarName]]>[EPSILON]
          CALC [LRBTD.TmpNum] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die bestehende Relation aufheben?',[LRBTD.TmpNum]
          IF [LRBTD.TmpNum]=[ID_YES]
            CALC [[LRBTD.IDVarName]] AS 0.0
            CALC [[LRBTD.VarName]]   AS ''

            IF [LRBTD.MaskUpdate]
              IF [LRBTD.MaskName]<>''
                MASK_UPDATE [[LRBTD.MaskName]]
              END_IF
            END_IF
          END_IF
        END_IF

        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      CALC [[LRBTD.IDVarName]] AS [LRBTD.Q2![LRBTD.Q2!QUERY_DESCR_REC_ID]]
    ELSE
      EXECUTE [LRBTD.Q2], [LRBTD.Res]
      IF [LRBTD.Res]=FALSE
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LRBTD.Q2], [LRBTD.Res]
      IF [LRBTD.Res]=FALSE
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF
    END_IF

    IF [LRBTD.Q1!FieldName1]<>''
      CALC [[LRBTD.VarName]] AS [LRBTD.Q2![LRBTD.Q1!FieldName1]]
    END_IF

    IF [LRBTD.Q1!FieldName2]<>''
      IF [[LRBTD.VarName]]<>''
        CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],', ')
      END_IF

      CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],[LRBTD.Q2![LRBTD.Q1!FieldName2]])
    END_IF

    IF [LRBTD.Q1!FieldName3]<>''
      IF [[LRBTD.VarName]]<>''
        CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],', ')
      END_IF

      CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],[LRBTD.Q2![LRBTD.Q1!FieldName3]])
    END_IF

    IF [LRBTD.Q1!FieldName4]<>''
      IF [[LRBTD.VarName]]<>''
        CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],', ')
      END_IF

      CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],[LRBTD.Q2![LRBTD.Q1!FieldName4]])
    END_IF

    IF [LRBTD.Q1!FieldName5]<>''
      IF [[LRBTD.VarName]]<>''
        CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],', ')
      END_IF

      CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],[LRBTD.Q2![LRBTD.Q1!FieldName5]])
    END_IF

    IF [LRBTD.Q1!FieldName6]<>''
      IF [[LRBTD.VarName]]<>''
        CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],', ')
      END_IF

      CALC [[LRBTD.VarName]] AS CON([[LRBTD.VarName]],[LRBTD.Q2![LRBTD.Q1!FieldName6]])
    END_IF

    IF [LRBTD.MaskUpdate]
      IF [LRBTD.MaskName]<>''
        MASK_UPDATE [[LRBTD.MaskName]]
      END_IF
    END_IF

    WAIT_CURSOR FALSE
  END_PROC



  PROCEDURE DMDropDocs2Mask VS DMDD2A.MaskVarName
    LOCAL_NUM     LocLnCnt
    LOCAL_NUM     LocLnMax
    LOCAL_NUM     LocFCnt
    LOCAL_NUM     LocSLen
    LOCAL_STR     LocDir
    LOCAL_STR     LocRealDir
    LOCAL_STR     LocStr1
    LOCAL_STR     LocStr2
    LOCAL_STR     LocStr3
    LOCAL_STR     LocStr4
    LOCAL_STR     LocStr5
    LOCAL_STR     LocThema
    LOCAL_BOOL    LocRes
    LOCAL_QUERY   LocQ
    LOCAL_BROWSER LocB
    LOCAL_TIME    LocTime
    LOCAL_FLOAT   LocItemID
    IDENTIFIER_EXIST 'DrHo.HeaderID',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR     DrHo.FolderInfo
      VAR_FLOAT   DrHo.HeaderID
      VAR_NUM     DrHo.ARecFlag
    END_IF

    IF [[DMDD2A.MaskVarName]!MASK_RECORD_ID]<=[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst eine Adresse aus.',[MESSAGE_WARNING]
      CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [[DMDD2A.MaskVarName]!MASK_DROP_LIST],[LocLnCnt],[LocLnMax]
    IF [LocLnMax]=0
      CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Die Dateien werden verarbeitet...'

    CALC [LocStr4]   AS LOWCASE([[DMDD2A.MaskVarName]!MASK_BASE])
    CALC [LocStr5]   AS LOWCASE([[DMDD2A.MaskVarName]!MASK_XREF_NAME])

    CALC [LocItemID] AS [[DMDD2A.MaskVarName]!MASK_RECORD_ID]
    CALL DocMgrCheckHeader [LocStr4], [LocItemID], [DrHo.ARecFlag], [DrHo.HeaderID]
    CALC [[DMDD2A.MaskVarName]!MASK_RECORD_FLAG] AS [DrHo.ARecFlag]
    MASK_UPDATE [[DMDD2A.MaskVarName]]


    CALL DocMgrUtilInitVars
    CALC [LocStr1] AS CON([DMDD2A.MaskVarName],'!MASK_RECORD_ID')
    CALL DocMgrUtilLoadRelationByTableFld [LocStr5], [LocStr4], 'DrHo.FolderInfo', [LocStr1], [DM_MASK_UPDATE_NO], [DM_VIEW_LIST_NO], [DM_CHECK_POSSIBLE_ERRORS_NO]

    CALC [LocThema] AS ''
    QUERY [LocQ]
      SELECT DISTINCT I.ThreadName
        FROM docmgri I
       WHERE I.HeaderID    = [DrHo.HeaderID|R0,0]
         AND I.HeaderID    > 1000
         AND I.ThreadName <> ""
    END_QUERY
    EXECUTE [LocQ], [LocRes]
    IF [LocRes]
      GET_DATA [LocQ], [LocRes]
      IF [LocRes]
        QUERY [LocB]
            SELECT [W40 N"Thema"]DISTINCT I.ThreadName
              FROM docmgri I
             WHERE I.HeaderID    = [DrHo.HeaderID|R0,0]
               AND I.HeaderID    > 1000
               AND I.ThreadName <> ""
          ORDER BY I.ThreadName
        END_QUERY
        CALC [LocB!QUERY_ID] AS 'DocMgrUtilsThemes01'
        VIEW [LocB],[LocRes],'Bitte das Thema auswhlen. (ESC = keines der gezeigten Themen)'
        IF [LocRes]
          CALC [LocThema] AS [LocB!DISTINCTI.ThreadName]
        END_IF
      END_IF
    END_IF

    CALC [LocStr1] AS [DrHo.FolderInfo]
    IF [LocStr4]='adressen'
      CALC [LocStr1] AS FILTER([LocStr1],'.,:;-0123456789+#?=)(/&%$"!^`@')
    ELSE
      CALC [LocStr1] AS FILTER([LocStr1],'.,:;-+#?=)(/&%$"!^`@')
    END_IF
    CALC [LocStr1] AS REPLACE([LocStr1],'  ',' ')
    CALC [LocStr1] AS REPLACE([LocStr1],'  ',' ')
    CALC [LocStr1] AS REPLACE([LocStr1],'  ',' ')
    CALC [LocStr1] AS REPLACE([LocStr1],'  ',' ')
    CALC [LocStr1] AS REPLACE([LocStr1],' ','_')
    CALC [LocStr1] AS LOWCASE([LocStr1])
    CALC [LocStr1] AS REPLACE([LocStr1],'','ae')
    CALC [LocStr1] AS REPLACE([LocStr1],'','oe')
    CALC [LocStr1] AS REPLACE([LocStr1],'','ue')
    CALC [LocStr1] AS REPLACE([LocStr1],'','ss')
    CALC [LocStr1] AS REPLACE([LocStr1],'','a')
    CALC [LocStr1] AS REPLACE([LocStr1],'','a')
    CALC [LocStr1] AS REPLACE([LocStr1],'','a')
    CALC [LocStr1] AS REPLACE([LocStr1],'','e')
    CALC [LocStr1] AS REPLACE([LocStr1],'','e')
    CALC [LocStr1] AS REPLACE([LocStr1],'','e')
    CALC [LocStr1] AS REPLACE([LocStr1],'','u')
    CALC [LocStr1] AS REPLACE([LocStr1],'','u')
    CALC [LocStr1] AS REPLACE([LocStr1],'','u')
    CALC [LocStr1] AS REPLACE([LocStr1],'','o')
    CALC [LocStr1] AS REPLACE([LocStr1],'','o')
    CALC [LocStr1] AS REPLACE([LocStr1],'','o')
    CALC [LocStr1] AS REPLACE([LocStr1],'','i')
    CALC [LocStr1] AS REPLACE([LocStr1],'','i')
    CALC [LocStr1] AS REPLACE([LocStr1],'','i')

    CALC [LocDir]  AS CON([DOCUMENT_PATH],[DMDocumentTrayFolder])

    IF [LocStr1]<>''
      CALC [LocDir]  AS CON([LocDir],[LocStr1])
      CALC [LocSLen] AS LEN([LocDir])
      IF [LocSLen]>0
        CALC [LocStr1] AS COPY([LocDir],[LocSLen],1)
      ELSE
        CALC [LocStr1] AS ''
      END_IF
      IF [LocStr1]<>'\'
        FILE_SLASH [LocDir], TRUE
      END_IF

      CALC [LocDir] AS REPLACE([LocDir],'\_\','\')

      CALC [LocDir] AS REPLACE([LocDir],'\_','\')
      CALC [LocDir] AS REPLACE([LocDir],'\_','\')
      CALC [LocDir] AS REPLACE([LocDir],'\_','\')

      CALC [LocDir] AS REPLACE([LocDir],'_\','\')
      CALC [LocDir] AS REPLACE([LocDir],'_\','\')
      CALC [LocDir] AS REPLACE([LocDir],'_\','\')
    END_IF

    CALC [LocStr1] AS [LocDir]
    EXIST_DIR [LocStr1],[LocRes]
    IF [LocRes]=FALSE
      FORCE_DIR [LocRes],[LocStr1]
      IF [LocRes]=FALSE
        CALC [LocStr1] AS CON('Folgendes Verzeichnis kann nicht angelegt werden|',[LocStr1])
        END_WAIT
        MESSAGE 'Achtung Fehler!',[LocStr1],[MESSAGE_ERROR]
        CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
        EXIT_PROC
      END_IF
    END_IF

    CALC [LocRealDir] AS [LocDir]
    CALL DocMgrFixPath [LocDir], [DM_INSERT_PATH_DUMMY], [DMDir]
    CALC [LocDir]     AS [DMDir]

    CALC [LocLnCnt] AS 1
    WHILE [LocLnCnt]<=[LocLnMax]
      LIST_STR_GET [[DMDD2A.MaskVarName]!MASK_DROP_LIST],[LocStr1],[LocLnCnt]
      EXIST_FILE [LocStr1],[LocRes]
      IF [LocRes]
        NEW_RECORD [LocRes],'docmgri',[LocItemID], TRUE, FALSE, FALSE
        IF [LocRes]=FALSE
          END_WAIT
          MESSAGE 'Achtung Fehler','Es konnte kein neuer Datensatz in der Tabelle "docmgri" erzeugt werden.',[MESSAGE_ERROR]
          CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
          EXIT_PROC
        END_IF

        FILE_NAME [LocStr3],[LocStr1]
        CALC [LocStr2] AS CON([LocDir],[LocStr3])

        CALC [LocFCnt] AS 0

        BACK_MARK

        CALC [LocStr5] AS CON([LocRealDir],[LocStr3])
        EXIST_FILE [LocStr5],[LocRes]
        IF [LocRes]
          FILE_EXT [LocStr4], [LocStr3]
          IF [LocStr4]<>''
            CALC [LocStr3] AS PART([LocStr3],1,[LocStr4])
          END_IF
          IF [LocFCnt]>0
            CALC [LocSLen] AS LEN([LocStr3])
            CALC [LocSLen] AS [LocSLen] - 5
            CALC [LocStr3] AS COPY([LocStr3],1,[LocSLen])
          END_IF
          INC [LocFCnt]

          CALC [LocStr5] AS     [LocFCnt]
          CALC [LocStr5] AS EXT([LocStr5],3,48,2,1)
          CALC [LocStr3] AS CON([LocStr3],'__',[LocStr5],[LocStr4])
          CALC [LocStr2] AS CON([LocDir],[LocStr3])

          BACK_JUMP
        END_IF

        IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
          CALC [LocStr2] AS DBL_BACK_SLASH([LocStr2])
        ELSE
          CALC [LocStr2] AS SGL_BACK_SLASH([LocStr2])
        END_IF


        QUERY [LocQ]
          UPDATE docmgri

             SET CreateDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
                 CreateTime         =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
                 CreateRunDate      =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
                 CreateRunTime      =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],

                 NextProcessDate    =  [DEFAULT_DATE_4_MODIFY],
                 NextProcessTime    =  [SQL_TIME_QUOTES_4_MODIFY][LocTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
                 NextProcessRunDate =  [DEFAULT_DATE_4_MODIFY],
                 NextProcessRunTime =  [SQL_TIME_QUOTES_4_MODIFY][LocTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],

                 FinishDate         =  [DEFAULT_DATE_4_MODIFY],
                 FinishTime         =  [SQL_TIME_QUOTES_4_MODIFY][LocTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
                 FinishRunDate      =  [DEFAULT_DATE_4_MODIFY],
                 FinishRunTime      =  [SQL_TIME_QUOTES_4_MODIFY][LocTime|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],

                 ItemNote           = "[LocStr3]",
                 FilePath           = "[LocStr2]",
                 ThreadName         = "[LocThema]",

                 CreatorID          =  [ACT_MIT_ID|R0,0],
                 HeaderID           =  [DrHo.HeaderID|R0,0]

           WHERE RecordID           =  [LocItemID|R0,0]
        END_QUERY

        EXECUTE [LocQ], [LocRes]
        IF [LocRes]

          CALL DocMgrFixPath [LocStr2], [DM_REMOVE_PATH_DUMMY], [DMDir]
          CALC [LocStr2] AS [DMDir]
          FILE_COPY [LocRes], [LocStr1], [LocStr2]
          IF [LocRes]
            FILE_DELETE [LocRes], [LocStr1]
            IF [LocRes]=FALSE
              CALC [LocStr1] AS CON('Folgende Datei konnte nicht gelscht werden|',[LocStr1])
              END_WAIT
              MESSAGE 'Achtung Fehler!',[LocStr1],[MESSAGE_WARNING]
              CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
            END_IF
          ELSE
            END_WAIT
            FILE_NAME [LocStr1], [LocStr2]
            CALC [LocStr1] AS CON('Folgende Datei konnt enicht kopiert werden|',[LocStr1])
            MESSAGE 'Achtung Fehler!',[LocStr1],[MESSAGE_WARNING]
            QUERY [LocQ]
              DELETE FROM docmgri WHERE RecordID = [LocItemID|R0,0]
            END_QUERY
            EXECUTE [LocQ],[LocRes]
            CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
            EXIT_PROC
          END_IF
        ELSE
          END_WAIT
          MESSAGE 'Achtung Fehler','Der Ordner-Eintrag konnte nicht gespeichert werden.',[MESSAGE_ERROR]
          QUERY [LocQ]
            DELETE FROM docmgri WHERE RecordID = [LocItemID|R0,0]
          END_QUERY
          EXECUTE [LocQ],[LocRes]
          CALC [[DMDD2A.MaskVarName]!MASK_ACTION] AS 1
          EXIT_PROC
        END_IF
      END_IF
      INC [LocLnCnt]
    END_WHILE

    MASK_COMMAND [[DMDD2A.MaskVarName]],[MASK_COMMAND_SEARCH]

    END_WAIT
  END_PROC