  ; DD, 01.02.2008, loads down files from a ftp-server using the standard ftp, which needs not to be installed
  ;

  PROCEDURE InitVars
    VAR_STR  FTPUser,        'username'
    VAR_STR  FTPPassword,    'password'
    VAR_STR  FTPServer,      'abcdef.com'
    VAR_STR  FTPDestPath,    ''

    VAR_STR  Str1
    VAR_STR  Str2
    VAR_STR  FTPScriptFName
    VAR_STR  FTPBatchFName
    VAR_BOOL Res

    VAR_LIST FTPScript
    VAR_LIST FTPBatch


    CALC [FTPScriptFName] AS CON([PRINTSET_PATH],'ftp_script_',[STATION_SHORT],'.ftp')
    CALC [FTPBatchFName]  AS CON([PRINTSET_PATH],'ftp_exec_',[STATION_SHORT],'.bat')

    LIST_CLR [FTPScript]

    CALC [Str1] AS CON('open ',[FTPServer])
    LIST_APPEND [FTPScript], [Str1]

    LIST_APPEND [FTPScript], [FTPUser]
    LIST_APPEND [FTPScript], [FTPPassword]
    LIST_APPEND [FTPScript], 'binary'
    LIST_APPEND [FTPScript], 'prompt'
    LIST_APPEND [FTPScript], 'mget *.csv'

    IF [FTPDestPath]<>''
      CALC [Str1] AS CON('cd ',[FTPDestPath])
      LIST_APPEND [FTPScript], [Str1]
    END_IF

    CALC [Str1] AS COPY([PRINTSET_PATH],1,1)
    IF [Str1]='\'
      EXIT_PROC
    END_IF

    LIST_APPEND [FTPBatch], '@ECHO OFF'

    CALC [Str1] AS COPY([PRINTSET_PATH],1,2)
    LIST_APPEND [FTPBatch], [Str1]

    CALC [Str1] AS COPY([PRINTSET_PATH],3,255)
    CALC [Str1] AS  CON('cd ',[Str1])
    LIST_APPEND [FTPBatch], [Str1]

    CALC [Str1] AS CON('ftp -s:',[FTPScriptFName])
    LIST_APPEND [FTPBatch], [Str1]

    CALC [Str1] AS CON('del ',[FTPScriptFName])
    LIST_APPEND [FTPBatch], [Str1]
  END_PROC


  PROCEDURE Main
    IF [Str1]='\'
      MESSAGE 'Achtung Abbruch','Diese Funktion kann nicht aus einer UNC-Umgebung ausgefhrt werden',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    LIST_APPEND [FTPScript], 'quit'
    LIST_APPEND [FTPBatch],  'exit'

    LIST_FILE_WRITE [FTPBatch], [Res],[FTPBatchFName]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Batch-Datei konnte nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    LIST_FILE_WRITE [FTPScript],[Res],[FTPScriptFName]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Script-Datei konnte nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    EXTERN [FTPBatchFName], [EXTERN_SHOW]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END