   ; dd 14.07.2003 Second Sample on EE-Variable-Type
   ;               This one shows how to deal an Excel-Sheet
   ;               without connecting a query to it, BUT
   ;               giving the data field by field to the sheet...
   ;

  PROCEDURE InitVars
    VAR_EE    ExSample2
    VAR_BOOL  Result
    VAR_NUM   numRes
    VAR_QUERY SQ

    VAR_NUM   AHour
    VAR_NUM   AMin
    VAR_NUM   ASec

    VAR_DATE  ADate
    VAR_TIME  ATime
    VAR_FLOAT AFloat
  END_PROC


  PROCEDURE UserDataFirst
    CALC [ExSample2!EE_USER_DATA_ACT] AS 1
  END_PROC


  PROCEDURE UserDataNext
    INC [ExSample2!EE_USER_DATA_ACT]
  END_PROC


  PROCEDURE UserDataPrev
    DEC [ExSample2!EE_USER_DATA_ACT]
  END_PROC


  PROCEDURE UserDataEof
    IF [ExSample2!EE_USER_DATA_ACT]>[ExSample2!EE_USER_DATA_MAX]
      CALC [ExSample2!EE_USER_DATA_EOF] AS TRUE
    END_IF
  END_PROC


  PROCEDURE UserDataGet
    IF [ExSample2!EE_USER_DATA_FIELD]='COL1'
      ; In the example this has been defined as a string field
      CALC [ExSample2!EE_USER_DATA_VALUE] AS CON('string value ',[ExSample2!EE_USER_DATA_ACT])

    ELSE_IF [ExSample2!EE_USER_DATA_FIELD]='COL2'
      ; In the example this has been defined as a date field
      CALC [ADate] AS [DATE] + [ExSample2!EE_USER_DATA_ACT]
      CALC [ExSample2!EE_USER_DATA_VALUE] AS [ADate]

    ELSE_IF [ExSample2!EE_USER_DATA_FIELD]='COL3'
      ; In the example this has been defined as a time field

      TIME_2_HMS [TIME],[AHour],[AMin],[ASec]
      CALC [AMin] AS [AMin] + [ExSample2!EE_USER_DATA_ACT]
      IF [AMin]>59
        CALC [AMin]  AS [AMin]  - 60
        CALC [AHour] AS [AHour] +  1
        IF [AHour]>23
          CALC [AHour] AS [AHour] - 24
        END_IF
      END_IF
      HMS_2_TIME [AHour],[AMin],[ASec],[ATime]

      CALC [ExSample2!EE_USER_DATA_VALUE] AS [ATime]

    ELSE_IF [ExSample2!EE_USER_DATA_FIELD]='COL4'
      ; In the example this has been defined as a num field
      CALC [ExSample2!EE_USER_DATA_VALUE] AS [ExSample2!EE_USER_DATA_ACT]

    ELSE_IF [ExSample2!EE_USER_DATA_FIELD]='COL5'
      ; In the example this has been defined as a float field
      CALC [AFloat] AS [ExSample2!EE_USER_DATA_ACT]*13000/7
      CALC [ExSample2!EE_USER_DATA_VALUE] AS [AFloat]
      CALC [ExSample2!EE_USER_DATA_VALUE] AS REPLACE([ExSample2!EE_USER_DATA_VALUE],'.',',')

    END_IF
  END_PROC


  PROCEDURE Main
    CALC [ExSample2!EE_TITLE]           AS 'ExSample02_User_Data'
    CALC [ExSample2!EE_TEMPLATE]        AS CON([SCRIPT_PATH],'EE_ExSample02_User_Data.xls')
    CALC [ExSample2!EE_SHEET]           AS 'ExSample02_User_Data_Sheet1'
    CALC [ExSample2!EE_OPTIONS]         AS [EE_OPTION_HOURGLAS_CURSOR]+[EE_OPTION_SHOW_PROGRESS]+[EE_OPTION_TOTALS_AS_FORMULA]

    ; As lang as you do not decide to do something else than this example shows in the following hooks
    ; you may NOT define any of this hooks, because they will be AUTOMATICLY run.
;   CALC [ExSample2!EE_HOOK_DATA_FIRST] AS 'UserDataFirst'
;   CALC [ExSample2!EE_HOOK_DATA_NEXT]  AS 'UserDataNext'
;   CALC [ExSample2!EE_HOOK_DATA_PREV]  AS 'UserDataPrev'
    ; To have also the EOF - hook running automaticly you must define the variable
    ; SCRIPT_EE_USER_DATA_MAX with a value bigger than 0
;   CALC [ExSample2!EE_HOOK_DATA_EOF]   AS 'UserDataEof'

    ; I decide here only to show 20 lines. Normaly this is depending on the data you
    ; want to show perhaps out of a query or out of a process that only know its end
    ; while runtime...
    CALC [ExSample2!EE_USER_DATA_MAX]   AS 20


    ; this is the only necessary hook
    CALC [ExSample2!EE_HOOK_DATA_GET]   AS 'UserDataGet'


    ; setting the Query NOT (no query, browser or mask is passed to the command) switches to USER DATA mode
    EE_EXECUTE [ExSample2], [numRes], [EE_SET_QUERY]

    EE_EXECUTE [ExSample2], [numRes], [EE_BAND_ADD], [EE_BAND_TYPE_TITLE],       'A1:E3'
    EE_EXECUTE [ExSample2], [numRes], [EE_BAND_ADD], [EE_BAND_TYPE_MASTER_DATA], 'A4:E4'



    CALC [numRes] AS [ID_NO]
    GET_YES_NO 'Achtung','Mchten Sie die Vorlage bzw. das Layout bearbeiten ?',[numRes]
    IF [numRes]=[ID_CANCEL]
      EXIT_PROC
    END_IF

    IF [numRes]=[ID_YES]
      EE_EXECUTE [ExSample2], [numRes], [EE_EDIT]
    ELSE
      EE_EXECUTE [ExSample2], [numRes], [EE_SHOW]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

