   ; dd 14.07.2003 8. Sample on EE-Variable-Type
   ;               This one shows how to deal summarys over dynamicly inserted formulars.
   ;

  PROCEDURE InitVars
    VAR_EE    ExSample4
    VAR_BOOL  Result
    VAR_NUM   numRes
    VAR_NUM   StartRow
    VAR_NUM   EndRow
    VAR_STR   Range
    VAR_STR   AStr
    VAR_QUERY SQ
  END_PROC


  PROCEDURE BeforeBuild
    CALC [StartRow] AS 0
    CALC [EndRow]   AS 0
  END_PROC


  PROCEDURE FormatCell
    IF [ExSample4!EE_ACT_BAND_TYPE]=[EE_BAND_TYPE_MASTER_DATA]
      IF [StartRow]=0
        CALC [StartRow] AS [ExSample4!EE_ACT_ROW_REPORT]
      END_IF
      CALC [EndRow] AS [ExSample4!EE_ACT_ROW_REPORT]

    ELSE_IF [ExSample4!EE_ACT_BAND_TYPE]=[EE_BAND_TYPE_SUMMARY]
      IF [ExSample4!EE_ACT_COL_REPORT]=3
        IF [ExSample4!EE_ACT_ROW_TEMPLATE]>=8
          CALC [Range] AS CON('C',[ExSample4!EE_ACT_ROW_REPORT])
          IF [ExSample4!EE_ACT_ROW_TEMPLATE]=8
            CALC [AStr]  AS CON('=Mode(C',[StartRow],':C',[EndRow],')')
            EE_EXECUTE [ExSample4], [numRes], [EE_SET_RANGE], [Range], [Range], [EE_RANGE_OPT_FORMULAR], [AStr]
          ELSE
            CALC [AStr]  AS CON('=Median(C',[StartRow],':C',[EndRow],')')
            EE_EXECUTE [ExSample4], [numRes], [EE_SET_RANGE], [Range], [Range], [EE_RANGE_OPT_FORMULAR], [AStr]
          END_IF
        END_IF
      END_IF
    END_IF
  END_PROC


  PROCEDURE Main
    CALC [ExSample4!EE_TITLE]           AS 'ExSample04_Sum_Report2'
    CALC [ExSample4!EE_TEMPLATE]        AS CON([SCRIPT_PATH],'EE_ExSample04_Sum_Report2.xls')
    CALC [ExSample4!EE_SHEET]           AS 'ExSample04_Sum_Report2'
    CALC [ExSample4!EE_OPTIONS]         AS [EE_OPTION_HOURGLAS_CURSOR]+[EE_OPTION_SHOW_PROGRESS]+[EE_OPTION_TOTALS_AS_FORMULA]

    QUERY [SQ]
        SELECT Auftragsnummer, Auftragsdatum, Brutto
          FROM Auftrag
         WHERE Aktiv    < 99
           AND FertByte = 0
           AND RecordID > 1000
      ORDER BY Auftragsnummer
    END_QUERY

    EXECUTE [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Datenbankabfrage konnte nicht ausgefhrt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Es konnten keine Daten gefunden werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [ExSample4!EE_HOOK_BEFORE_BUILD] AS 'BeforeBuild'
    CALC [ExSample4!EE_HOOK_FORMAT_CELL]  AS 'FormatCell'

    EE_EXECUTE [ExSample4], [numRes], [EE_SET_QUERY], [SQ]

    CALC [numRes] AS [ID_NO]
    GET_YES_NO 'Achtung','Mchten Sie die Vorlage bzw. das Layout bearbeiten ?',[numRes]
    IF [numRes]=[ID_CANCEL]
      EXIT_PROC
    END_IF

    IF [numRes]=[ID_YES]
      EE_EXECUTE [ExSample4], [numRes], [EE_EDIT]
    ELSE
      EE_EXECUTE [ExSample4], [numRes], [EE_SHOW]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

