   ; dd 14.07.2003 Fifth Sample on EE-Variable-Type
   ;               This one shows how to change the format while runtime.
   ;
   ;               Options shown                   change a rows height
   ;                                               change a cells text color
   ;                                               change a rows  text color
   ;                                               change a cells text attribute "bold"
   ;                                               change a cells text attribute "italic"
   ;                                               change a rows background color
   ;                                               insert a formular
   ;
   ;               also possible (but not shown)   change a cells background color
   ;                                               change a formular
   ;                                               change a rows text attribute "bold"
   ;                                               change a rows text attribute "italic"
   ;


  PROCEDURE InitVars
    VAR_EE    ExSample5
    VAR_BOOL  Result
    VAR_NUM   numRes
    VAR_FLOAT AFloat
    VAR_QUERY SQ

    VAR_STR   StartRange
    VAR_STR   StopRange
    VAR_STR   AStr
  END_PROC


  PROCEDURE FormatCell
    IF [ExSample5!EE_ACT_BAND_TYPE]=[EE_BAND_TYPE_MASTER_DATA]
      IF [ExSample5!EE_ACT_COL_REPORT]=4
        CALC [AFloat] AS VAL([ExSample5!EE_ACT_CELL_VALUE])
        IF [AFloat]>3000
          CALC [StartRange] AS CON('D',[ExSample5!EE_ACT_ROW_REPORT])
          CALC [StopRange ] AS [StartRange]

          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FONT_COLOR],    '$000000FF'
          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FONT_BOLD],     'TRUE'
        ELSE_IF [AFloat]<10
          CALC [StartRange] AS CON('A',[ExSample5!EE_ACT_ROW_REPORT])
          CALC [StopRange ] AS CON('D',[ExSample5!EE_ACT_ROW_REPORT])

          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FONT_COLOR],    '$00FFFFFF'
          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_INTERIOR_COLOR],'$000000FF'
        ELSE_IF [AFloat]>500
          IF [AFloat]<600
            CALC [StartRange] AS CON('A',[ExSample5!EE_ACT_ROW_REPORT])
            CALC [StopRange ] AS CON('D',[ExSample5!EE_ACT_ROW_REPORT])

            EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_ROW_HEIGHT],  '44'
          END_IF
        ELSE_IF [AFloat]>200
          IF [AFloat]<500
          CALC [StartRange] AS CON('D',[ExSample5!EE_ACT_ROW_REPORT])
          CALC [StopRange ] AS [StartRange]

          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FONT_COLOR],    '$00FF0000'
          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FONT_BOLD],     'TRUE'
          EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FONT_ITALIC],   'TRUE'
          END_IF
        ELSE_IF [AFloat]>100
          IF [AFloat]<200
            CALC [StartRange] AS CON('E',[ExSample5!EE_ACT_ROW_REPORT])
            CALC [StopRange ] AS [StartRange]

            CALC [AStr] AS CON('=D',[ExSample5!EE_ACT_ROW_REPORT],'/1.16')
            EE_EXECUTE [ExSample5], [numRes], [EE_SET_RANGE], [StartRange], [StopRange], [EE_RANGE_OPT_FORMULAR],    [AStr]
          END_IF
        END_IF
      END_IF
    END_IF
  END_PROC


  PROCEDURE Main
    CALC [ExSample5!EE_TITLE]    AS 'ExSample05_Change_Cell_Format'
    CALC [ExSample5!EE_TEMPLATE] AS CON([SCRIPT_PATH],'EE_ExSample05_Change_Cell_Format.xls')
    CALC [ExSample5!EE_SHEET]    AS 'Ex05_Change_Cell_Format_Sheet'
    CALC [ExSample5!EE_OPTIONS]  AS [EE_OPTION_HOURGLAS_CURSOR]+[EE_OPTION_SHOW_PROGRESS]+[EE_OPTION_TOTALS_AS_FORMULA]

    QUERY [SQ]
        SELECT A.Auftragsnummer, A.Auftragsdatum, K.Suchbegriff, A.Brutto
          FROM Auftrag A, Adressen K
         WHERE A.KundenID = K.RecordID
           AND A.Aktiv    < 99
           AND A.RecordID > 1000
           AND A.FertByte = 0
      ORDER BY A.Auftragsnummer
    END_QUERY

    EXECUTE [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Datenbankabfrage konnte nicht ausgefhrt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Es konnten keine Daten gefunden werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [ExSample5!EE_HOOK_FORMAT_CELL] AS 'FormatCell'

    EE_EXECUTE [ExSample5], [numRes], [EE_SET_QUERY], [SQ]

    CALC [numRes] AS [ID_NO]
    GET_YES_NO 'Achtung','Mchten Sie die Vorlage bzw. das Layout bearbeiten ?',[numRes]
    IF [numRes]=[ID_CANCEL]
      EXIT_PROC
    END_IF

    IF [numRes]=[ID_YES]
      EE_EXECUTE [ExSample5], [numRes], [EE_EDIT]
    ELSE
      EE_EXECUTE [ExSample5], [numRes], [EE_SHOW]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

