   ; dd 14.07.2003 Sixths Sample on EE-Variable-Type
   ;               This one shows how to change a cell value.
   ;


  PROCEDURE InitVars
    VAR_EE    ExSample6
    VAR_BOOL  Result
    VAR_NUM   numRes
    VAR_FLOAT AFloat
    VAR_QUERY SQ
    VAR_STR   AStr
  END_PROC


  PROCEDURE ChangeCell
    IF [ExSample6!EE_ACT_BAND_TYPE]=[EE_BAND_TYPE_MASTER_DATA]
      IF [ExSample6!EE_ACT_COL_REPORT]=4
        CALC [AFloat] AS VAL([ExSample6!EE_ACT_CELL_VALUE])
        CALC [AFloat] AS [AFloat]/1.16
        CALC [AStr]   AS [AFloat|X0,2]
        CALC [ExSample6!EE_ACT_CELL_VALUE] AS [AStr]
      END_IF
    END_IF
  END_PROC


  PROCEDURE Main
    CALC [ExSample6!EE_TITLE]    AS 'ExSample06_Cell_Value'
    CALC [ExSample6!EE_TEMPLATE] AS CON([SCRIPT_PATH],'EE_ExSample06_Cell_Value.xls')
    CALC [ExSample6!EE_SHEET]    AS 'Ex06_Cell_Value'
    CALC [ExSample6!EE_OPTIONS]  AS [EE_OPTION_HOURGLAS_CURSOR]+[EE_OPTION_SHOW_PROGRESS]+[EE_OPTION_TOTALS_AS_FORMULA]

    QUERY [SQ]
        SELECT A.Auftragsnummer, A.Auftragsdatum, K.Suchbegriff, A.Brutto
          FROM Auftrag A, Adressen K
         WHERE A.KundenID = K.RecordID
           AND A.Aktiv    < 99
           AND A.RecordID > 1000
           AND A.FertByte = 0
      ORDER BY A.Auftragsnummer
    END_QUERY

    EXECUTE [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Datenbankabfrage konnte nicht ausgefhrt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Es konnten keine Daten gefunden werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [ExSample6!EE_HOOK_SET_CELL_VALUE] AS 'ChangeCell'

    EE_EXECUTE [ExSample6], [numRes], [EE_SET_QUERY], [SQ]

    CALC [numRes] AS [ID_NO]
    GET_YES_NO 'Achtung','Mchten Sie die Vorlage bzw. das Layout bearbeiten ?',[numRes]
    IF [numRes]=[ID_CANCEL]
      EXIT_PROC
    END_IF

    IF [numRes]=[ID_YES]
      EE_EXECUTE [ExSample6], [numRes], [EE_EDIT]
    ELSE
      EE_EXECUTE [ExSample6], [numRes], [EE_SHOW]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

