   ; dd 14.07.2003 Sevenths Sample on EE-Variable-Type
   ;               This one shows how to handele user fields.
   ;               Here the "FirmenName" (CompanyName) is set manually
   ;               all the other data are coming form a query
   ;               no User-Data handling (like Example2) is needed.
   ;


  PROCEDURE InitVars
    VAR_EE    ExSample7
    VAR_BOOL  Result
    VAR_NUM   numRes
    VAR_FLOAT AFloat
    VAR_QUERY SQ
    VAR_STR   AStr
  END_PROC



  PROCEDURE Main
    CALC [ExSample7!EE_TITLE]    AS 'ExSample07_User_Fields'
    CALC [ExSample7!EE_TEMPLATE] AS CON([SCRIPT_PATH],'EE_ExSample07_User_Fields.xls')
    CALC [ExSample7!EE_SHEET]    AS 'Ex07_User_Fields_Sheet'
    CALC [ExSample7!EE_OPTIONS]  AS [EE_OPTION_HOURGLAS_CURSOR]+[EE_OPTION_SHOW_PROGRESS]+[EE_OPTION_TOTALS_AS_FORMULA]

    QUERY [SQ]
        SELECT A.Auftragsnummer, A.Auftragsdatum, K.Suchbegriff, A.Brutto
          FROM Auftrag A, Adressen K
         WHERE A.KundenID = K.RecordID
           AND A.Aktiv    < 99
           AND A.RecordID > 1000
           AND A.FertByte = 0
      ORDER BY A.Auftragsnummer
    END_QUERY

    EXECUTE [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Datenbankabfrage konnte nicht ausgefhrt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Es konnten keine Daten gefunden werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    EE_EXECUTE [ExSample7], [numRes], [EE_DIC_SET], 'FirmenName', 'Creative Soft- & Hardware'

    EE_EXECUTE [ExSample7], [numRes], [EE_SET_QUERY], [SQ]

    CALC [numRes] AS [ID_NO]
    GET_YES_NO 'Achtung','Mchten Sie die Vorlage bzw. das Layout bearbeiten ?',[numRes]
    IF [numRes]=[ID_CANCEL]
      EXIT_PROC
    END_IF

    IF [numRes]=[ID_YES]
      EE_EXECUTE [ExSample7], [numRes], [EE_EDIT]
    ELSE
      EE_EXECUTE [ExSample7], [numRes], [EE_SHOW]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

