   ; dd 14.07.2003 11. Sample on EE-Variable-Type
   ;               This one shows how to deal groupings.
   ;

  PROCEDURE InitVars
    VAR_EE    ExSample11
    VAR_BOOL  Result
    VAR_NUM   numRes
    VAR_QUERY SQ
  END_PROC



  PROCEDURE GroupingBandGroupHeaderCalcExpr
    ; don't forget to synchronize the data of query (fetched by the excel-exporter) to the contents in variables
    GET_DATA [SQ], [Result], [CURR_REC]
    CALC [ExSample11!EE_GROUP_VALUE] AS [SQ!A.Auftragsdatum|R0,yyyymm]
  END_PROC



  PROCEDURE Main
    CALC [ExSample11!EE_TITLE]    AS 'ExSample11_Grouping'
    CALC [ExSample11!EE_TEMPLATE] AS CON([SCRIPT_PATH],'EE_ExSample11_Grouping.xls')
    CALC [ExSample11!EE_SHEET]    AS 'ExSample11_Grouping_Sheet'
    CALC [ExSample11!EE_OPTIONS]  AS [EE_OPTION_HOURGLAS_CURSOR]+[EE_OPTION_SHOW_PROGRESS]+[EE_OPTION_TOTALS_AS_FORMULA]

    QUERY [SQ]
        SELECT A.Auftragsnummer, A.Auftragsdatum, A.Brutto, K.Suchbegriff, A.Status, A.Kurztext1, A.Kurztext2
          FROM Auftrag A, Adressen K
         WHERE A.KundenID = K.RecordID
           AND A.FertByte = 0
           AND A.RecordID > 1000
      ORDER BY A.Auftragsdatum, A.Auftragsnummer
    END_QUERY

    EXECUTE [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Datenbankabfrage konnte nicht ausgefhrt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ], [Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Es konnten keine Daten gefunden werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    EE_EXECUTE [ExSample11], [numRes], [EE_BAND_ADD],  [EE_BAND_TYPE_TITLE],        'A1:D5'
    EE_EXECUTE [ExSample11], [numRes], [EE_BAND_ADD],  [EE_BAND_TYPE_MASTER_DATA],  'A9:D10'
    EE_EXECUTE [ExSample11], [numRes], [EE_BAND_ADD],  [EE_BAND_TYPE_SUMMARY],      'A12:D12'
    EE_EXECUTE [ExSample11], [numRes], [EE_BAND_ADD],  [EE_BAND_TYPE_GROUP_HEADER], 'A7:D7', '', 'GroupingBandGroupHeaderCalcExpr'

    EE_EXECUTE [ExSample11], [numRes], [EE_SET_QUERY], [SQ]

    CALC [numRes] AS [ID_NO]
    GET_YES_NO 'Achtung','Mchten Sie die Vorlage bzw. das Layout bearbeiten ?',[numRes]
    IF [numRes]=[ID_CANCEL]
      EXIT_PROC
    END_IF

    IF [numRes]=[ID_YES]
      EE_EXECUTE [ExSample11], [numRes], [EE_EDIT]
    ELSE
      EE_EXECUTE [ExSample11], [numRes], [EE_SHOW]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

