
   PROCEDURE InitVars
     VAR_BROWSER Q
     VAR_BOOL    Res
     VAR_FLOAT   ID
     VAR_NUM     LnAct
     VAR_NUM     LnMax
     VAR_LIST    HardwareOnfo

     VAR_STR     Str1
     VAR_STR     Filters
     VAR_STR     UserName
     VAR_STR     ErrorName
     VAR_STR     ErrorInfo
     VAR_STR     Path2Cara,     [CARA_PATH]
     VAR_STR     Path2Prog,     [PROG_PATH]
     VAR_STR     Path2Document, [DOCUMENT_PATH]
     VAR_STR     Path2Picture,  [PICTURE_PATH]
     VAR_STR     Path2PrintSet, [PRINTSET_PATH]
     VAR_STR     Path2SetDoc,   [MASKS_PATH]
     VAR_STR     Path2Special,  [SPECIAL_PATH]
     VAR_STR     Path2SQL,      [SQL_PATH]
     VAR_STR     Path2Script,   [SCRIPT_PATH]
     VAR_STR     Path2Help,     [HELP_PATH]
     VAR_STR     FileConfig,    [CONFIG_FILE]
     VAR_STR     FileStation,   [STATION_INI_FILE]

     VAR_MASK    WorkMask,      'ErrorBoardDlg'

     CALC [WorkMask!MASK_HOOK_EXIT]     AS 'ExitHook'
     CALC [WorkMask!MASK_HOOK_BUTTON]   AS 'ButtonHook'
     CALC [WorkMask!MASK_HOOK_PRE_SAVE] AS 'PreSaveHook'

     ;                      "   '  `              
     CALC [Filters] AS CHAR(#34#39#96#145#146#147#148#180)

     LIST_CLR [HardwareOnfo]
     GET_HARDWARE_INFO [Res], [HardwareOnfo]

     IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
       LIST_ITEM_GET [HardwareOnfo],[LnAct],[LnMax]
       IF [LnMax]>0
         CALC [LnAct] AS 1
         WHILE [LnAct]<=[LnMax]
           LIST_STR_GET [HardwareOnfo],[Str1],[LnAct]
           CALC [Str1] AS DBL_BACK_SLASH([Str1])
           CALC [Str1] AS FILTER([Str1],[Filters])
           LIST_STR_SET [HardwareOnfo],[Str1],[LnAct]
           INC [LnAct]
         END_WHILE
       END_IF

       CALC [Path2Cara]     AS DBL_BACK_SLASH([Path2Cara])
       CALC [Path2Prog]     AS DBL_BACK_SLASH([Path2Prog])
       CALC [Path2Document] AS DBL_BACK_SLASH([Path2Document])
       CALC [Path2Picture]  AS DBL_BACK_SLASH([Path2Picture])
       CALC [Path2PrintSet] AS DBL_BACK_SLASH([Path2PrintSet])
       CALC [Path2SetDoc]   AS DBL_BACK_SLASH([Path2SetDoc])
       CALC [Path2Special]  AS DBL_BACK_SLASH([Path2Special])
       CALC [Path2SQL]      AS DBL_BACK_SLASH([Path2SQL])
       CALC [Path2Script]   AS DBL_BACK_SLASH([Path2Script])
       CALC [Path2Help]     AS DBL_BACK_SLASH([Path2Help])
       CALC [FileConfig]    AS DBL_BACK_SLASH([FileConfig])
       CALC [FileStation]   AS DBL_BACK_SLASH([FileStation])
     END_IF
   END_PROC



   PROCEDURE PreSaveHook
     CALC [ErrorInfo] AS TRIM([WorkMask!ErrorInfo])
     IF [ErrorInfo]<>''
       CALC [ErrorInfo] AS FILTER([ErrorInfo],[Filters])
       CALC [ErrorInfo] AS   TRIM([ErrorInfo])
     END_IF
     IF [ErrorInfo]=''
       MESSAGE 'Achtung Abbruch','Es wurde keine Fehlerbeschreibung angegeben',[MESSAGE_WARNING]
       CALC [WorkMask!MASK_ACTION] AS 1
       EXIT_PROC
     END_IF

     CALC [ErrorName] AS [WorkMask!ErrorName]
     CALC [ErrorName] AS TRIM([WorkMask!ErrorName])
     IF [ErrorName]<>''
       CALC [ErrorName] AS FILTER([ErrorName],[Filters])
       CALC [ErrorName] AS   TRIM([ErrorName])
     END_IF
     IF [ErrorName]=''
       MESSAGE 'Achtung Abbruch','Es wurde kein Fehlername angegeben',[MESSAGE_WARNING]
       CALC [WorkMask!MASK_ACTION] AS 1
       EXIT_PROC
     END_IF

     IF [SQL_BCK_SLSH_INTRO_SPEC_CHAR]
       CALC [ErrorInfo] AS DBL_BACK_SLASH([ErrorInfo])
       CALC [ErrorName] AS DBL_BACK_SLASH([ErrorName])
     END_IF

     CALC [UserName] AS [SHORT_NAME]
     QUERY [Q]
       SELECT Name1
         FROM adressen
        WHERE RecordID = [ACT_MIT_ID|R0,0]
     END_QUERY
     EXECUTE [Q],[Res]
     IF [Res]
       GET_DATA [Q],[Res]
       IF [Res]
         CALC [UserName] AS [Q!Name1]
       END_IF
     END_IF

     NEW_RECORD [Res],'errorboard',[ID], TRUE, FALSE, FALSE
     IF [Res]=FALSE
       MESSAGE 'Achtung Abbruch','Es konnte kein neuer Datensatz fr das "ErrorBoard" angelegt werden',[MESSAGE_ERROR]
       CALC [WorkMask!MASK_ACTION] AS 1
       EXIT_PROC
     END_IF

     QUERY [Q]
       UPDATE errorboard
          SET ErrorInfo         = "[ErrorInfo]",
              ErrorName         = "[ErrorName]",
              ErrorDate         =  [SQL_DATE_QUOTES_4_MODIFY][DATE|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
              ErrorTime         =  [SQL_TIME_QUOTES_4_MODIFY][TIME|R0,[SQL_TIME_PICTURE_4_MODIFY]][SQL_TIME_QUOTES_4_MODIFY],
              UserName          = "[UserName]",
              UserID            =  [ACT_MIT_ID|R0,0],
              StationName       = "[APPLICATION_MACHINE_NAME] / [APPLICATION_USER_NAME]",
              StationIDStr      = "[STATION_ID|R0,0]",
              StationShort      = "[STATION_SHORT]",
              StationID         =  [STATION_ID|R0,0],
              UserSID           = "[USER_SID]",
              UserSIDShort      = "[USER_SID_SHORT]",
              CARAVersion       = "[CARA_VERSION]",
              Path2Cara         = "[Path2Cara]",
              Path2Prog         = "[Path2Prog]",
              Path2Document     = "[Path2Document]",
              Path2Picture      = "[Path2Picture]",
              Path2PrintSet     = "[Path2PrintSet]",
              Path2SetDoc       = "[Path2SetDoc]",
              Path2Special      = "[Path2Special]",
              Path2SQL          = "[Path2SQL]",
              Path2Script       = "[Path2Script]",
              Path2Help         = "[Path2Help]",
              MandantID         =  [ACT_MANDANT_ID|R0,0],
              MandantIdx        =  [ACT_MANDANT],
              MandantName       = "[ACT_MANDANT_NAME]",
              LanguageID        =  [LANGUAGE_ID|R0,0],
              ApplicationName   = "[APPLICATION_NAME]",
              ApplicationShort  = "[APPLICATION_SHORT]",
              ProgramVersion    = "[PROGRAM_VERSION]",
              ConfigFile        = "[FileConfig]",
              StationINIFile    = "[FileStation]",
              VirtualDelID      =  0,
              VirtualDelUserIdx =  0
        WHERE RecordID          =  [ID|R0,0]
     END_QUERY

     EXECUTE [Q],[Res]
     IF [Res]=FALSE
       MESSAGE 'Achtung Abbruch','Ein neuer Datensatz des "ErrorBoard" konnte nicht initialisiert werden',[MESSAGE_ERROR]

       QUERY [Q]
         DELETE FROM errorboard WHERE RecordID = [ID|R0,0]
       END_QUERY
       EXECUTE [Q],[Res]

       CALC [WorkMask!MASK_ACTION] AS 1
       EXIT_PROC
     END_IF

     LIST_ITEM_GET [HardwareOnfo],[LnAct],[LnMax]
     IF [LnMax]>0
       NOTE_WRITE [HardwareOnfo],[Res],'errorboard',1,[ID]
     END_IF

     MESSAGE 'Info','Die Fehlermeldung wurde gespeichert!'
     MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]

     CALC [WorkMask!MASK_ACTION] AS 1
   END_PROC



   PROCEDURE ButtonHook
     IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_ERROR_NAME'
       QUERY [Q]
           SELECT [W25 N"Fehlername"]DISTINCT ErrorName
             FROM errorboard
            WHERE RecordID > 1000
         ORDER BY ErrorName
       END_QUERY

       VIEW [Q],[Res],'Fehlername auswhlen'
       IF [Res]
         CALC [WorkMask!ErrorName] AS [Q!DISTINCTErrorName]
         MASK_UPDATE [WorkMask]
       END_IF
     END_IF
   END_PROC



   PROCEDURE ExitHook
     CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
   END_PROC



   PROCEDURE Main
     MASK_PROCESS [WorkMask]
   END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END