DROP TABLE [SQL_IF_EXISTS] errorboard;

CREATE TABLE errorboard
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      ErrorInfo                 [SQL_DEFINE_STRING]   (240) [SQL_DEFINE_STRING_END],
      ErrorName                 [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      ErrorDate                 [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      ErrorTime                 [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      UserName                  [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      UserID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      StationID                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      StationIDStr              [SQL_DEFINE_STRING]   ( 13) [SQL_DEFINE_STRING_END],
      StationShort              [SQL_DEFINE_STRING]   ( 10) [SQL_DEFINE_STRING_END],
      StationName               [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      UserSID                   [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      UserSIDShort              [SQL_DEFINE_STRING]   ( 10) [SQL_DEFINE_STRING_END],
      CARAVersion               [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      Path2Cara                 [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2Prog                 [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2Document             [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2Picture              [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2PrintSet             [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2SetDoc               [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2Special              [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2SQL                  [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2Script               [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      Path2Help                 [SQL_DEFINE_STRING]   (220) [SQL_DEFINE_STRING_END],
      MandantID                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      MandantIdx                [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      MandantName               [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      LanguageID                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      ApplicationName           [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      ApplicationShort          [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      ProgramVersion            [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      ConfigFile                [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      StationINIFile            [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END]

      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndErrBoRecordID      ON errorboard (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndErrBoVirtualDelID  ON errorboard (VirtualDelID);
CREATE        INDEX IndErrBoErrorInfo     ON errorboard (ErrorInfo);
CREATE        INDEX IndErrBoErrorName     ON errorboard (ErrorName);
CREATE        INDEX IndErrBoErrorDate     ON errorboard (ErrorDate);
CREATE        INDEX IndErrBoErrorTime     ON errorboard (ErrorTime);
CREATE        INDEX IndErrBoUserName      ON errorboard (UserName);
CREATE        INDEX IndErrBoUserID        ON errorboard (UserID);
CREATE        INDEX IndErrBoStationID     ON errorboard (StationID);
CREATE        INDEX IndErrBoStationShort  ON errorboard (StationShort);
CREATE        INDEX IndErrBoUserSID       ON errorboard (UserSID);
CREATE        INDEX IndErrBoUserSIDShort  ON errorboard (UserSIDShort);
CREATE        INDEX IndErrBoCARAVersion   ON errorboard (CARAVersion);

