

  PROCEDURE InitVars
    VAR_NUM     MaskTimerTicks, 1000

    VAR_BOOL    Res
    VAR_FLOAT   TmpID
    VAR_BROWSER SB
    VAR_QUERY   UQ
    VAR_STR     StartingWithStr

    VAR_QUERY   GridQ
    VAR_NUM     GridOption
    CALC [GridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_ICON_INSERT]

    VAR_BOOL    BufVirtualDelete
    VAR_BOOL    BufSuids

    VAR_MASK    WorkMask,'MegaSearchDialog'

;   CALC [WorkMask!MASK_HOT_KEY_LIST]    AS '13@1|27@1'

    CALC [WorkMask!MASK_HOOK_EXIT]       AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_SHOW]       AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_POST_CLEAR] AS 'PostClearHook'
    CALC [WorkMask!MASK_HOOK_PRE_SEARCH] AS 'PreSearchHook'
    CALC [WorkMask!MASK_HOOK_KEY]        AS 'KeyHook'
    CALC [WorkMask!MASK_HOOK_POST_EDIT]  AS 'PostEditHook'
    CALC [WorkMask!MASK_HOOK_GRID_OK]    AS 'GridOkHook'

    ; Das wird weiter unten gesetzt!
    CALC [WorkMask!MASK_HOOK_TIMER]      AS ''
    MASK_TIMER [WorkMask], [MaskTimerTicks], FALSE

    CALC [BufVirtualDelete]              AS [VIRTUAL_DELETE]
    CALC [BufSuids]                      AS [SUPER_UNIQUE_RECORDID]

    CALC [SUPER_UNIQUE_RECORDID]         AS FALSE

    IDENTIFIER_EXIST 'GlobMegaSearchTable',[Res]
    IF [Res]=FALSE
      GLOBAL_BOOL GlobMegaSearchTableMade,  FALSE
      GLOBAL_STR  GlobMegaSearchTable

      ACT_REC_ID [TmpID]
      CALC [GlobMegaSearchTable] AS CON('ms',[TmpID|R0,0])
    END_IF
  END_PROC



  PROCEDURE MegsSearchTableDrop
    IF [GlobMegaSearchTableMade]
      QUERY [UQ]
        DROP TABLE [GlobMegaSearchTable]
      END_QUERY

      EXECUTE [UQ],[Res]
      IF [Res]=FALSE
        MESSAGE 'Abbruch','Die MegaSearch-Temporrtabelle konnte nicht gelscht werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      CALC [GlobMegaSearchTableMade] AS FALSE
    ELSE
      CALC [Res] AS TRUE
    END_IF
  END_PROC



  PROCEDURE MegsSearchTableCreate
    CALL MegsSearchTableDrop
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LOCAL_STR CreateAddStr1
    IF [SQL_VENDOR]='MYSQL'
      CALC [CreateAddStr1] AS 'ENGINE=MEMORY'
    END_IF

    QUERY [UQ]
      CREATE TABLE [GlobMegaSearchTable]
        (RelRefName [SQL_DEFINE_STRING]   (41) [SQL_DEFINE_STRING_END],
         FieldName1 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName2 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName3 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName4 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName5 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         FieldName6 [SQL_DEFINE_STRING]   (81) [SQL_DEFINE_STRING_END],
         TableName  [SQL_DEFINE_STRING]   (61) [SQL_DEFINE_STRING_END],
         RelRecID   [SQL_DEFINE_RECORDID]      [SQL_DEFINE_RECORDID_END],
         ScriptName [SQL_DEFINE_STRING]   (41) [SQL_DEFINE_STRING_END],
         Aktiv      [SQL_DEFINE_LONGINT]       [SQL_DEFINE_LONGINT_END]  ) [CreateAddStr1]
    END_QUERY

    EXECUTE [UQ],[Res]
    IF [Res]=FALSE
      MESSAGE 'Abbruch','Die MegaSearch-Temporrtabelle konnte nicht erzeugt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [GlobMegaSearchTableMade] AS TRUE
  END_PROC



  PROCEDURE MegsSearchTableInsert
    IF [WorkMask!Suchbegriff]=''
      EXIT_PROC
    END_IF

;   WAIT_INFO 'Bitte warten...','Die MegaSearch-Liste wird aufgebaut...'

    CALC [VIRTUAL_DELETE] AS [BufVirtualDelete]

    LOCAL_QUERY LocQ
    LOCAL_QUERY LocC
    LOCAL_QUERY LocU
    LOCAL_BOOL  LocRes
    LOCAL_LIST  LocList
    LOCAL_NUM   LocAllCnt
    LOCAL_NUM   LocLnAct
    LOCAL_NUM   LocLnCnt
    LOCAL_NUM   LocPos
    LOCAL_STR   LocStr1
    LOCAL_STR   LocStr2
    LOCAL_STR   LocStr3
    LOCAL_STR   LocStr4
    LOCAL_STR   LocStr5
    LOCAL_STR   LocStr6
    LOCAL_STR   LocRef
    LOCAL_BOOL  LocFound

    ; In welchen TableFld-Angaben wurde angegeben, dass dort Felder im MegaSearch Verwendung finden sollen?
    QUERY [LocQ]
      SELECT *
        FROM tablefld
       WHERE RecordID  > 0
         AND (FieldMS1 = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION] OR
              FieldMS2 = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION] OR
              FieldMS3 = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION] OR
              FieldMS4 = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION] OR
              FieldMS5 = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION] OR
              FieldMS6 = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]   )
    END_QUERY

    EXECUTE [LocQ], [LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Achtung Abruch','Die Liste der MegaSearch-Tabellen konnte nicht abgefragt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Achtung Abruch','Es gibt keine Tabellen deren Felder fr MegaSearch gekennzeichnet wurden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    WHILE [LocRes]
      ; Wurde in TableFld-Angaben ein Query hinterlegt?
      LIST_CLR  [LocList]
      NOTE_READ [LocList],[LocRes],'tablefld',1,[LocQ!RecordID]
      LIST_ITEM_GET [LocList],[LocLnAct],[LocLnCnt]
      IF [LocLnCnt]>0
        ; Ja, es wurde Query hinterlegt - wir nehmen es!
        QUERY [LocC]
        END_QUERY
        LIST_2_QUERY [LocList],[LocC]
      ELSE
        ; Nein, es wurde kein Query hinterlegt - wir bauen uns eines!
        QUERY [LocC]
             SELECT [LocQ!FieldName1], [LocQ!FieldName2], [LocQ!FieldName3], [LocQ!FieldName4], [LocQ!FieldName5], [LocQ!FieldName6], RecordID, RecFlag
               FROM [LocQ!TableName]
           ORDER BY [LocQ!FieldName1], [LocQ!FieldName2], [LocQ!FieldName3], [LocQ!FieldName4], [LocQ!FieldName5], [LocQ!FieldName6]
        END_QUERY
      END_IF

      ; Nun die Bedingungen mit dem Suchstring zusamen bauen
      IF [WorkMask!Volltextsuche]
        CALC [LocStr3] AS [WorkMask!Suchbegriff]
        CALC [LocStr3] AS REPLACE([LocStr3],' ',[SQL_WILD_CARD_MULTI])
        CALC [LocStr3] AS CON([SQL_WILD_CARD_MULTI],[LocStr3],[SQL_WILD_CARD_MULTI])
      ELSE
        CALC [LocStr3] AS CON([WorkMask!Suchbegriff],[SQL_WILD_CARD_MULTI])
      END_IF

      CALC [LocStr1] AS '('

      IF [LocQ!FieldMS1]
        CALC [LocStr2] AS CON([LocQ!FieldName1],' LIKE "',[LocStr3],'"')
        CALC [LocStr1] AS CON([LocStr1],[LocStr2])
      END_IF

      IF [LocQ!FieldMS2]
        IF [LocStr1]<>''
          CALC [LocStr1] AS CON([LocStr1],' OR ')
        END_IF
        CALC [LocStr2] AS CON([LocQ!FieldName2],' LIKE "',[LocStr3],'"')
        CALC [LocStr1] AS CON([LocStr1],[LocStr2])
      END_IF

      IF [LocQ!FieldMS3]
        IF [LocStr1]<>''
          CALC [LocStr1] AS CON([LocStr1],' OR ')
        END_IF
        CALC [LocStr2] AS CON([LocQ!FieldName3],' LIKE "',[LocStr3],'"')
        CALC [LocStr1] AS CON([LocStr1],[LocStr2])
      END_IF

      IF [LocQ!FieldMS4]
        IF [LocStr1]<>''
          CALC [LocStr1] AS CON([LocStr1],' OR ')
        END_IF
        CALC [LocStr2] AS CON([LocQ!FieldName4],' LIKE "',[LocStr3],'"')
        CALC [LocStr1] AS CON([LocStr1],[LocStr2])
      END_IF

      IF [LocQ!FieldMS5]
        IF [LocStr1]<>''
          CALC [LocStr1] AS CON([LocStr1],' OR ')
        END_IF
        CALC [LocStr2] AS CON([LocQ!FieldName5],' LIKE "',[LocStr3],'"')
        CALC [LocStr1] AS CON([LocStr1],[LocStr2])
      END_IF

      IF [LocQ!FieldMS6]
        IF [LocStr1]<>''
          CALC [LocStr1] AS CON([LocStr1],' OR ')
        END_IF
        CALC [LocStr2] AS CON([LocQ!FieldName6],' LIKE "',[LocStr3],'"')
        CALC [LocStr1] AS CON([LocStr1],[LocStr2])
      END_IF

      CALC [LocStr1] AS CON([LocStr1],')')
      QUERY_ADD_WHERE [LocC],255,[LocStr1]

      ; Das Query ausfhren und prfen, ob darin auch eine RecordID entahlten ist. - Sonst wird nicht weiter gemacht
      EXECUTE [LocC],[LocRes]
      IF [LocC!QUERY_DESCR_REC_ID]<>''
        QUERY_COUNT [LocC],[LocLnCnt]

        ; Wurden berhaupt Daten gefunden?
        IF [LocLnCnt]>0
          ; Jetzt kann es also losgehn. Die Daten sollen in die Temporrtabelle.

          ; Als erstes wird die berschrift generiert. Diese wird mit Aktiv = 1 gespeichert, dann kann man sie spter gut hervorheben.
          ; Hier wird der Name der Referenz gebildetet (entweder Tabellenname oder XRef-Name)-
          CALC [LocRef] AS [LocQ!TableName]
          IF [LocQ!XRefName]<>''
            CALC [LocRef] AS [LocQ!XRefName]
          END_IF

          ; Nun die Feldnamen ohne Alias als berschrift.
          CALC [LocStr1] AS [LocQ!FieldName1]
          CALC [LocPos]  AS POS('.',[LocStr1])
          IF [LocPos]>0
            CALC [LocStr1] AS PART([LocQ!FieldName1],2,'.')
          END_IF

          CALC [LocStr2] AS [LocQ!FieldName2]
          CALC [LocPos]  AS POS('.',[LocStr2])
          IF [LocPos]>0
            CALC [LocStr2] AS PART([LocQ!FieldName2],2,'.')
          END_IF

          CALC [LocStr3] AS [LocQ!FieldName3]
          CALC [LocPos]  AS POS('.',[LocStr3])
          IF [LocPos]>0
            CALC [LocStr3] AS PART([LocQ!FieldName3],2,'.')
          END_IF

          CALC [LocStr4] AS [LocQ!FieldName4]
          CALC [LocPos]  AS POS('.',[LocStr4])
          IF [LocPos]>0
            CALC [LocStr4] AS PART([LocQ!FieldName4],2,'.')
          END_IF

          CALC [LocStr5] AS [LocQ!FieldName5]
          CALC [LocPos]  AS POS('.',[LocStr5])
          IF [LocPos]>0
            CALC [LocStr5] AS PART([LocQ!FieldName5],2,'.')
          END_IF

          CALC [LocStr6] AS [LocQ!FieldName6]
          CALC [LocPos]  AS POS('.',[LocStr6])
          IF [LocPos]>0
            CALC [LocStr6] AS PART([LocQ!FieldName6],2,'.')
          END_IF

          ; berschrift speichern
          QUERY [LocU]
            INSERT
              INTO [GlobMegaSearchTable]
            VALUES ("[LocRef]","[LocStr1]","[LocStr2]","[LocStr3]","[LocStr4]","[LocStr5]","[LocStr6]","[LocQ!TableName]",0,"[LocQ!ExecScript]",1)
          END_QUERY
          EXECUTE [LocU],[LocRes]


          ; Nun das INSERT-Query basteln: alles bis zum FROM wegnehmen. Dann das INSERT-INTO davor bauen.
          QUERY [LocU]
            INSERT
              INTO [GlobMegaSearchTable]
                   (FieldName1, FieldName2, FieldName3, FieldName4, FieldName5, FieldName6, RelRefName, ScriptName, RelRecID)
            SELECT [LocQ!FieldName1], [LocQ!FieldName2], [LocQ!FieldName3], [LocQ!FieldName4], [LocQ!FieldName5], [LocQ!FieldName6], "", "", [LocC!QUERY_DESCR_REC_ID]
          END_QUERY

          ; Alles ab dem FROM an das Query dran bauen
          LIST_CLR [LocList]
          QUERY_2_LIST [LocC],[LocList]
          LIST_ITEM_GET [LocList],[LocLnAct],[LocLnCnt]
          CALC [LocLnAct] AS 1
          CALC [LocFound] AS FALSE
          WHILE [LocLnAct]<=[LocLnCnt]
            LIST_STR_GET [LocList],[LocStr1],[LocLnAct]
            IF [LocFound]
              QUERY_ADD_STRING [LocU],[LocStr1]
            ELSE
              CALC [LocPos] AS POS(' FROM ',[LocStr1])
              IF [LocPos]=0
                CALC [LocPos] AS POS(' FROM',[LocStr1])
                IF [LocPos]=0
                  CALC [LocPos] AS POS('FROM ',[LocStr1])
                  IF [LocPos]<>1
                    CALC [LocPos] AS 0
                  END_IF
                END_IF
              END_IF
              IF [LocPos]>0
                CALC [LocFound] AS TRUE
                CALC [LocStr1]  AS COPY([LocStr1],[LocPos],255)
                QUERY_ADD_STRING [LocU],[LocStr1]
              END_IF
            END_IF

            INC [LocLnAct]
          END_WHILE

          ; Einfgen....
          EXECUTE [LocU],[LocRes]

          ; Zum Schlu in die neuen Eintrge noch die fehlenden Informationen geben. FERTIG!
          QUERY [LocU]
            UPDATE [GlobMegaSearchTable]
               SET RelRefName = "[LocRef]",
                   Aktiv      =  0,
                   TableName  = "[LocQ!TableName]",
                   ScriptName = "[LocQ!ExecScript]"
             WHERE RelRefName = ""
          END_QUERY

          FLAG_SET [LocU!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
          FLAG_SET [LocU!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE

          EXECUTE [LocU],[LocRes]

          CALC [VIRTUAL_DELETE] AS FALSE
          QUERY [LocU]
            SELECT COUNT(RelRefName)
              FROM [GlobMegaSearchTable]
             WHERE RelRefName = "[LocRef]"
          END_QUERY
          EXECUTE [LocU],[LocRes]
          IF [LocRes]
            GET_DATA [LocU],[LocRes]
            IF [LocRes]
              CALC [LocLnCnt] AS [LocU!COUNT(RelRefName)]
              IF [LocLnCnt]>0
                DEC [LocLnCnt]
              END_IF

              IF [LocLnCnt]>0
                CALC [LocAllCnt] AS [LocAllCnt]+[LocLnCnt]
                CALC [LocStr1]   AS CON([LocRef],'   ',[LocLnCnt])

                QUERY [LocU]
                  UPDATE [GlobMegaSearchTable]
                     SET RelRefName = "[LocStr1]"
                   WHERE RelRefName = "[LocRef]"
                     AND Aktiv      = 1
                END_QUERY
                EXECUTE [LocU],[LocRes]
              END_IF
            END_IF
          END_IF

          CALC [VIRTUAL_DELETE] AS [BufVirtualDelete]
        END_IF
      END_IF

      GET_DATA [LocQ], [LocRes]
    END_WHILE

    IF [LocAllCnt]>0
      CALC [WorkMask!MASK_HEAD_LINE] AS CON('MegaSearch        ',[LocAllCnt],' Suchergebnisse')
    ELSE
      CALC [WorkMask!MASK_HEAD_LINE] AS 'MegaSearch'
    END_IF

;   END_WAIT
  END_PROC



  PROCEDURE InitGrid
    CALC [VIRTUAL_DELETE] AS FALSE

    LOCAL_STR LocClause
    LOCAL_STR LocStr1
    IF [WorkMask!Rubriken]
      CALC [LocClause] AS 'WHERE Aktiv = 1'
    ELSE_IF [WorkMask!Weitersuchen]
      IF [WorkMask!Suchbegriff]<>''
        IF [WorkMask!Volltextsuche]
          CALC [LocStr1] AS [WorkMask!Suchbegriff]
          CALC [LocStr1] AS REPLACE([LocStr1],' ',[SQL_WILD_CARD_MULTI])
          CALC [LocStr1] AS CON([SQL_WILD_CARD_MULTI],[LocStr1],[SQL_WILD_CARD_MULTI])
        ELSE
          CALC [LocStr1] AS CON([WorkMask!Suchbegriff],[SQL_WILD_CARD_MULTI])
        END_IF
        CALC [LocStr1] AS CON(' LIKE "',[LocStr1],'" ')

        CALC [LocClause] AS CON('WHERE (Aktiv = 1) OR (Aktiv = 0 AND (FieldName1 ',[LocStr1],' OR FieldName2 ',[LocStr1],' OR FieldName3 ',[LocStr1],' OR FieldName4 ',[LocStr1],' OR FieldName5 ',[LocStr1],' OR FieldName6 ',[LocStr1],'))')
      END_IF
    END_IF

    QUERY [GridQ]
      SELECT [  W10 N"Referenz"           ]RelRefName,
             [  W25 N"Bezeichner 1"       ]FieldName1,
             [  W25 N"Bezeichner 2"       ]FieldName2,
             [  W25 N"Bezeichner 3"       ]FieldName3,
             [  W25 N"Bezeichner 4"       ]FieldName4,
             [  W25 N"Bezeichner 5"       ]FieldName5,
             [  W25 N"Bezeichner 6"       ]FieldName6,
             [H                           ]TableName,
             [H                           ]RelRecID,
             [H                           ]ScriptName,
             [H                      K>"0"]Aktiv
        FROM [GlobMegaSearchTable]
             [LocClause]
             [StartingWithStr]
    END_QUERY

    EXECUTE [GridQ],[Res]
    IF [Res]
      GRID_SET [WorkMask], 'Ergebnisse', [GridQ], [Res], [GridOption]
    END_IF
  END_PROC



  PROCEDURE GridOkHook
    CALC [StartingWithStr] AS ''
    IF [WorkMask!MASK_ACT_GRID_NAME]='Ergebnisse'
      IF [WorkMask!Rubriken]
        CALC [WorkMask!Rubriken] AS FALSE
        MASK_UPDATE [WorkMask]
        CALC [StartingWithStr] AS CON('STARTING WITH RelRefName = "',[GridQ!RelRefName],'"')
        CALL InitGrid
      ELSE
        IF [GridQ!ScriptName]<>''
          SCRIPT [GridQ!ScriptName], [GridQ!RelRecID]
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE KeyHook
    CALC [WorkMask!MASK_HOOK_TIMER] AS ''
    MASK_TIMER [WorkMask], [MaskTimerTicks], FALSE

    IF [WorkMask!MASK_ACT_KEY]=13
      ; Enter Taste
      IF [WorkMask!Weitersuchen]=FALSE
        CALL MegsSearchTableInsert
      END_IF
      CALL InitGrid
    ELSE_IF [WorkMask!MASK_ACT_KEY]=27
      ; ESC Taste
      MASK_COMMAND  [WorkMask], [MASK_COMMAND_EXIT]
    ELSE
      CALC [WorkMask!MASK_HOOK_TIMER] AS 'TimerHook'
      MASK_TIMER [WorkMask], [MaskTimerTicks], TRUE
    END_IF
  END_PROC



  PROCEDURE PostEditHook
    IF [WorkMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='Rubriken'
      CALL InitGrid
    END_IF
  END_PROC



  PROCEDURE ExitHook
    CALL MegsSearchTableDrop
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE PostClearHook
    CALC [WorkMask!MASK_HEAD_LINE] AS 'MegaSearch'
    CALL MegsSearchTableDrop
    CALL MegsSearchTableCreate
    CALL InitGrid
  END_PROC



  PROCEDURE PreSearchHook
    CALL MegsSearchTableInsert
    CALL InitGrid
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE TimerHook
    IF [WorkMask!Suchbegriff]<>''
      CALC [WorkMask!MASK_HOOK_TIMER] AS ''
      MASK_TIMER [WorkMask], [MaskTimerTicks], FALSE
      CALC [WorkMask!MASK_HEAD_LINE] AS 'MegaSearch'
      CALL MegsSearchTableDrop
      CALL MegsSearchTableCreate
      CALL MegsSearchTableInsert
      CALL InitGrid
    END_IF
  END_PROC



  PROCEDURE ShowHook
    CALL MegsSearchTableCreate
    CALL InitGrid
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main

  CALC [VIRTUAL_DELETE]        AS [BufVirtualDelete]
  CALC [SUPER_UNIQUE_RECORDID] AS [BufSuids]
SCRIPT_END
