
  PROCEDURE InitVars
    VAR_MASK    WorkMask,'NoteShowDlg'

    VAR_STR     Str1
    VAR_QUERY   Q1
    VAR_BOOL    Res
    VAR_NUM     numRes

    VAR_LIST    NoteTypes

    CALC [WorkMask!MASK_HOOK_SHOW]       AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_EXIT]       AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_POST_CLEAR] AS 'PostClearHook'
    CALC [WorkMask!MASK_HOOK_POST_EDIT]  AS 'PostEditHook'
    CALC [WorkMask!MASK_HOOK_BUTTON]     AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_SEARCH]     AS 'PostSearchHook'
    CALC [WorkMask!MASK_HOOK_SPINNER]    AS 'PostSearchHook'
  END_PROC



  PROCEDURE ClearFieldList
    FIELD_FLAG_ON_OFF [WorkMask],'FieldNameLst','[FIELD_FLAG_PROTECTED]',''
    LIST_CLR      [WorkMask!FieldNameLst]
    LIST_ITEM_SET [WorkMask!FieldNameLst], 0
    CALC [WorkMask!SourceFieldName] AS ''
    MASK_UPDATE   [WorkMask]
  END_PROC



  PROCEDURE PostClearHook
    CALL ClearFieldList
  END_PROC



  PROCEDURE SetNoteList
    LOCAL_LIST   LocIniSecNam
    LOCAL_LIST   LocIniSecVal
    LOCAL_NUM    LocLnAct
    LOCAL_NUM    LocLnMax
    LOCAL_STR    LocStr1
    LOCAL_STR    LocStr2

    LIST_CLR    [LocIniSecNam]
    LIST_CLR    [LocIniSecVal]
    LIST_CLR    [NoteTypes]
    LIST_APPEND [NoteTypes],'Text 1|1'
    LIST_APPEND [NoteTypes],'Text 2|2'
    LIST_APPEND [NoteTypes],'Intern|3'
    LIST_APPEND [NoteTypes],'Immer|4'

    INI_READ_SECTION [Res],[LocIniSecNam],[LocIniSecVal],[APPLICATION_INI_FILE],'FreeNotes'
    LIST_ITEM_GET [LocIniSecNam],[LocLnAct],[LocLnMax]
    IF [LocLnMax]>0
      CALC [LocLnAct] AS 1
      WHILE [LocLnAct]<=[LocLnMax]
        LIST_STR_GET [LocIniSecNam],[LocStr1],[LocLnAct]
        LIST_STR_GET [LocIniSecVal],[LocStr2],[LocLnAct]
        CALC [Str1] AS CON([LocStr1],'|',[LocStr2])
        LIST_APPEND [NoteTypes],[Str1]
        INC  [LocLnAct]
      END_WHILE
    END_IF

    LIST_CLR      [WorkMask!NoteTypeLst]
    LIST_ITEM_SET [WorkMask!NoteTypeLst], 0
    CALC [WorkMask!NoteIdx] AS 0

    LIST_ITEM_GET [NoteTypes],[LocLnAct],[LocLnMax]
    IF [LocLnMax]>0
      CALC [LocLnAct] AS 1
      WHILE [LocLnAct]<=[LocLnMax]
        LIST_STR_GET [NoteTypes],[LocStr1],[LocLnAct]
        CALC [LocStr1] AS PART([LocStr1],1,'|')
        LIST_APPEND [WorkMask!NoteTypeLst], [LocStr1]
        LIST_APPEND [NoteTypes],[Str1]
        INC  [LocLnAct]
      END_WHILE
      LIST_ITEM_SET [WorkMask!NoteTypeLst], 1
    END_IF

    MASK_UPDATE [WorkMask], TRUE
  END_PROC



  PROCEDURE SetTableFields
    LIST_STR_GET [WorkMask!SourceTableName],[Str1]
    IF [Str1]<>''
      LOCAL_BOOL  LocUseDefID
      LOCAL_FLOAT LocDefID
      LOCAL_STR   FieldName
      LOCAL_NUM   FieldType


      CALC [LocUseDefID] AS FALSE
      CALC [LocDefID]    AS 0.0

      QUERY [Q1]
        SELECT DefinedID
          FROM tablefld
         WHERE UseDefID  =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
           AND TableName = "[Str1]"
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]
        GET_DATA [Q1],[Res]
        IF [Res]
          CALC [LocUseDefID] AS TRUE
          CALC [LocDefID]    AS [Q1!DefinedID]
        END_IF
      END_IF

      QUERY [Q1]
        SELECT * FROM [Str1]
      END_QUERY

      IF [LocUseDefID]
        CALC [Str1] AS CON('WHERE RecordID = ',[LocDefID|R0,0])
        QUERY_ADD_STRING [Q1], 255, [Str1]
      END_IF

      EXECUTE [Q1],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Tabellen-Felder knnen nicht gelesen werden',[MESSAGE_ERROR]
        CALC [WorkMask!SourceFieldName] AS ''
        EXIT_PROC
      END_IF

      QUERY_DESCR_TOP [Q1], [FieldName], [FieldType]
      WHILE [FieldName]<>''
        IF [FieldName]<>''
          LIST_APPEND [WorkMask!FieldNameLst], [FieldName]
        END_IF
        QUERY_DESCR_NEXT [Q1], [FieldName], [FieldType]
      END_WHILE
      LIST_SORT     [WorkMask!FieldNameLst]
      LIST_ITEM_SET [WorkMask!FieldNameLst], 1

      LIST_STR_GET [WorkMask!FieldNameLst],[Str1]
      IF [WorkMask!SourceFieldName]<>[Str1]
        LIST_STR_FIND [WorkMask!FieldNameLst], [WorkMask!SourceFieldName]
      END_IF

      LIST_STR_GET [WorkMask!FieldNameLst],[WorkMask!SourceFieldName]
      MASK_UPDATE  [WorkMask]

      FIELD_FLAG_ON_OFF [WorkMask],'FieldNameLst','','[FIELD_FLAG_PROTECTED]'
    END_IF
  END_PROC



  PROCEDURE PostSearchHook
    CALL SetTableFields

    CALC [Str1] AS [WorkMask!NoteIdx]
    LIST_STR_FIND [NoteTypes], [Str1], [numRes], '=', 2, '|'
    IF [numRes]>0
      LIST_ITEM_SET [WorkMask!NoteTypeLst], [numRes]
    END_IF
    MASK_UPDATE  [WorkMask]
  END_PROC



  PROCEDURE PostEditHook
    IF [WorkMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='SourceTableName'
      CALL ClearFieldList
      CALL SetTableFields
      EXIT_PROC
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='FieldNameLst'
      LIST_STR_GET [WorkMask!FieldNameLst],[WorkMask!SourceFieldName]
      MASK_UPDATE  [WorkMask]
      EXIT_PROC
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='NoteTypeLst'
      LIST_STR_GET [WorkMask!NoteTypeLst],[Str1]
      LIST_STR_FIND [NoteTypes], [Str1], [numRes], '=', 1, '|'
      IF [numRes]>0
        LIST_STR_GET  [NoteTypes],[Str1],[numRes]
        CALC [Str1]   AS PART([Str1],2,'|')
        CALC [numRes] AS  VAL([Str1])
        CALC [WorkMask!NoteIdx] AS [numRes]
      ELSE
        CALC [WorkMask!NoteIdx] AS 0
        LIST_ITEM_SET [WorkMask!NoteTypeLst], 0
      END_IF
      MASK_UPDATE  [WorkMask]
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_ScriptName'
      IF [WorkMask!ScriptName]<>''
        CALC [Str1] AS [WorkMask!ScriptName]
      ELSE
        CALC [Str1] AS '*.csh'
      END_IF
      CHOOSE_FILE [Str1],[CHOOSE_FILE_4_OPEN],'Scriptdatei auswhlen','Scriptdateien (*.csh)|*.csh',[Res], [SPECIAL_PATH]

      IF [Res]
        FILE_NAME [Str1],[Str1]
        CALC [WorkMask!ScriptName] AS [Str1]
        MASK_UPDATE [WorkMask]
      END_IF
    END_IF
  END_PROC



  PROCEDURE ShowHook
    CALL SetNoteList
  END_PROC



  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

