  ; DD 01.02.1999 alle Proceduren sind dokumentiert.
  ;
  ; Exportiert PROCEDURE SetNumber   VAR_NUM  SetNumber.NumberID,
  ;                                  VAR_STR  SetNumber.VarName
  ;
  ;            PROCEDURE GetNumber   VAR_NUM  GetNumber.NumberID,
  ;                                 ~VAR_STR  GetNumber.NumberResult
  ;
  ;            PROCEDURE LetNumber   VAR_NUM  LetNumber.NumberID,
  ;                                  VAR_STR  LetNumber.VarName
  ;
  ;            PROCEDURE ChkNumber   VAR_NUM  ChkNumber.NumberID,
  ;                                  VAR_STR  ChkNumber.VarName,
  ;                                  VAR_BOOL ChkNumber.HaveMessages,
  ;                                 ~VAR_BOOL ChkNumber.Result
  ;
  ;            PROCEDURE NewNumber   VAR_NUM  NewNumber.NumberID,
  ;                                  VAR_STR  NewNumber.VarName
  ;
  ;            PROCEDURE BlkNumber   VAR_NUM  BlkNumber.NumberID,
  ;                                 ~VAR_BOOL BlkNumber.Result
  ;

  ; Version 4.10.02 +
  ;            PROCEDURE ReadNumber   VAR_NUM  ReadNumber.NumberID,
  ;                                  ~VAR_BOOL ReadNumber.Result
  ;                                  ~VAR_BOOL ReadNumber.Result
  ;
  ; Version 4.10.02 -


  ; Speichert in die Nummernkreis definition mit der Nummer "SetNumber.NumberID" den Wert der in der
  ; Variable mit dem Namen "SetNumber.VarName" steht.
  ; Sollte der Nummernkreis "SetNumber.NumberID" keinen FastModus eingestellt haben, geschieht nichts.
  PROCEDURE SetNumber VAR_NUM SetNumber.NumberID, VAR_STR SetNumber.VarName
    LOCAL_QUERY SetNumber.AQuery
    LOCAL_BOOL  SetNumber.AQueryRes
    LOCAL_STR   SetNumber.TmpStr
    LOCAL_NUM   SetNumber.OriNum
    LOCAL_NUM   SetNumber.MandBuf,   [ACT_MANDANT]
    LOCAL_NUM   SetNumber.UseNumDef, 1

    WHILE [SetNumber.UseNumDef]>0
      CALC [SetNumber.OriNum] AS [SetNumber.NumberID]
      IF [ACT_MANDANT]>0
        CALC [SetNumber.TmpStr]   AS [SetNumber.NumberID]
        CALC [SetNumber.NumberID] AS 1000 + [ACT_MANDANT]
        CALC [SetNumber.TmpStr]   AS CON([SetNumber.NumberID],[SetNumber.TmpStr])
        CALC [SetNumber.NumberID] AS VAL([SetNumber.TmpStr])
        CALC [SetNumber.TmpStr]   AS ''
      END_IF

      QUERY [SetNumber.AQuery]
        SELECT Bezeichnung, SchnellModus, UseNumDef
          FROM nummern
         WHERE KreisID = [SetNumber.NumberID]
      END_QUERY

      EXECUTE [SetNumber.AQuery],[SetNumber.AQueryRes]
      IF [SetNumber.AQueryRes]=FALSE
        MESSAGE 'Achtung : schwerer Datenbankfehler','Die Nummernkreistabelle kann nicht gelesen werden'
        CALC [ACT_MANDANT] AS [SetNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [SetNumber.AQuery],[SetNumber.AQueryRes]
      IF [SetNumber.AQueryRes]=FALSE
        ; CALC [SetNumber.TmpStr] AS CON('Es wurde versucht den Startwert des Nummernkreises ',[SetNumber.NumberID],'|zu setzten, ohne da dieser Nummernkreis vorhanden ist!')
        ; MESSAGE 'Achtung Abbruch',[SetNumber.TmpStr]
        CALC [ACT_MANDANT] AS [SetNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [SetNumber.UseNumDef] AS [SetNumber.AQuery!UseNumDef]

      IF [SetNumber.UseNumDef]>0
        IF [SetNumber.UseNumDef]>=10000
          CALC [SetNumber.TmpStr] AS [SetNumber.UseNumDef]
          CALC [SetNumber.TmpStr] AS COPY([SetNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]      AS  VAL([SetNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]      AS 0
        END_IF
        CALC [SetNumber.TmpStr]   AS [SetNumber.UseNumDef]
        CALC [SetNumber.TmpStr]   AS COPY([SetNumber.TmpStr],5,255)
        CALC [SetNumber.NumberID] AS  VAL([SetNumber.TmpStr])
      END_IF
    END_WHILE

    IF [SetNumber.AQuery!SchnellModus]=FALSE
      ; CALC [SetNumber.TmpStr] AS CON('Es wurde versucht den Startwert des Nummernkreises "',[SetNumber.AQuery!Bezeichnung],'"  (ID:',[SetNumber.NumberID],')|zu setzten, ohne da dieser Nummernkreis auf Schnellmodus eingestellt ist!')
      ; MESSAGE 'Achtung Abbruch',[SetNumber.TmpStr]
      CALC [ACT_MANDANT] AS [SetNumber.MandBuf]
      EXIT_PROC
    END_IF

    CALC [SetNumber.TmpStr] AS CON('Der Startwert eines Nummernkreises im Schnellmodus|(Bezeichnung "',[SetNumber.AQuery!Bezeichnung],'",  ID:',[SetNumber.NumberID],')|konnte nicht gesetzt werden!')

    QUERY [SetNumber.AQuery]
      UPDATE nummern
         SET Startwert = "[[SetNumber.VarName]]"
       WHERE KreisID   =  [SetNumber.NumberID]
    END_QUERY

    EXECUTE [SetNumber.AQuery],[SetNumber.AQueryRes]
    IF [SetNumber.AQueryRes]=FALSE
      MESSAGE 'Achtung Systemfehler',[SetNumber.TmpStr]
      CALC [ACT_MANDANT] AS [SetNumber.MandBuf]
      EXIT_PROC
    END_IF

    CALC [ACT_MANDANT] AS [SetNumber.MandBuf]
  END_PROC


  ; Holt mit der Nummernkreis-Definition mit der Nummer "FndNumber.NumberID" eine neue Nummer.
  ; Wenn mit "FndNumber.NormalDirection" FALSE aufgerufen wird, dann wird in die entgegengesetzte
  ; Richtung gezhlt, die bei der Nummernkreisdefinition hinterleg wurde.
  PROCEDURE FndNumber VAR_NUM FndNumber.NumberID, ~VAR_STR FndNumber.NumberResult, VAR_BOOL FndNumber.NormalDirection, ~VAR_BOOL FndNumber.BlockField, VAR_BOOL FndNumber.IgnoreSpaces
    LOCAL_NUM   FndNumber.MaxFillSpaces, 100000

    LOCAL_STR   FndNumber.SearchFld
    LOCAL_STR   FndNumber.StartFld

    LOCAL_STR   FndNumber.DefFld
    LOCAL_STR   FndNumber.DefVar

    LOCAL_STR   FndNumber.NumRead
    LOCAL_STR   FndNumber.TmpStr
    LOCAL_STR   FndNumber.SwpStr
    LOCAL_STR   FndNumber.Str1
    LOCAL_STR   FndNumber.Str2
    LOCAL_STR   FndNumber.Str3

    LOCAL_STR   FndNumber.StartWert
    LOCAL_STR   FndNumber.DatenFeld
    LOCAL_STR   FndNumber.DatenBank
    LOCAL_STR   FndNumber.VariabelStart
    LOCAL_STR   FndNumber.Bedingung
    LOCAL_STR   FndNumber.SubOrderBy
    LOCAL_NUM   FndNumber.Stellen
    LOCAL_NUM   FndNumber.StepSize
    LOCAL_BOOL  FndNumber.FastMode

    LOCAL_NUM   FndNumber.LenFix
    LOCAL_NUM   FndNumber.LenVar
    LOCAL_NUM   FndNumber.LenStart
    LOCAL_NUM   FndNumber.LenRest
    LOCAL_NUM   FndNumber.TmpNum
    LOCAL_NUM   FndNumber.NumValue
    LOCAL_NUM   FndNumber.PreValue

    LOCAL_QUERY FndNumber.AQuery
    LOCAL_BOOL  FndNumber.AQueryRes
    LOCAL_NUM   FndNumber.MandBuf,    [ACT_MANDANT]
    LOCAL_NUM   FndNumber.UseNumDef,  1
    LOCAL_NUM   FndNumber.OriNum

    LOCAL_BOOL  FndNumber.FillSpaces
    LOCAL_BOOL  FndNumber.AvoidVirtDel
    LOCAL_BOOL  FndNumber.ActVirtDelState
    CALC [FndNumber.ActVirtDelState] AS [VIRTUAL_DELETE]

    CALC [FndNumber.NumberResult] AS ''
    CALC [FndNumber.SubOrderBy]   AS ''
    CALC [FndNumber.BlockField]   AS FALSE
    CALC [FndNumber.FillSpaces]   AS FALSE

    WHILE [FndNumber.UseNumDef]>0
      CALC [FndNumber.OriNum] AS [FndNumber.NumberID]
      IF [ACT_MANDANT]>0
        CALC [FndNumber.TmpStr]   AS [FndNumber.NumberID]
        CALC [FndNumber.NumberID] AS 1000 + [ACT_MANDANT]
        CALC [FndNumber.TmpStr]   AS CON([FndNumber.NumberID],[FndNumber.TmpStr])
        CALC [FndNumber.NumberID] AS VAL([FndNumber.TmpStr])
        CALC [FndNumber.TmpStr]   AS ''
      END_IF

      QUERY [FndNumber.AQuery]
          SELECT Stellen, Datenfeld, Datenbank, FestStart, FillSpaces,
                 VariabelStart, Schrittweite, Startwert, Bezeichnung,
                 Bedingung, KreisID, SchnellModus, EingabeBlocken,
                 FirstChars, AvoidVitualDel, UseNumDef,
                 RecordID, RecFlag, EventFlag
            FROM nummern
           WHERE KreisID = [FndNumber.NumberID]
        ORDER BY KreisID
      END_QUERY

      EXECUTE [FndNumber.AQuery],[FndNumber.AQueryRes]
      IF [FndNumber.AQueryRes]=FALSE
        CALC [ACT_MANDANT] AS [FndNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [FndNumber.AQuery],[FndNumber.AQueryRes]
      IF [FndNumber.AQueryRes]=FALSE
        CALC [ACT_MANDANT] AS [FndNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [FndNumber.UseNumDef]  AS [FndNumber.AQuery!UseNumDef]
      CALC [FndNumber.FillSpaces] AS [FndNumber.AQuery!FillSpaces]

      IF [FndNumber.UseNumDef]>0
        IF [FndNumber.UseNumDef]>=10000
          CALC [FndNumber.TmpStr] AS [FndNumber.UseNumDef]
          CALC [FndNumber.TmpStr] AS COPY([FndNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]      AS  VAL([FndNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]      AS 0
        END_IF

        CALC [FndNumber.TmpStr]   AS [FndNumber.UseNumDef]
        CALC [FndNumber.TmpStr]   AS COPY([FndNumber.TmpStr],5,255)
        CALC [FndNumber.NumberID] AS  VAL([FndNumber.TmpStr])
      END_IF
    END_WHILE

    CALC [FndNumber.BlockField]   AS [FndNumber.AQuery!EingabeBlocken]
    CALC [FndNumber.AvoidVirtDel] AS [FndNumber.AQuery!AvoidVitualDel]

    CALC [FndNumber.Bedingung] AS ''
    IF [FndNumber.AQuery!Bedingung]<>''
      CALC [FndNumber.Bedingung] AS CON(' AND (',[FndNumber.AQuery!Bedingung],') ')
      CALC [FndNumber.Bedingung] AS REPLACE([FndNumber.Bedingung],'|', '"')

      CALC [FndNumber.TmpNum] AS POS('!',[FndNumber.Bedingung])
      IF [FndNumber.TmpNum]>0
        ; Ein Ausrufungszeichen steht immer vor einem Bedinungs-Feld-Namen
        ; das in die Order-By-Clause des Such-Querys aufgenommen werden soll

        ; Bedinungs-Feld-Namen extraieren
        CALC [FndNumber.SubOrderBy] AS ' , '
        CALC [FndNumber.TmpStr]     AS ''
        CALC [FndNumber.LenVar]     AS LEN([FndNumber.Bedingung])
        WHILE [FndNumber.TmpStr]<>' '
          INC [FndNumber.TmpNum]
          IF [FndNumber.TmpNum]>[FndNumber.LenVar]
            CALC [FndNumber.TmpStr] AS ' '
          ELSE
            CALC [FndNumber.TmpStr] AS COPY([FndNumber.Bedingung],[FndNumber.TmpNum],1)
          END_IF
          IF [FndNumber.TmpStr]<>' '
            CALC [FndNumber.SubOrderBy] AS CON([FndNumber.SubOrderBy],[FndNumber.TmpStr])
          END_IF
        END_WHILE

        ; ! aus der Bedingung entfernen
        CALC [FndNumber.TmpNum] AS POS('!',[FndNumber.Bedingung])
        DEC  [FndNumber.TmpNum]
        IF [FndNumber.TmpNum]>0
          CALC [FndNumber.TmpStr] AS COPY([FndNumber.Bedingung],1,[FndNumber.TmpNum])
        ELSE
          CALC [FndNumber.TmpStr] AS ''
        END_IF
        CALC [FndNumber.TmpNum] AS [FndNumber.TmpNum] + 2
        CALC [FndNumber.Bedingung] AS COPY([FndNumber.Bedingung],[FndNumber.TmpNum],255)
        IF [FndNumber.Bedingung]=''
          CALC [FndNumber.Bedingung] AS [FndNumber.TmpStr]
          CALC [FndNumber.TmpStr]    AS ''
        END_IF
        IF [FndNumber.TmpStr]<>''
          CALC [FndNumber.Bedingung] AS CON([FndNumber.TmpStr],[FndNumber.Bedingung])
        END_IF
      END_IF
    END_IF

    CALC [FndNumber.StartWert] AS [FndNumber.AQuery!StartWert]
    CALC [FndNumber.StepSize]  AS [FndNumber.AQuery!Schrittweite]
    CALC [FndNumber.Stellen]   AS [FndNumber.AQuery!Stellen]

    CALC [FndNumber.FastMode]  AS [FndNumber.AQuery!SchnellModus]

    CALC [FndNumber.DatenFeld] AS TRIM([FndNumber.AQuery!DatenFeld])
    CALC [FndNumber.TmpNum]    AS POS(' ',[FndNumber.DatenFeld])
    IF [FndNumber.TmpNum]>0
      DEC [FndNumber.TmpNum]
      CALC [FndNumber.DatenFeld] AS COPY([FndNumber.DatenFeld],1,[FndNumber.TmpNum])
    END_IF

    CALC [FndNumber.DatenBank]     AS [FndNumber.AQuery!DatenBank]
    CALC [FndNumber.VariabelStart] AS UPCASE([FndNumber.AQuery!VariabelStart])

    CALC [FndNumber.LenFix] AS LEN([FndNumber.AQuery!FestStart])
    CALC [FndNumber.DefFld] AS [FndNumber.AQuery!FestStart]

    IF [FndNumber.VariabelStart]='JAHR'
      CALC [FndNumber.DefVar] AS [DATE]
      CALC [FndNumber.DefVar] AS COPY([FndNumber.DefVar],7,4)
    ELSE_IF [FndNumber.VariabelStart]='JAHR + MONAT'
      CALC [FndNumber.DefVar] AS [DATE]
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.DefVar],4,2)
      CALC [FndNumber.DefVar] AS COPY([FndNumber.DefVar],7,4)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
    ELSE_IF [FndNumber.VariabelStart]='JAHR + MONAT + TAG'
      CALC [FndNumber.SwpStr] AS [DATE]
      CALC [FndNumber.DefVar] AS COPY([FndNumber.SwpStr],7,4)
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.SwpStr],4,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.SwpStr],1,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
    ELSE_IF [FndNumber.VariabelStart]='MONAT + TAG'
      CALC [FndNumber.SwpStr] AS [DATE]
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.SwpStr],4,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.SwpStr],1,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
    ELSE_IF [FndNumber.VariabelStart]='BENUTZER'
      CALC [FndNumber.DefVar] AS COPY([SHORT_NAME],1,2)
    ELSE_IF [FndNumber.VariabelStart]='JAHR 2 St.'
      CALC [FndNumber.DefVar] AS [DATE]
      CALC [FndNumber.DefVar] AS COPY([FndNumber.DefVar],9,2)
    ELSE_IF [FndNumber.VariabelStart]='JAHR 2 St. + MONAT'
      CALC [FndNumber.DefVar] AS [DATE]
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.DefVar],4,2)
      CALC [FndNumber.DefVar] AS COPY([FndNumber.DefVar],9,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
    ELSE_IF [FndNumber.VariabelStart]='JAHR 2 St. + MONAT + TAG'
      CALC [FndNumber.SwpStr] AS [DATE]
      CALC [FndNumber.DefVar] AS COPY([FndNumber.SwpStr],9,2)
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.SwpStr],4,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.SwpStr],1,2)
      CALC [FndNumber.DefVar] AS CON([FndNumber.DefVar],[FndNumber.TmpStr])
    ELSE
      CALC [FndNumber.DefVar] AS ''
    END_IF

    CALC [FndNumber.LenVar]   AS LEN([FndNumber.DefVar])
    CALC [FndNumber.LenStart] AS [FndNumber.LenVar]+[FndNumber.LenFix]
    CALC [FndNumber.DefFld]   AS CON([FndNumber.DefFld],[FndNumber.DefVar])
    CALC [FndNumber.LenRest]  AS [FndNumber.Stellen]-[FndNumber.LenStart]


    IF [FndNumber.StepSize]>0
      ; hchste Nummer erstellen
      CALC [FndNumber.SearchFld] AS CHAR(#254)
      CALC [FndNumber.SearchFld] AS EXT([FndNumber.SearchFld],[FndNumber.LenRest],254,2,1)
    ELSE
      ; niederigste Nummer erstellen
      CALC [FndNumber.SearchFld] AS CHAR(#1)
      CALC [FndNumber.SearchFld] AS EXT([FndNumber.SearchFld],[FndNumber.LenRest],1,2,1)
    END_IF

    ; Start-Nummer erstellen
    CALC [FndNumber.StartFld] AS EXT('1',[FndNumber.LenRest],48,2,1)

    IF [FndNumber.StartWert]<>''
      CALC [FndNumber.TmpNum] AS [FndNumber.LenStart]+1
      CALC [FndNumber.TmpStr] AS COPY([FndNumber.StartWert],[FndNumber.TmpNum],250)
      IF [FndNumber.TmpStr]<>''
        CALC [FndNumber.StartFld] AS EXT([FndNumber.TmpStr],[FndNumber.LenRest],48,2,1)
      END_IF
    END_IF

    ; Default Ergebnis ist Start-Nummer
    CALC [FndNumber.NumberResult] AS CON([FndNumber.DefFld],[FndNumber.StartFld])

    CALC [FndNumber.TmpStr]  AS CON([FndNumber.DefFld],[FndNumber.SearchFld])

    IF [FndNumber.FastMode]=FALSE
      IF [FndNumber.AvoidVirtDel]
        CALC [VIRTUAL_DELETE] AS FALSE
      END_IF

      IF [FndNumber.DefFld]<>''
        CALC [FndNumber.TmpStr] AS CON([FndNumber.TmpStr],'" AND ',[FndNumber.DatenFeld],' LIKE "',[FndNumber.DefFld],[SQL_WILD_CARD_MULTI])
      END_IF

      ; This fits for ACCESS and MS-SQL
      CALC [FndNumber.Str1] AS ' TOP 1 '
      CALC [FndNumber.Str2] AS ''
      CALC [FndNumber.Str3] AS ''
      IF [SQL_VENDOR]='MYSQL'
        CALC [FndNumber.Str1] AS ''
        CALC [FndNumber.Str2] AS ' LIMIT 0,1 '
      ELSE_IF [SQL_VENDOR]='SQLITE'
        CALC [FndNumber.Str1] AS ''
        CALC [FndNumber.Str2] AS ' LIMIT 0,1 '
      END_IF

      IF [FndNumber.StepSize]>0
        IF [FndNumber.Startwert]<>''
          CALC [FndNumber.Str3] AS CON(' AND ',[FndNumber.DatenFeld],' >= "',[FndNumber.Startwert],'" ')
        END_IF

        QUERY [FndNumber.AQuery]
            SELECT [FndNumber.Str1] [FndNumber.DatenFeld] [FndNumber.SubOrderBy]
              FROM [FndNumber.DatenBank]
             WHERE [FndNumber.DatenFeld] < "[FndNumber.TmpStr]" [FndNumber.Bedingung]
                   [FndNumber.Str3]
          ORDER BY [FndNumber.DatenFeld] DESC [FndNumber.SubOrderBy]
                   [FndNumber.Str2]
        END_QUERY
      ELSE
        IF [FndNumber.Startwert]<>''
          CALC [FndNumber.Str3] AS CON(' AND ',[FndNumber.DatenFeld],' <= "',[FndNumber.Startwert],'" ')
        END_IF

        QUERY [FndNumber.AQuery]
            SELECT [FndNumber.Str1] [FndNumber.DatenFeld] [FndNumber.SubOrderBy]
              FROM [FndNumber.DatenBank]
             WHERE [FndNumber.DatenFeld] > "[FndNumber.TmpStr]" [FndNumber.Bedingung]
                   [FndNumber.Str3]
          ORDER BY [FndNumber.DatenFeld] DESC [FndNumber.SubOrderBy]
                   [FndNumber.Str2]
        END_QUERY
      END_IF

      EXECUTE [FndNumber.AQuery],[FndNumber.AQueryRes]
      IF [FndNumber.AQueryRes]=FALSE
        CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
        CALC [ACT_MANDANT]    AS [FndNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [FndNumber.AQuery],[FndNumber.AQueryRes]
      IF [FndNumber.AQueryRes]=FALSE
        CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
        CALC [ACT_MANDANT]    AS [FndNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [FndNumber.Str2] AS ''
      IF [FndNumber.Str1]<>''
        CALC [FndNumber.Str2] AS 'TOP1'
      END_IF
      CALC [FndNumber.NumRead] AS [FndNumber.AQuery![FndNumber.Str2][FndNumber.DatenFeld]]

      CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
    ELSE
      CALC [FndNumber.NumRead] AS [FndNumber.NumberResult]
    END_IF

    CALC [ACT_MANDANT] AS [FndNumber.MandBuf]

    ; Ergebnis kleiner als der FndNumber.SwpStr
    IF [FndNumber.StepSize]>0
      IF [FndNumber.NumRead]<[FndNumber.NumberResult]
        EXIT_PROC
      END_IF
    ELSE
      IF [FndNumber.NumRead]>[FndNumber.NumberResult]
        EXIT_PROC
      END_IF
    END_IF

    CALC [FndNumber.TmpNum]   AS [FndNumber.LenStart]+1
    CALC [FndNumber.TmpStr]   AS COPY([FndNumber.NumRead],[FndNumber.TmpNum],250)

    CALC [FndNumber.NumValue] AS VALUE([FndNumber.TmpStr])

    CALC [FndNumber.TmpStr] AS ''
    IF [FndNumber.LenStart]>0
      CALC [FndNumber.TmpStr]   AS COPY([FndNumber.NumRead],1,[FndNumber.LenStart])
    END_IF

    IF [FndNumber.VariabelStart]<>'Benutzer'
      IF [FndNumber.TmpStr]<[FndNumber.DefFld]
        CALC [FndNumber.TmpStr]       AS EXT('1',[FndNumber.LenRest],48,2,1)
        CALC [FndNumber.NumberResult] AS CON([FndNumber.DefFld],[FndNumber.TmpStr])
        EXIT_PROC
      END_IF
    ELSE
      IF [FndNumber.TmpStr]<>[FndNumber.DefFld]
        CALC [FndNumber.TmpStr]       AS EXT('1',[FndNumber.LenRest],48,2,1)
        CALC [FndNumber.NumberResult] AS CON([FndNumber.DefFld],[FndNumber.TmpStr])
        EXIT_PROC
      END_IF
    END_IF

    IF [FndNumber.NormalDirection]
      CALC [FndNumber.NumValue] AS ([FndNumber.NumValue])+([FndNumber.StepSize])
    ELSE
      CALC [FndNumber.NumValue] AS ([FndNumber.NumValue])-([FndNumber.StepSize])
    END_IF

    CALC [FndNumber.TmpStr]   AS [FndNumber.NumValue]
    CALC [FndNumber.PreValue] AS [FndNumber.NumValue]

    IF [FndNumber.TmpStr]<>''
      CALC [FndNumber.TmpStr] AS EXT([FndNumber.TmpStr],[FndNumber.LenRest],48,2,1)
    ELSE
      CALC [FndNumber.TmpStr] AS EXT('1',[FndNumber.LenRest],48,2,1)
    END_IF

    CALC [FndNumber.NumberResult] AS CON([FndNumber.DefFld],[FndNumber.TmpStr])

    IF [FndNumber.IgnoreSpaces]=FALSE
      IF [FndNumber.FillSpaces]
        WAIT_INFO 'Bitte warten...', 'Eventuell vorhandene Lcken im Nummernkreis werden gesucht und ggf. gefllt', FALSE, 70,2

        CALC [FndNumber.TmpStr]  AS CON([FndNumber.DefFld],[FndNumber.SearchFld])

        IF [FndNumber.AvoidVirtDel]
          CALC [VIRTUAL_DELETE] AS FALSE
        END_IF

        IF [FndNumber.DefFld]<>''
          CALC [FndNumber.TmpStr] AS CON([FndNumber.TmpStr],'" AND ',[FndNumber.DatenFeld],' LIKE "',[FndNumber.DefFld],[SQL_WILD_CARD_MULTI])
        END_IF

        CALC [FndNumber.Str1] AS CON(' TOP ',[FndNumber.MaxFillSpaces],' ')
        CALC [FndNumber.Str2] AS ''
        CALC [FndNumber.Str3] AS ''
        IF [SQL_VENDOR]='MYSQL'
          CALC [FndNumber.Str1] AS ''
          CALC [FndNumber.Str2] AS CON(' LIMIT 0,',[FndNumber.MaxFillSpaces],' ')
        ELSE_IF [SQL_VENDOR]='SQLITE'
          CALC [FndNumber.Str1] AS ''
          CALC [FndNumber.Str2] AS CON(' LIMIT 0,',[FndNumber.MaxFillSpaces],' ')
        END_IF

        IF [FndNumber.StepSize]>0
          IF [FndNumber.Startwert]<>''
            CALC [FndNumber.Str3] AS CON(' AND ',[FndNumber.DatenFeld],' >= "',[FndNumber.Startwert],'" ')
          END_IF

          QUERY [FndNumber.AQuery]
              SELECT [FndNumber.Str1] [FndNumber.DatenFeld] [FndNumber.SubOrderBy]
                FROM [FndNumber.DatenBank]
               WHERE [FndNumber.DatenFeld] < "[FndNumber.TmpStr]" [FndNumber.Bedingung]
                     [FndNumber.Str3]
            ORDER BY [FndNumber.DatenFeld] DESC [FndNumber.SubOrderBy]
                     [FndNumber.Str2]
          END_QUERY
        ELSE
          IF [FndNumber.Startwert]<>''
            CALC [FndNumber.Str3] AS CON(' AND ',[FndNumber.DatenFeld],' <= "',[FndNumber.Startwert],'" ')
          END_IF

          QUERY [FndNumber.AQuery]
              SELECT [FndNumber.Str1] [FndNumber.DatenFeld] [FndNumber.SubOrderBy]
                FROM [FndNumber.DatenBank]
               WHERE [FndNumber.DatenFeld] > "[FndNumber.TmpStr]" [FndNumber.Bedingung]
                     [FndNumber.Str3]
            ORDER BY [FndNumber.DatenFeld] DESC [FndNumber.SubOrderBy]
                     [FndNumber.Str2]
          END_QUERY
        END_IF

        EXECUTE [FndNumber.AQuery],[FndNumber.AQueryRes]
        IF [FndNumber.AQueryRes]=FALSE
          CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
          END_WAIT
          EXIT_PROC
        END_IF

        GET_DATA [FndNumber.AQuery],[FndNumber.AQueryRes]
        IF [FndNumber.AQueryRes]=FALSE
          CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
          END_WAIT
          EXIT_PROC
        END_IF

        CALC [FndNumber.Str2] AS ''
        IF [FndNumber.Str1]<>''
          CALC [FndNumber.Str2] AS CON('TOP',[FndNumber.MaxFillSpaces])
        END_IF

        WHILE [FndNumber.AQueryRes]
          CALC [FndNumber.NumRead]   AS [FndNumber.AQuery![FndNumber.Str2][FndNumber.DatenFeld]]

          CALC [FndNumber.TmpNum]    AS [FndNumber.LenStart]+1
          CALC [FndNumber.TmpStr]    AS  COPY([FndNumber.NumRead],[FndNumber.TmpNum],250)
          CALC [FndNumber.NumValue]  AS VALUE([FndNumber.TmpStr])

          CALC [FndNumber.AQueryRes] AS FALSE

          IF [FndNumber.NormalDirection]
            CALC [FndNumber.TmpNum] AS [FndNumber.PreValue]-[FndNumber.NumValue]
            IF [FndNumber.TmpNum]>[FndNumber.StepSize]
              ; Jetzt wurde eine Lcke gefunden
              CALC [FndNumber.AQueryRes] AS TRUE
            END_IF
          ELSE
            CALC [FndNumber.TmpNum] AS [FndNumber.NumValue]-[FndNumber.PreValue]
            IF [FndNumber.TmpNum]<[FndNumber.StepSize]
              ; Jetzt wurde eine Lcke gefunden
              CALC [FndNumber.AQueryRes] AS TRUE
            END_IF
          END_IF

          IF [FndNumber.AQueryRes]
            IF [FndNumber.NormalDirection]
              CALC [FndNumber.NumValue] AS [FndNumber.NumValue]+[FndNumber.StepSize]
            ELSE
              CALC [FndNumber.NumValue] AS [FndNumber.NumValue]-[FndNumber.StepSize]
            END_IF

            CALC [FndNumber.TmpStr] AS [FndNumber.NumValue]
            IF [FndNumber.TmpStr]<>''
              CALC [FndNumber.TmpStr] AS EXT([FndNumber.TmpStr],[FndNumber.LenRest],48,2,1)
            ELSE
              CALC [FndNumber.TmpStr] AS EXT('1',[FndNumber.LenRest],48,2,1)
            END_IF
            CALC [FndNumber.NumberResult] AS CON([FndNumber.DefFld],[FndNumber.TmpStr])

            CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
            END_WAIT

            EXIT_PROC
          END_IF

          CALC [FndNumber.PreValue] AS [FndNumber.NumValue]

          GET_DATA [FndNumber.AQuery],[FndNumber.AQueryRes]
        END_WHILE

        END_WAIT

        CALC [VIRTUAL_DELETE] AS [FndNumber.ActVirtDelState]
      END_IF
    END_IF
  END_PROC



  ; Holt mit der Nummernkreis-Definition mit der Nummer "GetNumber.NumberID" eine neue Nummer.
  ; Es wird in die Richtung gezhlt, die bei der Nummernkreisdefinition hinterlegt wurde.
  PROCEDURE GetNumber VAR_NUM GetNumber.NumberID, ~VAR_STR GetNumber.NumberResult
    LOCAL_BOOL GetNumber.CountForwardYes,TRUE
    LOCAL_BOOL GetNumber.DummyBlock

    CALL FndNumber [GetNumber.NumberID], [GetNumber.NumberResult], [GetNumber.CountForwardYes], [GetNumber.DummyBlock], FALSE
  END_PROC


  ; Holt mit der Nummernkreis-Definition mit der Nummer "LetNumber.NumberID" die Vorgnger-Nummer.
  ; Es wird in die entgegengesetzte Richtung gezhlt, die bei der Nummernkreisdefinition hinterleg wurde.
  ; Der aktuelle Wert [[LetNumber.VarName]] mu in der Definitionsdatei zu finden sein, sonst wird
  ; gar nicht erst versucht zurck zu  zhlen.
  PROCEDURE LetNumber VAR_NUM LetNumber.NumberID, VAR_STR LetNumber.VarName
    LOCAL_BOOL  LetNumber.CountForwardNo,FALSE
    LOCAL_QUERY LetNumber.AQuery
    LOCAL_BOOL  LetNumber.AQueryRes
    LOCAL_STR   LetNumber.TmpStr
    LOCAL_STR   LetNumber.NewNumber
    LOCAL_BOOL  LetNumber.BlockField
    LOCAL_NUM   LetNumber.MandBuf,    [ACT_MANDANT]
    LOCAL_NUM   LetNumber.UseNumDef,  1
    LOCAL_NUM   LetNumber.OriNum

    WHILE [LetNumber.UseNumDef]>0
      CALC [LetNumber.OriNum] AS [LetNumber.NumberID]
      IF [ACT_MANDANT]>0
        CALC [LetNumber.TmpStr]   AS [LetNumber.NumberID]
        CALC [LetNumber.NumberID] AS 1000 + [ACT_MANDANT]
        CALC [LetNumber.TmpStr]   AS CON([LetNumber.NumberID],[LetNumber.TmpStr])
        CALC [LetNumber.NumberID] AS VAL([LetNumber.TmpStr])
        CALC [LetNumber.TmpStr]   AS ''
      END_IF

      QUERY [LetNumber.AQuery]
        SELECT Stellen, Datenfeld, Datenbank, FestStart,
               VariabelStart, Schrittweite, Startwert, Bezeichnung,
               Bedingung, KreisID, SchnellModus, EingabeBlocken,
               FirstChars, AvoidVitualDel, UseNumDef,
               RecordID, RecFlag, EventFlag
          FROM nummern
         WHERE KreisID = [LetNumber.NumberID]
      END_QUERY

      EXECUTE [LetNumber.AQuery],[LetNumber.AQueryRes]
      IF [LetNumber.AQueryRes]=FALSE
        MESSAGE 'Achtung : schwerer Datenbankfehler','Die Nummernkreistabelle kann nicht gelesen werden'
        FORE_JUMP
      END_IF

      GET_DATA [LetNumber.AQuery],[LetNumber.AQueryRes]
      IF [LetNumber.AQueryRes]=FALSE
        ; CALC [LetNumber.TmpStr] AS CON('Es wurde versucht den Startwert des Nummernkreises ',[LetNumber.NumberID],'|zurck zu setzten, ohne da dieser Nummernkreis vorhanden ist!')
        ; MESSAGE 'Achtung Abbruch',[LetNumber.TmpStr]
        FORE_JUMP
      END_IF

      CALC [LetNumber.UseNumDef] AS [LetNumber.AQuery!UseNumDef]

      IF [LetNumber.UseNumDef]>0
        IF [LetNumber.UseNumDef]>=10000
          CALC [LetNumber.TmpStr] AS [LetNumber.UseNumDef]
          CALC [LetNumber.TmpStr] AS COPY([LetNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]      AS  VAL([LetNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]      AS 0
        END_IF

        CALC [LetNumber.TmpStr]   AS [LetNumber.UseNumDef]
        CALC [LetNumber.TmpStr]   AS COPY([LetNumber.TmpStr],5,255)
        CALC [LetNumber.NumberID] AS  VAL([LetNumber.TmpStr])
      END_IF
    END_WHILE


    IF [LetNumber.AQuery!SchnellModus]=FALSE
      ; CALC [LetNumber.TmpStr] AS CON('Es wurde versucht den Startwert des Nummernkreises "',[LetNumber.AQuery!Bezeichnung],'"  (ID:',[LetNumber.NumberID],')|zurck zu setzten, ohne da dieser Nummernkreis auf Schnellmodus eingestellt ist!')
      ; MESSAGE 'Achtung Abbruch',[LetNumber.TmpStr]
      FORE_JUMP
    END_IF

    IF [LetNumber.AQuery!AvoidVitualDel]
      FORE_JUMP
    END_IF

    IF [LetNumber.AQuery!Startwert]<>[[LetNumber.VarName]]
      ; CALC [LetNumber.TmpStr] AS CON('Es wurde versucht den Startwert des Nummernkreises "',[LetNumber.AQuery!Bezeichnung],'"  (ID:',[LetNumber.NumberID],')|zurck zu setzten, ohne da der Startwert zu dem bergabewert passt !')
      ; MESSAGE 'Achtung Abbruch',[LetNumber.TmpStr]
      FORE_JUMP
    END_IF

    CALL FndNumber [LetNumber.OriNum], [LetNumber.NewNumber], [LetNumber.CountForwardNo], [LetNumber.BlockField], TRUE

    IF [LetNumber.AQuery!Schrittweite]>0
      IF [LetNumber.NewNumber]>=[[LetNumber.VarName]]
        ; CALC [LetNumber.TmpStr] AS CON('Der Startwert des Nummernkreises "',[LetNumber.AQuery!Bezeichnung],'"  (ID:',[LetNumber.NumberID],')|wird nicht zurck zu gesetzt, da in der Zwischeinzeit bereits weitere Nummern vergeben wurden.')
        ; MESSAGE 'Achtung Abbruch',[LetNumber.TmpStr]
        FORE_JUMP
      END_IF
    ELSE
      IF [LetNumber.NewNumber]<=[[LetNumber.VarName]]
        ; CALC [LetNumber.TmpStr] AS CON('Der Startwert des Nummernkreises "',[LetNumber.AQuery!Bezeichnung],'"  (ID:',[LetNumber.NumberID],')|wird nicht zurck zu gesetzt, da in der Zwischeinzeit bereits weitere Nummern vergeben wurden.')
        ; MESSAGE 'Achtung Abbruch',[LetNumber.TmpStr]
        FORE_JUMP
      END_IF
    END_IF

    CALC [LetNumber.TmpStr] AS CON('Der Startwert eines Nummernkreises im Schnellmodus|(Bezeichnung "',[LetNumber.AQuery!Bezeichnung],'",  ID:',[LetNumber.NumberID],')|konnte nicht zurck gesetzt werden!')

    QUERY [LetNumber.AQuery]
      UPDATE nummern
         SET Startwert = "[LetNumber.NewNumber]"
       WHERE KreisID   =  [LetNumber.NumberID]
    END_QUERY

    EXECUTE [LetNumber.AQuery],[LetNumber.AQueryRes]
    IF [LetNumber.AQueryRes]=FALSE
      MESSAGE 'Achtung Systemfehler',[LetNumber.TmpStr]
      FORE_JUMP
    END_IF

    FORE_MARK
    CALC [ACT_MANDANT] AS [LetNumber.MandBuf]
  END_PROC



  ; Checkt den Wert in der Variable deren Name in "ChkNumber.VarName" bergeben wurde
  ; im Nummernkreis mit der Nummer "ChkNumber.NumberID". In ChkNumber.Result wird angezeigt, ob die Prfung
  ; erfolgreich war. Sollte die zu prfende Nummer bereits vergeben sein oder nicht in den
  ; laufenden Nummernkreis passen, so wird eine neue, passende erzeugt und in [[ChkNumber.VarName]]
  ; gespeichert.
  ;
  ; Falls die Variable [[ChkNumber.VarName]] eine Maskenvariable ist, geschieht auuerdem Folgendes:
  ; + Die zugehrige MASK_AKTION wird zunchst auf 1 gesetzt und nach erfolgreichem Test auf 0.
  ; + Bei Erneuerung einer Nummer wird mit der zugehrigen Maske ein MASK UPDATE durchgefhrt.
  ; + Die FIELD_FLAG der Maskenvaribale wird auf unmodified gestellt.
  ; + Ein erneutes Aufrufen des Speicherns ist danach nicht mehr ntig.
  PROCEDURE ChkNumber VN ChkNumber.NumberID, VS ChkNumber.VarName, VB ChkNumber.HaveMessages, ~VB ChkNumber.Result
    CALC [ChkNumber.Result] AS FALSE
    LOCAL_BOOL  ChkNumber.CountForwardYes,TRUE

    LOCAL_STR   ChkNumber.NewNumber
    LOCAL_NUM   ChkNumber.TmpNum

    LOCAL_QUERY ChkNumber.Q1
    LOCAL_BOOL  ChkNumber.Q1Res

    LOCAL_BOOL  ChkNumber.BlockField

    LOCAL_STR   ChkNumber.Datenfeld
    LOCAL_STR   ChkNumber.Datenbank
    LOCAL_STR   ChkNumber.Bedingung
    LOCAL_STR   ChkNumber.Bezeichnung

    LOCAL_STR   ChkNumber.TmpStr

    LOCAL_STR   ChkNumber.MaskName
    LOCAL_STR   ChkNumber.MaskField
    LOCAL_NUM   ChkNumber.MandBuf,    [ACT_MANDANT]
    LOCAL_NUM   ChkNumber.UseNumDef,  1
    LOCAL_NUM   ChkNumber.OriNum

    LOCAL_BOOL  ChkNumber.FillSpaces

    LOCAL_BOOL  ChkNumber.AvoidVirtDel
    LOCAL_BOOL  ChkNumber.ActVirtDelState
    CALC [ChkNumber.ActVirtDelState] AS [VIRTUAL_DELETE]

    CALC [ChkNumber.MaskName]  AS ''
    CALC [ChkNumber.MaskField] AS ''
    CALC [ChkNumber.TmpNum]    AS POS('!',[ChkNumber.VarName])
    IF [ChkNumber.TmpNum]>0
      DEC  [ChkNumber.TmpNum]
      CALC [ChkNumber.MaskName]  AS COPY([ChkNumber.VarName],1,[ChkNumber.TmpNum])
      CALC [ChkNumber.TmpNum]    AS [ChkNumber.TmpNum] + 2
      CALC [ChkNumber.MaskField] AS COPY([ChkNumber.VarName],[ChkNumber.TmpNum],255)
    END_IF

    CALC [ChkNumber.OriNum] AS [ChkNumber.NumberID]
    IF [ACT_MANDANT]>0
      CALC [ChkNumber.TmpStr]   AS [ChkNumber.NumberID]
      CALC [ChkNumber.NumberID] AS 1000 + [ACT_MANDANT]
      CALC [ChkNumber.TmpStr]   AS CON([ChkNumber.NumberID],[ChkNumber.TmpStr])
      CALC [ChkNumber.NumberID] AS VAL([ChkNumber.TmpStr])
      CALC [ChkNumber.TmpStr]   AS ''
    END_IF

    WHILE [ChkNumber.UseNumDef]>0
      QUERY [ChkNumber.Q1]
          SELECT Stellen, Datenfeld, Datenbank, FestStart, FillSpaces,
                 VariabelStart, Schrittweite, Startwert, Bezeichnung,
                 Bedingung, KreisID, SchnellModus, EingabeBlocken,
                 FirstChars, AvoidVitualDel, UseNumDef,
                 RecordID, RecFlag, EventFlag
            FROM nummern
           WHERE KreisID = [ChkNumber.NumberID]
        ORDER BY KreisID
      END_QUERY

      EXECUTE [ChkNumber.Q1],[ChkNumber.Q1Res]
      IF [ChkNumber.Q1Res]=FALSE
        MESSAGE 'Achtung : Fehler beim Prfen des Nummernkreises','Die Nummerntabelle-Abfrage konnte nicht bersetzt werden',[MESSAGE_ERROR]
        CALC [ACT_MANDANT] AS [ChkNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [ChkNumber.Q1],[ChkNumber.Q1Res]
      IF [ChkNumber.Q1Res]=FALSE
        ; MESSAGE 'Achtung : Fehler beim Prfen des Nummernkreises','Die Nummerntabelle konnte nicht gelesen werden',[MESSAGE_ERROR]
        ;
        ; Wenn keine Nummernkeisdefinition gewnscht ist, mu es trotzdem weiter gehen!
        CALC [ChkNumber.Result] AS TRUE
        CALC [ACT_MANDANT]      AS [ChkNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [ChkNumber.UseNumDef] AS [ChkNumber.Q1!UseNumDef]

      IF [ChkNumber.UseNumDef]>0
        IF [ChkNumber.UseNumDef]>=10000
          CALC [ChkNumber.TmpStr] AS [ChkNumber.UseNumDef]
          CALC [ChkNumber.TmpStr] AS COPY([ChkNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]      AS  VAL([ChkNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]      AS 0
        END_IF

        CALC [ChkNumber.TmpStr]   AS [ChkNumber.UseNumDef]
        CALC [ChkNumber.TmpStr]   AS COPY([ChkNumber.TmpStr],5,255)
        CALC [ChkNumber.NumberID] AS  VAL([ChkNumber.TmpStr])
      END_IF
    END_WHILE

    CALC [ChkNumber.AvoidVirtDel] AS [ChkNumber.Q1!AvoidVitualDel]
    CALC [ChkNumber.FillSpaces]   AS [ChkNumber.Q1!FillSpaces]

    IF [ChkNumber.MaskName]<>''
      CALC [[ChkNumber.MaskName]!MASK_ACTION] AS 1
    END_IF

    CALC [ChkNumber.Bedingung] AS ''
    IF [ChkNumber.Q1!Bedingung]<>''
      CALC [ChkNumber.Bedingung] AS CON(' AND (',[ChkNumber.Q1!Bedingung],') ')
      CALC [ChkNumber.Bedingung] AS REPLACE([ChkNumber.Bedingung],'|', '"')
      ; Hier wird zunchst darauf verzichtet ein "!" als ORDER BY Kriterium zu bercksichtigen
    END_IF
    CALC [ChkNumber.Datenfeld] AS TRIM([ChkNumber.Q1!DatenFeld])
    CALC [ChkNumber.TmpNum] AS POS(' ',[ChkNumber.Datenfeld])
    IF [ChkNumber.TmpNum]>0
      DEC [ChkNumber.TmpNum]
      CALC [ChkNumber.Datenfeld] AS COPY([ChkNumber.Datenfeld],1,[ChkNumber.TmpNum])
    END_IF
    CALC [ChkNumber.Datenbank]   AS [ChkNumber.Q1!DatenBank]
    CALC [ChkNumber.Bezeichnung] AS [ChkNumber.Q1!Bezeichnung]


    ; gibt es die Nummer schon ?
    IF [ChkNumber.AvoidVirtDel]
      CALC [VIRTUAL_DELETE] AS FALSE
    END_IF

    QUERY [ChkNumber.Q1]
      SELECT [ChkNumber.Datenfeld]
        FROM [ChkNumber.Datenbank]
       WHERE [ChkNumber.Datenfeld] = "[[ChkNumber.VarName]]"
             [ChkNumber.Bedingung]
    END_QUERY

    EXECUTE [ChkNumber.Q1],[ChkNumber.Q1Res]
    IF [ChkNumber.Q1Res]=FALSE
      MESSAGE 'Achtung : Fehler beim Prfen des Nummernkreises','Die Nummern-Prfung konnte nicht bersetzt werden',[MESSAGE_ERROR]
      CALC [VIRTUAL_DELETE] AS [ChkNumber.ActVirtDelState]
      CALC [ACT_MANDANT]    AS [ChkNumber.MandBuf]
      EXIT_PROC
    END_IF

    GET_DATA [ChkNumber.Q1],[ChkNumber.Q1Res]
    CALC [VIRTUAL_DELETE] AS [ChkNumber.ActVirtDelState]

    IF [ChkNumber.Q1Res]
      IF [ChkNumber.HaveMessages]
        CALC [ChkNumber.TmpStr] AS CON('Die aktuelle Nummer des Nummernkreises "',[ChkNumber.Bezeichnung],'" ist bereits vergeben')
        MESSAGE 'Achtung',[ChkNumber.TmpStr],[MESSAGE_WARNING]

        CALC [ChkNumber.TmpStr] AS CON('Soll eine neue Nummer fr den Nummernkreis "',[ChkNumber.Bezeichnung],'" ermittelt werden ?')

        GET_YES_NO 'Achtung',[ChkNumber.TmpStr],[ChkNumber.TmpNum]
        IF [ChkNumber.TmpNum]<>[ID_YES]
          CALC [ACT_MANDANT] AS [ChkNumber.MandBuf]
          EXIT_PROC
        END_IF
      END_IF

      CALL FndNumber [ChkNumber.OriNum], [ChkNumber.NewNumber], [ChkNumber.CountForwardYes], [ChkNumber.BlockField], TRUE
    ELSE_IF [ChkNumber.FillSpaces]
      CALL FndNumber [ChkNumber.OriNum], [ChkNumber.NewNumber], [ChkNumber.CountForwardYes], [ChkNumber.BlockField], FALSE
    ELSE
      CALL FndNumber [ChkNumber.OriNum], [ChkNumber.NewNumber], [ChkNumber.CountForwardYes], [ChkNumber.BlockField], TRUE

      IF [ChkNumber.NewNumber]<>[[ChkNumber.VarName]]
        IF [ChkNumber.HaveMessages]
          CALC [ChkNumber.TmpStr] AS CON('Die aktuelle Nummer weicht vom Nummernkreises "',[ChkNumber.Bezeichnung],'" ab.|Soll eine neue Nummer ermittelt werden ?')

          GET_YES_NO 'Achtung',[ChkNumber.TmpStr],[ChkNumber.TmpNum]
          IF [ChkNumber.TmpNum]<>[ID_YES]
            CALC [ACT_MANDANT] AS [ChkNumber.MandBuf]
            EXIT_PROC
          END_IF
        END_IF
      END_IF
    END_IF

    CALC [[ChkNumber.VarName]] AS [ChkNumber.NewNumber]
    CALC [ChkNumber.Result]    AS TRUE
    CALC [ACT_MANDANT]         AS [ChkNumber.MandBuf]

    IF [ChkNumber.MaskName]=''
      EXIT_PROC
    END_IF

    MASK_UPDATE [[ChkNumber.MaskName]]

    FIELD_FLAG_GET [[ChkNumber.MaskName]],[ChkNumber.MaskField],[ChkNumber.TmpNum]
    FLAG_SET [ChkNumber.TmpNum],[FIELD_FLAG_MODIFIED],FALSE

    FLAG_STATE [ChkNumber.TmpNum],[FIELD_FLAG_PROTECTED],[ChkNumber.Q1Res]
    IF [ChkNumber.Q1Res]=FALSE
      IF [ChkNumber.BlockField]
        FLAG_SET [ChkNumber.TmpNum],[FIELD_FLAG_PROTECTED],TRUE
      END_IF
    END_IF

    FIELD_FLAG_SET [[ChkNumber.MaskName]],[ChkNumber.MaskField],[ChkNumber.TmpNum]

    CALC [[ChkNumber.MaskName]!MASK_ACTION] AS 0
  END_PROC



  ; Holt eine neue Nummer aus dem Nummernkreis mit der Nummer "NewNumber.NumberID" und
  ; speicher diese in [[ChkNumber.VarName]].
  ;
  ; Falls die Variable [[ChkNumber.VarName]] eine Maskenvariable ist, geschieht auuerdem Folgendes:
  ; + Bei Erneuerung einer Nummer wird mit der zugehrigen Maske ein MASK UPDATE durchgefhrt.
  ; + Die FIELD_FLAG der Maskenvaribale wird auf unmodified gestellt.
  PROCEDURE NewNumber VAR_NUM NewNumber.NumberID, VAR_STR NewNumber.VarName
    LOCAL_BOOL  NewNumber.CountForwardYes,TRUE

    LOCAL_BOOL  NewNumber.BlockField
    LOCAL_BOOL  NewNumber.FlagState

    LOCAL_STR   NewNumber.ANumber
    LOCAL_STR   NewNumber.TmpStr
    LOCAL_NUM   NewNumber.TmpNum

    LOCAL_STR   NewNumber.MaskName
    LOCAL_STR   NewNumber.MaskField
    LOCAL_NUM   NewNumber.OriNum

    CALC [NewNumber.OriNum] AS [NewNumber.NumberID]
    IF [ACT_MANDANT]>0
      CALC [NewNumber.TmpStr]   AS [NewNumber.NumberID]
      CALC [NewNumber.NumberID] AS 1000 + [ACT_MANDANT]
      CALC [NewNumber.TmpStr]   AS CON([NewNumber.NumberID],[NewNumber.TmpStr])
      CALC [NewNumber.NumberID] AS VAL([NewNumber.TmpStr])
      CALC [NewNumber.TmpStr]   AS ''
    END_IF


    CALC [NewNumber.MaskName]  AS ''
    CALC [NewNumber.MaskField] AS ''
    CALC [NewNumber.TmpNum]    AS POS('!',[NewNumber.VarName])
    IF [NewNumber.TmpNum]>0
      DEC  [NewNumber.TmpNum]
      CALC [NewNumber.MaskName]  AS COPY([NewNumber.VarName],1,[NewNumber.TmpNum])
      CALC [NewNumber.TmpNum]    AS [NewNumber.TmpNum] + 2
      CALC [NewNumber.MaskField] AS COPY([NewNumber.VarName],[NewNumber.TmpNum],255)
    END_IF

    CALL FndNumber [NewNumber.OriNum], [NewNumber.ANumber], [NewNumber.CountForwardYes], [NewNumber.BlockField], FALSE
    IF [NewNumber.ANumber]=''
      EXIT_PROC
    END_IF

    CALC [[NewNumber.VarName]] AS [NewNumber.ANumber]

    IF [NewNumber.MaskName]=''
      EXIT_PROC
    END_IF

    MASK_UPDATE [[NewNumber.MaskName]]

    FIELD_FLAG_GET [[NewNumber.MaskName]],[NewNumber.MaskField],[NewNumber.TmpNum]
    FLAG_SET [NewNumber.TmpNum],[FIELD_FLAG_MODIFIED],FALSE

    FLAG_STATE [NewNumber.TmpNum],[FIELD_FLAG_PROTECTED],[NewNumber.FlagState]
    IF [NewNumber.FlagState]=FALSE
      IF [NewNumber.BlockField]
        FLAG_SET [NewNumber.TmpNum],[FIELD_FLAG_PROTECTED],TRUE
      END_IF
    END_IF

    FIELD_FLAG_SET [[NewNumber.MaskName]],[NewNumber.MaskField],[NewNumber.TmpNum]
  END_PROC


  ; Gibt in [BlkNumber.Result] zurck, ob die Eingabefelder des Nummernkreises mit
  ; der ID [BlkNumber.NumberID] geblockt werden sollen oder nicht.
  PROCEDURE BlkNumber VAR_NUM BlkNumber.NumberID, ~VAR_BOOL BlkNumber.Result
    LOCAL_QUERY BlkNumber.AQuery
    LOCAL_BOOL  BlkNumber.AQueryRes
    LOCAL_NUM   BlkNumber.MandBuf,     [ACT_MANDANT]
    LOCAL_NUM   BlkNumber.UseNumDef,   1
    LOCAL_NUM   BlkNumber.OriNum,      0
    LOCAL_STR   BlkNumber.TmpStr

    CALC [BlkNumber.Result] AS FALSE

    WHILE [BlkNumber.UseNumDef]>0
      CALC [BlkNumber.OriNum] AS [BlkNumber.NumberID]
      IF [ACT_MANDANT]>0
        CALC [BlkNumber.TmpStr]   AS [BlkNumber.NumberID]
        CALC [BlkNumber.NumberID] AS 1000 + [ACT_MANDANT]
        CALC [BlkNumber.TmpStr]   AS CON([BlkNumber.NumberID],[BlkNumber.TmpStr])
        CALC [BlkNumber.NumberID] AS VAL([BlkNumber.TmpStr])
        CALC [BlkNumber.TmpStr]   AS ''
      END_IF

      QUERY [BlkNumber.AQuery]
        SELECT EingabeBlocken, UseNumDef
          FROM nummern
         WHERE KreisID = [BlkNumber.NumberID]
      END_QUERY
      EXECUTE [BlkNumber.AQuery],[BlkNumber.AQueryRes]
      IF [BlkNumber.AQueryRes]=FALSE
        MESSAGE 'Achtung : schwerer Datenbankfehler','Die Nummernkreistabelle kann nicht gelesen werden'
        CALC [ACT_MANDANT] AS [BlkNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [BlkNumber.AQuery],[BlkNumber.AQueryRes]
      IF [BlkNumber.AQueryRes]=FALSE
        CALC [ACT_MANDANT] AS [BlkNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [BlkNumber.UseNumDef] AS [BlkNumber.AQuery!UseNumDef]
      IF [BlkNumber.UseNumDef]>0
        IF [BlkNumber.UseNumDef]>=10000
          CALC [BlkNumber.TmpStr] AS [BlkNumber.UseNumDef]
          CALC [BlkNumber.TmpStr] AS COPY([BlkNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]      AS  VAL([BlkNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]      AS 0
        END_IF

        CALC [BlkNumber.TmpStr]   AS [BlkNumber.UseNumDef]
        CALC [BlkNumber.TmpStr]   AS COPY([BlkNumber.TmpStr],5,255)
        CALC [BlkNumber.NumberID] AS  VAL([BlkNumber.TmpStr])
      END_IF
    END_WHILE

    CALC [ACT_MANDANT]      AS [BlkNumber.MandBuf]
    CALC [BlkNumber.Result] AS [BlkNumber.AQuery!EingabeBlocken]
  END_PROC



  PROCEDURE SaveNumber VN ChkNumber.NumberID, VS ChkNumber.VarName, VB ChkNumber.HaveMessages, ~VB ChkNumber.Result
    CALC [ChkNumber.Result] AS FALSE
    LOCAL_BOOL  ChkNumber.CountForwardYes,TRUE

    LOCAL_STR   ChkNumber.NewNumber
    LOCAL_NUM   ChkNumber.TmpNum

    LOCAL_QUERY ChkNumber.Q1
    LOCAL_BOOL  ChkNumber.Q1Res

    LOCAL_BOOL  ChkNumber.BlockField

    LOCAL_STR   ChkNumber.Datenfeld
    LOCAL_STR   ChkNumber.Datenbank
    LOCAL_STR   ChkNumber.Bedingung
    LOCAL_STR   ChkNumber.Bezeichnung

    LOCAL_STR   ChkNumber.TmpStr

    LOCAL_STR   ChkNumber.MaskName
    LOCAL_STR   ChkNumber.MaskField
    LOCAL_NUM   ChkNumber.MandBuf,    [ACT_MANDANT]
    LOCAL_NUM   ChkNumber.UseNumDef,  1
    LOCAL_NUM   ChkNumber.OriNum

    LOCAL_BOOL  ChkNumber.AvoidVirtDel
    LOCAL_BOOL  ChkNumber.ActVirtDelState
    CALC [ChkNumber.ActVirtDelState] AS [VIRTUAL_DELETE]

    CALC [ChkNumber.MaskName]  AS ''
    CALC [ChkNumber.MaskField] AS ''
    CALC [ChkNumber.TmpNum]    AS POS('!',[ChkNumber.VarName])
    IF [ChkNumber.TmpNum]>0
      DEC  [ChkNumber.TmpNum]
      CALC [ChkNumber.MaskName]  AS COPY([ChkNumber.VarName],1,[ChkNumber.TmpNum])
      CALC [ChkNumber.TmpNum]    AS [ChkNumber.TmpNum] + 2
      CALC [ChkNumber.MaskField] AS COPY([ChkNumber.VarName],[ChkNumber.TmpNum],255)
    END_IF

    WHILE [ChkNumber.UseNumDef]>0
      CALC [ChkNumber.OriNum] AS [ChkNumber.NumberID]
      IF [ACT_MANDANT]>0
        CALC [ChkNumber.TmpStr]   AS [ChkNumber.NumberID]
        CALC [ChkNumber.NumberID] AS 1000 + [ACT_MANDANT]
        CALC [ChkNumber.TmpStr]   AS CON([ChkNumber.NumberID],[ChkNumber.TmpStr])
        CALC [ChkNumber.NumberID] AS VAL([ChkNumber.TmpStr])
        CALC [ChkNumber.TmpStr]   AS ''
      END_IF

      QUERY [ChkNumber.Q1]
          SELECT Stellen, Datenfeld, Datenbank, FestStart,
                 VariabelStart, Schrittweite, Startwert, Bezeichnung,
                 Bedingung, KreisID, SchnellModus, EingabeBlocken,
                 FirstChars, AvoidVitualDel, UseNumDef,
                 RecordID, RecFlag, EventFlag
            FROM nummern
           WHERE KreisID = [ChkNumber.NumberID]
        ORDER BY KreisID
      END_QUERY

      EXECUTE [ChkNumber.Q1],[ChkNumber.Q1Res]
      IF [ChkNumber.Q1Res]=FALSE
        MESSAGE 'Achtung : Fehler beim Prfen des Nummernkreises','Die Nummerntabelle-Abfrage konnte nicht bersetzt werden',[MESSAGE_ERROR]
        CALC [ACT_MANDANT] AS [ChkNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [ChkNumber.Q1],[ChkNumber.Q1Res]
      IF [ChkNumber.Q1Res]=FALSE
        ; MESSAGE 'Achtung : Fehler beim Prfen des Nummernkreises','Die Nummerntabelle konnte nicht gelesen werden',[MESSAGE_ERROR]
        ;
        ; Wenn keine Nummernkeisdefinition gewnscht ist, mu es trotzdem weiter gehen!
        CALC [ChkNumber.Result] AS TRUE
        CALC [ACT_MANDANT]      AS [ChkNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [ChkNumber.UseNumDef] AS [ChkNumber.Q1!UseNumDef]

      IF [ChkNumber.UseNumDef]>0
        IF [ChkNumber.UseNumDef]>=10000
          CALC [ChkNumber.TmpStr] AS [ChkNumber.UseNumDef]
          CALC [ChkNumber.TmpStr] AS COPY([ChkNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]      AS  VAL([ChkNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]      AS 0
        END_IF

        CALC [ChkNumber.TmpStr]   AS [ChkNumber.UseNumDef]
        CALC [ChkNumber.TmpStr]   AS COPY([ChkNumber.TmpStr],5,255)
        CALC [ChkNumber.NumberID] AS  VAL([ChkNumber.TmpStr])
      END_IF
    END_WHILE

    CALC [ChkNumber.AvoidVirtDel] AS [ChkNumber.Q1!AvoidVitualDel]

    IF [ChkNumber.MaskName]<>''
      CALC [[ChkNumber.MaskName]!MASK_ACTION] AS 1
    END_IF

    CALC [ChkNumber.Bedingung] AS ''
    IF [ChkNumber.Q1!Bedingung]<>''
      CALC [ChkNumber.Bedingung] AS CON(' AND (',[ChkNumber.Q1!Bedingung],') ')
      CALC [ChkNumber.Bedingung] AS REPLACE([ChkNumber.Bedingung],'|', '"')
      ; Hier wird zunchst darauf verzichtet ein "!" als ORDER BY Kriterium zu bercksichtigen
    END_IF
    CALC [ChkNumber.Datenfeld] AS TRIM([ChkNumber.Q1!DatenFeld])
    CALC [ChkNumber.TmpNum] AS POS(' ',[ChkNumber.Datenfeld])
    IF [ChkNumber.TmpNum]>0
      DEC [ChkNumber.TmpNum]
      CALC [ChkNumber.Datenfeld] AS COPY([ChkNumber.Datenfeld],1,[ChkNumber.TmpNum])
    END_IF
    CALC [ChkNumber.Datenbank]   AS [ChkNumber.Q1!DatenBank]
    CALC [ChkNumber.Bezeichnung] AS [ChkNumber.Q1!Bezeichnung]


    ; gibt es die Nummer schon ?
    IF [ChkNumber.AvoidVirtDel]
      CALC [VIRTUAL_DELETE] AS FALSE
    END_IF

    QUERY [ChkNumber.Q1]
      SELECT [ChkNumber.Datenfeld]
        FROM [ChkNumber.Datenbank]
       WHERE [ChkNumber.Datenfeld] = "[[ChkNumber.VarName]]"
             [ChkNumber.Bedingung]
    END_QUERY

    EXECUTE [ChkNumber.Q1],[ChkNumber.Q1Res]
    IF [ChkNumber.Q1Res]=FALSE
      MESSAGE 'Achtung : Fehler beim Prfen des Nummernkreises','Die Nummern-Prfung konnte nicht bersetzt werden',[MESSAGE_ERROR]
      CALC [VIRTUAL_DELETE] AS [ChkNumber.ActVirtDelState]
      CALC [ACT_MANDANT]    AS [ChkNumber.MandBuf]
      EXIT_PROC
    END_IF

    GET_DATA [ChkNumber.Q1],[ChkNumber.Q1Res]
    CALC [VIRTUAL_DELETE] AS [ChkNumber.ActVirtDelState]

    IF [ChkNumber.Q1Res]
      IF [ChkNumber.HaveMessages]
        CALC [ChkNumber.TmpStr] AS CON('Die aktuelle Nummer des Nummernkreises "',[ChkNumber.Bezeichnung],'" ist bereits vergeben')
        MESSAGE 'Achtung',[ChkNumber.TmpStr],[MESSAGE_WARNING]

        CALC [ChkNumber.TmpStr] AS CON('Soll eine neue Nummer fr den Nummernkreis "',[ChkNumber.Bezeichnung],'" ermittelt werden ?')

        GET_YES_NO 'Achtung',[ChkNumber.TmpStr],[ChkNumber.TmpNum]
        IF [ChkNumber.TmpNum]<>[ID_YES]
          CALC [ACT_MANDANT] AS [ChkNumber.MandBuf]
          EXIT_PROC
        END_IF
      END_IF

      CALL FndNumber [ChkNumber.OriNum], [ChkNumber.NewNumber], [ChkNumber.CountForwardYes], [ChkNumber.BlockField], TRUE
    ELSE
      CALL FndNumber [ChkNumber.OriNum], [ChkNumber.NewNumber], [ChkNumber.CountForwardYes], [ChkNumber.BlockField], TRUE

      IF [ChkNumber.NewNumber]<>[[ChkNumber.VarName]]
        IF [ChkNumber.HaveMessages]
          CALC [ChkNumber.TmpStr] AS CON('Die aktuelle Nummer weicht vom Nummernkreises "',[ChkNumber.Bezeichnung],'" ab.|Soll eine neue Nummer ermittelt werden ?')

          GET_YES_NO 'Achtung',[ChkNumber.TmpStr],[ChkNumber.TmpNum]
          IF [ChkNumber.TmpNum]<>[ID_YES]
            CALC [ACT_MANDANT] AS [ChkNumber.MandBuf]
            EXIT_PROC
          END_IF
        END_IF
      END_IF
    END_IF


    CALC [[ChkNumber.VarName]] AS [ChkNumber.NewNumber]
    CALC [ChkNumber.Result]    AS TRUE
    CALC [ACT_MANDANT]         AS [ChkNumber.MandBuf]

    IF [ChkNumber.MaskName]=''
      EXIT_PROC
    END_IF

    MASK_UPDATE [[ChkNumber.MaskName]]

    FIELD_FLAG_GET [[ChkNumber.MaskName]],[ChkNumber.MaskField],[ChkNumber.TmpNum]
    FLAG_SET [ChkNumber.TmpNum],[FIELD_FLAG_MODIFIED],FALSE

    FLAG_STATE [ChkNumber.TmpNum],[FIELD_FLAG_PROTECTED],[ChkNumber.Q1Res]
    IF [ChkNumber.Q1Res]=FALSE
      IF [ChkNumber.BlockField]
        FLAG_SET [ChkNumber.TmpNum],[FIELD_FLAG_PROTECTED],TRUE
      END_IF
    END_IF

    FIELD_FLAG_SET [[ChkNumber.MaskName]],[ChkNumber.MaskField],[ChkNumber.TmpNum]

    CALC [[ChkNumber.MaskName]!MASK_ACTION] AS 0
  END_PROC



  PROCEDURE ReadNumber VAR_NUM ReadNumber.NumberID, ~VAR_BOOL ReadNumber.NumberIsSet, ~VAR_BOOL ReadNumber.Result
    ; prft, ob der Nummernkreis mit ID ReadNumber.NumberID angelegt ist
    ; und wenn ja, ob die Nummer zu blocken ist
    LOCAL_QUERY ReadNumber.AQuery
    LOCAL_BOOL  ReadNumber.AQueryRes
    LOCAL_STR   ReadNumber.TmpStr
    LOCAL_NUM   ReadNumber.MandBuf,    [ACT_MANDANT]
    LOCAL_NUM   ReadNumber.UseNumDef,  1
    LOCAL_NUM   ReadNumber.OriNum

    CALC [ReadNumber.Result]      AS FALSE
    CALC [ReadNumber.NumberIsSet] AS FALSE

    WHILE [ReadNumber.UseNumDef]>0
      CALC [ReadNumber.OriNum] AS [ReadNumber.NumberID]
      IF [ACT_MANDANT]>0
        CALC [ReadNumber.TmpStr]   AS [ReadNumber.NumberID]
        CALC [ReadNumber.NumberID] AS 1000 + [ACT_MANDANT]
        CALC [ReadNumber.TmpStr]   AS CON([ReadNumber.NumberID],[ReadNumber.TmpStr])
        CALC [ReadNumber.NumberID] AS VAL([ReadNumber.TmpStr])
        CALC [ReadNumber.TmpStr]   AS ''
      END_IF

      QUERY [ReadNumber.AQuery]
        SELECT Bezeichnung, EingabeBlocken, UseNumDef
          FROM nummern
         WHERE KreisID = [ReadNumber.NumberID]
      END_QUERY
      EXECUTE [ReadNumber.AQuery],[ReadNumber.AQueryRes]
      IF [ReadNumber.AQueryRes]=FALSE
        MESSAGE 'Achtung : schwerer Datenbankfehler','Die Nummernkreistabelle kann nicht gelesen werden'
        CALC [ACT_MANDANT] AS [ReadNumber.MandBuf]
        EXIT_PROC
      END_IF

      GET_DATA [ReadNumber.AQuery],[ReadNumber.AQueryRes]
      IF [ReadNumber.AQueryRes]=FALSE
        CALC [ACT_MANDANT] AS [ReadNumber.MandBuf]
        EXIT_PROC
      END_IF

      CALC [ReadNumber.UseNumDef] AS [ReadNumber.AQuery!UseNumDef]

      IF [ReadNumber.UseNumDef]>0
        IF [ReadNumber.UseNumDef]>=10000
          CALC [ReadNumber.TmpStr] AS [ReadNumber.UseNumDef]
          CALC [ReadNumber.TmpStr] AS COPY([ReadNumber.TmpStr],3,2)
          CALC [ACT_MANDANT]       AS  VAL([ReadNumber.TmpStr])
        ELSE
          CALC [ACT_MANDANT]       AS 0
        END_IF

        CALC [ReadNumber.TmpStr]   AS [ReadNumber.UseNumDef]
        CALC [ReadNumber.TmpStr]   AS COPY([ReadNumber.TmpStr],5,255)
        CALC [ReadNumber.NumberID] AS  VAL([ReadNumber.TmpStr])
      END_IF
    END_WHILE

    CALC [ACT_MANDANT]             AS [ReadNumber.MandBuf]
    CALC [ReadNumber.Result]       AS [ReadNumber.AQuery!EingabeBlocken]
    CALC [ReadNumber.NumberIsSet]  AS TRUE
  END_PROC

