/*
ALTER TABLE nummern ADD FillSpaces       [SQL_DEFINE_BOOLEAN] [SQL_DEFINE_BOOLEAN_END];
     UPDATE nummern SET FillSpaces     = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION];

ALTER TABLE nummern ADD UseNumDef        [SQL_DEFINE_LONGINT] [SQL_DEFINE_LONGINT_END];
ALTER TABLE nummern ADD AvoidVitualDel   [SQL_DEFINE_BOOLEAN] [SQL_DEFINE_BOOLEAN_END];
ALTER TABLE nummern ADD FirstChars       [SQL_DEFINE_STRING] ( 41) [SQL_DEFINE_STRING_END];

     UPDATE nummern SET UseNumDef      = 0;
     UPDATE nummern SET AvoidVitualDel = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION];
     UPDATE nummern SET FirstChars     = "";
*/

DROP TABLE [SQL_IF_EXISTS] nummern;
CREATE TABLE nummern
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      Stellen                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      Bezeichnung               [SQL_DEFINE_STRING]   ( 41) [SQL_DEFINE_STRING_END],
      Datenfeld                 [SQL_DEFINE_STRING]   ( 21) [SQL_DEFINE_STRING_END],
      Datenbank                 [SQL_DEFINE_STRING]   ( 13) [SQL_DEFINE_STRING_END],
      FestStart                 [SQL_DEFINE_STRING]   (  6) [SQL_DEFINE_STRING_END],
      VariabelStart             [SQL_DEFINE_STRING]   ( 21) [SQL_DEFINE_STRING_END],
      Bedingung                 [SQL_DEFINE_STRING]   ( 61) [SQL_DEFINE_STRING_END],
      Schrittweite              [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      KreisID                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Startwert                 [SQL_DEFINE_STRING]   ( 21) [SQL_DEFINE_STRING_END],
      SchnellModus              [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      EingabeBlocken            [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      FirstChars                [SQL_DEFINE_STRING]   ( 41) [SQL_DEFINE_STRING_END],
      AvoidVitualDel            [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      UseNumDef                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      FillSpaces                [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END]
      [SQL_DEFINE_PRIMARY_KEY2]
   );

CREATE UNIQUE INDEX IndNumRecordID     ON nummern (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndNumVirtualDelID ON nummern (VirtualDelID);
CREATE        INDEX IndNumKreisID      ON nummern (KreisID);

NEW_RECORD nummern 100;
    UPDATE nummern
       SET Stellen        = 3,
           Bezeichnung    = "Personalnummer",
           Datenfeld      = "Personalnummer",
           Datenbank      = "ADRESSEN",
           FestStart      = "",
           VariabelStart  = "keine",
           Bedingung      = "",
           Schrittweite   = 1,
           Startwert      = "",
           KreisID        = 0
     WHERE RecordID       = 100;

NEW_RECORD nummern 1;
    UPDATE nummern
       SET Stellen        = 5,
           Bezeichnung    = "Kundennummer",
           Datenfeld      = "Kundennummer",
           Datenbank      = "ADRESSEN",
           VariabelStart  = "keine",
           Schrittweite   = 1,
           KreisID        = 1
     WHERE RecordID       = 1;

NEW_RECORD nummern 2;
    UPDATE nummern
       SET Stellen        = 5,
           Bezeichnung    = "Lieferantennummer",
           Datenfeld      = "Lieferantennummer",
           Datenbank      = "ADRESSEN",
           VariabelStart  = "keine",
           Schrittweite   = 1,
           KreisID        = 2
     WHERE RecordID       = 2;

NEW_RECORD nummern 3;
    UPDATE nummern
       SET Stellen        = 6,
           Bezeichnung    = "Artikelnummer",
           Datenfeld      = "Artikelnummer",
           Datenbank      = "ARTIKEL",
           VariabelStart  = "keine",
           Schrittweite   = 1,
           KreisID        = 3
     WHERE RecordID       = 3;

NEW_RECORD nummern 4;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Bestellnummer",
           Datenfeld      = "Bestellnummer",
           Datenbank      = "BESTPOS",
           VariabelStart  = "Jahr",
           Schrittweite   = 1,
           KreisID        = 4
     WHERE RecordID       = 4;

NEW_RECORD nummern 5;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Eingangs-Rechnungen",
           Datenfeld      = "ERNummer",
           Datenbank      = "EINRECH",
           VariabelStart  = "Jahr",
           Schrittweite   = 1,
           KreisID        = 5
     WHERE RecordID       = 5;

NEW_RECORD nummern 6;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Angebotsnummer",
           Datenfeld      = "ANGEBOTSNUMMER",
           Datenbank      = "AUFTRAG",
           VariabelStart  = "Jahr",
           Bedingung      = "FERTBYTE = -1",
           Schrittweite   = 1,
           KreisID        = 6
     WHERE RecordID       = 6;

NEW_RECORD nummern 7;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Kunden-Auftrge",
           Datenfeld      = "AUFTRAGSNUMMER",
           Datenbank      = "AUFTRAG",
           VariabelStart  = "Jahr",
           Bedingung      = "FERTBYTE = 0",
           Schrittweite   = 1,
           KreisID        = 7
     WHERE RecordID       = 7;

NEW_RECORD nummern 8;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Lieferscheinnummer",
           Datenfeld      = "Lieferscheinnummer",
           Datenbank      = "LIEFERSC",
           VariabelStart  = "Jahr",
           Schrittweite   = 1,
           KreisID        = 8
     WHERE RecordID       = 8;

NEW_RECORD nummern 9;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Rechnungsnummer",
           Datenfeld      = "RECHNUNGSNUMMER",
           Datenbank      = "RECHNUNG",
           VariabelStart  = "Jahr",
           Bedingung      = "Kennung = 'R'",
           Schrittweite   = 1,
           KreisID        = 9
     WHERE RecordID       = 9;

NEW_RECORD nummern 10;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Gutschriftnummer",
           Datenfeld      = "RECHNUNGSNUMMER",
           Datenbank      = "RECHNUNG",
           VariabelStart  = "Jahr",
           Bedingung      = "Kennung = 'G'",
           Schrittweite   = 1,
           KreisID        = 10
     WHERE RecordID       = 10;

NEW_RECORD nummern 11;
    UPDATE nummern
       SET Stellen        = 8,
           Bezeichnung    = "Fertigungsauftrge",
           Datenfeld      = "AUFTRAGSNUMMER",
           Datenbank      = "AUFTRAG",
           FestStart      = "F",
           VariabelStart  = "keine",
           Bedingung      = "FERTBYTE = 1",
           Schrittweite   = 1,
           Startwert      = "",
           KreisID        = 11
     WHERE RecordID       = 11;

NEW_RECORD nummern 12;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "Bestellnummer",
           Datenfeld      = "Bestellnummer",
           Datenbank      = "BESTKOPF",
           FestStart      = "",
           VariabelStart  = "Jahr",
           Bedingung      = "FreeInt1 = 0",
           Schrittweite   = 1,
           Startwert      = "",
           KreisID        = 12
     WHERE RecordID       = 12;

NEW_RECORD nummern 15;
    UPDATE nummern
       SET Stellen        = 9,
           Bezeichnung    = "AnfrageNr",
           Datenfeld      = "Bestellnummer",
           Datenbank      = "BESTKOPF",
           FestStart      = "",
           VariabelStart  = "Jahr",
           Bedingung      = "FreeInt1 = 2",
           Schrittweite   = 1,
           Startwert      = "",
           KreisID        = 15
     WHERE RecordID       = 15;

NEW_RECORD nummern 16;
    UPDATE nummern
       SET Stellen        = 10,
           Bezeichnung    = "Gutschriftnummer",
           Datenfeld      = "STARTWERT",
           Datenbank      = "NUMMERN",
           FestStart      = "LS",
           VariabelStart  = "Jahr",
           Bedingung      = "KreisID = 16",
           Schrittweite   = 1,
           Startwert      = "LS20020000",
           KreisID        = 16
     WHERE RecordID       = 16;

NEW_RECORD nummern 20;
    UPDATE nummern
       SET Stellen        = 11,
           Bezeichnung    = "Bon-Nummer",
           Datenfeld      = "BonNr",
           Datenbank      = "KSBON",
           FestStart      = "B",
           VariabelStart  = "Jahr+Monat+Tag",
           Bedingung      = "",
           Schrittweite   = 1,
           Startwert      = "001",
           KreisID        = 20
     WHERE RecordID       = 20;

NEW_RECORD nummern 25;
    UPDATE nummern
       SET Stellen        = 3,
           Bezeichnung    = "Kassennummer",
           Datenfeld      = "Nummer",
           Datenbank      = "KASSE",
           FestStart      = "",
           VariabelStart  = "keine",
           Bedingung      = "",
           Schrittweite   = 1,
           Startwert      = "001",
           KreisID        = 25
     WHERE RecordID       = 25;

NEW_RECORD nummern 31;
    UPDATE nummern
       SET Stellen        = 8,
           Bezeichnung    = "Lager-Umbuchung",
           Datenfeld      = "BelegNummer",
           Datenbank      = "lubheader",
           FestStart      = "",
           VariabelStart  = "Jahr",
           Bedingung      = "",
           Schrittweite   = 1,
           Startwert      = "",
           KreisID        = 31
     WHERE RecordID       = 31;

