  ; Parameter   PAR_STR1    = Name der Label-Einstellung
  ;             PAR_STR2    = Text 1, der als Barcode gedruckt werden soll
  ;             PAR_STR3    = Text 2, der als Barcode gedruckt werden soll. Achtung: Text 2 ist nur bei manchen Barcode-Typen mglich.
  ;             PAR_STR4    = Zusatztext 1, der unterhalb des Barcodes angedruckt wird
  ;             PAR_STR5    = Zusatztext 2, der unterhalb des Barcodes angedruckt wird
  ;             PAR_STR6    = Zusatztext 3, der unterhalb des Barcodes angedruckt wird
  ;             PAR_STR7    = Zusatztext 4, der unterhalb des Barcodes angedruckt wird
  ;             RECORD_ID8  = Anzahl der Etiketten, wenn diese Zahl > 0 ist, wird sofort mit dem Druck begonnen
  ;             PAR_STR9    = Tabellen-Name, um das PreFix fr den Barcode Text 1 zu erzeugen
  ;             RECORD_ID10 = Seriendruck?! Wenn diese Zahl > 0 ist, wird nach dem Druck NICHT wieder auf den Standard-Drucker zurck gestellt
  ;             RECORD_ID11 = 1=PREVIEW
  ;             PAR_STR12   = Zusatztext 5, der unterhalb des Barcodes angedruckt wird, mit den gleichen Einstellungen wie PAR_STR7 = Zusatztext 4
  ;             PAR_STR13   = Zusatztext 6, der unterhalb des Barcodes angedruckt wird, mit den gleichen Einstellungen wie PAR_STR7 = Zusatztext 4
  ;             PAR_STR14   = Zusatztext 7, der unterhalb des Barcodes angedruckt wird, mit den gleichen Einstellungen wie PAR_STR7 = Zusatztext 4
  ;             PAR_STR15   = Zusatztext 8, der unterhalb des Barcodes angedruckt wird, mit den gleichen Einstellungen wie PAR_STR7 = Zusatztext 4


  INCLUDE PrintOut.inc



  PROCEDURE SetDefaults
    IF [PAR_STR9]='artikel'
      CALC [BarCodePreFix] AS 'x'
    ELSE_IF [PAR_STR9]='lagerort'
      CALC [BarCodePreFix] AS 'L'
    ELSE_IF [PAR_STR9]='adressen'
      CALC [BarCodePreFix] AS 'z'
    ELSE_IF [PAR_STR9]='fertauftrag'
      CALC [BarCodePreFix] AS 'v'
    ELSE_IF [PAR_STR9]='choicer'
      CALC [BarCodePreFix] AS 'c'
    ELSE
      CALC [BarCodePreFix] AS ''
    END_IF

    CALC [DefaultBarCodeText1] AS [PAR_STR2]
    CALC [DefaultBarCodeText2] AS [PAR_STR3]
    CALC [DefaultZusatzText1]  AS [PAR_STR4]
    CALC [DefaultZusatzText2]  AS [PAR_STR5]
    CALC [DefaultZusatzText3]  AS [PAR_STR6]
    CALC [DefaultZusatzText4]  AS [PAR_STR7]
    CALC [DefaultZusatzText5]  AS [PAR_STR12]
    CALC [DefaultZusatzText6]  AS [PAR_STR13]
    CALC [DefaultZusatzText7]  AS [PAR_STR14]
    CALC [DefaultZusatzText8]  AS [PAR_STR15]
  END_PROC



  PROCEDURE ReadUserSpecificValues
    CALL SetDefaults

    IF [DefaultLabelName]=''
      EXIT_PROC
    END_IF

    INI_READ [Res],[Str1],[SCRIPT_STRING],[StationINIFileName],[DefaultLabelName],'BarCodeLabel'
    IF [Str1]=''
      EXIT_PROC
    END_IF

    CALC [Str2] AS PART([Str1],1,'|')
    CALC [DefaultStartReihe] AS VAL([Str2])
    IF [DefaultStartReihe]<=0
      CALC [DefaultStartReihe] AS 1
    END_IF

    CALC [Str2] AS PART([Str1],2,'|')
    CALC [DefaultStartSpalte] AS VAL([Str2])
    IF [DefaultStartSpalte]<=0
      CALC [DefaultStartSpalte] AS 1
    END_IF

    CALC [Str2] AS PART([Str1],3,'|')
    CALC [DefaultAnzahl] AS VAL([Str2])
    IF [DefaultAnzahl]<=0
      CALC [DefaultAnzahl] AS 1
    END_IF
  END_PROC



  PROCEDURE ReadLabelNames
    INI_READ_SECTION [Res],[KeyNames],[KeyValues],[ConfigFileName],'BarCodeLabel'

    LIST_ITEM_GET [KeyNames],[KeyLnCnt],[KeyLnMax]
    IF [KeyLnMax]=0
      EXIT_PROC
    END_IF

    LIST_STR_FIND [KeyNames],[DefaultLabelName],[KeyLnCnt]
    LIST_STR_GET  [KeyNames],[Str1]
    IF [DefaultLabelName]<>''
      IF [Str1]<>[DefaultLabelName]
        LIST_APPEND [KeyNames], [DefaultLabelName]
        LIST_APPEND [KeyValues],' '
        CALC [KeyLnMax] AS [KeyLnMax]+1
        CALC [KeyLnCnt] AS [KeyLnMax]
      END_IF
    END_IF

    LIST_2_LIST   [KeyNames], [WorkMask!LabelName], TRUE, 0
    LIST_STR_FIND [WorkMask!LabelName],[DefaultLabelName]
    LIST_STR_GET  [WorkMask!LabelName],[Str1]

    IF [DefaultLabelName]=''
      IF [Str1]<>''
        CALC [DefaultLabelName] AS [Str1]
      END_IF
    END_IF

    MASK_UPDATE   [WorkMask], TRUE
  END_PROC



  PROCEDURE AfterLoad
    CALC [WorkMask!Reihe]             AS [DefaultStartReihe]
    CALC [WorkMask!Spalte]            AS [DefaultStartSpalte]
    CALC [WorkMask!Anzahl]            AS [DefaultAnzahl]

    CALC [WorkMask!ZusatzText1Size]   AS [DefaultZusatzText1Size]
    CALC [WorkMask!ZusatzText2Size]   AS [DefaultZusatzText2Size]
    CALC [WorkMask!ZusatzText3Size]   AS [DefaultZusatzText3Size]
    CALC [WorkMask!ZusatzText4Size]   AS [DefaultZusatzText4Size]
    CALC [WorkMask!ZusatzText5Size]   AS [DefaultZusatzText5Size]
    CALC [WorkMask!ZusatzText6Size]   AS [DefaultZusatzText6Size]
    CALC [WorkMask!ZusatzText7Size]   AS [DefaultZusatzText7Size]
    CALC [WorkMask!ZusatzText8Size]   AS [DefaultZusatzText8Size]

    CALC [WorkMask!ZusatzText1Height] AS [DefaultZusatzText1Height]
    CALC [WorkMask!ZusatzText2Height] AS [DefaultZusatzText2Height]
    CALC [WorkMask!ZusatzText3Height] AS [DefaultZusatzText3Height]
    CALC [WorkMask!ZusatzText4Height] AS [DefaultZusatzText4Height]
    CALC [WorkMask!ZusatzText5Height] AS [DefaultZusatzText5Height]
    CALC [WorkMask!ZusatzText6Height] AS [DefaultZusatzText6Height]
    CALC [WorkMask!ZusatzText7Height] AS [DefaultZusatzText7Height]
    CALC [WorkMask!ZusatzText8Height] AS [DefaultZusatzText8Height]

    CALC [WorkMask!ZusatzText1Style]  AS [DefaultZusatzText1Style]
    CALC [WorkMask!ZusatzText2Style]  AS [DefaultZusatzText2Style]
    CALC [WorkMask!ZusatzText3Style]  AS [DefaultZusatzText3Style]
    CALC [WorkMask!ZusatzText4Style]  AS [DefaultZusatzText4Style]
    CALC [WorkMask!ZusatzText5Style]  AS [DefaultZusatzText5Style]
    CALC [WorkMask!ZusatzText6Style]  AS [DefaultZusatzText6Style]
    CALC [WorkMask!ZusatzText7Style]  AS [DefaultZusatzText7Style]
    CALC [WorkMask!ZusatzText8Style]  AS [DefaultZusatzText8Style]

    CALC [WorkMask!ZusatzText1Align]  AS [DefaultZusatzText1Align]
    CALC [WorkMask!ZusatzText2Align]  AS [DefaultZusatzText2Align]
    CALC [WorkMask!ZusatzText3Align]  AS [DefaultZusatzText3Align]
    CALC [WorkMask!ZusatzText4Align]  AS [DefaultZusatzText4Align]
    CALC [WorkMask!ZusatzText5Align]  AS [DefaultZusatzText5Align]
    CALC [WorkMask!ZusatzText6Align]  AS [DefaultZusatzText6Align]
    CALC [WorkMask!ZusatzText7Align]  AS [DefaultZusatzText7Align]
    CALC [WorkMask!ZusatzText8Align]  AS [DefaultZusatzText8Align]

    CALC [WorkMask!TextStartPosX]     AS [DefaultTextStartPosX]
    CALC [WorkMask!TextStartPosY]     AS [DefaultTextStartPosY]
    CALC [WorkMask!LineHeight]        AS [DefaultLineHeight]
    CALC [WorkMask!FontName]          AS [DefaultFontName]
    CALC [WorkMask!FontSize]          AS [DefaultFontSize]
    CALC [WorkMask!FontOpts]          AS [DefaultFontOpts]
    CALC [WorkMask!FontAlign]         AS [DefaultFontAlign]
    CALC [WorkMask!FontCharSet]       AS [DefaultFontCharSet]
    CALC [WorkMask!FontColor]         AS [DefaultFontColor]
    CALC [WorkMask!EtikettEndlos]     AS [DefaultEtikettEndlos]
    CALC [WorkMask!EtikettSpalten]    AS [DefaultEtikettSpalten]
    CALC [WorkMask!EtikettReihen]     AS [DefaultEtikettReihen]
    CALC [WorkMask!ReihenAbstand]     AS [DefaultReihenAbstand]
    CALC [WorkMask!SpaltenAbstand]    AS [DefaultSpaltenAbstand]
    CALC [WorkMask!BlattBreite]       AS [DefaultBlattBreite]
    CALC [WorkMask!BlattHoehe]        AS [DefaultBlattHoehe]
    CALC [WorkMask!RandRechts]        AS [DefaultRandRechts]
    CALC [WorkMask!RandLinks]         AS [DefaultRandLinks]
    CALC [WorkMask!RandOben]          AS [DefaultRandOben]
    CALC [WorkMask!RandUnten]         AS [DefaultRandUnten]
    CALC [WorkMask!BarCodeText1Pos]   AS [DefaultBarCodeText1Pos]
    CALC [WorkMask!BarCodeText2Pos]   AS [DefaultBarCodeText2Pos]
    CALC [WorkMask!BarCodeHeight]     AS [DefaultBarCodeHeight]
    CALC [WorkMask!BarCodeWidth]      AS [DefaultBarCodeWidth]
    CALC [WorkMask!BarCodeStartPosX]  AS [DefaultBarCodeStartPosX]
    CALC [WorkMask!BarCodeStartPosY]  AS [DefaultBarCodeStartPosY]
    CALC [WorkMask!PictureHeight]     AS [DefaultPictureHeight]
    CALC [WorkMask!PictureWidth]      AS [DefaultPictureWidth]
    CALC [WorkMask!PictureStartPosX]  AS [DefaultPictureStartPosX]
    CALC [WorkMask!PictureStartPosY]  AS [DefaultPictureStartPosY]
    CALC [WorkMask!PictureFile]       AS [DefaultPictureFile]

    CALC [WorkMask!BarCodeText1Fix]   AS [DefaultBarCodeText1Fix]
    CALC [WorkMask!BarCodeText2Fix]   AS [DefaultBarCodeText2Fix]
    CALC [WorkMask!ZusatzText1Fix]    AS [DefaultZusatzText1Fix]
    CALC [WorkMask!ZusatzText2Fix]    AS [DefaultZusatzText2Fix]
    CALC [WorkMask!ZusatzText3Fix]    AS [DefaultZusatzText3Fix]
    CALC [WorkMask!ZusatzText4Fix]    AS [DefaultZusatzText4Fix]
    CALC [WorkMask!ZusatzText5Fix]    AS [DefaultZusatzText5Fix]
    CALC [WorkMask!ZusatzText6Fix]    AS [DefaultZusatzText6Fix]
    CALC [WorkMask!ZusatzText7Fix]    AS [DefaultZusatzText7Fix]
    CALC [WorkMask!ZusatzText8Fix]    AS [DefaultZusatzText8Fix]

    CALC [WorkMask!BarCodeText1No]    AS [DefaultBarCodeText1No]
    CALC [WorkMask!BarCodeText2No]    AS [DefaultBarCodeText2No]
    CALC [WorkMask!ZusatzText1No]     AS [DefaultZusatzText1No]
    CALC [WorkMask!ZusatzText2No]     AS [DefaultZusatzText2No]
    CALC [WorkMask!ZusatzText3No]     AS [DefaultZusatzText3No]
    CALC [WorkMask!ZusatzText4No]     AS [DefaultZusatzText4No]
    CALC [WorkMask!ZusatzText5No]     AS [DefaultZusatzText5No]
    CALC [WorkMask!ZusatzText6No]     AS [DefaultZusatzText6No]
    CALC [WorkMask!ZusatzText7No]     AS [DefaultZusatzText7No]
    CALC [WorkMask!ZusatzText8No]     AS [DefaultZusatzText8No]

    LIST_STR_FIND [WorkMask!BarCodeType],[DefaultBarCodeType]
    LIST_STR_GET  [WorkMask!BarCodeType],[Str1]

    CALC [WorkMask!BarCodeText1]  AS [DefaultBarCodeText1]
    CALC [WorkMask!BarCodeText2]  AS [DefaultBarCodeText2]

    CALC [WorkMask!ZusatzText1]  AS [DefaultZusatzText1]
    CALC [WorkMask!ZusatzText2]  AS [DefaultZusatzText2]
    CALC [WorkMask!ZusatzText3]  AS [DefaultZusatzText3]
    CALC [WorkMask!ZusatzText4]  AS [DefaultZusatzText4]
    CALC [WorkMask!ZusatzText5]  AS [DefaultZusatzText5]
    CALC [WorkMask!ZusatzText6]  AS [DefaultZusatzText6]
    CALC [WorkMask!ZusatzText7]  AS [DefaultZusatzText7]
    CALC [WorkMask!ZusatzText8]  AS [DefaultZusatzText8]

    CALC [WorkMask!AlwaysOne] AS [DefaultAlwaysOne]
    IF [DefaultAlwaysOne]
      IF [RECORD_ID8]<=[EPSILON]
        CALC [WorkMask!Anzahl] AS 1
        CALC [DefaultAnzahl]   AS 1
      END_IF
    END_IF

    CALC [WorkMask!UseCSHPrefix] AS [DefaultUseCSHPrefix]
    IF [DefaultUseCSHPrefix]=FALSE
      CALC [BarCodePreFix] AS ''
    END_IF

    MASK_UPDATE [WorkMask], TRUE

    IF [WorkMask!EtikettEndlos]>0
      FIELD_FLAG_ON_OFF [WorkMask],'EtikettReihen','[FIELD_FLAG_PROTECTED]',''
    ELSE
      FIELD_FLAG_ON_OFF [WorkMask],'EtikettReihen','','[FIELD_FLAG_PROTECTED]'
    END_IF
  END_PROC



  PROCEDURE ReadLabelSpecificValues
    IF [DefaultLabelName]=''
      EXIT_PROC
    END_IF

    LOCAL_LIST LocList
    LOCAL_NUM  LocAct
    LOCAL_NUM  LocMax

    LIST_CLR [LocList]
    LIST_STR_2_LIST [KeyValues], [LocList], '|', 97, [KeyLnCnt]
    LIST_ITEM_GET [LocList],[LocAct],[LocMax]

    LIST_STR_GET [LocList],[Str2],1
    CALC [DefaultEtikettSpalten] AS VAL([Str2])
    IF [DefaultEtikettSpalten]<=0
      CALC [DefaultEtikettSpalten] AS 1
    END_IF

    LIST_STR_GET [LocList],[Str2],2
    CALC [DefaultEtikettReihen] AS VAL([Str2])
    IF [DefaultEtikettReihen]<=0
      CALC [DefaultEtikettReihen] AS 1
    END_IF

    LIST_STR_GET [LocList],[Str2],3
    CALC [DefaultReihenAbstand] AS VAL([Str2])
    IF [DefaultReihenAbstand]<0
      CALC [DefaultReihenAbstand] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],4
    CALC [DefaultSpaltenAbstand] AS VAL([Str2])
    IF [DefaultSpaltenAbstand]<0
      CALC [DefaultSpaltenAbstand] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],5
    CALC [DefaultBlattBreite] AS VAL([Str2])
    IF [DefaultBlattBreite]<=0
      CALC [DefaultBlattBreite] AS 2100
    END_IF

    LIST_STR_GET [LocList],[Str2],6
    CALC [DefaultBlattHoehe] AS VAL([Str2])
    IF [DefaultBlattHoehe]<=0
      CALC [DefaultBlattHoehe] AS 2970
    END_IF

    LIST_STR_GET [LocList],[Str2],7
    CALC [DefaultRandRechts] AS VAL([Str2])
    IF [DefaultRandRechts]<0
      CALC [DefaultRandRechts] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],8
    CALC [DefaultRandLinks] AS VAL([Str2])
    IF [DefaultRandLinks]<0
      CALC [DefaultRandLinks] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],9
    CALC [DefaultRandOben] AS VAL([Str2])
    IF [DefaultRandOben]<0
      CALC [DefaultRandOben] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],10
    CALC [DefaultRandUnten] AS VAL([Str2])
    IF [DefaultRandUnten]<0
      CALC [DefaultRandUnten] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],11
    CALC [DefaultBarCodeText1Pos] AS VAL([Str2])
    IF [DefaultBarCodeText1Pos]<0
      CALC [DefaultBarCodeText1Pos] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],12
    CALC [DefaultBarCodeText2Pos] AS VAL([Str2])
    IF [DefaultBarCodeText2Pos]<0
      CALC [DefaultBarCodeText2Pos] AS 0
    END_IF

    LIST_STR_GET [LocList],[Str2],13
    CALC [DefaultBarCodeHeight] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],14
    CALC [DefaultBarCodeWidth] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],15
    CALC [DefaultBarCodeStartPosX] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],16
    CALC [DefaultBarCodeStartPosY] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],17
    CALC [DefaultBarCodeType] AS [Str2]

    LIST_STR_GET [LocList],[Str2],18
    CALC [DefaultEtikettEndlos] AS VAL([Str2])


    LIST_STR_GET [LocList],[Str2],19
    CALC [DefaultLineHeight] AS VAL([Str2])
    IF [DefaultLineHeight]=0
      CALC [DefaultLineHeight] AS 40
    END_IF

    LIST_STR_GET [LocList],[Str2],20
    CALC [DefaultFontName] AS [Str2]
    IF [DefaultFontName]=''
      CALC [DefaultFontName] AS 'Arial'
    END_IF

    LIST_STR_GET [LocList],[Str2],21
    CALC [DefaultFontSize] AS VAL([Str2])
    IF [DefaultFontSize]=0
      CALC [DefaultFontSize] AS 9
    END_IF

    LIST_STR_GET [LocList],[Str2],22
    CALC [DefaultFontOpts] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],23
    CALC [DefaultFontCharSet] AS [Str2]
    IF [DefaultFontCharSet]=''
      CALC [DefaultFontCharSet] AS 'DEFAULT_CHARSET'
    END_IF

    LIST_STR_GET [LocList],[Str2],24
    CALC [DefaultFontColor] AS [Str2]
    IF [DefaultFontColor]=''
      CALC [DefaultFontColor] AS 'Black'
    END_IF

    LIST_STR_GET [LocList],[Str2],25
    CALC [DefaultPictureHeight] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],26
    CALC [DefaultPictureWidth] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],27
    CALC [DefaultPictureStartPosX] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],28
    CALC [DefaultPictureStartPosY] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],29
    CALC [DefaultPictureFile] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],30
    CALC [DefaultZusatzText1Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],31
    CALC [DefaultZusatzText2Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],32
    CALC [DefaultZusatzText3Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],33
    CALC [DefaultZusatzText4Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],34
    CALC [DefaultZusatzText5Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],35
    CALC [DefaultZusatzText6Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],36
    CALC [DefaultZusatzText7Size] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],37
    CALC [DefaultZusatzText8Size] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],38
    CALC [DefaultZusatzText1Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],39
    CALC [DefaultZusatzText2Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],40
    CALC [DefaultZusatzText3Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],41
    CALC [DefaultZusatzText4Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],42
    CALC [DefaultZusatzText5Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],43
    CALC [DefaultZusatzText6Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],44
    CALC [DefaultZusatzText7Height] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],45
    CALC [DefaultZusatzText8Height] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],46
    CALC [DefaultZusatzText1Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],47
    CALC [DefaultZusatzText2Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],48
    CALC [DefaultZusatzText3Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],49
    CALC [DefaultZusatzText4Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],50
    CALC [DefaultZusatzText5Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],51
    CALC [DefaultZusatzText6Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],52
    CALC [DefaultZusatzText7Style] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],53
    CALC [DefaultZusatzText8Style] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],54
    CALC [DefaultZusatzText1Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],55
    CALC [DefaultZusatzText2Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],56
    CALC [DefaultZusatzText3Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],57
    CALC [DefaultZusatzText4Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],58
    CALC [DefaultZusatzText5Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],59
    CALC [DefaultZusatzText6Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],60
    CALC [DefaultZusatzText7Align] AS VAL([Str2])
    LIST_STR_GET [LocList],[Str2],61
    CALC [DefaultZusatzText8Align] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],62
    CALC [DefaultFontAlign] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],63
    IF [Str2]='1'
      CALC [DefaultBarCodeText1Fix] AS TRUE
    ELSE
      CALC [DefaultBarCodeText1Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],64
    IF [Str2]='1'
      CALC [DefaultBarCodeText2Fix] AS TRUE
    ELSE
      CALC [DefaultBarCodeText2Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],65
    IF [Str2]='1'
      CALC [DefaultZusatzText1Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText1Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],66
    IF [Str2]='1'
      CALC [DefaultZusatzText2Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText2Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],67
    IF [Str2]='1'
      CALC [DefaultZusatzText3Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText3Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],68
    IF [Str2]='1'
      CALC [DefaultZusatzText4Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText4Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],69
    IF [Str2]='1'
      CALC [DefaultZusatzText5Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText5Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],70
    IF [Str2]='1'
      CALC [DefaultZusatzText6Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText6Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],71
    IF [Str2]='1'
      CALC [DefaultZusatzText7Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText7Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],72
    IF [Str2]='1'
      CALC [DefaultZusatzText8Fix] AS TRUE
    ELSE
      CALC [DefaultZusatzText8Fix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],73
    IF [Str2]='1'
      CALC [DefaultBarCodeText1No] AS TRUE
    ELSE
      CALC [DefaultBarCodeText1No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],74
    IF [Str2]='1'
      CALC [DefaultBarCodeText2No] AS TRUE
    ELSE
      CALC [DefaultBarCodeText2No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],75
    IF [Str2]='1'
      CALC [DefaultZusatzText1No] AS TRUE
    ELSE
      CALC [DefaultZusatzText1No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],76
    IF [Str2]='1'
      CALC [DefaultZusatzText2No] AS TRUE
    ELSE
      CALC [DefaultZusatzText2No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],77
    IF [Str2]='1'
      CALC [DefaultZusatzText3No] AS TRUE
    ELSE
      CALC [DefaultZusatzText3No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],78
    IF [Str2]='1'
      CALC [DefaultZusatzText4No] AS TRUE
    ELSE
      CALC [DefaultZusatzText4No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],79
    IF [Str2]='1'
      CALC [DefaultZusatzText5No] AS TRUE
    ELSE
      CALC [DefaultZusatzText5No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],80
    IF [Str2]='1'
      CALC [DefaultZusatzText6No] AS TRUE
    ELSE
      CALC [DefaultZusatzText6No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],81
    IF [Str2]='1'
      CALC [DefaultZusatzText7No] AS TRUE
    ELSE
      CALC [DefaultZusatzText7No] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],82
    IF [Str2]='1'
      CALC [DefaultZusatzText8No] AS TRUE
    ELSE
      CALC [DefaultZusatzText8No] AS FALSE
    END_IF

    IF [DefaultBarCodeText1Fix]
      IF [DefaultBarCodeText1No]=FALSE
        LIST_STR_GET [LocList],[Str2],83
        CALC [DefaultBarCodeText1] AS [Str2]
      END_IF
    END_IF

    IF [DefaultBarCodeText2Fix]
      IF [DefaultBarCodeText2No]=FALSE
        LIST_STR_GET [LocList],[Str2],84
        CALC [DefaultBarCodeText2] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText1Fix]
      IF [DefaultZusatzText1No]=FALSE
        LIST_STR_GET [LocList],[Str2],85
        CALC [DefaultZusatzText1] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText2Fix]
      IF [DefaultZusatzText2No]=FALSE
        LIST_STR_GET [LocList],[Str2],86
        CALC [DefaultZusatzText2] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText3Fix]
      IF [DefaultZusatzText3No]=FALSE
        LIST_STR_GET [LocList],[Str2],87
        CALC [DefaultZusatzText3] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText4Fix]
      IF [DefaultZusatzText4No]=FALSE
        LIST_STR_GET [LocList],[Str2],88
        CALC [DefaultZusatzText4] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText5Fix]
      IF [DefaultZusatzText5No]=FALSE
        LIST_STR_GET [LocList],[Str2],89
        CALC [DefaultZusatzText5] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText6Fix]
      IF [DefaultZusatzText6No]=FALSE
        LIST_STR_GET [LocList],[Str2],90
        CALC [DefaultZusatzText6] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText7Fix]
      IF [DefaultZusatzText7No]=FALSE
        LIST_STR_GET [LocList],[Str2],91
        CALC [DefaultZusatzText7] AS [Str2]
      END_IF
    END_IF

    IF [DefaultZusatzText8Fix]
      IF [DefaultZusatzText8No]=FALSE
        LIST_STR_GET [LocList],[Str2],92
        CALC [DefaultZusatzText8] AS [Str2]
      END_IF
    END_IF

    LIST_STR_GET [LocList],[Str2],93
    IF [Str2]='1'
      CALC [DefaultAlwaysOne] AS TRUE
    END_IF

    LIST_STR_GET [LocList],[Str2],94
    IF [Str2]='1'
      CALC [DefaultUseCSHPrefix] AS TRUE
    ELSE
      CALC [DefaultUseCSHPrefix] AS FALSE
    END_IF

    LIST_STR_GET [LocList],[Str2],95
    CALC [DefaultTextStartPosX] AS VAL([Str2])

    LIST_STR_GET [LocList],[Str2],96
    CALC [DefaultTextStartPosY] AS VAL([Str2])
  END_PROC



  PROCEDURE InitVars
    ; In der Konfigurationsdatei werden die Label und deren Definitionen abgelegt, so dass sie fr alle User gleich sind.
    VAR_STR  ConfigFileName, 'ideal.cfg'
    CALC [ConfigFileName] AS CON([SPECIAL_PATH],[ConfigFileName])


    ; In der Stations-INI-Datei werden zu den Label-Definitionen die userspezifischen Einstellungen gespeichert (was wurde zuletzt wo und wie oft gedruckt)
    VAR_STR  StationINIFileName
    CALC [StationINIFileName] AS CON([PRINTSET_PATH],[STATION_SHORT])
    IF [USER_SID_SHORT]<>''
      CALC [StationINIFileName] AS CON([StationINIFileName],'_',[USER_SID_SHORT])
    END_IF
    CALC [StationINIFileName] AS CON([StationINIFileName],'.ini')

    VAR_BOOL  Res
    VAR_STR   Str1
    VAR_STR   Str2
    VAR_STR   Str3
    VAR_STR   BarCodePreFix
    VAR_NUM   YNRes
    VAR_NUM   SPos
    VAR_STR   StrSign
    VAR_NUM   BarcodeIdx
    VAR_BOOL  BarcodeDoUpcase

    VAR_STR   VpeVersion, '2'
    IDENTIFIER_EXIST 'VPE_VERSION',[Res]
    IF [Res]
      CALC [VpeVersion] AS [VPE_VERSION]
    END_IF

    ; Diese Werte werden errechnet
    VAR_NUM   EtikettBreite
    VAR_NUM   EtikettHoehe
    VAR_NUM   PrnBlattBreite
    VAR_NUM   PrnBlattHoehe


    VAR_NUM   OffsetOben
    VAR_NUM   OffsetLinks

    VAR_NUM   ActSeite, 1
    VAR_NUM   ActSpalte
    VAR_NUM   ActReihe
    VAR_NUM   ActEtiketten


    CALC [StrSign] AS CHAR(#39)

    VAR_NUM   Y
    VAR_NUM   X
    VAR_NUM   XExtra
    VAR_NUM   XBreite
    VAR_NUM   YHoehe
    VAR_NUM   TmpNum
    VAR_FLOAT TmpFloat

    VAR_STR   EtikettKuerzel

    VAR_LIST  KeyNames
    VAR_LIST  KeyValues

    VAR_NUM   KeyLnCnt
    VAR_NUM   KeyLnMax

    ; userspezifische Werte
    VAR_NUM   DefaultStartReihe,                      1
    VAR_NUM   DefaultStartSpalte,                     1
    VAR_NUM   DefaultAnzahl,                          1
    VAR_BOOL  DefaultAlwaysOne,                   FALSE
    VAR_BOOL  DefaultUseCSHPrefix,                 TRUE

    VAR_STR   DefaultZusatzText1,                    ''
    VAR_STR   DefaultZusatzText2,                    ''
    VAR_STR   DefaultZusatzText3,                    ''
    VAR_STR   DefaultZusatzText4,                    ''
    VAR_STR   DefaultZusatzText5,                    ''
    VAR_STR   DefaultZusatzText6,                    ''
    VAR_STR   DefaultZusatzText7,                    ''
    VAR_STR   DefaultZusatzText8,                    ''

    VAR_NUM   DefaultZusatzText1Size,                 0
    VAR_NUM   DefaultZusatzText2Size,                 0
    VAR_NUM   DefaultZusatzText3Size,                 0
    VAR_NUM   DefaultZusatzText4Size,                 0
    VAR_NUM   DefaultZusatzText5Size,                 0
    VAR_NUM   DefaultZusatzText6Size,                 0
    VAR_NUM   DefaultZusatzText7Size,                 0
    VAR_NUM   DefaultZusatzText8Size,                 0

    VAR_NUM   DefaultZusatzText1Height,               0
    VAR_NUM   DefaultZusatzText2Height,               0
    VAR_NUM   DefaultZusatzText3Height,               0
    VAR_NUM   DefaultZusatzText4Height,               0
    VAR_NUM   DefaultZusatzText5Height,               0
    VAR_NUM   DefaultZusatzText6Height,               0
    VAR_NUM   DefaultZusatzText7Height,               0
    VAR_NUM   DefaultZusatzText8Height,               0

    VAR_NUM   DefaultZusatzText1Style,                0
    VAR_NUM   DefaultZusatzText2Style,                0
    VAR_NUM   DefaultZusatzText3Style,                0
    VAR_NUM   DefaultZusatzText4Style,                0
    VAR_NUM   DefaultZusatzText5Style,                0
    VAR_NUM   DefaultZusatzText6Style,                0
    VAR_NUM   DefaultZusatzText7Style,                0
    VAR_NUM   DefaultZusatzText8Style,                0

    VAR_NUM   DefaultZusatzText1Align,                0
    VAR_NUM   DefaultZusatzText2Align,                0
    VAR_NUM   DefaultZusatzText3Align,                0
    VAR_NUM   DefaultZusatzText4Align,                0
    VAR_NUM   DefaultZusatzText5Align,                0
    VAR_NUM   DefaultZusatzText6Align,                0
    VAR_NUM   DefaultZusatzText7Align,                0
    VAR_NUM   DefaultZusatzText8Align,                0

    VAR_STR   DefaultBarCodeText1,                   ''
    VAR_STR   DefaultBarCodeText2,                   ''

    VAR_BOOL  DefaultBarCodeText1Fix,             FALSE
    VAR_BOOL  DefaultBarCodeText2Fix,             FALSE
    VAR_BOOL  DefaultZusatzText1Fix,              FALSE
    VAR_BOOL  DefaultZusatzText2Fix,              FALSE
    VAR_BOOL  DefaultZusatzText3Fix,              FALSE
    VAR_BOOL  DefaultZusatzText4Fix,              FALSE
    VAR_BOOL  DefaultZusatzText5Fix,              FALSE
    VAR_BOOL  DefaultZusatzText6Fix,              FALSE
    VAR_BOOL  DefaultZusatzText7Fix,              FALSE
    VAR_BOOL  DefaultZusatzText8Fix,              FALSE

    VAR_BOOL  DefaultBarCodeText1No,              FALSE
    VAR_BOOL  DefaultBarCodeText2No,              FALSE
    VAR_BOOL  DefaultZusatzText1No,               FALSE
    VAR_BOOL  DefaultZusatzText2No,               FALSE
    VAR_BOOL  DefaultZusatzText3No,               FALSE
    VAR_BOOL  DefaultZusatzText4No,               FALSE
    VAR_BOOL  DefaultZusatzText5No,               FALSE
    VAR_BOOL  DefaultZusatzText6No,               FALSE
    VAR_BOOL  DefaultZusatzText7No,               FALSE
    VAR_BOOL  DefaultZusatzText8No,               FALSE

    ; definitions Werte
    VAR_NUM   DefaultTextStartPosX,                   0
    VAR_NUM   DefaultTextStartPosY,                   0
    VAR_NUM   DefaultLineHeight,                     40
    VAR_STR   DefaultFontName,                   'Arial'
    VAR_NUM   DefaultFontSize,                        9
    VAR_NUM   DefaultFontOpts,                        0
    VAR_NUM   DefaultFontAlign,                       1
    VAR_STR   DefaultFontCharSet,      'DEFAULT_CHARSET'
    VAR_STR   DefaultFontColor,                  'Black'
    VAR_NUM   DefaultEtikettEndlos,                   0
    VAR_NUM   DefaultEtikettSpalten,                  4
    VAR_NUM   DefaultEtikettReihen,                  10
    VAR_NUM   DefaultReihenAbstand,                   0
    VAR_NUM   DefaultSpaltenAbstand,                  0
    VAR_NUM   DefaultBlattBreite,                  2100
    VAR_NUM   DefaultBlattHoehe,                   2970
    VAR_NUM   DefaultRandRechts,                     50
    VAR_NUM   DefaultRandLinks,                      50
    VAR_NUM   DefaultRandOben,                       50
    VAR_NUM   DefaultRandUnten,                      50
    VAR_STR   DefaultLabelName,                      ''
    VAR_NUM   DefaultBarCodeText1Pos,                 0
    VAR_NUM   DefaultBarCodeText2Pos,                 0
    VAR_NUM   DefaultBarCodeHeight,                -100
    VAR_NUM   DefaultBarCodeWidth,                -1000
    VAR_NUM   DefaultBarCodeStartPosX,              100
    VAR_NUM   DefaultBarCodeStartPosY,              100
    VAR_STR   DefaultBarCodeType,               'CODE39'
    VAR_NUM   DefaultPictureStartPosX,               50
    VAR_NUM   DefaultPictureStartPosY,               50
    VAR_NUM   DefaultPictureHeight,                -100
    VAR_NUM   DefaultPictureWidth,                 -100
    VAR_STR   DefaultPictureFile,                    ''

    CALC [DefaultLabelName] AS TRIM([PAR_STR1])

    VAR_MASK  WorkMask, 'PrintBarCodesDlg'

    CALL SetDefaults

    CALL ReadLabelNames

    CALL ReadUserSpecificValues
    CALL ReadLabelSpecificValues

    CALC [WorkMask!MASK_HOOK_IS_READY]  AS 'IsReadyHook'
    CALC [WorkMask!MASK_HOOK_EXIT]      AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_BUTTON]    AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_PRINT]     AS 'PrintHook'
    CALC [WorkMask!MASK_HOOK_POST_EDIT] AS 'PostEditHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE]  AS 'PreSaveHook'

    ; Wenn das Script ohne Parameter aufgerufen wurde, soll nun der erste verfgbare Label-Typ geladden werden
    IF [DefaultLabelName]<>''
      IF [DefaultLabelName]<>[PAR_STR1]
        CALL ReadUserSpecificValues
        CALL ReadLabelSpecificValues
      END_IF
    END_IF
  END_PROC



  PROCEDURE InitFontSettings
    CALC [Str1] AS CON('[PS 0 T ', [StrSign] , [WorkMask!FontName], [StrSign], ' S ', [WorkMask!FontSize],' ]')
    PRINT_STR [Prn], 200, 200, [Str1]
  END_PROC



  PROCEDURE PrintZusatzText VN LocZusIdx, VN LocZusIdxMax
    IF [WorkMask!ZusatzText[LocZusIdx]No]
      EXIT_PROC
    END_IF

    CALC [Str2] AS [WorkMask!ZusatzText[LocZusIdx]]
    IF [Str2]=''
      IF [LocZusIdx]<[LocZusIdxMax]
        CALC [Str3] AS ''
        LOCAL_NUM LocTmpIdx
        CALC [LocTmpIdx] AS [LocZusIdx]+1
        WHILE [LocTmpIdx]<=[LocZusIdxMax]
          IF [WorkMask!ZusatzText[LocZusIdx]No]=FALSE
            CALC [Str3] AS CON([Str3],[WorkMask!ZusatzText[LocTmpIdx]]
          END_IF
          INC [LocTmpIdx]
        END_WHILE
        CALC [Str3] AS TRIM([Str3])
      END_IF

      IF [Str3]=''
        EXIT_PROC
      END_IF
    END_IF

    CALC [Str1] AS CON('[N J L C ',[WorkMask!FontColor])

    CALC [TmpNum] AS [WorkMask!FontAlign]
    IF [WorkMask!ZusatzText[LocZusIdx]Align]>0
      IF [WorkMask!ZusatzText[LocZusIdx]Align]<>1
        CALC [TmpNum] AS [WorkMask!ZusatzText[LocZusIdx]Align]
      END_IF
    END_IF
    IF [TmpNum]=1
      CALC [Str1] AS CON([Str1], ' J L')
    ELSE_IF [TmpNum]=2
      CALC [Str1] AS CON([Str1], ' J CE')
    ELSE_IF [TmpNum]=4
      CALC [Str1] AS CON([Str1], ' J R')
    END_IF

    CALC [TmpNum] AS [WorkMask!FontOpts]
    IF [WorkMask!ZusatzText[LocZusIdx]Style]>0
      IF [WorkMask!ZusatzText[LocZusIdx]Style]<>[WorkMask!FontOpts]
        CALC [TmpNum] AS [WorkMask!ZusatzText[LocZusIdx]Style]
      END_IF
    END_IF

    FLAG_STATE [TmpNum],[FONT_STYLE_BOLD],[Res]
    IF [Res]
      CALC [Str1] AS CON([Str1], ' B')
    END_IF

    FLAG_STATE [TmpNum],[FONT_STYLE_UNDERLINE],[Res]
    IF [Res]
      CALC [Str1] AS CON([Str1], ' U')
    END_IF

    FLAG_STATE [TmpNum],[FONT_STYLE_ITALIC],[Res]
    IF [Res]
      CALC [Str1] AS CON([Str1], ' I')
    END_IF

    CALC [TmpNum] AS [WorkMask!FontSize]
    IF [WorkMask!ZusatzText[LocZusIdx]Size]>0
      IF [WorkMask!ZusatzText[LocZusIdx]Size]<>[WorkMask!FontSize]
        CALC [TmpNum] AS [WorkMask!ZusatzText[LocZusIdx]Size]
        CALC [Str1]   AS CON([Str1], ' S ',[TmpNum])
      END_IF
    END_IF

    CALC [Str1] AS CON([Str1], ']')

    CALC [SPos] AS ABS([WorkMask!LineHeight]) * (-1)
    IF [WorkMask!ZusatzText[LocZusIdx]Height]>0
      IF [WorkMask!ZusatzText[LocZusIdx]Height]<>[WorkMask!LineHeight]
        CALC [SPos] AS ABS([WorkMask!ZusatzText[LocZusIdx]Height]) * (-1)
      END_IF
    END_IF

    PRINT_BOX [Prn], [X], [Y], [XBreite], [SPos], [Str1], [Str2]
    IF [LocZusIdx]<8
      CALC [Y] AS [Y] + [WorkMask!LineHeight] + 5
    END_IF
  END_PROC



  PROCEDURE WriteEtikett
    IF [WorkMask!PictureFile]<>''
      CALC [X] AS [OffsetLinks]+10+[WorkMask!PictureStartPosX]
      CALC [Y] AS [OffsetOben] +10+[WorkMask!PictureStartPosY]

      PRINT_PIC [Prn], [X], [Y], [WorkMask!PictureWidth], [WorkMask!PictureHeight], [WorkMask!PictureFile]
    END_IF

    CALC [X] AS [OffsetLinks]+10+[WorkMask!BarCodeStartPosX]
    CALC [Y] AS [OffsetOben] +10+[WorkMask!BarCodeStartPosY]

    IF [WorkMask!BarCodeText1]<>''
      IF [BarcodeDoUpcase]
        IF [VpeVersion]<>'2'
          CALC [WorkMask!BarCodeText1] AS UPCASE([WorkMask!BarCodeText1])
          CALC [WorkMask!BarCodeText2] AS UPCASE([WorkMask!BarCodeText2])
          MASK_UPDATE [WorkMask]
        END_IF
      END_IF

      CALC [XBreite] AS ABS([WorkMask!BarCodeWidth])
      CALC [SPos]    AS ABS([WorkMask!BarCodeHeight])
      IF [XBreite]>0.5
        IF [SPos]>0.5
          PRINT_BAR [Prn], [X], [Y], [WorkMask!BarCodeWidth], [WorkMask!BarCodeHeight], [BarcodeIdx],  [WorkMask!BarCodeText1], [WorkMask!BarCodeText2], [WorkMask!BarCodeText1Pos], [WorkMask!BarCodeText2Pos]
        END_IF
      END_IF
    END_IF

    CALC [X] AS [OffsetLinks]+10+[WorkMask!BarCodeStartPosX]
    CALC [Y] AS [Y] + 10 + ABS([WorkMask!BarCodeHeight])

    IF [WorkMask!TextStartPosX]<>0
      CALC [X] AS [OffsetLinks]+[WorkMask!TextStartPosX]
    END_IF
    IF [WorkMask!TextStartPosY]<>0
      CALC [Y] AS [OffsetOben]+[WorkMask!TextStartPosY]
    END_IF

    CALC [XBreite] AS (ABS([EtikettBreite])-20) * (-1)

    CALL PrintZusatzText 1, 8
    CALL PrintZusatzText 2, 8
    CALL PrintZusatzText 3, 8
    CALL PrintZusatzText 4, 8
    CALL PrintZusatzText 5, 8
    CALL PrintZusatzText 6, 8
    CALL PrintZusatzText 7, 8
    CALL PrintZusatzText 8, 8
  END_PROC



  PROCEDURE DoPrintOut VN DPO.PrintOutMode
    IF [WorkMask!DebugMode]
      CALC [Str1] AS CON('VPE-Version ',[VpeVersion])
      DEBUG_INFO [Str1]
      DEBUG_INFO '.'
      CALC [Str1] AS CON([TIME],': Start der Etikettenerstellung')
      DEBUG_INFO [Str1]
    END_IF

    LIST_STR_GET [WorkMask!LabelName],[Str2]
    IF [Str2]=''
      EXIT_PROC
    END_IF

    IF [VpeVersion]='2'
      CALC [PrnBlattBreite] AS [WorkMask!BlattBreite] + 300
      CALC [PrnBlattHoehe]  AS [WorkMask!BlattHoehe]  + 300
    ELSE
      CALC [PrnBlattBreite] AS [WorkMask!BlattBreite]
      CALC [PrnBlattHoehe]  AS [WorkMask!BlattHoehe]
    END_IF

    CALC [EtikettKuerzel] AS CON([Str2],'_',[STATION_SHORT])

    IF [RECORD_ID10]<=[EPSILON]
      IF [VpeVersion]='2'
        IDENTIFIER_EXIST 'Prn',[Res]
        IF [Res]
          IDENTIFIER_DESTROY 'Prn',[Res]
        END_IF

        CALL PrintOut.GetSet [EtikettKuerzel], [DPO.PrintOutMode], [DPO.PrintOutMode], 'Barcode-Label-Druck'
      END_IF

      VAR_PRINT Prn, [PrnBlattBreite], [PrnBlattHoehe]
    END_IF

    CALC [TmpFloat]       AS ([WorkMask!BlattBreite]-[WorkMask!RandRechts]-[WorkMask!RandLinks]-([WorkMask!SpaltenAbstand]*([WorkMask!EtikettSpalten]-1)))/[WorkMask!EtikettSpalten]
    CALC [EtikettBreite]  AS [TmpFloat]

    CALC [TmpFloat]       AS ([WorkMask!BlattHoehe] -[WorkMask!RandOben]  -[WorkMask!RandUnten]-([WorkMask!ReihenAbstand] *([WorkMask!EtikettReihen] -1)))/[WorkMask!EtikettReihen]
    CALC [EtikettHoehe]   AS [TmpFloat]


    CALC [BarcodeDoUpcase] AS FALSE

    LIST_STR_GET [WorkMask!BarCodeType],[Str1]
    CALC [BarcodeIdx] AS [BCT_EAN13]
    IF [Str1]='2OF5'
      CALC [BarcodeIdx] AS [BCT_2OF5]
    ELSE_IF [Str1]='2OF5MATRIX'
      CALC [BarcodeIdx] AS [BCT_2OF5MATRIX]
    ELSE_IF [Str1]='CODABAR'
      CALC [BarcodeIdx] AS [BCT_CODABAR]
    ELSE_IF [Str1]='CODE11'
      CALC [BarcodeIdx] AS [BCT_CODE11]
    ELSE_IF [Str1]='CODE128'
      CALC [BarcodeIdx] AS [BCT_CODE128]
    ELSE_IF [Str1]='CODE128A'
      CALC [BarcodeIdx] AS [BCT_CODE128A]
    ELSE_IF [Str1]='CODE128B'
      CALC [BarcodeIdx] AS [BCT_CODE128B]
    ELSE_IF [Str1]='CODE128C'
      CALC [BarcodeIdx] AS [BCT_CODE128C]
    ELSE_IF [Str1]='CODE39'
      CALC [BarcodeDoUpcase] AS TRUE
      CALC [BarcodeIdx] AS [BCT_CODE39]
    ELSE_IF [Str1]='CODE39EXT'
      CALC [BarcodeIdx] AS [BCT_CODE39EXT]
    ELSE_IF [Str1]='CODE93'
      CALC [BarcodeIdx] AS [BCT_CODE93]
    ELSE_IF [Str1]='CODE93EXT'
      CALC [BarcodeIdx] AS [BCT_CODE93EXT]
    ELSE_IF [Str1]='EAN128'
      CALC [BarcodeIdx] AS [BCT_EAN128]
    ELSE_IF [Str1]='EAN128A'
      CALC [BarcodeIdx] AS [BCT_EAN128A]
    ELSE_IF [Str1]='EAN128B'
      CALC [BarcodeIdx] AS [BCT_EAN128B]
    ELSE_IF [Str1]='EAN128C'
      CALC [BarcodeIdx] AS [BCT_EAN128C]
    ELSE_IF [Str1]='EAN13'
      CALC [BarcodeIdx] AS [BCT_EAN13]
    ELSE_IF [Str1]='EAN13_2'
      CALC [BarcodeIdx] AS [BCT_EAN13_2]
    ELSE_IF [Str1]='EAN13_5'
      CALC [BarcodeIdx] AS [BCT_EAN13_5]
    ELSE_IF [Str1]='EAN2'
      CALC [BarcodeIdx] AS [BCT_EAN2]
    ELSE_IF [Str1]='EAN5'
      CALC [BarcodeIdx] AS [BCT_EAN5]
    ELSE_IF [Str1]='EAN8'
      CALC [BarcodeIdx] AS [BCT_EAN8]
    ELSE_IF [Str1]='EAN8_2'
      CALC [BarcodeIdx] AS [BCT_EAN8_2]
    ELSE_IF [Str1]='EAN8_5'
      CALC [BarcodeIdx] AS [BCT_EAN8_5]
    ELSE_IF [Str1]='IDENTCODE'
      CALC [BarcodeIdx] AS [BCT_IDENTCODE]
    ELSE_IF [Str1]='INTELLIGENT_MAIL'
      CALC [BarcodeIdx] AS [BCT_INTELLIGENT_MAIL]
    ELSE_IF [Str1]='INTERLEAVED2OF5'
      CALC [BarcodeIdx] AS [BCT_INTERLEAVED2OF5]
    ELSE_IF [Str1]='ISBN'
      CALC [BarcodeIdx] AS [BCT_ISBN]
    ELSE_IF [Str1]='ISBN5'
      CALC [BarcodeIdx] AS [BCT_ISBN5]
    ELSE_IF [Str1]='LEITCODE'
      CALC [BarcodeIdx] AS [BCT_LEITCODE]
    ELSE_IF [Str1]='MSI'
      CALC [BarcodeIdx] AS [BCT_MSI]
    ELSE_IF [Str1]='POSTNET'
      CALC [BarcodeIdx] AS [BCT_POSTNET]
    ELSE_IF [Str1]='PZN'
      CALC [BarcodeIdx] AS [BCT_PZN]
    ELSE_IF [Str1]='RM4SCC'
      CALC [BarcodeIdx] AS [BCT_RM4SCC]
    ELSE_IF [Str1]='TELEPENA'
      CALC [BarcodeIdx] AS [BCT_TELEPENA]
    ELSE_IF [Str1]='UPCA'
      CALC [BarcodeIdx] AS [BCT_UPCA]
    ELSE_IF [Str1]='UPCA_2'
      CALC [BarcodeIdx] AS [BCT_UPCA_2]
    ELSE_IF [Str1]='UPCA_5'
      CALC [BarcodeIdx] AS [BCT_UPCA_5]
    ELSE_IF [Str1]='UPCE'
      CALC [BarcodeIdx] AS [BCT_UPCE]
    ELSE_IF [Str1]='UPCE_2'
      CALC [BarcodeIdx] AS [BCT_UPCE_2]
    ELSE_IF [Str1]='UPCE_5'
      CALC [BarcodeIdx] AS [BCT_UPCE_5]
    END_IF

    IF [RECORD_ID10]<=[EPSILON]
      PRINT_CLR [Prn]
    END_IF

    CALL InitFontSettings

    CALC [ActSpalte]    AS [WorkMask!Spalte]
    CALC [ActReihe]     AS [WorkMask!Reihe]
    CALC [ActEtiketten] AS 0

    WHILE [ActEtiketten]<[WorkMask!Anzahl]
      INC [ActEtiketten]

      CALC [OffsetOben]  AS [WorkMask!RandOben] +(([ActReihe] -1)*([EtikettHoehe] +[WorkMask!ReihenAbstand]))
      CALC [OffsetLinks] AS [WorkMask!RandLinks]+(([ActSpalte]-1)*([EtikettBreite]+[WorkMask!SpaltenAbstand]))

      CALL WriteEtikett

      IF [WorkMask!EtikettEndlos]=0
        INC [ActSpalte]
        IF [ActSpalte]>[WorkMask!EtikettSpalten]
          CALC [ActSpalte] AS 1
          INC [ActReihe]
          IF [ActReihe]>[WorkMask!EtikettReihen]
            CALC [ActReihe] AS 1
            INC  [ActSeite]
            PRINT_PAGE [Prn]
            CALL InitFontSettings
          END_IF
        END_IF
      ELSE
        IF [WorkMask!EtikettSpalten]>1
          INC [ActSpalte]
          IF [ActSpalte]>[WorkMask!EtikettSpalten]
            CALC [ActSpalte] AS 1
            IF [ActEtiketten]<[WorkMask!Anzahl]
              PRINT_PAGE [Prn]
            END_IF
          END_IF
        ELSE_IF [ActEtiketten]<[WorkMask!Anzahl]
          PRINT_PAGE [Prn]
        END_IF
      END_IF
    END_WHILE

    IF [WorkMask!DebugMode]
      DEBUG_INFO '.'
      CALC [Str1] AS CON([TIME],': Ende der Etikettenerstellung')
      DEBUG_INFO [Str1]
    END_IF

    IF [RECORD_ID10]<=[EPSILON]
      IF [WorkMask!DebugMode]
        DEBUG_INFO '.'
        CALC [Str1] AS CON([TIME],': Start des Druckens')
        DEBUG_INFO [Str1]
      END_IF

      IF [VpeVersion]='2'
        CALL PrintOut.Direct 'Prn', 1, [WorkMask!MASK_ACT_PRINT_MODE], [WorkMask!MASK_ACT_PRINT_MODE]
      ELSE
        CALL PrintOut.OutPut 'Prn', 1, [EtikettKuerzel], [DPO.PrintOutMode], [DPO.PrintOutMode]
      END_IF

      IF [WorkMask!DebugMode]
        DEBUG_INFO '.'
        CALC [Str1] AS CON([TIME],': Ende des Druckens')
        DEBUG_INFO [Str1]
      END_IF
    END_IF

    IF [WorkMask!EtikettEndlos]=0
      CALC [WorkMask!Spalte] AS [ActSpalte]
      CALC [WorkMask!Reihe]  AS [ActReihe]
    ELSE_IF [WorkMask!EtikettSpalten]>1
      CALC [WorkMask!Spalte] AS [ActSpalte]
    END_IF

    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE PrintHook
    IF [RECORD_ID11]<=[EPSILON]
      CALL DoPrintOut [WorkMask!MASK_ACT_PRINT_MODE]
    ELSE
      CALL DoPrintOut [PRINT_OUT_PREVIEW]
    END_IF
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



  PROCEDURE WriteUserSpecificValues
    LIST_STR_GET [WorkMask!LabelName],[Str2]
    IF [Str2]=''
      EXIT_PROC
    END_IF

    CALC [Str1] AS CON([WorkMask!Reihe],'|',[WorkMask!Spalte],'|',[WorkMask!Anzahl])
    INI_WRITE [Res],[Str1],[SCRIPT_STRING],[StationINIFileName],[Str2],'BarCodeLabel'
  END_PROC



  PROCEDURE WriteLabelSpecificValues
    LOCAL_LIST LocList
    LOCAL_NUM  LocAct
    LOCAL_NUM  LocMax
    LOCAL_STR  LocListName

    LIST_STR_GET [WorkMask!LabelName],[LocListName]
    IF [LocListName]=''
      EXIT_PROC
    END_IF

    LIST_CLR [LocList]

    ; 01
    CALC [Str1] AS [WorkMask!EtikettSpalten]
    LIST_APPEND [LocList],[Str1]

    ; 02
    CALC [Str1] AS [WorkMask!EtikettReihen]
    LIST_APPEND [LocList],[Str1]

    ; 03
    CALC [Str1] AS [WorkMask!ReihenAbstand]
    LIST_APPEND [LocList],[Str1]

    ; 04
    CALC [Str1] AS [WorkMask!SpaltenAbstand]
    LIST_APPEND [LocList],[Str1]

    ; 05
    CALC [Str1] AS [WorkMask!BlattBreite]
    LIST_APPEND [LocList],[Str1]

    ; 06
    CALC [Str1] AS [WorkMask!BlattHoehe]
    LIST_APPEND [LocList],[Str1]

    ; 07
    CALC [Str1] AS [WorkMask!RandRechts]
    LIST_APPEND [LocList],[Str1]

    ; 08
    CALC [Str1] AS [WorkMask!RandLinks]
    LIST_APPEND [LocList],[Str1]

    ; 09
    CALC [Str1] AS [WorkMask!RandOben]
    LIST_APPEND [LocList],[Str1]

    ; 10
    CALC [Str1] AS [WorkMask!RandUnten]
    LIST_APPEND [LocList],[Str1]

    ; 11
    CALC [Str1] AS [WorkMask!BarCodeText1Pos]
    LIST_APPEND [LocList],[Str1]

    ; 12
    CALC [Str1] AS [WorkMask!BarCodeText2Pos]
    LIST_APPEND [LocList],[Str1]

    ; 13
    CALC [Str1] AS [WorkMask!BarCodeHeight]
    LIST_APPEND [LocList],[Str1]

    ; 14
    CALC [Str1] AS [WorkMask!BarCodeWidth]
    LIST_APPEND [LocList],[Str1]

    ; 15
    CALC [Str1] AS [WorkMask!BarCodeStartPosX]
    LIST_APPEND [LocList],[Str1]

    ; 16
    CALC [Str1] AS [WorkMask!BarCodeStartPosY]
    LIST_APPEND [LocList],[Str1]

    ; 17
    LIST_STR_GET [WorkMask!BarCodeType],[Str1]
    LIST_APPEND [LocList],[Str1]

    ; 18
    CALC [Str1] AS [WorkMask!EtikettEndlos]
    LIST_APPEND [LocList],[Str1]

    ; 19
    CALC [Str1] AS [WorkMask!LineHeight]
    LIST_APPEND [LocList],[Str1]

    ; 20
    CALC [Str1] AS [WorkMask!FontName]
    LIST_APPEND [LocList],[Str1]

    ; 21
    CALC [Str1] AS [WorkMask!FontSize]
    LIST_APPEND [LocList],[Str1]

    ; 22
    CALC [Str1] AS [WorkMask!FontOpts]
    LIST_APPEND [LocList],[Str1]

    ; 23
    CALC [Str1] AS [WorkMask!FontCharSet]
    LIST_APPEND [LocList],[Str1]

    ; 24
    CALC [Str1] AS [WorkMask!FontColor]
    LIST_APPEND [LocList],[Str1]

    ; 25
    CALC [Str1] AS [WorkMask!PictureHeight]
    LIST_APPEND [LocList],[Str1]

    ; 26
    CALC [Str1] AS [WorkMask!PictureWidth]
    LIST_APPEND [LocList],[Str1]

    ; 27
    CALC [Str1] AS [WorkMask!PictureStartPosX]
    LIST_APPEND [LocList],[Str1]

    ; 28
    CALC [Str1] AS [WorkMask!PictureStartPosY]
    LIST_APPEND [LocList],[Str1]

    ; 29
    CALC [Str1] AS [WorkMask!PictureFile]
    LIST_APPEND [LocList],[Str1]

    ; 30
    CALC [Str1] AS [WorkMask!ZusatzText1Size]
    LIST_APPEND [LocList],[Str1]

    ; 31
    CALC [Str1] AS [WorkMask!ZusatzText2Size]
    LIST_APPEND [LocList],[Str1]

    ; 32
    CALC [Str1] AS [WorkMask!ZusatzText3Size]
    LIST_APPEND [LocList],[Str1]

    ; 33
    CALC [Str1] AS [WorkMask!ZusatzText4Size]
    LIST_APPEND [LocList],[Str1]

    ; 34
    CALC [Str1] AS [WorkMask!ZusatzText5Size]
    LIST_APPEND [LocList],[Str1]

    ; 35
    CALC [Str1] AS [WorkMask!ZusatzText6Size]
    LIST_APPEND [LocList],[Str1]

    ; 36
    CALC [Str1] AS [WorkMask!ZusatzText7Size]
    LIST_APPEND [LocList],[Str1]

    ; 37
    CALC [Str1] AS [WorkMask!ZusatzText8Size]
    LIST_APPEND [LocList],[Str1]

    ; 38
    CALC [Str1] AS [WorkMask!ZusatzText1Height]
    LIST_APPEND [LocList],[Str1]

    ; 39
    CALC [Str1] AS [WorkMask!ZusatzText2Height]
    LIST_APPEND [LocList],[Str1]

    ; 40
    CALC [Str1] AS [WorkMask!ZusatzText3Height]
    LIST_APPEND [LocList],[Str1]

    ; 41
    CALC [Str1] AS [WorkMask!ZusatzText4Height]
    LIST_APPEND [LocList],[Str1]

    ; 42
    CALC [Str1] AS [WorkMask!ZusatzText5Height]
    LIST_APPEND [LocList],[Str1]

    ; 43
    CALC [Str1] AS [WorkMask!ZusatzText6Height]
    LIST_APPEND [LocList],[Str1]

    ; 44
    CALC [Str1] AS [WorkMask!ZusatzText7Height]
    LIST_APPEND [LocList],[Str1]

    ; 45
    CALC [Str1] AS [WorkMask!ZusatzText8Height]
    LIST_APPEND [LocList],[Str1]

    ; 46
    CALC [Str1] AS [WorkMask!ZusatzText1Style]
    LIST_APPEND [LocList],[Str1]

    ; 47
    CALC [Str1] AS [WorkMask!ZusatzText2Style]
    LIST_APPEND [LocList],[Str1]

    ; 48
    CALC [Str1] AS [WorkMask!ZusatzText3Style]
    LIST_APPEND [LocList],[Str1]

    ; 49
    CALC [Str1] AS [WorkMask!ZusatzText4Style]
    LIST_APPEND [LocList],[Str1]

    ; 50
    CALC [Str1] AS [WorkMask!ZusatzText5Style]
    LIST_APPEND [LocList],[Str1]

    ; 51
    CALC [Str1] AS [WorkMask!ZusatzText6Style]
    LIST_APPEND [LocList],[Str1]

    ; 52
    CALC [Str1] AS [WorkMask!ZusatzText7Style]
    LIST_APPEND [LocList],[Str1]

    ; 53
    CALC [Str1] AS [WorkMask!ZusatzText8Style]
    LIST_APPEND [LocList],[Str1]

    ; 54
    CALC [Str1] AS [WorkMask!ZusatzText1Align]
    LIST_APPEND [LocList],[Str1]

    ; 55
    CALC [Str1] AS [WorkMask!ZusatzText2Align]
    LIST_APPEND [LocList],[Str1]

    ; 56
    CALC [Str1] AS [WorkMask!ZusatzText3Align]
    LIST_APPEND [LocList],[Str1]

    ; 57
    CALC [Str1] AS [WorkMask!ZusatzText4Align]
    LIST_APPEND [LocList],[Str1]

    ; 58
    CALC [Str1] AS [WorkMask!ZusatzText5Align]
    LIST_APPEND [LocList],[Str1]

    ; 59
    CALC [Str1] AS [WorkMask!ZusatzText6Align]
    LIST_APPEND [LocList],[Str1]

    ; 60
    CALC [Str1] AS [WorkMask!ZusatzText7Align]
    LIST_APPEND [LocList],[Str1]

    ; 61
    CALC [Str1] AS [WorkMask!ZusatzText8Align]
    LIST_APPEND [LocList],[Str1]

    ; 62
    CALC [Str1] AS [WorkMask!FontAlign]
    LIST_APPEND [LocList],[Str1]

    ; 63
    CALC [Str1] AS ''
    IF [WorkMask!BarCodeText1Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 64
    CALC [Str1] AS ''
    IF [WorkMask!BarCodeText2Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 65
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText1Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 66
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText2Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 67
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText3Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 68
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText4Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 69
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText5Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 70
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText6Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 71
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText7Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 72
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText8Fix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 73
    CALC [Str1] AS ''
    IF [WorkMask!BarCodeText1No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 74
    CALC [Str1] AS ''
    IF [WorkMask!BarCodeText2No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 75
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText1No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 76
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText2No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 77
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText3No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 78
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText4No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 79
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText5No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 80
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText6No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 81
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText7No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 82
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText8No]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 83
    CALC [Str1] AS ''
    IF [WorkMask!BarCodeText1Fix]
      IF [WorkMask!BarCodeText1No]=FALSE
        CALC [Str1] AS [WorkMask!BarCodeText1]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 84
    CALC [Str1] AS ''
    IF [WorkMask!BarCodeText2Fix]
      IF [WorkMask!BarCodeText2No]=FALSE
        CALC [Str1] AS [WorkMask!BarCodeText2]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 85
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText1Fix]
      IF [WorkMask!ZusatzText1No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText1]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 86
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText2Fix]
      IF [WorkMask!ZusatzText2No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText2]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 87
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText3Fix]
      IF [WorkMask!ZusatzText3No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText3]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 88
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText4Fix]
      IF [WorkMask!ZusatzText4No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText4]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 89
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText5Fix]
      IF [WorkMask!ZusatzText5No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText5]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 90
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText6Fix]
      IF [WorkMask!ZusatzText6No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText6]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 91
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText7Fix]
      IF [WorkMask!ZusatzText7No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText7]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 92
    CALC [Str1] AS ''
    IF [WorkMask!ZusatzText8Fix]
      IF [WorkMask!ZusatzText8No]=FALSE
        CALC [Str1] AS [WorkMask!ZusatzText8]
      END_IF
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 93
    CALC [Str1] AS ''
    IF [WorkMask!AlwaysOne]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 94
    CALC [Str1] AS ''
    IF [WorkMask!UseCSHPrefix]
      CALC [Str1] AS '1'
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 95
    CALC [Str1] AS ''
    IF [WorkMask!TextStartPosX]<>0
      CALC [Str1] AS [WorkMask!TextStartPosX]
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; 96
    CALC [Str1] AS ''
    IF [WorkMask!TextStartPosY]<>0
      CALC [Str1] AS [WorkMask!TextStartPosY]
    END_IF
    LIST_APPEND [LocList],[Str1]

    ; Schnell nochmal die ganze Sektion lesen, weil sie dann ja gleich berschrieben wird
    INI_READ_SECTION [Res],[KeyNames],[KeyValues],[ConfigFileName],'BarCodeLabel'
    LIST_ITEM_GET [KeyNames],[KeyLnCnt],[KeyLnMax]
    IF [KeyLnMax]=0
      EXIT_PROC
    END_IF

    LIST_STR_FIND [KeyNames],[LocListName],[KeyLnCnt]
    IF [KeyLnCnt]=0
      LIST_APPEND [KeyNames], [LocListName]
      LIST_APPEND [KeyValues],' '
      CALC [KeyLnMax] AS [KeyLnMax]+1
      CALC [KeyLnCnt] AS [KeyLnMax]
    END_IF

    LIST_2_LIST_STR [LocList], [KeyValues], '|', [KeyLnCnt]

    ; Jetzt schreiben der Sektion
    INI_WRITE_SECTION [Res],[KeyNames],[KeyValues],[ConfigFileName],'BarCodeLabel'
  END_PROC



  PROCEDURE PostEditHook
    IF [WorkMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='EtikettEndlos'
      IF [WorkMask!EtikettEndlos]>0
        CALC [WorkMask!EtikettEndlos] AS 1
        CALC [WorkMask!EtikettReihen] AS 9999
        MASK_UPDATE [WorkMask]
        FIELD_FLAG_ON_OFF [WorkMask],'EtikettReihen','[FIELD_FLAG_PROTECTED]',''
      ELSE
        CALC [WorkMask!EtikettEndlos] AS 0
        CALC [WorkMask!EtikettReihen] AS 1
        MASK_UPDATE [WorkMask]
        FIELD_FLAG_ON_OFF [WorkMask],'EtikettReihen','','[FIELD_FLAG_PROTECTED]'
      END_IF
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='LabelName'
      CALC [Str2] AS [WorkMask!MASK_ACT_FIELD_VALUE]

      IF [DefaultLabelName]<>[Str2]
        LIST_STR_FIND [KeyNames],[Str2],[KeyLnCnt]
        IF [KeyLnCnt]=0
          CALC [YNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?!','Soll eine neue Definition in die Liste aufgenommen werden?',[YNRes]
          IF [YNRes]=[ID_YES]
            LIST_APPEND   [WorkMask!LabelName],[Str2]
            LIST_STR_FIND [WorkMask!LabelName],[Str2]

            LIST_APPEND [KeyNames], [Str2]
            LIST_APPEND [KeyValues],' '
            CALC [KeyLnMax] AS [KeyLnMax]+1
            CALC [KeyLnCnt] AS [KeyLnMax]
          ELSE
            EXIT_PROC
          END_IF
        END_IF

        MASK_UPDATE [WorkMask]

        CALC [DefaultLabelName] AS [Str2]
      END_IF

      IF [DefaultLabelName]=''
        EXIT_PROC
      END_IF

      CALL ReadUserSpecificValues
      CALL ReadLabelSpecificValues
      CALL AfterLoad
    END_IF
  END_PROC



  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_PRINT'
      IF [RECORD_ID11]<=[EPSILON]
        CALL DoPrintOut [PRINT_OUT_DIRECT]
	    ELSE
	      CALL DoPrintOut [PRINT_OUT_PREVIEW]
	    END_IF
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_PICTURE'
      CALC [Str1] AS CON([SPECIAL_PATH],'*.bmp')
      CHOOSE_FILE [Str1], [CHOOSE_FILE_4_OPEN], 'Bilddatei auswhlen','BMP-Dateien (*.bmp)|*.bmp|JPG-Dateien (*.jpg)|*.jpg|Alle Dateien (*.*)|*.*',[Res], [SPECIAL_PATH]
      IF [Res]
        CALC [WorkMask!PictureFile] AS [Str1]
      ELSE
        IF [WorkMask!PictureFile]<>''
          CALC [YNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?!','Soll die Zuordnung der Bilddatei nun aufgehoben werden?',[YNRes]
          IF [YNRes]=[ID_YES]
            CALC [WorkMask!PictureFile] AS ''
          END_IF
        END_IF
      END_IF
      MASK_UPDATE [WorkMask]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_FontSettings'
      CALC [Str1] AS CON([WorkMask!FontName],'|',[WorkMask!FontSize],'|',[WorkMask!FontCharSet]'|',[WorkMask!FontColor],'|',[WorkMask!FontOpts])

      GET_FONT [Res], [Str1], 'Schriftart auswhlen'
      IF [Res]
        CALC [WorkMask!FontName] AS PART([Str1],1,'|')

        CALC [Str2] AS PART([Str1],2,'|')
        CALC [SPos] AS VAL([Str2])
        IF [SPos]>0
          CALC [WorkMask!FontSize] AS [SPos]
        END_IF

        CALC [WorkMask!FontCharSet] AS PART([Str1],3,'|')
        CALC [WorkMask!FontColor]   AS PART([Str1],4,'|')

        CALC [Str2] AS PART([Str1],5,'|')
        CALC [SPos] AS VAL([Str2])
        IF [SPos]>0
          CALC [WorkMask!FontOpts] AS [SPos]
        END_IF

        MASK_UPDATE [WorkMask]
      END_IF
    END_IF
  END_PROC


  PROCEDURE IsReadyHook
    CALC [WorkMask!MASK_HOOK_IS_READY]  AS ''

    CALL AfterLoad

    IF [BarCodePreFix]<>''
      IF [DefaultBarCodeText1]<>''
        CALC [DefaultBarCodeText1]   AS CON([BarCodePreFix],[DefaultBarCodeText1])
        CALC [WorkMask!BarCodeText1] AS [DefaultBarCodeText1]
      END_IF
    END_IF

    IF [RECORD_ID8]>[EPSILON]
      CALC [DefaultAnzahl]   AS [RECORD_ID8]
      CALC [WorkMask!Anzahl] AS [RECORD_ID8]
    END_IF

    LIST_STR_FIND [WorkMask!BarCodeType],[DefaultBarCodeType]
    LIST_STR_GET  [WorkMask!BarCodeType],[Str1]

    MASK_UPDATE [WorkMask]

    IF [RECORD_ID8]>[EPSILON]
      IF [RECORD_ID11]<=[EPSILON]
        CALL DoPrintOut [PRINT_OUT_DIRECT]
        MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
	    ELSE
	      CALL DoPrintOut [PRINT_OUT_PREVIEW]
	    END_IF
    END_IF
  END_PROC



  PROCEDURE PreSaveHook
    CALL WriteUserSpecificValues
    CALL WriteLabelSpecificValues
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC




  PROCEDURE ExitHook
    CALL WriteUserSpecificValues
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main

  IF [RECORD_ID10]<=[EPSILON]
    IF [VpeVersion]='2'
      CALL PrintOut.GetSet 'STD', [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT], 'Standard-Drucker festlegen'
    END_IF
  END_IF
SCRIPT_END
