
  INCLUDE PrintOut.inc
  INCLUDE adrkopf.inc


  PROCEDURE InitVars
    VAR_BOOL  Res

    VAR_NUM   ListAct
    VAR_NUM   ListMax
    VAR_NUM   YNRes
    VAR_NUM   ActSpalte
    VAR_NUM   ActReihe
    VAR_NUM   LabelEndlos
    VAR_NUM   LabelSpalten
    VAR_NUM   LabelReihen
    VAR_NUM   LabelGesamt

    VAR_FLOAT RecID

    VAR_STR   Str1
    VAR_STR   CRLF
    VAR_STR   WaitInfo
    VAR_STR   DefaultLabelName, 'ADRESSEN_STANDARD'
    VAR_STR   EtikettKuerzel
    VAR_STR   VpeVersion, '2'

    CALC [ListAct] AS 1
    WHILE [ListAct]<8
      VAR_STR AnZ0[ListAct]
      INC [ListAct]
    END_WHILE

    IDENTIFIER_EXIST 'VPE_VERSION',[Res]
    IF [Res]
      CALC [VpeVersion] AS [VPE_VERSION]
    END_IF

    CALC [CRLF] AS CHAR(#13#10)
  END_PROC



  PROCEDURE SetPrinter VS LabelName
    LOCAL_NUM   LocBlattHoehe
    LOCAL_NUM   LocBlattBreite
    LOCAL_BOOL  LocRes
    LOCAL_STR   LocStr1
    LOCAL_STR   LocStr2
    LOCAL_STR   LocStr3

    IF [LabelName]=''
      EXIT_PROC
    END_IF

    IDENTIFIER_EXIST 'Prn',[LocRes]
    IF [LocRes]
      IDENTIFIER_DESTROY 'Prn',[LocRes]
    END_IF

    CALC [EtikettKuerzel] AS CON([LabelName],'_',[STATION_SHORT])

    IF [VpeVersion]='2'
      CALL PrintOut.GetSet [EtikettKuerzel], [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT], 'Label-Druck'
    END_IF

    CALC [LabelEndlos]    AS 0
    CALC [LabelSpalten]   AS 3
    CALC [LabelReihen]    AS 7
    CALC [LocBlattBreite] AS 2100
    CALC [LocBlattHoehe]  AS 2970

    CALC [ActSpalte]      AS 1
    CALC [ActReihe]       AS 1

    CALC [LocStr3] AS ''
    INI_READ [LocRes],[LocStr3],[SCRIPT_STRING],[CONFIG_FILE],[LabelName],'BarCodeLabel'
    IF [LocStr3]<>''
      CALC [LocStr2] AS PART([LocStr3],1,'|')
      CALC [LabelSpalten] AS VAL([LocStr2])
      IF [LabelSpalten]<=0
        CALC [LabelSpalten] AS 3
      END_IF

      CALC [LocStr2] AS PART([LocStr3],2,'|')
      CALC [LabelReihen] AS VAL([LocStr2])
      IF [LabelReihen]<=0
        CALC [LabelReihen] AS 7
      END_IF

      CALC [LocStr2] AS PART([LocStr3],5,'|')
      CALC [LocBlattBreite] AS VAL([LocStr2])
      IF [LocBlattBreite]<=0
        CALC [LocBlattBreite] AS 2100
      END_IF

      CALC [LocStr2] AS PART([LocStr3],5,'|')
      CALC [LocBlattHoehe] AS VAL([LocStr2])
      IF [LocBlattHoehe]<=0
        CALC [LocBlattHoehe] AS 2970
      END_IF

      CALC [LocStr2] AS PART([LocStr3],18,'|')
      CALC [LabelEndlos] AS VAL([LocStr2])
    END_IF

    GLOBAL_PRINT  Prn, [LocBlattBreite], [LocBlattHoehe]

    CALC [LabelGesamt] AS 0

    PRINT_CLR [Prn]
  END_PROC



  PROCEDURE PageFeed
    IF [LabelEndlos]=0
      INC [ActSpalte]
      IF [ActSpalte]>[LabelSpalten]
        CALC [ActSpalte] AS 1
        INC [ActReihe]
        IF [ActReihe]>[LabelReihen]
          CALC [ActReihe] AS 1
          PRINT_PAGE [Prn]
        END_IF
      END_IF
    ELSE
      IF [LabelSpalten]>1
        INC [ActSpalte]
        IF [ActSpalte]>[LabelSpalten]
          CALC [ActSpalte] AS 1
          PRINT_PAGE [Prn]
        END_IF
      ELSE
        PRINT_PAGE [Prn]
      END_IF
    END_IF

    INC [LabelGesamt]
  END_PROC



  PROCEDURE Main
    LIST_ITEM_GET [GlobSelectionList],[ListAct],[ListMax]
    IF [ListMax]=0
      MESSAGE 'Achtung Abbruch','Es wurden keine Adressen gefunden',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    CALC [Str1] AS CON('Es wurden '[ListMax],' Adressen ausgewhlt.|Mchten Sie diese Label jetzt drucken?')
    CALC [YNRes]  AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!',[Str1],[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    CALL SetPrinter [DefaultLabelName]

    CALC [WaitInfo] AS CON('Die Label fr ',[ListMax],' Adressen werden erzeugt')
    WAIT_INFO 'Bitte warten...', [WaitInfo], FALSE, 65, 2

    CALC [ListAct] AS 1
    WHILE [ListAct]<=[ListMax]
      LIST_STR_GET [GlobSelectionList],[Str1],[ListAct]
      CALC [RecID] AS VAL([Str1])
      IF [RecID]>[EPSILON]
        CALC [WaitInfo] AS CON('Die Label fr ',[ListMax],' Adressen werden erzeugt',[CRLF],'Adressen erledigt = ',[ListAct])
        WAIT_INFO 'Bitte warten...', [WaitInfo], FALSE, 65, 2

        CALL CalcAdr [RecID], 'ADRESSEN', '-N1--N2--Z1--Z2--PS-+LPO', [AnZ01], [AnZ02], [AnZ03], [AnZ04], [AnZ05], [AnZ06], [AnZ07]

        SCRIPT 'PrintBarCodes.csh', [DefaultLabelName], '', '', [AnZ01], [AnZ02], [AnZ03], [AnZ04], 1, 'adressen', 1, 0, [AnZ05], [AnZ06], [AnZ07], ''

        CALL PageFeed
      END_IF

      INC [ListAct]
    END_WHILE

    END_WAIT

    CALC [YNRes] AS [ID_YES]
    GET_YES_NO 'Ist der Drucker bereit?','Sollen die Label nun ausgedruckt werden?',[YNRes]

    IF [YNRes]=[ID_YES]
      IF [VpeVersion]='2'
        CALL PrintOut.Direct 'Prn', 1, [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT]
      ELSE
        CALL PrintOut.OutPut 'Prn', 1, [EtikettKuerzel], [PRINT_OUT_PREVIEW], [PRINT_OUT_PREVIEW]
      END_IF
    END_IF

    IF [VpeVersion]='2'
      CALL PrintOut.GetSet 'STD', [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT], 'Standard-Drucker festlegen'
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

