  INCLUDE PrintOut.inc


  PROCEDURE InitVars
    VAR_BOOL    Res
    VAR_QUERY   Q
    VAR_BROWSER B
    VAR_STR     Str1
    VAR_STR     Str2
    VAR_STR     StationShortLowcase
    VAR_STR     LastFName
    VAR_NUM     Num1
    VAR_NUM     ListeNummer
    VAR_FLOAT   SelID
    VAR_FLOAT   NewID
    VAR_NUM     LnAct
    VAR_NUM     LnCnt
    VAR_NUM     SortIdx
    VAR_NUM     YNRes

    VAR_LIST    FList

    CALC [Str1] AS CON('$',[STATION_SHORT])
    CALC [Num1] AS VAL([Str1])
    CALC [Str1] AS CON('8888',[Num1])
    CALC [ListeNummer] AS VAL([Str1])
    CALC [StationShortLowcase] AS LOWCASE([STATION_SHORT])

    CALL PrintOut.CheckAndSetPrinterCfgPath
  END_PROC


  PROCEDURE DeletePrintSet VS DPS.Setting
    CALC [Str1] AS CON([GlobTempPath],[STATION_SHORT],[DPS.Setting],'*.pst*')

    LIST_CLR  [FList]
    FILE_LIST [FList], [Str1], [GlobTempPath], FALSE
    LIST_ITEM_GET [FList],[LnAct],[LnCnt]
    IF [LnCnt]>0
      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [FList],[Str1],[LnAct]
        IF [Str1]<>''
          CALC [Str1] AS CON([GlobTempPath],[Str1])
          FILE_DELETE [Res], [Str1]
          IF [Res]=FALSE
            CALC [Str1] AS CON('Die Datei "',[Str1],'" konnte nicht gelscht werden.')
            MESSAGE 'Achtung Fehler',[Str1],[MESSAGE_ERROR]
          END_IF
        END_IF
        INC [LnAct]
      END_WHILE
    END_IF
  END_PROC


  PROCEDURE DelList
    QUERY [Q]
      DELETE FROM choicer WHERE ListeNummer = [ListeNummer]
    END_QUERY
    EXECUTE [Q],[Res]
  END_PROC


  PROCEDURE IncPrnList VS IPL.Bez
    NEW_RECORD [Res],'choicer',[NewID]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Liste der Druckeinstellungen konnte erweietert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY [Q]
      UPDATE choicer
         SET ListeNummer =  [ListeNummer],
             Sortierung  =  [SortIdx],
             Auswahl     = "[IPL.Bez]"
       WHERE RecordID    =  [NewID|R0,0]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Ein neuer Eintrag in die Liste der Druckeinstellungen konnte nicht gendert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF
  END_PROC


  PROCEDURE Main
    CALC [SortIdx] AS 0
    CALL IncPrnList 'Druck-Einstellungen'
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LIST_CLR  [FList]
    CALC [Str1] AS CON([STATION_SHORT],'*.pst*')
    FILE_LIST [FList], [Str1], [GlobTempPath], FALSE
    LIST_ITEM_GET [FList],[LnAct],[LnCnt]
    IF [LnCnt]>0
      LIST_SORT [FList]

      CALC [LastFName] AS ''
      CALC [LnAct]     AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [FList],[Str1],[LnAct]
        IF [Str1]<>''
          FILE_EXT [Str2], [Str1]
          CALC [Str1] AS PART([Str1],1,[Str2])
          CALC [Str1] AS REPLACE([Str1],[StationShortLowcase],'')
          CALC [Str1] AS TRIM([Str1])
          IF [Str1]<>''
            IF [Str1]<>[LastFName]
              INC [SortIdx]
              CALL IncPrnList [Str1]
              IF [Res]=FALSE
                EXIT_PROC
              END_IF
            END_IF
          END_IF

          CALC [LastFName] AS [Str1]
        END_IF
        INC [LnAct]
      END_WHILE
    END_IF

    QUERY [B]
      SELECT [W20 N "Krzel"]Auswahl, RecordID
        FROM choicer
       WHERE Listenummer = [Listenummer]
         AND Sortierung  > 0
    END_QUERY

    FLAG_SET [B!VIEW_FLAG], [BROWSER_FLAG_SELECT_ALLOWED], TRUE
    VIEW [B],[Res],'Druck-Einstellungen'
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY_LIST_COUNT [B],[Num1]
    IF [Num1]>0
      CALC [Str1] AS CON('Mchten Sie nun insgesamt ',[Num1],' Druck-Einstellungen dieser Station lschen?')
      CALC [YNRes] AS [ID_NO]
      GET_YES_NO 'Achtung! Sind Sie sicher?!',[Str1],[YNRes]
      IF [YNRes]<>[ID_YES]
        EXIT_PROC
      END_IF

      QUERY_LIST_FIRST [B],[SelID]
      WHILE [SelID]>[EPSILON]
         QUERY [Q]
           SELECT Auswahl FROM choicer WHERE RecordID = [SelID|R0,0]
         END_QUERY
         EXECUTE [Q],[Res]
         IF [Res]
           GET_DATA [Q],[Res]
           IF [Res]
             CALL DeletePrintSet [Q!Auswahl]
           END_IF
         END_IF

        QUERY_LIST_NEXT [B],[SelID]
      END_WHILE
    ELSE
      CALC [YNRes] AS [ID_NO]
      CALC [Str1] AS CON('Mchten Sie nun die Druck-Einstellung "',[B!Auswahl],'" dieser Station lschen?')
      GET_YES_NO 'Achtung! Sind Sie sicher?!',[Str1],[YNRes]
      IF [YNRes]<>[ID_YES]
        EXIT_PROC
      END_IF

      CALL DeletePrintSet [B!Auswahl]
    END_IF
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL DelList
  CALL Main
  CALL DelList
SCRIPT_END
