    ;   exportiert : PROCEDURE PrintOut.OutPut VS PrintOut.PrintVar,          Name der Druck-Job-Variablen
    ;                                          VN PrintOut.Copies,            Anzahl der gewnschten Kopien
    ;                                          VS PrintOut.CFGFileName,       Max. vier Buchstaben zum identifizieren des Druck-Jobs
    ;                                          VN PrintOut.DefaultMode,       IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                          VN PrintOut.ActualMode         User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])
    ;
    ;                Uses VPE-Dialog, loads the dialog if needed
    ;
    ;
    ;
    ;
    ;                PROCEDURE PrintOut.GetSet VS PrintOut.CFGFileName,       Max. vier Buchstaben zum identifizieren des Druck-Jobs
    ;                                          VN PrintOut.DefaultMode,       IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                          VN PrintOut.ActualMode         User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])
    ;
    ;                Uses CARA-Dialog, loads the dialog if needed (uses this BEFORE) the VAR_PRINT is allocated
    ;
    ;
    ;
    ;
    ;                PROCEDURE PrintOut.Direct VS PrintOut.PrintVar,          Name der Druck-Job-Variablen
    ;                                          VN PrintOut.Copies,            Anzahl der gewnschten Kopien
    ;                                          VN PrintOut.DefaultMode,       IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                          VN PrintOut.ActualMode         User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])
    ;
    ;                Directly prints aout to the standrad printer or shows the document
    ;
    ;


  PROCEDURE PrintOut.CheckAndSetPrinterCfgPath
    LOCAL_BOOL LocRes
    LOCAL_STR  LocPath2Use

;   CALC [LocPath2Use] AS 'c:\temp\'
;   CALC [LocPath2Use] AS [TEMP_FILES_PATH]
    CALC [LocPath2Use] AS [PRINTSET_PATH]

    IDENTIFIER_EXIST 'GlobTempPath',[LocRes]
    IF [LocRes]
      CALC [GlobTempPath] AS [LocPath2Use]
    ELSE
      GLOBAL_STR GlobTempPath, [LocPath2Use]
    END_IF

    EXIST_DIR [GlobTempPath],[LocRes]
    IF [LocRes]=FALSE
      FORCE_DIR [LocRes],[GlobTempPath]
    END_IF
  END_PROC


  PROCEDURE PrintOut.OutPut VS PrintOut.PrintVar, VN PrintOut.Copies, VS PrintOut.CFGFileName, VN PrintOut.DefaultMode, VF PrintOut.ActualMode, VS PrintOut.SetupMsg, VN PrintOut.CopyStart, VS PrintOut.CopyInfo
    CALL PrintOut.CheckAndSetPrinterCfgPath

    LOCAL_NUM   PrintOut.Mode
    LOCAL_NUM   PrintOut.TmpNum
    LOCAL_BOOL  PrintOut.Res
    LOCAL_STR   PrintOut.TmpStr
    LOCAL_NUM   PrintOut.XPos
    LOCAL_NUM   PrintOut.YPos
    LOCAL_STR   PrintOut.EmbFlags

    CALC [PrintOut.Mode] AS [PrintOut.DefaultMode]
    IF [PrintOut.ActualMode]>[EPSILON]
      CALC [PrintOut.Mode] AS [PrintOut.ActualMode]
    END_IF


    CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'.pst')
    IF [PrintOut.Mode]>[SEND_OUT_CHAT]
      IF [PrintOut.Mode]=[SEND_OUT_FAX]
        CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'_FAX.pst')
      ELSE_IF [PrintOut.Mode]=[SEND_OUT_EMAIL]
        CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'_EMAIL.pst')
      END_IF
    END_IF
    CALC [PrintOut.CFGFileName] AS LOWCASE([PrintOut.CFGFileName])

    IF [PrintOut.Mode]=[PRINT_OUT_DIRECT]
      IF [PrintOut.SetupMsg]<>''
        EXIST_FILE [PrintOut.CFGFileName],[PrintOut.Res]
        IF [PrintOut.Res]=FALSE
          WAIT_INFO 'Druckerausgabe-Konfiguration', [PrintOut.SetupMsg]
       END_IF
      END_IF

      PRINT_SET [[PrintOut.PrintVar]], [PrintOut.CFGFileName], FALSE
    ELSE_IF [PrintOut.Mode]=[PRINT_OUT_DIRECT_SETUP]
      EXIST_FILE [PrintOut.CFGFileName],[PrintOut.Res]
      IF [PrintOut.Res]
        FILE_DELETE [PrintOut.Res], [PrintOut.CFGFileName]
      END_IF

      IF [PrintOut.SetupMsg]<>''
        WAIT_INFO 'Druckerausgabe-Konfiguration', [PrintOut.SetupMsg]
      END_IF
      PRINT_SET [[PrintOut.PrintVar]], [PrintOut.CFGFileName], TRUE
    END_IF

    IF [PrintOut.MsgStr]<>''
      END_WAIT
    END_IF

    PROCESS_MESSAGES

    IF [PrintOut.Mode]<>[PRINT_OUT_PREVIEW]
      IF [PrintOut.Copies]<=0
        CALC [PrintOut.Copies] AS 1
      END_IF

      CALC [PrintOut.TmpNum] AS 1
      WHILE [PrintOut.TmpNum]<=[PrintOut.Copies]
        IF [PrintOut.CopyStart]>0
          IF [PrintOut.TmpNum]=[PrintOut.CopyStart]
            IF [PrintOut.CopyInfo]<>''
              PRINT_PAGE [[PrintOut.PrintVar]], 1
              CALC [PrintOut.TmpStr]   AS PART([PrintOut.CopyInfo],1,'|')
              CALC [PrintOut.XPos]     AS VAL ([PrintOut.TmpStr])
              CALC [PrintOut.TmpStr]   AS PART([PrintOut.CopyInfo],2,'|')
              CALC [PrintOut.YPos]     AS VAL ([PrintOut.TmpStr])
              CALC [PrintOut.EmbFlags] AS PART([PrintOut.CopyInfo],3,'|')
              CALC [PrintOut.TmpStr]   AS PART([PrintOut.CopyInfo],4,'|')
              IF [PrintOut.XPos]<>0
                IF [PrintOut.YPos]<>0
                  IF [PrintOut.TmpStr]<>''
                    PRINT_STR [[PrintOut.PrintVar]], [PrintOut.XPos], [PrintOut.YPos], [PrintOut.EmbFlags], [PrintOut.TmpStr]
                  END_IF
                END_IF
              END_IF
            END_IF
          END_IF
        END_IF

        PRINT_OUT [[PrintOut.PrintVar]], [PRINT_OUT_DIRECT]
        INC [PrintOut.TmpNum]
      END_WHILE
    ELSE
      PRINT_OUT [[PrintOut.PrintVar]], [PRINT_OUT_PREVIEW]
    END_IF
  END_PROC



  PROCEDURE PrintOut.GetSet VS PrintOut.CFGFileName, VN PrintOut.DefaultMode, VF PrintOut.ActualMode, VS PrintOut.SetupMessage, VB PrintOut.HideMessages
    CALL PrintOut.CheckAndSetPrinterCfgPath

    LOCAL_NUM   PrintOut.Mode
    LOCAL_NUM   PrintOut.TmpNum
    LOCAL_NUM   PrintOut.Dummy
    LOCAL_BOOL  PrintOut.Res
    LOCAL_STR   PrintOut.Str
    LOCAL_STR   PrintOut.TmpStr

    CALC [PrintOut.Mode] AS [PrintOut.DefaultMode]
    IF [PrintOut.ActualMode]>[EPSILON]
      CALC [PrintOut.Mode] AS [PrintOut.ActualMode]
    END_IF

    IF [PrintOut.Mode]=[PRINT_OUT_PREVIEW]
      EXIT_PROC
    END_IF

    IF [PrintOut.Mode]>[SEND_OUT_CHAT]
      CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'_',[PrintOut.Mode],'.pst')
      CALC [PrintOut.CFGFileName] AS LOWCASE([PrintOut.CFGFileName])

      CALC [PrintOut.TmpStr]      AS CON([PrintOut.CFGFileName],'d')
      EXIST_FILE [PrintOut.TmpStr],[PrintOut.Res]
      IF [PrintOut.Res]
        CALC [PrintOut.Mode] AS [PRINT_OUT_DIRECT]
      ELSE
        CALC [PrintOut.Mode] AS [PRINT_OUT_DIRECT_SETUP]
      END_IF
    ELSE
      CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'.pst')
    END_IF

    CALC [PrintOut.CFGFileName] AS LOWCASE([PrintOut.CFGFileName])

    IF [PrintOut.HideMessages]=FALSE
      WAIT_INFO 'Druckerausgabe fr', [PrintOut.SetupMessage]
    END_IF

    IF [PrintOut.Mode]=[PRINT_OUT_DIRECT]
      PRINT_SET [PrintOut.Dummy], [PrintOut.CFGFileName], 1, TRUE
    ELSE_IF [PrintOut.Mode]=[PRINT_OUT_DIRECT_SETUP]
      IF [PrintOut.CFGFileName]<>''
        EXIST_FILE [PrintOut.CFGFileName],[PrintOut.Res]
        IF [PrintOut.Res]
          FILE_DELETE [PrintOut.Res], [PrintOut.CFGFileName]
        END_IF

        CALC [PrintOut.Str] AS CON([PrintOut.CFGFileName],'d')
        EXIST_FILE [PrintOut.Str],[PrintOut.Res]
        IF [PrintOut.Res]
          FILE_DELETE [PrintOut.Res], [PrintOut.Str]
        END_IF

        CALC [PrintOut.Str] AS CON([PrintOut.CFGFileName],'s')
        EXIST_FILE [PrintOut.Str],[PrintOut.Res]
        IF [PrintOut.Res]
          FILE_DELETE [PrintOut.Res], [PrintOut.Str]
        END_IF

        PROCESS_MESSAGES
      END_IF

      PRINT_SET [PrintOut.Dummy], [PrintOut.CFGFileName], 2, TRUE
    END_IF

    END_WAIT

    PROCESS_MESSAGES
  END_PROC


  PROCEDURE PrintOut.Direct VS PrintOut.PrintVar, VN PrintOut.Copies, VN PrintOut.DefaultMode, VF PrintOut.ActualMode, VN PrintOut.CopyStart, VS PrintOut.CopyInfo
    LOCAL_NUM   PrintOut.Mode
    LOCAL_NUM   PrintOut.TmpNum
    LOCAL_STR   PrintOut.TmpStr
    LOCAL_NUM   PrintOut.XPos
    LOCAL_NUM   PrintOut.YPos
    LOCAL_STR   PrintOut.EmbFlags
    LOCAL_BOOL  PrintOut.Res

    CALC [PrintOut.Mode] AS [PrintOut.DefaultMode]
    IF [PrintOut.ActualMode]>[EPSILON]
      CALC [PrintOut.Mode] AS [PrintOut.ActualMode]
    END_IF

    IF [PrintOut.Mode]<>[PRINT_OUT_PREVIEW]
      IF [PrintOut.Copies]<=0
        CALC [PrintOut.Copies] AS 1
      END_IF

      CALC [PrintOut.TmpNum] AS 1
      WHILE [PrintOut.TmpNum]<=[PrintOut.Copies]
        IF [PrintOut.CopyStart]>0
          IF [PrintOut.TmpNum]=[PrintOut.CopyStart]
            IF [PrintOut.CopyInfo]<>''
              PRINT_PAGE [[PrintOut.PrintVar]], 1
              CALC [PrintOut.TmpStr]   AS PART([PrintOut.CopyInfo],1,'|')
              CALC [PrintOut.XPos]     AS  VAL([PrintOut.TmpStr])
              CALC [PrintOut.TmpStr]   AS PART([PrintOut.CopyInfo],2,'|')
              CALC [PrintOut.YPos]     AS  VAL([PrintOut.TmpStr])
              CALC [PrintOut.EmbFlags] AS PART([PrintOut.CopyInfo],3,'|')
              CALC [PrintOut.TmpStr]   AS PART([PrintOut.CopyInfo],4,'|')
              IF [PrintOut.XPos]<>0
                IF [PrintOut.YPos]<>0
                  IF [PrintOut.TmpStr]<>''
                    PRINT_STR [[PrintOut.PrintVar]], [PrintOut.XPos], [PrintOut.YPos], [PrintOut.EmbFlags], [PrintOut.TmpStr]
                  END_IF
                END_IF
              END_IF
            END_IF
          END_IF
        END_IF

        PRINT_OUT [[PrintOut.PrintVar]], [PRINT_OUT_DIRECT]
        INC [PrintOut.TmpNum]
      END_WHILE
    ELSE
      PRINT_OUT [[PrintOut.PrintVar]], [PRINT_OUT_PREVIEW]
    END_IF
  END_PROC



  PROCEDURE PrintOut.eDocPrintPro VS PrintOut.PrintVar, VN PrintOut.Copies, VB PrintOut.ShowMessages, ~VS PrintOut.eDocPrintProFileName
    LOCAL_STR   PrintOut.FileName
    LOCAL_BOOL  PrintOut.Res

    CALC [PrintOut.eDocPrintProFileName] AS ''

    CALC [PrintOut.FileName] AS CON([CARA_PATH],'eDocPrintProSniffer.exe')
    EXIST_FILE [PrintOut.FileName],[PrintOut.Res]
    IF [PrintOut.Res]=FALSE
      IF [PrintOut.ShowMessages]
        MESSAGE 'Achtung Abbruch','Der "eDocPrintProSniffer" ist nicht installiert.|Das Programm befindet sich nicht im CARA-Verzeichnis!',[MESSAGE_ERROR]
      END_IF
      EXIT_PROC
    END_IF

    LOCAL_STR   PrintOut.Str1
    LOCAL_STR   PrintOut.Str2
    LOCAL_NUM   PrintOut.Cnt
    LOCAL_NUM   PrintOut.Max
    LOCAL_NUM   PrintOut.Ln
    LOCAL_STR   PrintOut.Line
    LOCAL_FLOAT PrintOut.ID
    LOCAL_LIST  PrintOut.Lst

    ACT_REC_ID [PrintOut.ID]
    CALC [PrintOut.FileName] AS CON([PrintOut.FileName],' ',[PrintOut.ID|R0,0])
    EXTERN [PrintOut.FileName], [EXTERN_SHOWNORMAL]

    CALL PrintOut.Direct [PrintOut.PrintVar], [PrintOut.Copies], [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT]

    CALC [PrintOut.FileName] AS CON([TEMP_FILES_PATH],'eDocPrintProSniffer.log')
    CALC [PrintOut.Cnt] AS 0
    WHILE [PrintOut.Cnt]<=40
      EXIST_FILE [PrintOut.FileName],[PrintOut.Res]
      IF [PrintOut.Res]
        LIST_CLR [PrintOut.Lst]
        LIST_FILE_READ [PrintOut.Lst],[PrintOut.Res],[PrintOut.FileName]
        IF [PrintOut.Res]
          LIST_ITEM_GET [PrintOut.Lst],[PrintOut.Ln],[PrintOut.Max]
          IF [PrintOut.Max]>0
            LIST_STR_GET [PrintOut.Lst],[PrintOut.Line],[PrintOut.Max]
            ; 1    2    3       4       5        6    7
            ; date;time;message;printer;document;path;result;
            ; 2008-26-03;17:22:01;stop;eDocPrintPro;Cara;C:\tmp\eDocPrintProAusgabe.pdf;7849497885351;
            CALC [PrintOut.Str2] AS [PrintOut.ID|R0,0]
            CALC [PrintOut.Str1] AS PART([PrintOut.Line],7,';')

            IF [PrintOut.Str1]=[PrintOut.Str2]
              CALC [PrintOut.Line] AS PART([PrintOut.Line],6,';')
            END_IF

            EXIST_FILE [PrintOut.Line],[PrintOut.Res]
            IF [PrintOut.Res]
              CALC [PrintOut.Cnt] AS 100
              CALC [PrintOut.eDocPrintProFileName] AS [PrintOut.Line]
            END_IF
          END_IF
        END_IF
      ELSE
        DELAY 500
      END_IF
      INC [PrintOut.Cnt]
    END_WHILE

    EXIST_FILE [PrintOut.eDocPrintProFileName],[PrintOut.Res]
    IF [PrintOut.Res]=FALSE
      CALC [PrintOut.eDocPrintProFileName] AS ''
      IF [PrintOut.ShowMessages]
        MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht erzeugt oder gefunden werden',[MESSAGE_ERROR]
      END_IF
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE PrintOut.eDocPrintProWaiter VS PrintOut.PrintVar, VS PrintOut.FilePath, VS PrintOut.FileName, ~VB PrintOut.Result
    ; Diese Routine nutzt den eDocPrintPro zum Speichern einer PDF Datei in den User-Temp-Ordner mit dem Namen "eDocPrintPro.pdf"
    ; Dabei wird immer exakt der Dateiname "eDocPrintPro.pdf" zum Speichern verwendet.
    ; Dann wird die Datei auf Wunsch umbenannt                   : wenn FileName<>''
    ; Dann wird die Datei auf Wunsch in einen Zielordner kopiert : wenn FilePath<>''
    ;
    ; Die Einstellungen in den eDocPrintPro-Drucker-Eigenschaften mssen im Reiter "Ziel" wie folgt sein:
    ; Ziel Datei Type          = pdf
    ; Speicherungsmodus        = Speichern - ohne Dialog - mit voreingestelltem Ordner und Namen
    ; Ziel-Ordner              = %TEMP%
    ; Dateiname                = eDocPrintPro
    ; Ersetze bestehende Datei = Ersetze bestehende Datei
    ;
    ; Achtung: VS PrintOut.FileName: ist NUR der Dateiname, OHNE Dateipfad
    ;          VS PrintOut.FilePath: kann ein absoluter Pfad sein oder nur der Teil, der UNTERHALB vom DocumentPath gelten soll
    ;                                NUR wenn der Pfad gesetzt ist, wird die Datei auch kopiert, ansonsten bleibt sie im User-Temp-Ordner
    ;

    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocCnt
    LOCAL_NUM   LocMax
    LOCAL_STR   LocStr1
    LOCAL_STR   LocStr2
    LOCAL_STR   LocFlatTempFilesPath

    CALC [PrintOut.Result] AS FALSE

    CALC [LocFlatTempFilesPath] AS REVERSE_PART([TEMP_FILES_PATH],2,'\')
    CALC [LocMax] AS VAL([LocFlatTempFilesPath])
    IF [LocMax]>0
      CALC [LocFlatTempFilesPath] AS CON('\',[LocFlatTempFilesPath],'\')
      CALC [LocFlatTempFilesPath] AS REVERSE_PART([TEMP_FILES_PATH],2,[LocFlatTempFilesPath])
      FILE_SLASH [LocFlatTempFilesPath], TRUE
    ELSE
      CALC [LocFlatTempFilesPath] AS [TEMP_FILES_PATH]
    END_IF

    CALC [LocStr1] AS CON([LocFlatTempFilesPath],'eDocPrintPro.pdf')

    EXIST_FILE [LocStr1],[LocRes]
    IF [LocRes]
      FILE_DELETE [LocRes], [LocStr1]
      IF [LocRes]=FALSE
        MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht vorbereitet werden.',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF

    EXIST_FILE [PrintOut.FileName],[LocRes]
    IF [LocRes]
      FILE_DELETE [LocRes], [PrintOut.FileName]
      IF [LocRes]=FALSE
        MESSAGE 'Achtung Abbruch','Die Ziel-Datei konnte nicht vorbereitet werden.',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF

    CALL PrintOut.OutPut [PrintOut.PrintVar], 1, 'PDF', [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT], 'Bitte "eDocPrintPro" als Drucker auswhlen!'

    DELAY 3000

    CALC [LocCnt] AS 0
    CALC [LocMax] AS 20
    WHILE [LocCnt]<=[LocMax]
      INC [LocCnt]
      EXIST_FILE [LocStr1],[LocRes]
      IF [LocRes]
        CALC [LocCnt] AS [LocMax]+1
      ELSE
        DELAY 500
      END_IF
    END_WHILE

    IF [LocRes]=FALSE
      MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [LocCnt]  AS 0
    CALC [LocMax]  AS 40
    CALC [LocStr2] AS CON([LocFlatTempFilesPath],[PrintOut.FileName])
    WHILE [LocCnt]<=[LocMax]
      INC [LocCnt]
      FILE_RENAME [LocRes], [LocStr1], [LocStr2]
      IF [LocRes]
        CALC [LocCnt] AS [LocMax]+1
      ELSE
        DELAY 750
      END_IF
    END_WHILE

    IF [LocRes]=FALSE
      MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht umbenannt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    EXIST_FILE [LocStr2],[LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Achtung Abbruch','Die umbenannte PDF-Datei konnte nicht gefunden werden'
      EXIT_PROC
    END_IF

    ; Soll die Datei kopiert werden?
    IF [PrintOut.FilePath]<>''
      CALC [LocStr1] AS [PrintOut.FilePath]
      EXIST_DIR [LocStr1],[LocRes]
      IF [LocRes]=FALSE
        CALC [LocStr1] AS CON([DOCUMENT_PATH],[LocStr1])
        EXIST_DIR [LocStr1],[LocRes]
        IF [LocRes]=FALSE
          EXIT_PROC
        END_IF
      END_IF

      FILE_SLASH [LocStr1], TRUE
      CALC [LocStr1] AS CON([LocStr1],[PrintOut.FileName])

      CALC [LocCnt]  AS 0
      CALC [LocMax]  AS 40
      WHILE [LocCnt]<=[LocMax]
        INC [LocCnt]
        FILE_COPY [LocRes], [LocStr2], [LocStr1]
        IF [LocRes]
          CALC [LocCnt] AS [LocMax]+1
        ELSE
          DELAY 750
        END_IF
      END_WHILE
      IF [LocRes]=FALSE
        MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht kopiert werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

;     COPY_2_CLIPBOARD [LocStr1]

      CALC [LocCnt]  AS 0
      CALC [LocMax]  AS 40
      WHILE [LocCnt]<=[LocMax]
        INC [LocCnt]
        FILE_DELETE [LocRes], [LocStr2]
        IF [LocRes]
          CALC [LocCnt] AS [LocMax]+1
        ELSE
          DELAY 750
        END_IF
      END_WHILE
      IF [LocRes]=FALSE
        MESSAGE 'Achtung Abbruch','Die Quell-PDF-Datei konnte nicht gelscht werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF

    CALC [PrintOut.Result] AS TRUE
  END_PROC
