  ; Parameter RECORD_ID3 = aufrufende Maske [WorkMask!MASK_ACT_PRINT_MODE] oder [WorkMAsk!MASK_ACT_SEND_MODE]


  INCLUDE ActFax.inc
  INCLUDE AdrKopf.INC
  INCLUDE PrintOut.INC


  PROCEDURE InitVars
    ..
    ..
    ..

    ; Was man so braucht...
    VAR_BOOL  Res
    VAR_STR   Str1
    VAR_STR   Str2



    ; Wenn die Ausgabe an mehr als einen Drucker gehen soll (z.B. an verschiedenen Schchte etc.)
    VAR_NUM   AnzDrucker,      1

    ; Wir starten mit der Ausgabe an den ersten Drucker (wenn mehr als ein Drucker angesteuert werden sollten)
    VAR_NUM   AktDrucker,      1

    ; Wieviele Kopien sollen jeweils an den Drucker versendet werden. Dieser Wert wird wieter unten verndert.
    VAR_NUM   AnzahlKopien,    1

    ; Kuerzel fr den Dateinamen deises Ausdrucks z.B. "RG" bei Rechnungen
    VAR_STR   ShortPrintName, 'RG'

    ; Anzeige, wenn man diesen Drucker fr diesen Ausdruck das erste Mal einstellen soll. Z.B.: "Rechnungs-Drucker festlegen"
    VAR_STR   LongPrintName,  'Rechnungs-Drucker festlegen'

    ; Standard Druck-Ausgabe-Modus (wirklich nur fr das Drucken, nicht fr das Senden per Fax oder Email)
    ; Bei Rechnungen z.B. VAR_NUM StdPrintOutMode, [IP_PRINT_OUT_RG]
    VAR_NUM   StdPrintOutMode, [RECORD_ID3]

    ; Variablen fr den Act-Fax und Email-Versand
    VAR_STR   Actfax.Tmp1
    VAR_STR   Actfax.Tmp2
    VAR_STR   Actfax.Fax
    VAR_STR   Actfax.EMail
    VAR_STR   Actfax.Name
    VAR_STR   Actfax.PLZ
    VAR_STR   Actfax.Ort


    ; Wenn der Druck kein Sammeldruck ist... (also der Normalfall...)
    IDENTIFIER_EXIST 'Prn',[Res]
    IF [Res]=FALSE
      CALC [Str1] AS CON([ShortPrintName],[AktDrucker])
      CALC [Str2] AS CON([LongPrintName],' fr den ',[AktDrucker],'. Ausdruck')

      IF [RECORD_ID3]>[SEND_OUT_CHAT]
        CALL PrintOut.GetSet [Str1], [RECORD_ID3],      [RECORD_ID3], [Str2]
      ELSE_IF [RECORD_ID3]<>[PRINT_OUT_PREVIEW]
        CALL PrintOut.GetSet [Str1], [StdPrintOutMode], [RECORD_ID3], [Str2]
      END_IF

      VAR_PRINT Prn, 2100, 3100
    END_IF

    ..
    ..
    ..
  END_PROC


  ..
  ..
  ..


  PROCEDURE GetHeaderInfo ~VB GoOn
    CALC [GoOn] AS FALSE

    ; Beispiel fr Rechnungsdruck

    QUERY [HeadInfo]
      select R.Rechnungsnummer,
             ..
             ..
             ..

             A.PartnerID,
             R.RechKundeID,

             K.Fax1, K.Fax2, K.EMail1, K.Name1, K.PLZ, K.Ort,
             K.Kopien_KRG,

             ..
             ..
             ..

        from RECHNUNG R, AUFTRAG A, ADRESSEN K, WAEHRUNG W

       where (R.RecordID   = [RECORD_ID1|R0,0])
         and (R.AuftragID  = A.RecordID)
         and (A.KundenID   = K.RecordID)
         and (R.WaehrungID = W.RecordID)
    END_QUERY

    ..
    ..
    ..

    CALC [AnzahlKopien] AS [HeadInfo!K.Kopien_KRG]

    ; Zunchst einmal gehen Fax oder EMail an die Kundenadresse...
    CALC [Actfax.Fax]   AS [HeadInfo!K.Fax2]
    IF [Actfax.Fax]=''
      CALC [Actfax.Fax] AS [HeadInfo!K.Fax1]
    END_IF
    CALC [Actfax.EMail] AS [HeadInfo!K.EMail1]
    CALC [Actfax.Name]  AS [HeadInfo!K.Name1]
    CALC [Actfax.PLZ]   AS [HeadInfo!K.PLZ]
    CALC [Actfax.Ort]   AS [HeadInfo!K.Ort]


    ; Wurde ein Ansprechpartner bei dem Auftrag hinterlegt, dann sollen Fax oder EMail an diesen Ansprechpartner gehen
    IF [HeadInfo!A.PartnerID]>[EPSILON]
      CALL LoadRelationFields  [HeadInfo!A.PartnerID], 'ADRESSEN', 'Anrede|Name1|Name2|Fax1|EMail1|Plz|Ort|Fax2', [Actfax.Tmp1], ''
      IF [RECORD_ID3]=[SEND_OUT_EMAIL]
        CALC [Actfax.Tmp2] AS PART([Actfax.Tmp1], 5, '|')
        IF [Actfax.Tmp2]<>''
          CALC [Actfax.Fax]   AS PART([Actfax.Tmp1], 8, '|')
          IF [Actfax.Fax]=''
            CALC [Actfax.Fax] AS PART([Actfax.Tmp1], 4, '|')
          END_IF
          CALC [Actfax.EMail] AS PART([Actfax.Tmp1], 5, '|')
          CALC [Actfax.Name]  AS PART([Actfax.Tmp1], 2, '|')
          CALC [Actfax.PLZ]   AS PART([Actfax.Tmp1], 6, '|')
          CALC [Actfax.Ort]   AS PART([Actfax.Tmp1], 7, '|')
        END_IF
      ELSE_IF [RECORD_ID3]=[SEND_OUT_FAX]
        CALC [Actfax.Tmp2]     AS PART([Actfax.Tmp1], 8, '|')
        IF [Actfax.Tmp2]=''
          CALC [Actfax.Tmp2]   AS PART([Actfax.Tmp1], 4, '|')
        END_IF
        IF [Actfax.Tmp2]<>''
          CALC [Actfax.Fax]   AS PART([Actfax.Tmp1], 8, '|')
          IF [Actfax.Fax]=''
            CALC [Actfax.Fax] AS PART([Actfax.Tmp1], 4, '|')
          END_IF
          CALC [Actfax.EMail] AS PART([Actfax.Tmp1], 5, '|')
          CALC [Actfax.Name]  AS PART([Actfax.Tmp1], 2, '|')
          CALC [Actfax.PLZ]   AS PART([Actfax.Tmp1], 6, '|')
          CALC [Actfax.Ort]   AS PART([Actfax.Tmp1], 7, '|')
        END_IF
      END_IF
    END_IF


    ; Wurde eine Rechnungsadresse bei der Rechnung hinterlegt, dann sollen Fax oder EMail an diese Rechnungsadresse gehen
    IF [HeadInfo!R.RechKundeID]>[EPSILON]
      CALL LoadRelationFields  [HeadInfo!R.RechKundeID], 'ADRESSEN', 'Anrede|Name1|Name2|Fax1|EMail1|Plz|Ort|Fax2', [Actfax.Tmp1], ''
      IF [RECORD_ID3]=[SEND_OUT_EMAIL]
        CALC [Actfax.Tmp2] AS PART([Actfax.Tmp1], 5, '|')
        IF [Actfax.Tmp2]<>''
          CALC [Actfax.Fax]   AS PART([Actfax.Tmp1], 8, '|')
          IF [Actfax.Fax]=''
            CALC [Actfax.Fax] AS PART([Actfax.Tmp1], 4, '|')
          END_IF
          CALC [Actfax.EMail] AS PART([Actfax.Tmp1], 5, '|')
          CALC [Actfax.Name]  AS PART([Actfax.Tmp1], 2, '|')
          CALC [Actfax.PLZ]   AS PART([Actfax.Tmp1], 6, '|')
          CALC [Actfax.Ort]   AS PART([Actfax.Tmp1], 7, '|')
        END_IF
      ELSE_IF [RECORD_ID3]=[SEND_OUT_FAX]
        CALC [Actfax.Tmp2]     AS PART([Actfax.Tmp1], 8, '|')
        IF [Actfax.Tmp2]=''
          CALC [Actfax.Tmp2]   AS PART([Actfax.Tmp1], 4, '|')
        END_IF
        IF [Actfax.Tmp2]<>''
          CALC [Actfax.Fax]   AS PART([Actfax.Tmp1], 8, '|')
          IF [Actfax.Fax]=''
            CALC [Actfax.Fax] AS PART([Actfax.Tmp1], 4, '|')
          END_IF
          CALC [Actfax.EMail] AS PART([Actfax.Tmp1], 5, '|')
          CALC [Actfax.Name]  AS PART([Actfax.Tmp1], 2, '|')
          CALC [Actfax.PLZ]   AS PART([Actfax.Tmp1], 6, '|')
          CALC [Actfax.Ort]   AS PART([Actfax.Tmp1], 7, '|')
        END_IF
      END_IF
    END_IF

    ..
    ..
    ..

    CALC [GoOn] AS TRUE
  END_PROC





  ..
  ..
  ..





  PROCEDURE PrintIt
    WAIT_CURSOR TRUE
    CALL GetHeaderInfo [QRes]

    IF [QRes]=FALSE
      EXIT_PROC
    END_IF


    ; Wenn mehr als ein Drucker angesprochen werden soll, dann wird wieder an diese Stelle "zurck gesprungen"
    BACK_MARK


    ..
    ..
    ..


    IF [RECORD_ID3]>[SEND_OUT_CHAT]
      IF [RECORD_ID3]=[SEND_OUT_EMAIL]
        CALL ActFax.PrintAdresse 'Prn', 'EMAIL', 'Protokolleintrag fr das Fax oder die Email z.B. "Rechnung"', [HeadInfo!R.Rechnungsnummer], [Actfax.Fax], [Actfax.EMail], [Actfax.Name], [Actfax.PLZ], [Actfax.Ort]
      ELSE
        CALL ActFax.PrintAdresse 'Prn', 'FAX',   'Protokolleintrag fr das Fax oder die Email z.B. "Rechnung"', [HeadInfo!R.Rechnungsnummer], [Actfax.Fax], [Actfax.EMail], [Actfax.Name], [Actfax.PLZ], [Actfax.Ort]
      END_IF

      CALL PrintOut.Direct 'Prn', 1, [RECORD_ID3], [RECORD_ID3]
    ELSE
      CALL PrintOut.Direct 'Prn', [AnzahlKopien], [StdPrintOutMode], [RECORD_ID3]
    END_IF

    INC [AktDrucker]

    ;Soll noch eine Kopie auf einen anderen Drucker ausgegeben werden?
    IF [AktDrucker]<=[AnzahlDrucker]
      ; Druckervaribale wieder aus dem Speicher entfernen, Drucker erneut anmelden und danach die Druckervariable wieder neu anmelden.

      IDENTIFIER_DESTROY 'Prn', [Res]

      CALC [Str1] AS CON([ShortPrintName],[AktDrucker])
      CALC [Str2] AS CON([LongPrintName],' fr den ',[AktDrucker],'. Ausdruck')

      IF [RECORD_ID3]>[SEND_OUT_CHAT]
        CALL PrintOut.GetSet [Str1], [RECORD_ID3],      [RECORD_ID3], [Str2]
      ELSE_IF [RECORD_ID3]<>[PRINT_OUT_PREVIEW]
        CALL PrintOut.GetSet [Str1], [StdPrintOutMode], [RECORD_ID3], [Str2]
      END_IF

      VAR_PRINT Prn, 2100, 3100

      ; So ab noch oben und erneut (aber mit einem anderen Drucker) drucken...
      BACK_JUMP
    END_IF

    ; Den Standard-Drucker wieder setzten
    CALL PrintOut.GetSet 'STD', [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT], 'Standard-Drucker festlegen'
  END_PROC




SCRIPT_BEGIN
  CALL InitVars
  CALL PrintIt
SCRIPT_END
