  ; ***************************************************************************************
  ;
  ; Description : print out Rechnung using vpe
  ;
  ; History     : written by GH, 2003-10-15
  ;               Updates by ,
  ;
  ; Resources   : adrkopf.inc, routines.inc, printout.inc
  ;
  ; Called by   : aufstamm.csh (modus auftrag), printhook
  ;               stapeldruck auftragsbesttigung
  ;
  ; Hints       : RECORD_ID1 = RecordID from Auftrag
  ;               RECORD_ID2 = Einzeldruck ( = 0) oder Stapeldruck ( > 0)
  ;               RECORD_ID3 = ActualMode, for example direct, preview, setup
  ;               RECORD_ID4 = if Stapeldruck, Briefkopf drucken ja / nein
  ;               RECORD_ID5 > 0 heit, dass ein DPD-Aufkleber erzeugt werden soll
  ;               RECORD_ID6 > 0 heit, bei Stapeldruck auch an Proud senden
  ;               RECORD_ID7 > 0 heit, mit aktuellen Adressdaten versenden
  ;               RECORD_ID8 > 0 silent PDF Datei erzeugen, kein Versenden an Proud
  ;               PAR_STR9   = Unterverzeichnisname im Document-Ordner, wenn leer, dann Druck fr DMS
  ;
  ; ***************************************************************************************

  INCLUDE ActFax.inc

  INCLUDE adrkopf.inc
     ; Importiert PROCEDURE CalcAdr  VF AdressID, ...


  INCLUDE routines.inc
    ; importiert PROCEDURE RoundMoney ~VF RndVal

    ; importiert PROCEDURE LoadRelationFields  VF LocRelID,
    ;                                          VS LocTableName,
    ;                                          VS LocCompFld,
    ;                                         ~VS LocResFld,
    ;                                          VS LocInfo

    ; importiert PROCEDURE Dezimal2String VF R.LocFloat, VN R.LocCntNachkomma, ~VS R.LocStr

  INCLUDE houben.inc
    ; importiert PROCEDURE GetEntsorgungsPauschale ~VF LocEntsorgung
    ; importiert PROCEDURE GetCu VF LocMenge, VF LocArtBasisPreis, VF LocPosBasisPreis, VF LocArtGramm, ~VF LocCuPreis

  INCLUDE printout.inc
    ;   importiert PROCEDURE PrintOut.OutPut VS PrintOut.PrintVar,      Name der Druck-Job-Variablen
    ;                                        VN PrintOut.Copies,        Anzahl der gewnschten Kopien
    ;                                        VS PrintOut.CFGFileName,   Max. vier Buchstaben zum identifizieren des Druck-Jobs
    ;                                        VN PrintOut.DefaultMode,   IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                        VN PrintOut.ActualMode     User-Eingabe fr die Ausgabeart (z.B. [RECORD_ID2])


  INCLUDE prnform1.inc
    ;   importiert PROCEDURE BasisHeaderFooter VS PrVarName             Name der Druck-Job-Variablen


;Document-Managament-System +
  INCLUDE DmsRoutines.inc
;Document-Managament-System -



  PROCEDURE InitVars
;Document-Managament-System +
    CALL DmsXmlStartProcess
    CALL DmsXmlStartFile
;Document-Managament-System -

    VAR_STR   ANumStr
    VAR_NUM   ANumLen

    VAR_STR SchlussText
    CALC [SchlussText] AS 'bergabe der Ware ist keine Eigentumsbertragung. Das Eigentum geht erst durch Bezahlung ber.'
    CALC [SchlussText] AS CON([SchlussText],' Erfllungsort und Gerichtsstand ist Kln.')

    ; ######################################################################################
    ;
    ;                                 settings for layout
    ;
    ; ######################################################################################

    VAR_STR   FONT_STR,         'Arial'

    VAR_NUM   FONT_SIZE,            10

    VAR_NUM   Y_POS_ABSENDER,      510
      ; Start des Absenders
    VAR_NUM   X_POS_LEFT_MARGIN,   200
      ; linker Seitenrand

    VAR_NUM   X_POS_RIGHT_MARGIN, 2000
      ; rechter Seitenrand

    VAR_NUM   Y_POS_FOOTER,       2400
      ; maximale Y-Pos der letzten Position auf NICHT-letzter Seiten

    VAR_NUM   Y_POS_FOOTER_INFO,  2650
      ; StartPos des Footers auf letzter Seite

    VAR_NUM   Y_POS_REFERENZ,                    600
    VAR_NUM   X_REFERENZ_LABEL,                 1100
    VAR_NUM   X_REFERENZ_FIELD,                 1430
    VAR_NUM   X_REFERENZ_WIDTH,                 -600

    VAR_NUM   Y_POS_TITLE,                      1000

    VAR_NUM   Y_POS_ZUSATZADRESSE,              1100

    VAR_NUM   Y_POS_NEXT_PAGE,                   500

    VAR_NUM   Y_POS_POSITIONSKOPF,               -40

    VAR_NUM   ZEILEN_ABSTAND,                     37

    VAR_BOOL  REFERENZ_PRINT_USTID,             TRUE

    VAR_BOOL  PRINT_RECHNUNGS_KURZTEXT,        FALSE
      ; soll der Kurztext1 / 2 des Auftragskopfes in der Referenz gedruckt werden

    VAR_BOOL  PRINT_POS_NOTES_ALWAYS,          FALSE
      ; drucke Positions- und Artikelnotes 1/2 egal ob Kenner in POSTEN gesetzt ist

    VAR_BOOL  PRINT_UEBERTRAG,                  TRUE
    VAR_BOOL  PRINT_SACHNUMMER,                 TRUE

    VAR_NUM   PRINT_BRIEFKOPF,                  2
    ;         0 = BriefKopf nie drucken,
    ;         1 = BriefKopf auf Auftrag drucken (z.B. Fax oder normaler Druck)
    ;         2 = BriefKopf immer Drucken
    VAR_NUM   ANZAHL_NACHKOMMASTELLEN,          -2
    ;         Anzahl der Nachkommastellen, falls negativ wird selbst rausgefunden,
    ;         ob Nachkommastellen zu drucken sind



    ; ######################################################################################
    ;
    ;                                 internal use only
    ;
    ; ######################################################################################

    CONST_BOOL PRINT_NOTES_BOLD_NO,  FALSE
    CONST_BOOL PRINT_NOTES_BOLD_YES, TRUE

    CONST_NUM PRINT_BRIEFKOPF_NO,  0
    CONST_NUM PRINT_BRIEFKOPF_YES, 1

    CONST_NUM POS_TEXT1,          1
    CONST_NUM POS_TEXT2,          2
    CONST_NUM ART_TEXT1,          4
    CONST_NUM ART_TEXT2,          8
    CONST_NUM TITEL_TEXT,        16
    CONST_NUM ZWS_TEXT,          32
    CONST_NUM PAGE_FEED,         64

    VAR_BOOL  QRes
    VAR_BOOL  PrintHeadlineListYes, FALSE

    VAR_NUM   SLen
    VAR_STR   Str1

    VAR_NUM   Y
    VAR_NUM   YNRes
    VAR_NUM   SummenBlockHeight
    VAR_NUM   BedingungenBlockHeight
    VAR_NUM   SchlussTextBlockHeight

    VAR_NUM   PageNo
    VAR_NUM   NoteLnAct
    VAR_NUM   NoteLnCnt

    VAR_NUM   CntLS,      0
    VAR_NUM   CntAuftrag, 0

    VAR_FLOAT Uebertrag
    VAR_FLOAT ZwischenSumme
    VAR_FLOAT TmpFloat

    VAR_STR   PrnStr
    VAR_STR   TmpStr
    VAR_STR   StrSign
    VAR_STR   ProjektNr
    VAR_STR   IhreFaxNr
    VAR_STR   Vertreter
    VAR_STR   VersandArt
    VAR_STR   AnsprName1
    VAR_STR   AnsprName2
    VAR_STR   AnsprAnrede
    VAR_STR   LastLSNummer
    VAR_STR   LieferantenFax
    VAR_STR   ZahlBedStrEins
    VAR_STR   ZahlBedStrZwei
    VAR_STR   Lieferbedingung
    VAR_STR   Ansprechpartner

    VAR_STR   Referenz
    VAR_STR   Lieferdatum
    VAR_STR   Bestelldatum
    VAR_STR   Auftragsdatum
    VAR_STR   Bestellnummer
    VAR_STR   Auftragsnummer
    VAR_STR   KndAuftragsnummer
    VAR_STR   Lieferscheinnummer

    VAR_STR   Sachbearbeiter.Fax
    VAR_STR   Sachbearbeiter.Mail
    VAR_STR   Sachbearbeiter.Name
    VAR_STR   Sachbearbeiter.Telefon

    VAR_STR   Vertreter.Fax
    VAR_STR   Vertreter.Mail
    VAR_STR   Vertreter.Name
    VAR_STR   Vertreter.Telefon

    CALC [Y] AS 1
    WHILE [Y]<8
      ; Anschriften 1-7 fr Kunde bzw. Lieferanschrift
      VAR_STR   AnZ0[Y]
      VAR_STR   LaZ0[Y]
      VAR_STR   AgZ0[Y]
      INC [Y]
    END_WHILE

    VAR_QUERY PosList
    VAR_QUERY HeadInfo
    VAR_QUERY RechInfo

    VAR_NUM   PrintOutMode
    CALC [PrintOutMode] AS [RECORD_ID3]

    IF [RECORD_ID8]>[EPSILON]
      CALC [PrintOutMode] AS [PRINT_OUT_DIRECT]
    END_IF

    VAR_STR PrnVarName, 'RGPrn'

    IDENTIFIER_EXIST [PrnVarName],[QRes]
    IF [QRes]=FALSE
      VAR_PRINT RGPrn, 2100, 3100
    END_IF
    VAR_PRINT ScrPrn, 2100, 3100


    VAR_LIST  Note

    CALC [StrSign] AS CHAR(#39)

    VAR_BOOL Metallzuschlag, FALSE
    CALC [TmpStr] AS CON([SPECIAL_PATH],'ideal.cfg')
    INI_READ	[QRes], [Metallzuschlag],  [SCRIPT_BOOLEAN],  [TmpStr], 'METALL_ZUSCHLAG',  'Verkauf'
  END_PROC


  PROCEDURE MakeNumLen5 VS MNL5.NumStr
    CALC [ANumStr] AS [MNL5.NumStr]
;   CALC [ANumLen] AS LEN([ANumStr])
;   IF [ANumLen]=6
;     CALC [ANumStr] AS COPY([ANumStr],2,5)
;   END_IF
  END_PROC



  PROCEDURE LF ~VN ActY, VN Count
    IF [Count]=0
      CALC [Count] AS 1
    END_IF

    CALC [ActY] AS [ActY] + ([ZEILEN_ABSTAND] * [Count])
  END_PROC



  PROCEDURE InitFontSettings
    ; set the basic fonttype and size

    LOCAL_STR LocStr

    CALC [LocStr] AS CON('[PS 0 T ', [StrSign] , [FONT_STR], [StrSign], ' S ', [FONT_SIZE], ']')

    PRINT_STR  [[PrnVarName]], 200, 100, [LocStr]
  END_PROC



  PROCEDURE PrintAdresse
    CALL InitFontSettings

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ01]
    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ02]
    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

;    IF [Ansprechpartner]<>''
;      PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [Ansprechpartner]
;      CALL LF [Y], 1
;    END_IF

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ03]
    CALL LF [Y], 1

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ04]
    CALL LF [Y], 1

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ05]
    CALL LF [Y], 1

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ06]
    CALL LF [Y], 1

    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N J L B]', [AnZ07]
    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
  END_PROC



  PROCEDURE PrintReferenz
    LOCAL_NUM LocSaveYPos
    CALC [LocSaveYPos] AS [Y]

    ; Referenzblock auf rechter Seite

    LOCAL_NUM LocLabelWidth
    LOCAL_NUM LocSeparatorPos

    IF [Y_POS_REFERENZ]<0
      CALC [Y] AS [Y]-[Y_POS_REFERENZ]
    ELSE
      CALC [Y] AS [Y_POS_REFERENZ]
    END_IF

    ; wenn eine Box um die Referenz gewollt ist
    ; PRINT_BOX  [[PrnVarName]],  1100,  400, 2000,  800,             '[TO PS 2]'
    ; PRINT_LINE [[PrnVarName]],  1100,  600, 2000,  600,             '[TO PS 2]'

    PRINT_BOX  [[PrnVarName]],  1300,  [Y], 2000, [PRINT_POS_FREE], '[PS 0 T J L]', 'R E C H N U N G'
    CALL LF [Y],2

    PRINT_BOX  [[PrnVarName]],  1300,  [Y], 2000, [PRINT_POS_FREE], '[PS 0 T J L]', 'Bei Zahlung immer angeben'
    CALL LF [Y],2

    PRINT_LINE [[PrnVarName]],  1300, [Y], 2000, [Y]
    CALL LF [Y], 1

    PRINT_BOX  [[PrnVarName]],  1300,  [Y], 1500, [PRINT_POS_FREE], '[PS 0 T J L]', 'Datum'
    PRINT_BOX  [[PrnVarName]],  1500,  [Y], 1700, [PRINT_POS_FREE], '[PS 0 T J L]', 'KD-Nr'
    PRINT_BOX  [[PrnVarName]],  1700,  [Y], 1900, [PRINT_POS_FREE], '[PS 0 T J L]', 'RE-Nr'
    PRINT_BOX  [[PrnVarName]],  1850,  [Y], 2000, [PRINT_POS_FREE], '[PS 0 T J R]', 'Vertreter'
    CALL LF [Y], 2

    PRINT_BOX  [[PrnVarName]],  1300,  [Y], 1500, [PRINT_POS_FREE], '[PS 0 T J L]', [HeadInfo!R.Datum]
    PRINT_BOX  [[PrnVarName]],  1500,  [Y], 1700, [PRINT_POS_FREE], '[PS 0 T J L]', [HeadInfo!K.Kundennummer]

    CALL MakeNumLen5 [HeadInfo!R.Rechnungsnummer]
    IF [HeadInfo!R.Kurztext1]='STORNO'
      CALC [ANumStr] AS CON('STORNO ',[ANumStr])
    END_IF
    PRINT_BOX  [[PrnVarName]],  1700,  [Y], 1900, [PRINT_POS_FREE], '[PS 0 T J L]', [ANumStr]
    PRINT_BOX  [[PrnVarName]],  1850,  [Y], 2000, [PRINT_POS_FREE], '[PS 0 T J R]', [Vertreter]

    CALL LF [Y], 2
    PRINT_LINE [[PrnVarName]],  1300, [Y], 2000, [Y]

    IF [REFERENZ_PRINT_USTID]
      IF [HeadInfo!R.RechKundeID]>[EPSILON]
        CALC [PrnStr] AS CON([HeadInfo!K.UstIDNr],[RechInfo!UstIDNr])
      ELSE
        CALC [PrnStr] AS [HeadInfo!K.UstIDNr]
      END_IF
      CALC [PrnStr] AS TRIM([PrnStr])

      IF [PrnStr]<>''
        CALL LF [Y], 1
        PRINT_BOX  [[PrnVarName]],  1700,  [Y], 2000, [PRINT_POS_FREE], '[PS 0 T J L]', [HeadInfo!K.UstIDNr]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
        IF [HeadInfo!R.RechKundeID]>[EPSILON]
          IF [RechInfo!UstIDNr]<>''
            PRINT_BOX  [[PrnVarName]],  1700,  [Y], 2000, [PRINT_POS_FREE], '[PS 0 T J L]', [RechInfo!UstIDNr]
            PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
          END_IF
        END_IF
      END_IF
    END_IF


EXIT_PROC
    CALC [LocLabelWidth]   AS [X_REFERENZ_LABEL]-[X_REFERENZ_FIELD]-30
    CALC [LocSeparatorPos] AS [X_REFERENZ_FIELD]-20


    PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Datum'
    PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
    PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!R.Datum]
    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

    IF [HeadInfo!K.Kundennummer]<>''
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre Kunden-Nr.'
      PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!K.Kundennummer]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [CntAuftrag] = 1
      IF [Bestellnummer]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre Bestell.-Nr.'
        PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [Bestellnummer], ' vom ', [Bestelldatum]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    IF [CntAuftrag] = 1
      IF [Auftragsnummer]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre Auftrags-Nr.'
        PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [Auftragsnummer]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    IF [HeadInfo!R.Modus]< 1
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre Lieferschein'
      PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
      IF [CntLS] = 1
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]',[Lieferscheinnummer],' vom ', [Lieferdatum]]
      ELSE
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', 'Sammel-Lieferschein'
      END_IF
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [CntAuftrag] = 1
      IF [HeadInfo!A.Referenz]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre Referenz'
        PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!A.Referenz]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    IF [PRINT_RECHNUNGS_KURZTEXT]
      IF [HeadInfo!R.Kurztext1]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', [IP_VERKAUF_KURZTEXT1]
        PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!R.Kurztext1]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    IF [PRINT_RECHNUNGS_KURZTEXT]
      IF [HeadInfo!R.Kurztext2]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', [IP_VERKAUF_KURZTEXT2]
        PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!R.Kurztext2]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    CALC [Y] AS [Y]+20

    IF [Sachbearbeiter.Name]<>''
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Sachbearbeiter'
      PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [Sachbearbeiter.Name], ' ',[Sachbearbeiter.Telefon]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

      IF [Sachbearbeiter.Mail]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [Sachbearbeiter.Mail]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    IF [HeadInfo!K.LiefNummer]<>''
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Lieferanten-Nr.'
      PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!K.LiefNummer]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [IhreFaxNr]<>''
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre Fax-Nr.'
      PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [IhreFaxNr]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [REFERENZ_PRINT_USTID]
      IF [HeadInfo!R.RechKundeID]>[EPSILON]
        CALC [PrnStr] AS CON([HeadInfo!K.UstIDNr],[RechInfo!UstIDNr])
      ELSE
        CALC [PrnStr] AS [HeadInfo!K.UstIDNr]
      END_IF
      CALC [PrnStr] AS TRIM([PrnStr])

      IF [PrnStr]<>''
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Ihre USt.-Id.-Nr.'
        PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
        PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [HeadInfo!K.UstIDNr]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
        IF [HeadInfo!R.RechKundeID]>[EPSILON]
          IF [RechInfo!UstIDNr]<>''
            PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [RechInfo!UstIDNr]
            PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
          END_IF
        END_IF
      END_IF
    END_IF

    IF [ProjektNr]<>''
      CALC [Y] AS [Y]+20

      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_LABEL], [Y], [LocLabelWidth],    [PRINT_POS_FREE], '[J L]', 'Projekt'
      PRINT_BOX  [[PrnVarName]], [LocSeparatorPos],  [Y], -10,                [PRINT_POS_FREE], '[J L]', ': '
      PRINT_BOX  [[PrnVarName]], [X_REFERENZ_FIELD], [Y], [X_REFERENZ_WIDTH], [PRINT_POS_FREE], '[J L]', [ProjektNr]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocSaveYPos]>[Y]
      ; if Adress is longer then reference-block
      CALC [Y] AS [LocSaveYPos]
    END_IF
  END_PROC



  PROCEDURE TitleAndPageNo
    LOCAL_NUM LocSaveYPos
    CALC [LocSaveYPos] AS [Y]

    IF [Y_POS_TITLE]<0
      CALC [Y] AS [Y]-[Y_POS_TITLE]
    ELSE
      CALC [Y] AS [Y_POS_TITLE]
    END_IF

;    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], 2000, [PRINT_POS_FREE], '[N S 14 J L B]', 'RECHNUNG  ', [HeadInfo!R.Rechnungsnummer]
    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

    CALC [Y] AS [Y]+20

    IF [HeadInfo!R.Modus] = 1
      IF [HeadInfo!R.Buchungstext1] <> ''
        PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], 2000, [PRINT_POS_FREE], '[N S 14 J L B]', [HeadInfo!R.Buchungstext1]
      END_IF
    END_IF
    CALL InitFontSettings

    PRINT_BOX  [[PrnVarName]], 1800, [Y], 2000, [PRINT_POS_FREE], '[J R]', 'Seite ', [PageNo]

    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

    IF [LocSaveYPos]>[Y]
      ; if Adress is longer then reference-block
      CALC [Y] AS [LocSaveYPos]
    END_IF

    CALL LF [Y], 2
  END_PROC



  PROCEDURE Basis
    ; wird auf jeder Seite gedruckt und enthlt u. a. Header und Footer

    PRINT_STR [[PrnVarName]], 10, 10, '[PS 0] '

    IF [PRINT_BRIEFKOPF]<>[PRINT_BRIEFKOPF_NO]
      IF [RECORD_ID8]>[EPSILON]
        CALL BasisHeaderFooter [PrnVarName], TRUE
      ELSE
        CALL BasisHeaderFooter [PrnVarName]
      END_IF
    END_IF

    CALL InitFontSettings
  END_PROC



  PROCEDURE PrintZusatzAdressen
    LOCAL_NUM LocCnt, 2

    IF [Y_POS_ZUSATZADRESSE]<0
      CALC [Y] AS [Y]-[Y_POS_ZUSATZADRESSE]
    ELSE
      CALC [Y] AS [Y_POS_ZUSATZADRESSE]
    END_IF

    ; ursprnglich von DD von Hr. Houben gewnscht
    ; keinen Auftraggeber drucken, wenn es eine VSA gibt
    ; 20110208: von Frau Stolle:
    ; Leistungsempfnger fehlt auf Rechnungsdruck, wenn es VSA gibt
    ;IF [HeadInfo!R.VerKundeID]<=[EPSILON]
      IF [HeadInfo!R.RechKundeID]>[EPSILON]
        PRINT_BOX  [[PrnVarName]], 200, [Y], 530, [PRINT_POS_FREE], '[J L]', 'Auftraggeber'
        PRINT_BOX  [[PrnVarName]], 530, [Y], -10, [PRINT_POS_FREE], '[J L]', ':'

        CALC [PrnStr] AS [AgZ01]

        CALC [LocCnt] AS 2

        WHILE [LocCnt]<=6
          IF [AgZ0[LocCnt]]<>''
            IF [PrnStr]<>''
              CALC [PrnStr] AS CON([PrnStr],', ')
            END_IF
            CALC [PrnStr] AS CON([PrnStr],[AgZ0[LocCnt]])
          END_IF
          INC [LocCnt]
        END_WHILE

        PRINT_BOX [[PrnVarName]],  550, [Y], 2000, [PRINT_POS_FREE], '[J L]', [PrnStr]
        PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
      END_IF
    ;END_IF

    IF [HeadInfo!K.KFiBuKng]=2
      PRINT_BOX  [[PrnVarName]], 200, [Y], 2000, [PRINT_POS_FREE], '[N J L B]', 'Steuerfreie innergemeinschaftliche Lieferung'
      PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
      CALL LF [Y], 2
    END_IF

    IF [HeadInfo!R.VerKundeID]>[EPSILON]
      PRINT_BOX  [[PrnVarName]], 200, [Y], 530, [PRINT_POS_FREE], '[J L]', 'Versandadresse'
      PRINT_BOX  [[PrnVarName]], 530, [Y], -10, [PRINT_POS_FREE], '[J L]', ':'

      CALC [PrnStr] AS [LaZ01]

      CALC [LocCnt] AS 2

      WHILE [LocCnt]<=6
        IF [LaZ0[LocCnt]]<>''
          IF [PrnStr]<>''
            CALC [PrnStr] AS CON([PrnStr],', ')
          END_IF
          CALC [PrnStr] AS CON([PrnStr],[LaZ0[LocCnt]])
        END_IF
        INC [LocCnt]
      END_WHILE

      PRINT_BOX [[PrnVarName]],  550, [Y], 2000, [PRINT_POS_FREE], '[J L]', [PrnStr]
      PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
    END_IF

  END_PROC




  PROCEDURE PositionHeadLine
    LOCAL_NUM LocNum

    IF [PrintHeadlineListYes]=FALSE
      EXIT_PROC
    END_IF

    IF [Y_POS_POSITIONSKOPF]<0
      CALC [Y] AS [Y]-[Y_POS_POSITIONSKOPF]
    ELSE
      ; makes no sence to have positive values here
      CALC [Y] AS [Y]-40
    END_IF

    ; wenn man eine Box haben will, folgende Zeile einblenden, ansonsten werden Linien ausgedruckt
    ; und man muss die dann folgenden 3 Zeile einbauen

    CALC [Y] AS [Y]-10

    PRINT_BOX  [[PrnVarName]],  190, [Y],  2010, -60, '[N TO BC LtGray PC Black PS 0 J L]', ''

    ;PRINT_LINE [[PrnVarName]],  190, [Y], 2010, [Y]
    ;CALC [LocNum] AS [Y]+60
    ;PRINT_LINE [[PrnVarName]],  190, [LocNum], 2010, [LocNum]

    CALC [Y] AS [Y]+10

    PRINT_BOX  [[PrnVarName]],  200, [Y],  400, [PRINT_POS_FREE], '[N B J R]', 'Menge'
    PRINT_BOX  [[PrnVarName]],  450, [Y], 1400, [PRINT_POS_FREE], '[N B J L]', 'Artikel'
    PRINT_BOX  [[PrnVarName]], 1300, [Y], 1600, [PRINT_POS_FREE], '[N B J R]', 'Preis'
    PRINT_BOX  [[PrnVarName]], 1600, [Y], 1750, [PRINT_POS_FREE], '[N B J R]', 'Rabatt'
    PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[N B J R]', 'Betrag / ', [HeadInfo!W.Waehrung]

    CALL LF [Y], 2
  END_PROC



  PROCEDURE CheckAndDoUebertrag
    LOCAL_NUM LocNum

    CALC [LocNum] AS [Y_POS_FOOTER]-30
    IF [Y]<[LocNum]
      EXIT_PROC
    END_IF

    CALL LF [Y],1
    PRINT_LINE [[PrnVarName]], 200, [Y], 2000, [Y]
    CALC [Y] AS [Y]+20

    INC [PageNo]

    PRINT_BOX  [[PrnVarName]],  200, [Y], 2000, [PRINT_POS_FREE], '[J R]', 'Fortsetzung auf Seite ',[PageNo]

    PRINT_PAGE [[PrnVarName]]

    CALL Basis

    CALC [Y] AS [Y_POS_NEXT_PAGE]

    CALL MakeNumLen5 [HeadInfo!R.Rechnungsnummer]
    PRINT_BOX  [[PrnVarName]], [X_POS_LEFT_MARGIN], [Y], 2000, [PRINT_POS_FREE], '[J L]', 'Seite ', [PageNo], ' von Rechnung ', [ANumStr]

    IF [PRINT_UEBERTRAG]
      IF [PrintHeadlineListYes]
        PRINT_BOX  [[PrnVarName]], 1000, [Y], 2000, [PRINT_POS_FREE], '[J R]', 'bertrag ', [Uebertrag|X0,2]
      END_IF
    END_IF

    CALL LF [Y], 2

    CALL PositionHeadLine
  END_PROC




  PROCEDURE PrintOneNote VS NTabelle, VF NID, VN NType, VN NXPos, VN NBreite, VB LocPrintBoldYes
    LOCAL_NUM LocNBreite

    CALC [LocNBreite] AS [NBreite]*(-1)

    NOTE_READ [Note],[QRes],[NTabelle],[NType],[NID]
    IF [QRes]=FALSE
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [Note],[NoteLnAct],[NoteLnCnt]
    IF [NoteLnCnt]<=0
      EXIT_PROC
    END_IF

    CALC [NoteLnAct] AS 1
    WHILE [NoteLnAct]<=[NoteLnCnt]
      LIST_STR_GET [Note],[PrnStr],[NoteLnAct]
      IF [PrnStr]<>''
        IF [LocPrintBoldYes]
          PRINT_BOX [[PrnVarName]], [NXPos], [Y], [LocNBreite], [PRINT_POS_FREE], '[N J L B]', [PrnStr]
        ELSE
          PRINT_BOX [[PrnVarName]], [NXPos], [Y], [LocNBreite], [PRINT_POS_FREE], '[J L]', [PrnStr]
        END_IF

        PRINT_POS [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

        CALL CheckAndDoUebertrag
      END_IF
      INC [NoteLnAct]
    END_WHILE
  END_PROC



  PROCEDURE PrintSonderkosten
    CALC [PrintHeadlineListYes] AS TRUE

    CALC [Y] AS [Y]+100
    CALL CheckAndDoUebertrag
    IF [HeadInfo!R.BelegFracht] > [EPSILON]
      CALL LoadRelationFields  2,  'ARTIKEL',   'Bezeichnung1', [TmpStr],''

      PRINT_BOX  [[PrnVarName]],  600, [Y], -900, [PRINT_POS_FREE], '[J L]', [TmpStr]
      PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [HeadInfo!R.BelegFracht|X0,2]

      CALC [Uebertrag]     AS [Uebertrag]+[HeadInfo!R.BelegFracht]
      CALC [ZwischenSumme] AS [ZwischenSumme]+[HeadInfo!R.BelegFracht]

      CALL LF [Y], 1
      CALL CheckAndDoUebertrag
    END_IF

    IF [HeadInfo!R.BelegVerpackung] > [EPSILON]
      CALL LoadRelationFields  3,  'ARTIKEL',   'Bezeichnung1', [TmpStr],''

      PRINT_BOX  [[PrnVarName]],  600, [Y], -900, [PRINT_POS_FREE], '[J L]', [TmpStr]
      PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [HeadInfo!R.BelegVerpackung|X0,2]

      CALC [Uebertrag]     AS [Uebertrag]+[HeadInfo!R.BelegVerpackung]
      CALC [ZwischenSumme] AS [ZwischenSumme]+[HeadInfo!R.BelegVerpackung]

      CALL LF [Y], 1
      CALL CheckAndDoUebertrag
    END_IF

    IF [HeadInfo!R.Belegverrechnen] > [EPSILON]
      CALL LoadRelationFields  12,  'ARTIKEL',   'Bezeichnung1', [TmpStr],''

      PRINT_BOX  [[PrnVarName]],  600, [Y], -900, [PRINT_POS_FREE], '[J L]', [TmpStr]
      PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [HeadInfo!R.Belegverrechnen|X0,2]

      CALC [Uebertrag]     AS [Uebertrag]+[HeadInfo!R.Belegverrechnen]
      CALC [ZwischenSumme] AS [ZwischenSumme]+[HeadInfo!R.Belegverrechnen]

      CALL LF [Y], 1
      CALL CheckAndDoUebertrag
    END_IF

    IF [HeadInfo!R.Belegabgerechnet] > [EPSILON]
      CALL LoadRelationFields  10,  'ARTIKEL',   'Bezeichnung1', [TmpStr],''

      PRINT_BOX  [[PrnVarName]],  600, [Y], -900, [PRINT_POS_FREE], '[J L]', [TmpStr]
      PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [HeadInfo!R.Belegabgerechnet|X0,2]

      CALC [Uebertrag]     AS [Uebertrag]+[HeadInfo!R.Belegabgerechnet]
      CALC [ZwischenSumme] AS [ZwischenSumme]+[HeadInfo!R.Belegabgerechnet]

      CALL LF [Y], 1
      CALL CheckAndDoUebertrag
    END_IF

    CALL LF [Y], 2
    CALL CheckAndDoUebertrag

    CALC [PrintHeadlineListYes] AS FALSE
  END_PROC



  PROCEDURE PrintCU VF LocPosID
    LOCAL_BOOL  LocRes
    LOCAL_QUERY LocQ

    QUERY [LocQ]
      SELECT BelegGesamtPreis
        FROM POSTEN
       WHERE MotherID   = [LocPosID|R0,0]
         AND ArtikelID  = 21
    END_QUERY

    EXECUTE [LocQ],[LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Abbruch','Die Datenbank-Abfrage konnte nicht bersetzt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocRes]
    IF [LocRes]
      IF [LocQ!BelegGesamtPreis] > [EPSILON]
        CALL LoadRelationFields  21,  'ARTIKEL',   'Bezeichnung1', [TmpStr],''

        PRINT_BOX  [[PrnVarName]],  600, [Y], -900, [PRINT_POS_FREE], '[J L]', [TmpStr]
        PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [LocQ!BelegGesamtPreis|X0,2]

        CALC [Uebertrag]     AS [Uebertrag]+[LocQ!BelegGesamtPreis]
        CALC [ZwischenSumme] AS [ZwischenSumme]+[LocQ!BelegGesamtPreis]

        CALL LF [Y], 1
        CALL CheckAndDoUebertrag
      END_IF
    END_IF
  END_PROC



  PROCEDURE PrintKndArtikel VF LocArtikelID, VF LocKundenID
    IF [PRINT_SACHNUMMER] = FALSE
      EXIT_PROC
    END_IF

    LOCAL_QUERY LocQ
    LOCAL_BOOL  LocQRes

    QUERY [LocQ]
      SELECT ArtikelID, KundenID, Sachnummer
        FROM KUNDART
       WHERE ArtikelID = [LocArtikelID|R0,0]
         AND KundenID  = [LocKundenID|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    IF [LocQ!Sachnummer]=''
      EXIT_PROC
    END_IF

    PRINT_BOX  [[PrnVarName]],  600, [Y],  920, [PRINT_POS_FREE], '[J L]', 'Ihre Artikelnummer'
    PRINT_BOX  [[PrnVarName]],  930, [Y],  940, [PRINT_POS_FREE], '[J L]', ':'
    PRINT_BOX  [[PrnVarName]],  950, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Sachnummer]
    CALL LF [Y], 1
    CALL CheckAndDoUebertrag
  END_PROC



  PROCEDURE PrintEndSummen VN LocY, ~VN LocYSizeBox, VB PrintIt
    ; bei PrintIt = FALSE wird nur die Blockhhe gemessen, um den Block ans Ende zu bekommen

    LOCAL_BOOL  LocHaveSeparatorLines, FALSE
                  ; sollen Striche unter Mwst und Brutto gezeichnet werden

    LOCAL_NUM   LocNum
    LOCAL_FLOAT LocFloat
    LOCAL_NUM   LocStartY
    LOCAL_STR   LocStr
    LOCAL_STR   LocFormatStr

    CALC [LocStartY] AS [LocY]

    CALC [LocY] AS [LocY]+10

    CALC [LocNum] AS 1
    WHILE [LocNum]<=3
      CALC [LocFloat] AS ABS([HeadInfo!R.BelegNetto[LocNum]])
      IF [LocFloat]>[EPSILON]
        IF [PrintIt]
          PRINT_BOX  [[PrnVarName]], 1400, [LocY], 1550, [PRINT_POS_FREE], '[N B J L]', 'Netto '

          CALC [LocFloat] AS [HeadInfo!R.StSatz[LocNum]]
          CALL Dezimal2String [LocFloat], -2, [LocStr]
          PRINT_BOX  [[PrnVarName]], 1550, [LocY], 1650, [PRINT_POS_FREE], '[N B J R]', [LocStr], '%'
          PRINT_BOX  [[PrnVarName]], 1650, [LocY], 2000, [PRINT_POS_FREE], '[N B J R]', [HeadInfo!R.BelegNetto[LocNum]|X0,2], ' ', [HeadInfo!W.Waehrung]
        END_IF

        CALC [LocY] AS [LocY]+[ZEILEN_ABSTAND]+10
      END_IF

      INC [LocNum]
    END_WHILE

    IF [HeadInfo!R.MwstJa]
      IF [PrintIt]
        PRINT_BOX  [[PrnVarName]], 1400, [LocY], 1550, [PRINT_POS_FREE], '[N B J L]', 'Mwst '
        PRINT_BOX  [[PrnVarName]], 1650, [LocY], 2000, [PRINT_POS_FREE], '[N B J R]', [HeadInfo!R.BelegMwst|X0,2], ' ', [HeadInfo!W.Waehrung]
      END_IF

      CALC [LocY] AS [LocY]+[ZEILEN_ABSTAND]+10
    END_IF

    IF [LocHaveSeparatorLines]
      CALC [LocY] AS [LocY]+10

      IF [PrintIt]
        PRINT_LINE [[PrnVarName]], 1400, [LocY], 2000, [LocY]
      END_IF
    END_IF

    CALC [LocY] AS [LocY]+20

    IF [PrintIt]
      PRINT_BOX  [[PrnVarName]], 1400, [LocY], 1550, [PRINT_POS_FREE], '[N B J L]', 'Brutto '
      PRINT_BOX  [[PrnVarName]], 1650, [LocY], 2000, [PRINT_POS_FREE], '[N B J R]', [HeadInfo!R.BelegBrutto|X0,2], ' ', [HeadInfo!W.Waehrung]
    END_IF

    IF [LocHaveSeparatorLines]
      CALC [LocY] AS [LocY]+47

      IF [PrintIt]
        PRINT_LINE [[PrnVarName]], 1400, [LocY], 2000, [LocY]
        CALC [LocY] AS [LocY]+10
        PRINT_LINE [[PrnVarName]], 1400, [LocY], 2000, [LocY]
      ELSE
        CALC [LocY] AS [LocY]+10
      END_IF
    END_IF

    CALC [LocY] AS [LocY]+[ZEILEN_ABSTAND]+20

    CALC [LocYSizeBox] AS [LocY]-[LocStartY]
  END_PROC



  PROCEDURE PrintSchlussText VN LocY, ~VN LocYSizeBox, VB PrintIt
    LOCAL_NUM   LocStartY
    LOCAL_FLOAT LocFloat
    LOCAL_STR   LocStr
    LOCAL_STR   LocFormatStr2
    LOCAL_STR   LocFormatStr

    CALC [LocStartY] AS [LocY]

    IF [PrintIt]
      CALC [LocFormatStr2] AS '[J L]'
      CALC [LocFormatStr]  AS '[J R]'
    ELSE
      CALC [LocFormatStr2] AS '[N BC white C white J L]'
      CALC [LocFormatStr]  AS '[N BC white C white J L]'
    END_IF

    LOCAL_BOOL LocWerbung, FALSE
    IDENTIFIER_EXIST 'IP_WerbTxt01RG',[LocWerbung]
    IF [LocWerbung]
      CALC [LocWerbung] AS FALSE

      CALC [IP_WerbTxt01RG] AS TRIM([IP_WerbTxt01RG])
      CALC [IP_WerbTxt02RG] AS TRIM([IP_WerbTxt02RG])
      CALC [IP_WerbTxt03RG] AS TRIM([IP_WerbTxt03RG])
      CALC [IP_WerbTxt04RG] AS TRIM([IP_WerbTxt04RG])
      CALC [IP_WerbTxt05RG] AS TRIM([IP_WerbTxt05RG])

      IF [IP_WerbTxt01RG]<>''
        PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [IP_WerbTxt01RG]
        PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
        CALC [LocWerbung] AS TRUE
      END_IF

      IF [IP_WerbTxt02RG]<>''
        PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [IP_WerbTxt02RG]
        PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
        CALC [LocWerbung] AS TRUE
      END_IF

      IF [IP_WerbTxt03RG]<>''
        PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [IP_WerbTxt03RG]
        PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
        CALC [LocWerbung] AS TRUE
      END_IF

      IF [IP_WerbTxt04RG]<>''
        PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [IP_WerbTxt04RG]
        PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
        CALC [LocWerbung] AS TRUE
      END_IF

      IF [IP_WerbTxt05RG]<>''
        PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [IP_WerbTxt05RG]
        PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
        CALC [LocWerbung] AS TRUE
      END_IF

      IF [LocWerbung]
        CALC [LocY] AS [LocY]+([ZEILEN_ABSTAND]*2)
      END_IF
    END_IF

    LOCAL_BOOL   LocQRes
    LOCAL_QUERY  LocQ

    IF [HeadInfo!R.Modus] > 0
      QUERY [LocQ]
        SELECT Rechnungsnummer, Datum, Netto, Mwst, Brutto, Kurztext1, Kurztext2,Buchungstext2,
               AuftragID, RecordID
          FROM RECHNUNG
         WHERE AuftragID = [HeadInfo!A.RecordID|R0,0]
         ORDER BY Datum, Rechnungsnummer
      END_QUERY

      EXECUTE [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        PANEL_INFO ''
        WAIT_CURSOR FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LocQ],[LocQRes]

      CALC [LocY] AS [LocY]+20

      PRINT_BOX  [[PrnVarName]],  900, [LocY], 1200, [PRINT_POS_FREE], [LocFormatStr], 'Netto / ', [HeadInfo!W.Waehrung]
      PRINT_BOX  [[PrnVarName]], 1200, [LocY], 1500, [PRINT_POS_FREE], [LocFormatStr], 'Mwst / ', [HeadInfo!W.Waehrung]
      PRINT_BOX  [[PrnVarName]], 1500, [LocY], [X_POS_RIGHT_MARGIN], [PRINT_POS_FREE], [LocFormatStr], 'Brutto / ', [HeadInfo!W.Waehrung]

      CALL LF [LocY],1

      PRINT_BOX  [[PrnVarName]],  200, [LocY],  900,                 [PRINT_POS_FREE], [LocFormatStr2], 'Gesamtauftragswert'
      PRINT_BOX  [[PrnVarName]],  900, [LocY], 1200,                 [PRINT_POS_FREE], [LocFormatStr], [HeadInfo!A.BelegNetto|X0,2]
      PRINT_BOX  [[PrnVarName]], 1200, [LocY], 1500,                 [PRINT_POS_FREE], [LocFormatStr], [HeadInfo!A.BelegMwst|X0,2]
      PRINT_BOX  [[PrnVarName]], 1500, [LocY], [X_POS_RIGHT_MARGIN], [PRINT_POS_FREE], [LocFormatStr],[HeadInfo!A.BelegBrutto|X0,2]

      CALC [LocY] AS [LocY]+50

      PRINT_BOX  [[PrnVarName]],  200, [LocY],  900, [PRINT_POS_FREE], [LocFormatStr2], 'Teilzahlung-Rechnungen'
      CALL LF [LocY],1

      WHILE [LocQRes]

        CALC [LocFloat] AS [LocQ!RecordID] - [RECORD_ID1]
        CALC [LocFloat] AS ABS([LocFloat])
        CALL MakeNumLen5 [LocQ!Rechnungsnummer]
        IF [LocFloat] < [EPSILON]
         ; FROM the current RG I take Buchungstext2 (in H+S version) or not
         ; CALC [TmpStr] AS [LocQ!Buchungstext2]
          CALC [LocStr] AS CON([ANumStr],'/',[LocQ!Datum|R10,dd.mm.yyyy])
        ELSE
          CALC [LocStr] AS CON([ANumStr],'/',[LocQ!Datum|R10,dd.mm.yyyy])
        END_IF

        PRINT_BOX  [[PrnVarName]],  200, [LocY],  900,                 [PRINT_POS_FREE], [LocFormatStr2], [LocStr]
        PRINT_BOX  [[PrnVarName]],  900, [LocY], 1200,                 [PRINT_POS_FREE], [LocFormatStr], [LocQ!Netto|X0,2]
        PRINT_BOX  [[PrnVarName]], 1200, [LocY], 1500,                 [PRINT_POS_FREE], [LocFormatStr], [LocQ!Mwst|X0,2]
        PRINT_BOX  [[PrnVarName]], 1500, [LocY], [X_POS_RIGHT_MARGIN], [PRINT_POS_FREE], [LocFormatStr], [LocQ!Brutto|X0,2]
        CALL LF [LocY],1

        IF [LocFloat] < [EPSILON]
          EXIT_WHILE
        END_IF

        GET_DATA [LocQ],[LocQRes]
      END_WHILE
    END_IF

    CALC [LocY] AS [LocY]+30

    PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY], [X_POS_RIGHT_MARGIN], [PRINT_POS_FREE], [LocFormatStr2], 'Es gelten unsere allgemeinen Vertragsbedingungen unter dem erweiterten Eigentumsvorbehalt.'
    PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]

    CALC [LocY] AS [LocY]+20

    CALC [LocYSizeBox] AS [LocY]-[LocStartY]
  END_PROC



  PROCEDURE PrintEndBedingungen VN LocY, ~VN LocYSizeBox, VB PrintIt
    LOCAL_NUM   LocStartY
    LOCAL_STR LocFormatStr

    CALC [LocStartY] AS [LocY]

    IF [PrintIt]
      CALC [LocFormatStr] AS '[J L]'
    ELSE
      CALC [LocFormatStr] AS '[N BC white C white J L]'
    END_IF

;    IF [Lieferbedingung]<>''
;      PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY],  520, [PRINT_POS_FREE], [LocFormatStr], 'Lieferbedingung'
;      PRINT_BOX  [[PrnVarName]],  530,                 [LocY],  540, [PRINT_POS_FREE], [LocFormatStr], ':'
;      PRINT_BOX  [[PrnVarName]],  550,                 [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [Lieferbedingung]
;      PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
;    END_IF

    IF [ZahlBedStrEins]<>''
      PRINT_BOX  [[PrnVarName]],  [X_POS_LEFT_MARGIN], [LocY],  520, [PRINT_POS_FREE], [LocFormatStr], 'Zahlungsbedingung'
      PRINT_BOX  [[PrnVarName]],  530,                 [LocY],  540, [PRINT_POS_FREE], [LocFormatStr], ':'
      PRINT_BOX  [[PrnVarName]],  550,                 [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [ZahlBedStrEins]
      PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]

      IF [ZahlBedStrZwei]<>''
        PRINT_BOX  [[PrnVarName]],  550, [LocY], 2000, [PRINT_POS_FREE], [LocFormatStr], [ZahlBedStrZwei]
        PRINT_POS  [[PrnVarName]], [LocY], [PRINT_POS_BOTTOM]
      END_IF
    END_IF

    CALC [LocY] AS [LocY]+20

    CALC [LocYSizeBox] AS [LocY]-[LocStartY]
  END_PROC



  PROCEDURE FirstPage
    ; usually printed only on first page, if u want to print on following adjust it.
    ; print Absender, Anschrift, Referenzblock, Titel, Zusatzadressen
    ; and Notiz 1 from Header and PageNo = 1

    IF [PageNo]<>1
      EXIT_PROC
    END_IF

    CALC [Y] AS [Y_POS_ABSENDER]
    PRINT_BOX [[PrnVarName]],  [X_POS_LEFT_MARGIN], [Y], -1000, [PRINT_POS_FREE], '[N PS 0 S 7 J L U]', [IP_AUSDRUCK_ABSENDER]
    CALL LF [Y],1

    CALL PrintAdresse

    CALL PrintReferenz

    CALL TitleAndPageNo

    CALL PrintZusatzAdressen

    CALL LF [Y], 1
    CALL PrintOneNote 'RECHNUNG', [RECORD_ID1], 1, [X_POS_LEFT_MARGIN], 2000, [PRINT_NOTES_BOLD_NO]
  END_PROC



  PROCEDURE PrintPositionNotes VS LocTableName, VF LocID, VN LocPrintFlag, VN LocNoteType, VN LocLeftX, VN LocRightX, VB LocPrintNoteBold
    LOCAL_BOOL LocRes

    IF [PRINT_POS_NOTES_ALWAYS]
      CALL PrintOneNote [LocTableName], [LocID], [LocNoteType], [LocLeftX], [LocRightX], [LocPrintNoteBold]
      EXIT_PROC
    END_IF

    FLAG_STATE [PosList!P.Kenner1], [LocPrintFlag], [LocRes]
    IF [LocRes]
      CALL PrintOneNote [LocTableName], [LocID], [LocNoteType], [LocLeftX], [LocRightX], [LocPrintNoteBold]
    END_IF
  END_PROC



  PROCEDURE PrintVarStckListe VF LocPosID
    ; work 4 var StckList
    PRINT_BOX  [[PrnVarName]],  300, [Y],  800, [PRINT_POS_FREE], '[J L]', 'bestehend aus:'
    CALL LF [Y],1

    ; Print A.ArtikelNummer, A.Bzeichnung1, P.Stckzahl from POSTEN
    ; WHERE FertAuftragID = LocPosID
    ; and P.StueckFlag > 1
    ; order by Stufe

      IF [PosList!P.StueckFlag]=8
        CALL Dezimal2String [PosList!P.Stckzahl], [ANZAHL_NACHKOMMASTELLEN], [PrnStr]
      END_IF
  END_PROC



  PROCEDURE GetAuftragsInfo VF LocAuftragID
    LOCAL_BOOL  LocRes
    LOCAL_QUERY LocQ

    QUERY [LocQ]
      SELECT Auftragsnummer, Auftragsdatum, Bestellnummer, Bestelldatum, Referenz, RecordID
        FROM AUFTRAG
       WHERE RecordID = [LocAuftragID|R0,0]
    END_QUERY

    EXECUTE [LocQ], [LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    PRINT_BOX  [[PrnVarName]],  450, [Y],  750, [PRINT_POS_FREE], '[N J L B]', 'Auftragsnummer'

    CALL MakeNumLen5 [LocQ!Auftragsnummer]
    PRINT_BOX  [[PrnVarName]],  750, [Y], 2000, [PRINT_POS_FREE], '[N J L B]', [ANumStr],' vom ',[LocQ!Auftragsdatum]
    PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]

    IF [LocQ!Bestellnummer]<>''
      PRINT_BOX  [[PrnVarName]],  450, [Y],  750, [PRINT_POS_FREE], '[N J L B]', 'Bestellnummer'
      PRINT_BOX  [[PrnVarName]],  750, [Y], 2000, [PRINT_POS_FREE], '[N J L B]', [LocQ!Bestellnummer],' vom ',[LocQ!Bestelldatum]
      PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocQ!Referenz]<>''
      PRINT_BOX  [[PrnVarName]],  450, [Y], 2000, [PRINT_POS_FREE], '[N J L B]', [LocQ!Referenz]
      PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
    END_IF
  END_PROC



  PROCEDURE Body
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocY
    LOCAL_STR   LocStr
    LOCAL_FLOAT LocFloat
    LOCAL_FLOAT CUPreis

    ; print the Positionsliste, PageNo, Uebertrag, Title
    ; StartYPos on first page according to MaxY from FirstPage()
    ; else defined as StartYPosSecondPage

    CALC [PrintHeadlineListYes] AS TRUE

    IF [HeadInfo!R.Modus]>0
      CALC [TmpStr] AS CON(' AND (P.AuftragID = ', [HeadInfo!R.AuftragID|R0,0], ')')
    ELSE
      CALC [TmpStr] AS CON(' AND (P.RechnungID = ', [RECORD_ID1|R0,0], ')')
    END_IF

    CALL PositionHeadLine

    QUERY [PosList]
        SELECT P.PosNr, P.Stufe, P.Stckzahl, P.Liefermenge, P.BelegPreis, P.Anzahl, P.BelegGesamtPreis,
               P.Kurztext1, P.Kurztext2, P.Kurztext3, P.WunschKW, P.WunschDatum,
               P.RabattPr, P.MwstPr, P.FertAuftragID, P.BelegGrundPreis, P.PEinheit, P.FreeFloat1, P.FreeFloat2,
               P.RecordID, P.ArtikelID, P.LieferscheinID, P.AuftragID, P.RechnungID, P.KontoID,
               P.Kenner1, P.StueckFlag, P.Freebit1, P.Rabatt3, A.ZolltarifNr, A.AnbruchWarnung,
               A.Artikelnummer, A.Aktuell, A.Bezeichnung1, A.Kurzbezeichnung, A.PEinheit, A.VE, A.FreeBit1, A.FreeBit3,
               A.Zeichnungsnummer, A.Bauform, A.Werkstoff, A.Qualitaet, A.SNFlag,
               A.Bezeichnung2, A.Bezeichnung3, A.reserviert, A.Bestellt, A.Bedarf, A.EANCode1, A.Einheit, A.HandelID,
               L.Lieferscheinnummer, L.Lieferdatum, A.FREEFLOAT2, P.PREIS, A.FREEFLOAT1

          FROM posten P, artikel A, liefersc L

         WHERE P.ArtikelID      = A.RecordID
           AND P.ArtikelID      > 100
           AND P.LieferscheinID = L.RecordID
               [TmpStr]

      ORDER BY P.RechnungID, L.Lieferscheinnummer, P.PosNr, P.Stufe
    END_QUERY

    EXECUTE [PosList],[QRes]
    IF [QRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [PosList],[QRes]

    IF [QRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [Uebertrag]        AS 0.0
    CALC [ZwischenSumme]    AS 0.0
    CALC [LastLSNummer]     AS ''

    WHILE [QRes]
      CALL LF [Y], 2
      IF [Y] >= [Y_POS_FOOTER]
        CALL CheckAndDoUebertrag
      ELSE
        CALL LF [Y], -2
      END_IF

      ; line 0
      FLAG_STATE [PosList!P.Kenner1], [TITEL_TEXT], [QRes]
      IF [QRes]
        CALL PrintOneNote 'POSTEN',  [PosList!P.RecordID], 101, 200, 1300, [PRINT_NOTES_BOLD_YES]
        CALL LF [Y], 1
        CALL CheckAndDoUebertrag
      END_IF

      IF [PosList!L.Lieferscheinnummer]<>''
        IF [PosList!L.Lieferscheinnummer]<>[LastLSNummer]
          IF [LastLSNummer]<>''
            CALL LF [Y], 2
          END_IF
          PRINT_BOX  [[PrnVarName]],  450, [Y],  750, [PRINT_POS_FREE], '[N J L B]', 'Lieferschein'
          CALL MakeNumLen5 [PosList!L.Lieferscheinnummer]
          PRINT_BOX  [[PrnVarName]],  750, [Y], 2000, [PRINT_POS_FREE], '[N J L B]', [ANumStr],' vom ',[PosList!L.Lieferdatum]
          PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
          PRINT_BOX  [[PrnVarName]],  450, [Y],  750, [PRINT_POS_FREE], '[N J L B]', 'Lieferdatum'
          PRINT_BOX  [[PrnVarName]],  750, [Y], 2000, [PRINT_POS_FREE], '[N J L B]', [PosList!L.Lieferdatum], ' / ', [HeadInfo!A.Auftragsnummer]
          PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
          ;CALL LF [Y], 1
          CALC [LastLSNummer] AS  [PosList!L.Lieferscheinnummer]
          CALL CheckAndDoUebertrag

          ; hole den Auftrag
;         CALL GetAuftragsInfo [LocLastAuftragID]
          CALL GetAuftragsInfo [PosList!P.AuftragID]
        END_IF
      END_IF

      ; line 1
      CALL PrintPositionNotes 'POSTEN',  [PosList!P.RecordID],  [POS_TEXT1], 1, 450, 750

      ; line 2
      ;CALL PrintPositionNotes 'ARTIKEL', [PosList!P.ArtikelID], [ART_TEXT1], 1, 600, 2000

      ; line 3
      ;PRINT_BOX  [[PrnVarName]],  200, [Y],  250, [PRINT_POS_FREE], '[J R]', [PosList!P.PosNr|R3,0]

      CALL Dezimal2String [PosList!P.Anzahl], [ANZAHL_NACHKOMMASTELLEN], [PrnStr]
      PRINT_BOX  [[PrnVarName]], 200, [Y], 400, [PRINT_POS_FREE], '[J R]', [PrnStr]

      PRINT_BOX  [[PrnVarName]],  450, [Y], 1400, [PRINT_POS_FREE], '[J L]', [PosList!A.Artikelnummer]

      ; Menge und Einheit
      ; Einzelpreis mit PEinheit
;     CALC [PrnStr] AS [PosList!P.BelegGrundPreis|X0,2]
      CALC [PrnStr] AS [PosList!P.BelegGrundPreis|X0,4]
      CALC [SLen] AS LEN([PrnStr])
      CALC [Str1] AS COPY([PrnStr],[SLen],1)
      IF [Str1]='0'
        DEC  [SLen]
        CALC [PrnStr] AS COPY([PrnStr],1,[SLen])
        CALC [Str1] AS COPY([PrnStr],[SLen],1)
        IF [Str1]='0'
          DEC  [SLen]
          CALC [PrnStr] AS COPY([PrnStr],1,[SLen])
        END_IF
      END_IF
      IF [PosList!P.PEinheit]>1
        CALC [LocStr] AS [PosList!P.PEinheit|R0,0]
        CALC [PrnStr] AS CON([PrnStr],' / ',[LocStr])
      END_IF

      PRINT_BOX  [[PrnVarName]], 1300, [Y], 1600, [PRINT_POS_FREE], '[J R]', [PrnStr]

      IF [PosList!P.Rabatt3]>[EPSILON]
        CALL Dezimal2String [PosList!P.Rabatt3], [ANZAHL_NACHKOMMASTELLEN], [PrnStr]
        CALC [PrnStr] AS CON('-',[PrnStr],'%')
        PRINT_BOX  [[PrnVarName]], 1600, [Y], 1750, [PRINT_POS_FREE], '[J R]', [PrnStr]
      END_IF

; houben
      IF [PosList!A.FreeBit1]
      CALC [TmpFloat] AS ABS([PosList!P.RabattPr]+[PosList!P.Rabatt3])
        IF [TmpFloat]<=[EPSILON]
          CALC [PrnStr] AS 'netto'
          PRINT_BOX  [[PrnVarName]], 1600, [Y], 1750, [PRINT_POS_FREE], '[J R]', [PrnStr]
        END_IF
      END_IF
; houben

      PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [PosList!P.BelegGesamtPreis|X0,2]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

      PRINT_BOX  [[PrnVarName]],  450, [Y], 1400, [PRINT_POS_FREE], '[J L]', [PosList!P.Kurztext1]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

      IF [PosList!P.RabattPr]>[EPSILON]
        CALL Dezimal2String [PosList!P.RabattPr], [ANZAHL_NACHKOMMASTELLEN], [PrnStr]
        CALC [PrnStr] AS CON('-',[PrnStr],'%')
        PRINT_BOX  [[PrnVarName]], 1000, [Y], 1590, [PRINT_POS_FREE], '[J R]', 'Sonderrabatt'
        PRINT_BOX  [[PrnVarName]], 1600, [Y], 1750, [PRINT_POS_FREE], '[J R]', [PrnStr]
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      END_IF

      CALL CheckAndDoUebertrag

      IF [PosList!P.FreeBit1]=FALSE
        CALC [Uebertrag]     AS [Uebertrag]+[PosList!P.BelegGesamtPreis]
        CALC [ZwischenSumme] AS [ZwischenSumme]+[PosList!P.BelegGesamtPreis]
      END_IF

      ; line 5
      PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', [PosList!P.Kurztext2]
      IF [PosList!A.EANCode1]<>''
        PRINT_BOX  [[PrnVarName]], 1200, [Y], 1600, [PRINT_POS_FREE], '[J L]', 'EAN: ',[PosList!A.EANCode1]
      END_IF

      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      CALL CheckAndDoUebertrag

      PRINT_BOX  [[PrnVarName]],  450, [Y], 1400, [PRINT_POS_FREE], '[J L]', [PosList!P.Kurztext3]
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

      CALL CheckAndDoUebertrag

      CALC [LocStr] AS UPCASE([PosList!A.Artikelnummer])
      IF [LocStr]='XXX'
        PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Sonderbeschaffung, daher keine Rckgabe mglich.'
      END_IF
      IF [LocStr]='YYY'
        PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Sonderbeschaffung, daher keine Rckgabe mglich.'
      END_IF
      IF [LocStr]='ZZZ'
        PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Sonderbeschaffung, daher keine Rckgabe mglich.'
      END_IF
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      CALL CheckAndDoUebertrag

      IF [PosList!A.FreeBit3]
        IF [PosList!A.ZolltarifNr]<>''
          PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Nicht Ursprungsware.  Zolltarifnummer: ',[PosList!A.ZolltarifNr]
        ELSE
          PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Nicht Ursprungsware'
        END_IF
      ELSE
        IF [PosList!A.ZolltarifNr]<>''
          PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Zolltarifnummer: ',[PosList!A.ZolltarifNr]
        END_IF
      END_IF
      PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
      CALL CheckAndDoUebertrag


      ; line 7
      ;CALL PrintPositionNotes 'ARTIKEL', [PosList!P.ArtikelID], [ART_TEXT2], 2, 600, 2000

      ; line 8
      CALL PrintPositionNotes 'POSTEN',  [PosList!P.RecordID],  [POS_TEXT2], 2, 450, 750

      CALL PrintKndArtikel [PosList!P.ArtikelID], [HeadInfo!R.KundenID]
;      IF [Metallzuschlag]
;        CALL PrintCU [PosList!P.RecordID]
;      END_IF

      ; Houben +
      IF [PosList!A.AnbruchWarnung]
        PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', 'Bei Verpackungsanbruch keine Bruchgarantie!'
        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
        CALL CheckAndDoUebertrag
      END_IF

      ; CU
      CALL GetCu [PosList!P.Anzahl], [PosList!A.FreeFloat2], [PosList!P.FreeFloat2], [PosList!A.FreeFloat1], [CUPreis]
      CALC [LocFloat] AS ABS([PosList!P.Preis])
      IF [LocFloat]<[EPSILON]
        CALC [CuPreis] AS 0.0
      END_IF

      CALC [LocFloat] AS ABS([CuPreis])

      IF [LocFloat]>[EPSILON]
        ; Cu-Anteil
        ; in ARTIKEL.FreeFloat2 steht die Cu-Basis pro 100 kg
        CALL Dezimal2String [PosList!A.FreeFloat1], -3, [PrnStr]

        CALC [PrnStr] AS CON('Cu-Zuschlag, ',[PrnStr],'g, Kurs: ',[PosList!P.FreeFloat2|X0,2], ' ', [CURRENCY_STR])
        PRINT_BOX  [[PrnVarName]],  450, [Y], 1200, [PRINT_POS_FREE], '[J L]', [PrnStr]

        IF [PosList!P.PEinheit]>[EPSILON]
          CALC [CuPreis] AS [CuPreis]/[PosList!P.PEinheit]
        END_IF

        CALC [PrnStr] AS [CuPreis|R0,2]
        PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[J R]', [PrnStr]

        PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]
        CALL CheckAndDoUebertrag
      END_IF

      ; Houben -


      FLAG_STATE [PosList!P.Kenner1], [ZWS_TEXT], [LocRes]
      IF [LocRes]
        CALC [Y] AS [Y]+20
        PRINT_LINE [[PrnVarName]], 1450, [Y], 2000, [Y]
        CALC [Y] AS [Y]+20

        PRINT_BOX  [[PrnVarName]], 1450, [Y], 1750, [PRINT_POS_FREE], '[N PS 0 T B J L]', 'Zwischensumme'
        PRINT_BOX  [[PrnVarName]], 1750, [Y], 2000, [PRINT_POS_FREE], '[N PS 0 T B J R]', [ZwischenSumme|X0,2]

        CALL LF [Y], 1
        CALL CheckAndDoUebertrag

        CALC [ZwischenSumme]  AS 0.0
      END_IF

      FLAG_STATE [PosList!P.Kenner1], [PAGE_FEED], [LocRes]
      IF [LocRes]
        CALC [Y] AS [Y_POS_FOOTER]
        CALL CheckAndDoUebertrag
      END_IF

      GET_DATA [PosList],[QRes]

      IF [QRes]=FALSE
       CALC [PrintHeadlineListYes] AS FALSE
      ELSE
        ;CALL LF [Y], 1
        CALL CheckAndDoUebertrag
      END_IF
    END_WHILE

    CALC [PrnStr] AS CON([HeadInfo!K.Free1Str],[HeadInfo!K.Free2Str])
    IF [PrnStr]<>''
      CALL LF [Y], 2
      CALL CheckAndDoUebertrag
      PRINT_BOX [[PrnVarName]], 200, [Y], 2000, [PRINT_POS_FREE], '[N PS 0 T J L]', [HeadInfo!K.Free1Str],' ',[HeadInfo!K.Free2Str]
      PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
    END_IF


    IF [HeadInfo!K.BonusJa]
      CALL LF [Y], 2
      CALL CheckAndDoUebertrag

      PRINT_BOX [[PrnVarName]], 200, [Y], 2000, [PRINT_POS_FREE], '[N PS 0 T J L]', 'Bezglich der Entgeltsminderungen verweisen wir auf die aktuelle Bonusvereinbarung.'
      PRINT_POS [[PrnVarName]],  [Y], [PRINT_POS_BOTTOM]
    END_IF

    ;CALL PrintSonderkosten
  END_PROC



  PROCEDURE DrawGrayBackGround VN LocStartY, VN LocStopY
    LOCAL_NUM LocLeft
    LOCAL_NUM LocRight

    CALC [LocLeft]  AS [X_POS_LEFT_MARGIN]-10
    CALC [LocRight] AS [X_POS_RIGHT_MARGIN]+10

    PRINT_BOX  [[PrnVarName]], [LocLeft], [LocStartY], [LocRight],[LocStopY], '[N TO BC LtGray PC Black PS 0 J L]', ''
  END_PROC



  PROCEDURE LastPage
    LOCAL_FLOAT LocMTZ
    LOCAL_FLOAT LocPorto
    LOCAL_FLOAT LocEntsorgung
    LOCAL_FLOAT LocVerpackung

    CALL LF [Y], 1
    CALL CheckAndDoUebertrag

    CALL PrintOneNote 'RECHNUNG', [RECORD_ID1], 2, [X_POS_LEFT_MARGIN], 2000, [PRINT_NOTES_BOLD_NO]

    CALL CheckAndDoUebertrag

    CALC [Y] AS [Y_POS_FOOTER]

    PRINT_BOX  [[PrnVarName]], 200, [Y], 2000, [PRINT_POS_FREE], '[N PS 0 T J L]', [SchlussText]
    PRINT_POS  [[PrnVarName]], [Y], [PRINT_POS_BOTTOM]

    PRINT_BOX  [[PrnVarName]], 200, [Y], 2000, [PRINT_POS_FREE], '[N PS 0 T J L]', [ZahlBedStrEins]
    CALL LF [Y], 2

    ; ans Ende der Seite
    PRINT_BOX  [[PrnVarName]],  200, [Y],  400, -50, '[N PS 1 T J R]', 'Warenwert'
    PRINT_BOX  [[PrnVarName]],  400, [Y],  600, -50, '[N PS 1 T J R]', 'Verpackung'
    PRINT_BOX  [[PrnVarName]],  600, [Y],  750, -50, '[N PS 1 T J R]', 'Porto'
    PRINT_BOX  [[PrnVarName]],  750, [Y],  900, -50, '[N PS 1 T J R]', 'MTZ'
    PRINT_BOX  [[PrnVarName]],  900, [Y], 1100, -50, '[N PS 1 T J R]', 'Entsorgung'
    PRINT_BOX  [[PrnVarName]], 1100, [Y], 1300, -50, '[N PS 1 T J R]', 'Nettobetrag'
    PRINT_BOX  [[PrnVarName]], 1300, [Y], 1450, -50, '[N PS 1 T J R]', 'Mwst %'
    PRINT_BOX  [[PrnVarName]], 1450, [Y], 1700, -50, '[N PS 1 T J R]', 'Mwst Betrag'
    PRINT_BOX  [[PrnVarName]], 1700, [Y], 2000, -50, '[N PS 1 T J R]', 'Rechnungsbetrag'

    CALC [Y] AS [Y]+50
    PRINT_BOX  [[PrnVarName]],  200, [Y],  400, -50, '[N PS 1 T J R]', [HeadInfo!R.BelegWarenwert|X0,2]
    PRINT_BOX  [[PrnVarName]],  200, [Y],  600, -50, '[N PS 1 T J R]', [HeadInfo!R.Belegnebenkosten1|X0,2]
    PRINT_BOX  [[PrnVarName]],  600, [Y],  750, -50, '[N PS 1 T J R]', [HeadInfo!R.Belegnebenkosten2|X0,2]
    PRINT_BOX  [[PrnVarName]],  750, [Y],  900, -50, '[N PS 1 T J R]', [HeadInfo!R.Belegnebenkosten3|X0,2]
    PRINT_BOX  [[PrnVarName]],  900, [Y], 1100, -50, '[N PS 1 T J R]', [HeadInfo!R.Belegnebenkosten4|X0,2]
    PRINT_BOX  [[PrnVarName]], 1100, [Y], 1300, -50, '[N PS 1 T J R]', [HeadInfo!R.BelegNetto|X0,2]

    CALL Dezimal2String [HeadInfo!R.StSatz1], -2, [PrnStr]
    PRINT_BOX  [[PrnVarName]], 1300, [Y], 1450, -50, '[N PS 1 T J R]', [PrnStr]

    PRINT_BOX  [[PrnVarName]], 1450, [Y], 1700, -50, '[N PS 1 T J R]', [HeadInfo!R.Mwst|X0,2]
    PRINT_BOX  [[PrnVarName]], 1700, [Y], 2000, -50, '[N PS 1 T J R]', [HeadInfo!R.BelegBrutto|X0,2]
  END_PROC



  PROCEDURE OldLastPage
    LOCAL_NUM LocNum
    LOCAL_NUM SlStartY,  -1000
    LOCAL_NUM SumStartY, -1000
    LOCAL_NUM BedStartY, -1000
    LOCAL_NUM LocBlockHeight

    LOCAL_NUM LocLastPageTye, 2

    ; es gibt drei sinnvolle Varianten (fr die Hhenmessung der LastPage):
    ;   VARIANTE 1: BedingungenBlock, Summenblock und SchlussText untereinander
    ;   VARIANTE 2: BedingungenBlock neben Summenblock, SchlussText drunter oder drber
    ;   VARIANTE 2: SchlussText neben SummenBlock, BedingungenBlock drunter oder drber

    ; Print Notiz2, MfG, Liefer- und Zahlungsbedingungen und Summen

    CALL LF [Y], 1
    CALL CheckAndDoUebertrag

    CALL PrintOneNote 'RECHNUNG', [RECORD_ID1], 2, [X_POS_LEFT_MARGIN], 2000, [PRINT_NOTES_BOLD_NO]

    ; measure the height sprezece of all
    CALL PrintSchlussText    [SlStartY],  [SchlussTextBlockHeight], FALSE
    CALL PrintEndBedingungen [SumStartY], [BedingungenBlockHeight], FALSE
    CALL PrintEndSummen      [BedStartY], [SummenBlockHeight],      FALSE

    IF [LocLastPageTye]=1
      CALC [LocBlockHeight] AS [SummenBlockHeight]+[BedingungenBlockHeight]+[SchlussTextBlockHeight]
    ELSE_IF [LocLastPageTye]=2
      IF [SummenBlockHeight]<[BedingungenBlockHeight]
        CALC [SummenBlockHeight] AS [BedingungenBlockHeight]
      END_IF

      CALC [LocBlockHeight] AS [SummenBlockHeight]+[SchlussTextBlockHeight]
    ELSE
      IF [SummenBlockHeight]<[SchlussTextBlockHeight]
        CALC [SummenBlockHeight] AS [SchlussTextBlockHeight]
      END_IF

      CALC [LocBlockHeight] AS [SummenBlockHeight]+[BedingungenBlockHeight]
    END_IF

    CALC [LocNum] AS [Y_POS_FOOTER_INFO]-[LocBlockHeight]-[ZEILEN_ABSTAND]

    IF [Y]>[LocNum]
      CALC [Y] AS [Y_POS_FOOTER]+100
      CALL CheckAndDoUebertrag
    END_IF


    IF [LocLastPageTye]=1
      ; BedingungenBlock, Summenblock und SchlussText untereinander
      CALC [BedStartY] AS [LocNum]
      CALC [SlStartY]  AS [BedStartY]+[BedingungenBlockHeight]
      CALC [SumStartY] AS [SlStartY]+[SchlussTextBlockHeight]
    ELSE_IF [LocLastPageTye]=2
      ; BedingungenBlock neben Summenblock, SchlussText drunter oder drber
      CALC [SlStartY]  AS [LocNum]
      CALC [BedStartY] AS [SlStartY]+[SchlussTextBlockHeight]
      CALC [SumStartY] AS [SlStartY]+[SchlussTextBlockHeight]
    ELSE_IF [LocLastPageTye]=3
      ; SchlussText neben SummenBlock, BedingungenBlock drunter oder drber
      CALC [SumStartY] AS [LocNum]
      CALC [SlStartY]  AS [LocNum]
      CALC [BedStartY] AS [SlStartY]+[SummenBlockHeight]
    ELSE
      ; adjust by your own
    END_IF

    ; if u want to have gray background on all blocks
      ; CALL DrawGrayBackGround [LocNum], [Y_POS_FOOTER_INFO]

    ; if u want to have gray background on SummenBlock
    CALC [LocNum] AS [SumStartY]+[SummenBlockHeight]
    CALL DrawGrayBackGround [SumStartY], [LocNum]

    CALL PrintEndSummen [SumStartY], [SummenBlockHeight], TRUE

    CALL PrintSchlussText [SlStartY],   [SchlussTextBlockHeight], TRUE


    CALL PrintEndBedingungen [BedStartY], [BedingungenBlockHeight], TRUE
  END_PROC



  PROCEDURE LoadLS_AUF
    LOCAL_BOOL  LocRes
    LOCAL_QUERY LocQ


    LOCAL_FLOAT LocFloat,         0
    LOCAL_FLOAT LocLastLSID,      0
    LOCAL_FLOAT LocLastAuftragID, 0

    QUERY [LocQ]
      SELECT L.Lieferscheinnummer, L.Lieferdatum, L.RecordID,
             A.Auftragsnummer, A.Auftragsdatum, A.Referenz, A.Bestellnummer, A.Kurztext1,
             A.Kurztext2, A.Bestelldatum, A.RecordID
        FROM LIEFERSC L, AUFTRAG A
       WHERE L.RechnungID = [RECORD_ID1|R0,0]
         AND L.AuftragID = A.RecordID
       ORDER BY A.RecordID, L.RecordID
    END_QUERY

    EXECUTE [LocQ],[LocRes]
    IF [LocRes]
      GET_DATA [LocQ],[LocRes]

      WHILE [LocRes]
        CALC [LocFloat] AS ABS([LocQ!L.RecordID]-[LocLastLSID])
        IF [LocFloat]>[EPSILON]
          INC [CntLS]
        END_IF

        CALC [LocFloat] AS ABS([LocQ!A.RecordID]-[LocLastAuftragID])
        IF [LocFloat]>[EPSILON]
          INC [CntAuftrag]
        END_IF

        CALC [Referenz]           AS [LocQ!A.Referenz]
        CALC [Lieferdatum]        AS [LocQ!L.Lieferdatum]
        CALC [Bestelldatum]       AS [LocQ!A.Bestelldatum]
        CALC [Auftragsdatum]      AS [LocQ!A.Auftragsdatum]
        CALC [Bestellnummer]      AS [LocQ!A.Bestellnummer]

        CALL MakeNumLen5 [LocQ!A.Auftragsnummer]
        CALC [Auftragsnummer]     AS [ANumStr]
        CALC [KndAuftragsnummer]  AS [LocQ!A.Kurztext2]

        CALL MakeNumLen5 [LocQ!L.Lieferscheinnummer]
        CALC [Lieferscheinnummer] AS [ANumStr]

        CALC [LocLastLSID]        AS [LocQ!L.RecordID]
        CALC [LocLastAuftragID]   AS [LocQ!A.RecordID]

        GET_DATA [LocQ],[LocRes]
      END_WHILE
    END_IF
  END_PROC



  PROCEDURE LoadZahlungsBedingung
    LOCAL_BOOL  LocRes
    LOCAL_QUERY LocQ

    LOCAL_NUM   LocNum
    LOCAL_FLOAT LocFloat

    LOCAL_DATE  Zahlbed.NettoDatum
    LOCAL_BOOL  ZahlBed.Bankeinzug

    LOCAL_FLOAT Zahlbed.Skonto1
    LOCAL_DATE  Zahlbed.Skonto1Datum
    LOCAL_FLOAT Zahlbed.Skonto1Betrag
    LOCAL_FLOAT Zahlbed.Skonto1Zahlbetrag

    LOCAL_FLOAT Zahlbed.Skonto2
    LOCAL_DATE  Zahlbed.Skonto2Datum
    LOCAL_FLOAT Zahlbed.Skonto2Betrag
    LOCAL_FLOAT Zahlbed.Skonto2Zahlbetrag

    CALC [Zahlbed.NettoDatum]        AS [DATE]
    CALC [ZahlBed.Bankeinzug]        AS FALSE
    CALC [ZahlBedStrEins]            AS ''
    CALC [ZahlBedStrZwei]            AS ''

    CALC [Zahlbed.Skonto1]           AS 0.0
    CALC [Zahlbed.Skonto1Datum]      AS [DATE]
    CALC [Zahlbed.Skonto1Betrag]     AS 0.0
    CALC [Zahlbed.Skonto1Zahlbetrag] AS [HeadInfo!R.BelegBrutto]

    CALC [Zahlbed.Skonto2]           AS 0.0
    CALC [Zahlbed.Skonto2Datum]      AS [DATE]
    CALC [Zahlbed.Skonto2Betrag]     AS 0.0
    CALC [Zahlbed.Skonto2Zahlbetrag] AS [HeadInfo!R.BelegBrutto]


    QUERY [LocQ]
      SELECT Beschreibung, Beschreibung2, Zahlbedingung,
             Skonto1, TageBisS1, Skonto2, TageBisS2, Skonto3, TageBisS3, TageBisNetto, Bankeinzug
        FROM ZahlBed
       WHERE RecordID = [HeadInfo!R.ZahlBedID|R0,0]
    END_QUERY

    EXECUTE [LocQ], [LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [ZahlBed.Bankeinzug]    AS [LocQ!Bankeinzug]
    CALC [Zahlbed.NettoDatum]    AS [HeadInfo!R.Datum]+[LocQ!TageBisNetto]
    CALC [ZahlBedStrEins]        AS [LocQ!Beschreibung]
    CALC [ZahlBedStrZwei]        AS [LocQ!Beschreibung2]
;    CALC [ZahlBedStrDrei]        AS ''

    CALC [ZahlBedStrEins] AS CON('bis ',[Zahlbed.NettoDatum],' netto')

    IF [LocQ!Skonto1]>[EPSILON]
      CALC [Zahlbed.Skonto1]           AS [LocQ!Skonto1]
      CALC [Zahlbed.Skonto1Datum]      AS [HeadInfo!R.Datum]+[LocQ!TageBisS1]
      CALC [Zahlbed.Skonto1Betrag]     AS [HeadInfo!R.BelegBrutto]*[LocQ!Skonto1]/100
      CALL RoundMoney [Zahlbed.Skonto1Betrag]
      CALC [Zahlbed.Skonto1Zahlbetrag] AS [HeadInfo!R.BelegBrutto]-[Zahlbed.Skonto1Betrag]

      CALC [LocNum]   AS INT([LocQ!Skonto1])
      CALC [LocFloat] AS [LocQ!Skonto1]-[LocNum]
      IF [LocFloat]<[EPSILON]
        CALC [LocNum] AS 0
      ELSE
        CALC [LocNum] AS 2
      END_IF

      CALC [LocFloat] AS [HeadInfo!R.BelegBrutto]*[LocQ!Skonto1]/100
      CALC [ZahlBedStrZwei] AS CON('Bei Zahlung bis ',[Zahlbed.Skonto1Datum],' erhalten Sie ',[LocQ!Skonto1|X0,[LocNum]],' % Skonto = ',[LocFloat|X0,2],' ',[CURRENCY_STR])
    END_IF

;    IF [LocQ!Skonto2]>[EPSILON]
;      CALC [Zahlbed.Skonto2]           AS [LocQ!Skonto2]
;      CALC [Zahlbed.Skonto2Datum]      AS [HeadInfo!R.Datum]+[LocQ!TageBisS2]
;      CALC [Zahlbed.Skonto2Betrag]     AS [HeadInfo!R.BelegBrutto]*[LocQ!Skonto2]/100
;      CALL RoundMoney [Zahlbed.Skonto2Betrag]
;      CALC [Zahlbed.Skonto2Zahlbetrag] AS [HeadInfo!R.BelegBrutto]-[Zahlbed.Skonto2Betrag]
;
;      CALC [LocNum]   AS INT([LocQ!Skonto2])
;      CALC [LocFloat] AS [LocQ!Skonto2]-[LocNum]
;      IF [LocFloat]<[EPSILON]
;        CALC [LocNum] AS 0
;      ELSE
;        CALC [LocNum] AS 2
;      END_IF
;
;      CALC [LocFloat] AS [HeadInfo!R.BelegBrutto]*[LocQ!Skonto2]/100
;      CALC [ZahlBedStrDrei] AS CON('Bei Zahlung bis ',[Zahlbed.Skonto2Datum],' erhalten Sie ',[LocQ!Skonto2|X0,[LocNum]],' % Skonto = ',[LocFloat|X0,2],' ',[CURRENCY_STR])
;    END_IF
  END_PROC



  PROCEDURE GetHeaderInfo ~VB GoOn
    LOCAL_STR LocStr

    CALC [GoOn] AS FALSE

    WAIT_INFO 'Bitte warten','Die Kopfdaten werden geladen ...'

    QUERY [HeadInfo]
      SELECT R.Modus, R.Rechnungsnummer, R.Datum, R.Aktiv,
             R.Kurztext1, R.Kurztext2, R.IsBrutto,
             R.BelegNetto,  R.Netto, R.BelegMwst, R.Mwst,
             R.BelegNetto1, R.Netto1, R.StSatz1,
             R.BelegNetto2, R.Netto2, R.StSatz2,
             R.BelegNetto3, R.Netto3, R.StSatz3,
             R.BelegBrutto, R.Brutto, R.BelegWarenwert,
             R.BelegFracht, R.BelegVerpackung, R.Buchungstext1, R.Buchungstext2,
             R.Fracht, R.Verpackung, R.IDUser,
             R.Belegverrechnen, R.Belegabgerechnet,
             R.Belegnebenkosten1, R.Belegnebenkosten2, R.Belegnebenkosten3, R.Belegnebenkosten4,
             R.Belegnebenkosten5, R.Belegnebenkosten6, R.Belegnebenkosten7, R.Belegnebenkosten8,
             R.AuftragID, R.MwstJA, R.WaehrungID, R.VertreterID, R.ZahlBedID,
             R.KundenID, R.VerkundeID, R.RechkundeID,
             A.Auftragsnummer, A.Auftragsdatum, A.Referenz, A.Bestellnummer, A.Bestelldatum,
             A.PartnerID, A.MitarbeiterID, A.ProjekteID, A.RecordID,
             A.BelegNetto, A.BelegMwst, A.BelegBrutto,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor,
             K.RecordID, K.Kundennummer, K.Liefnummer, K.UstIdNr, K.Debitornummer,
             K.Fax1, K.EMail1, K.Name1, K.Name2, K.PLZ, K.Ort,
             K.Free1Str, K.Free2Str, K.Free3Str, K.KFiBuKng,
             K.BonusJa, K.Kopien_KRG, K.Formular_KRG, K.KLieferBedID
        FROM RECHNUNG R, AUFTRAG A, ADRESSEN K, WAEHRUNG W
       WHERE (R.RecordID   = [RECORD_ID1|R0,0])
         AND (R.AuftragID  = A.RecordID)
         AND (R.KundenID   = K.RecordID)
         AND (R.WaehrungID = W.RecordID)
    END_QUERY

    EXECUTE [HeadInfo],[GoOn]
    IF [GoOn]=FALSE
      END_WAIT
      MESSAGE 'Abbruch','Das Query fr die Beleg-Kopfdaten konnte nicht bersetzt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [HeadInfo],[GoOn]
    IF [GoOn]=FALSE
      END_WAIT
      MESSAGE 'Abbruch','Es wurden keine Daten fr den Belegkopf gefunden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF



;Document-Managament-System +
    LIST_APPEND [DmsXml], '<documentAttribute>'
    LIST_APPEND [DmsXml], '<attribute name="type" value="rechnung" />'
    LIST_APPEND [DmsXml], '<attribute name="sourceSystem" value="ideal" />'

    CALC [DmsXmlStr] AS CON('RG ',[HeadInfo!R.Rechnungsnummer],' vom ',[HeadInfo!R.Datum],'   Knd ',[HeadInfo!K.Kundennummer],', ',[HeadInfo!K.Name1],', ',[HeadInfo!K.Name2])
    CALL DmsXmlStrAdd '<attribute name="description" value="', [DmsXmlStr], '" />'

    ; ACHTUNG WICHTIG: Die [DmsUniqueID] muss unbedingt gesetzt werden, damit man den MD5-Vergeich der
    ;                  Datei machen kann und ggf. vermeidet, dass ein und dasselbe Dokument mehrfach
    ;                  im DMS abgelegt wird, obwohl es sich nicht verndert hat.
    CALC [DmsUniqueID] AS CON('rechnung#',[RECORD_ID1|R0,0])
    CALL DmsXmlStrAdd '<attribute name="sourceIdentifier" value="', [DmsUniqueID], '" />'
    LIST_APPEND [DmsXml], '</documentAttribute>'


    LIST_APPEND [DmsXml], '<searchAttribute>'
    CALL DmsXmlStrAdd '<attribute name="kundennummer"    type="string" value="', [HeadInfo!K.Kundennummer],                     '" />'
    CALL DmsXmlStrAdd '<attribute name="name1"           type="string" value="', [HeadInfo!K.Name1],                            '" />'
    CALL DmsXmlStrAdd '<attribute name="name2"           type="string" value="', [HeadInfo!K.Name2],                            '" />'
    CALL DmsXmlStrAdd '<attribute name="plz"             type="string" value="', [HeadInfo!K.PLZ],                              '" />'
    CALL DmsXmlStrAdd '<attribute name="ort"             type="string" value="', [HeadInfo!K.Ort],                              '" />'
    CALL DmsXmlStrAdd '<attribute name="dokumentennummer" type="string" value="', [HeadInfo!R.Rechnungsnummer],                  '" />'
    CALL DmsXmlStrAdd '<attribute name="dokumenttyp" type="string" value="rechnung"/>'


    CALC [DmsXmlStr] AS [HeadInfo!R.Datum|R0,yyyy-mm-dd]
    CALL DmsXmlStrAdd '<attribute name="datum"           type="date"   value="', [DmsXmlStr], '" />'

    CALL LoadRelationFields  [ACT_MIT_ID], 'ADRESSEN',   'Name1|Name2', [DmsXmlStr], ''
    IF [DmsXmlStr]=''
      CALC [DmsXmlStr] AS [SHORT_NAME]
    END_IF
    CALC [DmsXmlStr] AS REPLACE([DmsXmlStr],'|',' ')
    CALC [DmsXmlStr] AS    TRIM([DmsXmlStr])
    CALL DmsXmlStrAdd '<attribute name="commitname"      type="string" value="', [DmsXmlStr], '" />'

    LIST_APPEND [DmsXml], '</searchAttribute>'


    LIST_APPEND [DmsXml], '<systemAttribute>'
    CALC [DmsXmlStr] AS CON([RECORD_ID1|R0,0])
                                                         ;tabelle
    CALL DmsXmlStrAdd '<attribute name="backjump" value="rechnung#', [DmsXmlStr], '" />'
    CALL DmsXmlStrAdd '<attribute name="workflowname"    type="string" value="CheckItem=', [HeadInfo!R.Rechnungsnummer], '.pdf" />'
;Document-Managament-System -

    LOCAL_FLOAT LocAdressHistorieTimeStamp, [RECORD_ID1]
    IF [RECORD_ID7]>[EPSILON]
      CALC [LocAdressHistorieTimeStamp] AS 0.0
    END_IF

    IF [HeadInfo!R.RechKundeID]>[EPSILON]
      CALC [PrnStr] AS CON('TS',[LocAdressHistorieTimeStamp|R0,0],'|#N1-#N2--PS-+LPO')
      CALL CalcAdr [HeadInfo!R.RechKundeID], 'ADRESSEN', [PrnStr], [AnZ01], [AnZ02], [AnZ03], [AnZ04], [AnZ05], [AnZ06], [AnZ07]

      CALC [PrnStr] AS CON('TS',[LocAdressHistorieTimeStamp|R0,0],'|#N1-#N2--PS-+LPO')
      CALL CalcAdr [HeadInfo!R.KundenID],    'ADRESSEN', [PrnStr], [AgZ01], [AgZ02], [AgZ03], [AgZ04], [AgZ05], [AgZ06], [AgZ07]

      QUERY [RechInfo]
        SELECT Name1, Name2, Strasse, PLZPostfach, Postfach, Land, PLZ, Ort, UStIDNr, RecordID
          FROM adressen
         WHERE RecordID = [HeadInfo!R.RechkundeID|R0,0]
      END_QUERY
      EXECUTE [RechInfo], [GoOn]
      IF [GoOn]
        GET_DATA [RechInfo], [GoOn]
      END_IF
    ELSE
      CALC [PrnStr] AS CON('TS',[LocAdressHistorieTimeStamp|R0,0],'|#N1-#N2--PS-+LPO')
      CALL CalcAdr [HeadInfo!R.KundenID],    'ADRESSEN', [PrnStr], [AnZ01], [AnZ02], [AnZ03], [AnZ04], [AnZ05], [AnZ06], [AnZ07]
    END_IF

    CALC [PrnStr] AS CON('TS',[LocAdressHistorieTimeStamp|R0,0],'|-N1--N2--SS--LPO')
    CALL CalcAdr [HeadInfo!R.VerKundeID],    'ADRESSEN', [PrnStr], [LaZ01], [LaZ02], [LaZ03], [LaZ04], [LaZ05], [LaZ06], [LaZ07]

    CALC [PrnStr] AS CON('TS',[LocAdressHistorieTimeStamp|R0,0],'|#N1-#TE-#FX-#E1-')
    CALL CalcAdr [HeadInfo!A.MitarbeiterID], 'ADRESSEN', [PrnStr], [Sachbearbeiter.Name],     [Sachbearbeiter.Telefon], [Sachbearbeiter.Fax], [Sachbearbeiter.Mail]

    CALL LoadRelationFields  [HeadInfo!R.VertreterID],  'ADRESSEN',   'Personalnummer',                      [Vertreter],       ''
;   CALL LoadRelationFields  [HeadInfo!R.ZahlBedID],    'ZAHLBED',    'Beschreibung|Beschreibung2', [ZahlBedStrEins],  ''
    CALL LoadRelationFields  [HeadInfo!K.KLieferBedID], 'LIEFBED',    'Beschreibung',               [Lieferbedingung], ''
    CALL LoadRelationFields  [HeadInfo!A.PartnerID],    'ADRESSEN',   'Anrede|Name1|Name2',         [Ansprechpartner], ''
    CALL LoadRelationFields  [HeadInfo!A.ProjekteID],   'PROJEKTE',   'ProjektNr|Bezeichnung1',     [ProjektNr],       ''
;   CALL LoadRelationFields  [HeadInfo!A.VersandartID], 'VERSANDART', 'Beschreibung1',              [VersandArt],      ''

    CALC [LocStr]    AS PART([ProjektNr], 2, '|')
    CALC [ProjektNr] AS PART([ProjektNr], 1, '|')
    IF [LocStr]<>''
      CALC [ProjektNr] AS CON([ProjektNr],', ',[LocStr])
    END_IF

    CALL LoadZahlungsBedingung

;    CALC [ZahlBedStrZwei] AS PART([ZahlBedStrEins], 2, '|')
;    CALC [ZahlBedStrEins] AS PART([ZahlBedStrEins], 1, '|')

    CALC [AnsprAnrede] AS PART([Ansprechpartner], 1, '|')
    CALC [AnsprName1]  AS PART([Ansprechpartner], 2, '|')
    CALC [AnsprName2]  AS PART([Ansprechpartner], 3, '|')

    IF [AnsprName1]<>''
      CALC [Ansprechpartner] AS CON('z.Hd. ', [AnsprAnrede], ' ', [AnsprName1], ' ', [AnsprName2])
    END_IF

    CALC [IhreFaxNr] AS ''
    IF [HeadInfo!A.PartnerID] > [EPSILON]
      CALL LoadRelationFields  [HeadInfo!A.PartnerID],  'ADRESSEN',   'Fax1', [IhreFaxNr], ''
    END_IF

    IF [IhreFaxNr] =''
      CALL LoadRelationFields  [HeadInfo!K.RecordID],  'ADRESSEN',   'Fax1', [IhreFaxNr], ''
    END_IF

    CALL LoadLS_AUF

    IF [HeadInfo!R.AuftragID] >[EPSILON]
      CALC [CntAuftrag]         AS 1
      CALC [Referenz]           AS [HeadInfo!A.Referenz]
      CALC [Bestelldatum]       AS [HeadInfo!A.Bestelldatum]
      CALC [Auftragsdatum]      AS [HeadInfo!A.Auftragsdatum]
      CALC [Bestellnummer]      AS [HeadInfo!A.Bestellnummer]
      CALL MakeNumLen5 [HeadInfo!A.Auftragsnummer]
      CALC [Auftragsnummer]     AS [ANumStr]
    END_IF

  END_PROC



  PROCEDURE MainPrint
    WAIT_INFO 'Bitte warten','Die Kopfdaten werden geladen ...'

    LOCAL_NUM LocNum
    CALL GetHeaderInfo [QRes]
    IF [QRes]=FALSE
      END_WAIT

      ;Document-Managament-System +
      CALL DmsXmlAbortProcess
      ;Document-Managament-System -

      EXIT_PROC
    END_IF

    IF [RECORD_ID2]<[EPSILON]
      PRINT_CLR [[PrnVarName]]
    ELSE
      CALC [PRINT_BRIEFKOPF] AS [RECORD_ID4]
    END_IF

    END_WAIT

    IF [PRINT_BRIEFKOPF]=1
      GET_YES_NO 'Achtung','Soll die Rechnung als Faxformular gedruckt werden ?||(ja = mit BriefKopf, nein = ohne Briefkopf)',[PRINT_BRIEFKOPF]
      IF [PRINT_BRIEFKOPF]=[ID_CANCEL]
        ;Document-Managament-System +
        CALL DmsXmlAbortProcess
        ;Document-Managament-System -

        EXIT_PROC
      ELSE_IF [PRINT_BRIEFKOPF]=[ID_NO]
        CALC [PRINT_BRIEFKOPF] AS 0
      END_IF
    END_IF

    BACK_MARK

    CALC [PageNo] AS 1

    CALL InitFontSettings

    CALL Basis

    CALL FirstPage

    CALL Body

    CALL LastPage

    END_WAIT

    IF [RECORD_ID2]>[EPSILON]
      ; in case of Stapeldruck, jump out because print is done there (prn_ansd.csh)
      CALC [RECORD_ID2] AS 0.0
      CALC [PrnVarName] AS 'ScrPrn'
      PRINT_CLR [[PrnVarName]]
      CALC [RECORD_ID3] AS [PRINT_OUT_DIRECT]
      BACK_JUMP
    END_IF

    IF [PrintOutMode]>[SEND_OUT_CHAT]
      CALL MakeNumLen5 [HeadInfo!R.Rechnungsnummer]

      ;Document-Managament-System -
      CALL DmsXmlPrintPdf [PrnVarName], [HeadInfo!R.Rechnungsnummer]
      ;Document-Managament-System -

      IF [PrintOutMode]=[SEND_OUT_EMAIL]
        CALL ActFax.PrintAdresse [PrnVarName], 'EMAIL', 'Rechnung', [ANumStr], [HeadInfo!K.Fax1], [HeadInfo!K.EMail1], [HeadInfo!K.Name1], [HeadInfo!K.PLZ], [HeadInfo!K.Ort]
        CALC [PrnStr] AS 'EMail Rechnung'

        ;Document-Managament-System +
        LIST_APPEND [DmsXml], '<attribute name="printer" value="actfax email" />'
        ;Document-Managament-System -
      ELSE
        CALL ActFax.PrintAdresse [PrnVarName], 'FAX',   'Rechnung', [ANumStr], [HeadInfo!K.Fax1], [HeadInfo!K.EMail1], [HeadInfo!K.Name1], [HeadInfo!K.PLZ], [HeadInfo!K.Ort]
        CALC [PrnStr] AS 'Fax Rechnung'

        ;Document-Managament-System +
        LIST_APPEND [DmsXml], '<attribute name="printer" value="actfax fax" />'
        ;Document-Managament-System -
      END_IF

      CALL PrintOut.OutPut [PrnVarName], 1, 'RG', [PrintOutMode], [PrintOutMode], [PrnStr]
    ELSE
      IF [RECORD_ID8]>[EPSILON]
        CALC [PrnStr] AS CON([HeadInfo!R.Rechnungsnummer],'.pdf')
        IF [PAR_STR9]<>''
          IF [VPE_VERSION]='2'
            CALL PrintOut.eDocPrintProWaiter [PrnVarName], [PAR_STR9], [PrnStr], [QRes]
          ELSE
            CALC [PrnStr] AS CON([PAR_STR9],[PrnStr])
            PRINT_SAVE [PrnVarName], [PrnStr], [QRes]
          END_IF

          ;Document-Managament-System +
          CALL DmsXmlStrAdd '<attribute name="printer" value="', [PrnStr], '" />'
          CALL DmsXmlPrintPdf [PrnVarName], [HeadInfo!R.Rechnungsnummer]
          ;Document-Managament-System -
        ELSE
          ;Document-Managament-System +
          LIST_APPEND [DmsXml], '<attribute name="printer" value="dms" />'
          CALL DmsXmlPrintPdf [PrnVarName], [HeadInfo!R.Rechnungsnummer]
          ;Document-Managament-System -
        END_IF
      ELSE
        IF [PrintOutMode]=[PRINT_OUT_PREVIEW]
          CALL PrintOut.OutPut [PrnVarName], 1, 'RG', [IP_PRINT_OUT_RG], [PrintOutMode], 'Vorschau Rechnung'
;         CALL PrintOut.Direct [PrnVarName], [HeadInfo!K.Kopien_KRG], [IP_PRINT_OUT_RG], [PrintOutMode]
          ;Document-Managament-System -
          LIST_APPEND [DmsXml], '<attribute name="printer" value="display" />'
          CALL DmsXmlPrintPdf [PrnVarName], [HeadInfo!R.Rechnungsnummer]
          ;Document-Managament-System -

          ; Prout-Datei nur ansehen, NICHT an Prout verschicken.
          GET_YES_NO 'Achtung','Mchten Sie die Rechnung an Prout senden ?',[LocNum]
          IF [LocNum]=[ID_YES]
            SCRIPT 'rg_2_file.csh', [RECORD_ID1], 0, [RECORD_ID7]
          END_IF
        ELSE
          ; Prout-Datei an Prout verschicken.
          ;Document-Managament-System -
          LIST_APPEND [DmsXml], '<attribute name="printer" value="proud" />'
          CALL DmsXmlPrintPdf [PrnVarName], [HeadInfo!R.Rechnungsnummer]
          ;Document-Managament-System -

          IF [PrnVarName]<>'ScrPrn'
            SCRIPT 'rg_2_file.csh', [RECORD_ID1], 0, [RECORD_ID7]
          END_IF
        END_IF
      END_IF
    END_IF

;   CALL PrintOut.GetSet 'STD', [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT], 'Standard-Drucker festlegen'

    ;Document-Managament-System -
    LIST_APPEND [DmsXml], '</systemAttribute>'
    LIST_APPEND [DmsXml], '</dms>'
    CALL DmsXmlSaveFile
    CALL DmsXmlStopProcess
    ;Document-Managament-System -
  END_PROC



SCRIPT_BEGIN
  IF [RECORD_ID1]<[EPSILON]
    MESSAGE 'Abbruch','Sie haben keinen Rechnung ausgewhlt.',[MESSAGE_WARNING]
  ELSE
    CALL InitVars
    CALL MainPrint
  END_IF
SCRIPT_END
