

  PROCEDURE InitVars
    VAR_MASK  WorkMask, 'qfilterh'
    VAR_BOOL  Res
    VAR_STR   QFilterStd
    VAR_NUM   GridOption
    VAR_QUERY GridQ
    VAR_FLOAT MaskID
    VAR_NUM   YNRes

    IDENTIFIER_EXIST 'STATION_INI_FILE',[Res]
    IF [Res]=FALSE
      GLOBAL_STR STATION_INI_FILE
      CALC [STATION_INI_FILE] AS CON([PRINTSET_PATH],[STATION_SHORT],'.INI')
      IF [USER_SID_SHORT]<>''
        CALC [STATION_INI_FILE] AS CON([PRINTSET_PATH],[STATION_SHORT],'_',[USER_SID_SHORT],'.INI')
      END_IF
      CALC [STATION_INI_FILE] AS LOWCASE([STATION_INI_FILE])
    END_IF

    CALC [GridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_REC_LAST]+[BROWSER_FLAG_ICON_SELECT]

    CALC [WorkMask!MASK_HOOK_SHOW]       AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE]   AS 'SaveHook'
    CALC [WorkMask!MASK_HOOK_DELETE]     AS 'DeleteHook'
    CALC [WorkMask!MASK_HOOK_GRID_OK]    AS 'GridOkHook'
    CALC [WorkMask!MASK_HOOK_POST_EDIT]  AS 'PostEditHook'
  END_PROC



  PROCEDURE PostEditHook
    IF [WorkMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='Standard'
      IF [WorkMask!Standard]
        FIELD_FLAG_ON_OFF [WorkMask],'ExecuteOnStart','','[FIELD_FLAG_PROTECTED]',''
      ELSE
        CALC [WorkMask!ExecuteOnStart] AS FALSE
        MASK_UPDATE [WorkMask]
        FIELD_FLAG_ON_OFF [WorkMask],'ExecuteOnStart','[FIELD_FLAG_PROTECTED]',''
      END_IF
    END_IF
  END_PROC



  PROCEDURE DoData2Mask
    DATA_2_MASK [WorkMask],[GridQ], TRUE
    IF [WorkMask!UserID]>[EPSILON]
      CALC [WorkMask!Privat] AS TRUE
    END_IF

    INI_READ [Res],[QFilterStd],[SCRIPT_STRING],[STATION_INI_FILE],[PAR_STR1],'QFilter'
    IF [WorkMask!Name]=[QFilterStd]
      CALC [WorkMask!Standard] AS TRUE
    ELSE
      CALC [WorkMask!Standard] AS FALSE
    END_IF

    IF [WorkMask!Standard]
      FIELD_FLAG_ON_OFF [WorkMask],'ExecuteOnStart','','[FIELD_FLAG_PROTECTED]',''
    ELSE
      FIELD_FLAG_ON_OFF [WorkMask],'ExecuteOnStart','[FIELD_FLAG_PROTECTED]',''
    END_IF

    MASK_UPDATE [WorkMask], TRUE
  END_PROC



  PROCEDURE GridOkHook
    CALL DoData2Mask
    IF [WorkMask!MASK_RECORD_ID]<=[EPSILON]
      EXIT_PROC
    END_IF

    SCRIPT 'qfilteri.csh', [WorkMask!MASK_RECORD_ID], [WorkMask!Name]
  END_PROC



  PROCEDURE RecChangeHook
    CALL DoData2Mask
  END_PROC



  PROCEDURE SetGrid VS LocStarting
    CALC [GridQ!QUERY_HOOK_REC_CHANGE] AS ''

    IF [LocStarting]<>''
      CALC [LocStarting] AS CON('STARTING WITH Name = "',[LocStarting],'"')
    END_IF

    QUERY [GridQ]
        SELECT [W40]Name,
               [H  ]ScriptName,
               [H  ]UserID,
               [H  ]StationID,
               [H  ]ExecuteOnStart,
               [H  ]RecordID,
               [H  ]RecFlag
          FROM qfilterh
         WHERE ScriptName = "[PAR_STR1]"
           AND RecordID   > 0
      ORDER BY Name
               [LocStarting]
    END_QUERY

    EXECUTE [GridQ], [Res]
    IF [Res]
      GRID_SET [WorkMask], 'GR_QFilter', [GridQ], [Res], [GridOption]
    END_IF

    CALC [GridQ!QUERY_HOOK_REC_CHANGE] AS 'RecChangeHook'

    GET_DATA [GridQ], [Res]
    IF [Res]
      CALL DoData2Mask
    END_IF
  END_PROC



  PROCEDURE ShowHook
    CALL SetGrid [PAR_STR2]
  END_PROC



  PROCEDURE SaveHook
    IF [WorkMask!MASK_RECORD_ID]<=[EPSILON]
      NEW_RECORD [Res],'qfilterh',[MaskID], TRUE, FALSE, FALSE
      IF [Res]=FALSE
        MESSAGE 'Achtung Fehler','Es konnte keine neue Filterdefinition angelegt werden',[MESSAGE_ERROR]
        FORE_JUMP
      END_IF
      CALC [WorkMask!MASK_RECORD_ID] AS [MaskID]
      MASK_UPDATE [WorkMask]
    END_IF

    LOCAL_QUERY LocQ
    LOCAL_FLOAT LocUserID, [ACT_MIT_ID]

    IF [WorkMask!Privat]=FALSE
      CALC [LocUserID] AS 0.0
    END_IF

    IF [WorkMask!Standard]
      CALC [QFilterStd] AS [WorkMask!Name]
    ELSE
      CALC [QFilterStd] AS ''
    END_IF
    INI_WRITE [Res],[QFilterStd],[SCRIPT_STRING],[STATION_INI_FILE],[PAR_STR1],'QFilter'

    QUERY [LocQ]
      UPDATE qfilterh
         SET Name           = "[WorkMask!Name]",
             ScriptName     = "[PAR_STR1]",
             UserID         =  [LocUserID|R0,0],
             StationID      =  [WorkMask!StationID|R0,0],
             CreateDate     =  [SQL_DATE_QUOTES_4_MODIFY][WorkMask!CreateDate|R0,[SQL_DATE_PICTURE_4_MODIFY]][SQL_DATE_QUOTES_4_MODIFY],
             ExecuteOnStart =  [SQL_BOOLEAN_QUOTATION][WorkMask!ExecuteOnStart][SQL_BOOLEAN_QUOTATION]
       WHERE RecordID       =  [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY
    EXECUTE [LocQ], [Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Filterdefinition konnte nicht gespeichert werden',[MESSAGE_ERROR]
    END_IF

    FORE_MARK

    CALL SetGrid [WorkMask!Name]
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE DeleteHook
    IF [WorkMask!MASK_RECORD_ID]<=[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst eine Filterdefinition zum Lschen aus',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die Filterdefinition wirklich lschen',[YNRes]
    IF [YNRes]<>[ID_YES]
      FORE_JUMP
    END_IF

    LOCAL_QUERY LocQ

    QUERY [LocQ]
      DELETE
        FROM qfilterh
       WHERE RecordID =  [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY
    EXECUTE [LocQ], [Res]
    IF [Res]
      MESSAGE 'Information','Die Filterdefinition wurde gelscht'
    ELSE
      MESSAGE 'Achtung Fehler','Die Filterdefinition konnte nicht gelscht werden',[MESSAGE_ERROR]
    END_IF

    CALC [WorkMask!MASK_ACTION] AS 1

    CALL SetGrid ''
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
