;===============================================================================
; Filterdefinition
; qfilteri.msk
;
;===============================================================================



  PROCEDURE InitVars
    VAR_MASK    WorkMask, 'qfilteri'
    VAR_NUM     YNRes

    VAR_BOOL    Res

    VAR_QUERY   SQ
    VAR_BOOL    SQRes

    VAR_STR     TmpStr
    VAR_STR     TableID
    VAR_STR     FieldName
    VAR_NUM     FieldType
    VAR_NUM     FieldSize

    VAR_QUERY   DelQ
    VAR_BOOL    DelQRes

    VAR_NUM     FieldFlag

    VAR_QUERY   Grid
    VAR_NUM     GridOption
  END_PROC



  PROCEDURE InitHooks
    CALC [WorkMask!MASK_HOOK_SHOW]        AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_DELETE]      AS 'DeleteHook'
    CALC [WorkMask!MASK_HOOK_POST_SAVE]   AS 'PostSaveHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE]    AS 'PreSaveHook'
    CALC [WorkMask!MASK_HOOK_POST_CLEAR]  AS 'PostClearHook'
    CALC [WorkMask!MASK_HOOK_EXIT]        AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_POST_EDIT]   AS 'PostEditHook'
    CALC [WorkMask!MASK_HOOK_IS_READY]    AS 'IsReadyHook'

    CALC [GridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_OK_ON_STARTING]+[BROWSER_FLAG_SELECT_ALLOWED]
    MASK_UPDATE  [WorkMask]
    MASK_PROCESS [WorkMask]
  END_PROC



  PROCEDURE GridOk
    DATA_2_MASK [WorkMask], [Grid]
    LIST_STR_FIND [WorkMask!9900211], [WorkMask!Fieldname]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE GridSet
    QUERY_LOAD [Grid], [Res], 'qfilteri001'
    EXECUTE [Grid],[Res]
    IF [Res]
      GRID_SET [WorkMask], 'D.Grid', [Grid], [Res], [GridOption]
      CALC [WorkMask!MASK_HOOK_GRID_OK] AS 'GridOK'
    END_IF
  END_PROC



  PROCEDURE SetOneFieldProtected VAR_STR OneFieldName, VAR_BOOL ProtectIt
    FIELD_FLAG_GET [WorkMask], [OneFieldName], [FieldFlag]
    FLAG_SET [FieldFlag],[FIELD_FLAG_PROTECTED],[ProtectIt]
    FIELD_FLAG_SET [WorkMask], [OneFieldName], [FieldFlag]
  END_PROC



  PROCEDURE SetTableFields
    LIST_STR_GET [WorkMask!9900111],[WorkMask!TableName]
    MASK_UPDATE  [WorkMask]

    IF [WorkMask!TableName]<>''
      LIST_CLR [WorkMask!9900211]
      LIST_ITEM_SET [WorkMask!9900211], 0
      MASK_UPDATE   [WorkMask]
      CALL SetOneFieldProtected '9900211', TRUE

      WAIT_CURSOR TRUE
      PANEL_INFO 'Laden der Tabellen-Felder'

      CALC [TableID] AS ''
      QUERY [SQ]
        SELECT DefinedID
          FROM tablefld
         WHERE UseDefID  =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
           AND TableName = "[WorkMask!TableName]"
      END_QUERY
      EXECUTE [SQ],[SQRes]
      IF [SQRes]
        GET_DATA [SQ],[SQRes]
        IF [SQRes]
          CALC [TableID] AS CON('WHERE RecordID = ',[SQ!DefinedID|R0,0])
        END_IF
      END_IF

      QUERY [SQ]
        SELECT *
          FROM [WorkMask!TableName]
               [TableID]
      END_QUERY
      EXECUTE [SQ],[SQRes]
      IF [SQRes]=FALSE
        PANEL_INFO ''
        WAIT_CURSOR FALSE
        MESSAGE 'Abbruch','Die Tabellen-Felder knnen nicht gelesen werden',[MESSAGE_ERROR]
        CALC [WorkMask!FieldName] AS ''
        EXIT_PROC
      END_IF

      QUERY_DESCR_TOP [SQ], [FieldName], [FieldType]
      WHILE [FieldName]<>''
        IF [FieldName]<>''
          LIST_APPEND [WorkMask!9900211], [FieldName]
        END_IF

        QUERY_DESCR_NEXT [SQ], [FieldName], [FieldType]
      END_WHILE

      LIST_SORT [WorkMask!9900211]

      LIST_ITEM_SET [WorkMask!9900211], 1

      LIST_STR_GET [WorkMask!9900111],[WorkMask!TableName]
      IF [WorkMask!Fieldname]<>[WorkMask!TableName]
        LIST_STR_FIND [WorkMask!9900211], [WorkMask!Fieldname]
      END_IF

      LIST_STR_GET [WorkMask!9900211],[WorkMask!Fieldname]
      MASK_UPDATE  [WorkMask]

      CALL SetOneFieldProtected '9900211', FALSE

      PANEL_INFO ''
      WAIT_CURSOR FALSE
    ELSE
      LIST_CLR [WorkMask!9900211]
      LIST_ITEM_SET [WorkMask!9900211], 0
      CALC [WorkMask!Fieldname] AS ''
      MASK_UPDATE [WorkMask]
      CALL SetOneFieldProtected '9900211', TRUE
    END_IF
  END_PROC



  PROCEDURE PostEditHook
    IF [WorkMask!MASK_ACT_FIELD_MODIFIED]=FALSE
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_ID]=9900111

      CALL SetTableFields

      MASK_NEXT_FOCUS [WorkMask], '9900210'
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_ID]=9900211
      LIST_STR_GET [WorkMask!9900211],[WorkMask!Fieldname]
      MASK_UPDATE  [WorkMask]
      MASK_NEXT_FOCUS [WorkMask], '9900220'
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE ShowHook
    CALC [WorkMask!MASK_QUERY_REFRESH] AS FALSE
    CALL GridSet
  END_PROC



  PROCEDURE IsReadyHook
    CALC [WorkMask!MASK_HOOK_IS_READY] AS ''

    LIST_CLR      [WorkMask!9900111]
    LIST_ITEM_SET [WorkMask!9900111], 0
    MASK_UPDATE   [WorkMask]

    LOCAL_NUM LocLnAct
    LOCAL_NUM LocLnMax
    LOCAL_STR LocStr
    LIST_ITEM_GET [QFILTER_TABLES],[LocLnAct],[LocLnMax]
    IF [LocLnMax]>0
      CALC [LocLnAct] AS 1
      WHILE [LocLnAct]<=[LocLnMax]
        LIST_STR_GET [QFILTER_TABLES],[LocStr],[LocLnAct]
        LIST_APPEND [WorkMask!9900111], [LocStr]
        INC [LocLnAct]
      END_WHILE
      LIST_ITEM_SET [WorkMask!9900111], 1
      MASK_UPDATE   [WorkMask]

      CALL SetTableFields
      MASK_NEXT_FOCUS [WorkMask], '9900210'
    END_IF

    CALC [WorkMask!MASK_HEAD_LINE] AS CON('Filterdefinitionsdetails      "',[PAR_STR2],'"')
    MASK_UPDATE [WorkMask], TRUE
  END_PROC



  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE PreClearHook
    CALC [TmpStr] AS [WorkMask!TableName]
  END_PROC



  PROCEDURE PostClearHook
    LIST_STR_FIND [WorkMask!9900111],[TmpStr]
    MASK_UPDATE   [WorkMask]

    CALL SetTableFields
    MASK_NEXT_FOCUS [WorkMask], '9900210'
  END_PROC



  PROCEDURE PreSaveHook
    CALC [TableID] AS ''
    QUERY [SQ]
      SELECT DefinedID
        FROM tablefld
       WHERE UseDefID  =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
         AND TableName = "[WorkMask!TableName]"
    END_QUERY
    EXECUTE [SQ],[SQRes]
    IF [SQRes]
      GET_DATA [SQ],[SQRes]
      IF [SQRes]
        CALC [TableID] AS CON('WHERE RecordID = ',[SQ!DefinedID|R0,0])
      END_IF
    END_IF

    QUERY [SQ]
      SELECT [WorkMask!FieldName]
        FROM [WorkMask!TableName]
             [TableID]
    END_QUERY
    EXECUTE [SQ],[SQRes]
    IF [SQRes]=FALSE
      MESSAGE 'Abbruch','Die Tabellen-Felder knnen nicht gelesen werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY_DESCR_TOP [SQ], [FieldName], [FieldType], [FieldSize]
    CALC [WorkMask!FieldType] AS [FieldType]
    CALC [WorkMask!FieldSize] AS [FieldSize]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE PostSaveHook
    MASK_COMMAND  [WorkMask], [MASK_COMMAND_CLEAR]
    QUERY_REFRESH [Grid], FALSE
  END_PROC



  PROCEDURE DeleteHook
    IF [WorkMask!MASK_RECORD_ID]<=[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst einen Datensatz aus',[MESSAGE_WARNING]
      CALC [WorkMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    GET_YES_NO 'Achtung','Sind Sie sicher, da diese Filterdefinition gelscht werden soll ?',[YNRes]
    IF [YNRes]<>[ID_YES]
      CALC [WorkMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    ; Filterdefintion lschen
    QUERY [DelQ]
      DELETE
        FROM qfilteri
       WHERE RecordID = [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY
    EXECUTE [DelQ],[DelQRes]
    IF [DelQRes]=FALSE
      MESSAGE 'Achtung Fehler','Die Filterdefinition konnte nicht gelscht werden',[MESSAGE_ERROR]
      CALC [WorkMask!MASK_ACTION] AS 1
      EXIT_PROC
    END_IF

    MASK_COMMAND [WorkMask], [MASK_COMMAND_CLEAR]
    CALL GridSet
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE Main
    CALL InitVars
    CALL InitHooks
  END_PROC



SCRIPT_BEGIN
  CALL Main
SCRIPT_END