  ; Kopiert ein existierendes Rechtemodell und kann dieses auch sofort einem Mitarbeiter zuordnen
  ;
  ; DD 04.04.2007


  PROCEDURE InitVars
    VAR_NUM     YNRes
    VAR_NUM     Max
    VAR_NUM     Cnt
    VAR_STR     Inf
    VAR_BOOL    Res
    VAR_MASK    WorkMask, 'RightsCopyDlg'
    VAR_FLOAT   RightModID
    VAR_FLOAT   RightPosID
    VAR_QUERY   Q
    VAR_BROWSER B
    VAR_STR     UserTableName
    VAR_STR     UserClause

    INI_READ [Res], [UserTableName], [SCRIPT_STRING], [APPLICATION_INI_FILE], 'UserTableName',     'Config'
    INI_READ [Res], [UserClause],    [SCRIPT_STRING], [APPLICATION_INI_FILE], 'UserClause',        'Config'
    IF [UserClause]<>''
      CALC [UserClause] AS CON('AND ',[UserClause])
    END_IF

    CALC [WorkMask!MASK_HOOK_BUTTON] AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_EXIT]   AS 'ExitHook'
  END_PROC


  PROCEDURE DeleteModel
    IF [RightModID]<=[EPSILON]
      EXIT_PROC
    END_IF

    QUERY [B]
      DELETE FROM rightmod WHERE RecordID = [RightModID|R0,0]
    END_QUERY
    EXECUTE [B],[Res]

    QUERY [B]
      DELETE FROM rightpos WHERE RightModID = [RightModID|R0,0]
    END_QUERY
    EXECUTE [B],[Res]
  END_PROC


  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_QuellName'
      QUERY [B]
          SELECT ModellName, RecordID
            FROM rightmod
           WHERE RecordID > 1000
        ORDER BY ModellName
      END_QUERY

      VIEW [B],[Res], 'Rechtemodelle'
      IF [Res]
        CALC [WorkMask!QuellName] AS [B!ModellName]
        CALC [WorkMask!QuellID]   AS [B!RecordID]
      ELSE
        IF [WorkMask!QuellName]<>''
          CALC [YNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?','Mchten Sie die bestehende Zuordnung aufheben?',[YNRes]
          IF [YNRes]=[ID_YES]
            CALC [WorkMask!QuellName] AS ''
            CALC [WorkMask!QuellID]   AS 0.0
          END_IF
        END_IF
      END_IF

      MASK_UPDATE [WorkMask]

    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_MitName'
      CALC [RightModID] AS 0.0

      QUERY [B]
          SELECT Name1, Name2, RecordID
            FROM [UserTableName]
           WHERE RecordID > 1000
                 [UserClause]
        ORDER BY Name1, Name2
      END_QUERY

      VIEW [B],[Res], 'Mitarbeiter'
      IF [Res]
        CALC [WorkMask!MitName] AS CON([B!Name1],' ',[B!Name2])
        CALC [WorkMask!MitID]   AS [B!RecordID]
      ELSE
        IF [WorkMask!MitName]<>''
          CALC [YNRes] AS [ID_NO]
          GET_YES_NO 'Achtung! Sind Sie sicher?','Mchten Sie die bestehende Zuordnung aufheben?',[YNRes]
          IF [YNRes]=[ID_YES]
            CALC [WorkMask!MitName] AS ''
            CALC [WorkMask!MitID]   AS 0.0
          END_IF
        END_IF
      END_IF

      MASK_UPDATE [WorkMask]

    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_Copy'
      IF [WorkMask!QuellID]<=[EPSILON]
        MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst ein Modell aus, das kopiert werden soll (Quelle).',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      IF [WorkMask!ZielName]=''
        MESSAGE 'Achtung Abbruch','Bitte geben Sie zunchst einen Namen fr das neue Modell an (Ziel).',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      IF [WorkMask!ZielName]=[WorkMask!QuellName]
        MESSAGE 'Achtung Abbruch','Quell- und Ziel-Name mssen sich unterscheiden.',[MESSAGE_WARNING]
        EXIT_PROC
      END_IF

      QUERY [B]
        SELECT RecordID
          FROM rightmod
         WHERE ModellName = "[WorkMask!ZielName]"
           AND RecordID   >  1000
      END_QUERY

      EXECUTE [B],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Rechte-Modelle konnten nicht geprft werden.',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      GET_DATA [B],[Res]
      IF [Res]
        CALC [YNRes] AS [ID_NO]
        GET_YES_NO 'Achtung! Sind Sie sicher?','Der von Ihnen angegebene Name fr das neue Modell ist bereits vergeben (Ziel).|Mchten Sie dieses bereits bestehende Modell nun ersetzten?',[YNRes]
        IF [YNRes]<>[ID_YES]
          EXIT_PROC
        END_IF

        CALC [RightModID] AS [B!RecordID]

        QUERY [B]
          DELETE FROM rightpos WHERE RightModID = [RightModID|R0,0]
        END_QUERY
        EXECUTE [B],[Res]
      END_IF

      IF [RightModID]<=[EPSILON]
        NEW_RECORD [Res],'rightmod',[RightModID], TRUE, FALSE, FALSE
        IF [Res]=FALSE
          MESSAGE 'Achtung Abbruch','Es konnte kein neues Rechte-Modell angelegt werden.',[MESSAGE_ERROR]
          EXIT_PROC
        END_IF

        QUERY [B]
          UPDATE rightmod
             SET ModellName = "[WorkMask!ZielName]"
           WHERE RecordID   =  [RightModID|R0,0]
        END_QUERY

        EXECUTE [B],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Abbruch','Das neue Rechte-Modell konnte nicht initialisiert werden.',[MESSAGE_ERROR]
          CALL DeleteModel
          EXIT_PROC
        END_IF
      END_IF


      QUERY [Q]
        SELECT MenuItem, RightFlag
          FROM rightpos
         WHERE RightModID = [WorkMask!QuellID|R0,0]
      END_QUERY

      EXECUTE [Q],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Einstellungen des Quell-Rechte-Modells konnten nicht geladen werden.',[MESSAGE_ERROR]
        CALL DeleteModel
        EXIT_PROC
      END_IF

      GET_DATA [Q],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Das Quell-Rechte-Modells enthlt keine Daten.',[MESSAGE_ERROR]
        CALL DeleteModel
        EXIT_PROC
      END_IF

      QUERY_COUNT [Q],[Max]
      CALC [Cnt] AS 0

      WHILE [Res]
        INC  [Cnt]
        CALC [Inf] AS CON('Eintrag ',[Cnt],' / ',[Max])
        WAIT_INFO 'Bitte warten, das Rechtemodell wird kopiert...',[Inf]

        NEW_RECORD [Res],'rightpos',[RightPosID], TRUE, FALSE, FALSE
        IF [Res]=FALSE
          END_WAIT
          MESSAGE 'Achtung Abbruch','Es konnte kein neuer Eintrag in der Rechte-Tabelle erstellt werden.',[MESSAGE_ERROR]
          CALL DeleteModel
          EXIT_PROC
        END_IF

        QUERY [B]
          UPDATE rightpos
             SET MenuItem   = [Q!MenuItem],
                 RightFlag  = [Q!RightFlag],
                 RightModID = [RightModID|R0,0]
           WHERE RecordID   = [RightPosID|R0,0]
        END_QUERY
        EXECUTE [B],[Res]
        IF [Res]=FALSE
          END_WAIT
          MESSAGE 'Achtung Abbruch','Ein neuer Rechte-Eintrag konnte nicht initialisiert werden.',[MESSAGE_ERROR]
          CALL DeleteModel
          EXIT_PROC
        END_IF

        GET_DATA [Q],[Res]
      END_WHILE

      IF [WorkMask!MitID]>[EPSILON]
        QUERY [B]
          UPDATE [UserTableName]
             SET RightID  = [RightModID|R0,0]
           WHERE RecordID = [WorkMask!MitID|R0,0]
        END_QUERY

        EXECUTE [B],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Abbruch','Das neue Modell konnte dem Mitarbeiter nicht zugeordnet werden.',[MESSAGE_ERROR]
          EXIT_PROC
        END_IF
      END_IF

      END_WAIT

      MESSAGE 'Erfolg!','Das Rechte-Modell wurde kopiert'
    END_IF
  END_PROC



  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

