DROP TABLE [SQL_IF_EXISTS] stationnames;

CREATE TABLE stationnames
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],

      StationID                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      StationIDStr              [SQL_DEFINE_STRING]   ( 13) [SQL_DEFINE_STRING_END],
      StationShort              [SQL_DEFINE_STRING]   ( 10) [SQL_DEFINE_STRING_END],
      StationName               [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      UserSID                   [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
      UserSIDShort              [SQL_DEFINE_STRING]   ( 10) [SQL_DEFINE_STRING_END]

      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndStaNaRecordID      ON stationnames (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndStaNaVirtualDelID  ON stationnames (VirtualDelID);
CREATE        INDEX IndStaNaStationID     ON stationnames (StationID);
CREATE        INDEX IndStaNaStationShort  ON stationnames (StationShort);
CREATE        INDEX IndStaNaUserSID       ON stationnames (UserSID);
CREATE        INDEX IndStaNaUserSIDShort  ON stationnames (UserSIDShort);
CREATE UNIQUE INDEX IndStaNaComplete      ON stationnames (StationShort,UserSIDShort);


DELETE FROM stationnames WHERE StationShort = "" AND UserSIDShort = "";

