  ; Korrekturroutine fr folgenden Fall:
  ;
  ; Es wurde eine MySQL-Datenbank ausgelesen und mit dem falschen Zeichensatz wieder
  ; eingelesen. Danach sind alle Sonderzeichen wie z.B. auch die Umlaute nur noch als
  ; ? (Fragezeichen) in den Stringfeldern zu finden. Diese knnen auch nicht mit dem
  ; Umstellen des Zeichensatzes wieder gerettet werden.
  ;
  ; Daher sammelt dieses Script alle "defekten" Worte (nicht Strings - sondern WORTE
  ; in Strings) in einer Tabelle mit dem Namen Umlautworte. Schlielich knnen die
  ; Worte extrem schnell korrigiert werden. Zuletzt knnen die Korrekturen in die
  ; Datenbank zurckgeschrieben werden. Kein WORT wird doppelt erfasst!
  ;
  ;
  ; 1. Voraussetzung: die Tabelle "umlautworte" wurde angelegt!
  ;
  ; 2. Beim ersten Start den Knopf "1=Starten" aufrufen. Es werden ale Worte aller
  ;    Stringfelder aller Tabellen gesucht, in denen ein ? (Fragezeichen) vorkommt.
  ;    Doppelte Worte werden gefunden und gemeinsam verarbeitet. Man muss also ein
  ;    doppeltes Wort nicht zweimal manuell korrigieren.
  ;
  ; 3. Danach das Script neu aufrufen (am besten vorher die Knpfe in der Maske un-
  ;    sichtbar machen, dann knnen die Mitarbeiter nicht versehentlich etwas falsch
  ;    machen) und die einzelnen Zeichenketten berschreiben und somit korrigieren,
  ;    bis alle Worte manuell abgearbeitet wurden. Mit einem einfachen "Enter"
  ;    schliet man jeweils die Eingabe ab. Das Korrigieren kann mehrfach unterbrochen
  ;    werden. Die Routine setzt jeweils beim nchsten zu korrigierenden Wort wieder
  ;    auf.
  ;
  ; 4. Danach das Script neu aufrufen (und die Knpfe wieder sichtbar machen) und den
  ;    Knopf "3=bernahme" anklicken und die Korrektur bernehmen.
  ;
  ;
  ; Legende: DD, 02.11.2009


  PROCEDURE InitVars
    VAR_MASK    WorkMask,'UmlauteReparaturDlg'
    VAR_NUM     LnAct
    VAR_NUM     LnCnt
    VAR_NUM     Words
    VAR_NUM     StrLen
    VAR_NUM     StrPos
    VAR_NUM     WrdCnt
    VAR_NUM     YNRes
    VAR_STR     TmpStr
    VAR_STR     RepStr
    VAR_STR     ResStr
    VAR_STR     InfStr
    VAR_STR     CntStr
    VAR_STR     LowTableName
    VAR_STR     SizeStr
    VAR_STR     IdxStr
    VAR_STR     IdxInf
    VAR_STR     FieldName
    VAR_STR     UpFieldName
    VAR_NUM     FieldType
    VAR_NUM     DataSize
    VAR_BOOL    IsIndex
    VAR_LIST    TList
    VAR_QUERY   Q
    VAR_QUERY   IQ
    VAR_BOOL    AllTables
    VAR_BOOL    First
    VAR_BOOL    Res
    VAR_BOOL    UseDefID
    VAR_FLOAT   DefID
    VAR_FLOAT   NewID
    VAR_STR     VarBraOn
    VAR_STR     VarBraOff


    CALC [VarBraOn]  AS '['
    CALC [VarBraOff] AS ']'

    LIST_ITEM_GET [WorkMask!Datenbank],[LnAct],[LnCnt]
    IF [LnCnt]>0
      LIST_CLR    [TList]
      LIST_APPEND [TList], 'ALL_TABLES'

      CALC [LnAct]  AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [WorkMask!Datenbank],[TmpStr],[LnAct]
        LIST_APPEND [TList],[TmpStr]
        INC  [LnAct]
      END_WHILE

      LIST_CLR [WorkMask!Datenbank]
      LIST_ITEM_GET [TList],[LnAct],[LnCnt]
      IF [LnCnt]>0
        CALC [LnAct]  AS 1
        WHILE [LnAct]<=[LnCnt]
          LIST_STR_GET [TList],[TmpStr],[LnAct]
          LIST_APPEND [WorkMask!Datenbank],[TmpStr]
          INC  [LnAct]
        END_WHILE
      END_IF

      LIST_CLR [TList]
      CALC [WorkMask!Datenbank] AS 'ALL_TABLES'
      MASK_UPDATE [WorkMask], TRUE
    END_IF

    CALC [WorkMask!MASK_HOT_KEY_LIST]  AS '13@1'

    CALC [WorkMask!MASK_HOOK_BUTTON]   AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_EXIT]     AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_KEY]      AS 'KeyHook'
    CALC [WorkMask!MASK_HOOK_IS_READY] AS 'IsReadyHook'
  END_PROC



  PROCEDURE ExitHook
    MASK_CLEAR [WorkMask]
  END_PROC



  PROCEDURE KeyHook
    IF [WorkMask!MASK_ACT_KEY]<>13
      EXIT_PROC
    END_IF

    IF [WorkMask!UmlautwortKorrekt]=''
      CALC [YNRes] AS [ID_NO]
      GET_YES_NO 'Achtung! Sind Sie sicher?!','Soll das Wort beim spteren Ersetzten gelscht werden?',[YNRes]
      IF [YNRes]<>[ID_YES]
        EXIT_PROC
      END_IF
    ELSE
      CALC [StrPos] AS POS('?',[WorkMask!UmlautwortKorrekt])
      IF [StrPos]>0
        CALC [YNRes] AS [ID_NO]
        GET_YES_NO 'Achtung! Sind Sie sicher?!','Soll das angezeigte Fragezeichen spter NICHT ersetzt werden?',[YNRes]
        IF [YNRes]<>[ID_YES]
          EXIT_PROC
        END_IF
      END_IF
    END_IF

    QUERY [IQ]
      UPDATE umlautworte
         SET UmlautwortKorrekt = "[WorkMask!UmlautwortKorrekt]",
             EventFlag         =  1
       WHERE RecordID          =  [Q!RecordID|R0,0]
    END_QUERY
    EXECUTE [IQ],[Res]


    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Sie sind fertig','Alle Worte mit einem "?" wurden abgearbeitet'
      MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
      EXIT_PROC
    END_IF

    DEC [Words]
    CALC [WorkMask!MASK_HEAD_LINE]    AS CON('Zu bearbeitende Worte = ',[Words])
    CALC [WorkMask!UmlautwortKorrekt] AS [Q!UmlautwortKorrekt]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE IsReadyHook
    CALC [WorkMask!MASK_HOOK_IS_READY] AS ''

    ; Ist berhaupt schon mal die Liste der Worte erstellt worden?
    LOCAL_NUM LocCnt
    QUERY [Q]
      SELECT *
        FROM umlautworte
       WHERE RecordID   > 0
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
      EXIT_PROC
    END_IF
    QUERY_COUNT [Q],[LocCnt]
    IF [LocCnt]=0
      EXIT_PROC
    END_IF


    ; Was ist noch zu tun?
    QUERY [Q]
        SELECT *
          FROM umlautworte
         WHERE EventFlag <> 1
           AND RecordID   > 0
      ORDER BY UmlautwortDefekt
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Words]
    IF [Words]=0
      MESSAGE 'Achtung Sie sind fertig','Alle Worte mit einem "?" wurden abgearbeitet'
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [WorkMask!MASK_HEAD_LINE]    AS CON('Zu bearbeitende Worte = ',[Words])
    CALC [WorkMask!UmlautwortKorrekt] AS [Q!UmlautwortKorrekt]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE InitListVars
    CALC [AllTables]  AS FALSE
    CALC [First]      AS TRUE
    CALC [WAIT_BREAK] AS FALSE

    LIST_CLR    [TList]
  END_PROC



  PROCEDURE GetStringFields
    CALL InitListVars

    LIST_ITEM_GET [WorkMask!Datenbank],[LnAct],[LnCnt]
    IF [LnCnt]<=0
      EXIT_PROC
    END_IF

    IF [LnAct]<=0
      CALC [LnAct]  AS 1
    END_IF

    WAIT_CURSOR TRUE
    CALC [WAIT_BREAK] AS FALSE

    WAIT_INFO 'Bitte warten...','Alle Tabellen werden auf Stringfelder untersucht',FALSE,65,3

    WHILE [LnAct]<=[LnCnt]
      LIST_STR_GET [WorkMask!Datenbank],[TmpStr],[LnAct]
      CALC [TmpStr] AS TRIM([TmpStr])

      IF [TmpStr]<>''
        CALC [LowTableName] AS LOWCASE([TmpStr])

        IF [First]
          IF [TmpStr]='ALL_TABLES'
            CALC [AllTables] AS TRUE
          END_IF
        END_IF

        IF [TmpStr]<>'ALL_TABLES'
          CALC [InfStr] AS CON('Tabelle "',[TmpStr],'" wird untersucht')
          WAIT_INFO 'Bitte warten...',[InfStr],FALSE,65,3


          CALC [UseDefID] AS FALSE
          QUERY [Q]
            SELECT DefinedID
              FROM TableFld
             WHERE UseDefID  = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
               AND TableName = "[TmpStr]"
          END_QUERY
          EXECUTE [Q],[Res]
          IF [Res]
            GET_DATA [Q],[Res]
            IF [Res]
              CALC [UseDefID] AS TRUE
              CALC [DefID]    AS [Q!DefinedID]
            END_IF
          END_IF

          QUERY [Q]
            SELECT * FROM [TmpStr]
          END_QUERY

          IF [UseDefID]
            CALC [TmpStr] AS CON('WHERE RecordID = ',[DefID|R0,0])
            QUERY_ADD_STRING [Q], 255, [TmpStr]
          END_IF

          EXECUTE [Q],[Res]

          CALC [StrLen] AS POS('_',[TmpStr])
          IF [StrLen]>0
            CALC [Res] AS FALSE
          END_IF

          IF [Res]
            QUERY_DESCR_TOP [Q], [UpFieldName], [FieldType], [DataSize]
            IF [UpFieldName]<>''
              WHILE [UpFieldName]<>''
                IF [FieldType]=1
                  DEC [DataSize]

                  CALC [Res] AS TRUE
                  IF [SQL_SINGLE_CHAR_AS_BOOL]
                    IF [DataSize]<=3
                      CALC [Res] AS FALSE
                    END_IF
                  END_IF

                  IF [Res]
                    CALC [InfStr] AS CON([LowTableName],'|',[UpFieldName])
                    LIST_APPEND [TList], [InfStr]
                  END_IF
                END_IF

                QUERY_DESCR_NEXT [Q], [UpFieldName], [FieldType], [DataSize]
              END_WHILE
            END_IF
          END_IF
        END_IF
      END_IF

      INC  [LnAct]

      CALC [First] AS FALSE

      IF [AllTables]=FALSE
        CALC [LnAct] AS [LnCnt] + 1
      END_IF
    END_WHILE

    END_WAIT
    WAIT_CURSOR FALSE
  END_PROC



  PROCEDURE FindeUmlautWorte
    QUERY [Q]
      SELECT DISTINCT [UpFieldName]
        FROM [LowTableName]
       WHERE [UpFieldName] <> ""
         AND [UpFieldName] LIKE "[SQL_WILD_CARD_MULTI]?[SQL_WILD_CARD_MULTI]"
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    WHILE [Res]
      CALC [InfStr] AS [Q!DISTINCT[UpFieldName]]
      CALC [InfStr] AS TRIM([Q!DISTINCT[UpFieldName]])

      IF [InfStr]<>''
        CALC [StrPos] AS POS('  ',[InfStr])
        WHILE [StrPos]>0
          CALC [InfStr] AS REPLACE([InfStr],'  ',' ')
          IF [InfStr]=''
            CALC  [StrPos] AS 0
          ELSE
            CALC [StrPos] AS POS('  ',[InfStr])
          END_IF
        END_WHILE

        CALC [WrdCnt] AS 1
        CALC [TmpStr] AS PART([InfStr],[WrdCnt],' ')
        WHILE [TmpStr]<>''
          CALC [StrPos] AS POS('?',[TmpStr])
          IF [StrPos]>0
            CALC [NewID] AS [NewID] + 1
            QUERY [IQ]
              INSERT INTO umlautworte (RecordID,UmlautwortDefekt) VALUES ([NewID|R0,0],"[TmpStr]")
            END_QUERY
            EXECUTE [IQ],[Res]

            IF [Res]
              INC [Words]
              QUERY [IQ]
                UPDATE umlautworte
                   SET IDUser            = 0,
                       LevelUser         = 0,
                       Mandant           = 0,
                       UpdateID          = 0,
                       UpdateTime        = 0,
                       RecFlag           = 0,
                       EventFlag         = 0,
                       VirtualDelID      = 0,
                       VirtualDelUserIdx = 0,
                       UmlautwortKorrekt = ""
                 WHERE RecordID          = [NewID|R0,0]
              END_QUERY
              EXECUTE [IQ],[Res]
            END_IF
          END_IF

          INC  [WrdCnt]
          CALC [TmpStr] AS PART([InfStr],[WrdCnt],' ')
        END_WHILE
      END_IF

      GET_DATA [Q],[Res]
    END_WHILE
  END_PROC



  PROCEDURE ErsetzteUmlautWorte
    QUERY [Q]
      SELECT DISTINCT [UpFieldName]
        FROM [LowTableName]
       WHERE [UpFieldName] <> ""
         AND [UpFieldName] LIKE "[SQL_WILD_CARD_MULTI]?[SQL_WILD_CARD_MULTI]"
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    WHILE [Res]
      CALC [ResStr] AS ''
      CALC [InfStr] AS [Q!DISTINCT[UpFieldName]]
      CALC [InfStr] AS TRIM([Q!DISTINCT[UpFieldName]])

      IF [InfStr]<>''
        CALC [StrPos] AS POS('  ',[InfStr])
        WHILE [StrPos]>0
          CALC [InfStr] AS REPLACE([InfStr],'  ',' ')
          IF [InfStr]=''
            CALC  [StrPos] AS 0
          ELSE
            CALC [StrPos] AS POS('  ',[InfStr])
          END_IF
        END_WHILE

        CALC [WrdCnt] AS 1
        CALC [TmpStr] AS PART([InfStr],[WrdCnt],' ')
        WHILE [TmpStr]<>''
          CALC [StrPos] AS POS('?',[TmpStr])
          IF [StrPos]>0
            QUERY [IQ]
              SELECT UmlautwortKorrekt
                FROM umlautworte
               WHERE UmlautwortDefekt   = "[TmpStr]"
                 AND UmlautwortKorrekt <> UmlautwortDefekt
                 AND RecordID           > 1000
            END_QUERY
            EXECUTE [IQ],[Res]
            IF [Res]
              GET_DATA [IQ],[Res]
              IF [Res]
                CALC [TmpStr] AS [IQ!UmlautwortKorrekt]
              END_IF
            END_IF
          END_IF

          CALC [ResStr] AS CON([ResStr],[TmpStr],' ')

          INC  [WrdCnt]
          CALC [TmpStr] AS PART([InfStr],[WrdCnt],' ')
        END_WHILE

        CALC [ResStr] AS TRIM([ResStr])
        IF [InfStr]<>[ResStr]
          QUERY [IQ]
            UPDATE [LowTableName]
               SET [UpFieldName]  = "[ResStr]"
             WHERE [UpFieldName]  = "[InfStr]"
          END_QUERY
          EXECUTE [IQ],[Res]
        END_IF
      END_IF

      GET_DATA [Q],[Res]
    END_WHILE
  END_PROC



  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_Start'
      CALC [YNRes] AS [ID_NO]
      GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie wirklich die Liste der Worte mit defekten Umlauten neu erstellen lassen?',[YNRes]
      IF [YNres]<>[ID_YES]
        EXIT_PROC
      END_IF

      CALL GetStringFields
      LIST_ITEM_GET [TList],[LnAct],[LnCnt]
      IF [LnCnt]<=0
        EXIT_PROC
      END_IF

      WAIT_INFO 'Bitte warten...','Die Stringfelder werden untersucht',FALSE,65,3

      ACT_REC_ID [NewID]
      CALC [Words] AS 0
      QUERY [IQ]
        SELECT COUNT(RecordID) FROM umlautworte WHERE RecordID > 0
      END_QUERY
      EXECUTE [IQ],[Res]
      IF [Res]
        GET_DATA [IQ],[Res]
        IF [Res]
          CALC [Words] AS [IQ!COUNT(RecordID)]
        END_IF
      END_IF

      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [TList],[TmpStr],[LnAct]
        CALC [TmpStr] AS TRIM([TmpStr])
        CALC [LowTableName] AS PART([TmpStr],1,'|')
        CALC [UpFieldName]  AS PART([TmpStr],2,'|')
        CALC [InfStr] AS CON('Untersuchen der Tabelle "',[LowTableName],'" und des Feldes "',[UpFieldName],'"  (Worte bisher ',[Words],')')
        WAIT_INFO 'Bitte warten...',[InfStr],FALSE,65,3
        IF [LowTableName]<>'umlautworte'
          CALL FindeUmlautWorte
        END_IF
        INC [LnAct]
      END_WHILE

      QUERY [IQ]
        UPDATE umlautworte
           SET UmlautwortKorrekt = UmlautwortDefekt
         WHERE UmlautwortKorrekt = ""
           AND RecordID          > 0
      END_QUERY
      EXECUTE [IQ],[Res]

      END_WAIT

    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_TakeOver'
      CALC [YNRes] AS [ID_NO]
      GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie nun die Liste der Worte mit den korrigierten Umlauten bernehmen?',[YNRes]
      IF [YNres]<>[ID_YES]
        EXIT_PROC
      END_IF

      CALL GetStringFields
      LIST_ITEM_GET [TList],[LnAct],[LnCnt]
      IF [LnCnt]<=0
        EXIT_PROC
      END_IF

      WAIT_INFO 'Bitte warten...','Die Stringfelder werden korrigiert',FALSE,65,3

      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [TList],[TmpStr],[LnAct]
        CALC [TmpStr] AS TRIM([TmpStr])
        CALC [LowTableName] AS PART([TmpStr],1,'|')
        CALC [UpFieldName]  AS PART([TmpStr],2,'|')
        CALC [InfStr] AS CON('Korrigieren der Tabelle "',[LowTableName],'" und des Feldes "',[UpFieldName],'"')
        WAIT_INFO 'Bitte warten...',[InfStr],FALSE,65,3
        IF [LowTableName]<>'umlautworte'
          CALL ErsetzteUmlautWorte
        END_IF
        INC [LnAct]
      END_WHILE

      END_WAIT
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  MASK_PROCESS [WorkMask]
SCRIPT_END
