  ; DD, 01.02.2008, loads up a file to an ftp-server using the standard ftp, which needs not to be installed
  ;
  ; Parameter   PAR_STR1    Filename
  ;             RECORD_ID2  RecordID        if this value is > 0 it will give   the filename like 7898736573912.ext
  ;             RECORD_ID3  Index-Number    if this value is > 0 it will extend the filename like 7898736573912_1.ext


  PROCEDURE InitVars
    VAR_STR  FTPUser,        'username'
    VAR_STR  FTPPassword,    'password'
    VAR_STR  FTPServer,      'abcdef.com'
    VAR_STR  FTPDestPath,    'pictures'

    VAR_STR  Str1
    VAR_STR  Str2
    VAR_STR  FTPScriptFName
    VAR_STR  FTPBatchFName
    VAR_BOOL Res

    VAR_LIST FTPScript
    VAR_LIST FTPBatch


    CALC [FTPScriptFName] AS CON([PRINTSET_PATH],'ftp_script_',[STATION_SHORT],'.ftp')
    CALC [FTPBatchFName]  AS CON([PRINTSET_PATH],'ftp_exec_',[STATION_SHORT],'.bat')


    CALC [Str1] AS CON('open ',[FTPServer])
    LIST_APPEND [FTPScript], [Str1]

    LIST_APPEND [FTPScript], [FTPUser]
    LIST_APPEND [FTPScript], [FTPPassword]
    LIST_APPEND [FTPScript], 'binary'

    IF [FTPDestPath]<>''
      CALC [Str1] AS CON('cd ',[FTPDestPath])
      LIST_APPEND [FTPScript], [Str1]
    END_IF

    CALC [Str1] AS COPY([PRINTSET_PATH],1,1)
    IF [Str1]='\'
      EXIT_PROC
    END_IF

    LIST_APPEND [FTPBatch], '@ECHO OFF'

    CALC [Str1] AS COPY([PRINTSET_PATH],1,2)
    LIST_APPEND [FTPBatch], [Str1]

    CALC [Str1] AS COPY([PRINTSET_PATH],3,255)
    CALC [Str1] AS  CON('cd ',[Str1])
    LIST_APPEND [FTPBatch], [Str1]

    CALC [Str1] AS CON('ftp -s:',[FTPScriptFName])
    LIST_APPEND [FTPBatch], [Str1]

    CALC [Str1] AS CON('del ',[FTPScriptFName])
    LIST_APPEND [FTPBatch], [Str1]
  END_PROC


  PROCEDURE Main
    IF [Str1]='\'
      MESSAGE 'Achtung Abbruch','Diese Funktion kann nicht aus einer UNC-Umgebung ausgefhrt werden',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    EXIST_FILE [PAR_STR1],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    FILE_NAME [Str1],[PAR_STR1]
    IF [RECORD_ID2]>[EPSILON]
      ; Wenn der Parameter 2 = einer RecordID ist, wird der Zieldateiname die RecordID mit der passenden Extension sein.
      FILE_EXT [Str1], [Str1]
      CALC [Str1] AS CON([RECORD_ID2|R0,0],[Str1])

      IF [RECORD_ID3]>[EPSILON]
        FILE_EXT [Str2], [Str1]
        CALC [Str1] AS PART([Str1],1,[Str2])
        CALC [Str1] AS CON([Str1],'_',[RECORD_ID3|R0,0],[Str2])
      END_IF
    END_IF

    ; Zieldateinamen "normalisieren"
    CALC [Str1] AS LOWCASE([Str1])
    CALC [Str1] AS REPLACE([Str1],' ','_')
    CALC [Str1] AS REPLACE([Str1],'','ae')
    CALC [Str1] AS REPLACE([Str1],'','ue')
    CALC [Str1] AS REPLACE([Str1],'','oe')
    CALC [Str1] AS REPLACE([Str1],'','ss')


    CALC [Str1] AS CON([PRINTSET_PATH],[Str1])
    FILE_COPY [Res], [PAR_STR1], [Str1]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Das Bild konnte nicht kopiert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    FILE_NAME [Str2],[Str1]

    CALC [Str1] AS CON('send ./',[Str2])
    LIST_APPEND [FTPScript], [Str1]

    CALC [Str1] AS CON('del ',[Str2])
    LIST_APPEND [FTPBatch], [Str1]

    LIST_APPEND [FTPScript], 'quit'
    LIST_APPEND [FTPBatch],  'exit'

    LIST_FILE_WRITE [FTPBatch], [Res],[FTPBatchFName]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Batch-Datei konnte nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    LIST_FILE_WRITE [FTPScript],[Res],[FTPScriptFName]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Script-Datei konnte nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    EXTERN [FTPBatchFName], [EXTERN_SHOW]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END