  ; DD, 01.02.2008, loads up a file to an ssh-server using the pscp.exe from putty, which is freeware
  ;
  ; Parameter   PAR_STR1    Filename
  ;             RECORD_ID2  RecordID        if this value is > 0 it will give   the filename like 7898736573912.ext
  ;             RECORD_ID3  Index-Number    if this value is > 0 it will extend the filename like 7898736573912_1.ext

  PROCEDURE InitVars
    VAR_STR  SSHUser,               'username'
    VAR_STR  SSHPassword,           'password'
    VAR_STR  SSHServer,             'abcdef.com'
    VAR_STR  PathFromUserHome2Dest, '../../srv/vhosts/www.mydomain.com/htdocs/uploads/'

    VAR_STR  Str1
    VAR_STR  Str2
    VAR_BOOL Res
    VAR_STR  PSCPFilename
    VAR_STR  PSCParameters

    ; Hier den Pfad zum Putty-Programm pscp.exe korrekt angeben
    CALC [PSCPFilename]  AS CON([CARA_PATH],'pscp.exe')

    CALC [PSCParameters] AS CON('-C -l ',[SSHUser],' -pw ',[SSHPassword])
  END_PROC


  PROCEDURE Main
    EXIST_FILE [PAR_STR1],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [PSCParameters] AS CON([PSCParameters],' ',[PAR_STR1])

    FILE_NAME [Str1],[PAR_STR1]

    IF [RECORD_ID2]>[EPSILON]
      ; Wenn der Parameter 2 = einer RecordID ist, wird der Zieldateiname die RecordID mit der passenden Extension sein.
      FILE_EXT [Str1], [Str1]
      CALC [Str1] AS CON([RECORD_ID2|R0,0],[Str1])

      IF [RECORD_ID3]>[EPSILON]
        FILE_EXT [Str2], [Str1]
        CALC [Str1] AS PART([Str1],1,[Str2])
        CALC [Str1] AS CON([Str1],'_',[RECORD_ID3|R0,0],[Str2])
      END_IF
    END_IF

    ; Zieldateinamen "normalisieren"
    CALC [Str1] AS LOWCASE([Str1])
    CALC [Str1] AS REPLACE([Str1],' ','_')
    CALC [Str1] AS REPLACE([Str1],'','ae')
    CALC [Str1] AS REPLACE([Str1],'','ue')
    CALC [Str1] AS REPLACE([Str1],'','oe')
    CALC [Str1] AS REPLACE([Str1],'','ss')

    CALC [Str1] AS CON([SSHServer],':',[PathFromUserHome2Dest],[Str1])
    CALC [PSCParameters] AS CON([PSCParameters],' ',[Str1])

    CALC [Str1] AS CON([PSCPFilename],' ',[PSCParameters])
    EXTERN [Str1], [EXTERN_SHOW]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END