  PROCEDURE InitVars
    VAR_QUERY Q
    VAR_QUERY U

    VAR_BOOL  Result

    VAR_NUM   Max
    VAR_NUM   Cnt
    VAR_NUM   YNRes

    VAR_NUM   SLen

    VAR_STR   Inf
    VAR_STR   ANr
  END_PROC


  PROCEDURE CheckAuftragsnummer
    CALC [ANr]  AS [Q!Auftragsnummer]
    CALC [SLen] AS LEN([ANr])
    WHILE [SLen]<6
      CALC [ANr]  AS CON('0',[ANr])
      CALC [SLen] AS LEN([ANr])
    END_WHILE

    QUERY [U]
      UPDATE auftrag
         SET Auftragsnummer = "[ANr]"
       WHERE RecordID       =  [Q!RecordID|R0,0]
    END_QUERY
    EXECUTE [U], [Result]
  END_PROC


  PROCEDURE Main
    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher ?!','Sollen alle Auftragsnummern daraufhin berprft werden, ob sie sechsstellig sind?',[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Alle Auftragsnummern werden geladen.'

    QUERY [Q]
        SELECT Auftragsnummer, RecordID

          FROM auftrag

         WHERE Auftragsnummer <> ""

      ORDER BY RecordID
    END_QUERY

    EXECUTE [Q], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Die Auftragsnummern konnten nicht geladen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es sind keine Auftragsnummern vorhanden.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]

    CALC [Cnt]        AS 0
    CALC [WAIT_BREAK] AS FALSE

    END_WAIT


    WHILE [Result]
      INC  [Cnt]
      CALC [Inf] AS CON([Cnt],'/',[Max])

      IF [WAIT_BREAK]
        END_WAIT
        CALC [YNRes] AS [ID_NO]
        GET_YES_NO 'Achtung! Sind Sie sicher ?!','Soll die Auftragsnummernprfung agebrochen werden?',[YNRes]
        IF [YNRes]=[ID_YES]
          EXIT_PROC
        END_IF
        CALC [WAIT_BREAK] AS FALSE
      END_IF

      WAIT_INFO 'Bitte warten...',[Inf], TRUE
      CALL CheckAuftragsnummer

      GET_DATA [Q], [Result]
    END_WHILE

    END_WAIT
    MESSAGE 'Information','Die Auftragsnummernprfung wurde ausgefhrt.'
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
