; Lieferbedingungen GLS importieren

    ; So werden die Daten von Iesem Script exportiert, mit einem Semikolon, getrennt
    ; Die mit einem Sternchen versehenen wurden bei Koi-Discount zugeordnet
    ;* 01 Anrede
    ;* 02 Name1
    ;* 03 Name2
    ;* 04 Name3
    ;  05 Kontaktname
    ;* 06 Ort
    ;  07 Land (Inland)
    ;* 08 Land (ISO)
    ;  09 Land (ausgeschrieben, voller Name)
    ;  10 PLZ
    ;* 11 ID (Rechungsnummer oder Lieferscheinnummer)
    ;* 12 Telefonnummer
    ;  13 UStIDNr
    ;  14 EMail
    ;* 15 Gewicht
    ;* 16 Strasse
    ;* 17 Betrag
    ;* 18 Frankatur
    ;* 19 Produkt

  INCLUDE Choicer.INC


  PROCEDURE InitVars
    VAR_STR    FileName
    VAR_STR    FilterStr
    VAR_STR    CRLF
    VAR_STR    Frankatur
    VAR_BOOL   Result
    VAR_QUERY  WorkQ
    VAR_QUERY  AdresseQ
    VAR_NUM    GewichtIn100
    VAR_NUM    BetragInCnt
    VAR_STREAM AStream
    VAR_MASK   WorkMask, 'GLSInterfaceDLG'

    CALC [FilterStr] AS CHAR(#39)
    CALC [FilterStr] AS CON([FilterStr],'!"=?`;|<>@}][{^')
    CALC [CRLF]      AS CHAR(#13#10)
    CALC [FileName]  AS CON([PRINTSET_PATH],'GLSDaten.txt')


    CALC [WorkMask!MASK_HOT_KEY_LIST] AS '13@1'

    CALC [WorkMask!MASK_HOOK_BUTTON]  AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_SEARCH]  AS 'PostSearchHook'
    CALC [WorkMask!MASK_HOOK_KEY]     AS 'KeyHook'
    CALC [WorkMask!MASK_HOOK_EXIT]    AS 'ExitHook'
  END_PROC


  PROCEDURE WriteOneField VS WOF.Str
    CALC [WOF.Str] AS FILTER([WOF.Str],[FilterStr])
    CALC [WOF.Str] AS    CON([WOF.Str],';')
    FILE_WRITE [AStream],[WOF.Str],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung fehler','Es konnten keine Daten in die Ausgabedatei ausgegeben werden.',[MESSAGE_WARNING]
    END_IF
  END_PROC



  PROCEDURE LoadDaten
    IF [WorkMask!MASK_RECORD_ID]<[EPSILON]
      EXIT_PROC
    END_IF

    QUERY [WorkQ]
      SELECT *
        FROM UPSAdr
       WHERE RecordID = [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY

    EXECUTE [WorkQ],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden der Versanddaten konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [WorkQ],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Versanddaten konnte nicht geladen werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE DoVersand
    LOCAL_STR LocStr
    LOCAL_STR LocName1
    LOCAL_STR LocName2
    LOCAL_STR LocZusa1
    LOCAL_STR LocZusa2

    IF [WorkMask!MASK_RECORD_ID]<[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst einen Beleg aus.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    IF [WorkMask!Gewicht]<[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte geben Sie zunchst das Gewicht ein.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    EXIST_FILE [FileName],[Result]
    IF [Result]
      MESSAGE 'Achtung Abbruch','Die vorhergehende Datei ist vom GLS-Programm noch nicht abgearbeitet worden.|Bitte versuchen Sie es in ein paar Sekunden erneut',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    FILE_OPEN [AStream],[FileName],[FILE_OPEN_OUT],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Ausgabe-Datei konnte nicht geffnet werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [Frankatur] AS [WorkQ!Produkt]
    IF [WorkQ!Land]='CH'
      CALC [Frankatur] AS '4'
    END_IF

    CALC [GewichtIn100] AS [WorkMask!Gewicht]*10
    CALC [BetragInCnt]  AS [WorkQ!Betrag]*100

    CALC [LocName1]     AS [WorkQ!Name1]
    CALC [LocName2]     AS [WorkQ!Name2]
    CALC [LocZusa1]     AS [WorkQ!Zusatz1]
    CALC [LocZusa2]     AS [WorkQ!Zusatz2]

    IF [LocName1]=''
      CALC [LocName1]   AS [LocName2]
      CALC [LocName2]   AS [LocZusa1]
      CALC [LocZusa1]   AS [LocZusa2]
      CALC [LocZusa2]   AS ''
    ELSE_IF [LocName2]=''
      IF [LocZusa1]=''
        CALC [LocName2] AS [LocZusa2]
        CALC [LocZusa1] AS ''
        CALC [LocZusa2] AS ''
      ELSE
        CALC [LocName2] AS [LocZusa1]
        CALC [LocZusa1] AS [LocZusa2]
        CALC [LocZusa2] AS ''
      END_IF
    END_IF
    CALC [LocStr] AS  CON([LocZusa1],' ',[LocZusa2])
    CALC [LocStr] AS TRIM([LocStr])


    ; 01 Anrede
    CALL WriteOneField ''

    ; 02 Name1
    CALL WriteOneField [LocName1]

    ; 03 Name2
    CALL WriteOneField [LocName2]

    ; 04 Name3
    CALL WriteOneField [LocStr]

    ; 05 Kontaktname
    CALL WriteOneField [WorkQ!Kontaktperson]

    ; 06 Ort
    CALL WriteOneField [WorkQ!Ort]

    ; 07 Land (Inland)
    CALL WriteOneField [WorkQ!Land]

    ; 08 Land (ISO)
    CALL WriteOneField [WorkQ!LandISO]

    ; 09 Land (ausgeschrieben, voller Name)
    CALL WriteOneField [WorkQ!Laenderspezifikation]

    ; 10 PLZ
    CALL WriteOneField [WorkQ!PLZ]

    ; 11 ID (Rechungsnummer oder Lieferscheinnummer)
    CALL WriteOneField [WorkQ!Datensatzeigentuemer]

    ; 12 Telefonnummer
    CALL WriteOneField [WorkQ!Telefonnummer]

    ; 13 UStIDNr
    CALL WriteOneField [WorkQ!UStIDNr]

    ; 14 EMail
    CALL WriteOneField [WorkQ!EMail1]

    ; 15 Gewicht
    CALL WriteOneField [GewichtIn100]

    ; 16 Strasse
    CALL WriteOneField [WorkQ!Strasse]

    ; 17 Betrag
    CALL WriteOneField [BetragInCnt]

    ; 18 Frankatur
    CALL WriteOneField [Frankatur]

    ; 19 Produkt
    CALL WriteOneField [WorkMask!Produkt]



    FILE_WRITE [AStream],[CRLF],[Result]

    FILE_CLOSE [AStream]

;   MASK_COMMAND [WorkMask],[MASK_COMMAND_CLEAR]
    FIELD_FLAG_ON_OFF [WorkMask],'Datensatzeigentuemer','[FIELD_FLAG_ACTUAL]',''
  END_PROC


  PROCEDURE KeyHook
    IF [WorkMask!MASK_ACT_KEY]<>13
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='Datensatzeigentuemer'
      CALC [WorkMask!Datensatzeigentuemer] AS CON([WorkMask!Datensatzeigentuemer],'*')
      MASK_UPDATE  [WorkMask]
      MASK_COMMAND [WorkMask],[MASK_COMMAND_SEARCH]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='Gewicht'
      CALL DoVersand
    END_IF
  END_PROC


  PROCEDURE PostSearchHook
    FIELD_FLAG_ON_OFF [WorkMask],'Gewicht','[FIELD_FLAG_ACTUAL]',''

    CALL LoadDaten
    MASK_UPDATE [WorkMask]
  END_PROC


  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_Versenden'
      CALL DoVersand
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_Produkt'
      CALL ChoicerGet TRUE, 'WorkMask', 'Produkt', 'ProduktAlias', 355055, 'Wert4', 'Auswahl', 20, 'Produkte', 'Produkte', [Result]
    END_IF
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
