  PROCEDURE InitVars
    VAR_QUERY Q
    VAR_QUERY S
    VAR_QUERY U

    VAR_BOOL  Result

    VAR_FLOAT RecID

    VAR_NUM   Max
    VAR_NUM   Cnt
    VAR_NUM   YNRes

    VAR_NUM   SLen

    VAR_STR   Inf

    VAR_NUM   KNr, 0
    VAR_NUM   DNr, 0

    VAR_LIST  Protokoll
  END_PROC


  PROCEDURE GetMaxKundennummer
    QUERY [Q]
        SELECT Kundennummer
          FROM adressen
         WHERE KAktiv       > 0
           AND Kundennummer > "0"
      ORDER BY Kundennummer DESC
    END_QUERY

    EXECUTE [Q],[Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Result]
    WHILE [Result]
      CALC [KNr] AS VAL([Q!Kundennummer])
      IF [KNr]>0
        CALC [Result] AS FALSE
      ELSE
        GET_DATA [Q],[Result]
      END_IF
    END_WHILE

    IF [KNr]>0
      CALC [Result] AS TRUE
    END_IF

    CALC [Inf] AS CON('letzte Kundennummer ',[KNr])
    LIST_APPEND [Protokoll],[Inf]

    DEBUG_INFO [Inf]
  END_PROC



  PROCEDURE GetMaxDebitornummer
    QUERY [Q]
        SELECT Debitornummer
          FROM adressen
         WHERE KAktiv        > 0
           AND Debitornummer > "00001"
      ORDER BY Debitornummer DESC
    END_QUERY

    EXECUTE [Q],[Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Result]
    WHILE [Result]
      CALC [DNr] AS VAL([Q!Debitornummer])
      IF [DNr]>0
        CALC [Result] AS FALSE
      ELSE
        GET_DATA [Q],[Result]
      END_IF
    END_WHILE

    IF [DNr]>0
      CALC [Result] AS TRUE
    END_IF

    CALC [Inf] AS CON('letzte Debitornummer ',[DNr])
    LIST_APPEND [Protokoll],[Inf]

    DEBUG_INFO [Inf]
  END_PROC


  PROCEDURE CheckKundennummer
    QUERY [S]
      SELECT RecordID, Suchbegriff, Name1, Name2, Strasse, Plz, Ort
        FROM adressen
       WHERE Kundennummer = "[Q!Kundennummer]"
    END_QUERY

    EXECUTE [S], [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    ; 1. Datensatz holen und bergehen
    GET_DATA [S], [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    ; 2. Datensatz holen und dann loslegen
    GET_DATA [S], [Result]
    WHILE [Result]
      INC [KNr]
      QUERY [U]
        UPDATE adressen
           SET Kundennummer = "[KNr]"
         WHERE RecordID     =  [S!RecordID|R0,0]
      END_QUERY
      EXECUTE [U], [Result]
      IF [Result]
        CALC [Inf] AS CON('Kundennummer ',[Q!Kundennummer],' --> ',[KNr],'  Kunde (',[S!Suchbegriff],')  ',[S!Name1],' ',[S!Name2],', ',[S!Strasse],', ',[S!PLZ],' ',[S!Ort])
        LIST_APPEND [Protokoll],[Inf]

        DEBUG_INFO [Inf]
      END_IF

      GET_DATA [S], [Result]
    END_WHILE
  END_PROC


  PROCEDURE DoubleKundennummer
    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher ?!','Sollen alle doppelten Kundennummern eliminiert werden?',[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Alle Kundennummern werden geladen.'

    QUERY [Q]
        SELECT Kundennummer, count(Kundennummer)
          FROM adressen
         WHERE KAktiv > 0
           AND Kundennummer        > "0"
      GROUP BY Kundennummer
        HAVING count(Kundennummer) > 1
    END_QUERY

    EXECUTE [Q], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Die Kundennummern konnten nicht geladen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es sind keine Kundennummern vorhanden.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]

    CALC [Cnt]        AS 0
    CALC [WAIT_BREAK] AS FALSE

    END_WAIT


    WHILE [Result]
      INC  [Cnt]
      CALC [Inf] AS CON([Cnt],'/',[Max])

      IF [WAIT_BREAK]
        END_WAIT
        CALC [YNRes] AS [ID_NO]
        GET_YES_NO 'Achtung! Sind Sie sicher ?!','Soll die Kundennummernprfung agebrochen werden?',[YNRes]
        IF [YNRes]=[ID_YES]
          EXIT_PROC
        END_IF
        CALC [WAIT_BREAK] AS FALSE
      END_IF

      WAIT_INFO 'Bitte warten...',[Inf], TRUE
      CALL CheckKundennummer

      GET_DATA [Q], [Result]
    END_WHILE

    END_WAIT
    MESSAGE 'Information','Die Kundennummernprfung wurde ausgefhrt.'
  END_PROC


  PROCEDURE TextKundennummer
    QUERY [S]
      SELECT RecordID, Suchbegriff, Name1, Name2, Strasse, Plz, Ort, Kundennummer
        FROM adressen
       WHERE Kundennummer > "[KNr]"
    END_QUERY

    EXECUTE [S], [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [S], [Result]
    WHILE [Result]
      INC [KNr]
      QUERY [U]
        UPDATE adressen
           SET Kundennummer = "[KNr]"
         WHERE RecordID     =  [S!RecordID|R0,0]
      END_QUERY
      EXECUTE [U], [Result]
      IF [Result]
        CALC [Inf] AS CON('Kundennummer ',[S!Kundennummer],' --> ',[KNr],'  Kunde (',[S!Suchbegriff],')  ',[S!Name1],' ',[S!Name2],', ',[S!Strasse],', ',[S!PLZ],' ',[S!Ort])
        LIST_APPEND [Protokoll],[Inf]

        DEBUG_INFO [Inf]
      END_IF

      GET_DATA [S], [Result]
    END_WHILE
  END_PROC


  PROCEDURE CheckDebitornummer
    QUERY [S]
      SELECT RecordID, Suchbegriff, Name1, Name2, Strasse, Plz, Ort
        FROM adressen
       WHERE Debitornummer = "[Q!Debitornummer]"
    END_QUERY

    EXECUTE [S], [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    ; 1. Datensatz holen und bergehen
    GET_DATA [S], [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    ; 2. Datensatz holen und dann loslegen
    GET_DATA [S], [Result]
    WHILE [Result]
      INC [DNr]
      QUERY [U]
        UPDATE adressen
           SET Debitornummer = "[DNr]"
         WHERE RecordID     =  [S!RecordID|R0,0]
      END_QUERY
      EXECUTE [U], [Result]
      IF [Result]
        CALC [Inf] AS CON('Debitornummer ',[Q!Debitornummer],' --> ',[DNr],'  Kunde (',[S!Suchbegriff],')  ',[S!Name1],' ',[S!Name2],', ',[S!Strasse],', ',[S!PLZ],' ',[S!Ort])
        LIST_APPEND [Protokoll],[Inf]

        DEBUG_INFO [Inf]
      END_IF

      GET_DATA [S], [Result]
    END_WHILE
  END_PROC


  PROCEDURE DoubleDebitornummer
    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher ?!','Sollen alle doppelten Debitornummern eliminiert werden?',[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Alle Debitornummern werden geladen.'

    QUERY [Q]
        SELECT Debitornummer, count(Debitornummer)
          FROM adressen
         WHERE KAktiv > 0
           AND Debitornummer        > "00001"
      GROUP BY Debitornummer
        HAVING count(Debitornummer) > 1
    END_QUERY

    EXECUTE [Q], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Die Debitornummern konnten nicht geladen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es sind keine Debitornummern vorhanden.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]

    CALC [Cnt]        AS 0
    CALC [WAIT_BREAK] AS FALSE

    END_WAIT


    WHILE [Result]
      INC  [Cnt]
      CALC [Inf] AS CON([Cnt],'/',[Max])

      IF [WAIT_BREAK]
        END_WAIT
        CALC [YNRes] AS [ID_NO]
        GET_YES_NO 'Achtung! Sind Sie sicher ?!','Soll die Debitornummernprfung agebrochen werden?',[YNRes]
        IF [YNRes]=[ID_YES]
          EXIT_PROC
        END_IF
        CALC [WAIT_BREAK] AS FALSE
      END_IF

      WAIT_INFO 'Bitte warten...',[Inf], TRUE
      CALL CheckDebitornummer

      GET_DATA [Q], [Result]
    END_WHILE

    END_WAIT
    MESSAGE 'Information','Die Debitornummernprfung wurde ausgefhrt.'
  END_PROC


  PROCEDURE TextDebitornummer
    QUERY [S]
      SELECT RecordID, Suchbegriff, Name1, Name2, Strasse, Plz, Ort, Debitornummer
        FROM adressen
       WHERE Debitornummer > "[DNr]"
    END_QUERY

    EXECUTE [S], [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [S], [Result]
    WHILE [Result]
      INC [DNr]
      QUERY [U]
        UPDATE adressen
           SET Debitornummer = "[DNr]"
         WHERE RecordID      =  [S!RecordID|R0,0]
      END_QUERY
      EXECUTE [U], [Result]
      IF [Result]
        CALC [Inf] AS CON('Debitornummer ',[S!Debitornummer],' --> ',[DNr],'  Kunde (',[S!Suchbegriff],')  ',[S!Name1],' ',[S!Name2],', ',[S!Strasse],', ',[S!PLZ],' ',[S!Ort])
        LIST_APPEND [Protokoll],[Inf]

        DEBUG_INFO [Inf]
      END_IF

      GET_DATA [S], [Result]
    END_WHILE
  END_PROC



  PROCEDURE Main
    CALL GetMaxKundennummer
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    CALL GetMaxDebitornummer
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    CALL DoubleKundennummer
    CALL TextKundennummer
    CALL DoubleDebitornummer
    CALL TextDebitornummer

    LIST_ITEM_GET [Protokoll],[Cnt],[Max]
    IF [Max]>0
      ACT_REC_ID [RecID]
      REC_ID_2_FILENAME [RecID],[Inf]
      CALC [Inf] AS CON([DOCUMENT_PATH],'_Kunden_und_Debitornummern_pruefen_',[Inf],'_',[STATION_SHORT],'.txt')
      LIST_FILE_WRITE [Protokoll],[Result],[Inf]
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
