


  PROCEDURE InitVars
    CONST_NUM  OUTPUT_ALL,      0
    CONST_NUM  OUTPUT_BRANCHEN, 1
    CONST_NUM  OUTPUT_ART,      2

    VAR_NUM    OutPutMode
    VAR_STREAM Stream
    VAR_BOOL   Res, TRUE
    VAR_QUERY  MainQ
    VAR_QUERY  SubQ
    VAR_QUERY  Upd
    VAR_STR    FName
    VAR_STR    Inf
    VAR_STR    CRLF
    VAR_NUM    YNRes
    VAR_NUM    Max
    VAR_NUM    Cnt
    VAR_STR    FldDelim, ';'

    CALC [CRLF] AS CHAR(#13#10)
  END_PROC



  PROCEDURE WriteField VS WF.Field
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [Inf] AS CON('"',[WF.Field],'"',[FldDelim])
    FILE_WRITE [Stream],[Inf],[Res]
  END_PROC



  PROCEDURE OpenFile VS FNPart
    ; open file
    CALC [FName] AS CON([PRINTSET_PATH],[FNPart])
    FILE_OPEN [Stream],[FName],[FILE_OPEN_OUT],[Res]
    IF [Res]=FALSE
      CALC [Inf] AS CON('Folgende Datei konnte nicht angelegt werden:|',[FName])
      MESSAGE 'Achtung Abbruch',[Inf],[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    ; write headline
    CALL WriteField 'Anrede'
    CALL WriteField 'Vorname'
    CALL WriteField 'Nachname'
    CALL WriteField 'Suffix'
    CALL WriteField 'Firma'
    CALL WriteField 'Abteilung'
    CALL WriteField 'Position'
    CALL WriteField 'Strae geschftlich'
    CALL WriteField 'Ort geschftlich'
    CALL WriteField 'Postleitzahl geschftlich'
    CALL WriteField 'Land/Region geschftlich'
    CALL WriteField 'Fax geschftlich'
    CALL WriteField 'Telefon geschftlich'
    CALL WriteField 'Telefon geschftlich 2'
    CALL WriteField 'Mobiltelefon'
    CALL WriteField 'E-Mail-Adresse'
    CALL WriteField 'E-Mail-Typ'
    CALL WriteField 'E-Mail: Angezeigter Name'
    CALL WriteField 'Geburtstag'
    CALL WriteField 'Geschlecht'
    CALL WriteField 'Konto'
    CALL WriteField 'Postfach geschftlich'
    CALL WriteField 'Webseite'
;   CALL WriteField 'Notizen'
    IF [Res]
      FILE_WRITE [Stream],[CRLF],[Res]
    END_IF

    IF [Res]=FALSE
      CALC [Inf] AS CON('In die folgende Datei konnte nicht geschrieben werden:|',[FName])
      MESSAGE 'Achtung Abbruch',[Inf],[MESSAGE_WARNING]
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE ExportSubField VS MainF, VS SubF
    IF [SubF]<>''
      CALL WriteField [SubF]
    ELSE
      CALL WriteField [MainF]
    END_IF
  END_PROC



  PROCEDURE ExportSubAdresse VS ESA.Type
    CALL ExportSubField [MainQ!Anrede],    [SubQ!A.Anrede]
    CALL ExportSubField [MainQ!Name2],     [SubQ!A.Name2]
    CALL ExportSubField [MainQ!Name1],     [SubQ!A.Name1]
    CALL ExportSubField [MainQ!Zusatz1],   [SubQ!A.Zusatz1]
    CALL ExportSubField [MainQ!Zusatz2],   [SubQ!A.Zusatz2]
    CALL ExportSubField [MainQ!Abteilung], [SubQ!A.Abteilung]
    CALL ExportSubField [MainQ!Funktion],  [SubQ!A.Funktion]
    CALL ExportSubField [MainQ!Strasse],   [SubQ!A.Strasse]
    CALL ExportSubField [MainQ!Ort],       [SubQ!A.Ort]
    CALL ExportSubField [MainQ!PLZ],       [SubQ!A.PLZ]
    CALL ExportSubField [MainQ!Land],      [SubQ!A.Land]

    CALL WriteField [SubQ!A.Fax1]
    CALL WriteField [SubQ!A.Telefon1]
    CALL WriteField [SubQ!A.Telefon2]
    CALL WriteField [SubQ!A.Mobil1]
    CALL WriteField [SubQ!A.EMail1]
    CALL WriteField 'SMTP'

    CALC [Inf] AS CON([SubQ!A.Name1],' ',[SubQ!A.Name2])
    CALL WriteField [Inf]


    IF [SubQ!A.Geburt]>[DEFAULT_DATE]
      CALC [Inf] AS [SubQ!A.Geburt]
    ELSE
      CALC [Inf] AS '0.0.00'
    END_IF
    CALL WriteField [Inf]


    CALL WriteField [SubQ!A.Geschlecht]
    CALL WriteField [ESA.Type]

    CALL ExportSubField [MainQ!Postfach],  [SubQ!A.Postfach]
    CALL ExportSubField [MainQ!Internet],  [SubQ!A.Internet]

;   CALL WriteFiled 'Notizen'
    IF [Res]
      FILE_WRITE [Stream],[CRLF],[Res]
    END_IF
  END_PROC


  PROCEDURE ExportSubAdressen VS ESA.Type, VS EA.Type
    LOCAL_STR ESA.TypeComplete
    CALC [ESA.TypeComplete] AS CON([EA.Type],'/',[ESA.Type])
    QUERY [SubQ]
        SELECT A.Anrede, A.Name2, A.Name1, A.Zusatz1, A.Zusatz2, A.Abteilung, A.Funktion, A.Strasse, A.Ort,
               A.PLZ, A.Land, A.Fax1, A.Telefon1, A.Telefon2, A.Mobil1, A.EMail1, A.Geburt, A.Geschlecht,
               A.Postfach, A.Internet, Z.AdressenID, Z.RelationID, Z.RecordID, A.RecordID

          FROM adrzuord Z, adressen A

         WHERE Z.[ESA.Type] = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
           AND Z.AdressenID = [MainQ!RecordID|R0,0]
           AND A.RecordID   = Z.RelationID
           AND A.EventFlag  = 0

      ORDER BY Z.AdressenID, A.Name1
    END_QUERY

    EXECUTE [SubQ], [Res]
    IF [Res]
      GET_DATA [SubQ], [Res]
      WHILE [Res]
        CALC [Inf] AS  CON([SubQ!A.Name1],[SubQ!A.Name2])
        CALC [Inf] AS TRIM([Inf])
        IF [Inf]<>''
          CALL ExportSubAdresse [ESA.TypeComplete]
        END_IF

        QUERY [Upd]
          UPDATE adressen SET EventFlag = 1 WHERE RecordID = [SubQ!A.RecordID|R0,0]
        END_QUERY
        EXECUTE [Upd],[Res]

        GET_DATA [SubQ], [Res]
      END_WHILE
    END_IF
  END_PROC



  PROCEDURE ExportAdresse VS EA.Type
    CALL WriteField [MainQ!Anrede]
    CALL WriteField [MainQ!Name2]
    CALL WriteField [MainQ!Name1]
    CALL WriteField [MainQ!Zusatz1]
    CALL WriteField [MainQ!Zusatz2]
    CALL WriteField [MainQ!Abteilung]
    CALL WriteField [MainQ!Funktion]
    CALL WriteField [MainQ!Strasse]
    CALL WriteField [MainQ!Ort]
    CALL WriteField [MainQ!PLZ]
    CALL WriteField [MainQ!Land]
    CALL WriteField [MainQ!Fax1]
    CALL WriteField [MainQ!Telefon1]
    CALL WriteField [MainQ!Telefon2]
    CALL WriteField [MainQ!Mobil1]
    CALL WriteField [MainQ!EMail1]
    CALL WriteField 'SMTP'


    CALC [Inf] AS CON([MainQ!Name1],' ',[MainQ!Name2])
    CALL WriteField [Inf]


    IF [MainQ!Geburt]>[DEFAULT_DATE]
      CALC [Inf] AS [MainQ!Geburt]
    ELSE
      CALC [Inf] AS '0.0.00'
    END_IF
    CALL WriteField [Inf]


    CALL WriteField [MainQ!Geschlecht]
    CALL WriteField [EA.Type]
    CALL WriteField [MainQ!Postfach]
    CALL WriteField [MainQ!Internet]
;   CALL WriteField 'Notizen'
    IF [Res]
      FILE_WRITE [Stream],[CRLF],[Res]
    END_IF

    IF [Res]=FALSE
      CALC [Inf] AS CON('In die folgende Datei konnte nicht geschrieben werden:|',[FName])
      MESSAGE 'Achtung Abbruch',[Inf],[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    CALL ExportSubAdressen 'PA', [EA.Type]
    CALL ExportSubAdressen 'RA', [EA.Type]
    CALL ExportSubAdressen 'VA', [EA.Type]
  END_PROC



  PROCEDURE ExportAdressen VS EA.FName, VS EA.Type, VS EA.Clause
    CALC [Inf] AS CON('Ausgabe der Adressen des Typs "',[EA.Type],'"')
    GET_NUM [OutPutMode],[Inf],'0=Alle in eine Datei,  1=Datei pro Branche,  2=Datei pro Art','99',[Res]
    IF [Res]=FALSE
      CALC [OutPutMode] AS 0
    END_IF

    IF [OutPutMode]=[OUTPUT_ALL]
      CALL OpenFile [EA.FName]
      IF [Res]=FALSE
        EXIT_PROC
      END_IF
    END_IF

    LOCAL_STR LocLastCrtieria
    LOCAL_STR LocStr1

    QUERY [MainQ]
        SELECT Anrede, Name2, Name1, Zusatz1, Zusatz2, Abteilung, Funktion, Strasse, Ort,
               PLZ, Land, Fax1, Telefon1, Telefon2, Mobil1, EMail1, Geburt, Geschlecht,
               Postfach, Internet, Branche, Art, RecordID

          FROM adressen

         WHERE RecordID  > 1000
           AND EventFlag = 0
               [EA.Clause]
    END_QUERY

    CALC [Inf] AS 'ORDER BY Name1'
    IF [OutPutMode]=[OUTPUT_BRANCHEN]
      CALC [Inf] AS 'ORDER BY Branche, Name1'
    ELSE_IF [OutPutMode]=[OUTPUT_ART]
      CALC [Inf] AS 'ORDER BY Art, Name1'
    END_IF
    QUERY_ADD_STRING [MainQ],[Inf]

    EXECUTE [MainQ], [Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden von Adressdaten konnte nicht ausgefhrt werden.',[MESSAGE_WARNING]
      FILE_CLOSE [Stream]
      EXIT_PROC
    END_IF

    GET_DATA [MainQ], [Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abbruch','Es wurden keine Adressdaten gefunden.',[MESSAGE_WARNING]
      FILE_CLOSE [Stream]
      EXIT_PROC
    END_IF

    QUERY_COUNT [MainQ],[Max]
    CALC [Cnt] AS 0

    CALC [LocLastCrtieria] AS '########################################'
    WHILE [Res]
      INC  [Cnt]
      CALC [Inf] AS CON([EA.Type],' ',[Cnt],' / ',[Max])
      WAIT_INFO 'Bitte warten...',[Inf]

      IF [OutPutMode]>[OUTPUT_ALL]
        IF [OutPutMode]=[OUTPUT_BRANCHEN]
          CALC [LocStr1] AS [MainQ!Branche]
        ELSE
          CALC [LocStr1] AS [MainQ!Art]
        END_IF

        IF [LocLastCrtieria]<>[LocStr1]
          IF [LocLastCrtieria]<>'########################################'
            FILE_CLOSE [Stream]
          END_IF

          CALC [Inf] AS TRIM([LocStr1])
          IF [Inf]<>''
            CALC [Inf] AS REPLACE([Inf], '',  'ae')
            CALC [Inf] AS REPLACE([Inf], '',  'ae')
            CALC [Inf] AS REPLACE([Inf], '',  'ue')
            CALC [Inf] AS REPLACE([Inf], '',  'ue')
            CALC [Inf] AS REPLACE([Inf], '',  'oe')
            CALC [Inf] AS REPLACE([Inf], '',  'oe')
            CALC [Inf] AS REPLACE([Inf], '',  'ss')
            CALC [Inf] AS REPLACE([Inf], ' ',  '_')
            CALC [Inf] AS REPLACE([Inf], '/',  '_')
            CALC [Inf] AS REPLACE([Inf], '-',  '_')
            CALC [Inf] AS REPLACE([Inf], '__', '_')
            CALC [Inf] AS REPLACE([Inf], '__', '_')
            CALC [Inf] AS REPLACE([Inf], '__', '_')

            FILE_EXT [LocStr1], [EA.FName]
            CALC [LocStr1] AS PART([EA.FName],1,[LocStr1])
            CALC [Inf] AS CON([LocStr1],'_',[Inf],'.csv')
          ELSE
            CALC [Inf] AS [EA.FName]
          END_IF

          CALL OpenFile [Inf]
          IF [Res]=FALSE
            EXIT_PROC
          END_IF
        END_IF
      END_IF


      CALC [Inf] AS  CON([MainQ!Name1],[MainQ!Name2])
      CALC [Inf] AS TRIM([Inf])
      IF [Inf]<>''
        CALL ExportAdresse [EA.Type]
      END_IF

      QUERY [Upd]
        UPDATE adressen SET EventFlag = 1 WHERE RecordID = [MainQ!RecordID|R0,0]
      END_QUERY
      EXECUTE [Upd],[Res]

      IF [OutPutMode]>[OUTPUT_ALL]
        IF [OutPutMode]=[OUTPUT_BRANCHEN]
          CALC [LocLastCrtieria] AS [MainQ!Branche]
        ELSE
          CALC [LocLastCrtieria] AS [MainQ!Art]
        END_IF
      END_IF

      GET_DATA [MainQ], [Res]
    END_WHILE

    END_WAIT

    FILE_CLOSE [Stream]
  END_PROC



  PROCEDURE Main
    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie nun alle Adressen nach CSV exportieren?|Es enstehen die folgenden Dateien im PrintSet-Ordner:|_Exp_Kund.csv|_Exp_Lief.csv|_Exp_Mita.csv|_Exp_Snst.csv|_Exp_Inte.csv',[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    QUERY [Upd]
      UPDATE adressen SET EventFlag = 0
    END_QUERY
    EXECUTE [Upd], [Res]

    CALL ExportAdressen '_Exp_Kund.csv', 'Kunde',       'AND KAktiv = 1'
    CALL ExportAdressen '_Exp_Lief.csv', 'Lieferant',   'AND LAktiv = 1'

    CALL ExportAdressen '_Exp_Mita.csv', 'Mitarbeiter', 'AND MAktiv = 1'

    CALC [Inf] AS CON('AND Sonstige = ',[SQL_BOOLEAN_QUOTATION],[SQL_BOOLEAN_TRUE],[SQL_BOOLEAN_QUOTATION])
    CALL ExportAdressen '_Exp_Sons.csv', 'Sonstige',    [Inf]

    CALC [Inf] AS CON('AND Interessent = ',[SQL_BOOLEAN_QUOTATION],[SQL_BOOLEAN_TRUE],[SQL_BOOLEAN_QUOTATION])
    CALL ExportAdressen '_Exp_Inte.csv', 'Interessent', [Inf]

    QUERY [Upd]
      UPDATE adressen SET EventFlag = 0
    END_QUERY
    EXECUTE [Upd], [Res]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END