; Lieferbedingungen GLS importieren

  PROCEDURE InitVars
    VAR_STR    FileName
    VAR_STR    FilterStr
    VAR_STR    CRLF
    VAR_BOOL   Result
    VAR_QUERY  WorkQ
    VAR_QUERY  AdresseQ
    VAR_NUM    GewichtIn100
    VAR_NUM    BetragInCnt
    VAR_STREAM AStream
    VAR_MASK   WorkMask, 'GLSInterfaceDLG'


    CALC [FilterStr] AS CHAR(#39)
    CALC [FilterStr] AS CON([FilterStr],'!"=?`;|<>@}][{^')
    CALC [CRLF]      AS CHAR(#13#10)
    CALC [FileName]  AS CON([PRINTSET_PATH],'GLSDaten.txt')


    CALC [WorkMask!MASK_HOT_KEY_LIST] AS '13@1'

    CALC [WorkMask!MASK_HOOK_BUTTON]  AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_SEARCH]  AS 'PostSearchHook'
    CALC [WorkMask!MASK_HOOK_KEY]     AS 'KeyHook'
  END_PROC


  PROCEDURE WriteOneField VS WOF.Str
    CALC [WOF.Str] AS FILTER([WOF.Str],[FilterStr])
    CALC [WOF.Str] AS CON([WOF.Str],';')
    FILE_WRITE [AStream],[WOF.Str],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung fehler','Es konnten keine Daten in die Ausgabedatei ausgegeben werden.',[MESSAGE_WARNING]
    END_IF
  END_PROC



  PROCEDURE DoVersand
    IF [WorkMask!MASK_RECORD_ID]<[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst eine Rechnung aus.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    IF [WorkMask!Gewicht]<[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte geben Sie zunchst das Gewicht ein.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY [WorkQ]
      SELECT *
        FROM UPSAdr
       WHERE RecordID = [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY

    EXECUTE [WorkQ],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden der Versanddaten konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [WorkQ],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Versanddaten konnte nicht geladen werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    EXIST_FILE [FileName],[Result]
    IF [Result]
      MESSAGE 'Achtung Abbruch','Die vorhergehende Datei ist vom GLS-Programm noch nicht abgearbeitet worden.|Bitte versuchen Sie es in ein paar Sekunden erneut',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    FILE_OPEN [AStream],[FileName],[FILE_OPEN_OUT],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Ausgabe-Datei konnte nicht geffnet werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [GewichtIn100] AS [WorkMask!Gewicht]*10
    CALC [BetragInCnt]  AS [WorkQ!Betrag]*100

    CALL WriteOneField [WorkQ!Firmenname]
    CALL WriteOneField [WorkQ!Kontaktperson]
    CALL WriteOneField [WorkQ!AdressZeile1]
    CALL WriteOneField [WorkQ!AdressZeile2]
    CALL WriteOneField [WorkQ!AdressZeile3]
    CALL WriteOneField [WorkQ!Ort]
    CALL WriteOneField [WorkQ!Land]
    CALL WriteOneField [WorkQ!LandISO]
    CALL WriteOneField [WorkQ!Laenderspezifikation]
    CALL WriteOneField [WorkQ!PLZ]
    CALL WriteOneField [WorkQ!Datensatzeigentuemer]
    CALL WriteOneField [WorkQ!Telefonnummer]
    CALL WriteOneField [WorkQ!USTIDNr]
    CALL WriteOneField [WorkQ!EMail1]
    CALL WriteOneField [GewichtIn100]
    CALL WriteOneField [WorkQ!Strasse]
    CALL WriteOneField [BetragInCnt]
    CALL WriteOneField [WorkQ!Produkt]

    FILE_WRITE [AStream],[CRLF],[Result]

    FILE_CLOSE [AStream]

    MASK_COMMAND [WorkMask],[MASK_COMMAND_CLEAR]
    FIELD_FLAG_ON_OFF [WorkMask],'Datensatzeigentuemer','[FIELD_FLAG_ACTUAL]',''
  END_PROC


  PROCEDURE KeyHook
    IF [WorkMask!MASK_ACT_KEY]<>13
      EXIT_PROC
    END_IF

    IF [WorkMask!MASK_ACT_FIELD_NAME]='Datensatzeigentuemer'
      CALC [WorkMask!Datensatzeigentuemer] AS CON([WorkMask!Datensatzeigentuemer],'*')
      MASK_UPDATE  [WorkMask]
      MASK_COMMAND [WorkMask],[MASK_COMMAND_SEARCH]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='Gewicht'
      CALL DoVersand
    END_IF
  END_PROC


  PROCEDURE PostSearchHook
    FIELD_FLAG_ON_OFF [WorkMask],'Gewicht','[FIELD_FLAG_ACTUAL]',''
  END_PROC


  PROCEDURE ButtonHook
    CALL DoVersand
  END_PROC


  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
