  ; Schreibt einen Datensatz passend zu einem Lieferschein in die Tabelle UPSAdr.
  ; Der Datensatz enthlt den Ansprechpartner des Auftrages, die Versandadresse
  ; die Lieferscheinnummer als "Datensatzeigentmer" etc. Dies kann dann vom
  ; Programm UPS-World-Wide verarbeitet werden.
  ;
  ; Parameter : [RECORD_ID1] = RecordID eines Lieferscheins, d.h. im
  ;                            "Datensatzeigentmer" wird die Lieferscheinnummer
  ;                            gespeichert.
  ;
  ;             [RECORD_ID2] = RecordID einer Rechnung, d.h. im
  ;                            "Datensatzeigentmer" wird die Rechnungsnummer
  ;                            gespeichert.
  ;


  INCLUDE AdrKopf.INC
  INCLUDE Routines.INC

  PROCEDURE InitVars
    VAR_BOOL  QRes
    VAR_BOOL  Continue

    VAR_BOOL  NewID

    VAR_FLOAT UPSID

    VAR_QUERY HeadInfo
    VAR_QUERY AdressQ
    VAR_QUERY SQ
    VAR_QUERY Laender

    VAR_NUM   PLZNum
    VAR_NUM   TmpNum
    VAR_STR   LandISO
    VAR_STR   Telefon1
    VAR_STR   EMail1
    VAR_STR   TmpStr
    VAR_FLOAT TmpFloat

    VAR_NUM   N
    CALC [N] AS 1
    WHILE [N]<8
      VAR_STR AnZ0[N]
      INC [N]
    END_WHILE

    VAR_STR   Produkt
    VAR_STR   Ansprechpartner
  END_PROC



  PROCEDURE GetHeaderInfo ~VB GoOn
    CALC [GoOn] AS FALSE

    IF [RECORD_ID1]>[EPSILON]
      QUERY [HeadInfo]
        SELECT L.Lieferscheinnummer, L.Lieferdatum, L.RecordID,
               A.RechKundeID, A.KundenID, A.VertreterID, A.ArtikelID,
               A.Auftragsnummer, A.Sachbearbeiter, A.Auftragsdatum,
               A.VerKundeID, A.Referenz, A.Bestellnummer, A.Bestelldatum, A.PartnerID,
               K.Kundennummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort, K.Kopien_KLS, K.Suchbegriff,
               K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse, K.EMail1, K.Telefon1,
               K.Laenderspezifikation, K.Zusatz3, K.KLieferBedID, K.Free3Str
          FROM LIEFERSC L, AUFTRAG A, ADRESSEN K
         WHERE L.RecordID  = [RECORD_ID1|R0,0]
           AND L.AuftragID = A.RecordID
           AND A.KundenID  = K.RecordID
      END_QUERY
    ELSE
      QUERY [HeadInfo]
        SELECT R.Rechnungsnummer, R.Datum, R.RecordID,
               A.RechKundeID, A.KundenID, A.VertreterID, A.ArtikelID, R.ZahlBedID, A.LieferBedID,
               A.Auftragsnummer, A.Sachbearbeiter, A.Auftragsdatum, R.Brutto, R.Netto,
               A.VerKundeID, A.Referenz, A.Bestellnummer, A.Bestelldatum, A.PartnerID,
               K.Kundennummer, K.Name1, K.Name2, K.Land, K.Plz, K.Ort, K.Kopien_KLS, K.Suchbegriff,
               K.PlzPostfach, K.Postfach, K.Anrede, K.UstIdNr, K.Strasse, K.EMail1, K.Telefon1,
               K.Laenderspezifikation, K.Zusatz3, K.KLieferBedID, K.Free3Str
          FROM Rechnung R, AUFTRAG A, ADRESSEN K
         WHERE R.RecordID  = [RECORD_ID2|R0,0]
           AND R.AuftragID = A.RecordID
           AND A.KundenID  = K.RecordID
      END_QUERY
    END_IF

    EXECUTE [HeadInfo],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      END_WAIT
      MESSAGE 'Abbruch','Das Query fr die Beleg-Kopfdaten konnte nicht bersetzt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [HeadInfo],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      END_WAIT
      MESSAGE 'Abbruch','Es wurden keine Daten fr den Belegkopf gefunden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF


    CALC [UPSID] AS [HeadInfo!A.KundenID]
    IF [HeadInfo!A.VerKundeID]>[EPSILON]
      CALC [UPSID] AS [HeadInfo!A.VerKundeID]
    END_IF

    CALL CalcAdr [UPSID], 'ADRESSEN', '-N1--N2--Z1--SS-', [AnZ01], [AnZ02], [AnZ03], [AnZ04], [AnZ05], [AnZ06], [AnZ07]

    QUERY [AdressQ]
      SELECT Suchbegriff, Name1, Name2, Ort, PLZ, Land, Strasse, Laenderspezifikation,
             Zusatz1, Zusatz2, Zusatz3, EMail1, Telefon1
        FROM ADRESSEN
       WHERE RecordID = [UPSID|R0,0]
    END_QUERY

    EXECUTE [AdressQ],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      END_WAIT
      MESSAGE 'Abbruch','Das Query fr die Adress-Daten konnte nicht bersetzt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [AdressQ],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      END_WAIT
      MESSAGE 'Abbruch','Es wurden keine Adress-Daten gefunden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALL LoadRelationFields  [HeadInfo!A.PartnerID], 'ADRESSEN', 'Anrede|Name1|Name2', [Ansprechpartner], ''
    CALC [Ansprechpartner] AS REPLACE([Ansprechpartner],'|',' ')

    CALC [Produkt] AS ''
    IF [RECORD_ID1]<=[EPSILON]
      CALL LoadRelationFields [HeadInfo!A.LieferBedID], 'LIEFBED', 'Beschreibung2', [Produkt], ''
      CALL LoadRelationFields [HeadInfo!R.ZahlBedID],   'ZAHLBED', 'Beschreibung',  [TmpStr],  ''
      CALC [TmpStr] AS UPCASE([TmpStr])
      CALC [TmpNum] AS POS('NACHNAHME',[TmpStr])
      IF [TmpNum]>0
        CALC [Produkt] AS 'COD'
      END_IF
    END_IF

    CALC [GoOn] AS TRUE
  END_PROC







  PROCEDURE DoIt
    IF [RECORD_ID1]<[EPSILON]
      IF [RECORD_ID2]<[EPSILON]
        MESSAGE 'UPS-World-Wide - Abbruch','Es wurde weder eine LieferscheinID noch eine RechnungsID bergeben.',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF

    WAIT_CURSOR TRUE
    WAIT_INFO 'Bitte warten...','Die UPS - Daten werden gespeichert'
    CALL GetHeaderInfo [Continue]
    IF [Continue]=FALSE
      EXIT_PROC
    END_IF

    CALC [NewID] AS FALSE

    IF [RECORD_ID1]>[EPSILON]
      QUERY [SQ]
        SELECT * FROM upsadr WHERE Datensatzeigentuemer = "[HeadInfo!L.Lieferscheinnummer]"
      END_QUERY
    ELSE
      QUERY [SQ]
        SELECT * FROM upsadr WHERE Datensatzeigentuemer = "[HeadInfo!R.Rechnungsnummer]"
      END_QUERY
    END_IF

    EXECUTE [SQ],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch', 'Die Abfrage zum Ermitteln der UPS-Daten konnte nicht ausgefhrt werden', [MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ],[QRes]
    IF [QRes]
      CALC [UPSID] AS [SQ!RecordID]
    ELSE
      CALC [NewID] AS TRUE
      NEW_RECORD [QRes],'upsadr',[UPSID], TRUE, FALSE, FALSE
      IF [QRes]=FALSE
        WAIT_CURSOR FALSE
        END_WAIT
        MESSAGE 'Achtung Abbruch', 'Es konnte kein neuer Datensatz in der UPS-Tabelle angelegt werden', [MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF


    CALC [LandISO] AS [AdressQ!Land]

    QUERY [Laender]
      SELECT LandKz2
        FROM Laender
       WHERE LandKz1 = "[AdressQ!Land]"
          OR LandKz2 = "[AdressQ!Land]"
    END_QUERY
    EXECUTE [Laender],[QRes]
    IF [QRes]
      GET_DATA [SQ],[QRes]
      IF [QRes]
        CALC [LandISO] AS [Laender!LandKz2]
      END_IF
    END_IF


    CALC [Telefon1] AS [AdressQ!Telefon1]
    IF [Telefon1]=''
      CALC [Telefon1] AS [HeadInfo!K.Telefon1]
    END_IF

    CALC [EMail1] AS [AdressQ!EMail1]
    IF [EMail1]=''
      CALC [EMail1] AS [HeadInfo!K.EMail1]
    END_IF


    CALC [TmpFloat] AS 0.0
    CALC [PLZNum]   AS VAL([AdressQ!PLZ])

    IF [RECORD_ID1]>[EPSILON]
      CALC [TmpStr]   AS [HeadInfo!L.Lieferscheinnummer]
    ELSE
      CALC [TmpStr]   AS [HeadInfo!R.Rechnungsnummer]

      CALC [TmpFloat] AS [HeadInfo!R.Brutto]
      IF [TmpFloat]<=[EPSILON]
        CALC [TmpFloat] AS [HeadInfo!R.Netto]
      END_IF
    END_IF


    QUERY [SQ]
      UPDATE upsadr
         SET Firmenname           = "[AnZ01]",
             Kontaktperson        = "[Ansprechpartner]",
             AdressZeile1         = "[AnZ02]",
             AdressZeile2         = "[AnZ03]",
             AdressZeile3         = "[AnZ04]",
             Ort                  = "[AdressQ!Ort]",
             Land                 = "[AdressQ!Land]",
             LandISO              = "[LandISO]",
             Laenderspezifikation = "[AdressQ!Laenderspezifikation]",
             PLZNumerisch         =  [PLZNum],
             PLZ                  = "[AdressQ!PLZ]",
             Kundennummer         = "[HeadInfo!K.Kundennummer]",
             Datensatzeigentuemer = "[TmpStr]",
             Telefonnummer        = "[Telefon1]",
             USTIDNr              = "[HeadInfo!K.UStIdNr]",
             UPSKundennummer      = "[HeadInfo!K.Free3Str]",
             EMail1               = "[EMail1]",
             Strasse              = "[AdressQ!Strasse]",
             Betrag               = "[TmpFloat|R0,2]",
             Produkt              = "[Produkt]",
             Name1                = "[AdressQ!Name1]",
             Name2                = "[AdressQ!Name2]",
             Zusatz1              = "[AdressQ!Zusatz1]",
             Zusatz2              = "[AdressQ!Zusatz2]"
       WHERE RecordID             =  [UPSID|R0,0]
    END_QUERY

    EXECUTE [SQ],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch', 'Die UPS-Daten konnten nicht gespeichert werden', [MESSAGE_ERROR]

      IF [NewID]
        QUERY [SQ]
          DELETE FROM upsadr WHERE RecordID = [UPSID|R0,0]
        END_QUERY
        EXECUTE [SQ],[QRes]
      END_IF

      EXIT_PROC
    END_IF

    WAIT_CURSOR FALSE
    END_WAIT
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL DoIt
SCRIPT_END

