; This starts and stops the timer!

SCRIPT_BEGIN
  VAR_BOOL BGJ001.Res
  VAR_STR  BGJ001.Str
  VAR_NUM  BGJ001.TimerSequence,     0

  ; The timer will start every 10 mins.
  VAR_NUM  BGJ001.TimerSequenceHour, 0
  VAR_NUM  BGJ001.TimerSequenceMin,  10
  VAR_NUM  BGJ001.TimerSequenceSec,  0

  CALC [BGJ001.TimerSequence] AS (([BGJ001.TimerSequenceHour]*3600) + ([BGJ001.TimerSequenceMin]*60) + [BGJ001.TimerSequenceSec]) * 1000

  IDENTIFIER_EXIST 'BGJ001.WorkTime',[BGJ001.Res]
  IF [BGJ001.Res]=FALSE
    GLOBAL_STR  BGJ001.WorkTime
    GLOBAL_BOOL BGJ001.TimerOnceADayYes
    GLOBAL_BOOL BGJ001.JobIsRunning
  END_IF

  ; The timer will only work on the following days 'Mo,07:30:00-08:20:00,19:10:00-19:50:00|Di|Mi|Do|Fr' or 'Mo|Mi' or just "Fr' etc.
  ; Format = Day{,StartTime1-EndTime1{,StartTime2-EndTime2{,...StartTimeN-EndTimeN}}}|  if the string is empty, it will work always!
  CALC [BGJ001.WorkTime]         AS 'Mo,05:00:00-08:00:00|Di,05:00:00-08:00:00|Mi,05:00:00-08:00:00|Do,05:00:00-08:00:00|Fr,05:00:00-08:00:00'
  CALC [BGJ001.WorkTime]         AS UPCASE([BGJ001.WorkTime])

  ; The timer will only work one time every day.
  CALC [BGJ001.TimerOnceADayYes] AS TRUE

  ; This variable holds, if the job is running actually
  CALC [BGJ001.JobIsRunning]     AS FALSE

  TIMER_AVAIL [BGJ001.Res], 'BGJ001'
  IF [BGJ001.Res]
    TIMER_STOP  [BGJ001.Res], 'BGJ001'

    CALC [BGJ001.Str] AS 'Der Timer "BGJ001" ist gestoppt'
    IDENTIFIER_EXIST 'GlobServerJobs',[BGJ001.Res]
    IF [BGJ001.Res]
      CALC [BGJ001.Str] AS CON([DATE],' ',[TIME],'  >',[BGJ001.Str])
      LIST_APPEND [GlobServerJobs],[BGJ001.Str]
    ELSE
      PANEL_SET
      PANEL_INFO [BGJ001.Str]
    END_IF
  ELSE
    TIMER_START [BGJ001.Res], 'BGJ001', 'SJob1Main.CSH', [BGJ001.TimerSequence]
    SCRIPT 'SJob1Main.CSH'
  END_IF
SCRIPT_END