; This starts and stops the timer!

SCRIPT_BEGIN
  VAR_BOOL BGJ002.Res
  VAR_STR  BGJ002.Str
  VAR_NUM  BGJ002.TimerSequence,     0

  ; The timer will start every 10 mins.
  VAR_NUM  BGJ002.TimerSequenceHour, 0
  VAR_NUM  BGJ002.TimerSequenceMin,  10
  VAR_NUM  BGJ002.TimerSequenceSec,  0

  CALC [BGJ002.TimerSequence] AS (([BGJ002.TimerSequenceHour]*3600) + ([BGJ002.TimerSequenceMin]*60) + [BGJ002.TimerSequenceSec]) * 1000

  IDENTIFIER_EXIST 'BGJ002.WorkTime',[BGJ002.Res]
  IF [BGJ002.Res]=FALSE
    GLOBAL_STR  BGJ002.WorkTime
    GLOBAL_BOOL BGJ002.TimerOnceADayYes
    GLOBAL_BOOL BGJ002.JobIsRunning
  END_IF

  ; The timer will only work on the following days 'Mo,07:30:00-08:20:00,19:10:00-19:50:00|Di|Mi|Do|Fr' or 'Mo|Mi' or just "Fr' etc.
  ; Format = Day{,StartTime1-EndTime1{,StartTime2-EndTime2{,...StartTimeN-EndTimeN}}}|  if the string is empty, it will work always!
  CALC [BGJ002.WorkTime]         AS 'Mo,06:00:00-08:00:00|Di,06:00:00-08:00:00|Mi,06:00:00-08:00:00|Do,06:00:00-06:00:00|Fr,06:00:00-08:00:00'
  CALC [BGJ002.WorkTime]         AS UPCASE([BGJ002.WorkTime])

  ; The timer will only work one time every day.
  CALC [BGJ002.TimerOnceADayYes] AS TRUE

  ; This variable holds, if the job is running actually
  CALC [BGJ002.JobIsRunning]     AS FALSE

  TIMER_AVAIL [BGJ002.Res], 'BGJ002'
  IF [BGJ002.Res]
    TIMER_STOP  [BGJ002.Res], 'BGJ002'
    CALC [BGJ002.Str] AS 'Der Timer "BGJ002" ist gestoppt'
    IDENTIFIER_EXIST 'GlobServerJobs',[BGJ002.Res]
    IF [BGJ002.Res]
      CALC [BGJ002.Str] AS CON([DATE],' ',[TIME],'  >',[BGJ002.Str])
      LIST_APPEND [GlobServerJobs],[BGJ002.Str]
    ELSE
      PANEL_SET
      PANEL_INFO [BGJ002.Str]
    END_IF
  ELSE
    TIMER_START [BGJ002.Res], 'BGJ002', 'SJob2Main.CSH', [BGJ002.TimerSequence]
    SCRIPT 'SJob2Main.CSH'
  END_IF
SCRIPT_END