; This starts and stops the timer!

SCRIPT_BEGIN
  VAR_BOOL BGJ003.Res
  VAR_STR  BGJ003.Str
  VAR_NUM  BGJ003.TimerSequence,     0

  ; The timer will start every 10 mins.
  VAR_NUM  BGJ003.TimerSequenceHour, 0
  VAR_NUM  BGJ003.TimerSequenceMin,  14
  VAR_NUM  BGJ003.TimerSequenceSec,  0

  CALC [BGJ003.TimerSequence] AS (([BGJ003.TimerSequenceHour]*3600) + ([BGJ003.TimerSequenceMin]*60) + [BGJ003.TimerSequenceSec]) * 1000

  IDENTIFIER_EXIST 'BGJ003.WorkTime',[BGJ003.Res]
  IF [BGJ003.Res]=FALSE
    GLOBAL_STR  BGJ003.WorkTime
    GLOBAL_BOOL BGJ003.TimerOnceADayYes
    GLOBAL_BOOL BGJ003.JobIsRunning
  END_IF

  ; The timer will only work on the following days 'Mo,07:30:00-08:20:00,19:10:00-19:50:00|Di|Mi|Do|Fr' or 'Mo|Mi' or just "Fr' etc.
  ; Format = Day{,StartTime1-EndTime1{,StartTime2-EndTime2{,...StartTimeN-EndTimeN}}}|  if the string is empty, it will work always!
  CALC [BGJ003.WorkTime]         AS 'Mo,06:00:00-08:00:00|Di,06:00:00-08:00:00|Mi,06:00:00-08:00:00|Do,06:00:00-06:00:00|Fr,06:00:00-08:00:00'
  CALC [BGJ003.WorkTime]         AS UPCASE([BGJ003.WorkTime])

  ; The timer will only work one time every day.
  CALC [BGJ003.TimerOnceADayYes] AS TRUE

  ; This variable holds, if the job is running actually
  CALC [BGJ003.JobIsRunning]     AS FALSE

  TIMER_AVAIL [BGJ003.Res], 'BGJ003'
  IF [BGJ003.Res]
    TIMER_STOP  [BGJ003.Res], 'BGJ003'
    CALC [BGJ003.Str] AS 'Der Timer "BGJ003" ist gestoppt'
    IDENTIFIER_EXIST 'GlobServerJobs',[BGJ003.Res]
    IF [BGJ003.Res]
      CALC [BGJ003.Str] AS CON([DATE],' ',[TIME],'  >',[BGJ003.Str])
      LIST_APPEND [GlobServerJobs],[BGJ003.Str]
    ELSE
      PANEL_SET
      PANEL_INFO [BGJ003.Str]
    END_IF
  ELSE
    TIMER_START [BGJ003.Res], 'BGJ003', 'SJob3Main.CSH', [BGJ003.TimerSequence]
    SCRIPT 'SJob3Main.CSH'
  END_IF
SCRIPT_END