; This starts and stops the timer!

SCRIPT_BEGIN
  VAR_BOOL BGJ004.Res
  VAR_STR  BGJ004.Str
  VAR_NUM  BGJ004.TimerSequence,     0

  ; The timer will start every 10 mins.
  VAR_NUM  BGJ004.TimerSequenceHour, 0
  VAR_NUM  BGJ004.TimerSequenceMin,  19
  VAR_NUM  BGJ004.TimerSequenceSec,  0

  CALC [BGJ004.TimerSequence] AS (([BGJ004.TimerSequenceHour]*3600) + ([BGJ004.TimerSequenceMin]*60) + [BGJ004.TimerSequenceSec]) * 1000

  IDENTIFIER_EXIST 'BGJ004.WorkTime',[BGJ004.Res]
  IF [BGJ004.Res]=FALSE
    GLOBAL_STR  BGJ004.WorkTime
    GLOBAL_BOOL BGJ004.TimerOnceADayYes
    GLOBAL_BOOL BGJ004.JobIsRunning
  END_IF

  ; The timer will only work on the following days 'Mo,07:30:00-08:20:00,19:10:00-19:50:00|Di|Mi|Do|Fr' or 'Mo|Mi' or just "Fr' etc.
  ; Format = Day{,StartTime1-EndTime1{,StartTime2-EndTime2{,...StartTimeN-EndTimeN}}}|  if the string is empty, it will work always!
  CALC [BGJ004.WorkTime]         AS 'Mo,06:00:00-08:00:00|Di,06:00:00-08:00:00|Mi,06:00:00-08:00:00|Do,06:00:00-06:00:00|Fr,06:00:00-08:00:00'
  CALC [BGJ004.WorkTime]         AS UPCASE([BGJ004.WorkTime])

  ; The timer will only work one time every day.
  CALC [BGJ004.TimerOnceADayYes] AS TRUE

  ; This variable holds, if the job is running actually
  CALC [BGJ004.JobIsRunning]     AS FALSE

  TIMER_AVAIL [BGJ004.Res], 'BGJ004'
  IF [BGJ004.Res]
    TIMER_STOP  [BGJ004.Res], 'BGJ004'
    CALC [BGJ004.Str] AS 'Der Timer "BGJ004" ist gestoppt'
    IDENTIFIER_EXIST 'GlobServerJobs',[BGJ004.Res]
    IF [BGJ004.Res]
      CALC [BGJ004.Str] AS CON([DATE],' ',[TIME],'  >',[BGJ004.Str])
      LIST_APPEND [GlobServerJobs],[BGJ004.Str]
    ELSE
      PANEL_SET
      PANEL_INFO [BGJ004.Str]
    END_IF
  ELSE
    TIMER_START [BGJ004.Res], 'BGJ004', 'SJob4Main.CSH', [BGJ004.TimerSequence]
    SCRIPT 'SJob4Main.CSH'
  END_IF
SCRIPT_END