  ; Call this script from out of the main.csh!

  PROCEDURE InitVars
    VAR_BOOL  Res

    VAR_STR   TaskName,          'GiveAUniqueTaskNameHerePlease'
    VAR_STR   AppName,           'IDEAL'

    ; Must or should the user be changed?
    VAR_BOOL  Need2SwitchUser,   TRUE

    ; IF [Need2SwitchUser]: give a users recordid here,
    ; that is allowed to do the job, create one if needed
    ;
    ; It is always good to have one user for each job of this kind,
    ; so all changes or updates can be tracked back to this job.
    VAR_FLOAT SystemUser4Update, 7859003738571

    IDENTIFIER_EXIST 'CONFIG_FILE',[Res]
    IF [Res]=FALSE
      GLOBAL_STR CONFIG_FILE
      CALC [CONFIG_FILE] AS CON([SPECIAL_PATH],'ideal.cfg')
    END_IF


    VAR_FLOAT Float1
    VAR_FLOAT Float2

    VAR_FLOAT Buf4MitID,         [ACT_MIT_ID]

    VAR_FLOAT OneDayTimeStamp,   9395525.0
    VAR_STR   Str1
  END_PROC




  PROCEDURE Main
    RECORD_LOCK [TaskName],1,TRUE,[Res],FALSE
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    IF [Need2SwitchUser]
      SWITCH_USER [Res], [SystemUser4Update]
    END_IF

    CALC [Str1] AS ''
    INI_READ [Res],[Str1],[SCRIPT_STRING],[CONFIG_FILE],[TaskName],[AppName]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Der Zeitstempel fr eine Hintergrundaufgabe kann nicht gelesen werden',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    IF [Str1]<>''
      CALC [Float1] AS VAL([Str1])
      ACT_REC_ID [Float2]
      CALC [Float1] AS [Float2]-[Float1]

      IF [Float1]<[OneDayTimeStamp]
        FORE_JUMP
      END_IF
    END_IF

    CALC [Str1] AS [Float2|R0,0]
    INI_WRITE [Res],[Str1],[SCRIPT_STRING],[CONFIG_FILE],[TaskName],[AppName]

    WAIT_INFO 'Bitte warten...','Hintergrundaufgaben werden geprft und ggf. ausgefhrt'


    ; DO IT HERE


    END_WAIT

    FORE_MARK

    IF [Need2SwitchUser]
      SWITCH_USER [Res], [Buf4MitID]
    END_IF

    RECORD_LOCK [TaskName],1,FALSE,[Res],FALSE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END