; This script is started everytime the timer fires.
; It checks if the final script should be started or not.
; If also checks if the final script is already running.

  PROCEDURE InitVars
    VAR_STR  AStr
    VAR_STR  APart
    VAR_NUM  ACnt
    VAR_BOOL IORes
    VAR_DATE ADate
    VAR_NUM  APos
    VAR_STR  CFGDateiName
    VAR_TIME StartTime
    VAR_TIME StopTime

    CALC [CFGDateiName] AS CON([SPECIAL_PATH],'IDEAL.CFG')
  END_PROC


  PROCEDURE Main
    IF [BGJ001.JobIsRunning]
      EXIT_PROC
    END_IF

    CALL InitVars

    IF [BGJ001.WorkTime]<>''
      DATE_2_WEEK_DAY [Date],[AStr],TRUE
      CALC [AStr]  AS UPCASE([AStr])
      CALC [APart] AS [AStr]
      CALC [APos] AS POS([AStr],[BGJ001.WorkTime])
      IF [APos]=0
        ; worktime has entrys, but the actual day could not be found in the worktime string = exit without doing anything
        EXIT_PROC
      END_IF

      CALC [AStr] AS PART([BGJ001.WorkTime],2,[AStr])
      IF [AStr]<>''
        CALC [AStr] AS FILTER([AStr],[APart])
      END_IF
      IF [AStr]=''
        ; for the choosen day no times are specified, so continue with executing the script
        FORE_JUMP
      END_IF

      CALC [AStr] AS PART([AStr],1,'|')
      IF [AStr]=''
        ; for the choosen day no times are specified, so continue with executing the script
        FORE_JUMP
      END_IF

      ; now check the times
      CALC [ACnt]  AS 1
      CALC [IORes] AS TRUE
      WHILE [IORes]
        INC  [ACnt]
        CALC [APart] AS PART([AStr],[ACnt],',')
        IF [APart]=''
          ; no time given = error
          EXIT_PROC
        END_IF

        CALC [APart]     AS PART([APart],1,'-')
        CALC [StartTime] AS [APart]
        CALC [APart]     AS PART([AStr],[ACnt],',')
        CALC [APart]     AS PART([APart],2,'-')
        CALC [StopTime]  AS [APart]

        IF [Time]>=[StartTime]
          IF [Time]<=[StopTime]
            ; the actual time is in the given range, so continue with executing the script
            FORE_JUMP
          END_IF
        END_IF
      END_WHILE
    END_IF


    FORE_MARK

    IF [BGJ001.TimerOnceADayYes]
      INI_READ [IORes], [AStr], [SCRIPT_STRING], [CFGDateiName], 'LastExecutionDate', 'BGJ'
      IF [IORes]
        IF [AStr]<>''
          CALC [ADate] AS [AStr]
          IF [ADate]>=[Date]
            EXIT_PROC
          END_IF
        END_IF
      ELSE
        MESSAGE 'Fehler','Der Schlssel "LastExecutionDate" konnte nicht gelesen werden',[MESSAGE_ERROR]
      END_IF
    END_IF

    CALC [BGJ001.JobIsRunning] AS TRUE

    SCRIPT 'BackGroundJob001Exec.CSH'

    IF [BGJ001.TimerOnceADayYes]
      CALC [AStr] AS [Date]
      INI_WRITE [IORes], [AStr], [SCRIPT_STRING], [CFGDateiName], 'LastExecutionDate', 'BGJ'
      IF [IORes]=FALSE
        MESSAGE 'Fehler','Der Schlssel "LastExecutionDate" konnte nicht geschrieben werden',[MESSAGE_ERROR]
      END_IF
    END_IF

    CALC [BGJ001.JobIsRunning] AS FALSE
  END_PROC


SCRIPT_BEGIN
  PANEL_SET
  PANEL_INFO 'Der Timer "BackGroundJob001" luft...'

  CALL Main

  PANEL_SET
  PANEL_INFO ''
SCRIPT_END
