  ; Abstand zweier Postleitzahlen in km bei www.koordinaten.de abfragen
  ;
  ; Parameter PAR_STR1 = PLZ 1
  ;           PAR_STR2 = PLZ 2
  ;
  ; Die Globale-Variable "GlobPLZAbstand" vom Typ FLOAT hlt anschlieend das Ergebnis bereit.


  PROCEDURE InitVars
    CONST_STR EigeneKundenKennung, 'rhig35_bockig'

    VAR_QUERY Q
    VAR_BOOL  Res
    VAR_BOOL  PLZAbfrageTableAvail
    VAR_FLOAT NewRecID

    QUERY [Q]
      UPDATE plzabfrage
         SET PLZ1     = "XXXXXXXXXX",
             PLZ2     = "XXXXXXXXXX"
       WHERE RecordID = 0
    END_QUERY
    EXECUTE [Q],[PLZAbfrageTableAvail]

    IF [PLZAbfrageTableAvail]=FALSE
      QUERY [Q]
        CREATE TABLE plzabfrage
            ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
              IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
              LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
              Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
              UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
              UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
              RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
              EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],

              PLZ1                      [SQL_DEFINE_STRING]   (10)  [SQL_DEFINE_STRING_END],
              PLZ2                      [SQL_DEFINE_STRING]   (10)  [SQL_DEFINE_STRING_END],
              Abstand                   [SQL_DEFINE_FLOAT]          [SQL_DEFINE_FLOAT_END]

              [SQL_DEFINE_PRIMARY_KEY2]
            )
      END_QUERY
      EXECUTE [Q],[PLZAbfrageTableAvail]

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          CREATE UNIQUE INDEX IndPARecordID    ON plzabfrage (RecordID) [SQL_DEFINE_PRIMARY_KEY3]
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
      END_IF

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          CREATE UNIQUE INDEX IndPAPLZ12       ON plzabfrage (PLZ1,PLZ2)
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
      END_IF

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          CREATE        INDEX IndPAAbstand     ON plzabfrage (Abstand)
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
      END_IF

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          CREATE        INDEX IndPAPLZ1        ON plzabfrage (PLZ1)
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
      END_IF

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          CREATE        INDEX IndPAPLZ2        ON plzabfrage (PLZ2)
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
      END_IF

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          INSERT INTO plzabfrage VALUES (0,0,0,0,0,0,0,0,"XXXXXXXXXX","XXXXXXXXXX",0)
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
      END_IF

      IF [PLZAbfrageTableAvail]
        QUERY [Q]
          SELECT RecordID
            FROM tablefld
           WHERE TableName = "plzabfrage"
        END_QUERY
        EXECUTE [Q],[PLZAbfrageTableAvail]
        IF [PLZAbfrageTableAvail]
          GET_DATA [Q],[PLZAbfrageTableAvail]
        END_IF

        IF [PLZAbfrageTableAvail]=FALSE
          NEW_RECORD [PLZAbfrageTableAvail],'tablefld',[NewRecID], TRUE, FALSE, FALSE
          IF [PLZAbfrageTableAvail]
            QUERY [Q]
              UPDATE tablefld
                 SET Name       = "plzabfrage",
                     TableName  = "plzabfrage",
                     XRefName   = "plzabfrage",
                     FieldName1 = "Recordid",
                     FieldName2 = "Recordid",
                     FieldName3 = "Recordid",
                     FieldName4 = "Recordid",
                     NoteWidth  = 500,
                     UseDefID   = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION],
                     DefinedID  = 0
               WHERE RecordID   = [NewRecID|R0,0]
            END_QUERY
            EXECUTE [Q],[PLZAbfrageTableAvail]
          END_IF
        END_IF
      END_IF
    END_IF


    VAR_FLOAT ActProcessID
    VAR_STR   NaviRes
    VAR_STR   PLZAbfrage
    VAR_LIST  AList
    VAR_NUM   LnAct
    VAR_NUM   LnCnt
    VAR_STR   Str1

    IF [PAR_STR1]>[PAR_STR2]
      CALC [Str1]     AS [PAR_STR1]
      CALC [PAR_STR1] AS [PAR_STR2]
      CALC [PAR_STR2] AS [Str1]
    END_IF

    IDENTIFIER_EXIST 'GlobPLZAbstand',[Res]
    IF [Res]
      CALC [GlobPLZAbstand] AS 0.0
    ELSE
      GLOBAL_FLOAT GlobPLZAbstand
    END_IF


    ACT_REC_ID [ActProcessID]

    CALC [NaviRes]    AS CON([PRINTSET_PATH],'PLZAbstand_',[STATION_SHORT],'_',[ActProcessID|R0,0],'.txt')

    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF

    CALC [PLZAbfrage] AS CON('http://www.koordinaten.de/kunden/',[EigeneKundenKennung],'/entfern.php?plz1=',[PAR_STR1],'&plz2=',[PAR_STR2])

    VAR_MASK  WorkMask, 'PLZAbstandDlg'

    CALC [WorkMask!MASK_HOOK_POST_NAVIGATE] AS 'PostNavigate'
    CALC [WorkMask!MASK_HOOK_EXIT]          AS 'ExitHook'
  END_PROC


; IF [QuelleStr]>>'*malachit*'
;   CALC [QuelleStr] AS PART([QuelleStr],2,'malachit')
;   CALC [QuelleStr] AS PART([QuelleStr],2,'+')
;   CALC [QuelleStr] AS PART([QuelleStr],1,'+')
;   CALC [QuelleStr] AS '\\hdfksdh\kjdahkjdsah\dkkdshf\test.htm'
;   CALC [QuelleStr] AS REVERESE_PART([QuelleStr],1,'\')
; Ergebnis = test.htm
;   CALC [QuelleStr] AS DIGITS([QuelleStr],'+#')
;

  PROCEDURE PostNavigate
    IF [WorkMask!MASK_ACT_FIELD_NAME]='OnlineInfo'
      NAVIGATE [WorkMask], 'OnlineInfo', [NAVIGATE_SAVE], [NaviRes]

      LIST_CLR [AList]
      LIST_FILE_READ [AList],[Res],[NaviRes]
      IF [Res]
        LIST_ITEM_GET [AList],[LnAct],[LnCnt]
        IF [LnCnt]>0
          LIST_STR_GET [AList],[Str1],1
          CALC [GlobPLZAbstand] AS VAL([Str1])

          IF [GlobPLZAbstand]>[EPSILON]
            IF [PLZAbfrageTableAvail]
              ; Speichern in Tabelle "PLZAbfrage"
              NEW_RECORD [Res],'plzabfrage',[NewRecID], TRUE, FALSE, FALSE
              IF [Res]
                QUERY [Q]
                  UPDATE plzabfrage
                     SET PLZ1     = "[PAR_STR1]",
                         PLZ2     = "[PAR_STR2]",
                         Abstand  =  [GlobPLZAbstand]
                   WHERE RecordID =  [NewRecID|R0,0]
                END_QUERY

                EXECUTE [Q],[Res]
                IF [Res]=FALSE
                  MESSAGE 'Achtung Fehler','Ein neuer Datensatz der Tabelle PLZAbfrage konnte nicht initialisiert werden.',[MESSAGE_ERROR]

                  QUERY [Q]
                    DELETE FROM plzabfrage WHERE RecordID = [NewRecID|R0,0]
                  END_QUERY
                  EXECUTE [Q],[Res]
                END_IF
              ELSE
                MESSAGE 'Achtung Fehler','Es konnte kein neuer Datensatz in der Tabelle PLZAbfrage angelegt werden.',[MESSAGE_ERROR]
              END_IF
            END_IF
          END_IF
        END_IF
      END_IF

       MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
    END_IF
  END_PROC


  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE

    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF
  END_PROC



  PROCEDURE Main
    IF [PAR_STR1]=''
      ; Keine Daten fr die erste  PLZ angegeben
      EXIT_PROC
    END_IF

    IF [PAR_STR2]=''
      ; Keine Daten fr die zweite PLZ angegeben
      EXIT_PROC
    END_IF

    IF [PLZAbfrageTableAvail]
      QUERY [Q]
        SELECT Abstand
          FROM plzabfrage
         WHERE PLZ1 = "[PAR_STR1]"
           AND PLZ2 = "[PAR_STR2]"
      END_QUERY

      EXECUTE [Q],[Res]
      IF [Res]
        GET_DATA [Q],[Res]
        IF [Res]
          CALC [GlobPLZAbstand] AS [Q!Abstand]
          EXIT_PROC
        END_IF
      END_IF
    END_IF

    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
CALC [PAR_STR1] AS '44678'
CALC [PAR_STR2] AS '69493'
  CALL InitVars
  CALL Main
SHOW_VAR [GlobPLZAbstand]
SCRIPT_END