  ; UStIDNr und Adresse eines auslndischen UStIDNr online prfen (inlndische knnen so nicht geprft werden!)
  ;
  ; Parameter RECORD_ID1   AdressenID
  ;           RECORD_ID2   0=keine Meldungen,  1=Meldungen ausgeben
  ;           PAR_STR3     eigene UStIDNr
  ;
  ; Die Globale-Variable "UStIDNrPruefungRes" vom Typ NUM hlt anschlieend das Ergebnis bereit. (200=ok)
  ; In der Variable [GLOB_RES_STR1] steht das Ergebnis in Worten.
  ;
  ; http://evatr.bff-online.de/eVatR/xmlrpc/schnittstelle



  PROCEDURE InitVars
    CALC [GLOB_RES_STR1] AS ''

    VAR_BOOL   Res

    VAR_BOOL   ShowMessages
    IF [RECORD_ID2]>[EPSILON]
      CALC [ShowMessages] AS TRUE
    END_IF

    VAR_STR    EigeneUStIDNr
    CALC [EigeneUStIDNr] AS [PAR_STR3]
    IF [EigeneUStIDNr]=''
      CALC [GLOB_RES_STR1] AS 'Es wurde keine eigene UStIDNr bergeben.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      EXIT_PROC
    END_IF

    VAR_QUERY  Q

    VAR_FLOAT  ActProcessID
    VAR_STR    NaviRes
    VAR_STR    UStIDNrPruefung

    VAR_LIST   AList
    VAR_NUM    LnAct
    VAR_NUM    LnCnt
    VAR_NUM    SPos
    VAR_STR    Str1

    VAR_STR    UStIDNr
    VAR_STR    Name
    VAR_STR    Ort
    VAR_STR    PLZ
    VAR_STR    Strasse
    VAR_STR    CRLF

    CALC [CRLF] AS CHAR(#13#10)

    IDENTIFIER_EXIST 'UStIDNrPruefungRes',[Res]
    IF [Res]
      CALC [UStIDNrPruefungRes] AS 0
    ELSE
      GLOBAL_NUM UStIDNrPruefungRes
    END_IF


    ACT_REC_ID [ActProcessID]

    CALC [NaviRes]    AS CON([PRINTSET_PATH],'UStIDNrPruefung_',[STATION_SHORT],'_',[ActProcessID|R0,0],'.txt')

    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF

    IF [RECORD_ID1]<=[EPSILON]
      CALC [GLOB_RES_STR1] AS 'Bitte geben Sie eine Datensatz-ID fr die Adresse an'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      CALC [Res] AS FALSE
      EXIT_PROC
    END_IF

    QUERY [Q]
      SELECT UStIDNr, Name1, Name2, Ort, PLZ, Strasse
        FROM adressen
       WHERE RecordID = [RECORD_ID1|R0,0]
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      CALC [GLOB_RES_STR1] AS 'Die Abfrage zum Prfen einer UStIDNr kann nicht ausgefhrt werden.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      EXIT_PROC
    END_IF
    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      CALC [GLOB_RES_STR1] AS 'Die Adresse, bei der eine UStIDNr geprft werden soll, kann nicht gefunden werden.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      EXIT_PROC
    END_IF

    CALC [UStIDNr] AS [Q!UStIDNr]
    CALC [UStIDNr] AS FILTER([UStIDNr],' ')
    CALC [UStIDNr] AS TRIM([UStIDNr])
    IF [UStIDNr]=''
      CALC [GLOB_RES_STR1] AS 'Die Adresse, bei der eine UStIDNr geprft werden soll, enthlt keine UStIDNr.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      CALC [Res] AS FALSE
      EXIT_PROC
    END_IF

    CALC [Name] AS TRIM([Q!Name1])
    IF [Name]=''
      CALC [GLOB_RES_STR1] AS 'Die Adresse, bei der eine UStIDNr geprft werden soll, enthlt keinen Namen.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      CALC [Res] AS FALSE
      EXIT_PROC
    END_IF

    CALC [Ort] AS TRIM([Q!Ort])
    IF [Ort]=''
      CALC [GLOB_RES_STR1] AS 'Die Adresse, bei der eine UStIDNr geprft werden soll, enthlt keinen Ort.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      CALC [Res] AS FALSE
      EXIT_PROC
    END_IF

    CALC [PLZ] AS TRIM([Q!PLZ])
    IF [PLZ]=''
      CALC [GLOB_RES_STR1] AS 'Die Adresse, bei der eine UStIDNr geprft werden soll, enthlt keine PLZ.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      CALC [Res] AS FALSE
      EXIT_PROC
    END_IF

    CALC [Strasse] AS TRIM([Q!Strasse])
    IF [Strasse]=''
      CALC [GLOB_RES_STR1] AS 'Die Adresse, bei der eine UStIDNr geprft werden soll, enthlt keine Strasse.'
      IF [ShowMessages]
        MESSAGE 'Achtung Abbruch',[GLOB_RES_STR1],[MESSAGE_WARNING]
      END_IF
      CALC [Res] AS FALSE
      EXIT_PROC
    END_IF

    CALC [Name]    AS  A2HTML([Name])
    CALC [Name]    AS REPLACE([Name],' ','%20')

    CALC [Ort]     AS A2HTML([Ort])
    CALC [Ort]     AS REPLACE([Ort],' ','%20')

    CALC [PLZ]     AS A2HTML([PLZ])
    CALC [PLZ]     AS REPLACE([PLZ],' ','%20')

    CALC [Strasse] AS A2HTML([Strasse])
    CALC [Strasse] AS REPLACE([Strasse],' ','%20')


    CALC [UStIDNrPruefung] AS CON('http://evatr.bff-online.de/evatrRPC?UstId_1=',[EigeneUStIDNr],'&UstId_2=',[UStIDNr],'&Firmenname=',[Name],'&Ort=',[Ort],'&PLZ=',[PLZ],'&Strasse=',[Strasse],'&Druck=ja')

    VAR_MASK  WorkMask, 'UStIDNrPruefungDlg'

    CALC [WorkMask!MASK_HOOK_EXIT]          AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_IS_READY]      AS 'IsReadyHook'
  END_PROC


  PROCEDURE PostNavigate
    IF [WorkMask!MASK_ACT_FIELD_NAME]='OnlineInfo'
      NAVIGATE [WorkMask], 'OnlineInfo', [NAVIGATE_SAVE], [NaviRes]

      LIST_CLR [AList]
      LIST_FILE_READ [AList],[Res],[NaviRes]
      IF [Res]
        LIST_ITEM_GET [AList],[LnAct],[LnCnt]
        IF [LnCnt]>0
          CALC [LnAct] AS 1
          WHILE [LnAct]<=[LnCnt]
            LIST_STR_GET [AList],[Str1],[LnAct]
            INC [LnAct]
            CALC [SPos] AS POS('>ErrorCode<',[Str1]
            IF [SPos]>0
              LIST_STR_GET [AList],[Str1],[LnAct]
              CALC [Str1] AS PART([Str1],2,'<string>')
              CALC [Str1] AS PART([Str1],1,'<')
              CALC [Str1] AS TRIM([Str1])
              CALC [UStIDNrPruefungRes] AS VAL([Str1])
              MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
            END_IF
          END_WHILE
        END_IF
      END_IF
    END_IF
  END_PROC


  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE

    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF
  END_PROC



  PROCEDURE Main
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    MASK_PROCESS [WorkMask]

    CALC [Str1] AS 'Die UStIDNr-Prfung konnte nicht durchgefhrt werden'
    IF [UStIDNrPruefungRes]=200
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist gltig'
    ELSE_IF [UStIDNrPruefungRes]=201
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig.'
    ELSE_IF [UStIDNrPruefungRes]=202
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie ist nicht in der Unternehmerdatei des betreffenden EU-Mitgliedstaates registriert.'
      ; Hinweis: Ihr Geschftspartner kann seine gltige USt-IdNr. bei der fr ihn zustndigen Finanzbehrde in Erfahrung bringen.
      ;          Mglicherweise muss er einen Antrag stellen, damit seine USt-IdNr. in die Datenbank aufgenommen wird.
    ELSE_IF [UStIDNrPruefungRes]=203
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie ist in Zukunft gltig.'
      ; Sie ist erst ab dem ... gltig (siehe Feld "Gueltig_ab").'
    ELSE_IF [UStIDNrPruefungRes]=204
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie war frher einmal gltig.'
      ; Sie war im Zeitraum von ... bis ... gltig (siehe Feld 'Gueltig_ab' und 'Gueltig_bis').
    ELSE_IF [UStIDNrPruefungRes]=205
      CALC [Str1] AS 'Ihre Anfrage kann derzeit durch den angefragten EU-Mitgliedstaat oder aus anderen Grnden nicht beantwortet werden.|Bitte versuchen Sie es spter noch einmal. '
      ; Bei wiederholten Problemen wenden Sie sich bitte an das Bundeszentralamt fr Steuern - Dienstsitz Saarlouis.
    ELSE_IF [UStIDNrPruefungRes]=206
      CALC [Str1] AS 'Ihre deutsche USt-IdNr. ist ungltig. Eine Besttigungsanfrage ist daher nicht mglich.|Den Grund hierfr knnen Sie beim Bundeszentralamt fr Steuern - Dienstsitz Saarlouis - erfragen.'
    ELSE_IF [UStIDNrPruefungRes]=207
      CALC [Str1] AS 'Ihnen wurde die deutsche USt-IdNr. ausschliesslich zu Zwecken der Besteuerung des innergemeinschaftlichen Erwerbs erteilt.|Sie sind somit nicht berechtigt, Besttigungsanfragen zu stellen.'
    ELSE_IF [UStIDNrPruefungRes]=208
      CALC [Str1] AS 'Fr die von Ihnen angefragte USt-IdNr. luft gerade eine Anfrage von einem anderen Nutzer.|Eine Bearbeitung ist daher nicht mglich.|Bitte versuchen Sie es spter noch einmal.'
    ELSE_IF [UStIDNrPruefungRes]=209
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie entspricht nicht dem Aufbau der fr diesen EU-Mitgliedstaat gilt. ( Aufbau der USt-IdNr. aller EU-Lnder)'
    ELSE_IF [UStIDNrPruefungRes]=210
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie entspricht nicht den Prfziffernregeln die fr diesen EU-Mitgliedstaat gelten.'
    ELSE_IF [UStIDNrPruefungRes]=211
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie enthlt unzulssige Zeichen.'
    ELSE_IF [UStIDNrPruefungRes]=212
      CALC [Str1] AS 'Die angefragte USt-IdNr. ist ungltig. Sie enthlt ein unzulssiges Lnderkennzeichen.'
    ELSE_IF [UStIDNrPruefungRes]=213
      CALC [Str1] AS 'Die Abfrage einer deutschen USt-IdNr. ist nicht mglich.'
    ELSE_IF [UStIDNrPruefungRes]=214
      CALC [Str1] AS 'Ihre deutsche USt-IdNr. ist fehlerhaft. Sie beginnt mit "DE" gefolgt von 9 Ziffern.'
    ELSE_IF [UStIDNrPruefungRes]=215
      CALC [Str1] AS 'Ihre Anfrage enthlt nicht alle notwendigen Angaben fr eine einfache Besttigungsanfrage (Ihre deutsche USt-IdNr. und die ausl. USt-IdNr.).|Ihre Anfrage kann deshalb nicht bearbeitet werden.'
    ELSE_IF [UStIDNrPruefungRes]=216
      CALC [Str1] AS 'Ihre Anfrage enthlt nicht alle notwendigen Angaben fr eine qualifizierte Besttigungsanfrage (Ihre deutsche USt-IdNr., die ausl. USt-IdNr., Firmenname einschl. Rechtsform und Ort).'
      ; Es wurde eine einfache Besttigungsanfrage durchgefhrt mit folgenden Ergebnis: Die angefragte USt-IdNr. ist gltig.
    ELSE_IF [UStIDNrPruefungRes]=217
      CALC [Str1] AS 'Bei der Verarbeitung der Daten aus dem angefragten EU-Mitgliedstaat ist ein Fehler aufgetreten.|Ihre Anfrage kann deshalb nicht bearbeitet werden.'
    ELSE_IF [UStIDNrPruefungRes]=218
      CALC [Str1] AS 'Eine qualifizierte Besttigung ist zur Zeit nicht mglich.|Es wurde eine einfache Besttigungsanfrage mit folgendem Ergebnis durchgefhrt:|Die angefragte USt-IdNr. ist gltig.'
    ELSE_IF [UStIDNrPruefungRes]=219
      CALC [Str1] AS 'Bei der Durchfhrung der qualifizierten Besttigungsanfrage ist ein Fehler aufgetreten.|Es wurde eine einfache Besttigungsanfrage mit folgendem Ergebnis durchgefhrt:|Die angefragte USt-IdNr. ist gltig.'
    ELSE_IF [UStIDNrPruefungRes]=220
      CALC [Str1] AS 'Bei der Anforderung der amtlichen Besttigungsmitteilung ist ein Fehler aufgetreten.|Sie werden kein Schreiben erhalten.'
    ELSE_IF [UStIDNrPruefungRes]=999
      CALC [Str1] AS 'Eine Bearbeitung Ihrer Anfrage ist zurzeit nicht mglich.|Bitte versuchen Sie es spter noch einmal.'
    END_IF

    IF [ShowMessages]
      MESSAGE 'Information',[Str1]
    END_IF

    CALC [GLOB_RES_STR1] AS [Str1]
  END_PROC


  PROCEDURE IsReadyHook
    CALC [WorkMask!MASK_HOOK_IS_READY] AS ''
    CALC [WorkMask!MASK_HOOK_POST_NAVIGATE] AS 'PostNavigate'
    NAVIGATE [WorkMask], 'OnlineInfo', [UStIDNrPruefung], [NaviRes]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

