  ; Whrungskurs abfragen bei http://de.finance.yahoo.com/waehrungsrechner/
  ;
  ; Parameter PAR_STR1 = Whrung 1 (meist EUR bzw. Systemwhrung)
  ;           PAR_STR2 = Whrung 2
  ;
  ; Die Globale-Variable "GlobWaehrungsKurs" vom Typ FLOAT hlt anschlieend das Ergebnis bereit.


  PROCEDURE InitVars
    VAR_FLOAT ActProcessID
    VAR_STR   NaviRes
    VAR_STR   WaehrungAbfrage
    VAR_LIST  MainList
    VAR_LIST  SubList
    VAR_NUM   LnAct
    VAR_NUM   LnCnt
    VAR_NUM   SubLnAct
    VAR_NUM   SubLnCnt
    VAR_STR   Str1
    VAR_BOOL  Res

    IDENTIFIER_EXIST 'GlobWaehrungsKurs',[Res]
    IF [Res]
      CALC [GlobWaehrungsKurs] AS 0.0
    ELSE
      GLOBAL_FLOAT GlobWaehrungsKurs
    END_IF

    CALC [PAR_STR1] AS UPCASE([PAR_STR1])
    CALC [PAR_STR2] AS UPCASE([PAR_STR2])

    ACT_REC_ID [ActProcessID]

    CALC [NaviRes] AS CON([PRINTSET_PATH],'WaehrungsKurs_',[STATION_SHORT],'_',[ActProcessID|R0,0],'.txt')

    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF

;   CALC [WaehrungAbfrage] AS CON('http://de.finance.yahoo.com/waehrungsrechner/convert?amt=1&from=',[PAR_STR1],'&to=',[PAR_STR2],'&submit=Umrechnen')
    CALC [WaehrungAbfrage] AS CON('http://de.finance.yahoo.com/waehrungen/waehrungsrechner/#from=',[PAR_STR1],';to=',[PAR_STR2],';amt=1')

    VAR_MASK  WorkMask, 'WaehrungAbfrageDlg'

    CALC [WorkMask!MASK_HOOK_POST_NAVIGATE] AS 'PostNavigate'
    CALC [WorkMask!MASK_HOOK_EXIT]          AS 'ExitHook'
  END_PROC



  PROCEDURE PostNavigate
    IF [WorkMask!MASK_ACT_FIELD_NAME]='OnlineInfo'
      NAVIGATE [WorkMask], 'OnlineInfo', [NAVIGATE_SAVE], [NaviRes]

      LIST_CLR [MainList]
      LIST_FILE_READ [MainList],[Res],[NaviRes]
      IF [Res]
        LIST_ITEM_GET [MainList],[LnAct],[LnCnt]
        IF [LnCnt]>0
          CALC [LnAct] AS 1
          WHILE [LnAct]<=[LnCnt]
            LIST_CLR [SubList]
            LIST_STR_2_LIST [MainList], [SubList], '<td class="yfnc_tabledata1">', 0, [LnAct]

            LIST_ITEM_GET [SubList],[SubLnAct],[SubLnCnt]
            IF [SubLnCnt]>1
              LIST_STR_GET [SubList],[Str1],5
              CALC [Str1]  AS PART([Str1],1,'<')
              CALC [Str1]  AS REPLACE([Str1],',','.')
              CALC [LnAct] AS [LnCnt]
              CALC [GlobWaehrungsKurs] AS VAL([Str1])
            END_IF

            INC [LnAct]
          END_WHILE
        END_IF
      END_IF

       MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
    END_IF
  END_PROC


  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE

    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF
  END_PROC



  PROCEDURE Main
    IF [PAR_STR1]=''
      ; Keine Daten fr die erste  Whrung angegeben
      EXIT_PROC
    END_IF

    IF [PAR_STR2]=''
      ; Keine Daten fr die zweite Whrung angegeben
      EXIT_PROC
    END_IF

    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
CALC [PAR_STR1] AS 'EUR'
CALC [PAR_STR2] AS 'USD'
  CALL InitVars
  CALL Main
SHOW_VAR [GlobWaehrungsKurs]
SCRIPT_END