  ; Dieter Dasberg am 26.01.2000
  ;
  ; Dieses Script exportiert alle Adressen so, wie sie vom Programm CATS
  ; (Telefonie-Lsung, www.cats.ms, info@cats.ms) verarbeitet werden knnen.
  ;
  ; Die Daten werden Zeilenweise in die Datei geschrieben. Das Format ist:
  ;
  ; Tel1,Tel2,Mobil,Fax|Adressnummer|Name1|||Anwendungsname|Mandant|Adresskenner|RecordID||Name2|Strasse|Land-PLZ|Ort|Zusatz
  ;
  ; "Adressnummer" kann Kundennumer oder Lieferantennummer oder Personalnummer oder leer sein
  ; "Adresskenner" ist L=Lieferant oder K=Kunde oder I=Interessent oder M=Mitarbeiter


  PROCEDURE InitVars
    VAR_STR    ExportFileName
    VAR_STR    ExportMandant
    VAR_STR    ExportAnwendung

    LOCAL_BOOL CC.IORes,    FALSE
    LOCAL_STR  CC.CatsDir,  ''
    LOCAL_STR  CC.CatsCall, ''

    INI_READ  [CC.IORes], [CC.CatsDir], [SCRIPT_STRING], [APPLICATION_INI_FILE], 'CatsSpoolDir', 'Config'

    IF [CC.CatsDir]=''
      MESSAGE 'Achtung Abbruch','Es ist kein Pfad zur Cats-Telefonie-Lsung in der INI-Datei angegeben worden.',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    CALC [ExportFileName] AS CON([CC.CatsDir],'\CATS-EXP.DAT')


    CALC [ExportMandant] AS [IP_FIRMEN_KUERZEL]
    IF [ExportMandant]=''
      CALC [ExportMandant] AS 'MANDANT'
    END_IF

    CALC [ExportAnwendung] AS [APPLICATION_NAME]
    IF [ExportAnwendung]=''
      CALC [ExportAnwendung] AS 'ANWENDUNG'
    END_IF

    VAR_STREAM ExportFile
    VAR_STR    ExportStr1
    VAR_STR    ExportStr2
    VAR_STR    ExportStr3
    VAR_STR    ExportStr4
    VAR_STR    ExportNummer
    VAR_STR    ExportZeichen
    VAR_STR    CRLF
    VAR_STR    TmpStr

    VAR_NUM    Cnt
    VAR_NUM    Max

    VAR_BOOL   Result
    VAR_BOOL   DoExport
    VAR_BOOL   Search4SubAdresses

    VAR_QUERY  MainQuery
    VAR_QUERY  SubQuery
    VAR_QUERY  UpdtQuery

    CALC [CRLF] AS CHAR(#13#10)
  END_PROC


  PROCEDURE MarkAdressAsDone VF MAAD.ID
    QUERY [UpdtQuery]
      UPDATE adressen SET EventFlag = 0 WHERE RecordID = [MAAD.ID|R0,0]
    END_QUERY
    EXECUTE [UpdtQuery],[Result]
  END_PROC


  PROCEDURE WriteExportStrings
    FILE_WRITE [ExportFile],[ExportStr1],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Daten konnten nicht geschrieben werden'
      EXIT_PROC
    END_IF

    FILE_WRITE [ExportFile],[ExportStr2],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Daten konnten nicht geschrieben werden'
      EXIT_PROC
    END_IF

    FILE_WRITE [ExportFile],[ExportStr3],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Daten konnten nicht geschrieben werden'
      EXIT_PROC
    END_IF

    FILE_WRITE [ExportFile],[ExportStr4],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Daten konnten nicht geschrieben werden'
      EXIT_PROC
    END_IF
  END_PROC


  PROCEDURE WriteSubLine
    ; gebaut  wird : Telefon1,Telefon2,Mobil,Fax|
    ; mglich sind : Telefon1,Telefon2,Telefon3,Telefon4,Fax1,Fax2,Fax3,Fax4,Mobil1,Mobil2|
    CALC [ExportStr1] AS CON([SubQuery!A.Telefon1],',',[SubQuery!A.Telefon2],',',[SubQuery!A.Mobil1],',',[SubQuery!A.Fax1],'|')

    ; gebaut  wird : Kndnr/LiefNr/PersonalNummer|Name1|||IDEAL|NOZAR|L/K/I/M|
    CALC [ExportStr2] AS CON([ExportNummer],'|',[SubQuery!A.Name1],'|||',[ExportAnwendung],'|',[ExportMandant],'|',[ExportZeichen],'|')

    ; gebaut  wird : RecordID||Name2|Strasse|Land-PLZ|Ort|Zusatz
    CALC [TmpStr] AS [SubQuery!A.Land]
    IF [TmpStr]=''
      CALC [TmpStr] AS 'D'
    END_IF
    CALC [TmpStr] AS CON([TmpStr],'-',[SubQuery!A.Plz])

    CALC [ExportStr3] AS CON([SubQuery!A.RecordID|R0,0],'-',[MainQuery!RecordID|R0,0],'||',[SubQuery!A.Name2],'|',[SubQuery!A.Strasse],'|',[TmpStr],'|',[SubQuery!A.Ort],'|')

    CALC [ExportStr4] AS ''
    IF [SubQuery!Zusatz1]<>''
      IF [ExportStr4]<>''
        CALC [ExportStr4] AS CON([ExportStr4],', ',[SubQuery!Zusatz1])
      ELSE
        CALC [ExportStr4] AS [SubQuery!Zusatz1]
      END_IF
    END_IF
    IF [SubQuery!Zusatz2]<>''
      IF [ExportStr4]<>''
        CALC [ExportStr4] AS CON([ExportStr4],', ',[SubQuery!Zusatz2])
      ELSE
        CALC [ExportStr4] AS [SubQuery!Zusatz2]
      END_IF
    END_IF
;   IF [SubQuery!Zusatz3]<>''
;     IF [ExportStr4]<>''
;       CALC [ExportStr4] AS CON([ExportStr4],', ',[SubQuery!Zusatz3])
;     ELSE
;       CALC [ExportStr4] AS [SubQuery!Zusatz3]
;     END_IF
;   END_IF
    CALC [ExportStr4] AS CON([ExportStr4],[CRLF])

    CALL WriteExportStrings
  END_PROC


  PROCEDURE WriteSubAdresses
    QUERY [SubQuery]
        SELECT A.Telefon1,A.Telefon2,A.Telefon3,A.Telefon4,
               A.Fax1,A.Fax2,A.Fax3,A.Fax4,
               A.Mobil1, A.Mobil2, Zusatz1, Zusatz2, Zusatz3,
               A.Name1,A.Name2,A.Land,A.Plz,A.Ort,A.Strasse,
               A.RecordID, A.RecFlag,
               Z.AdressenID, Z.RelationID, Z.RecordID
          FROM AdrZuord Z, Adressen A
         WHERE (   (Z.PA = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION])
                OR (Z.RA = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION])
                OR (Z.VA = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION])
               )
           AND Z.AdressenID = [MainQuery!RecordID|R0,0]
           AND A.RecordID = Z.RelationID
      ORDER BY Z.AdressenID, A.Name1
    END_QUERY

    EXECUTE [SubQuery],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zur Ermittlung der zugeordneten Adressen konnte nicht bersetzt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SubQuery],[Result]

    WHILE [Result]
      CALC [DoExport] AS TRUE

      CALL MarkAdressAsDone [SubQuery!A.RecordID]

      IF [SubQuery!A.Telefon1]=''
        IF [SubQuery!A.Telefon2]=''
          IF [SubQuery!A.Mobil1]=''
            IF [SubQuery!A.Fax1]=''
              CALC [DoExport] AS FALSE
            END_IF
          END_IF
        END_IF
      END_IF

      IF [DoExport]
        CALL WriteSubLine
        IF [Result]=FALSE
          EXIT_PROC
        END_IF
      END_IF

      GET_DATA [SubQuery],[Result]
    END_WHILE

    CALC [Result] AS TRUE
  END_PROC


  PROCEDURE WriteLine
    IF [ExportZeichen]=''
      EXIT_PROC
    END_IF

    ; gebaut  wird : Telefon1,Telefon2,Mobil,Fax|
    ; mglich sind : Telefon1,Telefon2,Telefon3,Telefon4,Fax1,Fax2,Fax3,Fax4,Mobil1,Mobil2|
    CALC [ExportStr1] AS CON([MainQuery!Telefon1],',',[MainQuery!Telefon2],',',[MainQuery!Mobil1],',',[MainQuery!Fax1],'|')

    ; gebaut  wird : Kndnr/LiefNr/PersonalNummer|Name1|||IDEAL|NOZAR|L/K/I/M/S|
    CALC [ExportStr2] AS CON([ExportNummer],'|',[MainQuery!Name1],'|||',[ExportAnwendung],'|',[ExportMandant],'|',[ExportZeichen],'|')

    ; gebaut  wird : RecordID||Name2|Strasse|Land-PLZ|Ort
    CALC [TmpStr] AS [MainQuery!Land]
    IF [TmpStr]=''
      CALC [TmpStr] AS 'D'
    END_IF
    CALC [TmpStr] AS CON([TmpStr],'-',[MainQuery!Plz])

    CALC [ExportStr3] AS CON([MainQuery!RecordID|R0,0],'||',[MainQuery!Name2],'|',[MainQuery!Strasse],'|',[TmpStr],'|',[MainQuery!Ort],'|')

    CALC [ExportStr4] AS ''
    IF [MainQuery!Zusatz1]<>''
      IF [ExportStr4]<>''
        CALC [ExportStr4] AS CON([ExportStr4],', ',[MainQuery!Zusatz1])
      ELSE
        CALC [ExportStr4] AS [MainQuery!Zusatz1]
      END_IF
    END_IF
    IF [MainQuery!Zusatz2]<>''
      IF [ExportStr4]<>''
        CALC [ExportStr4] AS CON([ExportStr4],', ',[MainQuery!Zusatz2])
      ELSE
        CALC [ExportStr4] AS [MainQuery!Zusatz2]
      END_IF
    END_IF
;   IF [MainQuery!Zusatz3]<>''
;     IF [ExportStr4]<>''
;       CALC [ExportStr4] AS CON([ExportStr4],', ',[MainQuery!Zusatz3])
;     ELSE
;       CALC [ExportStr4] AS [MainQuery!Zusatz3]
;     END_IF
;   END_IF
    CALC [ExportStr4] AS CON([ExportStr4],[CRLF])

    CALL WriteExportStrings

    IF [Result]
      IF [Search4SubAdresses]
        CALL WriteSubAdresses
      END_IF
    END_IF
  END_PROC


  PROCEDURE DoAllOtherAdresses
    QUERY [MainQuery]
        SELECT Telefon1, Telefon2, Telefon3, Telefon4,
               Fax1, Fax2, Fax3, Fax4,
               Mobil1, Mobil2, Zusatz1, Zusatz2, Zusatz3,
               Name1,Name2,Land,Plz,Ort,Strasse,
               KAktiv, LAktiv, MAktiv, Interessent,
               PersonalNummer, Lieferantennummer,
               Kundennummer,
               RecordID, RecFlag
          FROM Adressen
         WHERE EventFlag = 1
      ORDER BY RecordID
    END_QUERY

    EXECUTE [MainQuery],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zur Ermittlung der "Sonstigen" Adressen konnte nicht bersetzt werden',[MESSAGE_ERROR]
      WAIT_CURSOR FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [MainQuery],[Max]
    CALC [Cnt] AS 0

    GET_DATA [MainQuery],[Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Die "Sonstigen" Adressen werden fr "Cats" exportiert',TRUE,50,2

    WHILE [Result]
      INC [Cnt]
      CALC [TmpStr] AS CON('Die Adressen (',[Cnt],'/',[Max],') werden fr "Cats" exportiert')
      WAIT_INFO 'Bitte warten...',[TmpStr],TRUE,50,2

      CALC [DoExport] AS TRUE

      IF [MainQuery!Telefon1]=''
        IF [MainQuery!Telefon2]=''
          IF [MainQuery!Mobil1]=''
            IF [MainQuery!Fax1]=''
              CALC [DoExport] AS FALSE
            END_IF
          END_IF
        END_IF
      END_IF

      IF [DoExport]
        CALC [Search4SubAdresses] AS FALSE
        CALC [ExportZeichen]      AS 'S'
        CALL WriteLine
      END_IF

      GET_DATA [MainQuery],[Result]
      PROCESS_MESSAGES

      IF [WAIT_BREAK]
        CALC [Result] AS FALSE
      END_IF
    END_WHILE
  END_PROC


  PROCEDURE Main
    WAIT_CURSOR TRUE

    QUERY [MainQuery]
      UPDATE Adressen SET EventFlag = 1 WHERE RecordID > 99
    END_QUERY
    EXECUTE [MainQuery],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Adressen konnten nicht fr den Export initialisiert werden',[MESSAGE_ERROR]
      WAIT_CURSOR FALSE
      EXIT_PROC
    END_IF


    QUERY [MainQuery]
        SELECT Telefon1, Telefon2, Telefon3, Telefon4,
               Fax1, Fax2, Fax3, Fax4,
               Mobil1, Mobil2, Zusatz1, Zusatz2, Zusatz3,
               Name1,Name2,Land,Plz,Ort,Strasse,
               KAktiv, LAktiv, MAktiv, Interessent,
               PersonalNummer, Lieferantennummer,
               Kundennummer,
               RecordID, RecFlag
          FROM Adressen
         WHERE (   (MAktiv > 0)
                OR (LAktiv > 0)
                OR (KAktiv > 0)
                OR (Interessent = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION])
               )
      ORDER BY RecordID
    END_QUERY

    EXECUTE [MainQuery],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zur Ermittlung der Adressen konnte nicht bersetzt werden',[MESSAGE_ERROR]
      WAIT_CURSOR FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [MainQuery],[Max]
    CALC [Cnt] AS 0

    GET_DATA [MainQuery],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Keine Adressen fr den Export vorhanden',[MESSAGE_INFO]
      WAIT_CURSOR FALSE
      EXIT_PROC
    END_IF

    FILE_OPEN [ExportFile],[ExportFileName],[FILE_OPEN_OUT],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Exportdatei konnte nicht geffnet werden',[MESSAGE_ERROR]
      WAIT_CURSOR FALSE
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Die Adressdaten werden fr "Cats" exportiert',TRUE,50,2

    WHILE [Result]
      INC [Cnt]
      CALC [TmpStr] AS CON('Die Adressen (',[Cnt],'/',[Max],') werden fr "Cats" exportiert')
      WAIT_INFO 'Bitte warten...',[TmpStr],TRUE,50,2

      CALL MarkAdressAsDone [MainQuery!RecordID]

      CALC [DoExport] AS TRUE

      IF [MainQuery!Telefon1]=''
        IF [MainQuery!Telefon2]=''
          IF [MainQuery!Mobil1]=''
            IF [MainQuery!Fax1]=''
              CALC [DoExport] AS FALSE
            END_IF
          END_IF
        END_IF
      END_IF

      CALC [Search4SubAdresses] AS FALSE
      CALC [ExportZeichen]      AS 'S'

      IF [MainQuery!MAktiv]>0
        CALC [ExportNummer]  AS [MainQuery!PersonalNummer]
        CALC [ExportZeichen] AS 'M'
      ELSE_IF [MainQuery!LAktiv]>0
        CALC [ExportNummer]  AS [MainQuery!Lieferantennummer]
        CALC [ExportZeichen] AS 'L'
        CALC [Search4SubAdresses] AS TRUE
      ELSE_IF [MainQuery!KAktiv]>0
        CALC [ExportNummer]  AS [MainQuery!Kundennummer]
        CALC [ExportZeichen] AS 'K'
        CALC [Search4SubAdresses] AS TRUE
      ELSE_IF [MainQuery!Interessent]
        CALC [ExportZeichen] AS 'I'
        CALC [Search4SubAdresses] AS TRUE
      END_IF

      IF [DoExport]
        CALL WriteLine
      ELSE_IF [Search4SubAdresses]
        CALL WriteSubAdresses
      END_IF

      GET_DATA [MainQuery],[Result]
      PROCESS_MESSAGES

      IF [WAIT_BREAK]
        CALC [Result] AS FALSE
      END_IF
    END_WHILE


    CALL DoAllOtherAdresses


    FILE_CLOSE [ExportFile]

    WAIT_CURSOR FALSE

    QUERY [MainQuery]
      UPDATE Adressen SET EventFlag = 0 WHERE RecordID > 99
    END_QUERY
    EXECUTE [MainQuery],[Result]

    END_WAIT
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main

  IF [RECORD_ID1]>[EPSILON]
    CARA_HALT
  END_IF
SCRIPT_END
