  ; Dieses Script wird von der Engine angesprochen, wenn es entsprechend in der INI-Datei angegeben wurde.
  ;
  ; Es verarbeitet die Felder des CATS-Events, die mit dem Befehl
  ; CATS [boolRes], [CATS_READ], boolOnOrOff {, strSubStation, strListenEvents, strFieldList}
  ; ausgesucht wurden (siehe Script CatsStart.csh).
  ;



  PROCEDURE InitVars
    VAR_QUERY Q
    VAR_BOOL  Res
    VAR_STR   Name
    VAR_FLOAT RecID
    VAR_FLOAT SubRecID
    VAR_STR   Tmp
    VAR_STR   Swp
    VAR_STR   TelNummer
    VAR_STR   AdrNummer
    VAR_STR   Typ
    VAR_NUM   YNRes
    VAR_STR   TypeName
    VAR_NUM   SLen
    VAR_NUM   SPos

    VAR_MASK  CatsMask,'CatsEventDlg'

    CALC [CatsMask!MASK_HOOK_BUTTON] AS 'ButtonHook'
    CALC [CatsMask!MASK_HOOK_SHOW]   AS 'ShowHook'
    CALC [CatsMask!MASK_HOOK_TIMER]  AS 'TimerHook'
  END_PROC


  PROCEDURE DoButton
    IF [Typ]='L'
      SCRIPT 'LifStExt.csh', [Q!RecordID]
    ELSE_IF [Typ]='K'
      SCRIPT 'KndStExt.csh', [Q!RecordID]
    ELSE_IF [Typ]='I'
      SCRIPT 'AdrInter.csh', [Q!RecordID]
    ELSE_IF [Typ]='M'
      SCRIPT 'MitStamm.csh', [Q!RecordID]
    ELSE_IF [Typ]='S'
      SCRIPT 'adr_alle.csh', [Q!RecordID]
    END_IF
  END_PROC


  PROCEDURE ButtonHook
    MASK_TIMER [CatsMask], 0, FALSE
    CALL DoButton
    MASK_COMMAND [CatsMask],[MASK_COMMAND_EXIT]
  END_PROC


  PROCEDURE ShowHook
    MASK_TIMER [CatsMask], 10000, TRUE
  END_PROC


  PROCEDURE TimerHook
    MASK_COMMAND [CatsMask],[MASK_COMMAND_EXIT]
  END_PROC


  PROCEDURE Main
    CALC [Tmp]       AS PART([PAR_STR1],7,'|')
    CALC [Typ]       AS PART([PAR_STR1],6,'|')
    CALC [Name]      AS PART([PAR_STR1],5,'|')
    CALC [AdrNummer] AS PART([PAR_STR1],4,'|')
    CALC [TelNummer] AS PART([PAR_STR1],3,'|')

    CALC [SLen] AS LEN([TelNummer])
    IF [SLen]<5
      ; Interne Weiterleitungen werden nicht verarbeitet
      EXIT_PROC
    END_IF

    CALC [SubRecID] AS 0.0
    CALC [SPos] AS POS('-',[Tmp])
    IF [SPos]>0
      DEC  [SPos]
      CALC [Swp]  AS COPY([Tmp],1,[SPos])
      CALC [SPos] AS [SPos] + 2
      CALC [Tmp]  AS COPY([Tmp],[SPos],255)
      CALC [SubRecID] AS VAL([Swp])
    END_IF

    CALC [RecID] AS  VAL([Tmp])
    IF [RecID]<[EPSILON]
      EXIT_PROC
    END_IF

    QUERY [Q]
      SELECT RecordID FROM adressen WHERE RecordID = [RecID|R0,0]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [YNRes] AS [ID_YES]

    IF [Typ]='L'
      CALC [TypeName] AS 'Lieferant'
    ELSE_IF [Typ]='K'
      CALC [TypeName] AS 'Kunde'
    ELSE_IF [Typ]='I'
      CALC [TypeName] AS 'Interessent'
    ELSE_IF [Typ]='M'
      CALC [TypeName] AS 'Mitarbeiter'
    ELSE_IF [Typ]='S'
      CALC [TypeName] AS '"sonstige" Adresse'
    END_IF

    CALC [TypeName] AS CON([TypeName],' ',[Name])

    SET_LABEL [CatsMask],'BB_SHOW',[TypeName]
    MASK_PROCESS [CatsMask]
  END_PROC


SCRIPT_BEGIN
   CALL InitVars
   CALL MAin
SCRIPT_END