; Mit diesem Script kann der User entscheiden, ob die CARA-Engine auf die CATS-Ereignisse "horchen" soll.
; Auerdem kann entschieden werden, welche Felder des CATS-Events berhaupt von der Engine weitergeleitet
; werden soll und welcher Event berhaupt zur Kenntnis genommen werden soll.



; Der Cats-Event hat folgende Felder
;
;    1|    2|   3|           4|          5|                  6|        7|           8|           9|                    10|         11|                       12|                13|
; SCNT|EVENT|RCNT|Arbeitsplatz|Eventnummer|Datum      Zeit    |Eventart |Anrufnummer |Nebenstelle |virtuelle Nebenstelle | Nummer    |Info (Nummer)            |Info (virt. NSt.) |
;  972|EVENT|    |            |924526     |2006-04-27 17:50:59|iR       |924525      |13          |13                    |01716074758|Creative Soft- & Hardware|Herr Grundmann    |
;
;            14|   15|                       16|   17|   18|   19|                  20|   21|   22|   23|     24|                      25|     26|          27|                 28|29|30|31|32|
; TEL          |ADR  | NAME                    |RES1 |RES2 |ANW  | MAND               |DATEI|USR1 |USR2 | NAME2 |STR                     |PLZ    |ORT         |ZUS
; +491716074758|70190|Creative Soft- & Hardware|     |     |IDEAL|Pellegrini&Grundmann|L    |101  |/2   |       |Aschaffenburger Str. 94d|D-63500|Seligenstadt|Herr Dieter Dasberg|  |  |  |  |
;
;
;
; Beispiel der internen Weiterleitung eines externen Anrufes
;
;    1|    2|   3|           4|          5|                  6|        7|           8|           9|                    10|         11|                              12|                13|           14|   15|                         16|   17|   18|   19|                  20|   21|   22        |     23|     24|                      25|     26|          27|                 28|29|30|31|32|
; SCNT|EVENT|RCNT|Arbeitsplatz|Eventnummer|Datum      Zeit    |Eventart |Anrufnummer |Nebenstelle |virtuelle Nebenstelle | Nummer    |Info (Nummer)                   |Info (virt. NSt.) |TEL          |ADR  | NAME                      |RES1 |RES2 |ANW  | MAND               |DATEI|USR1         |  USR2 | NAME2 |STR                     |PLZ    |ORT         |ZUS
;
;  307|EVENT|    |            |926593     |2006-04-28 16:13:37|       iD|      926591|          12|                    12|         27|[Pellegrini & Grundmann GmbH]-27|Frau Simonyan     |+4963411410- |12730|Pellegrini & Grundmann GmbH|    |      |IDEAL|Pellegrini&Grundmann|    K|7817569787423|/1     |       |Ostring 29              |D-76829|Landau      |                   |  |  |  |  |
;  309|EVENT|    |            |926594     |2006-04-28 16:13:37|       iR|      926591|          12|                    12|         27|[Pellegrini & Grundmann GmbH]-27|Frau Simonyan     |+4963411410- |12730|Pellegrini & Grundmann GmbH|    |      |IDEAL|Pellegrini&Grundmann|    K|7817569787423|/1     |       |Ostring 29              |D-76829|Landau      |                   |  |  |  |  |
;  312|EVENT|    |            |926597     |2006-04-28 16:13:38|        S|      926588|          12|                    27|01716074758|Creative Soft- & Hardware       |                  |+491716074758|70190|Creative Soft- & Hardware  |    |      |IDEAL|Pellegrini&Grundmann|    L|101          |/2     |       |Aschaffenburger Str. 94d|D-63500|Seligenstadt|Herr Dieter Dasberg|  |  |  |  |
;  313|EVENT|    |            |926598     |2006-04-28 16:13:38|        S|      926591|          12|                    12|01716074758|Creative Soft- & Hardware       |Frau Simonyan     |+491716074758|70190|Creative Soft- & Hardware  |    |      |IDEAL|Pellegrini&Grundmann|    L|101          |/2     |       |Aschaffenburger Str. 94d|D-63500|Seligenstadt|Herr Dieter D
;  314|EVENT|    |            |926599     |2006-04-28 16:13:46|       iH|      926588|          12|                    27|01716074758|Creative Soft- & Hardware       |                  |+491716074758|70190|Creative Soft- & Hardware  |    |      |IDEAL|Pellegrini&Grundmann|    L|101          |/2     |       |Aschaffenburger Str. 94d|D-63500|Seligenstadt|Herr Dieter Dasberg|  |  |  |  |
;  315|EVENT|    |            |926600     |2006-04-28 16:13:46|       iH|      926588|          12|                    27|01716074758|Creative Soft- & Hardware       |                  |+491716074758|70190|Creative Soft- & Hardware  |    |      |IDEAL|Pellegrini&Grundmann|    L|101          |/2     |       |Aschaffenburger Str. 94d|D-63500|Seligenstadt|Herr Dieter Dasberg|  |  |  |  |



SCRIPT_BEGIN
  VAR_BOOL Res
  VAR_NUM  YNRes
  CALC [YNRes] AS [ID_YES]

  GET_YES_NO 'CATS-Lauscher','Sollen IDEAL-Adressen, die per CATS gemeldet werden, angezeigt werden knnen?',[YNRes]
  IF [YNRes]=[ID_YES]
    ; CATS [boolRes], [CATS_READ], boolOnOrOff {, strSubStation, strListenEvents, strFieldList}
    ;                                             |              |                |
    ;                                             |              |                |
    ;                                -------------       --------                 |
    ;         Die Variable          |                   |                         |
    ;         [CATS_ACT_STATION]    |                iR |      Feld 9 des CATS    |
    ;         beinhaltet den        |     incoming Ring |      Event wird als     |
    ;         String, der innerhalb |                   |      Feld 1 an CARA     |
    ;         CATS die aktuelle     |                 S |      weitergeleitet etc.|
    ;         Station bezeichnet.   |     Weiterleitung |        -----------------
    ;                               |                   |       |
    ;                               v                   v       v
    CATS [Res], [CATS_READ], TRUE, [CATS_ACT_STATION], 'iR|S', '9|10|11|15|16|21|22'
  ELSE
    CATS [Res], [CATS_READ], FALSE
  END_IF
SCRIPT_END