

  PROCEDURE InitVars
    VAR_LIST AList1
    VAR_LIST AList2

    LIST_APPEND [AList2], 'Einfach mal Zeile 1 in die Liste 2 geschrieben'
    LIST_APPEND [AList2], 'Einfach mal Zeile 2 in die Liste 2 geschrieben'
    LIST_APPEND [AList2], 'Einfach mal Zeile 3 in die Liste 2 geschrieben'
  END_PROC



  PROCEDURE CombineNotes VS CNo.TableName, VF CNo.RecID, VN CNo.NoteType, VS CNo.ResListName
    ; read a note and adds the lines to another list
    LOCAL_BOOL CNo.Result
    LOCAL_LIST CNo.Note
    LOCAL_NUM  CNo.NoteLnAct
    LOCAL_NUM  CNo.NoteLnCnt
    LOCAL_STR  CNo.Line

    NOTE_READ [CNo.Note],[CNo.Result],[CNo.TableName],[CNo.NoteType],[CNo.RecID]
    IF [CNo.Result]=FALSE
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [CNo.Note],[CNo.NoteLnAct],[CNo.NoteLnCnt]
    IF [CNo.NoteLnCnt]<=0
      EXIT_PROC
    END_IF

    CALC [CNo.NoteLnAct] AS 1
    WHILE [CNo.NoteLnAct]<=[CNo.NoteLnCnt]
      LIST_STR_GET [CNo.Note], [CNo.Line], [CNo.NoteLnAct]
      LIST_APPEND  [[CNo.ResListName]], [CNo.Line]
      INC [CNo.NoteLnAct]
    END_WHILE
  END_PROC


  PROCEDURE CombineLists VS CLi.SourceListName, VS CLi.DestListName
    ; takes the lines of one memo-mask-field and adds them to another list
    LOCAL_BOOL CLi.Result
    LOCAL_NUM  CLi.NoteLnAct
    LOCAL_NUM  CLi.NoteLnCnt
    LOCAL_STR  CLi.Line

    LIST_ITEM_GET [[CLi.SourceListName]],[CLi.NoteLnAct],[CLi.NoteLnCnt]
    IF [CLi.NoteLnCnt]<=0
      EXIT_PROC
    END_IF

    CALC [CLi.NoteLnAct] AS 1
    WHILE [CLi.NoteLnAct]<=[CLi.NoteLnCnt]
      LIST_STR_GET [[CLi.SourceListName]], [CLi.Line], [CLi.NoteLnAct]
      LIST_APPEND  [[CLi.DestListName]],   [CLi.Line]
      INC [CLi.NoteLnAct]
    END_WHILE
  END_PROC


  PROCEDURE Main
    ; Routine 1 = Notiz lesen und an eine Liste anhngen
    ;             die "Liste" kann natrlich auch ein
    ;             Masken-Memo-Feld sein

    ; Liest aus der Tabelle "Adressen" eine Text1-Notiz (1)
    ; vom Datensatz mit der ID 7823678108437 und baut
    ; diese an die Liste "AList1"
    CALL CombineNotes 'Adressen', 7823678108437, 1, 'AList1'

    ; Liest aus der Tabelle "Artikel" eine Intern-Notiz (3)
    ; vom Datensatz mit der ID 7823684948582 und baut
    ; diese (auch noch) an die Liste "AList1"
    CALL CombineNotes 'Artikel',  7823684948582, 3, 'AList1'





    ; Routine 2 = Den Inhalt einer Liste an eine andere anhngen.
    ;             Jede der "Listen" kann natrlich auch ein
    ;             Masken-Memo-Feld sein
    ;             z.B.  "CALL CombineLists 'WorkMask!Memo1', 'WorkMask!Memo2'"
    CALL CombineLists 'AList1', 'AList2'

    ; zeigt die Liste
    LIST_DISPLAY [AList2]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
