  ; Zeigt, wie man mit dem Export-Befehl umgeht / shows, how to handle the export command

  PROCEDURE InitVars
    VAR_MASK    WorkMask, 'ExportTestDlg'
    VAR_BROWSER B
    VAR_QUERY   G
    VAR_BOOL    Result
    VAR_NUM     GOptions

    CONST_BOOL  DO_THE_EXECUTE_YES, TRUE
    CONST_BOOL  DO_THE_EXECUTE_NO,  FALSE

    CALC [GOptions] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_ICON_INSERT]

    CALC [WorkMask!MASK_HOOK_BUTTON] AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_SHOW]   AS 'ShowHook'

    VAR_NUM LocListEditOptions
    CALC [LocListEditOptions] AS [TEXT_DISP_OPT_LOAD_ICON] + [TEXT_DISP_OPT_SAVE_ICON] + [TEXT_DISP_OPT_CLEAR_ICON] + [TEXT_DISP_OPT_MODIFY]
  END_PROC


  PROCEDURE SetUpTheExampleGrid
    QUERY [G]
        SELECT Artikelnummer, Kurzbezeichnung, Bezeichnung1, Bezeichnung2, RecordID, RecFlag
          FROM Artikel
         WHERE RecordID > 1000
      ORDER BY Artikelnummer, Kurzbezeichnung, Bezeichnung1, Bezeichnung2
    END_QUERY
    EXECUTE [G], [Result]
    IF [Result]=FALSE
      MESSAGE 'Abbruch / Abort','Grid-Query fehlgeschlagen / grid query failed',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF
    GRID_SET [WorkMask], 'AGrid', [G], [Result], [GOptions]
  END_PROC


  PROCEDURE ShowHook
    CALL SetUpTheExampleGrid
  END_PROC


  PROCEDURE SetUpBrowser VB DoTheExecute
    QUERY [B]
        SELECT Suchbegriff, Name1, Name2, Strasse, Plz, Ort, Telefon1, RecordID, RecFlag
          FROM Adressen
         WHERE RecordID > 1000
           AND KAktiv   = 1
      ORDER BY Suchbegriff, Name1, Name2, Strasse, Plz, Ort, Telefon1
    END_QUERY

    IF [DoTheExecute]
      EXECUTE [B], [Result]
      IF [Result]=FALSE
        MESSAGE 'Abbruch / Abort','Browser-Query fehlgeschlagen / browser query failed',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
      GET_DATA [B], [Result]
      IF [Result]=FALSE
        MESSAGE 'Abbruch / Abort','Browser-Query hat keine Daten / browser query without data',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF
  END_PROC


  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='AGridExportView'
      EXPORT [WorkMask], 'AGrid', [EXP_VIEW_CHOOSE]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='AGridExportPrint'
      EXPORT [WorkMask], 'AGrid', [EXP_PRINT]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='ABrowserExportView'
      CALL SetUpBrowser [DO_THE_EXECUTE_YES]

      ; Ausgabe-Optionen setzten / setting the output options
      CALC [EXP_OPTIONS] AS [EXP_OPTION_SHOW_COL_HEADERS] + [EXP_OPTION_SHOW_CLIPBOARD_MSG]

      ; Kopftext setzten / setting the header-text
      LIST_APPEND  [EXP_HEADER],     'Demo: Kopf / head   -   Zeile / line 1'
      LIST_APPEND  [EXP_HEADER],     'Demo: Kopf / head   -   Zeile / line 2'
      LIST_APPEND  [EXP_HEADER],     'Demo: Kopf / head   -   Zeile / line 3'
      LIST_APPEND  [EXP_HEADER],     'Demo: Kopf / head   -   Zeile / line 4'

      ; Fusstext setzten / setting the footer-text
      LIST_APPEND  [EXP_FOOTER],     'Demo: Fuss / foot   -   Zeile / line 1'
      LIST_APPEND  [EXP_FOOTER],     'Demo: Fuss / foot   -   Zeile / line 2'
      LIST_APPEND  [EXP_FOOTER],     'Demo: Fuss / foot   -   Zeile / line 3'
      LIST_APPEND  [EXP_FOOTER],     'Demo: Fuss / foot   -   Zeile / line 4'

      ; Fusstext vom Benutzer bearbeiten lassen / let the footer-text be edited from the user
      LIST_DISPLAY [EXP_FOOTER],     'Fusstext bearbeiten ?! / edit footer-text ?!', [LocListEditOptions], [Result]

      ; Spalten-berschriften setzten ? / set the colums headers ?
      LIST_APPEND [EXP_CAPTIONS],   'Spalte 1 gesetzt'
      LIST_APPEND [EXP_CAPTIONS],   'Spalte 2 gesetzt'

      ; Spalten-Breiten setzten (in Zeichen) ? / set the colums widths (in character) ?
      LIST_APPEND [EXP_COL_WIDTHS], '50'
      LIST_APPEND [EXP_COL_WIDTHS], '10'

      ; Ausgabe auf RTF festlegen / set output type to RTF
      CALC [EXP_FILE_TYPE] AS [EXP_FILE_TYPE_RTF]

      ; Ergebnis anzeigen , ohne den User nach dem Ausgabeformat zu fragen / show the result without any choice for the output
      EXPORT [B], '', [EXP_VIEW_DIRECT]

      ; Soll der User whlen?!  / shall the user choose the output format ?!
      ; EXPORT [B], '', [EXP_VIEW_CHOOSE]


      ; Resultat in einem festgelegten Ziel speichern / Save Result to a given destination
      CALC [EXP_FILE_NAME]  AS CON([DOCUMENT_PATH],'Export_Test_',[STATION_SHORT],'.RTF')
      EXPORT [B], '', [EXP_SAVE]

      ; Immer schn sauber machen, sonst hat der Benuzer das in seinem nchsten Export ebenfalls so!
      ; Always clean up well, otherwise the user will have this settings in his next export as well!
      LIST_CLR [EXP_COL_WIDTHS]
      LIST_CLR [EXP_CAPTIONS]
      LIST_CLR [EXP_FOOTER]
      LIST_CLR [EXP_HEADER]

      CALC [EXP_FILE_TYPE] AS [EXP_FILE_TYPE_EXCEL]
      CALC [EXP_OPTIONS]   AS [EXP_OPTION_DEFAULT]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='ABrowserExportPrint'
      CALL SetUpBrowser [DO_THE_EXECUTE_YES]
      EXPORT [B], '', [EXP_PRINT]
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='ABrowserShow'
      CALL SetUpBrowser [DO_THE_EXECUTE_NO]
      VIEW [B], [Result], 'Adressen / adresses'
    END_IF
  END_PROC


  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
