  INCLUDE AdrKopf.INC
    ; Importiert PROCEDURE CalcAdr  VF AdressID, ...


  INCLUDE Routines.INC
    ; importiert PROCEDURE RoundMoney ~VF RndVal

    ; importiert PROCEDURE LoadRelationFields  VF LocRelID,
    ;                                          VS LocTableName,
    ;                                          VS LocCompFld,
    ;                                         ~VS LocResFld,
    ;                                          VS LocInfo

  PROCEDURE InitVars
    ; sollen die Zahlungsbedingungen mit einem Datum ausgedruckt werden ?
    VAR_BOOL    ZB_MIT_DATUM,                     TRUE
    VAR_BOOL    TR,                               FALSE

    VAR_BOOL    Continue
    VAR_FLOAT   PEinheit,                         1
    VAR_FLOAT   ZwischenSumme,                    0
    VAR_FLOAT   Uebertrag,                        0

    CONST_NUM   POS_TEXT1,          1
    CONST_NUM   POS_TEXT2,          2
    CONST_NUM   ART_TEXT1,          4
    CONST_NUM   ART_TEXT2,          8
    CONST_NUM   TITEL_TEXT,        16
    CONST_NUM   ZWS_TEXT,          32
    CONST_NUM   PAGE_FEED,         64

    VAR_PF      RGPf, RG_Print.lst
    VAR_BOOL    Result
    VAR_NUM     numRes

    VAR_NUM     LastStufe
    VAR_NUM     MaxRec
    VAR_NUM     ActRec

    VAR_NUM     TmpNum
    VAR_FLOAT   TmpFloat

    VAR_LIST    RGNote1
    VAR_LIST    RGNote2
    VAR_LIST    PONote101
    VAR_LIST    PONote1
    VAR_LIST    PONote2
    VAR_LIST    ArtNote1
    VAR_LIST    ArtNote2

    VAR_BOOL    QRes

    VAR_QUERY   PosList
    VAR_QUERY   HeadInfo

    CALC [ActRec] AS 1
    WHILE [ActRec]<8
      ; Anschriften 1-7 fr Kunde bzw. Lieferanschrift
      VAR_STR   AN.Z0[ActRec]
      VAR_STR   Ra.Z0[ActRec]
      VAR_STR   La.Z0[ActRec]
      INC [ActRec]
    END_WHILE

    VAR_STR     Vertreter
    VAR_STR     ZahlBedStrEins
    VAR_STR     ZahlBedStrZwei
    VAR_STR     Lieferbedingung
    VAR_STR     Sachnummer

    VAR_BOOL    Designing
  END_PROC



  PROCEDURE DefineVars
    PF_SET_VAR [RGPf], [HeadInfo]

    PF_SET_VAR [RGPf], [RGNote1]
    PF_SET_VAR [RGPf], [RGNote2]

    PF_SET_VAR [RGPf], [AN.Z01]
    PF_SET_VAR [RGPf], [AN.Z02]
    PF_SET_VAR [RGPf], [AN.Z03]
    PF_SET_VAR [RGPf], [AN.Z04]
    PF_SET_VAR [RGPf], [AN.Z05]
    PF_SET_VAR [RGPf], [AN.Z06]
    PF_SET_VAR [RGPf], [AN.Z07]

    PF_SET_VAR [RGPf], [RA.Z01]
    PF_SET_VAR [RGPf], [RA.Z02]
    PF_SET_VAR [RGPf], [RA.Z03]
    PF_SET_VAR [RGPf], [RA.Z04]
    PF_SET_VAR [RGPf], [RA.Z05]
    PF_SET_VAR [RGPf], [RA.Z06]
    PF_SET_VAR [RGPf], [RA.Z07]

    PF_SET_VAR [RGPf], [LA.Z01]
    PF_SET_VAR [RGPf], [LA.Z02]
    PF_SET_VAR [RGPf], [LA.Z03]
    PF_SET_VAR [RGPf], [LA.Z04]
    PF_SET_VAR [RGPf], [LA.Z05]
    PF_SET_VAR [RGPf], [LA.Z06]
    PF_SET_VAR [RGPf], [LA.Z07]

    PF_SET_VAR [RGPf], [Vertreter]
    PF_SET_VAR [RGPf], [ZahlBedStrEins]
    PF_SET_VAR [RGPf], [ZahlBedStrZwei]
    PF_SET_VAR [RGPf], [Lieferbedingung]
  END_PROC


  PROCEDURE DefineFlds
    PF_SET_VAR [RGPf], [PosList],       [PF_VAR_TYPE_FLD]

    PF_SET_VAR [RGPf], [PONote101],     [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [PONote1],       [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [PONote2],       [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [ArtNote1],      [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [ArtNote2],      [PF_VAR_TYPE_FLD]

    PF_SET_VAR [RGPf], [Sachnummer],    [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [LastStufe],     [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [ZwischenSumme], [PF_VAR_TYPE_FLD]
    PF_SET_VAR [RGPf], [Uebertrag],     [PF_VAR_TYPE_FLD]
  END_PROC


  PROCEDURE CalcZahlBed
    LOCAL_BOOL  LocQRes
    LOCAL_DATE  TmpDate
    LOCAL_QUERY LocQ

    QUERY [LocQ]
      SELECT Beschreibung, Beschreibung2, Zahlbedingung,
             Skonto1, TageBisS1, TageBisNetto, Bankeinzug
        FROM ZAHLBED
       WHERE RecordID = [HeadInfo!R.ZahlBedID|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    IF [LocQ!Bankeinzug]
      CALC [ZahlBedStrEins] AS [LocQ!Beschreibung]
      CALC [ZahlBedStrZwei] AS [LocQ!Beschreibung2]
      EXIT_PROC
    END_IF


    IF [LocQ!Skonto1]>[EPSILON]
      CALC [TmpNum]   AS INT([LocQ!Skonto1])
      CALC [TmpFloat] AS [LocQ!Skonto1]-[TmpNum]
      IF [TmpFloat]<[EPSILON]
        CALC [TmpNum] AS 0
      ELSE
        CALC [TmpNum] AS 2
      END_IF

      CALC [TmpDate]  AS [HeadInfo!R.Datum]+[LocQ!TageBisS1]
      CALC [TmpFloat] AS [HeadInfo!R.BelegBrutto]*[LocQ!Skonto1]/100

      CALC [ZahlBedStrEins] AS CON('bis ',[TmpDate],' abzgl. ',[LocQ!Skonto1|X0,[TmpNum]],' % Skonto, zu zahlen: ')

      CALC [TmpFloat] AS [HeadInfo!R.BelegBrutto]-[TmpFloat]
      CALC [ZahlBedStrEins] AS CON([ZahlBedStrEins],[TmpFloat|X0,2],' ',[HeadInfo!W.Waehrung])

      CALC [TmpDate] AS [HeadInfo!R.Datum]+[LocQ!TageBisNetto]
      CALC [ZahlBedStrZwei] AS CON('bis ',[TmpDate],' rein netto')
    ELSE
      CALC [TmpDate] AS [HeadInfo!R.Datum]+[LocQ!TageBisNetto]
      CALC [ZahlBedStrEins] AS CON('bis ',[TmpDate],' rein netto')
    END_IF
  END_PROC


  PROCEDURE GetHeaderInfo ~VB GoOn
    CALC [GoOn] AS FALSE

    QUERY [HeadInfo]
      select R.Rechnungsnummer, R.Datum,
             R.BelegNetto,  R.Netto, R.BelegMwst,
             R.BelegNetto1, R.Netto1, R.StSatz1,
             R.BelegNetto2, R.Netto2, R.StSatz2,
             R.BelegNetto3, R.Netto3, R.StSatz3,
             R.BelegBrutto, R.Brutto,
             R.BelegFracht, R.BelegVerpackung, R.Mwst,
             R.Fracht, R.Verpackung,
             R.Modus, R.AuftragID, R.MwstJA, R.WaehrungID, R.VertreterID, R.ZahlBedID,
             A.RecordID, A.Auftragsnummer, A.Auftragsdatum, A.Bestellnummer, A.Bestelldatum,
             A.Sachbearbeiter, A.Referenz, A.VertreterID, A.Versandart, K.LiefNummer,
             A.KundenID, R.KundenID, R.RechKundeID, R.VerKundeID, A.ZahlBedID, A.PartnerID,
             A.MwstJA, A.WaehrungID,
             W.RecordID, W.Waehrung, W.Systemwaehrung, W.IsEuro, W.FFaktor, W.SFaktor,
             K.RecordID, K.Kundennummer, K.UstIdNr, K.Kopien_KRG, A.LieferBedID, K.KFibuKng
        from RECHNUNG R, AUFTRAG A, ADRESSEN K, WAEHRUNG W
       where (R.RecordID = [RECORD_ID1|R0,0])
         and (R.AuftragID = A.RecordID)
         and (A.KundenID = K.RecordID)
         and (R.WaehrungID = W.RecordID)
    END_QUERY

    EXECUTE [HeadInfo],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      MESSAGE 'Abbruch','Das Query fr die Beleg-Kopfdaten konnte nicht bersetzt werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [HeadInfo],[QRes]
    IF [QRes]=FALSE
      WAIT_CURSOR FALSE
      MESSAGE 'Abbruch','Es wurden keine Daten fr den Belegkopf gefunden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    IF [HeadInfo!R.Modus]>0
      CALC [TR] AS TRUE
    END_IF

    CALL CalcAdr [HeadInfo!R.KundenID],   'ADRESSEN', '-N1--N2--Z1--Z2--PS-+LPO', [AN.Z01], [AN.Z02], [AN.Z03], [AN.Z04], [AN.Z05], [AN.Z06], [AN.Z07]

    IF [HeadInfo!R.RechKundeID]>[EPSILON]
      CALC [RA.Z01] AS [AN.Z01]
      CALC [RA.Z02] AS [AN.Z02]
      CALC [RA.Z03] AS [AN.Z03]
      CALC [RA.Z04] AS [AN.Z04]
      CALC [RA.Z05] AS [AN.Z05]
      CALC [RA.Z06] AS [AN.Z06]
      CALC [RA.Z07] AS [AN.Z07]
      CALL CalcAdr [HeadInfo!R.RechKundeID], 'ADRESSEN', '-N1--N2--Z1--Z2--PS-+LPO', [AN.Z01], [AN.Z02], [AN.Z03], [AN.Z04], [AN.Z05], [AN.Z06], [AN.Z07]
    END_IF

    CALL CalcAdr [HeadInfo!R.VerKundeID], 'ADRESSEN', '-N1--N2--Z1--Z2--SS-+LPO', [LA.Z01], [LA.Z02], [LA.Z03], [LA.Z04], [LA.Z05], [LA.Z06], [LA.Z07]

    CALL LoadRelationFields  [HeadInfo!A.VertreterID],  'ADRESSEN', 'Name1',        [Vertreter],       ''
    CALL LoadRelationFields  [HeadInfo!R.ZahlBedID],    'ZAHLBED',  'Beschreibung', [ZahlBedStrEins],  ''
    CALL LoadRelationFields  [HeadInfo!A.LieferBedID],  'LIEFBED',  'Beschreibung', [Lieferbedingung], ''

    IF [ZB_MIT_DATUM]
      CALL CalcZahlBed
    END_IF

    NOTE_READ [RGNote1],[Result],'RECHNUNG',1,[RECORD_ID1]
    NOTE_READ [RGNote2],[Result],'RECHNUNG',2,[RECORD_ID1]

    CALC [GoOn] AS TRUE
  END_PROC


  PROCEDURE GetKndArt VF LocArtikelID, VF LocKundenID, ~VS LocSachnummer
    LOCAL_QUERY LocQ
    LOCAL_BOOL  LocQRes

    QUERY [LocQ]
      SELECT ArtikelID, KundenID, Sachnummer
        FROM KUNDART
       WHERE ArtikelID = [LocArtikelID|R0,0]
         AND KundenID  = [LocKundenID|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocQRes]
    IF [LocQRes]=FALSE
      CALC [LocSachnummer] AS ''
      EXIT_PROC
    END_IF

    CALC [LocSachnummer] AS [LocQ!Sachnummer]
  END_PROC


  PROCEDURE GetListInfo ~VB GoOn
    CALC [GoOn] AS FALSE

    IF [TR]
      QUERY [PosList]
        SELECT P.Liefermenge, P.BelegPreis, P.Anzahl, P.BelegGesamtPreis, A.Artikelnummer, A.Aktuell,
               P.PosNr, P.Stufe, P.Stckzahl, P.StueckFlag, P.RechnungID, A.Bezeichnung1, A.Kurzbezeichnung, A.PEinheit, A.VE,
               A.Bezeichnung2, A.reserviert, A.Bestellt, A.Bedarf, A.EANCode1,
               P.WunschKW, P.WunschDatum, P.RecordID, P.Kenner1, P.KontoID, ,
               P.RabattPr, P.MwstPr, A.HandelID, P.FertAuftragID, P.BelegGrundPreis, P.PEinheit,
               P.Kurztext1, P.Kurztext2, P.FreeFloat1, P.FreeFloat2, A.Einheit,
               P.ArtikelID, P.LieferscheinID
          FROM POSTEN P, ARTIKEL A
         WHERE (P.AuftragID = [HeadInfo!R.AuftragID|R0,0])
           AND (P.ArtikelID = A.RecordID)
           ;AND (P.StueckFlag < 2)
        ORDER BY P.RechnungID, P.PosNr, P.Stufe
      END_QUERY
    ELSE
      QUERY [PosList]
        SELECT P.Liefermenge, P.BelegPreis, P.Anzahl, P.BelegGesamtPreis, A.Artikelnummer, A.Aktuell,
               P.PosNr, P.Stufe, P.Stckzahl, P.StueckFlag, P.RechnungID, A.Bezeichnung1, A.Kurzbezeichnung, A.PEinheit,
               A.Bezeichnung2, A.reserviert, A.Bestellt, A.Bedarf, A.EANCode1,
               P.WunschKW, P.WunschDatum, P.RecordID, P.Kenner1, P.KontoID,
               P.RabattPr, P.MwstPr, A.HandelID, P.FertAuftragID, P.BelegGrundPreis, P.PEinheit,
               P.Kurztext1, P.Kurztext2, P.FreeFloat1, P.FreeFloat2, A.Einheit,
               P.ArtikelID, P.LieferscheinID
          FROM POSTEN P, ARTIKEL A
         WHERE (P.RechnungID = [RECORD_ID1|R0,0])
           AND (P.ArtikelID = A.RecordID)
           ;AND (P.StueckFlag < 2)
        ORDER BY P.RechnungID, P.PosNr, P.Stufe
      END_QUERY
    END_IF

    EXECUTE [PosList],[QRes]
    IF [QRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [PosList],[QRes],[FIRST_REC]
    IF [QRes]
      CALC [GoOn] AS TRUE
    END_IF

    QUERY_COUNT [PosList], [MaxRec]
  END_PROC


  PROCEDURE PrintOut
    IF [Designing]=FALSE
      PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_PRINT_VAR]
    END_IF

    GET_DATA [PosList],[QRes],[FIRST_REC]
    IF [QRes]
      CALC [LastStufe] AS [PosList!P.StueckFlag]
    END_IF

    CALC [ZwischenSumme] AS 0
    CALC [Uebertrag]     AS 0
    CALC [LastStufe]     AS 0
    CALC [ActRec]        AS 0

    WHILE [QRes]
      INC [ActRec]

      IF [Designing]=FALSE
        CALC [RGPf!PF_PROCESS_PERCENT] AS [ActRec]/[MaxRec]*100
        PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_PROCESS_INFO]
      END_IF


      CALC [PEinheit] AS [PosList!P.PEinheit]
      IF [PEinheit]<[EPSILON]
        CALC [PEinheit] AS [PosList!A.PEinheit]
        IF [PEinheit]<[EPSILON]
          CALC [PEinheit] AS 1
        END_IF
      END_IF

      CALC [ZwischenSumme] AS [ZwischenSumme]+[PosList!P.BelegGesamtPreis]
      CALC [Uebertrag]     AS [Uebertrag]+[PosList!P.BelegGesamtPreis]

      IF [LastStufe]<8
        IF [PosList!P.StueckFlag]=8
          ; PRINT_BOX  [RechPrn],  300, [Y],  800, [PRINT_POS_FREE], '[J L]', 'bestehend aus:'
        END_IF
      END_IF

      LIST_CLR [PONote101]
      LIST_CLR [PONote1]
      LIST_CLR [PONote2]
      LIST_CLR [ArtNote1]
      LIST_CLR [ArtNote2]

      FLAG_STATE [PosList!P.Kenner1], [TITEL_TEXT], [QRes]
      IF [QRes]
        NOTE_READ [PONote101],[Result],'POSTEN',101,[PosList!P.RecordID]
      END_IF

      FLAG_STATE [PosList!P.Kenner1], [POS_TEXT1], [QRes]
      IF [QRes]
        NOTE_READ [PONote1],[Result],'POSTEN',1,[PosList!P.RecordID]
      END_IF

      FLAG_STATE [PosList!P.Kenner1], [ART_TEXT1], [QRes]
      IF [QRes]
        NOTE_READ [ArtNote1],[Result],'ARTIKEL',1,[PosList!P.ArtikelID]
      END_IF

      FLAG_STATE [PosList!P.Kenner1], [ART_TEXT2], [QRes]
      IF [QRes]
        NOTE_READ [ArtNote2],[Result],'ARTIKEL',2,[PosList!P.ArtikelID]
      END_IF

      FLAG_STATE [PosList!P.Kenner1], [POS_TEXT2], [QRes]
      IF [QRes]
        NOTE_READ [PONote2],[Result],'POSTEN',2,[PosList!P.RecordID]
      END_IF

      CALL GetKndArt [PosList!P.ArtikelID], [HeadInfo!R.KundenID], [Sachnummer]

      FLAG_STATE [PosList!P.Kenner1], [ZWS_TEXT], [QRes]
      IF [QRes]
        NOTE_READ [PONote101],[Result],'POSTEN',101,[PosList!P.RecordID]
      END_IF

      FLAG_STATE [PosList!P.Kenner1], [PAGE_FEED], [QRes]
      IF [QRes]
      END_IF

      CALC [LastStufe] AS [PosList!P.StueckFlag]

      IF [Designing]
        EXIT_PROC
      ELSE
        CALL DefineFlds

        PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_PRINT_FLD]
        IF [numRes]=[PF_WRN_REPEAT_DATA]
          PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_PRINT_VAR]
        END_IF
      END_IF

      GET_DATA [PosList],[QRes]
    END_WHILE

    PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_PRINT_END]
  END_PROC


  PROCEDURE Design
    CALC [Designing] AS TRUE

    CALL PrintOut

    PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_DESIGN]

    CALC [Designing] AS FALSE
  END_PROC


  PROCEDURE Print
    PF_EXECUTE [RGPf], [numRes], [PF_EXECUTE_OPT_PRINT_OUT]
  END_PROC


  PROCEDURE Main
    WAIT_INFO 'Bitte warten...', 'Der Rechnungsdruck wird vorbereitet...'

    CALC [RGPf!PF_ACTION]           AS 0
    CALC [RGPf!PF_DEFINE_VARS_PROC] AS 'DefineVars'
    CALC [RGPf!PF_DEFINE_FLDS_PROC] AS 'DefineFlds'
    CALC [RGPf!PF_PRINT_OUT_PROC]   AS 'PrintOut'
    CALC [RGPf!PF_SOURCE_FILE_NAME] AS CON([SPECIAL_PATH],'RG_Print.lst')
    CALC [RGPf!PF_HEADER]           AS 'Rechnung'
    CALC [RGPf!PF_PROCESS_PERCENT]  AS 0
    CALC [RGPf!PF_PROCESS_INFO]     AS 'Rechnungs-Ausdruck'
    CALC [RGPf!PF_OPTIONS]          AS 0
    CALC [RGPf!PF_COPIES]           AS 4

    CALL GetHeaderInfo [Continue]
    IF [Continue]=FALSE
      EXIT_PROC
    END_IF

    CALL GetListInfo [Continue]
    IF [Continue]=FALSE
      EXIT_PROC
    END_IF

    END_WAIT


    ; CALL Design

    CALL Print
  END_PROC


SCRIPT_BEGIN
  ; Testen mit den IDEAL - Testdaten
  CALC [RECORD_ID1] AS 7822805709009

  ; Testen mit den FOMAS - Testdaten
  ; CALC [RECORD_ID1] AS 7822710953033

  CALL InitVars
  CALL Main
SCRIPT_END
 