
  PROCEDURE InitVars
    VAR_MASK  AnyPrint
    VAR_STR   PrnFilename, '_ll_AnyPrint.lst'
    VAR_NUM   AllPages
    VAR_NUM   numRes
    VAR_NUM   MaxRec
    VAR_NUM   ActRec
    VAR_BOOL  boolRes
    VAR_QUERY MainQ
  END_PROC



  PROCEDURE DefineVars
    PF_SET_VAR [AnyPrint], [MainQ]
    PF_SET_VAR [AnyPrint], [AllPages]
  END_PROC



  PROCEDURE DefineFlds
    PF_SET_VAR [AnyPrint], [ListQ],    [PF_VAR_TYPE_FLD]
  END_PROC



  PROCEDURE PrintOut
    PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PRINT_VAR]

    GET_DATA [ListQ], [boolRes], [FIRST_REC]

    WHILE [boolRes]
      INC [ActRec]

      CALC [AnyPrint!PF_PROCESS_PERCENT] AS [ActRec]/[MaxRec]*100
      PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PROCESS_INFO]

      CALL DefineFlds
      PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PRINT_FLD]

      IF [numRes]=[PF_WRN_REPEAT_DATA]
        PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PRINT_VAR]
        PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PRINT_FLD]
      END_IF

      GET_DATA [ListQ], [boolRes], [NEXT_REC]
    END_WHILE

    PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PRINT_END]
  END_PROC


  PROCEDURE Main
    WAIT_INFO 'please wait', 'initializing the printout...'

    QUERY [MainQ]
      SELECT *
        FROM AnyTable
       WHERE RecordID = [RECORD_ID1|R0,0]
    END_QUERY

    EXECUTE [MainQ],[boolRes]
    IF [boolRes]=FALSE
      END_WAIT
      MESSAGE 'abort','could not execute main...',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [MainQ],[boolRes]
    IF [boolRes]=FALSE
      END_WAIT
      MESSAGE 'abort','no data found in main...',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY [ListQ]
      SELECT *
        FROM AnyOtherTable
       WHERE AnyOtherTable.AnyTableID = [RECORD_ID1|R0,0]
    END_QUERY

    EXECUTE [ListQ],[boolRes]
    IF [boolRes]=FALSE
      END_WAIT
      MESSAGE 'abort','could not execute list...',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [ListQ],[boolRes]
    IF [boolRes]=FALSE
      END_WAIT
      MESSAGE 'abort','no data found in list...',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    QUERY_COUNT [ListQ], [MaxRec]

    CALC [AnyPrint!PF_ACTION]           AS 0
    CALC [AnyPrint!PF_DEFINE_VARS_PROC] AS 'DefineVars'
    CALC [AnyPrint!PF_DEFINE_FLDS_PROC] AS 'DefineFlds'
    CALC [AnyPrint!PF_PRINT_OUT_PROC]   AS 'PrintOut'
    CALC [AnyPrint!PF_SOURCE_FILE_NAME] AS CON([SPECIAL_PATH],[PrnFilename])
    CALC [AnyPrint!PF_HEADER]           AS 'AnyPrintHeader'
    CALC [AnyPrint!PF_PROCESS_PERCENT]  AS 0
    CALC [AnyPrint!PF_PROCESS_INFO]     AS 'AnyPrint-Process'
    CALC [AnyPrint!PF_COPIES]           AS 1

    CALC [AnyPrint!PF_OPTIONS]          AS [RECORD_ID2]
    CALC [AllPages]                     AS [RECORD_ID3]

    FLAG_STATE [AnyPrint!PF_OPTIONS],[PRINT_OUT_LAYOUT],[boolRes]
    IF [boolRes]
      PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_DESIGN]
    END_IF

    PF_EXECUTE [AnyPrint], [numRes], [PF_EXECUTE_OPT_PRINT_OUT]

    FLAG_STATE [AnyPrint!PF_OPTIONS],[PRINT_OUT_PAGE_COUNT_RET],[boolRes]
    IF [boolRes]
      IF [AnyPrint!PF_PAGE_COUNT]>0
        CALC [GLOB_RES_STR1] AS [AnyPrint!PF_PAGE_COUNT]
      END_IF
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END