
  PROCEDURE InitVars
    ; REPORT VARS
    VAR_DATE WEDatum

    ; REPORT FIELDS
    VAR_BOOL TTW

    VAR_QUERY AQ
    VAR_QUERY SlctQ

    ; INTERNAL VARIABLES
    VAR_BOOL  AQRes
    VAR_BOOL  Result
    VAR_BOOL  PrintExit

    VAR_NUM   numRes
    VAR_NUM   SlctMax
    VAR_NUM   SlctAct


    VAR_STR   InfoStr
    VAR_STR   PrnStr
    VAR_STR   CRLF

    VAR_FLOAT TmpFloat

    VAR_DATE  Datum

    CALC [CRLF] AS CHAR(#13#10)

    VAR_PF  APf

    CALC [APf!PF_ACTION]           AS 0
    CALC [APf!PF_DEFINE_VARS_PROC] AS 'DefineVars'
    CALC [APf!PF_DEFINE_FLDS_PROC] AS 'DefineFlds'
    CALC [APf!PF_PRINT_OUT_PROC]   AS 'PrintOut'
    CALC [APf!PF_SOURCE_FILE_NAME] AS CON([SPECIAL_PATH],'we_i_auf.lst')
    CALC [APf!PF_HEADER]           AS 'Positions-Check'
    CALC [APf!PF_PROCESS_PERCENT]  AS 0
    CALC [APf!PF_PROCESS_INFO]     AS 'Positions-Check-Ausdruck'
    CALC [APf!PF_OPTIONS]          AS 0
    CALC [APf!PF_COPIES]           AS 1
  END_PROC



  PROCEDURE DefineVars
    PF_SET_VAR [APf], [WEDatum],           [PF_VAR_TYPE_VAR]
    PF_SET_VAR [APf], [IP_FIRMEN_KUERZEL], [PF_VAR_TYPE_VAR]
  END_PROC


  PROCEDURE DefineFlds
    PF_SET_VAR [APf], [SlctQ], [PF_VAR_TYPE_FLD]
    PF_SET_VAR [APf], [AQ],    [PF_VAR_TYPE_FLD]
    PF_SET_VAR [APf], [TTW],   [PF_VAR_TYPE_FLD]
  END_PROC



  PROCEDURE Print.Break ~VB Print.Exit
    LOCAL_NUM   YNRes

    END_WAIT

    CALC [YNRes] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher ?!','Soll die Auswertung abgebrochen werden ?',[YNRes]
    IF [YNRes]=[ID_YES]
      CALC [Print.Exit] AS TRUE
      EXIT_PROC
    END_IF

    CALC [Print.Exit] AS FALSE
    CALC [WAIT_BREAK] AS FALSE
  END_PROC



  PROCEDURE Print.FetchData VS Print.PF
    CALL DefineFlds

    PF_EXECUTE [[Print.PF]], [numRes], [PF_EXECUTE_OPT_PRINT_FLD]
    IF [numRes]=[PF_WRN_REPEAT_DATA]
      PF_EXECUTE [[Print.PF]], [numRes], [PF_EXECUTE_OPT_PRINT_VAR]
    END_IF
  END_PROC



  PROCEDURE GetAuftrag
    QUERY [AQ]
      SELECT P.ArtikelID, P.Wunschdatum, P.Anzahl,
             P.entnommen, A.Auftragsnummer, A.Auftragsdatum, A.KundenID,
             K.Name1, K.Name2, K.Suchbegriff, A.FertByte,
             A.Fertdatum, R.Artikelnummer
        FROM POSTEN P, AUFTRAG A, ADRESSEN K, ARTIKEL R
       WHERE (P.ArtikelID = [SlctQ!B.ArtikelID|R0,0])
         AND (P.Aktiv = 0)
         AND (P.AuftragID = A.RecordID)
         AND (A.KundenID = K.RecordID)
         AND (A.ArtikelID = R.RecordID)
       ORDER BY P.ArtikelID, P.Wunschdatum
    END_QUERY

    EXECUTE [AQ],[AQRes]
    IF [AQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [AQ],[AQRes]
    IF [AQRes]=FALSE
      EXIT_PROC
    END_IF

    WHILE [AQRes]
      CALC [PrnStr] AS [AQ!K.Suchbegriff]

      IF [PrnStr]=''
        CALC [PrnStr] AS [AQ!K.Name1]
        IF [PrnStr]=''
          CALC [PrnStr] AS [AQ!K.Name2]
        END_IF
      END_IF

      CALC [TmpFloat] AS [AQ!P.Anzahl]-[AQ!P.entnommen]
      IF [TmpFloat]<[EPSILON]
        CALC [TmpFloat] AS 0
      END_IF

      CALC [Datum] AS [AQ!P.Wunschdatum]
      IF [AQ!A.FertByte]>0
        CALC [Datum]  AS [AQ!A.Fertdatum]
        CALC [PrnStr] AS [AQ!R.Artikelnummer]
      END_IF

      CALL Print.FetchData 'Apf'

      GET_DATA [AQ],[AQRes]
    END_WHILE
  END_PROC



  PROCEDURE PrintOut
    PF_EXECUTE [APf], [numRes], [PF_EXECUTE_OPT_PRINT_VAR]

    GET_DATA [SlctQ],[Result],[FIRST_REC]
    WHILE [Result]
      INC [SlctAct]

      CALC [APf!PF_PROCESS_PERCENT] AS [SlctAct]/[SlctMax]*100
      PF_EXECUTE [APf], [numRes], [PF_EXECUTE_OPT_PROCESS_INFO]

      IF [WAIT_BREAK]
        CALL Print.Break [PrintExit]
        IF [PrintExit]
          EXIT_PROC
        END_IF
      END_IF

      CALC [InfoStr] AS CON([SlctAct],'/',[SlctMax],[CRLF],'Artikel-Nr.: ',[SlctQ!A.Artikelnummer])
      CALC [APf!PF_PROCESS_INFO] AS [InfoStr]

      IF [Result]
        CALL Print.FetchData 'Apf'

        CALL GetAuftrag
      END_IF

      GET_DATA [SlctQ], [Result]
    END_WHILE

    PF_EXECUTE [APf], [numRes], [PF_EXECUTE_OPT_PRINT_END]

    END_WAIT
  END_PROC



  PROCEDURE Main

    CALC [WEDatum] AS [DATE]

    GET_DATE [WEDatum], 'Wareneingangs-Protokoll', 'Datum des Wareneingangs :','dd.mm.yyyy', [Result]
    IF [Result]=FALSE
      EXIT_PROC
    END_IF

    WAIT_INFO 'Bitte warten...','Die Positionen werden selektiert...', TRUE

    QUERY [SlctQ]
      SELECT B.ArtikelID, B.Lieferdatum, B.Liefermenge, B.Preis, B.Free1Str, B.Free2Str, B.PEinheit,
             A.Artikelnummer, A.Kurzbezeichnung, A.Bezeichnung1,
             A.Bezeichnung2, A.Zeichnungsnummer, A.Bauform,
             A.PEinheit, A.Aktuell, A.Bedarf, A.bestellt, A.reserviert, A.frei, A.verfuegbar,
             A.GewichtBrutto, A.RecordID
        FROM BESTPOS B, ARTIKEL A
       WHERE (B.Lieferdatum = [SQL_DATE_QUOTES_4_SELECT][WEDatum|R8,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT])
         AND (B.ArtikelID = A.RecordID)
     ORDER BY A.Artikelnummer
    END_QUERY

    EXECUTE [SlctQ], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Selektieren der Positionen konnte nicht bersetzt werden',[MESSAGE_ERROR]
    END_IF

    GET_DATA [SlctQ], [Result]
    IF [Result]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es konnten keine Positionen gefunden werden',[MESSAGE_WARNING]
    END_IF

    QUERY [AQ]
      SELECT P.ArtikelID, P.Wunschdatum, P.Anzahl,
             P.entnommen, A.Auftragsnummer, A.KundenID,
             K.Name1, K.Name2, K.Suchbegriff, A.FertByte,
             A.Fertdatum, R.Artikelnummer
        FROM POSTEN P, AUFTRAG A, ADRESSEN K, ARTIKEL R
       WHERE (P.ArtikelID = [SlctQ!B.ArtikelID|R0,0])
         AND (P.Aktiv = 0)
         AND (P.AuftragID = A.RecordID)
         AND (A.KundenID = K.RecordID)
         AND (A.ArtikelID = R.RecordID)
       ORDER BY P.ArtikelID, P.Wunschdatum
    END_QUERY

    EXECUTE [AQ],[AQRes]
    IF [AQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [AQ],[AQRes]
    IF [AQRes]=FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [SlctQ], [SlctMax]
    CALC [SlctAct] AS 0

    END_WAIT

    PF_EXECUTE [APf], [numRes], [PF_EXECUTE_OPT_DESIGN]
    PF_EXECUTE [APf], [numRes], [PF_EXECUTE_OPT_PRINT_OUT]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
