  ; DD 06/2005: Baut die Dateien einer Anwendung so um, dass sie mit einer Message-Datei verbunden werden.
  ;             Das Script legt die Message-Datei an oder erweitert sie, wenn sie schon vrhanden ist.
  ;    06/2008: Komplett berarbeitet fr Bodo-Mller-Chemie
  ;    08/2010: BMZ weitere Verbesserungen angebracht
  ;VD  19/11/2010: modified the SQL Line , it can handle all the [N"descriptions"] in the line

  PROCEDURE InitVars
    ; Sollen nur die Dateien im Special-Pfad zu einem Message-File kompatibel gemacht werden?
    VAR_BOOL JustSpecialPath, FALSE

    ; Sollen nur die Dateien im Special-Pfad NICHT ins Message-File bernommen werden?
    VAR_BOOL SpecialPathNot,  TRUE

    ; Sollen Phrasen, die schon einmal gefunden wurden, nicht ein zweites Mal in die Message-Datei eingebaut werden?
    VAR_BOOL AvoidDoubles,    FALSE

    ; Ab welcher Nummer sollen die Messages gezhlt werden?
    VAR_NUM  MsgOffset,       10000

    ; Sollen Dateien, die mit einem Unterstrich beginnen ausgelassen werden?
    VAR_BOOL Avoid_Files,     FALSE


    VAR_NUM  FTYPE_MASK,    1
    VAR_NUM  FTYPE_SCRIPT,  2
    VAR_NUM  FTYPE_SQL,     3
    VAR_NUM  FTYPE_MENU,    4
    VAR_NUM  FTYPE_INCLUDE, 5

    VAR_LIST Files
    VAR_LIST SpecialList
    VAR_LIST AFile
    VAR_LIST TFile
    VAR_LIST MFile

    VAR_BOOL Res


    VAR_BOOL InQuery
    VAR_BOOL InChoicer
    VAR_BOOL InViewField
    VAR_BOOL InViewFieldReg
    VAR_BOOL InViewStarted

    VAR_NUM  MainMsgCnt
    VAR_NUM  FoundMsgCnt
    VAR_NUM  YNRes
    VAR_NUM  SPos

    VAR_STR  DoubleInfo
    VAR_STR  DoubleLine

    VAR_NUM  StrPos1
    VAR_NUM  StrPos2
    VAR_NUM  StrLen1
    VAR_NUM  StrLen2

    VAR_NUM  SLCnt
    VAR_NUM  SLAct

    VAR_NUM  FLCnt
    VAR_NUM  FLAct

    VAR_NUM  FCnt
    VAR_NUM  FAct

    VAR_NUM  MCnt
    VAR_NUM  MAct

    VAR_STR  Delim
    VAR_STR  AddRepl
    VAR_STR  StrSgn
    VAR_STR  VarStartSgn
    VAR_STR  VarStopSgn
    VAR_STR  SqlLeftBracket
    VAR_STR  SqlRightBracket
    VAR_STR  Inf
    VAR_STR  SLine
    VAR_STR  FLine
    VAR_STR  ALine
    VAR_STR  MLine
    VAR_STR  FName
    VAR_STR  FExt
    VAR_STR  FSubDir
    VAR_STR  TmpStr1
    VAR_STR  TmpStr2
    VAR_STR  TmpStr3
    VAR_STR  TmpStr4
    VAR_STR  TmpStr5
    VAR_STR  MFName
    VAR_STR  FindVarInColons
    VAR_STR  FindSingleVarLine

    VAR_LIST SkipFiles

    FILE_NAME [TmpStr1],[APPLICATION_INI_FILE]
    FILE_EXT  [TmpStr2],[APPLICATION_INI_FILE]
    CALC [TmpStr3] AS PART([TmpStr1],1,[TmpStr2])
    CALC [MFName]  AS CON([PROG_PATH],[TmpStr3],'.msg')

    CALC [Delim]       AS CHAR(#166)
    CALC [AddRepl]     AS CHAR(#169)
    CALC [StrSgn]      AS CHAR(#39)
    CALC [VarStartSgn] AS CHAR(#91)
    CALC [VarStopSgn]  AS CHAR(#93)

    CALC [SqlLeftBracket]   AS CHAR(#14)
    CALC [SqlRightBracket]  AS CHAR(#15)

    CALC [FindVarInColons]   AS CON('*"',[VarStartSgn],'*',[VarStopSgn],'"*')
    CALC [FindSingleVarLine] AS CON([VarStartSgn],'*',[VarStopSgn])
  END_PROC



  PROCEDURE CheckMsg VS CL.Inf
    CALC [Res] AS TRUE
    IF [AvoidDoubles]=FALSE
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [MFile],[MAct],[MCnt]
    IF [MCnt]>0
      CALC [MAct] AS 1
      WHILE [MAct]<=[MCnt]
        LIST_STR_GET [MFile],[MLine],[MAct]
        IF [MLine]<>''
          CALC [TmpStr4] AS PART([MLine],1,[Delim])
          IF [TmpStr4]=[CL.Inf]
            CALC [TmpStr4] AS PART([MLine],2,[Delim])
            CALC [FoundMsgCnt] AS VAL([TmpStr4])
            CALC [Res] AS FALSE
          END_IF
        END_IF
        INC [MAct]
      END_WHILE
    END_IF
  END_PROC



  PROCEDURE CheckDelim VN ChDe.No, VS ChDe.Delim, VB ChDe.Write
    CALC [TmpStr1] AS PART([ALine],[ChDe.No],[ChDe.Delim])

    CALC [StrLen1] AS LEN([TmpStr1])
    IF [StrLen1]<2
      EXIT_PROC
    END_IF

    CALC [TmpStr2] AS COPY([TmpStr1],1,1)
    IF [TmpStr2]=[AddRepl]
      EXIT_PROC
    END_IF
    IF [TmpStr2]='['
      EXIT_PROC
    END_IF

    CALC [StrPos1] AS POS([TmpStr1],[ALine])
    DEC  [StrPos1]
    CALC [TmpStr2] AS COPY([ALine],1,[StrPos1])
    CALC [StrLen2] AS LEN([TmpStr2])
    CALC [StrLen1] AS [StrLen1]+[StrLen2]+1
    CALC [TmpStr3] AS COPY([ALine],[StrLen1],255)

    IF [ChDe.Write]
      CALL CheckMsg [TmpStr1]
      IF [Res]
        INC  [MainMsgCnt]
        CALC [TmpStr4] AS CON([TmpStr1],[Delim],[MainMsgCnt])
        LIST_APPEND [MFile], [TmpStr4]
        CALC [TmpStr1] AS CON([MainMsgCnt], ' ',[TmpStr1])
      ELSE
        CALC [TmpStr1] AS CON([FoundMsgCnt],' ',[TmpStr1])
      END_IF

      CALC [ALine] AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])
    END_IF
  END_PROC



  PROCEDURE CheckDelimReg
    CALC [TmpStr1] AS PART([ALine],4,[StrSgn])

    CALC [StrLen1] AS LEN([TmpStr1])
    IF [StrLen1]<2
      EXIT_PROC
    END_IF

    CALC [TmpStr2] AS COPY([TmpStr1],1,1)
    IF [TmpStr2]=[AddRepl]
      EXIT_PROC
    END_IF
    IF [TmpStr2]='['
      EXIT_PROC
    END_IF

    CALC [StrPos1] AS POS([TmpStr1],[ALine])
    DEC  [StrPos1]
    CALC [TmpStr2] AS COPY([ALine],1,[StrPos1])
    CALC [StrLen2] AS LEN([TmpStr2])
    CALC [StrLen1] AS [StrLen1]+[StrLen2]+1
    CALC [TmpStr3] AS COPY([ALine],[StrLen1],255)

    CALL CheckMsg [TmpStr1]
    IF [Res]
      INC  [MainMsgCnt]
      CALC [TmpStr4] AS CON([TmpStr1],[Delim],[MainMsgCnt])
      LIST_APPEND [MFile], [TmpStr4]
    END_IF

    IF [Res]
      CALC [ALine] AS CON([TmpStr2],[TmpStr1],'#',[AddRepl],[MainMsgCnt], ' translate',[TmpStr3])
    ELSE
      CALC [ALine] AS CON([TmpStr2],[TmpStr1],'#',[AddRepl],[FoundMsgCnt],' translate',[TmpStr3])
    END_IF
  END_PROC



  PROCEDURE DoQueryLine_OLD
    ; WHILE (we have something to read)
    ;   read the first part until ]
    ;   read the second part after [
    ;   process between
    ;   the [ and ] i replace with 2 other signs :  CHAR(#14) and  CHAR(#15)
    ; END_WHILE
    ; replace the 2 other signs back to [ and ]
    CALC [StrLen1] AS 1
    CALC [StrLen2] AS 2

    CALC [TmpStr2] AS PART([ALine],[StrLen2],'[')
    WHILE [TmpStr2]<>''
      CALC [TmpStr1] AS PART([ALine],[StrLen1],'[')
      CALC [TmpStr1] AS  CON([TmpStr1],[SqlLeftBracket])
      CALC [StrPos1] AS  POS(']',[ALine])
;     CALC [TmpStr3] AS PART([ALine],[StrLen2],']')
      INC [StrPos1]
      CALC [TmpStr3] AS COPY([ALine],[StrPos1],255)
      CALC [TmpStr5] AS  CON([SqlRightBracket],[TmpStr3])

      ; Fehler 1 : Wenn Farbangabe mit Script-Konstante z.B. [W12 N"Dr. No" C1A="[SQL_BOOLEAN_TRUE]"]A.Name1,  <-- zerhackt die Konstante
      CALC [TmpStr2] AS PART([TmpStr2],1,']')
      IF [TmpStr2]=''
        EXIT_PROC
      END_IF

      CALC [StrPos1] AS POS('N "',[TmpStr2])
      IF [StrPos1]=0
        CALC [StrPos1] AS POS('N"',[TmpStr2])
      END_IF

      IF [StrPos1]>0

        CALC [TmpStr4] AS COPY([TmpStr2],1,[StrPos1])
        CALC [TmpStr1] AS CON([TmpStr1],[TmpStr4],'"')
        CALC [TmpStr2] AS COPY([TmpStr2],[StrPos1],255)
        CALC [TmpStr4] AS PART([TmpStr2],3,'"')
        CALC [TmpStr3] AS CON('"',[TmpStr4],[TmpStr3])
        CALC [TmpStr2] AS PART([TmpStr2],2,'"')

        CALC [TmpStr4] AS COPY([TmpStr2],1,1)
        IF [TmpStr4]=[AddRepl]
          ; do nothing
        ELSE_IF [TmpStr2]='['
         ; this is an error, having [[ in the same line
          CALC [ALine] AS CON([TmpStr1],[TmpStr2],[TmpStr5])
        ELSE
          CALL CheckMsg [TmpStr2]
          IF [Res]
            INC  [MainMsgCnt]
            CALC [TmpStr4] AS CON([TmpStr2],[Delim],[MainMsgCnt])
            LIST_APPEND [MFile], [TmpStr4]
            CALC [TmpStr2] AS CON([MainMsgCnt], ' ',[TmpStr2],'"')
          ELSE
            CALC [TmpStr2] AS CON([FoundMsgCnt],' ',[TmpStr2],'"')
          END_IF

          CALC [ALine] AS CON([TmpStr1],[AddRepl],[TmpStr2],[TmpStr5])
        END_IF
      ELSE
        CALC [ALine] AS CON([TmpStr1],[TmpStr2],[TmpStr5])
      END_IF

      CALC [TmpStr2] AS PART([ALine],[StrLen2],'[')
    END_WHILE

    CALC [ALine] AS REPLACE([ALine],[SqlLeftBracket],'[')
    CALC [ALine] AS REPLACE([ALine],[SqlRightBracket],']')
  END_PROC



  PROCEDURE DoQueryLine
    ; E.g.>>        [W12 N"Dr. No" C1A="[SQL_BOOLEAN_TRUE]"]A.Name1,  [N"Created" M"ID" C2A<"[EPSILON]" W25]A.RecordID, <<
    ;       123456789          0123456789          0123456789          0123456789          0123456789          012345678
    ;                0123456789          0123456789          0123456789          0123456789          0123456789

    BACK_MARK

    ; Gibt es "CSH-Syntax"?
    CALC [StrPos1] AS  POS('[',[ALine])
    IF [StrPos1]<=0
      FORE_JUMP
    END_IF

    ; Fr CSH-Syntax muss der getrimmte String mal MINDESTENS 10 Zeichen lang sein
    CALC [TmpStr1] AS TRIM([ALine])
    CALC [StrLen1] AS  LEN([TmpStr1])
    IF [StrLen1]<=10
      EXIT_PROC
    END_IF

    ; Merke in TmpStr1 alle Zeichen bis StrPos1 und baue schon mal die linke Klammer der CSH-Syntax dazu
    DEC  [StrPos1]
    CALC [TmpStr1] AS COPY([ALine],1,[StrPos1])
    CALC [TmpStr1] AS  CON([TmpStr1],[SqlLeftBracket])
    CALC [StrPos1] AS [StrPos1]+2

    ; Jetzt von StrPos1 aus solange lesen, bis die Klammer wieder zu geht, dabei alle eckigen Klammern durch SqlXXXXBrackets ersetzen
    CALC [StrLen1] AS LEN([ALine])
    CALC [StrPos2] AS 1
    CALC [TmpStr2] AS ''
    WHILE [StrPos1]<=[StrLen1]
      CALC [TmpStr3] AS COPY([ALine],[StrPos1],1)
      IF [TmpStr3]='['
        INC  [StrPos2]
        CALC [TmpStr2] AS CON([TmpStr2],[SqlLeftBracket])
      ELSE_IF [TmpStr3]=']'
        DEC  [StrPos2]
        CALC [TmpStr2] AS CON([TmpStr2],[SqlRightBracket])
      ELSE
        CALC [TmpStr2] AS CON([TmpStr2],[TmpStr3])
      END_IF

      IF [StrPos2]=0
        CALC [TmpStr4] AS 'N "'
        CALC [StrPos2] AS POS([TmpStr4],[TmpStr2])
        IF [StrPos2]=0
          CALC [TmpStr4] AS 'N"'
          CALC [StrPos2] AS POS([TmpStr4],[TmpStr2])
        END_IF
        IF [StrPos2]>0
          CALC [StrLen2] AS LEN([TmpStr4])
          CALC [StrPos2] AS [StrPos2]+[StrLen2]-1
          CALC [TmpStr3] AS COPY([TmpStr2],1,[StrPos2])
          CALC [TmpStr1] AS  CON([TmpStr1],[TmpStr3])
          INC  [StrPos2]
          CALC [TmpStr2] AS COPY([TmpStr2],[StrPos2],255)
          CALC [StrPos2] AS  POS('"',[TmpStr2])
          IF [StrPos2]=0
            ; Syntax nicht eingehalten, darum kmmern wir uns jetzt mal nicht
            EXIT_PROC
          END_IF
          DEC  [StrPos2]
          CALC [TmpStr3] AS COPY([TmpStr2],1,[StrPos2])

          CALL CheckMsg [TmpStr3]
          IF [Res]
            INC  [MainMsgCnt]
            CALC [TmpStr4] AS CON([TmpStr3],[Delim],[MainMsgCnt])
            LIST_APPEND [MFile], [TmpStr4]
            CALC [TmpStr3] AS CON([AddRepl],[MainMsgCnt], ' ',[TmpStr3])
          ELSE
            CALC [TmpStr3] AS CON([AddRepl],[FoundMsgCnt],' ',[TmpStr3])
          END_IF
          CALC [TmpStr1] AS  CON([TmpStr1],[TmpStr3])

          INC  [StrPos2]
          CALC [TmpStr3] AS COPY([TmpStr2],[StrPos2],255)
          CALC [TmpStr1] AS  CON([TmpStr1],[TmpStr3])
        ELSE
          CALC [TmpStr1] AS CON([TmpStr1],[TmpStr2])
        END_IF

        INC [StrPos1]
        CALC [TmpStr3] AS COPY([ALine],[StrPos1],255)
        CALC [ALine]   AS  CON([TmpStr1],[TmpStr3])

        BACK_JUMP
      END_IF

      INC [StrPos1]
    END_WHILE

    FORE_MARK

    CALC [ALine] AS REPLACE([ALine],[SqlLeftBracket],'[')
    CALC [ALine] AS REPLACE([ALine],[SqlRightBracket],']')
  END_PROC



  PROCEDURE TranslateMaskLine
    ; in TmpStr1 ist schon der "getrimmte" Wert von ALine enthalten...
    CALC [TmpStr3] AS UPCASE([TmpStr1])
    CALC [TmpStr2] AS PART([TmpStr3],1,' ')
    IF [TmpStr2]=''
      CALC [TmpStr2] AS [TmpStr3]
    END_IF

    IF [TmpStr2]='BEGIN'
      CALL CheckDelim 4, [StrSgn], TRUE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ITEM'
      IF [InChoicer]
        CALL CheckDelim 2, [StrSgn], TRUE
      ELSE
        CALC [InViewField]    AS FALSE
        CALC [InViewFieldReg] AS FALSE

        CALC [TmpStr1] AS PART([ALine],2,[StrSgn])
        CALC [TmpStr1] AS TRIM([TmpStr1])
        CALC [TmpStr1] AS UPCASE([TmpStr1])
        IF [TmpStr1]='LABEL'
          CALC [InViewField] AS TRUE
        ELSE_IF [TmpStr1]='STRING'
          CALC [InViewField] AS TRUE
        ELSE_IF [TmpStr1]='LIST_TEXT'
          CALC [InViewField] AS TRUE
        ELSE_IF [TmpStr1]='BIT_BUTTON'
          CALC [InViewField] AS TRUE
        ELSE_IF [TmpStr1]='GROUP_BOX'
          CALC [InViewField] AS TRUE
        ELSE_IF [TmpStr1]='RADIO_BOX'
          CALC [InViewField] AS TRUE
        ELSE_IF [TmpStr1]='REGISTER'
          CALC [InViewFieldReg] AS TRUE
        END_IF
      END_IF
      EXIT_PROC
    ELSE_IF [TmpStr2]='VIEW'
      IF [InViewField]
        CALL CheckDelim 2, [StrSgn], TRUE
      ELSE_IF [InViewFieldReg]
        CALL CheckDelimReg
      END_IF
      EXIT_PROC
    ELSE_IF [TmpStr2]='HINT'
      CALL CheckDelim 2, [StrSgn], TRUE
      EXIT_PROC
    ELSE_IF [TmpStr2]='TEXT'
      CALL CheckDelim 2, [StrSgn], TRUE
      EXIT_PROC
    ELSE_IF [TmpStr2]='CHOICER_BEGIN'
      CALC [InChoicer] AS TRUE
      EXIT_PROC
    ELSE_IF [TmpStr2]='CHOICER_END'
      CALC [InChoicer] AS FALSE
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE TranslateMenuLine
    ; in TmpStr1 ist schon der "getrimmte" Wert von ALine enthalten...
    CALC [TmpStr3] AS UPCASE([TmpStr1])
    CALC [TmpStr2] AS PART([TmpStr3],1,' ')

    IF [TmpStr2]='ITEM'
      CALL CheckDelim 2, [StrSgn], TRUE
      EXIT_PROC
    ELSE_IF [TmpStr2]='SUBMENU_BEGIN'
      CALL CheckDelim 2, [StrSgn], TRUE
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE TranslateScriptLine
    ; in TmpStr1 ist schon der "getrimmte" Wert von ALine enthalten...
    CALC [TmpStr3] AS UPCASE([TmpStr1])
    CALC [TmpStr2] AS PART([TmpStr3],1,' ')
    IF [TmpStr2]=''
      CALC [TmpStr2] AS [TmpStr3]
    END_IF

    IF [TmpStr2]='CALL'
      ; Es gibt natrlich viele Aufrufe, bei denen String bergeben werden, die sich zu bersetzten lohnen wrden.
      ; ABER: die Hauptmenge der Parameter sind solche, die NICHT bersetzt werden sollten.
      EXIT_PROC

    ELSE_IF [TmpStr2]='MESSAGE'
      CALC [DoubleInfo] AS ''
      CALC [DoubleLine] AS [ALine]

      CALL CheckDelim 2, [StrSgn], FALSE
      IF [TmpStr1]=''
        EXIT_PROC
      END_IF

      INC  [MainMsgCnt]
      CALC [DoubleInfo] AS CON([TmpStr1],[Delim],[MainMsgCnt])
      CALC [TmpStr1]    AS CON([MainMsgCnt], ' ',[TmpStr1])
      CALC [ALine]      AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])

      CALL CheckDelim 4, [StrSgn], FALSE
      IF [TmpStr1]=''
        DEC  [MainMsgCnt]
        CALC [ALine] AS [DoubleLine]
        EXIT_PROC
      END_IF

      CALC [DoubleInfo] AS CON([DoubleInfo],[Delim],[TmpStr1])
      LIST_APPEND [MFile], [DoubleInfo]
      CALC [TmpStr1] AS CON([MainMsgCnt], ' ',[TmpStr1])
      CALC [ALine] AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])

      EXIT_PROC
    ELSE_IF [TmpStr2]='GET_YES_NO'
      CALC [DoubleInfo] AS ''
      CALC [DoubleLine] AS [ALine]

      CALL CheckDelim 2, [StrSgn], FALSE
      IF [TmpStr1]=''
        EXIT_PROC
      END_IF

      INC  [MainMsgCnt]
      CALC [DoubleInfo] AS CON([TmpStr1],[Delim],[MainMsgCnt])
      CALC [TmpStr1]    AS CON([MainMsgCnt], ' ',[TmpStr1])
      CALC [ALine]      AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])

      CALL CheckDelim 4, [StrSgn], FALSE
      IF [TmpStr1]=''
        DEC  [MainMsgCnt]
        CALC [ALine] AS [DoubleLine]
        EXIT_PROC
      END_IF

      CALC [DoubleInfo] AS CON([DoubleInfo],[Delim],[TmpStr1])
      LIST_APPEND [MFile], [DoubleInfo]
      CALC [TmpStr1] AS CON([MainMsgCnt], ' ',[TmpStr1])
      CALC [ALine] AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])

      EXIT_PROC
    ELSE_IF [TmpStr2]='WAIT_INFO'
      CALC [DoubleInfo] AS ''
      CALC [DoubleLine] AS [ALine]

      CALL CheckDelim 2, [StrSgn], FALSE
      IF [TmpStr1]=''
        EXIT_PROC
      END_IF

      INC  [MainMsgCnt]
      CALC [DoubleInfo] AS CON([TmpStr1],[Delim],[MainMsgCnt])
      CALC [TmpStr1]    AS CON([MainMsgCnt], ' ',[TmpStr1])
      CALC [ALine]      AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])

      CALL CheckDelim 4, [StrSgn], FALSE
      IF [TmpStr1]=''
        DEC  [MainMsgCnt]
        CALC [ALine] AS [DoubleLine]
        EXIT_PROC
      END_IF

      CALC [DoubleInfo] AS CON([DoubleInfo],[Delim],[TmpStr1])
      LIST_APPEND [MFile], [DoubleInfo]
      CALC [TmpStr1] AS CON([MainMsgCnt], ' ',[TmpStr1])
      CALC [ALine] AS CON([TmpStr2],[AddRepl],[TmpStr1],[TmpStr3])

      EXIT_PROC
    ELSE_IF [TmpStr2]='VIEW'
      CALL CheckDelim 2, [StrSgn], TRUE
      CALL CheckDelim 4, [StrSgn], TRUE
    ELSE_IF [TmpStr2]='CHOOSE_FILE'
      CALL CheckDelim 2, [StrSgn], TRUE
      CALL CheckDelim 4, [StrSgn], TRUE
    ELSE_IF [TmpStr2]='QUERY'
      CALC [InQuery]     AS TRUE
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='END_QUERY'
      CALC [InQuery]     AS FALSE
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='SELECT'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS TRUE
    ELSE_IF [TmpStr2]='WHERE'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='UPDATE'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='AND'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='OR'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ORDER'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='GROUP'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='STARTING'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ALTER'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='DELETE'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='CREATE'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='DROP'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='FROM'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='UPDATE'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='INSERT'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ASCII_2_TABLE'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='TABLE_2_ASCII'
      IF [InQuery]=FALSE
        EXIT_PROC
      END_IF
      CALC [InViewField] AS FALSE
      EXIT_PROC
    END_IF

    IF [InQuery]
      IF [InViewField]
       CALL DoQueryLine
     END_IF
    END_IF
  END_PROC



  PROCEDURE TranslateSqlLine
    ; in TmpStr1 ist schon der "getrimmte" Wert von ALine enthalten...
    CALC [TmpStr3] AS UPCASE([TmpStr1])

    CALC [TmpStr2] AS   TRIM([TmpStr3])
    IF [TmpStr2]>>[FindSingleVarLine]
      EXIT_PROC
    END_IF

    CALC [TmpStr2] AS   PART([TmpStr3],1,' ')

    ; Variablen in Gnsefchen werden nicht bersetzt
    IF [TmpStr3]>>[FindVarInColons]
      EXIT_PROC
    END_IF

    ; Solche Zeilen mssen NICHT bersetzt werden
    IF [TmpStr3]>>'*SQL_BOOLEAN_QUOTATION*'
      EXIT_PROC
    END_IF

    ; Solche Zeilen mssen NICHT bersetzt werden
    IF [TmpStr3]>>'*SQL_DATE_QUOTES_4_*'
      EXIT_PROC
    END_IF

    IF [TmpStr2]='SELECT'
      CALC [InViewField]   AS TRUE
      CALC [InViewStarted] AS TRUE
    ELSE_IF [TmpStr2]='WHERE'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='UPDATE'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='DROP'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='AND'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='OR'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ORDER'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='GROUP'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='STARTING'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='FROM'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='UPDATE'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ALTER'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='DELETE'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='CREATE'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='INSERT'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='ASCII_2_TABLE'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    ELSE_IF [TmpStr2]='TABLE_2_ASCII'
      CALC [InViewStarted] AS FALSE
      CALC [InViewField]   AS FALSE
      EXIT_PROC
    END_IF

    IF [InViewField]
      CALL DoQueryLine
    ELSE_IF [InViewStarted]=FALSE
      ; Das muss nun also eine berschrift in einer SQL-Datei sein (bevor die SELECT-Anweisung startet)
      CALC [TmpStr4] AS COPY([TmpStr3],1,1)
      IF [TmpStr4]=[AddRepl]
        ; do nothing
      ELSE
        CALL CheckMsg [TmpStr1]
        IF [Res]
          INC  [MainMsgCnt]
          CALC [TmpStr4] AS CON([TmpStr1],[Delim],[MainMsgCnt])
          LIST_APPEND [MFile], [TmpStr4]
          CALC [TmpStr1] AS CON([MainMsgCnt], ' ',[TmpStr1])
        ELSE
          CALC [TmpStr1] AS CON([FoundMsgCnt],' ',[TmpStr1])
        END_IF

        CALC [ALine] AS CON([AddRepl],[TmpStr1])
      END_IF
    END_IF
  END_PROC



  PROCEDURE CheckTranslationDir VS CTD.Dir
    CALC [FName] AS CON([CTD.Dir],'translation')
    EXIST_DIR [FName],[Res]
    IF [Res]=FALSE
      FORCE_DIR [Res],[FName]
      IF [Res]=FALSE
        END_WAIT
        CALC [Inf] AS CON('The subdir "',[FName],'" for the translated files could not be created!')
        MESSAGE 'Attention! Error!',[Inf],[MESSAGE_ERROR]
        EXIT_PROC
      END_IF
    END_IF
  END_PROC



  PROCEDURE Check4Append VS C4A.Inf
    LIST_ITEM_GET [MFile],[MAct],[MCnt]
    IF [MCnt]>0
      CALC [MAct] AS 1
      WHILE [MAct]<=[MCnt]
        LIST_STR_GET [MFile],[MLine],[MAct]
        IF [MLine]<>''
          IF [MLine]=[C4A.Inf]
            EXIT_PROC
          END_IF
        END_IF
        INC [MAct]
      END_WHILE
    END_IF
    LIST_APPEND [MFile],[C4A.Inf]
  END_PROC



  PROCEDURE WorkOutFile VS WOF.FName, VS WOF.Dir, VN WOF.FType
    CALC [InQuery]       AS FALSE
    CALC [InChoicer]     AS FALSE
    CALC [InViewField]   AS FALSE
    CALC [InViewStarted] AS FALSE

    CALL CheckTranslationDir [WOF.Dir]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    ; Keine Dateien, die mit einem Tiefstrich / Unterstrich / Underscore beginnen. <-- die sind in der Regel kein Bestandteil des Standards.
    CALC [SPos] AS POS('_',[WOF.FName])
    IF [SPos]=1
      IF [Avoid_Files]
        EXIT_PROC
      END_IF
    END_IF

    CALC [FName] AS CON([WOF.Dir],[WOF.FName])
    LIST_CLR [AFile]
    LIST_FILE_READ [AFile],[Res],[FName]
    IF [Res]=FALSE
      END_WAIT
      CALC [Inf] AS CON('Could not read file "',[FName],'"')
      MESSAGE 'Attention! Error!',[Inf],[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    ; Datadefinition (DDF) Dateien, werden NICHT abgearbeitet.
    IF [WOF.FType]=[FTYPE_SQL]
      LIST_STR_FIND [AFile], '*CREATE TABLE*', [Res], '>>'
      IF [Res]
        EXIT_PROC
      END_IF
      LIST_STR_FIND [AFile], '*DROP TABLE*', [Res], '>>'
      IF [Res]
        EXIT_PROC
      END_IF
    END_IF

    IF [WOF.FType]=[FTYPE_MASK]
      CALC [TmpStr1] AS CON(';*** MASKE ',[WOF.FName],'**********************************************')
    ELSE_IF [WOF.FType]=[FTYPE_SCRIPT]
      CALC [TmpStr1] AS CON(';*** SCRIPT ',[WOF.FName],'**********************************************')
    ELSE_IF [WOF.FType]=[FTYPE_SQL]
      CALC [TmpStr1] AS CON(';*** SQL ',[WOF.FName],'**********************************************')
    ELSE_IF [WOF.FType]=[FTYPE_MENU]
      CALC [TmpStr1] AS CON(';*** MENU ',[WOF.FName],'**********************************************')
    ELSE_IF [WOF.FType]=[FTYPE_INCLUDE]
      CALC [TmpStr1] AS CON(';*** INCLUDE ',[WOF.FName],'**********************************************')
    END_IF
    CALL Check4Append [TmpStr1]


    LIST_CLR [TFile]
    LIST_ITEM_GET [AFile],[FAct],[FCnt]
    IF [FCnt]>0
      CALC [FAct] AS 1
      WHILE [FAct]<=[FCnt]
        LIST_STR_GET [AFile],[ALine],[FAct]

        CALC [TmpStr1] AS TRIM([ALine])
        IF [TmpStr1]<>''
          CALC [TmpStr2] AS COPY([TmpStr1],1,1)
          IF [TmpStr2]<>';'
            CALC [ALine] AS REPLACE([ALine],'@',[AddRepl])

            IF [WOF.FType]=[FTYPE_MASK]
              CALL TranslateMaskLine
            ELSE_IF [WOF.FType]=[FTYPE_SCRIPT]
              CALL TranslateScriptLine
            ELSE_IF [WOF.FType]=[FTYPE_SQL]
              CALL TranslateSqlLine
            ELSE_IF [WOF.FType]=[FTYPE_MENU]
              CALL TranslateMenuLine
            ELSE_IF [WOF.FType]=[FTYPE_INCLUDE]
              CALL TranslateScriptLine
            END_IF

            IF [ALine]<>''
              CALC [ALine] AS REPLACE([ALine],[AddRepl],'@')
            END_IF
          END_IF
        ELSE
          CALC [ALine] AS ' '
        END_IF
        LIST_APPEND [TFile],[ALine]

        INC [FAct]
      END_WHILE
    END_IF


    CALC [FName] AS CON([WOF.Dir],'translation/',[WOF.FName])
    LIST_FILE_WRITE [TFile],[Res],[FName]
    IF [Res]=FALSE
      END_WAIT
      CALC [Inf] AS CON('The file "',[FName],'" could not be saved')
      MESSAGE 'Attention! Error!',[Inf],[MESSAGE_ERROR]
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE ReadAndTranslateFiles VN RATF.FType
    IF [RATF.FType]=[FTYPE_MASK]
      CALC [FExt]    AS '*.msk'
      CALC [FSubDir] AS [MASKS_PATH]
    ELSE_IF [RATF.FType]=[FTYPE_SCRIPT]
      CALC [FExt]    AS '*.csh'
      CALC [FSubDir] AS [SCRIPT_PATH]
    ELSE_IF [RATF.FType]=[FTYPE_SQL]
      CALC [FExt]    AS '*.sql'
      CALC [FSubDir] AS [SQL_PATH]
    ELSE_IF [RATF.FType]=[FTYPE_MENU]
      CALC [FExt]    AS '*.mnu'
      CALC [FSubDir] AS [PROG_PATH]
    ELSE_IF [RATF.FType]=[FTYPE_INCLUDE]
      CALC [FExt]    AS '*.inc'
      CALC [FSubDir] AS [SCRIPT_PATH]
    END_IF

    IF [SpecialPathNot]=FALSE
      LIST_CLR  [SpecialList]
      FILE_LIST [SpecialList], [FExt], [SPECIAL_PATH]
      LIST_ITEM_GET [SpecialList],[SLAct],[SLCnt]
      IF [SLCnt]>0
        CALC [SLAct] AS 1
        WHILE [SLAct]<=[SLCnt]
          LIST_STR_GET [SpecialList],[SLine],[SLAct]
          IF [SLine]<>''
            CALC [Inf] AS CON([SPECIAL_PATH],'   ',[SLAct],'/',[SLCnt])
            WAIT_INFO 'Please wait...',[Inf]
            CALL WorkOutFile [SLine], [SPECIAL_PATH], [RATF.FType]
            IF [Res]=FALSE
              EXIT_PROC
            END_IF
          END_IF
          INC [SLAct]
        END_WHILE
      END_IF
    END_IF

    IF [JustSpecialPath]
      EXIT_PROC
    END_IF

    LIST_CLR  [Files]
    FILE_LIST [Files], [FExt], [FSubDir]
    LIST_ITEM_GET [Files],[FLAct],[FLCnt]
    IF [FLCnt]>0
      ; alle Dateien, die sich im Special-Verzeichnis befinden, jetzt hier aus der Liste "rauswerfen"
      IF [SLCnt]>0
        CALC [SLAct] AS 1
        WHILE [SLAct]<=[SLCnt]
          LIST_STR_GET [SpecialList],[SLine],[SLAct]
          IF [SLine]<>''
            CALC [SLine] AS LOWCASE([SLine])
            LIST_ITEM_GET [Files],[FLAct],[FLCnt]
            IF [FLCnt]>0
              CALC [FLAct] AS 1
              WHILE [FLAct]<=[FLCnt]
                LIST_STR_GET [Files],[FLine],[FLAct]
                IF [FLine]<>''
                  CALC [FLine] AS LOWCASE([FLine])
                  IF [FLine]=[SLine]
                    IF [FLCnt]>1
                      LIST_DELETE [Files],[FLAct]
                    ELSE
                      LIST_CLR [Files]
                    END_IF

                    CALC [FLAct] AS [FLCnt]
                  END_IF
                END_IF
                INC [FLAct]
              END_WHILE
            END_IF
          END_IF
          INC [SLAct]
        END_WHILE
      END_IF
    END_IF

    LIST_ITEM_GET [Files],[FLAct],[FLCnt]
    IF [FLCnt]>0
      CALC [FLAct] AS 1
      WHILE [FLAct]<=[FLCnt]
        LIST_STR_GET [Files],[FLine],[FLAct]
        IF [FLine]<>''
          CALC [Inf] AS CON([FSubDir],'   ',[FLAct],'/',[FLCnt])
          WAIT_INFO 'Please wait...',[Inf]
          CALL WorkOutFile [FLine], [FSubDir], [RATF.FType]
          IF [Res]=FALSE
            EXIT_PROC
          END_IF
        END_IF
        INC [FLAct]
      END_WHILE
    END_IF
  END_PROC



  PROCEDURE WriteMessageFile
    LIST_CLR [AFile]
    LIST_ITEM_GET [MFile],[MAct],[MCnt]
    IF [MCnt]>0
      CALC [MAct] AS 1
      WHILE [MAct]<=[MCnt]
        LIST_STR_GET [MFile],[MLine],[MAct]
        IF [MLine]<>''
          CALC [TmpStr4] AS COPY([MLine],1,1)
          IF [TmpStr4]=';'
            LIST_APPEND [AFile], ' '
            LIST_APPEND [AFile], ' '
            LIST_APPEND [AFile], ' '
            LIST_APPEND [AFile], ' '
            LIST_APPEND [AFile], ';*****************************************************************************************************'
            LIST_APPEND [AFile], [MLine]
            LIST_APPEND [AFile], ';*****************************************************************************************************'
          ELSE
            CALC [TmpStr4] AS PART([MLine],2,[Delim])
            CALC [TmpStr4] AS CON('I:',[TmpStr4])
            LIST_APPEND [AFile], [TmpStr4]

            CALC [TmpStr4] AS PART([MLine],3,[Delim])
            IF [TmpStr4]=''
              CALC [TmpStr4] AS PART([MLine],1,[Delim])
              CALC [TmpStr4] AS CON('M:',[TmpStr4])
              LIST_APPEND [AFile], [TmpStr4]
            ELSE
              CALC [TmpStr4] AS PART([MLine],1,[Delim])
              CALC [TmpStr4] AS CON('H:',[TmpStr4])
              LIST_APPEND [AFile], [TmpStr4]

              CALC [TmpStr4] AS PART([MLine],3,[Delim])
              CALC [TmpStr4] AS CON('M:',[TmpStr4])
              LIST_APPEND [AFile], [TmpStr4]
            END_IF

            LIST_APPEND [AFile], ' '
          END_IF
        END_IF
        INC [MAct]
      END_WHILE
    END_IF


    LIST_FILE_WRITE [AFile],[Res],[MFName]
    IF [Res]=FALSE
      MESSAGE 'Attention! Error!','The message-file could not be saved',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF
  END_PROC



  PROCEDURE ReadMessageFile
    LIST_CLR [MFile]
    LIST_CLR [AFile]
    LIST_FILE_READ [AFile],[Res],[MFName]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [TmpStr2] AS ''
    CALC [TmpStr3] AS ''

    LIST_ITEM_GET [AFile],[FLAct],[FLCnt]
    IF [FLCnt]>0
      CALC [FLAct] AS 1
      WHILE [FLAct]<=[FLCnt]
        LIST_STR_GET [AFile],[FLine],[FLAct]
        CALC [FLine] AS TRIM([FLine])
        IF [FLine]<>''
          CALC [TmpStr1] AS COPY([FLine],1,1)
          IF [TmpStr1]=';'
            CALC [TmpStr1] AS COPY([FLine],1,5)
            IF [TmpStr1]<>';****'
              LIST_APPEND [MFile], [FLine]
            END_IF
          ELSE
            IF [TmpStr2]=''
              CALC [TmpStr2] AS PART([FLine],2,'I:')
            END_IF
            IF [TmpStr3]=''
              CALC [TmpStr3] AS PART([FLine],2,'M:')
            END_IF

            IF [TmpStr2]<>''
              IF [TmpStr3]<>''
                CALC [TmpStr1] AS CON([TmpStr3],[Delim],[TmpStr2])
                LIST_APPEND [MFile], [TmpStr1]
                CALC [TmpStr2] AS ''
                CALC [TmpStr3] AS ''
              END_IF
            END_IF
          END_IF
        END_IF
        INC [FLAct]
      END_WHILE
    END_IF
  END_PROC


  PROCEDURE Main
    CALC [YNRes] AS [ID_NO]
    GET_DECISION 'Attention! Are you shure?!','Should the message file now be created (if not existing) or extended (if it already exists)?','create','extend','abort',[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    CALC [MainMsgCnt] AS [MsgOffset]

    WAIT_INFO 'Please wait...','Reading the message-file...'
    CALL ReadMessageFile

   CALL ReadAndTranslateFiles [FTYPE_SCRIPT]
   CALL ReadAndTranslateFiles [FTYPE_INCLUDE]
   CALL ReadAndTranslateFiles [FTYPE_MASK]
   CALL ReadAndTranslateFiles [FTYPE_MENU]
   CALL ReadAndTranslateFiles [FTYPE_SQL]

    WAIT_INFO 'Please wait...','Writing the message-file.'
    CALL WriteMessageFile

    END_WAIT
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
