
  INCLUDE xml2xls_tools.inc


  PROCEDURE InitVars
    VAR_BOOL   Res
    VAR_LIST   MsgFile
    VAR_NUM    Max
    VAR_NUM    Act
    VAR_STR    SrcName
    VAR_STR    DstName
    VAR_STR    Str1
    VAR_STR    Str2
    VAR_STR    MsgIdx
    VAR_STR    MsgHead
    VAR_STR    MsgInfo

    CALC [SrcName] AS CON([PROG_PATH],'idealDE.msg')
    CALC [DstName] AS CON([PROG_PATH],'idealDE.xml')

;   CALC [SrcName] AS CON([CARA_PATH],'CaraDE.msg')
;   CALC [DstName] AS CON([CARA_PATH],'CaraDE.xml')
  END_PROC



  PROCEDURE DefineHeadLine
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocNum
    LOCAL_STR   LocStr

    CALC [XMLColCnt] AS 5

    CALC [LocNum] AS 0
    WHILE [LocNum]<=[XMLColCnt]
      INC [LocNum]

      CALC [LocStr] AS CON('XMLHeadLine',[LocNum])
      IDENTIFIER_EXIST [LocStr],[LocRes]
      IF [LocRes]=FALSE
        VAR_STR XMLHeadLine[LocNum]
      END_IF

      CALC [LocStr] AS CON('XMLHLSize',[LocNum])
      IDENTIFIER_EXIST [LocStr],[LocRes]
      IF [LocRes]=FALSE
        VAR_FLOAT XMLHLSize[LocNum]
      END_IF
    END_WHILE

    CALC [XMLHeadLine1] AS 'MsgID'
    CALC [XMLHeadLine2] AS 'Header'
    CALC [XMLHeadLine3] AS 'Message'
    CALC [XMLHeadLine4] AS 'Header translated'
    CALC [XMLHeadLine5] AS 'Message translated'

    CALC [XMLHLSize1]   AS  85.0
    CALC [XMLHLSize2]   AS 100.0
    CALC [XMLHLSize3]   AS 200.0
    CALC [XMLHLSize4]   AS 100.0
    CALC [XMLHLSize5]   AS 200.0
  END_PROC



  PROCEDURE WriteXMLHeader
    LOCAL_NUM LocNum
    LOCAL_STR LocStr

    CALL XMLOpenRow 'Index="3"'

    CALC [LocNum] AS 1
    WHILE [LocNum]<=[XMLColCnt]
      CALC [LocStr] AS CON('XMLHeadLine',[LocNum])

      CALC [LocStr] AS [[LocStr]]

      CALL XMLWriteCell [LocStr], '', [STYLE_HEADLINE], ''

      INC [LocNum]
    END_WHILE

    CALL XMLCloseRow
  END_PROC



  PROCEDURE Main
    LIST_FILE_READ [MsgFile],[Res],[SrcName]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [MsgFile],[Act],[Max]
    CALC [Act] AS 1

    CALL XMLReadParameter

    CALL DefineHeadLine

		CALL XMLOpenFile [DstName], [XMLRes]
		IF [XMLRes]=FALSE
			EXIT_PROC
		END_IF

    CALL XMLDocumentHeader

    CALL XMLOpenStyles
    CALL XMLStyles [XMLFont], [XMLTitleSize], [XMLHeadlineSize], [XMLNormalSize], [XMLTitleColor], [XMLCellColor], [XMLBackColor]
    CALL XMLCloseStyles

    CALL XMLOpenWorkSheet 'IDEAL-ERP Message Translation'

    CALL XMLOpenTable [XMLColCnt]

    CALL XMLSetColWidth

    CALC [Str1] AS CON('IDEAL-ERP Message Translation')

    CALL XMLWriteTitle [Str1], [XMLColCnt]

    CALC [XMLCntRows] AS 0

    CALL WriteXMLHeader

    WHILE [Act]<[Max]
      CALC [Str1] AS CON([Act],' / ',[Max])
      WAIT_INFO 'Bitte warten...',[Str1]

      LIST_STR_GET [MsgFile],[Str1],[Act]
      CALC [Str1] AS TRIM([Str1])
      IF [Str1]<>''
        CALC [Str2] AS COPY([Str1],1,1)
        IF [Str2]<>';'
          CALC [Str2] AS COPY([Str1],1,2)
          IF [Str2]='I:'
            IF [MsgIdx]<>''
              INC [XMLCntRows]
              CALL XMLOpenRow ''

              CALL XMLWriteCell [MsgIdx],  '', '', ''
              CALL XMLWriteCell [MsgHead], '', '', ''
              CALL XMLWriteCell [MsgInfo], '', '', ''

              CALC [MsgIdx]  AS ''
              CALC [MsgHead] AS ''
              CALC [MsgInfo] AS ''

              CALL XMLWriteCell [MsgHead], '', '', ''
              CALL XMLWriteCell [MsgInfo], '', '', ''

              CALL XMLCloseRow
            END_IF
            CALC [MsgIdx] AS COPY([Str1],3,255)
          ELSE_IF [Str2]='H:'
            CALC [MsgHead] AS COPY([Str1],3,255)
          ELSE_IF [Str2]='M:'
            CALC [MsgInfo] AS COPY([Str1],3,255)
          END_IF
        END_IF
      END_IF

      INC [Act]
    END_WHILE

    END_WAIT


    CALL XMLCloseTable

    CALL XMLWSOptions 3, 0

    CALL XMLCloseWorkSheet

    CALL XMLDocumentFooter

		CALL XMLCloseFile

    IF [XMLCntRows]<=0
      EXIT_PROC
    END_IF

;   SHELL_EXECUTE '', [DstName],'','',[EXTERN_SHOWNORMAL]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END

