
  INCLUDE Help.INC

  PROCEDURE InitVars
    CALC [RECORD_LOCKING_IS_ACTIVE] AS TRUE

    VAR_MASK    WorkMask, 'TextToolDlg'
    VAR_NUM     YNRes

    VAR_STR     TmpStr

    VAR_LIST    Note
    VAR_NUM     NoteIdx
    VAR_NUM     NoteLnAct
    VAR_NUM     NoteLnCnt

    VAR_FLOAT   RecID
    VAR_NUM     RecNum
    VAR_BOOL    Res
    VAR_BOOL    TralaCreated

    VAR_BROWSER Q

    VAR_FLOAT   LastLockedID

    VAR_QUERY   GridQ
    VAR_NUM     GridOption

    CALC [GridOption] AS [BROWSER_FLAG_ICON_OK]+[BROWSER_FLAG_ICON_NOTES]+[BROWSER_FLAG_ICON_LIST_GEN]+[BROWSER_FLAG_ICON_SEARCH]+[BROWSER_FLAG_OK_ON_STARTING]+[BROWSER_FLAG_SELECT_ALLOWED]

    CALC [WorkMask!MASK_HOOK_SHOW]        AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_DELETE]      AS 'DeleteHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE]    AS 'PreSaveHook'
    CALC [WorkMask!MASK_HOOK_POST_CLEAR]  AS 'PostClearHook'
    CALC [WorkMask!MASK_HOOK_IS_READY]    AS 'IsReadyHook'
    CALC [WorkMask!MASK_HOOK_EXIT]        AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_PRINT]       AS 'PrintHook'
    CALC [WorkMask!MASK_HOOK_BUTTON]      AS 'ButtonHook'
  END_PROC



  PROCEDURE LockRecord VF LockID
    IF [LastLockedID]>[EPSILON]
      RECORD_LOCK 'texttool',[LastLockedID],FALSE,[Res]
    END_IF

    IF [LockID]>[EPSILON]
      RECORD_LOCK 'texttool',[LockID],TRUE,[Res],TRUE
      IF [Res]=FALSE
        CALC [LockID] AS 0
        MASK_CLEAR [WorkMask]
      END_IF
    END_IF
    CALC [LastLockedID] AS [LockID]
  END_PROC


  PROCEDURE DoData2Mask
    IF [WorkMask!L.LanguageIdx]=0
      DATA_2_MASK [WorkMask], [GridQ]
    ELSE
      CALC [WorkMask!MASK_RECORD_ID]  AS [GridQ!RecordID]
      CALC [WorkMask!TextDescription] AS ''

      QUERY [Q]
        SELECT TransValue
          FROM trala
         WHERE RelRecID    =  [GridQ!RecordID|R0,0]
           AND TableName   = "texttool"
           AND FieldName   = "TextDescription"
           AND LanguageIdx =  [WorkMask!L.LanguageIdx]
      END_QUERY

      EXECUTE [Q],[Res]
      IF [Res]
        GET_DATA [Q],[Res]
        IF [Res]
          CALC [WorkMask!TextDescription] AS [Q!TransValue]
        END_IF
      END_IF

      LIST_CLR [Note]
      CALC [NoteIdx] AS 10000 + [WorkMask!L.LanguageIdx]
      NOTE_READ [Note],[Res],'texttool',[NoteIdx],[GridQ!RecordID]
      MEMO_SET  [WorkMask],[Note],'D.Memo1'

      MASK_UPDATE [WorkMask], TRUE
    END_IF

    CALL LockRecord [WorkMask!MASK_RECORD_ID]
  END_PROC


  PROCEDURE GridOk
    CALL DoData2Mask
  END_PROC


  PROCEDURE GridRecChangeHook
    CALL DoData2Mask
  END_PROC


  PROCEDURE GridSet
    CALC [GridQ!QUERY_HOOK_REC_CHANGE] AS ''
    QUERY_LOAD [GridQ], [Res], 'TextTool001'
    EXECUTE [GridQ],[Res]
    IF [Res]
      GRID_SET [WorkMask], 'D.Grid', [GridQ], [Res], [GridOption]
      CALC [WorkMask!MASK_HOOK_GRID_OK] AS 'GridOK'
      CALC [GridQ!QUERY_HOOK_REC_CHANGE]  AS 'GridRecChangeHook'
      DATA_2_MASK [WorkMask], [GridQ]
    END_IF
  END_PROC


  PROCEDURE IsReadyHook
    CALC [WorkMask!MASK_HOOK_IS_READY] AS ''
    FIELD_FLAG_ON_OFF [WorkMask], 'TextDescription', '[FIELD_FLAG_ACTUAL]', ''
  END_PROC


  PROCEDURE SaveTextMemoLineOneAndTwo
    LOCAL_STR Short1, ''
    LOCAL_STR Short2, ''

    IF [NoteLnCnt]>=1
      LIST_STR_GET [Note],[Short1],1
      IF [NoteLnCnt]>=2
        LIST_STR_GET [Note],[Short2],2
      END_IF
    END_IF

    QUERY [Q]
      UPDATE texttool
         SET TextShort1 = "[Short1]",
             TextShort2 = "[Short2]"
       WHERE RecordID   = [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Kurztexte konnten nicht gespeichert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF
  END_PROC


  PROCEDURE ShowHook
    CALC [WorkMask!MASK_QUERY_REFRESH] AS FALSE
    CALL GridSet
  END_PROC


  PROCEDURE PostClearHook
    CALL LockRecord 0
    FIELD_FLAG_ON_OFF [WorkMask], 'TextDescription', '[FIELD_FLAG_ACTUAL]', ''
  END_PROC


  PROCEDURE PrintHook
    GET_YES_NO 'Achtung','Wollen Sie die Textbausteine ausdrucken ?',[YNRes]
    IF [YNRes]=[ID_YES]
      SCRIPT 'PrintTextBaustein.CSH'
    END_IF
  END_PROC


  PROCEDURE ExitHook
    MASK_CLEAR [WorkMask]
    CALL LockRecord 0
  END_PROC


  PROCEDURE PreSaveHook
    IF [WorkMask!TextDescription]=''
      MESSAGE 'Achtung Abbruch','Bitte geben Sie eine Bezeichnung fr den Textbaustein ein',[MESSAGE_WARNING]
      FORE_JUMP
    END_IF

    MEMO_GET [WorkMask],[Note],'D.Memo1'
    LIST_ITEM_GET [Note],[NoteLnAct],[NoteLnCnt]
    IF [NoteLnCnt]<=0
      MESSAGE 'Achtung Abbruch','Bitte geben Sie einen Text fr den Textbaustein ein',[MESSAGE_WARNING]
      FORE_JUMP
    END_IF

    IF [WorkMask!MASK_RECORD_ID]<=[EPSILON]
      IF [WorkMask!L.LanguageIdx]<>0
        MESSAGE 'Achtung Abbruch','Bitte legen Sie zuerst den deutschsprachigen Textbaustein an',[MESSAGE_WARNING]
        FORE_JUMP
      END_IF

      QUERY [Q]
        SELECT MAX(TextIdx) FROM texttool
      END_QUERY
      EXECUTE [Q],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Es konnte keine neue Nummer fr die Textbausteine ermittelt (1) werden.',[MESSAGE_ERROR]
        FORE_JUMP
      END_IF
      GET_DATA [Q],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Es konnte keine neue Nummer fr die Textbausteine ermittelt (2) werden.',[MESSAGE_ERROR]
        FORE_JUMP
      END_IF
      CALC [RecNum] AS [Q!MAX(TextIdx)]+1

      NEW_RECORD [Res],'texttool',[RecID], TRUE, FALSE, FALSE
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Es konnte kein neuer Eintrag in die Liste der Textbausteine gemacht werden.',[MESSAGE_ERROR]
        FORE_JUMP
      END_IF

      QUERY [Q]
        UPDATE texttool
           SET TextIdx         =  [RecNum],
               TextDescription = "[WorkMask!TextDescription]",
               Active          =  1
         WHERE RecordID        =  [RecID|R0,0]
      END_QUERY

      EXECUTE [Q],[Res]
      IF [Res]=FALSE
        QUERY [Q]
          DELETE FROM texttool WHERE RecordID = [RecID|R0,0]
        END_QUERY
        EXECUTE [Q],[Res]

        MESSAGE 'Achtung Abbruch','Es ein neuer Eintrag der Liste der Textbausteine konnte nicht initialisiert werden.',[MESSAGE_ERROR]
        FORE_JUMP
      END_IF

      CALL LockRecord [RecID]
      CALC [WorkMask!MASK_RECORD_ID] AS [RecID]
      MASK_UPDATE [WorkMask], TRUE
      MEMOS_WRITE [WorkMask]
      CALL SaveTextMemoLineOneAndTwo
    ELSE
      IF [WorkMask!L.LanguageIdx]=0
        QUERY [Q]
          UPDATE texttool
             SET TextDescription = "[WorkMask!TextDescription]"
           WHERE RecordID        =  [WorkMask!MASK_RECORD_ID|R0,0]
        END_QUERY

        EXECUTE [Q],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Abbruch','Der Datensatz konnte nicht gespeichert werden.',[MESSAGE_ERROR]
          FORE_JUMP
        END_IF
        MASK_UPDATE [WorkMask], TRUE
        MEMOS_WRITE [WorkMask]
        CALL SaveTextMemoLineOneAndTwo
      ELSE
        QUERY [Q]
          SELECT RecordID
            FROM trala
           WHERE RelRecID    =  [WorkMask!MASK_RECORD_ID|R0,0]
             AND TableName   = "texttool"
             AND FieldName   = "TextDescription"
             AND LanguageIdx =  [WorkMask!L.LanguageIdx]
        END_QUERY

        EXECUTE [Q],[Res]
        IF [Res]=FALSE
          MESSAGE 'Achtung Abbruch','Ein bersetzungstext konnte nicht abgefragt werden.',[MESSAGE_ERROR]
          FORE_JUMP
        END_IF

        GET_DATA [Q],[Res]
        IF [Res]
          CALC [RecID] AS [Q!RecordID]
          CALC [TralaCreated] AS FALSE
        ELSE
          NEW_RECORD [Res],'trala',[RecID], TRUE, FALSE, FALSE
          IF [Res]=FALSE
            MESSAGE 'Achtung Abbruch','Ein bersetzungstext konnte nicht angelegt werden.',[MESSAGE_ERROR]
            FORE_JUMP
          END_IF

          CALC [TralaCreated] AS TRUE
        END_IF

        QUERY [Q]
          UPDATE trala
             SET RelRecID    =  [WorkMask!MASK_RECORD_ID|R0,0],
                 TableName   = "texttool",
                 FieldName   = "TextDescription",
                 LanguageIdx =  [WorkMask!L.LanguageIdx],
                 TransValue  = "[WorkMask!TextDescription]"
           WHERE RecordID    =  [RecID|R0,0]
        END_QUERY

        EXECUTE [Q],[Res]
        IF [Res]=FALSE
          IF [TralaCreated]
            QUERY [Q]
              DELETE FROM trala WHERE RecordID = [RecID|R0,0]
            END_QUERY
            EXECUTE [Q],[Res]
          END_IF

          MESSAGE 'Achtung Abbruch','Ein bersetzungstext konnte nicht gespeichert werden.',[MESSAGE_ERROR]
          FORE_JUMP
        END_IF

        CALC [NoteIdx] AS 10000 + [WorkMask!L.LanguageIdx]
        NOTE_WRITE [Note],[Res],'texttool',[NoteIdx],[WorkMask!MASK_RECORD_ID]
        IF [Res]=FALSE
          MESSAGE 'Achtung Abbruch','Ein fremdsprachlicher Text konnte nicht gespeichert werden.',[MESSAGE_ERROR]
          FORE_JUMP
        END_IF
      END_IF
    END_IF

    CALC [TmpStr] AS CON('STARTING WITH RecordID = ',[WorkMask!MASK_RECORD_ID|R0,0])
    QUERY_REFRESH [GridQ], FALSE, [TmpStr]

    FORE_MARK
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE DeleteHook
    LOCAL_BOOL LocVrtDelBuf, [VIRTUAL_DELETE]
    CALC [VIRTUAL_DELETE] AS FALSE

    IF [WorkMask!MASK_RECORD_ID]<=[EPSILON]
      MESSAGE 'Achtung Abbruch','Bitte whlen Sie zunchst einen Textbaustein aus',[MESSAGE_WARNING]
      FORE_JUMP
    END_IF

    GET_YES_NO 'Achtung','Sind Sie sicher, da dieser Textbaustein gelscht werden soll ?',[YNRes]
    IF [YNRes]<>[ID_YES]
      FORE_JUMP
    END_IF

    QUERY [Q]
      DELETE
        FROM Notes
       WHERE RelRecID  =  [WorkMask!MASK_RECORD_ID|R0,0]
         AND TableName = "texttool"
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die Texte eines Textbaustein konnten nicht gelscht werden',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    QUERY [Q]
      DELETE
        FROM trala
       WHERE RelRecID  =  [WorkMask!MASK_RECORD_ID|R0,0]
         AND TableName = "texttool"
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die bersetztungen des Textbaustein-Bezeichners konnten nicht gelscht werden',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    QUERY [Q]
      DELETE
        FROM texttool
       WHERE RecordID = [WorkMask!MASK_RECORD_ID|R0,0]
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Der Textbaustein konnte nicht gelscht werden',[MESSAGE_ERROR]
      FORE_JUMP
    END_IF

    CALC [VIRTUAL_DELETE] AS [LocVrtDelBuf]
    MASK_COMMAND [WorkMask], [MASK_COMMAND_CLEAR]
    CALL GridSet

    FORE_MARK

    CALC [VIRTUAL_DELETE] AS [LocVrtDelBuf]
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC


  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_LANGUAGE'
      QUERY_LOAD [Q],[Res],'langs001'
      IF [Res]=FALSE
        EXIT_PROC
      END_IF

      CALC [TmpStr] AS CON('STARTING WITH LanguageIdx = ',[WorkMask!L.LanguageIdx])
      QUERY_ADD_STRING [Q],[TmpStr]

      VIEW [Q],[Res],'Sprachen'
      IF [Res]
        CALC [WorkMask!L.LanguageIdx]   AS [Q!LanguageIdx]
        CALC [WorkMask!L.LanguageShort] AS [Q!LanguageShort]
        MASK_UPDATE [WorkMask]

        CALL DoData2Mask
      END_IF
    END_IF
  END_PROC


  PROCEDURE Main
    CALL InitVars
    MASK_PROCESS [WorkMask]
  END_PROC


SCRIPT_BEGIN
  CALL Main
SCRIPT_END