  ; RECORD_ID1 = ArtikelID


  PROCEDURE InitVars
    VAR_MASK    WorkMask, '208'
    VAR_BROWSER SB
    VAR_BOOL    Res
    VAR_NUM     Max
    VAR_NUM     LanguageIdx
    VAR_FLOAT   RecID

    CALC [WorkMask!MASK_HOOK_BUTTON]     AS 'ButtonHook'
    CALC [WorkMask!MASK_HOOK_DELETE]     AS 'DeleteHook'
    CALC [WorkMask!MASK_HOOK_PRE_SAVE]   AS 'PreSaveHook'
    CALC [WorkMask!MASK_HOOK_PRE_SEARCH] AS 'PreSearchHook'
    CALC [WorkMask!MASK_HOOK_IS_READY]   AS 'IsReadyHook'
    CALC [WorkMask!MASK_HOOK_EXIT]       AS 'ExitHook'
  END_PROC


  PROCEDURE LoadTrala
    CALC [WorkMask!LanguageName] AS [SB!L.LanguageName]
    CALC [WorkMask!LanguageIdx]  AS [SB!L.LanguageIdx]
    CALC [LanguageIdx]           AS [SB!L.LanguageIdx]

    CALC [WorkMask!Bezeichnung1] AS ''
    CALC [WorkMask!Bezeichnung2] AS ''
    CALC [WorkMask!Bezeichnung3] AS ''
    CALC [WorkMask!Bezeichnung4] AS ''
    CALC [WorkMask!Bezeichnung5] AS ''

    QUERY [SB]
      SELECT TransValue, FieldName
        FROM trala
       WHERE TableName   = "artikel"
         AND RelRecID    =  [RECORD_ID1|R0,0]
         AND LanguageIdx =  [LanguageIdx]
    END_QUERY

    EXECUTE [SB], [Res]
    IF [Res]=FALSE
      MASK_UPDATE [WorkMask], TRUE
      EXIT_PROC
    END_IF

    GET_DATA [SB], [Res]
    WHILE [Res]
      CALC [WorkMask![SB!FieldName]] AS [SB!TransValue]
      GET_DATA [SB], [Res]
    END_WHILE

    MASK_UPDATE [WorkMask], TRUE
  END_PROC


  PROCEDURE PreSearchHook
    QUERY [SB]
      SELECT [N"Sprache"]L.LanguageName, [H]L.LanguageIdx
        FROM trala T, langs L
       WHERE T.TableName   = "artikel"
         AND T.FieldName   = "Bezeichnung1"
         AND T.RelRecID    =  [RECORD_ID1|R0,0]
         AND T.LanguageIdx =  L.LanguageIdx
    END_QUERY

    EXECUTE [SB], [Res]
    IF [Res]=FALSE
      FORE_JUMP
    END_IF

    QUERY_COUNT [SB], [Max]
    IF [Max]=0
      FORE_JUMP
    END_IF

    IF [Max]=1
      GET_DATA [SB], [Res]
      IF [Res]
        CALL LoadTrala
      END_IF

      FORE_JUMP
    END_IF

    VIEW [SB],[Res],'Bereits angegebene Sprachen','',FALSE,TRUE
    IF [Res]
      CALL LoadTrala
    END_IF

    FORE_MARK
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC



  PROCEDURE SelectSprache
    LOCAL_BOOL    LocRes
    LOCAL_BROWSER LocSB
    LOCAL_STR     LocStr

    QUERY_LOAD [LocSB],[LocRes],'langs001'

    CALC [LocStr] AS CON('STARTING WITH LanguageIdx = "',[WorkMask!LanguageIdx],'"')
    QUERY_ADD_STRING [LocSB],[LocStr]

    VIEW [LocSB],[LocRes],'Sprache auswhlen'
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    IF [LocSB!LanguageIdx]<>[WorkMask!LanguageIdx]
      MASK_COMMAND [WorkMask],[MASK_COMMAND_CLEAR]
    END_IF

    CALC [WorkMask!LanguageName] AS [LocSB!LanguageName]
    CALC [WorkMask!LanguageIdx]  AS [LocSB!LanguageIdx]
    MASK_UPDATE [WorkMask], TRUE
  END_PROC



  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_SPRACHE'
      CALL SelectSprache
    END_IF
  END_PROC


  PROCEDURE DeleteHook
    IF [WorkMask!LanguageIdx]<=0
      MESSAGE 'Abbruch','Bitte whlen Sie zunchst eine bersetzung aus.',[MESSAGE_WARNING]
      FORE_JUMP
    END_IF

    LOCAL_BOOL  LocRes
    LOCAL_QUERY LocQ
    LOCAL_NUM   LocNum, [ID_NO]

    GET_YES_NO 'Achtung! Sind Sie sicher?!','Soll diese bersetzung wirklich gelscht werden?',[LocNum]
    IF [LocNum]<>[ID_YES]
      FORE_JUMP
    END_IF

    QUERY [LocQ]
      DELETE
        FROM trala
       WHERE TableName   =    "artikel"
         AND FieldName   LIKE "Bezeichnung[SQL_WILD_CARD_MULTI]"
         AND RelRecID    =     [RECORD_ID1|R0,0]
         AND LanguageIdx =     [WorkMask!LanguageIdx]
    END_QUERY

    EXECUTE [LocQ], [LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Achtung Abbruch','Die bersetzung konnte nicht gelscht werden.',[MESSAGE_WARNING]
    ELSE
      MESSAGE 'Hinweis','Die bersetzung wurde gelscht.',[MESSAGE_INFO]
      MASK_CLEAR [WorkMask]
    END_IF

    FORE_MARK
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC


  PROCEDURE SaveBezeichnung VN SB.Idx
    IF [WorkMask!Bezeichnung[SB.Idx]]=''
      EXIT_PROC
    END_IF

    NEW_RECORD [Res],'trala',[RecID], TRUE, FALSE, FALSE
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY [SB]
      UPDATE trala
         SET RelRecID      =  [RECORD_ID1|R0,0],
             TableName     = "artikel",
             FieldName     = "Bezeichnung[SB.Idx]",
             LanguageIdx   =  [WorkMask!LanguageIdx],
             TransValue    = "[WorkMask!Bezeichnung[SB.Idx]]"
       WHERE RecordID      =  [RecID|R0,0]
    END_QUERY

    EXECUTE [SB], [Res]
  END_PROC


  PROCEDURE PreSaveHook
    IF [WorkMask!LanguageName]=''
      MESSAGE 'Abbruch','Bitte whlen Sie zunchst die Sprache aus.',[MESSAGE_WARNING]
      FORE_JUMP
    END_IF

    IF [WorkMask!Bezeichnung1]=''
      MESSAGE 'Abbruch','Bitte geben Sie mindestens in die erste Zeile der Bezeichnungen etwas ein.',[MESSAGE_WARNING]
      FORE_JUMP
    END_IF

    QUERY [SB]
      DELETE
        FROM trala
       WHERE TableName   =    "artikel"
         AND FieldName   LIKE "Bezeichnung[SQL_WILD_CARD_MULTI]"
         AND RelRecID    =     [RECORD_ID1|R0,0]
         AND LanguageIdx =     [WorkMask!LanguageIdx]
    END_QUERY

    EXECUTE [SB], [Res]
    IF [Res]=FALSE
      FORE_JUMP
    END_IF

    CALL SaveBezeichnung 1
    IF [Res]
      CALL SaveBezeichnung 2
    END_IF
    IF [Res]
      CALL SaveBezeichnung 3
    END_IF
    IF [Res]
      CALL SaveBezeichnung 4
    END_IF
    IF [Res]
      CALL SaveBezeichnung 5
    END_IF

    IF [Res]=FALSE
      MESSAGE 'Achtung Fehler','Die berstezung konnte nicht gespeichert werden',[MESSAGE_ERROR]
    END_IF

    FORE_MARK
    CALC [WorkMask!MASK_ACTION] AS 1
  END_PROC


  PROCEDURE IsReadyHook
    CALC [WorkMask!MASK_HOOK_IS_READY] AS ''
    MASK_COMMAND [WorkMask], [MASK_COMMAND_SEARCH]
  END_PROC


  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars

  IF [RECORD_ID1]>[EPSILON]
    MASK_PROCESS [WorkMask]
  END_IF
SCRIPT_END
