

  PROCEDURE InitVars
    VAR_STR   NaviRes
    VAR_STR   XML_Abfrage
    VAR_STR   Str1
    VAR_NUM   count,       1
    VAR_NUM   LastCount,   1
    VAR_NUM   MaxPages,  100
    VAR_BOOL  Res

    CALC [Res] AS [NAVIGATOR_IS_ONLINE]
    IF [Res]=FALSE
      NAVIGATE [NAVIGATE_ONLINE]
    END_IF

    ; Erstmal alle mglichen Antwortdateien lschen
    CALC [Count] AS 1
    WHILE [Count]<=[MaxPages]
      CALC [NaviRes] AS CON([PRINTSET_PATH],'wiener_',[count],'.xml')
      EXIST_FILE [NaviRes],[Res]
      IF [Res]
        FILE_DELETE [Res], [NaviRes]
      END_IF
      INC [Count]
    END_WHILE
    CALC [Count] AS 1

    CALC [XML_Abfrage] AS CON('http://b2b.bike-parts.de/xml/?loginid=csh&password=germany&processtype=searchcatalog&category=cat&pagesize=',[MaxPages],'&page=',[Count])

    VAR_MASK  WorkMask, 'WienerDlg'

    CALC [Str1] AS CON('Bitte warten (',[count],' / ',[MaxPages],') ...')
    SET_LABEL [WorkMask],'LB_Wait',[Str1]

    CALC [WorkMask!MASK_HOOK_POST_NAVIGATE] AS 'PostNavigate'
    CALC [WorkMask!MASK_HOOK_EXIT]          AS 'ExitHook'
    CALC [WorkMask!MASK_HOOK_TIMER]         AS 'TimerHook'

    ; sptestens alle 100ms (also jede 10tel Sekunde) schauen ob die nchste Seite geladen werden kann...
    MASK_TIMER [WorkMask], 100, TRUE
  END_PROC



  PROCEDURE PostNavigate
    CALC [NaviRes] AS CON([PRINTSET_PATH],'wiener_',[count],'.xml')

    ; auf jeden All die Datei lschen, wenn sie schon da sein sollte
    EXIST_FILE [NaviRes],[Res]
    IF [Res]
      FILE_DELETE [Res], [NaviRes]
    END_IF

    NAVIGATE [WorkMask], 'OnlineInfo', [NAVIGATE_SAVE], [NaviRes]
    INC [Count]
  END_PROC



  PROCEDURE ExitHook
    CALC [WorkMask!MASK_IS_MODIFIED] AS FALSE
  END_PROC



  PROCEDURE TimerHook
    IF [LastCount]=[Count]
      EXIT_PROC
    END_IF

    CALC [LastCount] AS [Count]
    IF [Count]>[MaxPages]
      MASK_COMMAND [WorkMask],[MASK_COMMAND_EXIT]
      EXIT_PROC
    END_IF

    CALC [Str1] AS CON('Bitte warten (',[count],' / ',[MaxPages],') ...')
    SET_LABEL [WorkMask],'LB_Wait',[Str1]

    CALC [XML_Abfrage] AS CON('http://b2b.bike-parts.de/xml/?loginid=csh&password=germany&processtype=searchcatalog&category=cat&pagesize=100&page=',[Count])
    NAVIGATE [WorkMask], 'OnlineInfo', [XML_Abfrage]
  END_PROC



  PROCEDURE Main
    MASK_PROCESS [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
