

  PROCEDURE InitVars
    VAR_LIST XML

    VAR_NUM  SubPos
    VAR_NUM  SubCount
    VAR_NUM  SubAct

    VAR_NUM  ItemCount
    VAR_NUM  ItemAct
    VAR_NUM  ItemPos

    VAR_NUM  ValPos
    VAR_STR  ValStr
    VAR_STR  TmpStr

    VAR_LIST ItemList
    VAR_LIST ValList
    VAR_LIST SubList

    VAR_BOOL Res

    ; Die Liste wird mit Beispieldaten gefllt. Man knnte sie auch mit LIST_FILE_READ aus einer Datei laden.
    LIST_APPEND [XML], '<MainTag><SubTag><Item><Detail1>D001</Detail1><Detail2>D002</Detail2><Detail3>D003</Detail3></Item>'
    LIST_APPEND [XML], '<Item><Detail1>D011</Detail1><Detail2>D012</Detail2><Detail3>D013</Detail3></Item><Item><Detail1>D021</Detail1><Detail2>D022</Detail2><Detail3>D023</Detail3></Item>'
    LIST_APPEND [XML], '<Item><Detail1>D031</Detail1><Detail2>D032</Detail2><Detail3>D033</Detail3></Item><Item><Detail1>D041</Detail1><Detail2>D042</Detail2><Detail3>D043</Detail3></Item>'
    LIST_APPEND [XML], '<Item><Detail1>D051</Detail1><Detail2>D052</Detail2><Detail3>D053</Detail3></Item></SubTag><SubTag>'
    LIST_APPEND [XML], '<Item><Detail1>D101</Detail1><Detail2>D102</Detail2><Detail3>D103</Detail3></Item><Item><Detail1>D111</Detail1><Detail2>D112</Detail2><Detail3>D113</Detail3></Item>'
    LIST_APPEND [XML], '<Item><Detail1>D121</Detail1><Detail2>D122</Detail2><Detail3>D123</Detail3></Item><Item><Detail1>D131</Detail1><Detail2>D132</Detail2><Detail3>D133</Detail3></Item>'
    LIST_APPEND [XML], '<Item><Detail1>D141</Detail1><Detail2>D142</Detail2><Detail3>D143</Detail3></Item><Item><Detail1>D151</Detail1><Detail2>D152</Detail2><Detail3>D153</Detail3></Item></SubTag></MainTag>'
  END_PROC



  PROCEDURE GetOneDetail VN Idx
    ; VOR jedem Suchen eines Details den Such-Cursor ganz nach oben setzten.
    ; So erwischt man jedes Detail - egal in welcher Reihenfolge es in der XML-Datei
    ; vorkommt und egal in welcher Reihenfolge man das Detail liest.
    CALC [ValPos] AS 1
    CALC [TmpStr] AS CON('Detail',[Idx])

    ; Den Wert des Details in einen Sting laden
    LIST_TAG_GET [ItemList], [TmpStr], [ValPos], [ValStr], [Res]
    IF [Res]
      ; Ausagbe des Details
      CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   Detail ',[Idx],' >',[ValStr],'<')
      DEBUG_INFO [TmpStr]
    END_IF
  END_PROC



  PROCEDURE Main
    ; Wieviele "SubTag" gibt es? Die Suche beginnt am Beginn der Datei.
    CALC [SubPos] AS 1
    LIST_TAG_COUNT [XML], 'SubTag', [SubPos], [SubCount]

    ; Jetzt alle "SubTag" durchlaufen
    CALC [SubAct] AS 1
    CALC [SubPos] AS 1
    WHILE [SubAct]<=[SubCount]
      ; Die gesamte "SubTag"-Sequenz in die Liste [SubList] laden
      LIST_TAG_GET [XML], 'SubTag', [SubPos], [SubList], [Res]

      ; Wieviele "Item" gibt es in dem aktuellen "SubTag"? Die Suche beginnt am Beginn der "SubList"-Sequenz.
      CALC [ItemPos] AS 1
      LIST_TAG_COUNT [SubList], 'Item', [ItemPos], [ItemCount]

      ; Jetzt alle "Item" des aktuellen "SubTag" durchlaufen
      CALC [ItemAct] AS 1
      CALC [ItemPos] AS 1
      WHILE [ItemAct]<=[ItemCount]
        ; Die gesamte "Item"-Sequenz in die Liste [ItemList] laden
        LIST_TAG_GET [SubList], 'Item', [ItemPos], [ItemList], [Res]

        ; In jedem "Item" werden drei Felder mit den Namen "Detail1", "Detail2" un "Detail3" erwartet
        CALL GetOneDetail 1
        CALL GetOneDetail 2
        CALL GetOneDetail 3

        INC [ItemAct]
        DEBUG_INFO '.'
      END_WHILE

      INC [SubAct]
      DEBUG_INFO '.'
    END_WHILE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END