

  PROCEDURE InitVars
    VAR_LIST XML

    VAR_NUM  SubPos
    VAR_NUM  SubCount
    VAR_NUM  SubAct

    VAR_NUM  ItemCount
    VAR_NUM  ItemAct
    VAR_NUM  ItemPos

    VAR_NUM  ValPos
    VAR_STR  ValStr
    VAR_STR  AttrStr
    VAR_STR  TmpStr

    VAR_LIST ItemList
    VAR_LIST ValList
    VAR_LIST SubList
    VAR_LIST AttrList

    VAR_BOOL Res

    ; Die Liste wird mit Beispieldaten gefllt. Man knnte sie auch mit LIST_FILE_READ aus einer Datei laden.
    LIST_APPEND [XML], '<MainTag MainAttribute=1>'
    LIST_APPEND [XML],   '<SubTag SubAttribute=1>'
    LIST_APPEND [XML],     '<Item ItemAttribute=1>'
    LIST_APPEND [XML],       '<preis PreisAttribute=1>200,00</preis>'
    LIST_APPEND [XML],       '<EAN EANAttribute=1>53535353535</EAN>'
    LIST_APPEND [XML],       '<TAX TaxAttribute=1>19,00</TAX>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item>'
    LIST_APPEND [XML],       '<EAN>74464734445</EAN>'
    LIST_APPEND [XML],       '<preis>300,00</preis>'
    LIST_APPEND [XML],       '<TAX>19,00</TAX>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item>'
    LIST_APPEND [XML],       '<TAX>19,00</TAX>'
    LIST_APPEND [XML],       '<preis>400,00</preis>'
    LIST_APPEND [XML],       '<EAN>39479327493</EAN>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],   '</SubTag>'
    LIST_APPEND [XML],   '<SubTag>'
    LIST_APPEND [XML],     '<Item>'
    LIST_APPEND [XML],       '<preis>220,00</preis>'
    LIST_APPEND [XML],       '<TAX>19,00</TAX>'
    LIST_APPEND [XML],       '<EAN>98237948723</EAN>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item>'
    LIST_APPEND [XML],       '<TAX>19,00</TAX>'
    LIST_APPEND [XML],       '<EAN>23492347983</EAN>'
    LIST_APPEND [XML],       '<preis>330,00</preis>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item>'
    LIST_APPEND [XML],       '<TAX>19,00</TAX>'
    LIST_APPEND [XML],       '<EAN>13213132223</EAN>'
    LIST_APPEND [XML],       '<preis>440,00</preis>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item ItemAttribute=2/>'
    LIST_APPEND [XML],     '<Item>'
    LIST_APPEND [XML],       '<TAX>19,00</TAX>'
    LIST_APPEND [XML],       '<EAN>133234223</EAN>'
    LIST_APPEND [XML],       '<preis>460,00</preis>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],   '</SubTag>'
    LIST_APPEND [XML], '</MainTag>'
  END_PROC



  PROCEDURE Main
    ; Wieviele "SubTag" gibt es? Die Suche beginnt am Beginn der Datei.
    CALC [SubPos] AS 1
    LIST_TAG_COUNT [XML], 'SubTag', [SubPos], [SubCount], [AttrStr]
    IF [AttrStr]<>''
      DEBUG_INFO [AttrStr]
    END_IF

    ; Jetzt alle "SubTag" durchlaufen
    CALC [SubAct] AS 1
    CALC [SubPos] AS 1
    WHILE [SubAct]<=[SubCount]
      ; Die gesamte "SubTag"-Sequenz in die Liste [SubList] laden
      LIST_TAG_GET [XML], 'SubTag', [SubPos], [SubList], [Res], [AttrStr]
      IF [AttrStr]<>''
        DEBUG_INFO [AttrStr]
      END_IF

      ; Wieviele "Item" gibt es in dem aktuellen "SubTag"? Die Suche beginnt am Beginn der "SubList"-Sequenz.
      CALC [ItemPos] AS 1
      LIST_TAG_COUNT [SubList], 'Item', [ItemPos], [ItemCount]

      ; Jetzt alle "Item" des aktuellen "SubTag" durchlaufen
      CALC [ItemAct] AS 1
      CALC [ItemPos] AS 1
      WHILE [ItemAct]<=[ItemCount]
        ; Die gesamte "Item"-Sequenz in die Liste [ItemList] laden
        LIST_TAG_GET [SubList], 'Item', [ItemPos], [ItemList], [Res], [AttrStr]
        IF [AttrStr]<>''
          DEBUG_INFO [AttrStr]
        END_IF

        ; VOR jedem Suchen eines Details den Such-Cursor ganz nach oben setzten.
        ; So erwischt man jedes Detail - egal in welcher Reihenfolge es in der XML-Datei
        ; vorkommt und egal in welcher Reihenfolge man das Detail liest.
        CALC [ValPos] AS 1

        ; Den Wert des Details in einen Sting laden
        LIST_TAG_GET [ItemList], 'preis', [ValPos], [ValStr], [Res], [AttrStr]
        IF [Res]
          IF [AttrStr]<>''
            DEBUG_INFO [AttrStr]
          END_IF

          ; Ausagbe des Preises
          CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   Preis  >',[ValStr],'<')
          DEBUG_INFO [TmpStr]
        END_IF


        CALC [ValPos] AS 1
        LIST_TAG_GET [ItemList], 'EAN', [ValPos], [ValStr], [Res], [AttrStr]
        IF [Res]
          IF [AttrStr]<>''
            DEBUG_INFO [AttrStr]
          END_IF

          CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   EAN    >',[ValStr],'<')
          DEBUG_INFO [TmpStr]
        END_IF


        CALC [ValPos] AS 1
        LIST_TAG_GET [ItemList], 'TAX', [ValPos], [ValStr], [Res], [AttrStr]
        IF [Res]
          IF [AttrStr]<>''
            DEBUG_INFO [AttrStr]
          END_IF

          CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   TAX    >',[ValStr],'<')
          DEBUG_INFO [TmpStr]
        END_IF


        INC [ItemAct]
        DEBUG_INFO '.'
      END_WHILE

      INC [SubAct]
      DEBUG_INFO '.'
    END_WHILE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END