

  PROCEDURE InitVars
    VAR_LIST XML

    VAR_NUM  SubPos
    VAR_NUM  SubCount
    VAR_NUM  SubAct

    VAR_NUM  ItemCount
    VAR_NUM  ItemAct
    VAR_NUM  ItemPos

    VAR_NUM  ValPos
    VAR_STR  ValStr
    VAR_STR  TmpStr

    VAR_LIST ItemList
    VAR_LIST ValList
    VAR_LIST SubList

    VAR_BOOL Res

    ; Die Liste wird mit Beispieldaten gefllt. Man knnte sie auch mit LIST_FILE_READ aus einer Datei laden.
    LIST_APPEND [XML], '<MainTag>'
    LIST_APPEND [XML],   '<SubTag class="s">'
    LIST_APPEND [XML],     '<Item class="i">'
    LIST_APPEND [XML],       '<preis class="p">200,00</preis>'
    LIST_APPEND [XML],       '<EAN   class="e">53535353535</EAN>'
    LIST_APPEND [XML],       '<TAX   class="t">19,00</TAX>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item class="i">'
    LIST_APPEND [XML],       '<EAN   class="e">74464734445</EAN>'
    LIST_APPEND [XML],       '<preis class="p">300,00</preis>'
    LIST_APPEND [XML],       '<TAX   class="t">19,00</TAX>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item class="i">'
    LIST_APPEND [XML],       '<TAX   class="t">19,00</TAX>'
    LIST_APPEND [XML],       '<preis class="p">400,00</preis>'
    LIST_APPEND [XML],       '<EAN   class="e">39479327493</EAN>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],   '</SubTag>'
    LIST_APPEND [XML],   '<SubTag class="s">'
    LIST_APPEND [XML],     '<Item class="i">'
    LIST_APPEND [XML],       '<preis class="p">220,00</preis>'
    LIST_APPEND [XML],       '<TAX   class="t">19,00</TAX>'
    LIST_APPEND [XML],       '<EAN   class="e">98237948723</EAN>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item class="i">'
    LIST_APPEND [XML],       '<TAX   class="t">19,00</TAX>'
    LIST_APPEND [XML],       '<EAN   class="e">23492347983</EAN>'
    LIST_APPEND [XML],       '<preis class="p">330,00</preis>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],     '<Item class="i">'
    LIST_APPEND [XML],       '<TAX   class="t">19,00</TAX>'
    LIST_APPEND [XML],       '<EAN   class="e">13213132223</EAN>'
    LIST_APPEND [XML],       '<preis class="p">440,00</preis>'
    LIST_APPEND [XML],     '</Item>'
    LIST_APPEND [XML],   '</SubTag>'
    LIST_APPEND [XML], '</MainTag>'
  END_PROC



  PROCEDURE Main
    ; Wieviele "SubTag" gibt es? Die Suche beginnt am Beginn der Datei.
    CALC [SubPos] AS 1
    LIST_TAG_COUNT [XML], 'SubTag', [SubPos], [SubCount]

    ; Jetzt alle "SubTag" durchlaufen
    CALC [SubAct] AS 1
    CALC [SubPos] AS 1
    WHILE [SubAct]<=[SubCount]
      ; Die gesamte "SubTag"-Sequenz in die Liste [SubList] laden
      LIST_TAG_GET [XML], 'SubTag', [SubPos], [SubList], [Res]

      ; Wieviele "Item" gibt es in dem aktuellen "SubTag"? Die Suche beginnt am Beginn der "SubList"-Sequenz.
      CALC [ItemPos] AS 1
      LIST_TAG_COUNT [SubList], 'Item', [ItemPos], [ItemCount]

      ; Jetzt alle "Item" des aktuellen "SubTag" durchlaufen
      CALC [ItemAct] AS 1
      CALC [ItemPos] AS 1
      WHILE [ItemAct]<=[ItemCount]
        ; Die gesamte "Item"-Sequenz in die Liste [ItemList] laden
        LIST_TAG_GET [SubList], 'Item', [ItemPos], [ItemList], [Res]


        ; VOR jedem Suchen eines Details den Such-Cursor ganz nach oben setzten.
        ; So erwischt man jedes Detail - egal in welcher Reihenfolge es in der XML-Datei
        ; vorkommt und egal in welcher Reihenfolge man das Detail liest.
        CALC [ValPos] AS 1

        ; Den Wert des Details in einen Sting laden
        LIST_TAG_GET [ItemList], 'preis', [ValPos], [ValStr], [Res]
        IF [Res]
          ; Ausagbe des Preises
          CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   Preis  >',[ValStr],'<')
          DEBUG_INFO [TmpStr]
        END_IF


        CALC [ValPos] AS 1
        LIST_TAG_GET [ItemList], 'EAN', [ValPos], [ValStr], [Res]
        IF [Res]
          CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   EAN    >',[ValStr],'<')
          DEBUG_INFO [TmpStr]
        END_IF

DEBUG_INFO '.'
DEBUG_INFO '.'
DEBUG_INFO '...Unverndert...'
DEBUG_INFO '.'
DEBUG_INFO '.'
SHOW_VAR [ItemList]

        CALC [ValPos] AS 1
        CALC [ValStr] AS '7.0'
        LIST_TAG_SET [ItemList], 'TAX', [ValPos], [ValStr], [Res]
DEBUG_INFO 'LIST_TAG_SET   ...TAX auf 7.00 gendert...'
DEBUG_INFO '.'
DEBUG_INFO '.'
SHOW_VAR [ItemList]

        CALC [ValPos] AS 1
        LIST_TAG_DELETE [ItemList], 'TAX', [ValPos], [Res]
DEBUG_INFO 'LIST_TAG_DELETE...TAX entfernt...'
DEBUG_INFO '.'
DEBUG_INFO '.'
SHOW_VAR [ItemList]

        CALC [ValPos] AS 1
        CALC [ValStr] AS '<TAX   class="t">0,00</TAX>'
        LIST_TAG_INSERT [ItemList], [ValPos], [ValStr], [Res]
DEBUG_INFO 'LIST_TAG_INSERT...TAX mit 0.00 eingebaut...'
DEBUG_INFO '.'
DEBUG_INFO '.'
SHOW_VAR [ItemList]

        CALC [ValPos] AS 1
        LIST_TAG_GET [ItemList], 'TAX', [ValPos], [ValStr], [Res]
        IF [Res]
          CALC [TmpStr] AS CON('Sub ',[SubAct],'   Item ',[ItemAct],'   TAX    >',[ValStr],'<')
          DEBUG_INFO [TmpStr]
        END_IF


        INC [ItemAct]
        DEBUG_INFO '.'
      END_WHILE

      INC [SubAct]
      DEBUG_INFO '.'
    END_WHILE
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END