  ; DD, 08.08.2006
  ;
  ; Repariert bzw. setzt die RecFlag aller Datenstze in allen
  ; Tabellen denen Notizen und/oder Dokumente zugeordnet wurden.
  ;
  ; Alle "nicht benutzten" Notizen oder Dokumenten-Ordner oder
  ; Dokumenten-Eintrge werden gelscht.



  PROCEDURE InitVars
    ; Setzte diese Variable = FASLE, wenn keine
    ; "ubenutzten" Datenstze gelscht werden sollen...
    VAR_BOOL     DelUnused, TRUE

    VAR_BOOL     Res
    VAR_QUERY    Q
    VAR_QUERY    Rel
    VAR_NUM      YNRes
    VAR_NUM      Max
    VAR_NUM      Cnt
    VAR_NUM      LnAct
    VAR_NUM      LnCnt
    VAR_NUM      Flag
    VAR_STR      Inf
    VAR_STR      Str1
    VAR_STR      Str2
    VAR_LIST     Tables

    VAR_NUM      MandBuf, [ACT_MANDANT]
    CALC [ACT_MANDANT] AS 0
  END_PROC



  PROCEDURE Main
    CALC [YNRes] AS [ID_NO]
    CALC [Str1]  AS 'Mchten Sie bei alle Datenstzen, zu denen Notizen oder Dokumente angelegt wurden, den Anzeigekenner (RecFlag) prfen und ggf. neu setzten lassen?'
    IF [DelUnused]
      CALC [Str1]  AS CON([Str1],'||Hinweis: "Unbenuzte" Notiz- und Dokument-Zuordnungen werden gelscht!')
    END_IF
    CALC [Str1]  AS CON([Str1],'||Dies kann ein paar Minuten dauern.')
    GET_YES_NO 'Achtung! Sind Sie sicher?!',[Str1],[YNRes]
    IF [YNRes]<>[ID_YES]
      EXIT_PROC
    END_IF

    LIST_CLR [Tables]

    WAIT_INFO 'Bitte warten...', 'Die betroffenen Tabellen werden ermittelt...'

    IF [DelUnused]
      ; Erstmal alle EventFlags auf 0 setzten
      QUERY [Q]
        UPDATE notes
           SET EventFlag  = 0
      END_QUERY
      EXECUTE [Q],[Res]

      QUERY [Q]
        UPDATE notes
           SET NoteInfo = ""
         WHERE RecordID < 10
      END_QUERY
      EXECUTE [Q],[Res]

      QUERY [Q]
        UPDATE docmgrh
           SET EventFlag  = 0
      END_QUERY
      EXECUTE [Q],[Res]

      QUERY [Q]
        UPDATE docmgri
           SET EventFlag  = 0
      END_QUERY
      EXECUTE [Q],[Res]

      ; Nun alle zu untersuchenden Records "markieren".
      ; Die, die spter noch markiert sind, werden gelscht.
      QUERY [Q]
        UPDATE notes
           SET EventFlag  = 1
         WHERE RecordID   > 1000
           AND TableName <> ""
      END_QUERY
      EXECUTE [Q],[Res]

      QUERY [Q]
        UPDATE docmgrh
           SET EventFlag  = 1
         WHERE RecordID   > 1000
           AND TableName <> ""
      END_QUERY
      EXECUTE [Q],[Res]

      QUERY [Q]
        UPDATE docmgri
           SET EventFlag  = 1
         WHERE RecordID   > 1000
      END_QUERY
      EXECUTE [Q],[Res]
    END_IF

    ; Alle Tabellen-Namen, die in den Notizen je Verwendung fanden in eine Liste speichern.
    QUERY [Q]
      SELECT DISTINCT TableName
        FROM notes
       WHERE RecordID   > 1000
         AND TableName <> ""
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]
      GET_DATA [Q],[Res]
      WHILE [Res]
        CALC [Str1] AS LOWCASE([Q!DISTINCTTableName])
        LIST_STR_FIND [Tables],[Str1]
        LIST_ITEM_GET [Tables],[LnAct],[LnCnt]
        LIST_STR_GET  [Tables],[Str2], [LnAct]
        IF [Str1]<>[Str2]
          LIST_APPEND [Tables],[Str1]
        END_IF
        GET_DATA [Q],[Res]
      END_WHILE
    END_IF

    LIST_SORT [Tables]


    ; Alle Tabellen-Namen, die in den Dokumenten-Ordnern jemals verwendet wurden, abholen,
    ; und nur dann in die Liste schreiben, wenn diese Tabelle bei den Notizen nicht auch
    ; schon gefunden wurde.
    QUERY [Q]
      SELECT DISTINCT TableName
        FROM docmgrh
       WHERE RecordID   > 1000
         AND TableName <> ""
    END_QUERY
    EXECUTE [Q],[Res]
    IF [Res]
      GET_DATA [Q],[Res]
      WHILE [Res]
        CALC [Str1] AS LOWCASE([Q!DISTINCTTableName])
        LIST_STR_FIND [Tables],[Str1]
        LIST_ITEM_GET [Tables],[LnAct],[LnCnt]
        LIST_STR_GET  [Tables],[Str2], [LnAct]
        IF [Str1]<>[Str2]
          LIST_APPEND [Tables],[Str1]
        END_IF
        GET_DATA [Q],[Res]
      END_WHILE
    END_IF

    LIST_SORT [Tables]

    LIST_ITEM_GET [Tables],[LnAct],[LnCnt]
    IF [LnCnt]=0
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es wurden bisher weder Notizen noch Dokumente verwendet.'
      EXIT_PROC
    END_IF

    ; Alle Tabellen, die nun in der Liste stehen initialisieren.
    LIST_ITEM_GET [Tables],[LnAct],[LnCnt]
    IF [LnCnt]>0
      CALC [LnAct] AS 1
      WHILE [LnAct]<=[LnCnt]
        LIST_STR_GET [Tables],[Str1],[LnAct]
        IF [Str1]<>''
          CALC [Inf] AS CON('Die Tabelle "',[Str1],'" wird initialisiert...')
          WAIT_INFO 'Bitte warten...', [Inf]
          QUERY [Q]
            UPDATE [Str1] SET RecFlag = 0
          END_QUERY
          EXECUTE [Q],[Res]
        END_IF
        INC [LnAct]
      END_WHILE
    END_IF

    END_WAIT



    ; Durch die Notizen gehen und die RecFlag der zugeordneten Datenstze setzten.
    WAIT_INFO 'Bitte warten...', 'Die Notizen werden geladen...'

    QUERY [Q]
        SELECT TableName, RelRecID, NoteID
          FROM notes
         WHERE RecordID  > 1000
           AND RelRecID  > 0
      GROUP BY TableName, RelRecID, NoteID
      ORDER BY TableName, RelRecID, NoteID
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden aller Notizen konnte nicht ausgefhrt werden.'
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es sind keine Daten in der Notizen-Tabelle.'
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]
    CALC [Cnt] As 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Inf] AS CON('Notiz ',[Max],' / ',[Cnt])
      WAIT_INFO 'Bitte warten...', [Inf]

      ; Aktuelle RecFlag des Datensatzes holen (diese knnte ja schon
      ; bei einer zuvor gefundenen Notiz verndert worden sein).
      QUERY [Rel]
        SELECT RecFlag
          FROM [Q!TableName]
         WHERE RecordID = [Q!RelRecID|R0,0]
      END_QUERY

      EXECUTE [Rel],[Res]
      IF [Res]
        GET_DATA [Rel],[Res]
        IF [Res]
          CALC [Flag] AS [Rel!RecFlag]

          ; Flagge passend zur Notiz verndern (wenn ntig).
          IF [Q!NoteID]=1
            FLAG_SET [Flag],[NOTES_FLAG_PRINT_FRONT], TRUE
          ELSE_IF [Q!NoteID]=2
            FLAG_SET [Flag],[NOTES_FLAG_PRINT_BACK],  TRUE
          ELSE_IF [Q!NoteID]=3
            FLAG_SET [Flag],[NOTES_FLAG_INTERN],      TRUE
          ELSE_IF [Q!NoteID]=4
            FLAG_SET [Flag],[NOTES_FLAG_DEMAND],      TRUE
          ELSE_IF [Q!NoteID]>4
            FLAG_SET [Flag],[NOTES_FLAG_FREE_TEXT],   TRUE
          END_IF

          IF [Flag]<>[Rel!RecFlag]
            ; Die RecFlag wurde verndert, also muss diese nderung
            ; zurck in den Datensatz geschrieben werden.
            QUERY [Rel]
              UPDATE [Q!TableName]
                 SET RecFlag  = [Flag]
               WHERE RecordID = [Q!RelRecID|R0,0]
            END_QUERY
            EXECUTE [Rel],[Res]

            IF [DelUnused]
              QUERY [Rel]
                UPDATE notes
                   SET EventFlag =  0
                 WHERE RelRecID  =  [Q!RelRecID|R0,0]
                   AND TableName = "[Q!TableName]"
              END_QUERY
              EXECUTE [Rel],[Res]
            END_IF
          END_IF
        END_IF
      END_IF

      GET_DATA [Q],[Res]
    END_WHILE

    IF [DelUnused]
      ; Jetzt die unbenutzten Datenstze lschen...
      QUERY [Rel]
        DELETE
          FROM notes
         WHERE EventFlag = 1
      END_QUERY
      EXECUTE [Rel],[Res]
    END_IF

    END_WAIT


    ; Durch die Dokumenten-Ordner gehen und die RecFlag der zugeordneten Datenstze setzten.
    WAIT_INFO 'Bitte warten...', 'Die Dokumente werden geladen...'

    QUERY [Q]
        SELECT TableName, RelRecID
          FROM docmgrh
         WHERE RecordID  > 1000
           AND RelRecID  > 0
      GROUP BY TableName, RelRecID
      ORDER BY TableName, RelRecID
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Laden aller Dokumenten-Ordner konnte nicht ausgefhrt werden.'
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      END_WAIT
      MESSAGE 'Achtung Abbruch','Es sind keine Daten in der Dokumenten-Ordner-Tabelle.'
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]
    CALC [Cnt] As 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Inf] AS CON('Dokument ',[Max],' / ',[Cnt])
      WAIT_INFO 'Bitte warten...', [Inf]

      ; Aktuelle RecFlag des Datensatzes holen (diese knnte ja schon
      ; bei einer zuvor gefundenen Notiz oder einem zuvor gefundenen
      ; Dokumenten-Ordner verndert worden sein).
      QUERY [Rel]
        SELECT RecFlag
          FROM [Q!TableName]
         WHERE RecordID = [Q!RelRecID|R0,0]
      END_QUERY

      EXECUTE [Rel],[Res]
      IF [Res]
        GET_DATA [Rel],[Res]
        IF [Res]
          CALC [Flag] AS [Rel!RecFlag]

          ; Flagge verndern (wenn ntig).
          FLAG_SET [Flag],8192,TRUE

          IF [Flag]<>[Rel!RecFlag]
            ; Die RecFlag wurde verndert, also muss diese nderung
            ; zurck in den Datensatz geschrieben werden.
            QUERY [Rel]
              UPDATE [Q!TableName]
                 SET RecFlag  = [Flag]
               WHERE RecordID = [Q!RelRecID|R0,0]
            END_QUERY
            EXECUTE [Rel],[Res]

            IF [DelUnused]
              QUERY [Rel]
                UPDATE docmgrh
                   SET EventFlag =  0
                 WHERE RelRecID  =  [Q!RelRecID|R0,0]
                   AND TableName = "[Q!TableName]"
              END_QUERY
              EXECUTE [Rel],[Res]
            END_IF
          END_IF
        END_IF
      END_IF

      GET_DATA [Q],[Res]
    END_WHILE

    IF [DelUnused]
      ; Jetzt die unbenutzten Datenstze lschen...

      ; !!!!!! WICHTIG !!!!!!! Die Reihenfolge der folgenden Querys ist WICHTIG!

      ; Diese Abfrage knnte z.B. auf einm MS-SQL-Server fehlschlagen
      IF [SQL_VENDOR]='MSSQL'
        QUERY [Rel]
          UPDATE docmgri I
             SET I.EventFlag = 0
            FROM docmgri I, docmgrh H
           WHERE I.HeaderID  = H.RecordID
        END_QUERY
        EXECUTE [Rel],[Res]
      ELSE
        QUERY [Rel]
          UPDATE docmgri I, docmgrh H
             SET I.EventFlag =  0
           WHERE I.HeaderID  = H.RecordID
        END_QUERY
        EXECUTE [Rel],[Res]
      END_IF

      IF [Res]
        QUERY [Rel]
          DELETE
            FROM docmgri
           WHERE EventFlag = 1
        END_QUERY
        EXECUTE [Rel],[Res]
      END_IF

      QUERY [Rel]
        DELETE
          FROM docmgrh
         WHERE EventFlag = 1
      END_QUERY
      EXECUTE [Rel],[Res]
    END_IF

    END_WAIT
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
  CALC [ACT_MANDANT] AS [MandBuf]
SCRIPT_END
