
  PROCEDURE InitVars
    ; ************************************
    ; ***  CONFIGURATION  ****  START  ***
    ; ************************************

    ; Were are the data-file(s)
    VAR_STR    Path2Data, [PRINTSET_PATH]

    ; Path2Data MUST have a backslash at the end
    FILE_SLASH [Path2Data], TRUE

    ; Wildcards in the filename are allowed, so lists of files may be imported
    ; The import-files should always be in the PRINTSET-folder.
    VAR_LIST   FileList
    FILE_LIST [FileList], 'XXXXXXXXX.csv', [Path2Data], FALSE, FALSE, FALSE, TRUE

    ; How many headlines does the import-file(s) have
    VAR_NUM    Headlines, 1

    ; Shall the import-files be deleted after they have been processed?
    VAR_BOOL   DeleteImportFiles, FALSE

    ; How are the data fields seperated ? exaples: ';' or '";' or ',' etc.
    VAR_STR    DataDelim, ';'

    ; ************************************
    ; ***  CONFIGURATION  ****  END    ***
    ; ************************************


    VAR_NUM    FLnCnt
    VAR_NUM    FLnMax


    VAR_STR    FileName

    VAR_STR    CRLF
    CALC [CRLF] AS CHAR(#13#10)

    VAR_STR    AFilter
    CALC [AFilter] AS ''

    VAR_STR    CFGDateiName
    CALC [CFGDateiName] AS CON([SPECIAL_PATH],'ideal.cfg')

    VAR_FLOAT  UPSPackID
    VAR_NUM    TmpNum
    VAR_FLOAT  TmpFloat

    VAR_DATE   DefDate, 01.01.1980
    VAR_TIME   DefTime, 00:00:00

    VAR_STR    Str
    VAR_STR    StrWithLineFeed
    VAR_STR    Swp
    VAR_STR    InfStr
    VAR_BOOL   Res
    VAR_BOOL   Dummy
    VAR_BOOL   CRLFFound
    VAR_NUM    Cnt
    VAR_NUM    RealCnt
    VAR_NUM    SPos
    VAR_QUERY  Q
    VAR_STREAM Stream

    ; Variables and Types of the CSV-Fields in the Headerrow
    VAR_STR    Field1
    VAR_NUM    Field2
    ; etc
  END_PROC


  PROCEDURE ReadWord VS RW.Var, VN RW.Type
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    CALC [StrWithLineFeed] AS ''
    BACK_MARK

    FILE_READ [Stream],[Str],[Res],1,[AFilter],[DataDelim],[CRLF]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    IF [Str]<>''
      CALC [Str] AS REPLACE([Str],[DataDelim],'')
      IF [Str]<>''
        CALC [Str] AS REPLACE([Str],'"','')
      END_IF
    END_IF

    CALC [SPos] AS POS([CRLF],[Str])
    IF [SPos]>0
      CALC [CRLFFound] AS TRUE

      CALC [Str] AS REPLACE([Str],[CRLF],' ')

      IF [StrWithLineFeed]=''
        CALC [Swp] AS COPY([Str],1,1)
      ELSE
        CALC [Swp] AS COPY([StrWithLineFeed],1,1)
      END_IF
      IF [Swp]='"'
        CALC [Swp]  AS TRIM([Str])
        CALC [SPos] AS  LEN([Swp])
        CALC [Swp]  AS COPY([Swp],[SPos],1)
        IF [Swp]<>'"'
          CALC [StrWithLineFeed] AS CON([StrWithLineFeed],[Str])
          CALC [CRLFFound] AS FALSE
          BACK_JUMP
        ELSE
          CALC [Str] AS CON([StrWithLineFeed],[Str])
        END_IF
      END_IF
    END_IF

    IF [Str]<>''
      CALC [Str] AS REPLACE([Str],'"','')
      CALC [Str] AS TRIM([Str])
    END_IF

    IF [RW.Type]=[SCRIPT_BOOLEAN]
      IF [Str]='0'
        CALC [[RW.Var]] AS FALSE
      ELSE_IF [Str]='N'
        CALC [[RW.Var]] AS FALSE
      ELSE_IF [Str]=''
        CALC [[RW.Var]] AS FALSE
      ELSE
        CALC [[RW.Var]] AS TRUE
      END_IF
    ELSE_IF [RW.Type]=[SCRIPT_NUM]
      IF [Str]<>''
        CALC [Str] AS REPLACE([Str],',','.')
      END_IF
      CALC [[RW.Var]] AS VAL([Str])
    ELSE_IF [RW.Type]=[SCRIPT_FLOAT]
      IF [Str]<>''
        CALC [Str] AS REPLACE([Str],',','.')
      END_IF
      CALC [[RW.Var]] AS VAL([Str])
    ELSE_IF [RW.Type]=[SCRIPT_DATE]
      CALC [Str] AS PART([Str],1,' ')
      CALC [[RW.Var]] AS [Str]
    ELSE_IF [RW.Type]=[SCRIPT_TIME]
      CALC [Str] AS PART([Str],2,' ')
      CALC [Str] AS CON([Str],':00')
      CALC [[RW.Var]] AS [Str]
    ELSE
      CALC [[RW.Var]] AS [Str]
    END_IF
  END_PROC


  PROCEDURE IntRecord
    CALC [CRLFFound] AS FALSE

    CALC [Field1] AS ''
    CALC [Field2] AS 0
    ;usw.
  END_PROC


  PROCEDURE ReadLine VB LocCheckData
    CALL IntRecord

    CALL ReadWord 'Field1',   [SCRIPT_STRING]
    IF [LocCheckData]
      ; Do the checing here - if the data may be ok or not:
      ; e.g. the first field should always have 5 digits - otherwise stop!

    END_IF

    CALL ReadWord 'Field2',   [SCRIPT_NUM]
    ; usw.



    ; If a line ends with an DataDelim, the CRLF has still to be fetched
    IF [Res]
      WHILE [CRLFFound]=FALSE
        CALL ReadWord 'InfStr',      [SCRIPT_STRING]
      END_WHILE
    END_IF
  END_PROC



  PROCEDURE SaveData
    ; Do soemething with the data-record

  END_PROC



  PROCEDURE Main
    CALC [FLnCnt] AS 1
    LIST_ITEM_GET [FileList],[FLnCnt],[FLnMax]
    CALC [FLnCnt] AS 1

    IF [FLnMax]=0
      MESSAGE 'Abbruch','Es sind keine importierbare Dateien vorhanden'
      EXIT_PROC
    END_IF

    WHILE [FLnCnt]<=[FLnMax]
      LIST_STR_GET [FileList],[FileName],[FLnCnt]

      CALC [FileName] AS CON([Path2Data],[FileName])

      FILE_OPEN [Stream],[FileName],[FILE_OPEN_IN],[res]
      IF [Res]=FALSE
        CALC [Str] AS CON('Die Datei "',[FileName],'" konnte nicht geffnet werden')
        MESSAGE 'Abbruch',[Str]
        EXIT_PROC
      END_IF

      CALC [InfStr] AS CON('Datei ', [FLnCnt],' / ',[FLnMax])
      WAIT_INFO 'Bitte warten...',[InfStr],FALSE,60,3

      IF [Headlines]>0
        CALC [Cnt] AS 0
        WHILE [Cnt]<=[Headlines]
          INC [Cnt]

          CALC [InfStr] AS CON('Datei ', [FLnCnt],' / ',[FLnMax],[CRLF],'Kopfzeile ',[Cnt],' / ',[Headlines])
          WAIT_INFO 'Bitte warten...',[InfStr],FALSE,60,3

          CALL ReadLine FALSE
        END_WHILE
      END_IF

      CALC [Cnt]     AS 0
      CALC [RealCnt] AS 0

      WHILE [Res]
        INC  [Cnt]

        CALC [InfStr] AS CON('Datei ', [FLnCnt],' / ',[FLnMax],[CRLF],'Zeile ',[Cnt])
        WAIT_INFO 'Bitte warten...',[InfStr],FALSE,60,3

        CALL ReadLine TRUE
        IF [Res]
          INC  [RealCnt]
          CALL SaveData
        ELSE
          FILE_CLOSE  [Stream]
          IF [DeleteImportFiles]
            FILE_DELETE [Res], [FileName]
          END_IF
          CALC [Res] AS FALSE
        END_IF
      END_WHILE

      INC [FLnCnt]
    END_WHILE

    END_WAIT

    MESSAGE 'Information','Der Import wurde durchgefhrt'
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
