DROP TABLE [SQL_IF_EXISTS] tsclock;

CREATE TABLE tsclock
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      PreDate                   [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      PreTime                   [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      PreIsSummer               [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      PostDate                  [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      PostTime                  [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      PostIsSummer              [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      CorrectionMins            [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END]
      [SQL_DEFINE_PRIMARY_KEY2]
    );

CREATE UNIQUE INDEX IndTSCRecordID ON tsclock (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndTSCPreDate  ON tsclock (PreDate);
CREATE        INDEX IndTSCPreTime  ON tsclock (PreTime);
CREATE        INDEX IndTSCPostDate ON tsclock (PostDate);
CREATE        INDEX IndTSCPostTime ON tsclock (PostTime);

NEW_RECORD tsclock 0;

