DROP TABLE [SQL_IF_EXISTS] tsmdata;

CREATE TABLE tsmdata
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      MitIdx                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      CardIdx                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      DisplayName               [SQL_DEFINE_STRING]   ( 16) [SQL_DEFINE_STRING_END],
      MitStatus                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      Active                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],     /* 0 = TimeScan saved it last, 1 = TimeScan has to set it */
      MinActual                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      MinLeft                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      RestholiDays              [SQL_DEFINE_FLOAT]          [SQL_DEFINE_FLOAT_END],
      Birthday                  [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      InfoStr1                  [SQL_DEFINE_STRING]   ( 16) [SQL_DEFINE_STRING_END],
      InfoStr2                  [SQL_DEFINE_STRING]   ( 16) [SQL_DEFINE_STRING_END]
      [SQL_DEFINE_PRIMARY_KEY2]
    );


CREATE UNIQUE INDEX IndTSMDRecordID    ON tsmdata (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE UNIQUE INDEX IndTSMDMitIdx      ON tsmdata (MitIdx);
CREATE UNIQUE INDEX IndTSMDCardIdx     ON tsmdata (CardIdx);
CREATE        INDEX IndTSMDDisplayName ON tsmdata (DisplayName);
CREATE        INDEX IndTSMDMitStatus   ON tsmdata (MitStatus);
CREATE        INDEX IndTSMDActive      ON tsmdata (Active);

NEW_RECORD tsmdata 0;
    UPDATE tsmdata
       SET MitIdx   = 999999999,
           CardIdx  = 999999999
     WHERE RecordID = 0;


/*  *** START ***********+ Test data only
NEW_RECORD tsmdata 7877648475531;
    UPDATE tsmdata
       SET MitIdx      = 2,
           CardIdx     = 33120,
           DisplayName = "TS-Test"
     WHERE RecordID    = 7877648475531;
  *** STOP ************+ Test data only */


