DROP TABLE [SQL_IF_EXISTS] tsvdata;

CREATE TABLE tsvdata
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VDate                     [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      VTime                     [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      Station                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      Action                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      ASCIIData                 [SQL_DEFINE_STRING]   ( 81) [SQL_DEFINE_STRING_END],
      ProjectIdx                [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      TaskIdx                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      MachineIdx                [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      FreeIdx                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      MitIdx                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      InfoIdx                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      SummerTime                [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      Active                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END]
      [SQL_DEFINE_PRIMARY_KEY2]
    );

CREATE UNIQUE INDEX IndTSVDRecordID   ON tsvdata (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndTSVDVDate      ON tsvdata (VDate);
CREATE        INDEX IndTSVDVTime      ON tsvdata (VTime);
CREATE        INDEX IndTSVDStation    ON tsvdata (Station);
CREATE        INDEX IndTSVDAction     ON tsvdata (Action);
CREATE        INDEX IndTSVDASCIIData  ON tsvdata (ASCIIData);
CREATE        INDEX IndTSVDProjectIdx ON tsvdata (ProjectIdx);
CREATE        INDEX IndTSVDTaskIdx    ON tsvdata (TaskIdx);
CREATE        INDEX IndTSVDMachineIdx ON tsvdata (MachineIdx);
CREATE        INDEX IndTSVDFreeIdx    ON tsvdata (FreeIdx);
CREATE        INDEX IndTSVDMitIdx     ON tsvdata (MitIdx);
CREATE        INDEX IndTSVDInfoIdx    ON tsvdata (InfoIdx);
CREATE        INDEX IndTSVDActive     ON tsvdata (Active);

NEW_RECORD tsvdata 0;

