
  PROCEDURE InitVars
    VAR_BOOL  Result
    VAR_DATE  CheckDate
    VAR_DATE  ADate
    VAR_TIME  ATime
    VAR_FLOAT NextPID
    VAR_QUERY SQ
    VAR_STR   TmpStr
    VAR_STR   InfStr

    CALC [ADate] AS [DATE]
    CALC [ATime] AS [TIME] - 60
    DATE_TIME_2_REC_ID [ADate],[ATime],[NextPID]
  END_PROC


  PROCEDURE CheckMahnungen
    QUERY [SQ]
      SELECT R.RechnungsNummer, R.Datum, R.Brutto, R.gezahlt, K.Name1, K.Name2, R.KundenID, R.RecordID
        FROM Rechnung R, Adressen K
       WHERE R.KundenID    = K.RECORDID
         AND R.Kennung     = "R"
         AND R.Aktiv       = 2
         AND R.MahnDatum1 <= [SQL_DATE_QUOTES_4_SELECT][DATE|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND R.Mahnen      = -1
    END_QUERY

    EXECUTE [SQ],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Mahnungstermine konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ],[Result]
    WHILE [Result]
      CALC [TmpStr] AS [SQ!R.Datum]
      CALC [InfStr] AS [SQ!R.Brutto|R0,2]
      CALC [InfStr] AS EXT([InfStr],12,32,2,2)
      CALC [TmpStr] AS CON('MAHNUNG ',[SQ!R.RechnungsNummer],' vom ',[TmpStr],' Brutto ',[InfStr])

      ITEM_2_USER_TIMER [Result], [SQ!R.RecordID], [NextPID], [ADate], [ATime], [TmpStr], [SQ!K.Name1], [SQ!K.Name2], 'rechnung', 'WorkOutTimer.csh'

      IF [Result]=FALSE
        MESSAGE 'Achtung','Ein Termin-Item konnte nicht in die Timer-Liste aufgenommen werden'
      END_IF

      GET_DATA [SQ],[Result]
    END_WHILE
  END_PROC


  PROCEDURE CheckKommi
    CALC [CheckDate] AS [DATE]-60

    QUERY [SQ]
      SELECT DISTINCT A.RecordID, A.Auftragsnummer, K.Name1, K.Name2, A.Lieferdatum1, A.Auftragsdatum, A.Brutto
        FROM Posten P, Auftrag A, Adressen K
       WHERE P.AuftragID     = A.RecordID
         AND P.RechnungID   <= 0
         AND A.FertByte      = 0
         AND A.KundenID      = K.RecordID
         AND A.Aktiv        <  99
         AND A.Lieferdatum1 <= [SQL_DATE_QUOTES_4_SELECT][CheckDate|R0,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
    END_QUERY

    EXECUTE [SQ],[Result]
    IF [Result]=FALSE
      MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Kommissionstermine konnte nicht ausgefhrt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ],[Result]
    WHILE [Result]
      CALC [TmpStr] AS [SQ!A.LieferDatum1]
      CALC [InfStr] AS [SQ!A.Brutto|R0,2]
      CALC [InfStr] AS EXT([InfStr],12,32,2,2)
      CALC [TmpStr] AS CON('KOMMI ',[SQ!A.AuftragsNummer],' vom ',[TmpStr],' Brutto ',[InfStr])

      ITEM_2_USER_TIMER [Result], [SQ!DISTINCTA.RecordID], [NextPID], [ADate], [ATime], [TmpStr], [SQ!K.Name1], [SQ!K.Name2], 'auftrag', 'WorkOutTimer.csh'

      IF [Result]=FALSE
        MESSAGE 'Achtung','Ein Termin-Item konnte nicht in die Timer-Liste aufgenommen werden'
      END_IF

      GET_DATA [SQ],[Result]
    END_WHILE
  END_PROC


  PROCEDURE Main
    CALL CheckMahnungen
    CALL CheckKommi
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END


