  ; ghw: Sortierung nach Gruppe, PersonalNr
  ;                      Gruppe, Name1
  ;                      PersonalNr
  ;                      Name1
  ; Fixierung mit Name und berschrift, nicht nur berschrift


  INCLUDE xml2xls_tools.inc
    ; importiert PROCEDURE XMLReadParameter
    ; importiert PROCEDURE XMLOpenFile VS LocFileName, ~VB LocRes
    ; importiert PROCEDURE XMLCloseFile
    ; importiert PROCEDURE XMLDocumentHeader
    ; importiert PROCEDURE XMLDocumentFooter
    ; importiert PROCEDURE XMLOpenStyles
    ; importiert PROCEDURE XMLStyles VS LocFontType, VN LocTitleFSize, VN LocHeadlineFSize, VN LocNormalFSize
    ; importiert PROCEDURE XMLCloseStyles
    ; importiert PROCEDURE XMLOpenWorkSheet VS LocSheetName
    ; importiert PROCEDURE XMLCloseWorkSheet
    ; importiert PROCEDURE XMLWSOptions VN LocFixedLine
    ; importiert PROCEDURE XMLSetColWidth
    ; importiert PROCEDURE XMLOpenTable VN LocColCnt
    ; importiert PROCEDURE XMLCloseTable
    ; importiert PROCEDURE XMLOpenRow VS LocOptionStr
    ; importiert PROCEDURE XMLCloseRow
    ; importiert PROCEDURE XMLWriteTitle VS LocTitle, VN LocSpan
    ; importiert PROCEDURE XMLWriteCell VS LocContentStr, VS LocTypeStr, VS LocOptionStr
    ; importiert PROCEDURE XMLWriteSum VS LocContentStr, VN LocRowNo, VS LocStyleStr, VN LocColOffset



  PROCEDURE InitVars
    CONST_NUM KALENDER_FEIERTAG,  1
    CONST_NUM KALENDER_FERIEN,    2
    CONST_NUM KALENDER_URLAUB,    4
    CONST_NUM KALENDER_KRANK,     8
    CONST_NUM KALENDER_ABWESEND, 16

    VAR_LIST  RowList

    WAIT_CURSOR TRUE
    VAR_MASK WorkMask,'betriebskalender'
    WAIT_CURSOR FALSE

    CALC [WorkMask!MASK_HOOK_SHOW]   AS 'ShowHook'
    CALC [WorkMask!MASK_HOOK_BUTTON] AS 'ButtonHook'
  END_PROC



  PROCEDURE WriteHeader
    LOCAL_NUM   LocNum
    LOCAL_DATE  LocDate
    LOCAL_STR   LocStr

    CALL XMLOpenRow 'Index="3"'

    CALL XMLWriteCell '', '', [STYLE_HEADLINE]
    CALL XMLWriteCell '', '', [STYLE_HEADLINE]
    CALL XMLWriteCell '', '', [STYLE_HEADLINE]
    CALL XMLWriteCell '', '', [STYLE_HEADLINE]

    CALC [LocDate] AS [WorkMask!vonDatum]

    WHILE [LocDate]<=[WorkMask!bisDatum]
      DATE_2_WEEK_DAY [LocDate],[LocStr],TRUE

      CALL XMLWriteCell [LocStr], '', [STYLE_HEADLINE]

      CALC [LocDate] AS [LocDate]+1
    END_WHILE

    CALL XMLCloseRow

    CALC [LocDate] AS [WorkMask!vonDatum]

;    CALL XMLOpenRow 'Index="3"'

    CALL XMLOpenRow ''

    CALL XMLWriteCell 'PersonalNr',  '', [STYLE_HEADLINE]
    CALL XMLWriteCell 'Name',        '', [STYLE_HEADLINE]
    CALL XMLWriteCell 'Untergruppe', '', [STYLE_HEADLINE]
    CALL XMLWriteCell 'Kategorie',   '', [STYLE_HEADLINE]

    WHILE [LocDate]<=[WorkMask!bisDatum]
      CALC [LocStr] AS [LocDate|R0,dd.mm.]

      CALL XMLWriteCell [LocStr], '', [STYLE_HEADLINE]

      CALC [LocDate] AS [LocDate]+1
    END_WHILE

    CALL XMLCloseRow
  END_PROC



  PROCEDURE GetFeiertage
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocDay
    LOCAL_NUM   LocYear
    LOCAL_NUM   LocMonth
    LOCAL_DATE  LocDate
    LOCAL_STR   LocStr
    LOCAL_STR   LocStr1
    LOCAL_QUERY LocQ

    ; von bis Datum in Liste einlesen und ber LIST_STR_SET mit Index die Feiertage setzen,
    ; dann enthlt die RowList die Kopiervorlage

    LIST_CLR [RowList]

    CALC [LocDate] AS [WorkMask!vonDatum]
    WHILE [LocDate]<=[WorkMask!bisDatum]
      ; false Wochenende

      DATE_2_WEEK_DAY [LocDate],[LocStr1],TRUE
      ; 1.Buchstabe ein S, dann Wochenende, egal ob deutsch oder englisch
      CALC [LocStr1] AS COPY([LocStr1],1,1)
      CALC [LocStr1] AS UPCASE([LocStr1])

      CALC [LocStr] AS [LocDate|R0,dd.mm.yyyy]

      IF [LocStr1]='S'
        CALC [LocStr] AS CON([LocStr],'|W')
      ELSE
;        CALC [LocStr] AS CON([LocStr],'|N')
      END_IF

      LIST_APPEND [RowList], [LocStr]

      CALC [LocDate] AS [LocDate]+1
    END_WHILE

    QUERY [LocQ]
      SELECT Datum, Bezeichnung, ganz, halb, Aktiv
        FROM kalender
       WHERE Datum >= [SQL_DATE_QUOTES_4_SELECT][WorkMask!VonDatum|R8,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND Datum <= [SQL_DATE_QUOTES_4_SELECT][WorkMask!BisDatum|R8,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND Aktiv < 4
       ORDER BY Datum
    END_QUERY

    EXECUTE [LocQ],[LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Abbruch','Execute-Fehler in GetFeiertage',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    WHILE [LocRes]
      DATE_DIFF [WorkMask!vonDatum], [LocQ!Datum], [LocYear], [LocMonth], [LocDay], TRUE
      INC [LocDay]

      CALC [LocStr] AS [LocQ!Datum|R0,dd.mm.yyyy]

      IF [LocQ!ganz]
        CALC [LocStr] AS CON([LocStr],'|F')
      ELSE
        CALC [LocStr] AS CON([LocStr],'|f')
      END_IF

      LIST_STR_SET [RowList], [LocStr], [LocDay]

      GET_DATA [LocQ], [LocRes]
    END_WHILE
  END_PROC



  PROCEDURE WriteOneCell VS LocCellStr
    LOCAL_STR LocStr

    CALC [LocStr] AS UPCASE([LocCellStr])

    IF [LocStr]='W'
      ; Wochenende
      CALL XMLWriteCell '', '', 'CellStyleGray'
    ELSE_IF [LocStr]='F'
      ; Feiertag
      CALL XMLWriteCell '', '', 'CellStyleFeiertag'
    ELSE_IF [LocStr]='B'
      ; Betriebsferien
      CALL XMLWriteCell '', '', 'CellStyleFerien'
    ELSE_IF [LocStr]='U'
      ; Urlaub
      CALL XMLWriteCell [LocCellStr], '', 'CellStyleGreen'
    ELSE_IF [LocStr]='K'
      ; krank
      CALL XMLWriteCell [LocCellStr], '', 'CellStyleRed'
    ELSE_IF [LocStr]='A'
      ; abwesend
      CALL XMLWriteCell [LocCellStr], '', 'CellStyleDark'
    ELSE
      CALL XMLWriteCell '', '', ''
    END_IF
  END_PROC



  PROCEDURE GetOneMitarbeiter VF LocMitarbeiterID, VS LocPN, VS LocName, VS LocUntergruppe, VS LocKategorie
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocNum1
    LOCAL_NUM   LocNum2
    LOCAL_NUM   LocIndex
    LOCAL_STR   LocStr
    LOCAL_STR   LocStr1
    LOCAL_LIST  LocList
    LOCAL_QUERY LocQ

    LIST_CLR [LocList]

    LIST_2_LIST [RowList], [LocList], TRUE

    QUERY [LocQ]
      SELECT K.Datum, K.Bezeichnung, K.ganz, K.halb, K.Aktiv
        FROM kalender K
       WHERE K.MitarbeiterID = [LocMitarbeiterID|R0,0]
         AND K.Datum >= [SQL_DATE_QUOTES_4_SELECT][WorkMask!VonDatum|R8,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND K.Datum <= [SQL_DATE_QUOTES_4_SELECT][WorkMask!BisDatum|R8,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
         AND K.Aktiv > 3
    END_QUERY

    EXECUTE [LocQ], [LocRes]
    IF [LocRes]=FALSE
      MESSAGE 'Abbruch','Die Kalenderdaten konnte nicht gelesen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocRes]

    WHILE [LocRes]
      CALC [LocStr] AS [LocQ!K.Datum|R0,dd.mm.yyyy]

      IF [LocQ!K.Aktiv]=[KALENDER_FEIERTAG]
        CALC [LocStr1] AS 'f'
      ELSE_IF [LocQ!K.Aktiv]=[KALENDER_FERIEN]
        CALC [LocStr1] AS 'b'
      ELSE_IF [LocQ!K.Aktiv]=[KALENDER_URLAUB]
        CALC [LocStr1] AS 'u'
      ELSE_IF [LocQ!K.Aktiv]=[KALENDER_KRANK]
        CALC [LocStr1] AS 'k'
      ELSE_IF [LocQ!K.Aktiv]=[KALENDER_ABWESEND]
        CALC [LocStr1] AS 'a'
      END_IF

      IF [LocQ!K.ganz]
        CALC [LocStr1] AS UPCASE([LocStr1])
      END_IF

      CALC [LocStr] AS CON([LocStr],'|',[LocStr1])

      DATE_DIFF [WorkMask!vonDatum], [LocQ!K.Datum], [LocNum1], [LocNum2], [LocIndex], TRUE
      INC [LocIndex]

      LIST_STR_SET [LocList], [LocStr], [LocIndex]

      GET_DATA [LocQ], [LocRes]
    END_WHILE


    DATE_DIFF [WorkMask!vonDatum], [WorkMask!bisDatum], [LocNum1], [LocNum2], [LocIndex], TRUE
    INC [LocIndex]

    INC [XMLCntRows]

    CALL XMLOpenRow ''

    CALL XMLWriteCell [LocPN],          '', ''
    CALL XMLWriteCell [LocName],        '', ''
    CALL XMLWriteCell [LocUntergruppe], '', ''
    CALL XMLWriteCell [LocKategorie],   '', ''

    CALC [LocNum1] AS 1
    WHILE [LocNum1]<=[LocIndex]
      LIST_STR_GET [LocList],[LocStr], [LocNum1]
      CALC [LocStr] AS PART([LocStr],2,'|')

      CALL WriteOneCell [LocStr]

      INC [LocNum1]
    END_WHILE

    CALL XMLCloseRow
  END_PROC



	PROCEDURE WriteData
	  LOCAL_BOOL  LocRes
	  LOCAL_STR   LocStr
	  LOCAL_QUERY LocQ

    CALC [XMLCntRows] AS 0

    WAIT_INFO 'Bitte warten','Die Daten werden ausgegeben ...'

    CALL GetFeiertage

    CALC [LocStr] AS ''
    IF [WorkMask!MitarbeiterID]>[EPSILON]
      CALC [LocStr] AS CON(' AND A.RecordID = ',[WorkMask!MitarbeiterID|R0,0])
    END_IF

    IF [WorkMask!GruppenID]>[EPSILON]
      CALC [LocStr] AS CON([LocStr],' AND G.RecordID = ',[WorkMask!GruppenID|R0,0])
    END_IF

    IF [WorkMask!G.Untergruppe]<>''
      CALC [LocStr] AS CON([LocStr],' AND G.Untergruppe = "',[WorkMask!G.Untergruppe],'"')
    END_IF

    IF [WorkMask!G.Kategorie]<>''
      CALC [LocStr] AS CON([LocStr],' AND G.Kategorie = "',[WorkMask!G.Kategorie],'"')
    END_IF

    QUERY [LocQ]
      SELECT A.Personalnummer, A.Name1, A.Name2, A.RecordID,
             G.Untergruppe, G.Kategorie, G.RecordID
        FROM adressen A, gruppen G
       WHERE A.GruppenID = G.RecordID
             [LocStr]
         AND A.MAktiv > 0
         AND G.RecordID > 1000
       ORDER BY G.Untergruppe, G.Kategorie
    END_QUERY

    EXECUTE [LocQ],[LocRes]
    IF [LocRes]=FALSE
      END_WAIT
      MESSAGE 'Abbruch','Das Query konnte nicht compiliert werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocRes]
    IF [LocRes]=FALSE
      END_WAIT
      MESSAGE 'Abbruch','Es konnten keine Daten gefunden werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALL WriteHeader

    WHILE [LocRes]
      CALC [LocStr] AS CON([LocQ!A.Name1],',',[LocQ!A.Name2])
      CALL GetOneMitarbeiter [LocQ!A.RecordID], [LocQ!A.Personalnummer], [LocStr], [LocQ!G.Untergruppe], [LocQ!G.Kategorie]

      GET_DATA [LocQ],[LocRes]
    END_WHILE

;    CALL XMLOpenRow ''
;
;    ; anpassen
;    CALL XMLWriteSum '',  5, [STYLE_NUMBER_3NK_BOLD], [XMLCntRows]
;    CALL XMLWriteSum '', 11, [STYLE_NUMBER_0NK_BOLD], [XMLCntRows]
;    CALL XMLWriteSum '', 12, [STYLE_NUMBER_2NK_BOLD], [XMLCntRows]
;
;    CALL XMLCloseRow

    END_WAIT
  END_PROC



	PROCEDURE DoExport
	  LOCAL_BOOL  LocRes
	  LOCAL_NUM   LocNum
	  LOCAL_NUM   LocYear
	  LOCAL_NUM   LocMonth
	  LOCAL_STR   LocStr

    CALL XMLReadParameter

    CALC [XMLTitleSize]    AS 7
    CALC [XMLHeadlineSize] AS 7

    DATE_DIFF [WorkMask!vonDatum], [WorkMask!bisDatum], [LocYear], [LocMonth], [XMLColCnt], TRUE
    INC [XMLColCnt]

    CALC [XMLColCnt] AS [XMLColCnt]+4
      ; da 4 Spalten mehr wegen Personalnummer und Name, Untergruppe und Kategorie

		CALL XMLOpenFile [WorkMask!Exportname], [XMLRes]
		IF [XMLRes]=FALSE
			EXIT_PROC
		END_IF

    CALL XMLDocumentHeader

    CALL XMLOpenStyles
    CALL XMLStyles [XMLFont], [XMLTitleSize], [XMLHeadlineSize], [XMLNormalSize], [XMLTitleColor], [XMLCellColor], [XMLBackColor]
    CALL XMLAddOneStyle 'CellStyleRed',      0, 'Center', FALSE, 'FF0000'
    CALL XMLAddOneStyle 'CellStyleGray',     0, 'Center', FALSE, 'DDDDDD'
    CALL XMLAddOneStyle 'CellStyleGreen',    0, 'Center', FALSE, '00FF00'
    CALL XMLAddOneStyle 'CellStyleDark',     0, 'Center', FALSE, '999999'
    CALL XMLAddOneStyle 'CellStyleFeiertag', 0, 'Center', FALSE, 'FFFF00'
    CALL XMLAddOneStyle 'CellStyleFerien',   0, 'Center', FALSE, 'AAFF33'
    CALL XMLCloseStyles

    ; anpassen
    CALL XMLOpenWorkSheet 'Kalender'

    CALL XMLOpenTable [XMLColCnt]

    CALC [LocStr] AS CON('   <Column ss:Width="80"/>')
    IF [XMLListUse]
      LIST_APPEND [XMLList], [LocStr]
    ELSE
      FILE_WRITE [XMLData], [LocStr], [LocRes]
      FILE_WRITE [XMLData], [CRLF],   [LocRes]
    END_IF

    CALC [LocStr] AS CON('   <Column ss:Width="120"/>')
    IF [XMLListUse]
      LIST_APPEND [XMLList], [LocStr]
    ELSE
      FILE_WRITE [XMLData], [LocStr], [LocRes]
      FILE_WRITE [XMLData], [CRLF],   [LocRes]
    END_IF

    CALC [LocStr] AS CON('   <Column ss:Width="100"/>')
    IF [XMLListUse]
      LIST_APPEND [XMLList], [LocStr]
    ELSE
      FILE_WRITE [XMLData], [LocStr], [LocRes]
      FILE_WRITE [XMLData], [CRLF],   [LocRes]
    END_IF

    CALC [LocStr] AS CON('   <Column ss:Width="100"/>')
    IF [XMLListUse]
      LIST_APPEND [XMLList], [LocStr]
    ELSE
      FILE_WRITE [XMLData], [LocStr], [LocRes]
      FILE_WRITE [XMLData], [CRLF],   [LocRes]
    END_IF

    CALC [LocYear] AS [XMLColCnt]-4
    CALC [LocNum] AS 1
    WHILE [LocNum]<=[LocYear]
      CALC [LocStr] AS CON('   <Column ss:Width="30"/>')
      IF [XMLListUse]
        LIST_APPEND [XMLList], [LocStr]
      ELSE
        FILE_WRITE [XMLData], [LocStr], [LocRes]
        FILE_WRITE [XMLData], [CRLF], [LocRes]
      END_IF

      INC [LocNum]
    END_WHILE


    ; anpassen
    CALC [LocStr] AS CON('Kalender ',[WorkMask!VonDatum],' bis ',[WorkMask!BisDatum])

    CALL XMLWriteTitle [LocStr], [XMLColCnt]

    CALL WriteData

    CALL XMLCloseTable

    CALL XMLWSOptions 4, 4

    CALL XMLCloseWorkSheet

    CALL XMLDocumentFooter

		CALL XMLCloseFile

    IF [XMLCntRows]<=0
      EXIT_PROC
    END_IF

    ;SHELL_EXECUTE 'open', [WorkMask!Exportname],'','',[EXTERN_SHOWNORMAL]
    SHELL_EXECUTE '', [WorkMask!Exportname],'','',[EXTERN_SHOWNORMAL]
	END_PROC



  PROCEDURE OpenExportFile
    LOCAL_BOOL  LocRes
    LOCAL_STR   LocStr

    CALC [LocStr] AS '*.xml'
    CHOOSE_FILE [LocStr],[CHOOSE_FILE_4_OPEN],'Bitte geben Sie den Dateinamen fr den Export an','xml-Dateien (*.xml)|Alle Dateien (*.*)|*.*',[LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [WorkMask!ExportName] AS [LocStr]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE ShowChoicer VN LocListNo, VS LocTargetFld
    LOCAL_BOOL    LocRes
    LOCAL_STR     LocStr
    LOCAL_BROWSER LocSB

    QUERY [LocSB]
      SELECT Sortierung, Auswahl
        FROM choicer
       WHERE Listenummer = [LocListNo]
         AND Sortierung > 0
       ORDER BY Sortierung
     STARTING WITH Auswahl = "[WorkMask![LocTargetFld]]"
    END_QUERY

    VIEW [LocSB], [LocRes], 'Auswahl'
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [WorkMask![LocTargetFld]]  AS [LocSB!Auswahl]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE ShowMitarbeiter
    LOCAL_BOOL    LocRes
    LOCAL_BROWSER LocSB

    QUERY [LocSB]
      SELECT Personalnummer, Name1, Name2, Telefon1, [H]RecordID
        FROM adressen
       WHERE MAktiv > 0
       ORDER BY Name1, Name2, Personalnummer
    END_QUERY

    VIEW [LocSB], [LocRes], 'Mitarbeiter'
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [WorkMask!A.Name1]          AS [LocSB!Name1]
    CALC [WorkMask!A.Name2]          AS [LocSB!Name2]
    CALC [WorkMask!MitarbeiterID]    AS [LocSB!RecordID]
    CALC [WorkMask!A.Personalnummer] AS [LocSB!Personalnummer]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE ShowGruppe
    LOCAL_BOOL    LocRes
    LOCAL_BROWSER LocSB

    QUERY [LocSB]
      SELECT Nummer, Typ, Untergruppe, Kategorie, Bezeichnung1, Bezeichnung2, Aktiv, RecordID, RecFlag
        FROM gruppen
       WHERE Aktiv = 1
      ORDER BY Nummer
    END_QUERY

    VIEW [LocSB], [LocRes], 'Gruppen'
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [WorkMask!G.Nummer]       AS [LocSB!Nummer]
    CALC [WorkMask!G.Bezeichnung1] AS [LocSB!Bezeichnung1]
    CALC [WorkMask!GruppenID]      AS [LocSB!RecordID]
    MASK_UPDATE [WorkMask]
  END_PROC



  PROCEDURE ButtonHook
    IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_FILENAME'
      CALL OpenExportFile
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_EXPORT'
      CALL DoExport
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_PERSONAL'
      CALL ShowMitarbeiter
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_GRUPPE'
      CALL ShowGruppe
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_UNTERGRUPPE'
      CALL ShowChoicer 282001, 'G.Untergruppe'
    ELSE_IF [WorkMask!MASK_ACT_FIELD_NAME]='BB_KATEGORIE'
      CALL ShowChoicer 282002, 'G.Kategorie'
    END_IF
  END_PROC



  PROCEDURE ShowHook
    LOCAL_NUM  LocDay
    LOCAL_NUM  LocYear
    LOCAL_NUM  LocMonth
    LOCAL_DATE LocDate
    LOCAL_STR  LocStr

    CALC [LocDate] AS [DATE]
    DATE_2_DMY [LocDate],[LocDay],[LocMonth],[LocYear]
    DEC [LocDay]

    CALC [LocDate] AS [LocDate]-[LocDay]

    CALC [LocStr] AS CON([DOCUMENT_PATH],'kalender_',[SHORT_NAME],'.xml')

    CALC [WorkMask!VonDatum]   AS [LocDate]
    CALC [WorkMask!Exportname] AS [LocStr]
    MASK_UPDATE [WorkMask]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars

  MASK_PROCESS [WorkMask]
SCRIPT_END


