; Diese Library wurde von Gerald Heyer entwickelt und ist sehr schnell und leicht fr den Excel-Export verwendbar. DD 25.07.2007


;       Spaltenbreite
;           Ziffern       Anzahl Zeichen    pixel       pt      Breite im xlm     Breite / Anzahl Zeichen
;           0-9 => 70     10                77          10,29   57.5
;           0-9           40                293         41,14   219.75
;
;       Borders
;       Headline-Orientierung
;
; ghw: Verweise in andere Tabellen, borders ?

; Interessante links
;http://msdn2.microsoft.com/en-us/library/aa140062(office.10).aspx
;http://en.wikipedia.org/wiki/Microsoft_Office_XML_formats
;http://en.wikipedia.org/wiki/Office_Open_XML



  PROCEDURE XMLReadParameter
    LOCAL_BOOL  LocRes
    LOCAL_STR   LocStr
    LOCAL_NUM   LocNum


    IDENTIFIER_EXIST 'XMLCaraVersionIsOk',[LocRes]
    IF [LocRes]=FALSE
      VAR_BOOL XMLCaraVersionIsOk, FALSE

      ; Mindestens 9.01.13, sonst gibt es dir Berechnungsmethode CALC [S] AS A2HTML([S]) nicht.
      ; Der Versions-String sieht etwa so aus "9.01.13 -  SQL:MySQL - LL:NO - DocuWare:NO - Syska:NO - TS:YES - CTI:NO - EE:YES"
      CALC [LocStr] AS PART([CARA_VERSION],1,'.')
      CALC [LocNum] AS  VAL([LocStr])
; vdw: 27.05.2008
      IF [LocNum]>9
        CALC [XMLCaraVersionIsOk] AS TRUE
; vdw: 27.05.2008-
      ELSE_IF [LocNum]=9
        CALC [LocStr] AS PART([CARA_VERSION],2,'.')
        CALC [LocNum] AS  VAL([LocStr])
; vdw: 27.05.2008
        IF [LocNum]>1
          CALC [XMLCaraVersionIsOk] AS TRUE
; vdw: 27.05.2008-
        ELSE_IF [LocNum]=1
          CALC [LocStr] AS PART([CARA_VERSION],3,'.')
          CALC [LocStr] AS PART([LocStr],1,' ')
          CALC [LocNum] AS  VAL([LocStr])
          IF [LocNum]>=13
            CALC [XMLCaraVersionIsOk] AS TRUE
          END_IF
        END_IF
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLList',[LocRes]
    IF [LocRes]=FALSE
      VAR_LIST XMLList
    END_IF

    IDENTIFIER_EXIST 'XMLFont',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR XMLFont
      INI_READ [LocRes], [XMLFont],  [SCRIPT_STRING],  [CONFIG_FILE], 'XML_FONT', 'Allgemein'
      IF [XMLFont]=''
        CALC [XMLFont] AS 'Arial'
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLTitleSize',[LocRes]
    IF [LocRes]=FALSE
      VAR_NUM XMLTitleSize
      INI_READ [LocRes], [XMLTitleSize],  [SCRIPT_NUM],  [CONFIG_FILE], 'XML_TITLE_SIZE', 'Allgemein'
      IF [XMLTitleSize]<=4
        CALC [XMLTitleSize] AS 12
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLHeadlineSize',[LocRes]
    IF [LocRes]=FALSE
      VAR_NUM XMLHeadlineSize
      INI_READ [LocRes], [XMLHeadlineSize],  [SCRIPT_NUM],  [CONFIG_FILE], 'XML_HEADLINE_SIZE', 'Allgemein'
      IF [XMLHeadlineSize]<=4
        CALC [XMLHeadlineSize] AS 10
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLNormalSize',[LocRes]
    IF [LocRes]=FALSE
      VAR_NUM XMLNormalSize
      INI_READ [LocRes], [XMLNormalSize],  [SCRIPT_NUM],  [CONFIG_FILE], 'XML_NORMAL_SIZE', 'Allgemein'
      IF [XMLNormalSize]<=4
        CALC [XMLNormalSize] AS 10
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLTitleColor',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR XMLTitleColor
      INI_READ [LocRes], [XMLTitleColor],  [SCRIPT_STRING],  [CONFIG_FILE], 'XML_TITLE_COLOR', 'Allgemein'
      IF [XMLTitleColor]=''
        CALC [XMLTitleColor] AS '000000'
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLCellColor',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR XMLCellColor
      INI_READ [LocRes], [XMLCellColor],  [SCRIPT_STRING],  [CONFIG_FILE], 'XML_CELL_COLOR', 'Allgemein'
      IF [XMLCellColor]=''
        CALC [XMLCellColor] AS '000000'
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLBackColor',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR XMLBackColor
      INI_READ [LocRes], [XMLBackColor],  [SCRIPT_STRING],  [CONFIG_FILE], 'XML_BACK_COLOR', 'Allgemein'
      IF [XMLBackColor]=''
        CALC [XMLBackColor] AS 'FFCC99'
      END_IF
    END_IF

    IDENTIFIER_EXIST 'XMLRes',[LocRes]
    IF [LocRes]=FALSE
      VAR_BOOL XMLRes
    END_IF

    IDENTIFIER_EXIST 'XMLColCnt',[LocRes]
    IF [LocRes]=FALSE
  	  VAR_NUM   XMLColCnt
  	    ; Anzahl der Spalten
    END_IF

    IDENTIFIER_EXIST 'XMLCntRows',[LocRes]
    IF [LocRes]=FALSE
      VAR_NUM   XMLCntRows
        ; Anzahl der geschriebenen Zeilen (fr Summenbildung)
    END_IF
  END_PROC



  PROCEDURE XMLOpenFile VS LocFileName, ~VB LocRes
    IDENTIFIER_EXIST 'CRLF',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   CRLF
    END_IF

    CALC [CRLF] AS CHAR(#13#10)

    IDENTIFIER_EXIST 'STYLE_HEADLINE',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_HEADLINE
    END_IF
    CALC [STYLE_HEADLINE] AS 'StyleHeadline'

    IDENTIFIER_EXIST 'STYLE_NUMBER_0NK',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_0NK
    END_IF
    CALC [STYLE_NUMBER_0NK] AS 'StyleNumberNK0'

    IDENTIFIER_EXIST 'STYLE_NUMBER_2NK',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_2NK
    END_IF
    CALC [STYLE_NUMBER_2NK] AS 'StyleNumberNK2'

    IDENTIFIER_EXIST 'STYLE_NUMBER_3NK',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_3NK
    END_IF
    CALC [STYLE_NUMBER_3NK] AS 'StyleNumberNK3'

    IDENTIFIER_EXIST 'STYLE_NUMBER_5NK',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_5NK
    END_IF
    CALC [STYLE_NUMBER_5NK] AS 'StyleNumberNK5'

    IDENTIFIER_EXIST 'STYLE_NUMBER_0NK_BOLD',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_0NK_BOLD
    END_IF
    CALC [STYLE_NUMBER_0NK_BOLD] AS 'StyleNumberNK0Bold'

    IDENTIFIER_EXIST 'STYLE_NUMBER_2NK_BOLD',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_2NK_BOLD
    END_IF
    CALC [STYLE_NUMBER_2NK_BOLD] AS 'StyleNumberNK2Bold'

    IDENTIFIER_EXIST 'STYLE_NUMBER_3NK_BOLD',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_3NK_BOLD
    END_IF
    CALC [STYLE_NUMBER_3NK_BOLD] AS 'StyleNumberNK3Bold'

    IDENTIFIER_EXIST 'STYLE_NUMBER_5NK_BOLD',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_NUMBER_5NK_BOLD
    END_IF
    CALC [STYLE_NUMBER_5NK_BOLD] AS 'StyleNumberNK5Bold'

    IDENTIFIER_EXIST 'STYLE_STRING_BOLD',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR   STYLE_STRING_BOLD
    END_IF
    CALC [STYLE_STRING_BOLD] AS 'BoldString'

    IDENTIFIER_EXIST 'XMLFileName',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR XMLFileName
    END_IF
    CALC [XMLFileName] AS [LocFileName]

    IDENTIFIER_EXIST 'XMLNormStr',[LocRes]
    IF [LocRes]=FALSE
      VAR_STR XMLNormStr
    END_IF
    CALC [XMLNormStr] AS ''

    LIST_CLR [XMLList]

    CALC [LocRes] AS TRUE
	END_PROC




  PROCEDURE XMLCloseFile
	  LOCAL_BOOL LocRes

    LIST_FILE_WRITE [XMLList],[LocRes],[XMLFileName]
    IF [LocRes]=FALSE
      MESSAGE 'Abbruch','Die Ausgabe-Datei konnte nicht gespeichert werden.',[MESSAGE_ERROR]
    END_IF
	END_PROC


  PROCEDURE XMLDocumentHeader
    LIST_APPEND [XMLList],'<?xml version="1.0"?>'
    LIST_APPEND [XMLList],'<?mso-application progid="Excel.Sheet"?>'
    LIST_APPEND [XMLList],'<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"'
    LIST_APPEND [XMLList],' xmlns:o="urn:schemas-microsoft-com:office:office"'
    LIST_APPEND [XMLList],' xmlns:x="urn:schemas-microsoft-com:office:excel"'
    LIST_APPEND [XMLList],' xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"'
    LIST_APPEND [XMLList],' xmlns:html="http://www.w3.org/TR/REC-html40">'
    LIST_APPEND [XMLList],' <DocumentProperties xmlns="urn:schemas-microsoft-com:office:office">'
    LIST_APPEND [XMLList],' </DocumentProperties>'
    LIST_APPEND [XMLList],' <ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel">'
    LIST_APPEND [XMLList],'  <ProtectStructure>False</ProtectStructure>'
    LIST_APPEND [XMLList],'  <ProtectWindows>False</ProtectWindows>'
    LIST_APPEND [XMLList],' </ExcelWorkbook>'
	END_PROC


  PROCEDURE XMLDocumentFooter
    LIST_APPEND [XMLList],'</Workbook>'
  END_PROC



  PROCEDURE XMLAddOneStyle VS LocStyleName, VS LocBorderStyle, VN LocFontSize, VS LocAlignment, VB LocBoldYes, VS LocBGColor
    LOCAL_BOOL  LocRes
    LOCAL_STR   LocStr
	  LOCAL_STR   LocGatter

    CALC [LocGatter] AS CHAR(#35)

    IDENTIFIER_EXIST [LocStyleName], [LocRes]
    IF [LocRes]=FALSE
      VAR_STR [LocStyleName]
    END_IF

    CALC [LocStr] AS CON('  <Style ss:ID="',[LocStyleName],'">')
    LIST_APPEND [XMLList], [LocStr]

    CALC [LocStr] AS [LocAlignment]
    IF [LocStr]=''
      CALC [LocStr] AS 'Left'
    END_IF

    ; borders
    IF [LocBorderStyle]<>''
      LIST_APPEND [XMLList], '  <Borders>';
      LIST_APPEND [XMLList], '   <Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/>';
      LIST_APPEND [XMLList], '   <Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/>';
      LIST_APPEND [XMLList], '   <Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/>';
      LIST_APPEND [XMLList], '   <Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/>';
      LIST_APPEND [XMLList], '  </Borders>';
    END_IF

    CALC [LocStr] AS CON('   <Alignment ss:Horizontal="',[LocStr],'"/>'
    LIST_APPEND [XMLList], [LocStr]

    IF [LocFontSize]<=0
      CALC [LocStr] AS [XMLNormalSize]
    ELSE
      CALC [LocStr] AS [LocFontSize]
    END_IF

    IF [LocBoldYes]
      CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocStr],'" ss:Color="',[LocGatter],[XMLCellColor],'" ss:Bold="1"/>')
    ELSE
      CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocStr],'" ss:Color="',[LocGatter],[XMLCellColor],'" ss:Bold="0"/>')
    END_IF
    LIST_APPEND [XMLList], [LocStr]

    IF [LocBGColor]=''
      CALC [LocStr] AS CON([LocGatter],'000000')
    ELSE
      CALC [LocStr] AS COPY([LocBGColor],1,1)
      IF [LocStr]<>'#'
        CALC [LocStr] AS CON([LocGatter],[LocBGColor])
      ELSE
        CALC [LocStr] AS [LocBGColor]
      END_IF
    END_IF

    CALC [LocStr] AS CON('   <Interior ss:Color="',[LocStr],'" ss:Pattern="Solid"/>')

    LIST_APPEND [XMLList], [LocStr]
    LIST_APPEND [XMLList], '  </Style>'
  END_PROC



  PROCEDURE XMLStyles  VS LocFontType, VN LocTitleFSize, VN LocHeadlineFSize, VN LocNormalFSize, VS LocFTitleColor, VS LocFCellColor, VS LocFBackColor
	  LOCAL_NUM   LocTitleSize
	  LOCAL_NUM   LocNormalSize
	  LOCAL_NUM   LocHeadlineSize
	  LOCAL_STR   LocStr
	  LOCAL_STR   LocGatter
    LOCAL_STR   LocTitleColor
    LOCAL_STR   LocCellColor
    LOCAL_STR   LocBackColor

    CALC [LocGatter] AS CHAR(#35)

	  CALC [LocTitleSize]    AS [LocTitleFSize]
	  CALC [LocNormalSize]   AS [LocNormalFSize]
	  CALC [LocHeadlineSize] AS [LocHeadlineFSize]

    CALC [LocTitleColor]   AS [LocFTitleColor]
    CALC [LocCellColor]    AS [LocFCellColor]
    CALC [LocBackColor]    AS [LocFBackColor]

    IF [LocTitleSize]<=0
	    CALC [LocTitleSize] AS 12
    END_IF

    IF [LocNormalSize]<=0
	    CALC [LocNormalSize] AS 10
    END_IF

    IF [LocHeadlineSize]<=0
	    CALC [LocHeadlineSize] AS 10
    END_IF

    IF [LocTitleColor]=''
      CALC [LocTitleColor] AS '000000'
    END_IF

    IF [LocCellColor]=''
      CALC [LocCellColor] AS 'FFFFFF'
    END_IF

    IF [LocBackColor]=''
      CALC [LocBackColor] AS 'FFCC99'
    END_IF

    CALC [LocStr] AS COPY([LocTitleColor],1,1)
    IF [LocStr]<>'#'
      CALC [LocTitleColor] AS CON([LocGatter],[LocTitleColor])
    END_IF

    CALC [LocStr] AS COPY([LocCellColor],1,1)
    IF [LocStr]<>'#'
      CALC [LocCellColor] AS CON([LocGatter],[LocCellColor])
    END_IF

    CALC [LocStr] AS COPY([LocBackColor],1,1)
    IF [LocStr]<>'#'
      CALC [LocBackColor] AS CON([LocGatter],[LocBackColor])
    END_IF


    ; ##############################
    ;          Style fr Titel
    ; ##############################
    LIST_APPEND [XMLList],'  <Style ss:ID="StyleTitle">'
    LIST_APPEND [XMLList],'   <Alignment ss:Horizontal="Center"/>',


    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocTitleSize],'" ss:Color="',[LocTitleColor],'" ss:Bold="1"/>')
    LIST_APPEND [XMLList], [LocStr]

    CALC [LocStr] AS CON('   <Interior ss:Color="',[LocBackColor],'" ss:Pattern="Solid"/>')
    LIST_APPEND [XMLList], [LocStr]


    LIST_APPEND [XMLList],'  </Style>'

    ; ##############################
    ;          Style fr Headline
    ; ##############################

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleHeadline">'
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocHeadlineSize],'" ss:Bold="1"/>')
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <Interior ss:Color="#DDDDDD" ss:Pattern="Solid"/>'
    LIST_APPEND [XMLList],'   <Alignment ss:Horizontal="Center" ss:Vertical="Center" ss:WrapText="1"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleHeadlineHellOrange">'
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocHeadlineSize],'" ss:Bold="1"/>')
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <Interior ss:Color="#FF9900" ss:Pattern="Solid"/>'
    LIST_APPEND [XMLList],'   <Alignment ss:Horizontal="Center" ss:Vertical="Center" ss:WrapText="1"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleHeadlineYellow">'
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocHeadlineSize],'" ss:Bold="1"/>')
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <Interior ss:Color="#FFFF00" ss:Pattern="Solid"/>'
    LIST_APPEND [XMLList],'   <Alignment ss:Horizontal="Center" ss:Vertical="Center" ss:WrapText="1"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleHeadlineYellowGreen">'
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocHeadlineSize],'" ss:Bold="1"/>')
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <Interior ss:Color="#99CC00" ss:Pattern="Solid"/>'
    LIST_APPEND [XMLList],'   <Alignment ss:Horizontal="Center" ss:Vertical="Center" ss:WrapText="1"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleHeadlineLightBlue">'
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocHeadlineSize],'" ss:Bold="1"/>')
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <Interior ss:Color="#00CCFF" ss:Pattern="Solid"/>'
    LIST_APPEND [XMLList],'   <Alignment ss:Horizontal="Center" ss:Vertical="Center" ss:WrapText="1"/>'
    LIST_APPEND [XMLList],'  </Style>'


    ; ###################################################################
    ;          Styles fr String 
    ; ###################################################################
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocNormalFSize],'"  ss:Bold="0"/>')

    ; @ prevents Excel to transform String into Num in case of number represented as string !
    LIST_APPEND [XMLList],'  <Style ss:ID="NormalString">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="@"/>'
    LIST_APPEND [XMLList],'  </Style>'
    
    ; bold string
    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocNormalFSize],'"  ss:Bold="1"/>')
    LIST_APPEND [XMLList],'  <Style ss:ID="BoldString">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="@"/>'
    LIST_APPEND [XMLList],'  </Style>'

    ; ###################################################################
    ;          Styles fr Numbers in normalen Zellen mit Nachkommastellen
    ; ###################################################################

    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocNormalFSize],'"/>')

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK0">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK2">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0.00"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK3">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0.000"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK5">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0.00000"/>'
    LIST_APPEND [XMLList],'  </Style>'


    ; #################################################################
    ;          Styles fr Numbers in Summen-Zellen mit Nachkommastellen
    ; #################################################################

    CALC [LocStr] AS CON('   <Font x:Family="Swiss" ss:Size="',[LocNormalFSize],'" ss:Bold="1"/>')

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK0Bold">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK2Bold">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0.00"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK3Bold">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0.000"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="StyleNumberNK5Bold">'
    LIST_APPEND [XMLList],[LocStr]
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="0.00000"/>'
    LIST_APPEND [XMLList],'  </Style>'

    LIST_APPEND [XMLList],'  <Style ss:ID="Default" ss:Name="Normal">'
    LIST_APPEND [XMLList],'   <Alignment ss:Vertical="Bottom"/>'
    LIST_APPEND [XMLList],'   <Borders/>'
    LIST_APPEND [XMLList],'   <Font/>'
    LIST_APPEND [XMLList],'   <Interior/>'
    LIST_APPEND [XMLList],'   <NumberFormat/>'
    LIST_APPEND [XMLList],'   <Protection/>'
    LIST_APPEND [XMLList],'  </Style>'
    LIST_APPEND [XMLList],'  <Style ss:ID="s21">'
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="Fixed"/>'
    LIST_APPEND [XMLList],'  </Style>'
    LIST_APPEND [XMLList],'  <Style ss:ID="StyleSimpleDateFormat">'
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="dd.mm.yyyy"/>'
    LIST_APPEND [XMLList],'  </Style>'
    LIST_APPEND [XMLList],'  <Style ss:ID="StyleDateFormat">'
    LIST_APPEND [XMLList],'   <NumberFormat ss:Format="hh:mm;@"/>'
    LIST_APPEND [XMLList],'  </Style>'
	END_PROC



  PROCEDURE XMLOpenStyles
    LIST_APPEND [XMLList],' <Styles>'
  END_PROC



  PROCEDURE XMLCloseStyles
    LIST_APPEND [XMLList],' </Styles>'
  END_PROC



  PROCEDURE XMLNormalizeStr VS XNS.Str
    CALC [XMLNormStr] AS [XNS.Str]
    IF [XMLNormStr]=''
      EXIT_PROC
    END_IF

    IF [XMLCaraVersionIsOk]
      CALC [XMLNormStr] AS A2HTML([XMLNormStr])
    ELSE
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'&','&amp;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'"','&quot;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'<','&lt;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'>','&gt;')

      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&iexcl;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&cent;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&pound;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&curren;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&yen;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&brvbar;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&sect;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&uml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&copy;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ordf;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&laquo;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&not;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&shy;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&reg;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&macr;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&deg;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&plusmn;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&sup2;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&sup3;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&acute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&micro;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&para;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&middot;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&cedil;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&sup1;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ordm;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&raquo;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&frac14;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&frac12;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&frac34;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&iquest;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Agrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Aacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Acirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Atilde;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Auml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Aring;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&AElig;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ccedil;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Egrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Eacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ecirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Euml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Igrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Iacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Icirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Iuml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ETH;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ntilde;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ograve;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Oacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ocirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Otilde;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ouml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&times;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Oslash;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ugrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Uacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Ucirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Uuml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&Yacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&THORN;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&szlig;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&agrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&aacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&acirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&atilde;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&auml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&aring;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&aelig;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ccedil;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&egrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&eacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ecirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&euml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&igrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&iacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&icirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&iuml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&eth;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ntilde;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ograve;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&oacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ocirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&otilde;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ouml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&divide;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&oslash;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ugrave;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&uacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&ucirc;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&uuml;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&yacute;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&thorn;')
      CALC [XMLNormStr] AS REPLACE([XMLNormStr],'','&yuml;')
    END_IF
  END_PROC



  PROCEDURE XMLOpenWorkSheet VS LocSheetName
    CALL XMLNormalizeStr [LocSheetName]
    CALC [XMLNormStr] AS CON(' <Worksheet ss:Name="',[XMLNormStr],'">')
    LIST_APPEND [XMLList],[XMLNormStr]
  END_PROC



  PROCEDURE XMLCloseWorkSheet
    LIST_APPEND [XMLList],' </Worksheet>'
  END_PROC



  PROCEDURE XMLWSOptions VN LocFixedLine, VN LocFixedCol
    LOCAL_STR   LocStr

    LIST_APPEND [XMLList], '  <WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">'
    LIST_APPEND [XMLList], '   <FrozenNoSplit/>'

    IF [LocFixedLine]>0
      CALC [LocStr] AS CON('   <SplitHorizontal>',[LocFixedLine],'</SplitHorizontal>')
      LIST_APPEND [XMLList], [LocStr]

      CALC [LocStr] AS CON('   <TopRowBottomPane>',[LocFixedLine],'</TopRowBottomPane>')
      LIST_APPEND [XMLList], [LocStr]
    END_IF

    IF [LocFixedCol]>0
      CALC [LocStr] AS CON('   <SplitVertical>',[LocFixedCol],'</SplitVertical>')
      LIST_APPEND [XMLList], [LocStr]

      CALC [LocStr] AS CON('   <LeftColumnRightPane>',[LocFixedCol],'</LeftColumnRightPane>')
      LIST_APPEND [XMLList], [LocStr]
    END_IF

    IF [LocFixedLine]>0
      IF [LocFixedCol]>0
        LIST_APPEND [XMLList], '   <ActivePane>0</ActivePane>'
      ELSE
        LIST_APPEND [XMLList], '   <ActivePane>2</ActivePane>'
      END_IF
    ELSE
      IF [LocFixedCol]>0
        LIST_APPEND [XMLList], '   <ActivePane>1</ActivePane>'
      END_IF
    END_IF


    LIST_APPEND [XMLList], '  </WorksheetOptions>'
  END_PROC



  PROCEDURE XMLAutoFilter VS LocRangeStr
    LOCAL_STR LocStr

    CALC [LocStr] AS CON('  <AutoFilter x:Range="',[LocRangeStr],'" xmlns="urn:schemas-microsoft-com:office:excel">')
    LIST_APPEND [XMLList], [LocStr]

    LIST_APPEND [XMLList], '  </AutoFilter>'
  END_PROC



  PROCEDURE XMLSetColWidth
    LOCAL_NUM   LocNum
    LOCAL_STR   LocStr

    CALC [LocNum] AS 1
    WHILE [LocNum]<=[XMLColCnt]
      CALC [LocStr] AS CON('XMLHLSize',[LocNum])

      CALC [LocStr] AS [[LocStr]]
      CALC [LocStr] AS CON('   <Column ss:Width="',[LocStr],'"/>')
      LIST_APPEND [XMLList], [LocStr]

      INC [LocNum]
    END_WHILE
  END_PROC



  PROCEDURE XMLOpenTable VN LocColCnt
    LOCAL_STR   LocStr

    CALC [LocStr] AS CON('  <Table ss:ExpandedColumnCount="',[LocColCnt],'" x:FullColumns="1" x:FullRows="1" ss:DefaultColumnWidth="60">'
    LIST_APPEND [XMLList], [LocStr]
  END_PROC



  PROCEDURE XMLCloseTable
    LIST_APPEND [XMLList],'  </Table>'
  END_PROC



  PROCEDURE XMLOpenRow VS LocOptionStr
    LOCAL_STR   LocStr

    IF [LocOptionStr]=''
      LIST_APPEND [XMLList],'   <Row>'
    ELSE
      CALC [LocStr] AS CON('   <Row ss:',[LocOptionStr],'>')
      LIST_APPEND [XMLList],[LocStr]
    END_IF
    
    INC [XMLCntRows]
  END_PROC



  PROCEDURE XMLCloseRow
    LIST_APPEND [XMLList],'   </Row>'
  END_PROC




  PROCEDURE XMLWriteTitle VS LocTitle, VN LocSpan
    LOCAL_NUM   LocNum

    CALC [LocNum] AS [LocSpan]-1

    CALL XMLOpenRow ''

    CALL XMLNormalizeStr [LocTitle]
    CALC [XMLNormStr] AS CON('    <Cell ss:MergeAcross="',[LocNum],'" ss:StyleID="StyleTitle"><Data ss:Type="String">',[XMLNormStr],'</Data></Cell>')
    LIST_APPEND [XMLList], [XMLNormStr]

    CALL XMLCloseRow
  END_PROC


  ; more Subtitles in a single line, each having more cells width
 PROCEDURE XMLWriteSubTitle VS LocSubTitle, VS LocStyleName, VN LocSpan, VB LocOpenRow, VB LocCloseRow
   LOCAL_NUM   LocNum

   CALC [LocNum] AS [LocSpan]-1

   IF [LocOpenRow]
     CALL XMLOpenRow ''
   END_IF

   CALL XMLNormalizeStr [LocSubTitle]
   CALC [XMLNormStr] AS CON('    <Cell ss:MergeAcross="',[LocNum],'" ss:StyleID="',[LocStyleName],'"><Data ss:Type="String">',[XMLNormStr],'</Data></Cell>')
   LIST_APPEND [XMLList], [XMLNormStr]

   IF [LocCloseRow]
     CALL XMLCloseRow
   END_IF
 END_PROC


  ; here we can add Formula to the Cell !
  PROCEDURE XMLWriteExtendedCell VS LocContentStr, VS LocTypeStr, VS LocStyleStr, VS LocRefStr, VS LocFormula
    ; e.g. '|ss:Formula="=RC[-2]+RC[-1]"'
    LOCAL_STR   LocTyp
    LOCAL_STR   LocStyleString

    CALC [LocTyp] AS [LocTypeStr]
    IF [LocTyp]=''
      CALC [LocTyp] AS 'String'
    END_IF

    IF [LocStyleStr]=''
      CALC [LocStyleStr] AS 'NormalString'
     END_IF

    CALL XMLNormalizeStr [LocContentStr]

    IF [LocTyp]='DateTime'
      IF [LocRefStr]=''
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleDateFormat" ',[LocFormula],'><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
      ELSE
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleDateFormat" ss:HRef="#',[LocRefStr],'" ',[LocFormula],'><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
      END_IF
    ELSE_IF [LocTyp]='Date'
      IF [LocRefStr]=''
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleSimpleDateFormat" ',[LocFormula],'><Data ss:Type="DateTime">',[XMLNormStr],'</Data></Cell>')
      ELSE
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleSimpleDateFormat" ss:HRef="#',[LocRefStr],'" ',[LocFormula],'><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
      END_IF
    ELSE
      IF [LocStyleStr]<>''
        IF [LocRefStr]=''
          CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="',[LocStyleStr],'" ',[LocFormula],'><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
        ELSE
          CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="',[LocStyleStr],'" ss:HRef="#',[LocRefStr],'" ',[LocFormula],'><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
        END_IF
      ELSE
        IF [LocRefStr]=''
          CALC [XMLNormStr] AS CON('    <Cell><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
        ELSE
          CALC [XMLNormStr] AS CON('    <Cell><Data ss:Type="',[LocTyp],'" ss:HRef="#',[LocRefStr],'">',[XMLNormStr],'</Data></Cell>')
        END_IF
      END_IF
    END_IF

    LIST_APPEND [XMLList], [XMLNormStr]
  END_PROC



  PROCEDURE XMLWriteCell VS LocContentStr, VS LocTypeStr, VS LocStyleStr, VS LocRefStr
    ; z.B.  <Cell ss:StyleID="s26" ss:HRef="#Positionen!A4"><Data ...
    LOCAL_STR   LocTyp
    LOCAL_STR   LocStyleString

    CALC [LocTyp] AS [LocTypeStr]
    IF [LocTyp]=''
      CALC [LocTyp] AS 'String'
    END_IF

    IF [LocStyleStr]=''
      CALC [LocStyleStr] AS 'NormalString'
    END_IF

    CALL XMLNormalizeStr [LocContentStr]

    IF [LocTyp]='DateTime'
      IF [LocRefStr]=''
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleDateFormat"><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
      ELSE
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleDateFormat" ss:HRef="#',[LocRefStr],'"><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
      END_IF
    ELSE_IF [LocTyp]='Date'
      IF [LocRefStr]=''
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleSimpleDateFormat"><Data ss:Type="DateTime">',[XMLNormStr],'</Data></Cell>')
      ELSE
        CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="StyleSimpleDateFormat" ss:HRef="#',[LocRefStr],'"><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
      END_IF
    ELSE
      IF [LocStyleStr]<>''
        IF [LocRefStr]=''
          CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="',[LocStyleStr],'"><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
        ELSE
          CALC [XMLNormStr] AS CON('    <Cell ss:StyleID="',[LocStyleStr],'" ss:HRef="#',[LocRefStr],'"><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
        END_IF
      ELSE
        IF [LocRefStr]=''
          CALC [XMLNormStr] AS CON('    <Cell><Data ss:Type="',[LocTyp],'">',[XMLNormStr],'</Data></Cell>')
        ELSE
          CALC [XMLNormStr] AS CON('    <Cell><Data ss:Type="',[LocTyp],'" ss:HRef="#',[LocRefStr],'">',[XMLNormStr],'</Data></Cell>')
        END_IF
      END_IF
    END_IF

    LIST_APPEND [XMLList], [XMLNormStr]
  END_PROC



  PROCEDURE XMLWriteSum VS LocContentStr, VN LocRowNo, VS LocStyleStr, VN LocColOffset
    LOCAL_STR   LocStr

    CALC [LocStr] AS CON('    <Cell ss:Index="',[LocRowNo],'" ss:StyleID="',[LocStyleStr],'"')
    CALC [LocStr] AS CON([LocStr],' ss:Formula="=SUM(R[-',[LocColOffset],']C:R[-1]C)">'
    CALC [LocStr] AS CON([LocStr],'<Data ss:Type="Number">',[LocContentStr],'</Data></Cell>')

    LIST_APPEND [XMLList], [LocStr]
  END_PROC



  PROCEDURE XMLWriteAverage VS LocContentStr, VN LocRowNo, VS LocStyleStr, VN LocColOffset
    LOCAL_STR   LocStr
    CALC [LocStr] AS CON('    <Cell ss:Index="',[LocRowNo],'" ss:StyleID="',[LocStyleStr],'"')

;    CALC [LocStr] AS CON('    <Cell ss:Index="',[LocRowNo],'" ss:StyleID="s26"')
    CALC [LocStr] AS CON([LocStr],' ss:Formula="=AVERAGE(R[-',[LocColOffset],']C:R[-1]C)">'
    CALC [LocStr] AS CON([LocStr],'<Data ss:Type="Number">',[LocContentStr],'</Data></Cell>')

    LIST_APPEND [XMLList], [LocStr]
  END_PROC



  PROCEDURE XMLWriteDivision VS LocContentStr, VN LocRowNo, VS LocStyleStr, VN LocColOffset
    LOCAL_STR   LocStr

    CALC [LocStr] AS CON('    <Cell ss:Index="',[LocRowNo],'" ss:StyleID="',[LocStyleStr],'"')
    CALC [LocStr] AS CON([LocStr],' ss:Formula="=IF(RC[-1]=0,IF(RC[-2]=0,0,100),(100*(RC[-2]-RC[-1])/RC[-1]))">'
    CALC [LocStr] AS CON([LocStr],'<Data ss:Type="Number">',[LocContentStr],'</Data></Cell>')

    LIST_APPEND [XMLList], [LocStr]
  END_PROC



  PROCEDURE XMLEmptyLine
    ; empty line
    CALL XMLOpenRow ''
    CALL XMLWriteCell '', '', '', ''
    CALL XMLCloseRow
  END_PROC



  PROCEDURE XMLGetCFGInfos
    LOCAL_BOOL  LocRes

    IDENTIFIER_EXIST 'LP_XML_USE_XML_EXPORT',[LocRes]
    IF [LocRes]=FALSE
      VAR_BOOL  LP_XML_USE_XML_EXPORT
    END_IF

    INI_READ	[LocRes], [LP_XML_USE_XML_EXPORT], [SCRIPT_BOOLEAN], [CONFIG_FILE], 'XML_USE_XML_EXPORT', 'Allgemein'
  END_PROC

