; Dieses Dokument beschreibt die CSH-Syntax die in SQL-Anweisungen
; innerhalb von CARA verwendet werden knnen.
;
; Diese CSH-Syntax wird vor der Ausfhrung eines Querys aus dem
; Query entfernt, denn es handelt dabei sich NICHT um SQL konforme
; Schlsselworte.




; Die STARTNG WITH - Anweisung
; Am Ende einer SELECT-Anweisung kann man
; z.B. STARTING WITH Name1 = "Creative Soft- & Hardware"
; anhngen. Dadurch wird der Daten-Cursor nach dem ffnen
; der SELECT-Anweisung bis auf den Datensatz verschoben,
; der der Bedingung in der STARTING WITH - Anweisung
; gengt. Wenn kein Treffer erzielt wird, dann wird bis
; zum Ende der SELECT-Records gesucht. Diese Anweisung
; sollte nur dann verwendet werden, wenn man sich
; sicher ist, da der User nicht Minuten lang warten
; mu bis das gesuchte Record gefunden wurde.


; Die TABLE_2_ASCII - Anweisung  : siehe Historie.rtf
; Die ASCII_2_TABLE - Anweisung  : siehe Historie.rtf


; SELECT - ANWEISUNGEN

; Dies ist eine Notiz

; Es folgt die berschrift des Browsers
SQL-Abfragen und CSH-Syntax

    ; Syntax :
    ;
    ; SQL_FIELD_SEARCH_FAST              = S          Soll ein Feld in der Schnellsuche verfgbar sein
    ;                                                 (auch wenn es nicht in der ORDER BY Anweisung aufgefhrt ist)?
    ; SQL_FIELD_HIDDEN                   = H
    ; SQL_FIELD_VISIBLE                  = V          Macht Spalten sichtbar, die normalerweise automatisch ausgeblendet
    ;                                                 werden, wie z.B. Felder RecordID, RecFLag etc.
    ; SQL_FIELD_WIDTH                    = W    z.B.  W15
    ; SQL_FIELD_NAME                     = N    z.B.  N"Testberschrift mit allen Schikanen"
    ;                                                 N"Nachname|R" <-- rechtsbndige Darstellung (nur bei String-Feldern)
    ;
    ; SQL_FIELD_EDITABLE                 = E    z.B.  E"XXXXXXXXXXXXXXX" oder E"dd.mm.yyyy" oder E"####.##"....
    ;
    ; SQL_FIELD_MASK                     = M    z.B.  M "4"  bei Zahlen = vier Nachkommastellen anzeigen. Es knnen alle Werte von 0-5 verwendet werden.
    ;                                                 M "K2" bei Zahlen = zwei Nachkommastellen, das Dezimalkomma ist ein Schrgstrich, zur Darstellung von Kalenderwochen.
    ;                                                 M "T2" bei Zahlen = zwei Nachkommastellen, Dezimalkomma und Tausenderpunkte anzeigen.
    ;                                                 M "T0" bei Zahlen = keine Nachkommastelen und Tausenderpunkte
    ;                                                 M "ID" stellt eine RecordID in der Form "Datum Zeit RecID" dar
    ;                                                 M "Plain" stellt einen RTF-Text als normalen Text im Browser dar
    ;                                                 M "dd.mm.yyyy" um ein Datum zu formatieren
    ;                                                 M "hh:mm:ss" um eine Zeit zu formatieren
    ;                                                 M "beliebiger Text" NUR bei Strings = Zeigt anstelle des Strings in der Datenbank einfach immer in jeder Zeile den hier angegebenen String an.
    ;
    ; SQL_FIELD_LEVEL                    = L    z.B.  L "2" Level der aktuellen Benutzer-Rechte
    ;                                                       muss mindestens 2 sein, sonst wird
    ;                                                       das Feld ausgeblendet.
    ; SQL_FIELD_ROWS_HEIGHT              = R    z.B.  R "2" Die Zeilen des Browsers sind normalerweise
    ;                                                       eine Zeile hoch, in diesem Falle wren sie
    ;                                                       zwei Zeilen hoch.
    ;
    ; SQL_FIELD_LOCKED_COLS              = F    z.B.  F "1" Die erste Spalte des Browsers ist fixiert
    ;
    ; SQL_FIELD_OHTER_CONTENT            = Z    z.B.  Z "MyOwnContentScript" ScriptName, in dem der Content des Feldinhaltes erstellt wird - bergeben wird der Inhalt ohne Vernderung
    ;
    ; SQL_ROW_PROTECTED_ON               = P    z.B. PROTECTED_ON Verknpfung Operator "Inhalt"
    ; SQL_ROW_PROTECTED_OFF              = U
    ; SQL_ROW_COLORED_ON                 = C    z.B. COLORED_ON ROW_COLOR Verknpfung Operator "Inhalt"
    ; SQL_ROW_COLORED_OFF                = T
    ;
    ; SQL_ROW_KNOT_ON                    = K    z.B. KNOT_ON Verknpfung Operator "Inhalt" (fr TREE_SET oder LIST_SET
    ; SQL_ROW_KNOT_OFF                   = X                                                kann aber in normalen SELECT-
    ;                                                                                       Anweisungen als 4. Farbe <gelb>
    ;                                                                                       "missbraucht" werden)
    ;
    ; SQL_FIELD_COLORED_ON               = I    z.B. COLORED_ON FIELD_COLOR Operator "Inhalt"
    ; SQL_FIELD_COLORED_OFF              = J
    ;
    ; SQL_ROW_COLOR_1                    = 1
    ; SQL_ROW_COLOR_2                    = 2
    ; SQL_ROW_COLOR_3                    = 3
    ; SQL_ROW_COLOR_4                    = 4
    ; SQL_ROW_COLOR_5                    = 5
    ; SQL_ROW_COLOR_6                    = 6
    ; SQL_ROW_COLOR_7                    = 7
    ; SQL_ROW_COLOR_8                    = 8
    ; SQL_ROW_COLOR_9                    = 9
    ;
    ; SQL_COMPARE_OPERATOR_EQUAL         = =
    ; SQL_COMPARE_OPERATOR_GREATER       = >
    ; SQL_COMPARE_OPERATOR_LESS          = <
    ; SQL_COMPARE_OPERATOR_GR_OR_EQUAL   = >=
    ; SQL_COMPARE_OPERATOR_LESS_OR_EQUAL = <=
    ; SQL_COMPARE_OPERATOR_LIKE          = >>
    ; SQL_CO7MPARE_OPERATOR_NOT_LIKE     = <<
    ;
    ;
    ;       Width = 15
    ;       |   ==> Die Darstellungbreite der Browser-SPALTE Name1 ist 15 Zeichen (programm-intern stehen natrlich alle Zeichen zur Verfgung)
    ;       |
    ;       |   Color 2 AND-verknpft LIKE "*ey*" (beim ersten Filter immer AND verknpfen)
    ;       |   |       ==> Diese ZEILE erhlt die Farbe 2 wenn das Feld Name1 irgendwo ein "ey" enthlt.
    ;       |   |
    ;       |   |           Color 3 OR-verknpft LIKE "*eie*"
    ;       |   |           |       ==> Diese ZEILE erhlt die Farbe 3 wenn das Feld Name1 irgendwo ein "eie" enthlt.
    ;       |   |           |
    ;       |   |           |            Color 1 OR-verknpft LIKE "*k*"
    ;       |   |           |            |       ==> Diese ZEILE erhlt die Farbe 1 wenn das Feld Name1 irgendwo ein "k" enthlt.
    ;       |   |           |            |
    ;       |   |           |            |          Protected AND-verknpft LIKE "**"
    ;       |   |           |            |          |         ==> Diese ZEILE kann man nicht auswhlen (ist protected) wenn das Feld Name1 irgendwo ein "" enthlt.
    ;       |   |           |            |          |
    ;       |   |           |            |          |         Bezeichner der Browser-SPALTE (Name des Header) = "Nachname"
    ;       |   |           |            |          |         |
    ;       |   |           |            |          |         |           Knoten-Kriterium, hier als 4. Farbe verwendet
    ;       |   |           |            |          |         |           |    ==> Diese ZEILE erhlt die Farbe gelb wenn das Feld Name1 am Ende ein "GmbH" enthlt.
    ;       |   |           |            |          |         |           |
    ;       |   |           |            |          |         |           |           Benutzer-Level muss 3 sein um das Feld sehen zu knnen.
    ;       |   |           |            |          |         |           |           |
    ;       |   |           |            |          |         |           |           |    Zeilenhhe = 2
    ;       |   |           |            |          |         |           |           |    |
    ;       |   |           |            |          |         |           |           |    |    Fixierte Spalten = 1
    ;       |   |           |            |          |         |           |           |    |    |
    ;       v   v           v            v          v         v           v           v    v    v
    SELECT [W15 C2A>>"*ey*" C3O>>"*eie*" C1O>>"*k*" PA>>"**" N"Nachname" KO>>"*GmbH" L"3" R"2" F"1"]Name1,

    ;       Hidden
    ;       |   ==> Diese Browser-SPALTE wird zwar fr den programm-internen Gebrauch geladen, aber sie wird ausgeblendet, so da der User sie nicht sieht
    ;       |
    ;       v
           [H S]Name2,

    ;       Editable
    ;       |   ==> Diese Feld ist editierbar entlang der angegebenen Editirr-Eingabe-Maske "XXXXXX" also 6-Zeichen sind zur Eingabe mglich
    ;       |
    ;       |         Width = 6
    ;       |         |   ==> Die Darstellungbreite der Browser-SPALTE Name1 ist 6 Zeichen (programm-intern stehen natrlich alle Zeichen zur Verfgung)
    ;       |         |
    ;       |         |  Nur das Feld PLZ wird die Farbe 3 haben, wenn die PLZ mit 4 beginnt
    ;       |         |  |
    ;       |         |  |         Das Feld PLZ wird normal farbig dargestellt, wenn die PLZ > als 41000 ist.
    ;       |         |  |         |
    ;       |         |  |         |
    ;       v         v  v         v
           [E"XXXXXX" W6 I3A>>"4*" JA>"41000"]PLZ,

    ;       Dieses Feld soll auch in der Schnellsuche verfgbar sein
    ;       |
    ;       |
    ;       v
           [S]Ort,
           Strasse,

    ;       Maske = 4 Nachkommastellen fr die Float-Zahl
    ;       |
    ;       |
    ;       v
           [M "4" ]KHaben,

    ;       Startet das Script BrowserFieldContent.csh und bergibt zuvor den Inhalt des
    ;       Feldes an die Globalvariable [GLOB_CONTENT_STR] (hier z.B. unter MySQL "ID 7883733534733").
    ;       Das Script schreibt wieder in die Variable [GLOB_CONTENT_STR] und das wird dann in dem
    ;       Feld als Inhalt angezeigt.
    ;       Hier ein einfaches Beispiel:  SCRIPT_BEGIN
    ;       |                               CALC [GLOB_CONTENT_STR] AS PART([GLOB_CONTENT_STR],2,' ')
    ;       |                             SCRIPT_END
    ;       |
    ;       |
    ;       v
           [Z"BrowserFieldContent.csh"][SQL_CONCATE]"ID "[SQL_COLON_REPLACE]RecordID)


    ;       Maske = ID bedeutet, dass die Zahl ein TimeStamp sein soll und der Wert + Datum und Zeit ausgegeben wird.
    ;       |
    ;       |
    ;       v
           [M "ID"]KZahlBedID,

    ;      Diese Browser-SPALTEN werden zwar fr den programm-internen Gebrauch geladen, aber sie wirden per default ausgeblendet, so da der User sie nicht sieht
    ;      |
    ;      |
    ;      v
           RecordID,
           Mandant,
           RecFlag

      FROM Adressen
     WHERE RecordID > 100
  ORDER BY Name1
