/* MySQL: Lschen aus einer Tabelle mit Referenz auf eine andere */
delete L
  from lockrecs AS L inner join auftrag AS A
 where L.RelrecID       = A.RecordID
   and L.TableName      = "auftrag"
   and A.FertByte       = -1
   and A.Angebotsnummer = "201106852"



/* Beispiel zu MySQL (by Vasile) -> in CARA mssen die Leerzeichen in dem Feld-Select durch das BlankReplace-Zeichen "" ersetzt werden  */
  SELECT R.Kennung,
         (SELECT SUM(G.Brutto) FROM Rechnung G WHERE G.Kennung = "G" AND G.KundenID = R.KundenID AND G.Aktiv < 99),
         R.Gezahlt,
         R.Brutto
    FROM rechnung R, adressen K, zahlbed Z
   WHERE R.KundenID  = K.RecordID
     AND R.Aktiv     < 99
     AND R.Kennung   = "R"
     AND R.ZahlBedID = Z.RecordID
ORDER BY R.Kennung, R.Rechnungsnummer


/* schnes Beispiel zu MySQL substring (by Bene) */
      UPDATE adressen
         SET name1   =    substring(name1 from 28),
             branche =    "Hotel & Gastronomie"
       WHERE name1   LIKE "Gaststtten, Restaurants - %";


/* MySQL case-sensitive string compare */
      SELECT RecordID
        FROM auftrag
       WHERE Aktiv    < 99
         AND FertByte = 0
         AND RecordID > 1000
         AND STRCMP(Status, '---LF---') = 0


/* SQLite Field Concatination */
SELECT name1 || '.' || name2 FROM adressen;


/* update two tables in sqlite */
UPDATE T1
   SET T1.colA = T2.colA,
       T1.colB = T2.colB
  FROM T1, T2
 WHERE T1.colC = T2.colC


/* character-set unter MySQL nach "deutsch" wechseln */
ALTER TABLE tablename CHARACTER SET latin1 COLLATE latin1_german1_ci;


/* SQLite concat */
UPDATE examp SET one = '(' || one || ')' WHERE two < 50;


/* MySQL an ein Nummernkreisfeld (string) vorne eine 0 anfgen */
update rechnung
   set rechnungsnummer = concat("0",rechnungsnummer)
 where Kennung = "R";

select rechnungsnummer from rechnung where kennung = "R";


/* Das Backup einer MySQL-Sicherung beginnt meist so */
-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.1.35-community


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema ideal
--

CREATE DATABASE IF NOT EXISTS ideal;
USE ideal;








/* Im MSSQL gibt es kein "limit" */
SELECT RecordID, Name1, Name2 FROM adressen LIMIT 0,100 ---> MySQL
SELECT top 100 RecordID, Name1, Name2 FROM adressen     ---> MSSQL




/* MySQL Tabele anlegen mit INDEX und Storage-Engine-Anagabe */
CREATE TABLE `CADImportH` (
  `RecordID` decimal(13,0) NOT NULL default '0',
  `IDUser` decimal(13,0) NOT NULL default '0',
  `LevelUser` decimal(13,0) NOT NULL default '0',
  `Mandant` decimal(13,0) NOT NULL default '0',
  `UpdateID` decimal(13,0) NOT NULL default '0',
  `UpdateTime` decimal(13,0) NOT NULL default '0',
  `RecFlag` int(11) NOT NULL default '0',
  `EventFlag` int(11) NOT NULL default '0',
  `Bezeichnung` char(81) NOT NULL default '',
  `Zeichnungsnummer` char(81) NOT NULL default '',
  `ImportDate` date NOT NULL default '0000-00-00',
  `MitarbeiterID` decimal(13,0) NOT NULL default '0',
  `StckListeAnlegen` char(1) NOT NULL default '',
  `FileName` char(128) NOT NULL default '',
  `Aktiv` int(11) NOT NULL default '0',
  `Uebernommen` date NOT NULL default '0000-00-00',
  `ArtikelID` decimal(13,0) NOT NULL default '0',
  `Free1Str` char(81) NOT NULL default '',
  `Free2Str` char(81) NOT NULL default '',
  `Free3Str` char(81) NOT NULL default '',
  `FreeFloat1` double NOT NULL default '0',
  `FreeFloat2` double NOT NULL default '0',
  `FreeFloat3` double NOT NULL default '0',
  `FreeInt1` int(11) NOT NULL default '0',
  `FreeInt2` int(11) NOT NULL default '0',
  `FreeInt3` int(11) NOT NULL default '0',
  `FreeNum1` int(11) NOT NULL default '0',
  `FreeNum2` int(11) NOT NULL default '0',
  `FreeNum3` int(11) NOT NULL default '0',
  `FreeDate1` date NOT NULL default '0000-00-00',
  `FreeDate2` date NOT NULL default '0000-00-00',
  `FreeDate3` date NOT NULL default '0000-00-00',
  `FreeTime1` time default NULL,
  `FreeTime2` time default NULL,
  `FreeTime3` time default NULL,
  `FreeBit1` char(1) NOT NULL default '',
  `FreeBit2` char(1) NOT NULL default '',
  `FreeBit3` char(1) NOT NULL default '',
  `Artikelnummer` char(81) NOT NULL default '',
  PRIMARY KEY  (`RecordID`),
  UNIQUE KEY `IndCADHRecordID` (`RecordID`),
  KEY `IndCADHBezeichnung` (`Bezeichnung`),
  KEY `IndCADHZeichnungsnummer` (`Zeichnungsnummer`),
  KEY `IndCADHImportDate` (`ImportDate`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



/* Kundenadresse mit allen Unteradressen */
   SELECT [W25 N"Hauptadresse Kundennummer"         ]H.Kundennummer,
          [W25 N"Hauptadresse Suchbegirff"          ]H.Suchbegriff,
          [W25 N"Hauptadresse Name 1"               ]H.Name1,
          [W25 N"Hauptadresse Name 2"               ]H.Name2,
          [W25 N"Hauptadresse Strasse"              ]H.Strasse,
          [W15 N"Hauptadresse PLZ"                  ]H.PLZ,
          [W25 N"Hauptadresse Ort"                  ]H.Ort,

          [W25 N"Nebenadresse Suchbegirff"          ]A.Suchbegriff,
          [W25 N"Nebenadresse Name 1"               ]A.Name1,
          [W25 N"Nebenadresse Name 2"               ]A.Name2,
          [W25 N"Nebenadresse Strasse"              ]A.Strasse,
          [W15 N"Nebenadresse PLZ"                  ]A.PLZ,
          [W25 N"Nebenadresse Ort"                  ]A.Ort,

          [W25 N"Nebenadresse ist Versandadresse"   ]Z.VA,
          [W25 N"Nebenadresse ist Rechnungsadresse" ]Z.RA,
          [W25 N"Nebenadresse ist Partner"          ]Z.PA

     FROM adressen A, adrzuord Z, adressen H

    WHERE A.RecordID = Z.RelationID
      AND H.RecordID = Z.AdressenID
      AND Z.RecordID > 1000
      AND A.RecordID > 1000
      AND H.RecordID > 1000

ORDER BY H.Kundennummer, H.Suchbegriff, H.Name1, H.Name2, Z.VA, Z.RA, Z.PA




/* Hat ein Artikel einen Dokumentenmanager Bezug?  (Wenn ja, dann wurde 8192 = 2^13 zur RecFlag addiert) */
/* Da die BinaryFlag auch fr 1 = 2^0 funktionieren soll, muss zum Wert des Exponenten 1 addiert werden  */
SELECT A.Artikelnummer, A.Bezeichnung1
  FROM artikel A
 WHERE A.RecordID  > 1000
   AND BINARY_NOT_FLAG_14_A.RECFLAG



/* Welche Artikel haben einen Immertext?                                                                 */
/* Da die BinaryFlag auch fr 1 = 2^0 funktionieren soll, muss zum Wert des Exponenten 1 addiert werden  */
/* NOTES_FLAG_DEMAND      =  256   2^8  Immer-Text
   NOTES_FLAG_FREE_TEXT   =  512   2^9  irgend einer der frei in der INI-Datei festlegbaren Texte
   NOTES_FLAG_INTERN      = 1024   2^10 Interner-Text
   NOTES_FLAG_PRINT_FRONT = 2048   2^11 Text 1
   NOTES_FLAG_PRINT_BACK  = 4096   2^12 Text 2                                                           */
SELECT A.Artikelnummer, A.Bezeichnung1
  FROM artikel A
 WHERE A.RecordID  > 1000
   AND BINARY_FLAG_9_A.RECFLAG



/* nur bei MySQL */
			SELECT DISTINCT name,
				     strasse as street,
				     land    as country,
				     plz     as zip,
				     ort     as city,
				     telefon as phone,
				     telefax as fax,
				     email,
				     link    as website
			  FROM dealer
		   WHERE SUBSTRING(plz, 1, 1) LIKE REPLACE("[$zip]", "all", "%")
		     AND land = CASE WHEN '[$country]' = ''
		                     THEN 'D'
					               ELSE '[$country]'
				            END
		ORDER BY plz



/* ndern eines Feldes in einer MYSQL-Tabelle in der Regel sind "ActualFildName"
   und "NewFieldName" gleich, da man ja die Eigenschaften und nicht den Namen
   des Feldes ndert */
ALTER TABLE tablename CHANGE COLUMN ActualFildName NewFieldName CHAR(62) NOT NULL DEFAULT ''



/* und so sieht das beim MSSQL aus */
ALTER TABLE tablename ALTER COLUMN fieldname CHAR(62) NULL

/* und so sieht das beim MSSQL aus, wenn auf dem feld auch ein Index ist */
/* MSSQL bis version 2000 */
DROP INDEX IndLaBGrund ON lagerbew;
/* MSSQL ab version 2000 */
DROP INDEX IndArtBezeichnung1 ON artikel;
ALTER TABLE artikel ALTER COLUMN Bezeichnung1 CHAR(50) NULL;
CREATE INDEX IndArtBezeichnung1 ON artikel (Bezeichnung1);





/* selektiere zwei Zahlen, und schreibe sie untereinander MySQL */
select name1, CONCAT(LUmsatzGesamt'\n'LEKUmsatzGesamt) from adressen where laktiv > 0


/* vergleiche einen String mit Banks mit einem ohne: MySQL */
     WHERE A.EANCode1 <> REPLACE(E.EANCode, ' ', '')


/* Suche alle doppelt vergebenen EANCOdes der Artikeltabelle  MySQL */
  SELECT A.Artikelnummer, E.EANCode
    FROM artikel A, eancodes E
   WHERE A.RecordID =   E.ArtikelID
     AND A.RecordID >   1000
     AND A.RecordID IN (  SELECT A.RecordID
                            FROM artikel A, eancodes E
                           WHERE A.RecordID = E.ArtikelID
                             AND A.RecordID > 1000
                        GROUP BY A.RecordID
                          HAVING count(A.RecordID) > 1    )
ORDER BY A.Artikelnummer



/* Suche alle Rechnungsnummern die mehrfach vergeben wurden, aber NUR die mehrfach vergebenen */

  SELECT Rechnungsnummer, count(rechnungsnummer)
    FROM rechnung
   WHERE kennung = "R"
GROUP BY rechnungsnummer
  HAVING count(rechnungsnummer) > 1


  SELECT Kundennummer, count(Kundennummer)
    FROM adressen
   WHERE KAktiv > 0
GROUP BY Kundennummer
  HAVING count(Kundennummer) > 1;

  SELECT EANCode1, count(EANCode1)
    FROM artikel
   WHERE RecordID > 0
GROUP BY EANCode1
  HAVING count(EANCode1) > 1;


  SELECT MAX(Kundennummer)
    FROM adressen
   WHERE KAktiv > 0


  SELECT EMail1, count(EMail1)
    FROM adressen
   WHERE EMail1 <> ""
GROUP BY EMail1
  HAVING count(EMail1) > 1;



/* Merke: wenn man GROUP BY verwendet und eine WHERE-Bedingung fr eine "gegrouptes" Feld braucht,
       dann verwendet man HAVING. Kurz: "HAVING ist die WHERE-Bedingung des GROUP BY".              */







/* Was muss man machen, wenn ein Feldname ein Komma enthlt? */

 SELECT K.Name1, K.Kundennummer, K.Name2, K.Suchbegriff,
        SUM(IF(A.FertByte =  0, Netto,  0)) AS SumAufNet,
/*                            ^                              */
/*                            |                              */
/*                 Hier sind Kommata enthalten!              */
/*                            |                              */
/*                            v                              */
        SUM(IF(A.FertByte =  0, Brutto, 0)) AS SumAufGross,
        SUM(IF(A.FertByte = -1, Netto,  0)) AS SumAngNet,
        SUM(IF(A.FertByte = -1, Brutto, 0)) AS SumAngGross
   FROM adressen K, auftrag A
  WHERE K.RecordID = A.KundenID
GROUP BY  K.RecordID


/* Der SQL-PHarser, "strt" sich an den Kommata. Dafr git es Abhilfe. */
 SELECT K.Name1, K.Kundennummer, K.Name2, K.Suchbegriff,
        [W 10 N"Auftrag netto" ]SUM(IF(A.FertByte =  0 Netto  0)) AS SumAufNet,
        [W 10 N"Auftrag brutto"]SUM(IF(A.FertByte =  0 Brutto 0)) AS SumAufGross,
        [W 10 N"Angebot netto" ]SUM(IF(A.FertByte = -1 Netto  0)) AS SumAngNet,
        [W 10 N"Angebot brutto"]SUM(IF(A.FertByte = -1 Brutto 0)) AS SumAngGross
   FROM adressen K, auftrag A
  WHERE K.RecordID = A.KundenID
GROUP BY  K.RecordID
/* Hier werden die Kommata durch den in der INI-Datei hinterlegten Schlel "ColonReplace=" ersetzt */




/* Im IDEAL werden Rechnungen und Gutschriften innerhalb einer Tabelle gespeichert.                 */
/* Gutschriften beziehen sich auf Rechnungen und Rechnungen beziehen sich auf Auftrge.             */
/* Wie kann man nun alle Rechnungen udnGutschriften eines Auftrags in EINER Lsite zeigen ?          */
/* Ausserdem ist die AuftragsID in einer Rechnung, die sich auf mehrere Lieferschein bezieht, leer! */
    SELECT [H                   ]DISTINCT P.RechnungID,
           [W05 N"Kng" C1A<>"R" ]R.Kennung,                 /* Gutschriften      mit Farbe 1 */
           [W12 N"Rechnungs-Nr" ]R.Rechnungsnummer AS RGNR,
           [W10 N"Datum"        ]R.Datum,
           [W12 N"Brutto"       ]R.Brutto,
           [W12 N"gezahlt"      ]R.gezahlt,
           [W12 N"BelegNetto"   ]R.BelegNetto,
           [W12 N"BelegBrutto"  ]R.BelegBrutto,
           [W12 N"Mahnstufe"    ]R.Mahnstufe,
           [W12 N"Netto"        ]R.Netto,
           [W40 N"Kurztext 1"   ]R.Kurztext1,
           [W40 N"Kurztext 2"   ]R.Kurztext2,
           [W12 N"Rohgewinn"   H]R.Rohgewinn,
           [H   C3A="99"        ]R.Aktiv,                   /* archivierte RG/GS mit Farbe 3 */
           [H                   ]R.RecordID,
           [H                   ]R.RecFlag,
           [H                   ]R.EventFlag
      FROM posten P, rechnung R, auftrag A
     WHERE P.AuftragID  = [AuftragMask!MASK_RECORD_ID|R0,0]
       AND P.RechnungID = R.RecordID
       AND P.RechnungID > 100
       AND P.AuftragID  > 100
       AND P.AuftragID  = A.RecordID
       AND A.FertByte   = 0

UNION

    SELECT DISTINCT P.RechnungID,
           R.Kennung,
           R.Rechnungsnummer AS RGNR,
           R.Datum,
           R.Brutto,
           R.gezahlt,
           R.BelegNetto,
           R.BelegBrutto,
           R.Mahnstufe,
           R.Netto,
           R.Kurztext1,
           R.Kurztext2,
           R.Rohgewinn,
           R.Aktiv,
           R.RecordID,
           R.RecFlag,
           R.EventFlag
      FROM posten P, rechnung R, rechnung M, auftrag A
     WHERE P.AuftragID  = [AuftragMask!MASK_RECORD_ID|R0,0]
       AND P.RechnungID = M.RecordID
       AND R.GSID       = M.RecordID
       AND M.AuftragID  = [AuftragMask!MASK_RECORD_ID|R0,0]
       AND P.AuftragID  = A.RecordID
       AND A.FertByte   = 0

  ORDER BY RGNR desc


/* Update ber mehrere Tabellen in MSSQL-Server */
UPDATE posten
   SET posten.FreeFloat3 = A.VKZW1
  FROM posten P, artikel A, rechnung R
 WHERE P.ArtikelID  = A.RecordID
   AND P.RechnungID = R.RecordID
   AND R.Kennung    = "G"
   AND P.ArtikelID  > 1000
   AND P.FreeFloat3 = 0
   AND A.VKZW1      > 0

update posten
   set posten.Aktiv = 2
  from posten P, auftrag A
 where P.AuftragID  = A.RecordID
   and A.FertByte   = 1
   and A.Aktiv      = 99



/* Ulrich Becker  Join - MAX *ggg* */
SELECT `artikel_ges`.`Hauptartikel`,
       `artikel_ges`.`Artikelbezeichnung`,
       `artikel_ges`.`Groesse`,
       `bestand2011`.`Bestand`                        AS `Anfang2011`,
       `vartikelausgabennachmonat`.`Verbrauch`        AS `Verbrauch akt Monat`,
       `vartikelausgabennachmonat`.`AbrMonat`,
       `vverbrauchseit2011`.`VerbrauchSeit2011`       AS `Verbrauch_01 bis Akt Monat`,
       `mindestbestnde`.`Mindestbestand`,
       `vwarenausgangnachmonat`.`Menge`               AS `Wareneingang akt Monat`,
       `vwarenausgangnachmonat`.`AbrMonat`

  FROM `heinemann`.`artikel_ges` LEFT JOIN `heinemann`.`bestand2011`                ON (`artikel_ges`.`Artikelnummer` = `bestand2011`.`ArtNr`)
                                 LEFT JOIN `heinemann`.`vartikelausgabennachmonat`  ON (`artikel_ges`.`Artikelnummer` = `vartikelausgabennachmonat`.`ArtikelNr` AND `vartikelausgabennachmonat`.`AbrMonat` ='022011')
                                 LEFT JOIN `heinemann`.`vverbrauchseit2011`         ON (`artikel_ges`.`Artikelnummer` = `vverbrauchseit2011`.`ArtikelNr`)
                                 LEFT JOIN `heinemann`.`mindestbestnde`            ON (`artikel_ges`.`Artikelnummer` = `mindestbestnde`.`Artikelnummer`)
                                 LEFT JOIN `heinemann`.`vwarenausgangnachmonat`     ON (`artikel_ges`.`Artikelnummer` = `vwarenausgangnachmonat`.`Artikel` AND `vwarenausgangnachmonat`.`AbrMonat` ='022011')

