
  PROCEDURE InitVars
    VAR_QUERY O


    VAR_QUERY Q
    VAR_QUERY U
    VAR_BOOL  Res
    VAR_NUM   Max
    VAR_NUM   Cnt
    VAR_STR   TmpStr1
    VAR_STR   Inf
    VAR_NUM   SLen

    VAR_STR   FieldMax
    VAR_NUM   FieldMaxNum
  END_PROC


  PROCEDURE SetFieldLen VS FieldName, VS WhereClause, VS TableName, VN FillerSignASCIICode, VB RightJust, VN FieldWidth
    QUERY [Q]
      SELECT [FieldName], RecordID
        FROM [TableName]
             [WhereClause]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abruch','SetFieldLen: Die Tabelle konnte nicht abgefragt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abruch','SetFieldLen: Es liegen keine Daten vor',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]
    CALC [Cnt] AS 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Inf] AS CON('Datensatz ',[Cnt],'/',[Max])
      WAIT_INFO 'Bitte warten',[Inf]

      CALC [TmpStr1] AS [Q![FieldName]]
      CALC [SLen]    AS LEN([TmpStr1])


      IF [SLen]<[FieldWidth]
        IF [RightJust]
          CALC [TmpStr1] AS EXT([TmpStr1],[FieldWidth],[FillerSignASCIICode],2,1)
        ELSE
          CALC [TmpStr1] AS EXT([TmpStr1],[FieldWidth],[FillerSignASCIICode],1,1)
        END_IF

        QUERY [U]
          UPDATE [TableName]
             SET [FieldName] = "[TmpStr1]"
           WHERE RecordID    = [Q!RecordID|R0,0]
        END_QUERY

        EXECUTE [U],[Res]
        IF [Res]=FALSE
          END_WAIT
          MESSAGE 'Achtung Abruch','SetFieldLen: Ein Datensatz konnte nicht gendert werden',[MESSAGE_ERROR]
          EXIT_PROC
        END_IF
      END_IF

      GET_DATA [Q],[Res]
    END_WHILE

    END_WAIT
  END_PROC



  PROCEDURE UnDoubleSpecValue VS FieldValue, VS FieldName, VS WhereClause, VS TableName, VN FillerSignASCIICode, VB RightJust, VN FieldWidth
    LOCAL_STR LocWhereClause

    IF [WhereClause]=''
      CALC [LocWhereClause] AS CON('WHERE ',[FieldName],' = "',[FieldValue],'"')
    ELSE
      CALC [LocWhereClause] AS CON(  'AND ',[FieldName],' = "',[FieldValue],'"')
    END_IF

    QUERY [O]
      SELECT [FieldName], RecordID
        FROM [TableName]
             [WhereClause]
             [LocWhereClause]
    END_QUERY

    EXECUTE [O],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abruch','UnDoubleSpecValue: Die Tabelle konnte nicht abgefragt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [O],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    ; den jeweils ersten berspringen
    GET_DATA [O],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF


    WHILE [Res]
      INC  [FieldMaxNum]
      CALC [TmpStr1] AS [FieldMaxNum]
      CALC [SLen]    AS LEN([TmpStr1])


      IF [SLen]<[FieldWidth]
        IF [RightJust]
          CALC [TmpStr1] AS EXT([TmpStr1],[FieldWidth],[FillerSignASCIICode],2,1)
        ELSE
          CALC [TmpStr1] AS EXT([TmpStr1],[FieldWidth],[FillerSignASCIICode],1,1)
        END_IF
      END_IF

      QUERY [U]
        UPDATE [TableName]
           SET [FieldName] = "[TmpStr1]"
         WHERE RecordID    = [O!RecordID|R0,0]
      END_QUERY

      EXECUTE [U],[Res]
      IF [Res]=FALSE
        END_WAIT
        MESSAGE 'Achtung Abruch','UnDoubleSpecValue: Ein Datensatz konnte nicht gendert werden',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      GET_DATA [O],[Res]
    END_WHILE
  END_PROC



  PROCEDURE UnDouble VS FieldName, VS WhereClause, VS TableName, VN FillerSignASCIICode, VB RightJust, VN FieldWidth
    QUERY [Q]
        SELECT MAX([FieldName])
          FROM [TableName]
               [WhereClause]
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abruch','UnDouble: Der Maximalwert nicht abgefragt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Erfolg','UnDouble: Der Maximalwert konnte nicht ermittelt werden',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    CALC [FieldMax]    AS [Q!MAX([FieldName])]
    CALC [FieldMaxNum] AS VAL([FieldMax])

    QUERY [Q]
        SELECT [FieldName], count([FieldName])
          FROM [TableName]
               [WhereClause]
      GROUP BY [FieldName]
        HAVING count([FieldName]) > 1
      ORDER BY [FieldName] DESC
    END_QUERY

    EXECUTE [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Achtung Abruch','UnDouble: Die Tabelle konnte nicht abgefragt werden',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [Q],[Res]
    IF [Res]=FALSE
      MESSAGE 'Erfolg','UnDouble: Es liegen keine Daten vor',[MESSAGE_WARNING]
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q],[Max]
    CALC [Cnt] AS 0

    WHILE [Res]
      INC  [Cnt]
      CALC [Inf] AS CON('Doppelte ',[Cnt],'/',[Max])
      WAIT_INFO 'Bitte warten',[Inf]

      CALC [TmpStr1] AS [Q![FieldName]]

      CALL UnDoubleSpecValue [TmpStr1], [FieldName], [WhereClause], [TableName], [FillerSignASCIICode], [RightJust], [FieldWidth]

      GET_DATA [Q],[Res]
    END_WHILE

    END_WAIT
  END_PROC


  PROCEDURE Main
    CALL SetFieldLen 'BestellNummer', 'WHERE RecordID > 0', 'BestKopf', 48, TRUE, 6
;    CALL UnDouble    'Kundennummer', 'WHERE KAktiv > 0 AND RecordID > 0', 'adressen', 48, TRUE, 6
  END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALl Main
SCRIPT_END