; Legt die Felder VirtualDelID und VirtualDelUserIdx in jeder Tabelle auer in der Tabelle "suids" an.


  PROCEDURE InitVars
    VAR_BOOL   Res
    VAR_QUERY  Q1
    VAR_LIST   Tables
    VAR_NUM    TMax
    VAR_NUM    TCnt
    VAR_NUM    Num1
    VAR_NUM    MandBuf
    VAR_STR    Str1
    VAR_STR    TableName
    VAR_FLOAT  RecID
    VAR_LIST   Log
  END_PROC



  PROCEDURE CheckAndDoDeleteVirtual
    QUERY [Q1]
      SELECT count(RecordID) FROM [TableName]
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [Str1] AS CON('Die Tabelle "',[TableName],'" ist keine CARA-Tabelle, da das Feld "RecordID" fehlt.')
      LIST_APPEND [Log], [Str1]
      EXIT_PROC
    END_IF


    QUERY [Q1]
      SELECT count(VirtualDelID) FROM [TableName]
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]
      CALC [Str1] AS CON('Die Tabelle "',[TableName],'" wurde bereits auf das virtuelle Lschen vorbereitet.')
      LIST_APPEND [Log], [Str1]
      EXIT_PROC
    END_IF


    QUERY [Q1]
      ALTER TABLE [TableName] ADD VirtualDelID [SQL_DEFINE_RECORDID] [SQL_DEFINE_RECORDID_END]
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [Str1] AS CON('Die Tabelle "',[TableName],'" konnte nicht auf das virtuelle Lschen vorbereitet werden (1).')
      LIST_APPEND [Log], [Str1]
      EXIT_PROC
    END_IF


    QUERY [Q1]
      ALTER TABLE [TableName] ADD VirtualDelUserIdx [SQL_DEFINE_LONGINT] [SQL_DEFINE_LONGINT_END]
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [Str1] AS CON('Die Tabelle "',[TableName],'" konnte nicht auf das virtuelle Lschen vorbereitet werden (2).')
      LIST_APPEND [Log], [Str1]
      EXIT_PROC
    END_IF


    FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
    FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE
    QUERY [Q1]
      UPDATE [TableName] SET VirtualDelID = 0, VirtualDelUserIdx = 0
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [Str1] AS CON('Die Tabelle "',[TableName],'" konnte nicht fr das virtuelle Lschen initialisiert werden.')
      LIST_APPEND [Log], [Str1]
      EXIT_PROC
    END_IF


    QUERY [Q1]
      CREATE INDEX IndVirtualDelID[TCnt]Idx  ON [TableName] (VirtualDelID)
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      CALC [Str1] AS CON('Die Tabelle "',[TableName],'" konnte nicht fr das virtuelle Lschen indiziert werden.')
      LIST_APPEND [Log], [Str1]
      EXIT_PROC
    END_IF


    QUERY [Q1]
      SELECT RecordID FROM tablefld WHERE TableName = "[TableName]"
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]
      GET_DATA [Q1],[Res]
      IF [Res]
        FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
        FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE
        QUERY [Q1]
          UPDATE tablefld SET VirtualDelete = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION] WHERE TableName = "[TableName]"
        END_QUERY
        EXECUTE [Q1],[Res]
      ELSE
        NEW_RECORD [Res],'tablefld',[RecID], TRUE, FALSE, FALSE
        IF [Res]
          FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
          FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE
          QUERY [Q1]
            UPDATE tablefld
               SET VirtualDelete =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION],
                   Name          = "[TableName]",
                   TableName     = "[TableName]",
                   XRefName      = "[TableName]",
                   FieldName1    = "RECORDID",
                   FieldName2    = "RECORDID",
                   FieldName3    = "RECORDID",
                   FieldName4    = "RECORDID",
                   NoteWidth     =  500,
                   IsMand        =  [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]
             WHERE RecordID      =  [RecID|R0,0]
          END_QUERY
          EXECUTE [Q1],[Res]
        END_IF
      END_IF
    END_IF
  END_PROC



  PROCEDURE Main
    VAR_BOOL VirtualDel
    CALC [VirtualDel] AS [VIRTUAL_DELETE]
    CALC [VIRTUAL_DELETE] AS FALSE

    CALC [Num1] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die Applikation auf virtuelles Lschen vorbereiten?|Dies kann unter Umstnden einige Zeit in Anspruch nehmen!',[Num1]
    IF [Num1]<>[ID_YES]
      EXIT_PROC
    END_IF

    GET_TABLE_LIST [Tables]
    LIST_ITEM_GET  [Tables],[TCnt],[TMax]
    IF [TMax]<1
      MESSAGE 'Achtung Abbruch','Die Liste der Tabellen der Applikation ist leer',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [MandBuf] AS [ACT_MANDANT]
    CALC [ACT_MANDANT] AS 0

    QUERY [Q1]
      ALTER TABLE tablefld ADD VirtualDelete [SQL_DEFINE_BOOLEAN] [SQL_DEFINE_BOOLEAN_END]
    END_QUERY
    EXECUTE [Q1],[Res]
    IF [Res]
      FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
      FLAG_SET [Q1!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE

      QUERY [Q1]
        UPDATE tablefld SET VirtualDelete = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_FALSE][SQL_BOOLEAN_QUOTATION]
      END_QUERY
      EXECUTE [Q1],[Res]
    END_IF


    CALC [TCnt] AS 1
    WHILE [TCnt]<=[TMax]
      LIST_STR_GET [Tables],[TableName],[TCnt]

      CALC [Str1] AS CON([TableName],'  ',[TCnt],' / ',[TMax])
      WAIT_INFO 'Bitte warten...',[Str1]

      IF [TableName]<>'suids'
        CALL CheckAndDoDeleteVirtual
      END_IF

      INC [TCnt]
    END_WHILE

    END_WAIT

    CALC [ACT_MANDANT] AS [MandBuf]

    LIST_ITEM_GET [Log],[TCnt],[TMax]
    IF [TMax]>0
      LIST_DISPLAY [Log],'Fehler-Liste'
    ELSE
      MESSAGE 'Information','Das virtuelle Lschen ist ab jetzt mglich!'
    END_IF

    CALC [VIRTUAL_DELETE] AS [VirtualDel]
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END