DROP TABLE [SQL_IF_EXISTS] applog;

CREATE TABLE applog
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      AppID                     [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      AppInfo                   [SQL_DEFINE_STRING]   ( 41) [SQL_DEFINE_STRING_END],
      StationID                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UserID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      StationIDShort            [SQL_DEFINE_STRING]   ( 11) [SQL_DEFINE_STRING_END],
      UserSIDShort              [SQL_DEFINE_STRING]   ( 11) [SQL_DEFINE_STRING_END],
      CaraVersion               [SQL_DEFINE_STRING]   (165) [SQL_DEFINE_STRING_END],
      AppName                   [SQL_DEFINE_STRING]   (165) [SQL_DEFINE_STRING_END],
      LicensedVersion           [SQL_DEFINE_STRING]   ( 21) [SQL_DEFINE_STRING_END]

      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndAppLogRecordID        ON applog (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndAppLogVirtualDelID    ON applog (VirtualDelID);
CREATE        INDEX IndAppLogAppId           ON applog (AppId);
CREATE        INDEX IndAppLogAppInfo         ON applog (AppInfo);
CREATE        INDEX IndAppLogStationID       ON applog (StationID);
CREATE        INDEX IndAppLogUserID          ON applog (UserID);
CREATE        INDEX IndAppLogStationIDShort  ON applog (StationIDShort);
CREATE        INDEX IndAppLogUserSIDShort    ON applog (UserSIDShort);
CREATE        INDEX IndAppLogCaraVersion     ON applog (CaraVersion);
CREATE        INDEX IndAppLogAppName         ON applog (AppName);
CREATE        INDEX IndAppLogLicensedVersion ON applog (LicensedVersion);
