DROP TABLE [SQL_IF_EXISTS] bookmarks;

CREATE TABLE bookmarks
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      TableName                 [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      XRefName                  [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      ScriptName                [SQL_DEFINE_STRING]   (128) [SQL_DEFINE_STRING_END],
      RelRecID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UserID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Description               [SQL_DEFINE_STRING]   (128) [SQL_DEFINE_STRING_END]
      [SQL_DEFINE_PRIMARY_KEY2]
    );


CREATE UNIQUE INDEX IndBooMaRecordID          ON bookmarks (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndBooMaVirtualDelID      ON bookmarks (VirtualDelID);
CREATE        INDEX IndBooMaTableName         ON bookmarks (TableName);
CREATE        INDEX IndBooMaRelRecID          ON bookmarks (RelRecID);
CREATE        INDEX IndBooMaUserID            ON bookmarks (UserID);
