DROP TABLE [SQL_IF_EXISTS] changes;

CREATE TABLE changes
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],

      TableName                 [SQL_DEFINE_STRING]   ( 60) [SQL_DEFINE_STRING_END],
      RelRecID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],

      ChangeDate                [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      ChangeTime                [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],

      UserName                  [SQL_DEFINE_STRING]   ( 60) [SQL_DEFINE_STRING_END],

      FieldName                 [SQL_DEFINE_STRING]   ( 60) [SQL_DEFINE_STRING_END],
      ValueOld                  [SQL_DEFINE_STRING]   (250) [SQL_DEFINE_STRING_END],
      ValueNew                  [SQL_DEFINE_STRING]   (250) [SQL_DEFINE_STRING_END],

      StationID                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UserID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END]

      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndChangRecordID      ON changes (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndChangVirtualDelID  ON changes (VirtualDelID);
CREATE        INDEX IndChangTableName     ON changes (TableName);
CREATE        INDEX IndChangRelRecID      ON changes (RelRecID);
CREATE        INDEX IndChangChangeDate    ON changes (ChangeDate);
CREATE        INDEX IndChangChangeTime    ON changes (ChangeTime);
CREATE        INDEX IndChangUserName      ON changes (UserName);
CREATE        INDEX IndChangFieldName     ON changes (FieldName);
CREATE        INDEX IndChangValueOld      ON changes (ValueOld);
CREATE        INDEX IndChangValueNew      ON changes (ValueNew);
CREATE        INDEX IndChangStationID     ON changes (StationID);
CREATE        INDEX IndChangUserID        ON changes (UserID);
