DROP TABLE [SQL_IF_EXISTS] notes;

CREATE TABLE notes
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      TableName                 [SQL_DEFINE_STRING]   ( 42) [SQL_DEFINE_STRING_END],
      NoteID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      NoteSegment               [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      RelRecID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      NoteInfo                  [SQL_DEFINE_STRING]   (252) [SQL_DEFINE_STRING_END],
      ResponsibleID             [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      ExpireDate                [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      CreateDate                [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END]
      [SQL_DEFINE_PRIMARY_KEY2]
    );

CREATE UNIQUE INDEX IndNoRecordID      ON notes (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndNoVirtualDelID  ON notes (VirtualDelID);
CREATE        INDEX IndNoIDUser        ON notes (IDUser);
CREATE        INDEX IndNoLevelUser     ON notes (LevelUser);
CREATE        INDEX IndNoMandant       ON notes (Mandant);
CREATE        INDEX IndNoRecFlag       ON notes (RecFlag);
CREATE        INDEX IndNoEventFlag     ON notes (EventFlag);
CREATE        INDEX IndNoTableName     ON notes (TableName);
CREATE        INDEX IndNoNoteID        ON notes (NoteID);
CREATE        INDEX IndNoNoteSegment   ON notes (NoteSegment);
CREATE        INDEX IndNoRelRecID      ON notes (RelRecID);
CREATE        INDEX IndNoNoteInfo      ON notes (NoteInfo);
CREATE        INDEX IndNoResponsibleID ON notes (ResponsibleID);
CREATE        INDEX IndNoExpireDate    ON notes (ExpireDate);
CREATE        INDEX IndNoCreateDate    ON notes (CreateDate);

