DROP TABLE [SQL_IF_EXISTS] ode;

CREATE TABLE ode
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      StartDate                 [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      StartTime                 [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      StopDate                  [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      StopTime                  [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      JobName                   [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      JobSuccess                [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      OffsetDate                [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      OffsetTime                [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      StartID                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      StopID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      OffsetID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END]
      [SQL_DEFINE_PRIMARY_KEY2]
    );

CREATE UNIQUE INDEX IndODERecordID     ON ode (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndODEVirtualDelID ON ode (VirtualDelID);

