DROP TABLE [SQL_IF_EXISTS] plzcoords;

CREATE TABLE plzcoords
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      LandID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      PLZ                       [SQL_DEFINE_STRING]   ( 12) [SQL_DEFINE_STRING_END],
      PlzNum                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      Breite                    [SQL_DEFINE_STRING]   ( 12) [SQL_DEFINE_STRING_END],
      BreiteNum                 double(9,6) NOT NULL default '0.000000',
      Laenge                    [SQL_DEFINE_STRING]   ( 12) [SQL_DEFINE_STRING_END],
      LaengeNum                 double(9,6) NOT NULL default '0.000000'

      [SQL_DEFINE_PRIMARY_KEY2]
);

CREATE UNIQUE INDEX IndPlzCoRecordID     ON plzcoords (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndPlzCoVirtualDelID ON plzcoords (VirtualDelID);
CREATE        INDEX IndPlzCoLandID       ON plzcoords (LandID);
CREATE        INDEX IndPlzCoPLZ          ON plzcoords (PLZ);
CREATE        INDEX IndPlzCoPlzNum       ON plzcoords (PlzNum);
CREATE        INDEX IndPlzCoBreite       ON plzcoords (Breite);
CREATE        INDEX IndPlzCoBreiteNum    ON plzcoords (BreiteNum);
CREATE        INDEX IndPlzCoLaenge       ON plzcoords (Laenge);
CREATE        INDEX IndPlzCoLaengeNum    ON plzcoords (LaengeNum);

ASCII_2_TABLE plzcoords [SQL_PATH]ddf\plzcoords.txt;
