DROP TABLE [SQL_IF_EXISTS] qfilterh;

CREATE TABLE qfilterh
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      Name                      [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      ScriptName                [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      UserID                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      StationID                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      CreateDate                [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      ExecuteOnStart            [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END]
      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndQFilHRecordID       ON qfilterh (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndQFilHVirtualDelID   ON qfilterh (VirtualDelID);
CREATE        INDEX IndQFilHName           ON qfilterh (Name);
CREATE        INDEX IndQFilHScriptName     ON qfilterh (ScriptName);
CREATE        INDEX IndQFilHUserID         ON qfilterh (UserID);
CREATE        INDEX IndQFilHStationID      ON qfilterh (StationID);
CREATE        INDEX IndQFilHCreateDate     ON qfilterh (CreateDate);
CREATE        INDEX IndQFilHExecuteOnStart ON qfilterh (ExecuteOnStart);

