/*
      ALTER TABLE qfilteri ADD StrLeading [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END];
      ALTER TABLE qfilteri ADD StrEnding  [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END];
      ALTER TABLE qfilteri ADD FilterLink [SQL_DEFINE_STRING]   ( 16) [SQL_DEFINE_STRING_END];
           UPDATE qfilteri SET StrLeading = "",
                               StrEnding  = "",
                               FilterLink = "AND";
     CREATE INDEX IndQFilIStrLeading ON qfilteri (StrLeading);
     CREATE INDEX IndQFilIStrEnding  ON qfilteri (StrEnding);
     CREATE INDEX IndQFilIFilterLink ON qfilteri (FilterLink);
*/


DROP TABLE [SQL_IF_EXISTS] qfilteri;

CREATE TABLE qfilteri
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      QFilterHID                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      TableName                 [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      FieldName                 [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      FieldType                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      FieldSize                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      CompareOperator           [SQL_DEFINE_STRING]   ( 16) [SQL_DEFINE_STRING_END],
      CompareValue              [SQL_DEFINE_STRING]   (128) [SQL_DEFINE_STRING_END],
      StrLeading                [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      StrEnding                 [SQL_DEFINE_STRING]   ( 64) [SQL_DEFINE_STRING_END],
      FilterLink                [SQL_DEFINE_STRING]   ( 16) [SQL_DEFINE_STRING_END]
      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndQFilIRecordID        ON qfilteri (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndQFilIVirtualDelID    ON qfilteri (VirtualDelID);
CREATE        INDEX IndQFilIQFilterHID      ON qfilteri (QFilterHID);
CREATE        INDEX IndQFilITableName       ON qfilteri (TableName);
CREATE        INDEX IndQFilIFieldName       ON qfilteri (FieldName);
CREATE        INDEX IndQFilIFieldType       ON qfilteri (FieldType);
CREATE        INDEX IndQFilIFieldSize       ON qfilteri (FieldSize);
CREATE        INDEX IndQFilICompareOperator ON qfilteri (CompareOperator);
CREATE        INDEX IndQFilICompareValue    ON qfilteri (CompareValue);
CREATE        INDEX IndQFilIStrLeading      ON qfilteri (StrLeading);
CREATE        INDEX IndQFilIStrEnding       ON qfilteri (StrEnding);
CREATE        INDEX IndQFilIFilterLink      ON qfilteri (FilterLink);

