DROP TABLE [SQL_IF_EXISTS] sendmsgs;

CREATE TABLE sendmsgs
    ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
      IDUser                    [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      LevelUser                 [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      Mandant                   [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      UpdateTime                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      RecFlag                   [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      EventFlag                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
      VirtualDelID              [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      VirtualDelUserIdx         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],

      SendMsgDID                [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      SendState                 [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],

      AdressenSendID            [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      DateSend                  [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      TimeSend                  [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      StationSendID             [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],

      AdressenReceiveID         [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      DateReceive               [SQL_DEFINE_DATE]           [SQL_DEFINE_DATE_END],
      TimeReceive               [SQL_DEFINE_TIME]           [SQL_DEFINE_TIME_END],
      StationReceiveID          [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],

      SourceID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
      AnswerID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],

      DocMgrLegend              [SQL_DEFINE_BOOLEAN]        [SQL_DEFINE_BOOLEAN_END],
      Active                    [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END]

      [SQL_DEFINE_PRIMARY_KEY2]
      );

CREATE UNIQUE INDEX IndSndMsgRecordID     ON sendmsgs (RecordID) [SQL_DEFINE_PRIMARY_KEY3];
CREATE        INDEX IndSndMsgVirtualDelID ON sendmsgs (VirtualDelID);
CREATE        INDEX IndSndMsgSendMsgDID   ON sendmsgs (SendMsgDID);
CREATE        INDEX IndSndMsgAdrSendID    ON sendmsgs (AdressenSendID);
CREATE        INDEX IndSndMsgDateSend     ON sendmsgs (DateSend);
CREATE        INDEX IndSndMsgSendState    ON sendmsgs (SendState);
CREATE        INDEX IndSndMsgTimeSend     ON sendmsgs (TimeSend);
CREATE        INDEX IndSndMsgStaSendID    ON sendmsgs (StationSendID);
CREATE        INDEX IndSndMsgAdrRecID     ON sendmsgs (AdressenReceiveID);
CREATE        INDEX IndSndMsgDateRec      ON sendmsgs (DateReceive);
CREATE        INDEX IndSndMsgTimeRec      ON sendmsgs (TimeReceive);
CREATE        INDEX IndSndMsgStaRecID     ON sendmsgs (StationReceiveID);
CREATE        INDEX IndSndMsgSourceID     ON sendmsgs (SourceID);
CREATE        INDEX IndSndMsgAnswerID     ON sendmsgs (AnswerID);
CREATE        INDEX IndSndMsgActive       ON sendmsgs (Active);

NEW_RECORD sendmsgs 0;

SELECT count(RecordID)
  FROM sendmsgs
 WHERE RecordID > 1000
   AND Active   = 1
   AND (AdressenReceiveID = [ACT_MIT_ID|R0,0] OR
        StationReceiveID  = [STATION_ID|R0,0]    );
