-- These are the minimum settings per session to get correct
--      SORT order
--      Currency, Date, Time & decimal Numeric Output
--      WHERE clause linguistic correct string compares (*)
-- in the case of default database settings 
--      (AMERICAN.AMERICA and COMP=binary, SORT=binary):
--
-- Even if these parms could be implemented into the database (via init.ora
-- during database creation), I think it's a better idea to set them per session
-- cause of 
--      better variability of database usage in the case of 
--        multilingual client platforms
--      better integration of IDEAL (as tablespace) into a existing database
--        with pre-defined NLS parameters
--
--
-- (*)  it may be possible to create indexes on character based columns
--      in NLS_SORT manner to get better performance:
--
--	CREATE INDEX idxtab ON tab (NLSSORT(col, 'NLS_SORT=german'))

alter session set nls_territory=germany;
alter session set nls_sort=german;
alter session set nls_comp=ansi;

select * from nls_session_parameters;	-- to check all these nice things ...
