

  PROCEDURE InitVars
    VAR_BOOL   CheckIdPeforeInsert
    VAR_BOOL   Res
    VAR_QUERY  Q1
    VAR_QUERY  Q2
    VAR_LIST   Tables
    VAR_NUM    TMax
    VAR_NUM    TCnt
    VAR_NUM    RMax
    VAR_NUM    RCnt
    VAR_STR    Str1
    VAR_NUM    MandBuf
    VAR_STR    TableName
    VAR_NUM    Num1
    VAR_LIST   Log
  END_PROC


  PROCEDURE CheckAndSaveSuids
    QUERY [Q1]
      SELECT RecordID FROM [TableName] WHERE RecordID > 1000
    END_QUERY

    EXECUTE [Q1],[Res]
    IF [Res]=FALSE
      ; Table without RecordID -> nothing to do...
      EXIT_PROC
    END_IF

    GET_DATA [Q1],[Res]
    IF [Res]=FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [Q1],[RMax]
    CALC [RCnt] AS 0

    WAIT_INFO 'Bitte warten...',[TableName]

    WHILE [Res]
      INC  [RCnt]
      CALC [Num1] AS [RCnt] MOD 500
      IF [Num1]=0
        CALC [Str1] AS CON([TableName],' ',[RCnt],' / ',[RMax])
        WAIT_INFO 'Bitte warten...',[Str1]
      END_IF

      IF [CheckIdPeforeInsert]
        QUERY [Q2]
          SELECT RecordID FROM suids WHERE RecordID = [Q1!RecordID|R0,0] AND TableName = "[TableName]"
        END_QUERY
        EXECUTE [Q2],[Res]
        IF [Res]
          GET_DATA [Q2],[Res]
          IF [Res]
            CALC [Res] AS FALSE
          ELSE
            CALC [Res] AS TRUE
          END_IF
        END_IF
      END_IF

      IF [Res]
        QUERY [Q2]
          INSERT INTO suids VALUES ([Q1!RecordID|R0,0],"[TableName]",[APPLICATION_ID|R0,0])
        END_QUERY
        EXECUTE [Q2],[Res]
        IF [Res]=FALSE
          CALC [Str1] AS CON([TableName],' ',[Q1!RecordID|R0,0])
          LIST_APPEND [Log], [Str1]
        END_IF
      END_IF

      GET_DATA [Q1],[Res]
    END_WHILE
  END_PROC



  PROCEDURE Main
    CALC [Num1] AS [ID_NO]
    GET_YES_NO 'Achtung! Sind Sie sicher?!','Mchten Sie die Applikation auf Super-Unique-RecordIDs vorbereiten?|Dies kann unter Umstnden einige Zeit in Anspruch nehmen!',[Num1]
    IF [Num1]<>[ID_YES]
      EXIT_PROC
    END_IF


    CALC [CheckIdPeforeInsert] AS FALSE

    CALC [MandBuf] AS [ACT_MANDANT]
    CALC [ACT_MANDANT] AS 0

    QUERY [Q1]
      SELECT COUNT(RecordID) FROM suids
    END_QUERY
    EXECUTE [Q1],[Res]

    CALC [ACT_MANDANT] AS [MandBuf]

    IF [Res]
      GET_DATA [Q1],[Res]
      IF [Res]
        IF [Q1!COUNT(RecordID)]>0
          CALC [CheckIdPeforeInsert] AS TRUE
        END_IF
      END_IF
    ELSE
      QUERY [Q1]
        DROP TABLE suids
      END_QUERY
      EXECUTE [Q1],[Res]

      QUERY [Q1]
        CREATE
         TABLE suids
             ( RecordID                  [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
               TableName                 [SQL_DEFINE_STRING]   ( 81) [SQL_DEFINE_STRING_END],
               ApplicationID             [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END]
               [SQL_DEFINE_PRIMARY_KEY2]
             )
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Die Tabelle "suids" existiert nicht und konnte auch nicht angelegt werden.',[MESSAGE_ERROR]
        EXIT_PROC
      END_IF

      QUERY [Q1]
        CREATE UNIQUE INDEX IndSuidsRecordID      ON suids (RecordID) [SQL_DEFINE_PRIMARY_KEY3]
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Primrschlssel der Tabelle "suids" konnte nicht angelegt werden.',[MESSAGE_ERROR]
        QUERY [Q1]
          DROP TABLE suids
        END_QUERY
        EXECUTE [Q1],[Res]

        EXIT_PROC
      END_IF

      QUERY [Q1]
        CREATE        INDEX IndSuidsTableName     ON suids (TableName)
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Tabellenschlssel der Tabelle "suids" konnte nicht angelegt werden.',[MESSAGE_ERROR]
        QUERY [Q1]
          DROP TABLE suids
        END_QUERY
        EXECUTE [Q1],[Res]

        EXIT_PROC
      END_IF

      QUERY [Q1]
        CREATE        INDEX IndSuidsApplicationID ON suids (ApplicationID)
      END_QUERY
      EXECUTE [Q1],[Res]
      IF [Res]=FALSE
        MESSAGE 'Achtung Abbruch','Der Applikationsschlssel der Tabelle "suids" konnte nicht angelegt werden.',[MESSAGE_ERROR]
        QUERY [Q1]
          DROP TABLE suids
        END_QUERY
        EXECUTE [Q1],[Res]

        EXIT_PROC
      END_IF
    END_IF



    GET_TABLE_LIST [Tables]
    LIST_ITEM_GET  [Tables],[TCnt],[TMax]
    IF [TMax]<1
      MESSAGE 'Achtung Abbruch','Die Liste der Tabellen der Applikation ist leer',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    CALC [MandBuf] AS [ACT_MANDANT]
    CALC [ACT_MANDANT] AS 0

    CALC [TCnt] AS 1
    WHILE [TCnt]<=[TMax]
      LIST_STR_GET [Tables],[TableName],[TCnt]
      IF [TableName]<>'suids'
        CALL CheckAndSaveSuids
      END_IF
      INC [TCnt]
    END_WHILE

    END_WAIT

    CALC [ACT_MANDANT] AS [MandBuf]

    LIST_ITEM_GET [Log],[TCnt],[TMax]
    IF [TMax]>0
      LIST_DISPLAY [Log],'Fehler-Liste'
    ELSE
      MESSAGE 'Information','Die Super-Uniqe-RecordID wurden erzeugt!'
    END_IF
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END